# CGNS
[![Actions Status](https://github.com/CGNS/CGNS/workflows/cgns/badge.svg)](https://github.com/CGNS/CGNS/actions)
[![Build Status: Windows](https://ci.appveyor.com/api/projects/status/jux83kxj0r234oy6?svg=true)](https://ci.appveyor.com/project/brtnfld/cgns)

<a href="https://scan.coverity.com/projects/cgns-cgns">
  <img alt="Coverity Scan Build Status"
       src="https://scan.coverity.com/projects/7923/badge.svg"/>
</a>

## About

The CFD General Notation System (CGNS) provides a standard for recording and recovering computer data associated with the numerical solution of fluid dynamics equations.

## Bugs/Feature and issue tracking

https://cgnsorg.atlassian.net

## Installation

### Installation Instructions using `cmake`

1. Install HDF5 on your system.
  
   - HDF5 can use the standard GNU autotools, so `./configure`, `make`, `sudo make install` should install HDF5 without problems on most systems.
2. Unpack the tar ball containing the source code into some directory.
3. Create a new directory in which to build the library.
4. Use `cmake` to initialize the build tree.
   ```shell
   user@hostname:build_path$ cmake /path/to/cgns/sources/
   ```
5. Use `ccmake` to edit the control variables as needed.
   ```shell
   user@hostname:build_path$ ccmake .
   ```
   - The path to the HDF5 library should be specified with `CMAKE_PREFIX_PATH=$HDF_DIR` for linking with a specific HDF5 version.
     - If HDF5 is built with parallel-IO support via MPI, the `HDF5_NEED_MPI` flag must be set to `true`.
     - If HDF5 is built with `zlib` and `szip` support, these need to be flagged with `HDF5_NEED_ZLIB` and `HDF5_NEED_SZIP` as well as the paths for those libraries.
   - Fortran can be enabled by toggling the `CGNS_ENABLE_FORTRAN` variable.
     - A view of the attempt to autodetect the correct interface between Fortran and C is show, setting the value of `FORTRAN_NAMING`.
     - For `gfortran` and `pgf90` the value of `FORTRAN_NAMING` should be `LOWERCASE_`.
   - The build system must be reconfigured after variable changes by pressing `c`. Variables who's value has changed are marked with a `*` in the interface.
   - After configuration, the `Makefile`s must be generated by pressing `g`.
6. Use `make` to build the library.
   ```shell
   user@hostname:build_path$ make
   ```
   - A colorized review of the build process should follow.
7. Installation of the library is accomplished with the `install` target of the makefile.
   ```shell
   user@hostname:build_path$ make install
   ```
   - You must have permissions to alter the directory where CGNS will be installed.

### Installation Instructions using `make`

1. Install HDF5 on your system.
   - HDF5 can use the standard GNU autotools, so `./configure`, `make`, `sudo make install` should install HDF5 without problems on most systems.
2. Typically the standard `./configure`, `make`, `make install` will suffice.  
3. Sample scripts for building parallel CGNS can be found in `src/SampleScripts`.

## Usage

## License

The distribution and use of the CGNS software is covered by the
following license:

-----------------------------------------------------------------------
This software is provided 'as-is', without any express or implied
warranty. In no event will the authors be held liable for any damages
arising from the use of this software.

Permission is granted to anyone to use this software for any purpose,
including commercial applications, and to alter it and redistribute it
freely, subject to the following restrictions:

1. The origin of this software must not be misrepresented; you must
   not claim that you wrote the original software. If you use this
   software in a product, an acknowledgment in the product documentation would be appreciated but is not required.

2. Altered source versions must be plainly marked as such, and must not be misrepresented as being the original software.

3.  This notice may not be removed or altered from any source distribution.

----------------------------------------------------------------------

This license is borrowed from the zlib/libpng License:

    http://www.opensource.org/licenses/zlib-license.php

and supersedes the GNU Lesser General Public License (LGPL) which
previously governed the use and distribution of the software.

For details on the policy governing the distribution of the CGNS
standard and software see:

    http://www.grc.nasa.gov/www/cgns/charter/principles.html

## Development
CGNS uses the branching/release model as summarized at:

http://nvie.com/posts/a-successful-git-branching-model/
  

![image](https://github.com/CGNS/cgns.github.io/blob/master/git-model.png)

There are 2 things that need to be correct for the
Fortran to C interface to work properly. The first
is the form of the Fortran name mangling. If you get
unresolved references, then this is not correct. You
can control this by defining one of:

UPPERCASE   : Fortran name is CSUB
UPPERCASE_  : Fortran name is CSUB_
UPPERCASE__ : Fortran name is CSUB__
LOWERCASE   : Fortran name is csub
LOWERCASE_  : Fortran name is csub_
LOWERCASE__ : Fortran name is csub__

The default is LOWERCASE_, except for Cray, VMS and Windows
which use UPPERCASE. See csub.c for these interfaces.

*** NOTE ***
If you are using g77, this will probably not work unless
you use LOWERCASE_ (the default) and add -fno-second-underscore
to the Fortran compile line. The reason is that g77 appends
2 underscores to names that contain an underscore already,
and only 1 to names that don't.
Thus, cg_sub becomes cg_sub__ and adfsub becomes adfsub_
************

The second is the location of the implicit string len
in the argument list, and accessing the character string.
With the exception of Cray, VMS and Windows, the standard
is to put the implicit length at the end of the argument list.
For the Cray and VMS, these are accessed through structures.
For Visual Fortran, the implicit length immediately follows the string.

To figure out what you need, compile csub.c with the appropriate
define, then compile and link fmain.f with you Fortran compiler.

cc -c csub.c
f77 -o fmain fmain.f csub.o [any other libs you need]

If you get an undefined reference to CSUB_ or _CSUB_ (for instance) then
repeat with:

cc -DUPPERCASE_ -c csub.c

After your links succeeds, run fmain.

There is also a Makefile - edit as needed, then run make.

If none of these work for you, please let me know:

Bruce Wedan
bruce.wedan@ansys.com

This contains a set of Fortran90 test cases from UserGuideCode.
(modified for use with V3.3)

If CGNS is compiled with --enable-64bit, then the created "grid.cgns"
file will use 64-bit integers as appropriate

Currently, the testing (make test) only compares output files of some
of the variables written to and read from the grid.cgns file.  It
does not check whether the 64-bit integers were necessarily written
as I8 or not.  To check this, one could use "cgnsview" to look at the
grid.cgns file(s) directly.  For example, with 64-bit integers, in
the cgns file under Test_Grid_Str, the PointList data type under
the BC_t nodes (under ZoneBC_t) should be I8 rather than I4.

***** NOTE *****
You will first have to edit the Makefile include to set up your
CGNS location and compiler and options

Edit 'make.defs' for Linux/Unix
Not checked for Windows yet.

To just build the code, use
    make
on linux/Unix

To build and run the tests, use
    make test

Note: executables, output files, and the resulting CGNS file are put in
each Subdirectory/build/ directory

To clean everything up, use
    make clean

This contains a set of C test cases from UserGuideCode.
(modified for use with V3.3)

If CGNS is compiled with --enable-64bit, then the created "grid_c.cgns"
file will use 64-bit integers as appropriate

Currently, the testing (make test) only compares output files of some
of the variables written to and read from the grid_c.cgns file.  It
does not check whether the 64-bit integers were necessarily written
as I8 or not.  To check this, one could use "cgnsview" to look at the
grid_c.cgns file(s) directly.  For example, with 64-bit integers, in
the cgns file under Test_Grid_Str, the PointList data type under
the BC_t nodes (under ZoneBC_t) should be I8 rather than I4.

***** NOTE *****
You will first have to edit the Makefile include to set up your
CGNS location and compiler and options

Edit 'make.defs' for Linux/Unix
Not checked for Windows yet.

To just build the code, use
    make
on linux/Unix

To build and run the tests, use
    make test

Note: executables, output files, and the resulting CGNS file are put in
each Subdirectory/build/ directory

To clean everything up, use
    make clean

This example assumes all the needed packages are in ${HOME}/packages and the all the scripts 
are placed in ${HOME}/packages.

NOTE (1): If the system already has HDF5 installed then you can use it instead, as long as it was build with --enable-parallel.

(1) Building zlib from source:
  
   Download and extract the zlib source: http://www.zlib.net/

   (a) cd into the top level zlib source directory.
   (b) modify and run the script: ../build_zlib

(2) Building hdf5 from source:

   (a) From the top level of the hdf5 library, change the ${HOME}/packages to 
    where zlib was installed in STEP 1. 

../build_hdf5 --without-pthread --disable-shared --enable-parallel --enable-production \
--enable-fortran --enable-fortran2003 \
--disable-stream-vfd --disable-direct-vfd \
--with-zlib=${HOME}/packages/zlib-1.2.8/lib --prefix=${HOME}/packages/phdf5-trunk

where prefix is set for where the hdf5 library will get installed. There should 
be no need to modify in the script.

(3) Building cgns from source:

   (a) cd into the cgns/src directory
   (b) modify and run: <pathto>/build_cgns
   (c) make
   (d) To make the tests: 
			  cd ptests
			  make

(4) IMPORTANT PARAMETERS FOR GOOD PERFORMANCE

    (i) The environment variable BGLOCKLESSMPIO_F_TYPE=0x47504653 should be set.

        * Set using qsub --env BGLOCKLESSMPIO_F_TYPE=0x47504653

    (ii) does CGNS_FILETYPE need to be set ????

2.2 Building on SGI (Lustre)

1. Building zlib from source: Download and extract the zlib source: http://www.zlib.net/

   (a) cd into the top level zlib source directory. 

   (b) modify and run the script: ../build_zlib

   (c) Note: if you get errors in steps 2 or 3 below because it cannot find the zlib.h or zlib.a
       files, it may be necessary to do the following:
          cd $HOME/packages/zlib-1.2.8
          ln -s lib/include/zlib.h .
          ln -s lib/lib/libz.a . 

2. Building hdf5 from source

   (a) From the top level of the hdf5 library, change the ${HOME}/packages to where zlib was installed in STEP 1. 
    
   (b) ../build_hdf5

3. Building cgns from source:

   (a) cd into the cgns/src directory 

   (b) modify and run: <pathto>/build_cgns 

   (c) make

   (d) To make the tests: cd ptests; make

4. Running:

   (a) tests need to be submitted as a job; see, e.g.: run_cgns.sh

5. IMPORTANT PARAMETERS FOR GOOD PERFORMANCE

   (a) The Lustre parameters have not been fully tested.

   (b) On Pleiades, lfs setstripe -c 64 -s 0 /nobackupp8/<dir>, has shown good performance.

2.2 Building on SGI (Lustre)

0. Module Enviromnment:
    1) comp-intel/2015.0.090   2) mpi-intel/5.0.1.035
  (mpi-sgi/mpt.2.11r13 generates strange error messages at run time)


1. Building zlib from source: Download and extract the zlib source: http://www.zlib.net/

   (a) cd into the top level zlib source directory. 

   (b) modify and run the script: ../build_zlib

   (c) Note: if you get errors in steps 2 or 3 below because it cannot find the zlib.h or zlib.a
       files, it may be necessary to do the following:
          cd $HOME/packages/zlib-1.2.8
          ln -s lib/include/zlib.h .
          ln -s lib/lib/libz.a . 

2. Building hdf5 from source (version 1.8.14)

   (a) From the top level of the hdf5 library, change the ${HOME}/packages to where zlib was installed in STEP 1. 
    
   (b) ../build_hdf5

3. Building cgns from source:

   Note before compiling: CGNS expects the compilers to be mpicc and mpif90. Therefore, create a directory 'bin' in your home directory
   and add symbolic links to the mpi/intel wrappers:

      mpicc -> /nasa/intel/impi/5.0.1.035/bin64/mpiicc*
      mpif90 -> /nasa/intel/impi/5.0.1.035/bin64/mpiifort* 
   
   The script will point to these symbolic links.

   (a) cd into the cgns/src directory 

   (b) modify and run: <pathto>/build_cgns  (need to point to your own bin directory as noted above)
 
   (c) make

   (d) To make the tests: cd ptests; make

4. Running:

   (a) tests need to be submitted as a job; see, e.g.: run_cgns.sh

5. IMPORTANT PARAMETERS FOR GOOD PERFORMANCE

   (a) The Lustre parameters have not been fully tested.

   (b) It is best to create a directory with the lustre file parameters, for example:

       On Pleiades, cd to /nobackupp8/<username>:

          mkdir 2M
	  lfs setstripe -c 64 -s 2m 2M

        Then run in subdirectory 2M, using example submit script run_cgns.sh (appropriately modified)

	This will use a count of 64 and a strip size of 2M, which has shown good performance.

This contains a number of Fortran test cases to test the CGNS library.

***** NOTE *****
You will first have to edit the Makefile include to set up your
CGNS location and compiler and options

Edit 'make.defs' for Linux/Unix or Windows using gmake.
Edit 'make.win" for Windows using nmake

To just build the code, use
    make
on linux/Unix, or
    nmake -f Makefile.win
on Windows

To build and run the tests, use
    make test
or
    nmake -f Makefile.win test

To clean everything up, use
    make clean
or
    nmake -f Makefile.win clean

If you just want to look at a specific example, then cd to the
directory and use the make commands above there.

	program write_bprop
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on August 2002

!       This example test the BCProperty_t data structure and its children
!       It tests the functions:
!	- cg_bc_wallfunction_write_f(cg, B, Z, BC, WallFunctionType, ier)
!	- cg_bc_area_write_f(cg, B, Z, BC, AreaType, SurfaceArea, RegionName, ier)
!       And the following:
!       - multiple calls for the same BC => must return error in mode write
!       - Test RegionName in 32 char string, justification, call with a name (not declared)
!       - cg_descriptor_write under BCProperty_t, WallFunction_t, Area_t
!       - cg_user_data_write, under BCProperty_t, WallFunction_t, Area_t
!       - cg_array_write under Area_t => should return an error
!       - links under BCProperty_t, WallFunction_t, Area_t
!       - cg_goto to BCProperty_t, WallFunction_t, Area_t
!       - Memory check with Insure

#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 3)
	integer index_dim, cell_dim, phys_dim
	character*100 linkpath

	integer cg, base, zone, boco, ier, i, num
	integer(cgsize_t) size(Ndim*3)
	integer WallFunctionType, AreaType
	integer(cgsize_t) pnts(Ndim,2)
	character*32 RegionName32
	character*10 RegionName10
	character*100 RegionName100
	real *4 SurfaceArea
	integer dim_vals(2)
	

! *** initialize
	ier = 0
	index_dim=Ndim
	cell_dim=Ndim
	phys_dim=Ndim

! *** open CGNS file for writing
 	call cg_open_f('Test_V2', MODE_WRITE, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f

! *** base
 	call cg_base_write_f(cg, 'Basename', cell_dim, phys_dim,
     &                       base, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f

! *** write a descriptor under the base
        call cg_goto_f(cg, base, ier, 'end')
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_descriptor_write_f('BaseDescriptorName',
     &      'BaseDescriptorText', ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** write a zone
	do i=1,index_dim                    	! zone#1: 3*4*5
	    size(i) = i+2			! nr of nodes in i,j,k
	    size(i+index_dim) = size(i)-1	! nr of elements in i,j,k
	    size(i+2*index_dim) = 0		! nr of bnd nodes if ordered
	    num = num * size(i)             	! nr of nodes
	enddo

	call cg_zone_write_f(cg, base, 'Zone#1', size, Structured,
     & 	    zone, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** write bocos
	! imin face
	do i=1, index_dim
	    pnts(i,1) = 1
	    pnts(i,2) = size(i)
	enddo
	pnts(1,2) = 1
        call cg_boco_write_f(cg, base, zone, 'boco#1',
     &       BCInflow, PointRange, 2_cgsize_t, pnts, boco, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        ! imax face
	do i=1, index_dim
            pnts(i,1) = 1
            pnts(i,2) = size(i)
        enddo
        pnts(1,1) = size(1)
	call cg_boco_write_f(cg, base, zone, 'boco#2',
     &       BCOutflow, PointRange, 2_cgsize_t, pnts, boco, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	
! *** write BCProperty_t/WallFunction_t node under boco#2
	WallFunctionType = Generic
	call cg_bc_wallfunction_write_f(cg, base, zone,
     &        boco, WallFunctionType, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** test calling it again
!	call cg_bc_wallfunction_write_f(cg, base, zone,
!    &        boco, WallFunctionType, ier)
!       if (ier .eq. ERROR) call cg_error_exit_f

! *** write BCProperty_t/Area_t node under boco#2
	AreaType = BleedArea
	SurfaceArea = 123.456
!	RegionName10 = 'myRegion'
 	RegionName100 = 'myRegion'
!	write(RegionName32,'(a10)')'myRegion32'
	call cg_bc_area_write_f(cg, base, zone, boco, AreaType,
     & 	     SurfaceArea, RegionName100, ier)

! *** write Descriptor_t, UserDefinedData_t & Link under...
! ...   BCProperty_t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1,
     &	    'BC_t', boco, 'BCProperty_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_descriptor_write_f('BCpropDescriptorName',
     &      'BCpropDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_user_data_write_f('BCPropUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! ...   WallFunction_t
	call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1,
     &      'BC_t', boco, 'BCProperty_t', 1, 'WallFunction_t', 1, 'end')

	call cg_descriptor_write_f('WFDescriptorName',
     &	    'WFDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_user_data_write_f('WFUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! ...   Area_t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1,
     &      'BC_t', boco, 'BCProperty_t', 1, 'Area_t', 1, 'end')
	call cg_descriptor_write_f('AreaDescriptorName',
     &	    'AreaDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_user_data_write_f('AreaUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

 	dim_vals(1)=3
 	dim_vals(2)=2
 	call cg_array_write_f('arraysize', Integer, 2, dim_vals,
     &        size, ier)
 	if (ier .ne. ERROR) write(6,'(a)') 'Error in API'

! * DataClass & DimensionalUnits under SurfaceArea
	call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1,
     &      'BC_t', boco, 'BCProperty_t', 1, 'Area_t', 1, 'DataArray_t',
     &	    1, 'end')

	call cg_dataclass_write_f(Dimensional, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	call cg_units_write_f(Kilogram, Meter, Second, Kelvin,
     &	    		      Radian, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

! *** close CGNS file
	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	end

      PROGRAM TEST

!
!     SAMPLE ADF TEST PROGRAM TO BUILD FILES ILLUSTRATED
!     IN THE EXAMPLE DATABASE FIGURE
!
      USE CGNS
      IMPLICIT NONE
!
      INTEGER MAXCHR
      PARAMETER (MAXCHR=32)
!
      CHARACTER*(MAXCHR) TSTLBL,DTYPE
      CHARACTER*(MAXCHR) FNAM,PATH
!
      REAL*8 RID,PID,CID,TMPID,RIDF2
      REAL A(4,3),B(4,3)
      INTEGER*4 IC(6),ID(6)
      INTEGER IERR,ICGIO,ICGIO2
      INTEGER(CGSIZE_T) :: IDIM(2),IDIMA(2),IDIMC,IDIMD
!
      DATA A /1.1,2.1,3.1,4.1,                                          &
     &      1.2,2.2,3.2,4.2,                                            &
     &      1.3,2.3,3.3,4.3/
      DATA IDIMA /4,3/
!
      DATA IC /1,2,3,4,5,6/
      DATA IDIMC /6/
      INTEGER NUMDIM, I, J

!
      IF (CG_BUILD_64BIT) THEN
        PRINT *,'PROGRAM NOT SET UP FOR 64-BIT'
        STOP
      ENDIF
!
!     SET ERROR FLAG TO ABORT ON ERROR
!
      CALL CGIO_ERROR_ABORT_F(1)
!
! *** 1.) OPEN 1ST DATABASE (ADF_FILE_TWO.ADF)
!     2.) CREATE THREE NODES AT FIRST LEVEL
!     3.) PUT LABEL ON NODE F3
!     4.) PUT DATA IN F3
!     5.) CREATE TWO NODES BELOW F3
!     6.) CLOSE DATABASE
!
      CALL CGIO_OPEN_FILE_F('file_two.cgio',CGIO_MODE_WRITE,            &
     &                      CGIO_FILE_ADF,ICGIO,IERR)
      CALL CGIO_GET_ROOT_ID_F(ICGIO,RID,IERR)
      RIDF2 = RID
      CALL CGIO_CREATE_NODE_F(ICGIO,RID,'F1',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,RID,'F2',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,RID,'F3',PID,IERR)
      CALL CGIO_SET_LABEL_F(ICGIO,PID,'LABEL ON NODE F3',IERR)
      CALL CGIO_SET_DIMENSIONS_F(ICGIO,PID,'R4',2,IDIMA,IERR)
      CALL CGIO_WRITE_ALL_DATA_F(ICGIO,PID,A,IERR)
!
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'F4',CID,IERR)
!
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'F5',CID,IERR)
!
      CALL CGIO_CLOSE_FILE_F(ICGIO,IERR)
!
! *** 1.) OPEN 2ND DATABASE
!     2.) CREATE NODES
!     3.) PUT DATA IN N13
!
      CALL CGIO_OPEN_FILE_F('file_one.cgio',CGIO_MODE_WRITE,            &
     &                      CGIO_FILE_ADF,ICGIO,IERR)
      CALL CGIO_GET_ROOT_ID_F(ICGIO,RID,IERR)
!
!     THREE NODES UNDER ROOT
!
      CALL CGIO_CREATE_NODE_F(ICGIO,RID,'N1',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,RID,'N2',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,RID,'N3',TMPID,IERR)
!
!     THREE NODES UNDER N1 (TWO REGULAR AND ONE LINK)
!
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'N1',PID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'N4',TMPID,IERR)
      CALL CGIO_CREATE_LINK_F(ICGIO,PID,'L3','file_two.cgio','/F3',     &
     &                        TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'N5',TMPID,IERR)
!
!     TWO NODES UNDER N4
!
      CALL CGIO_GET_NODE_ID_F(ICGIO,PID,'N4',CID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,CID,'N6',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,CID,'N7',TMPID,IERR)
!
!     ONE NODE UNDER N6
!
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'/N1/N4/N6',PID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'N8',TMPID,IERR)
!
!     THREE NODES UNDER N3
!
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'N3',PID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'N9',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'N10',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'N11',TMPID,IERR)
!
!     TWO NODES UNDER N9
!
      CALL CGIO_GET_NODE_ID_F(ICGIO,PID,'N9',CID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,CID,'N12',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,CID,'N13',TMPID,IERR)
!
!     PUT LABEL AND DATA IN N13
!
      CALL CGIO_SET_LABEL_F(ICGIO,TMPID,'LABEL ON NODE N13',IERR)
      CALL CGIO_SET_DIMENSIONS_F(ICGIO,TMPID,'I4',1,IDIMC,IERR)
      CALL CGIO_WRITE_ALL_DATA_F(ICGIO,TMPID,IC,IERR)
!
!     TWO NODES UNDER N10
!
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'/N3/N10',PID,IERR)
      CALL CGIO_CREATE_LINK_F(ICGIO,PID,'L1','\0','/N3/N9/N13',         &
     & TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'N14',TMPID,IERR)
!
!     TWO NODES UNDER N11
!
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'/N3/N11',PID,IERR)
      CALL CGIO_CREATE_LINK_F(ICGIO,PID,'L2','\0','/N3/N9/N13',         &
     & TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'N15',TMPID,IERR)
!
! *** READ AND PRINT DATA FROM NODES
!     1.) NODE F5 THROUGH LINK L3
!
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'/N1/L3',PID,IERR)
      CALL CGIO_GET_LABEL_F(ICGIO,PID,TSTLBL,IERR)
      CALL CGIO_GET_DATA_TYPE_F(ICGIO,PID,DTYPE,IERR)
      CALL CGIO_GET_DIMENSIONS_F(ICGIO,PID,NUMDIM,IDIM,IERR)
      CALL CGIO_READ_ALL_DATA_F(ICGIO,PID,B,IERR)
      PRINT *,' NODE F3 THROUGH LINK L3:'
      PRINT *,'   LABEL       = ',TSTLBL
      PRINT *,'   DATA TYPE   = ',DTYPE
      PRINT *,'   NUM OF DIMS = ',NUMDIM
      PRINT *,'   DIM VALS    = ',IDIM
      PRINT *,'   DATA:'
      WRITE(*,100)((B(J,I),I=1,3),J=1,4)
  100 FORMAT(5X,3F10.2)
!
!     2.) N13
!
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'N3/N9/N13',PID,IERR)
      CALL CGIO_GET_LABEL_F(ICGIO,PID,TSTLBL,IERR)
      CALL CGIO_GET_DATA_TYPE_F(ICGIO,PID,DTYPE,IERR)
      CALL CGIO_GET_DIMENSIONS_F(ICGIO,PID,NUMDIM,IDIMD,IERR)
      CALL CGIO_READ_ALL_DATA_F(ICGIO,PID,ID,IERR)
      PRINT *,' '
      PRINT *,' NODE N13:'
      PRINT *,'   LABEL       = ',TSTLBL
      PRINT *,'   DATA TYPE   = ',DTYPE
      PRINT *,'   NUM OF DIMS = ',NUMDIM
      PRINT *,'   DIM VALS    = ',IDIMD
      PRINT *,'   DATA:'
      WRITE(*,200)(ID(I),I=1,6)
  200 FORMAT(5X,6I6)
!
!     3.) N13 THROUGH L1
!
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'N3/N10/L1',TMPID,IERR)
      CALL CGIO_GET_LABEL_F(ICGIO,TMPID,TSTLBL,IERR)
      CALL CGIO_READ_ALL_DATA_F(ICGIO,TMPID,ID,IERR)
      PRINT *,' '
      PRINT *,' NODE N13 THROUGH LINK L1:'
      PRINT *,'   LABEL       = ',TSTLBL
      PRINT *,'   DATA:'
      WRITE(*,200)(ID(I),I=1,6)
!
!     4.) N13 THROUTH L2
!
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'N3/N11/L2',CID,IERR)
      CALL CGIO_GET_LABEL_F(ICGIO,CID,TSTLBL,IERR)
      CALL CGIO_READ_ALL_DATA_F(ICGIO,CID,ID,IERR)
      PRINT *,' '
      PRINT *,' NODE N13 THROUGH LINK L2:'
      PRINT *,'   LABEL       = ',TSTLBL
      PRINT *,'   DATA:'
      WRITE(*,200)(ID(I),I=1,6)
!
!     PRINT LIST OF CHILDREN UNDER ROOT NODE
!
      CALL PRTCLD(ICGIO,RID)
!
!     PRINT LIST OF CHILDREN UNDER N3
!
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'N3',PID,IERR)
      CALL PRTCLD(ICGIO,PID)
!
!     REOPEN ADF_FILE_TWO AND GET NEW ROOT ID
!
      CALL CGIO_OPEN_FILE_F('file_two.cgio',CGIO_MODE_READ,             &
     &                      CGIO_FILE_ADF,ICGIO2,IERR)
      CALL CGIO_GET_ROOT_ID_F(ICGIO2,RID,IERR)
      PRINT *,' '
      PRINT *,' COMPARISON OF ROOT ID: '
      PRINT *,' file_two.cgio ORIGINAL ROOT ID = ',RIDF2
      PRINT *,' file_two.cgio NEW ROOT ID      = ',RID
!
      CALL CGIO_CLOSE_FILE_F(ICGIO,IERR)
      CALL CGIO_CLOSE_FILE_F(ICGIO2,IERR)
!
      STOP
      END
!
! ************* SUBROUTINES ****************
!
      SUBROUTINE PRTCLD(ICGIO,PID)
      USE CGNS
!
! *** PRINT TABLE OF CHILDREN GIVEN A PARENT NODE-ID
!
      PARAMETER (MAXCLD=10)
      PARAMETER (MAXCHR=32)
      REAL*8 PID
      CHARACTER*(MAXCHR) NODNAM,NDNMS(MAXCLD)
      CALL CGIO_GET_NAME_F(ICGIO,PID,NODNAM,IERR)
      CALL CGIO_NUMBER_CHILDREN_F(ICGIO,PID,NUMC,IERR)
      WRITE(*,120)NODNAM,NUMC
  120 FORMAT(/,' PARENT NODE NAME = ',A,/,                              &
     &       '     NUMBER OF CHILDREN = ',I2,/,                         &
     &       '     CHILDREN NAMES:')
      NLEFT = NUMC
      ISTART = 1
!     --- TOP OF DO-WHILE LOOP
  130 CONTINUE
         CALL CGIO_CHILDREN_NAMES_F(ICGIO,PID,ISTART,MAXCLD,MAXCHR,     &
     &                              NUMRET,NDNMS,IERR)
         WRITE(*,140)(NDNMS(K),K=1,NUMRET)
  140    FORMAT(8X,A)
         NLEFT = NLEFT - MAXCLD
         ISTART = ISTART + MAXCLD
      IF (NLEFT .GT. 0) GO TO 130
      RETURN
      END

!
! @file test_poly_unstructured_f90.F90
! @version 0.1
!
! @section DESCRIPTION
! Test program for pcgns library
! -- created to test cgp_poly_section_write
! -- created to test cgp_poly_element_write_data
!
! @section USAGE
! Launch with:
!    mpirun -np <#> test_unstructured
!
! where number of ranks should be 2.
!
!

PROGRAM test_poly_unstructured_f

  USE mpi
  USE ISO_C_BINDING
  USE CGNS
  USE testing_utils
  IMPLICIT NONE

#include "cgnstypes_f03.h"
#ifdef WINNT
  INCLUDE 'cgnswin_f.h'
#endif
  INTEGER, PARAMETER :: dp = KIND(0.0d0)

  INTEGER(C_INT) comm_size, comm_rank, mpi_err
  INTEGER Cx, Cy, Cz, F, B, Z, S
  INTEGER :: info
  INTEGER :: ierr
  INTEGER :: cell_dim
  INTEGER :: phys_dim
  INTEGER :: nb_zones
  INTEGER :: count
  INTEGER :: iProc
  INTEGER :: iZone
  INTEGER(cgsize_t) :: nbCellSide
  INTEGER(cgsize_t) :: nbNodeSide
  INTEGER(cgsize_t) :: nbNodeSlice
  INTEGER(cgsize_t) :: nbNodeTotal
  INTEGER(cgsize_t) :: nbCellSlice
  INTEGER(cgsize_t) :: nbCellTotal
  INTEGER(cgsize_t) :: offsetsTotalSize
  INTEGER(cgsize_t) :: startOffset
  INTEGER(cgsize_t) :: nbNodeIdeal
  INTEGER(cgsize_t) :: nbCellIdeal
  INTEGER(cgsize_t) :: cellOnProcStart
  INTEGER(cgsize_t) :: cellOnProcEnd
  INTEGER(cgsize_t) :: nodeOnProcStart
  INTEGER(cgsize_t) :: nodeOnProcEnd
  INTEGER(cgsize_t) :: nbCellWrite
  INTEGER(cgsize_t) :: nbNodeWrite
  INTEGER(cgsize_t) :: start, end
  INTEGER(C_INT64_T) :: start_l, end_l, nb_read
  INTEGER(cgsize_t) :: iNode, jNode, iCell, jCell, i, j, k
  INTEGER(cgsize_t) :: local_size(1)
  INTEGER(cgsize_t) :: sizes(3)
  INTEGER(cgsize_t), ALLOCATABLE :: offsets_sizes(:)
  INTEGER(cgsize_t), ALLOCATABLE :: cells(:), offsets(:)
  INTEGER(cgsize_t) :: size_read
  INTEGER(cgsize_t), ALLOCATABLE, TARGET :: cells_read(:), offsets_read(:)

  REAL(dp), ALLOCATABLE :: nodeX(:), nodeY(:), nodeZ(:)
  REAL(dp) :: spacing

  CHARACTER(len=10) :: cZone
  CHARACTER(len=1) :: ichr1
!
!---- initialize MPI
  CALL MPI_INIT(mpi_err)
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD, comm_size, mpi_err)
  CALL MPI_COMM_RANK(MPI_COMM_WORLD, comm_rank, mpi_err)
  CALL MPI_INFO_CREATE(info, mpi_err)

  IF (comm_size /= 2 .AND. comm_rank == 0) THEN
    PRINT*, "WARNING: test is supposed to be run with two processes"
  END IF

  ! default test values
  cell_dim = 3
  phys_dim = 3
  nb_zones = 5
  nbCellSide = 20

  ! basic mesh information
  nbNodeSide = nbCellSide + 1
  nbNodeSlice = nbNodeSide * nbNodeSide
  nbNodeTotal = nbNodeSide * nbNodeSlice
  nbCellSlice = nbCellSide * nbCellSide
  nbCellTotal = nbCellSide * nbCellSlice

  ! sizing of section
  offsetsTotalSize = 0
  startOffset = 0

  ! distribute the elements and nodes hosted by each rank
  nbNodeIdeal = (nbNodeTotal / comm_size) + 1
  nbCellIdeal = (nbCellTotal / comm_size) + 1
  cellOnProcStart = (comm_rank) * (nbCellIdeal)
  cellOnProcEnd = (comm_rank + 1) * (nbCellIdeal)
  nodeOnProcStart = (comm_rank) * (nbNodeIdeal)
  nodeOnProcEnd = (comm_rank + 1) * (nbNodeIdeal)
  cellOnProcEnd = MIN(cellOnProcEnd, nbCellTotal)
  nodeOnProcEnd = MIN(nodeOnProcEnd, nbNodeTotal)
  nbCellWrite = cellOnProcEnd - cellOnProcStart
  nbNodeWrite = nodeOnProcEnd - nodeOnProcStart

  ! create a simple cube mesh
  ALLOCATE(nodeX(nbNodeWrite))
  ALLOCATE(nodeY(nbNodeWrite))
  ALLOCATE(nodeZ(nbNodeWrite))
  spacing = 1.0 / (nbNodeSide - 1)
  count = 1
  DO iNode = nodeOnProcStart+1, nodeOnProcEnd
    jNode = iNode - 1
    i = FLOOR(jNode / REAL(nbNodeSlice, dp))
    j = FLOOR((jNode - i * nbNodeSlice) / REAL(nbNodeSide, dp))
    k = jNode - i * nbNodeSlice - j * nbNodeSide
    nodeX(count) = (i * spacing)
    nodeY(count) = (j * spacing)
    nodeZ(count) = (k * spacing)
    count = count + 1
  END DO

  ALLOCATE(cells(9*nbCellWrite))
  ALLOCATE(offsets(nbCellWrite+1))
  count = 0
  offsets(1) = 0
  DO iCell = cellOnProcStart+1, cellOnProcEnd
    jCell = iCell - 1
    i = FLOOR(jCell / REAL(nbCellSlice, dp))
    j = FLOOR((jCell - i * nbCellSlice) / REAL(nbCellSide))
    k = jCell - i * nbCellSlice - j * nbCellSide
    cells(count + 1) = INT(CGNS_ENUMV(HEXA_8), cgsize_t)
    cells(count + 2) = &
        (i + 0) * nbNodeSlice + (j + 0) * nbNodeSide + (k + 0) + 1
    cells(count + 3) = &
        (i + 1) * nbNodeSlice + (j + 0) * nbNodeSide + (k + 0) + 1
    cells(count + 4) = &
        (i + 1) * nbNodeSlice + (j + 1) * nbNodeSide + (k + 0) + 1
    cells(count + 5) = &
        (i + 0) * nbNodeSlice + (j + 1) * nbNodeSide + (k + 0) + 1
    cells(count + 6) = &
        (i + 0) * nbNodeSlice + (j + 0) * nbNodeSide + (k + 1) + 1
    cells(count + 7) = &
        (i + 1) * nbNodeSlice + (j + 0) * nbNodeSide + (k + 1) + 1
    cells(count + 8) = &
        (i + 1) * nbNodeSlice + (j + 1) * nbNodeSide + (k + 1) + 1
    cells(count + 9) = &
        (i + 0) * nbNodeSlice + (j + 1) * nbNodeSide + (k + 1) + 1
    count = count + 9
    offsets(iCell - cellOnProcStart + 1) = count
  END DO

  ! get writing offsets
  ALLOCATE(offsets_sizes(comm_size))
  local_size(1) = offsets(nbCellWrite+1)

#if CG_BUILD_64BIT_F
  CALL MPI_Allgather(local_size, 1, MPI_INT64_T, offsets_sizes, 1, MPI_INT64_T, &
                      MPI_COMM_WORLD, ierr)
#else
  CALL MPI_Allgather(local_size, 1, MPI_INT32_T, offsets_sizes, 1, MPI_INT32_T, &
                      MPI_COMM_WORLD, ierr)
#endif

  DO iProc = 1, comm_size
    IF (iProc-1 < comm_rank) THEN
      startOffset = startOffset + INT(offsets_sizes(iProc), cgsize_t)
    END IF
    offsetsTotalSize = offsetsTotalSize + INT(offsets_sizes(iProc), cgsize_t)
  END DO

  DO iCell = 1, nbCellWrite+1
    offsets(iCell) = offsets(iCell) + startOffset
  END DO

  IF(comm_rank.EQ.0) CALL write_test_header("Testing writing a data node selection")

  ! write file
  CALL cgp_mpi_comm_f(MPI_COMM_WORLD, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
  CALL cgp_open_f('test_poly_unstructured_f90.cgns', CG_MODE_WRITE, F, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
  CALL cg_base_write_f(F, 'Unstructured3D', cell_dim, phys_dim, B, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

  DO iZone = 1,nb_zones
     WRITE(ichr1,'(I1.1)') iZone

    ! offset the nodes for each zone
    IF (iZone > 1) THEN
      DO iNode = 1, nbNodeWrite
        nodeX(iNode) = nodeX(iNode) + 1.0
      END DO
    END IF

    ! create the zone
    WRITE(cZone,"(I6)") iZone - 1
    sizes(1) = nbNodeTotal
    sizes(2) = nbCellTotal
    sizes(3) = 0
    CALL cg_zone_write_f(F, B, "domain"//TRIM(ADJUSTL(cZone)), sizes, CGNS_ENUMV(Unstructured), Z, ierr)
    IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

    ! write the nodes in parallel
    start = nodeOnProcStart + 1
    end = nodeOnProcEnd
    CALL cgp_coord_write_f(F, B, Z, CGNS_ENUMV(RealDouble), 'CoordinateX', Cx, ierr)
    IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
    CALL cgp_coord_write_f(F, B, Z, CGNS_ENUMV(RealDouble), 'CoordinateY', Cy, ierr)
    IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
    CALL cgp_coord_write_f(F, B, Z, CGNS_ENUMV(RealDouble), 'CoordinateZ', Cz, ierr)
    IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
    CALL cgp_coord_write_data_f(F, B, Z, Cx, start, end, nodeX, ierr)
    IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
    CALL cgp_coord_write_data_f(F, B, Z, Cy, start, end, nodeY, ierr)
    IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
    CALL cgp_coord_write_data_f(F, B, Z, Cz, start, end, nodeZ, ierr)
    IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

    ! create element node
    start = 1
    end = nbCellTotal
    CALL cgp_poly_section_write_f(F, B, Z, "Elements 3D", CGNS_ENUMV(MIXED), start, end, offsetsTotalSize, 0, S, ierr)
    IF(ierr.NE.CG_OK)THEN
       IF (comm_rank .EQ. 0) CALL write_test_status(failed, "Test cgp_poly_section_write_f, Zone "//ichr1)
       CALL cgp_error_exit_f()
    ELSE
       IF (comm_rank .EQ. 0) CALL write_test_status(passed, "Test cgp_poly_section_write_f, Zone "//ichr1)
    ENDIF

    start = cellOnProcStart + 1
    end = cellOnProcEnd
    CALL cgp_poly_elements_write_data_f(F, B, Z, S, start, end, cells, offsets, ierr)
    IF(ierr.NE.CG_OK)THEN
       WRITE(ichr1,'(I1.1)') iZone
       IF (comm_rank .EQ. 0) CALL write_test_status(failed, "Test cgp_poly_elements_write_data_f, Zone "//ichr1)
       CALL cgp_error_exit_f()
    ELSE
       IF (comm_rank .EQ. 0) CALL write_test_status(passed, "Test cgp_poly_elements_write_data_f, Zone "//ichr1)
    ENDIF

  END DO

  CALL cgp_close_f(F, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

  CALL MPI_Barrier(MPI_COMM_WORLD, ierr)

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  ! Read and compare data with expected values
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  IF(comm_rank.EQ.0) CALL write_test_header("Testing reading a data node selection")

  DO iZone = 1, nb_zones

     WRITE(ichr1,'(I1.1)') iZone

     ! Zero out node coordinates
     nodeX = 0.0_dp
     nodeY = 0.0_dp
     nodeZ = 0.0_dp

     ! Open file in parallel
     CALL cgp_mpi_comm_f(MPI_COMM_WORLD, ierr)
     IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

     CALL cgp_open_f('test_poly_unstructured_f90.cgns', CG_MODE_READ, F, ierr)
     IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

     ! Read nodes and compare
     start = nodeOnProcStart + 1
     end   = nodeOnProcEnd
  
     CALL cgp_coord_read_data_f(F, B, iZone, Cx, start, end, nodeX, ierr)
     IF (ierr /= CG_OK) CALL cgp_error_exit_f
     CALL cgp_coord_read_data_f(F, B, iZone, Cy, start, end, nodeY, ierr)
     IF (ierr /= CG_OK) CALL cgp_error_exit_f
     CALL cgp_coord_read_data_f(F, B, iZone, Cz, start, end, nodeZ, ierr)
     IF (ierr /= CG_OK) CALL cgp_error_exit_f

     count = 1
     DO iNode = nodeOnProcStart+1, nodeOnProcEnd
        jNode = iNode - 1
        i = FLOOR(jNode / REAL(nbNodeSlice, dp))
        j = FLOOR((jNode - i * nbNodeSlice) / REAL(nbNodeSide, dp))
        k = jNode - i * nbNodeSlice - j * nbNodeSide

        ! Compare values
        IF (.NOT. check_eq(nodeX(count), i * spacing + (iZone-1) * 1.0_dp)) THEN
           IF (comm_rank .EQ. 0) CALL write_test_status(failed, "Test cgp_coord_read_data_f", "Mismatch in nodeX")
           CALL cgp_error_exit_f()
        ENDIF
        IF (.NOT. check_eq(nodeY(count) , j * spacing)) THEN
           IF (comm_rank .EQ. 0) CALL write_test_status(failed, "Test cgp_coord_read_data_f", "Mismatch in nodeY")
           CALL cgp_error_exit_f()
        ENDIF
        IF (.NOT. check_eq(nodeZ(count), k * spacing)) THEN
           IF (comm_rank .EQ. 0) CALL write_test_status(failed, "Test cgp_coord_read_data_f", "Mismatch in nodeZ")
           CALL cgp_error_exit_f()
        ENDIF
        count = count + 1
     END DO

     CALL cgp_close_f(F, ierr)
     IF (ierr /= CG_OK) CALL cgp_error_exit_f
  END DO

  IF (comm_rank .EQ. 0) CALL write_test_status(passed, "Test cgp_coord_read_data_f")

  ! Read elements in serial mode

  IF(comm_rank.EQ.0) CALL write_test_header("Testing reading mixed element data in serial")

  DO iZone = 1, nb_zones

     WRITE(ichr1,'(I1.1)') iZone

     ! Compare on rank 0 only, read for all procs
     IF (comm_rank == 0) THEN
        CALL cgp_mpi_comm_f(MPI_COMM_SELF, ierr)
        IF (ierr /= CG_OK) CALL cgp_error_exit_f
        CALL cgp_open_f('test_poly_unstructured_f90.cgns', CG_MODE_READ, F, ierr)
        IF (ierr /= CG_OK) CALL cgp_error_exit_f

        start_l = INT(cellOnProcStart + 1, KIND=C_INT64_T)
        end_l   = INT(cellOnProcEnd, KIND=C_INT64_T)
        nb_read = INT(cellOnProcEnd - cellOnProcStart, KIND=C_INT64_T)

        DO iProc = 1, comm_size
           IF (iProc-1 /= comm_rank) THEN
              CALL MPI_Recv(nb_read, 1, MPI_INT64_T, iProc-1, 1, MPI_COMM_WORLD, MPI_STATUS_IGNORE, mpi_err)
              CALL MPI_Recv(start_l, 1, MPI_INT64_T, iProc-1, 2, MPI_COMM_WORLD, MPI_STATUS_IGNORE, mpi_err)
              CALL MPI_Recv(end_l  , 1, MPI_INT64_T, iProc-1, 3, MPI_COMM_WORLD, MPI_STATUS_IGNORE, mpi_err)
           END IF

           CALL cg_ElementPartialSize_f(F, B, iZone, S, INT(start_l, cgsize_t), INT(end_l, cgsize_t), size_read, ierr)
           IF (ierr /= CG_OK) CALL cgp_error_exit_f

           ALLOCATE(cells_read(size_read))
           ALLOCATE(offsets_read(nb_read + 1))

           CALL cg_poly_elements_partial_read_f(F, B, iZone, S, start_l, end_l, &
                cells_read, offsets_read, C_NULL_PTR, ierr)
           IF (ierr /= CG_OK) CALL cgp_error_exit_f

           ! Compare element connectivity
           count = 1
           DO iCell = start_l, end_l
              jCell = iCell - 1
              i = FLOOR(jCell / REAL(nbCellSlice, dp))
              j = FLOOR((jCell - i * nbCellSlice) / REAL(nbCellSide, dp))
              k = jCell - i * nbCellSlice - j * nbCellSide

              IF( .NOT.check_eq(cells_Read(count + 0), INT(CGNS_ENUMV(HEXA_8), CGSIZE_T)) .OR. &
                  .NOT.check_eq(cells_Read(count + 1), (i + 0) * nbNodeSlice + (j + 0) * nbNodeSide + (k + 0) + 1) .OR. &
                  .NOT.check_eq(cells_Read(count + 2), (i + 1) * nbNodeSlice + (j + 0) * nbNodeSide + (k + 0) + 1) .OR. &
                  .NOT.check_eq(cells_Read(count + 3), (i + 1) * nbNodeSlice + (j + 1) * nbNodeSide + (k + 0) + 1) .OR. &
                  .NOT.check_eq(cells_Read(count + 4), (i + 0) * nbNodeSlice + (j + 1) * nbNodeSide + (k + 0) + 1) .OR. &
                  .NOT.check_eq(cells_Read(count + 5), (i + 0) * nbNodeSlice + (j + 0) * nbNodeSide + (k + 1) + 1) .OR. &
                  .NOT.check_eq(cells_Read(count + 6), (i + 1) * nbNodeSlice + (j + 0) * nbNodeSide + (k + 1) + 1) .OR. &
                  .NOT.check_eq(cells_Read(count + 7), (i + 1) * nbNodeSlice + (j + 1) * nbNodeSide + (k + 1) + 1) .OR. &
                  .NOT.check_eq(cells_Read(count + 8), (i + 0) * nbNodeSlice + (j + 1) * nbNodeSide + (k + 1) + 1)) THEN

                 IF (comm_rank .EQ. 0) CALL write_test_status(failed, "read cg_poly_elements_partial_read_f values, Zone "//ichr1)
                 CALL cgp_error_exit_f()
              ENDIF
              count = count + 9
           END DO

           DEALLOCATE(cells_read)
           DEALLOCATE(offsets_read)
        END DO

        CALL cgp_close_f(F, ierr)
        IF (ierr /= CG_OK) CALL cgp_error_exit_f

     ELSE
        start_l = INT(cellOnProcStart + 1, KIND=C_INT64_T)
        end_l = INT(cellOnProcEnd, KIND=C_INT64_T)
        nb_read = INT(cellOnProcEnd - cellOnProcStart, KIND=C_INT64_T)
    
        CALL MPI_Send(nb_read, 1, MPI_INT64_T, 0, 1, MPI_COMM_WORLD, ierr)
        CALL MPI_Send(start_l, 1, MPI_INT64_T, 0, 2, MPI_COMM_WORLD, ierr)
        CALL MPI_Send(end_l  , 1, MPI_INT64_T, 0, 3, MPI_COMM_WORLD, ierr)
     END IF

     IF (comm_rank .EQ. 0) CALL write_test_status(passed, "read cg_poly_elements_partial_read_f values, Zone "//ichr1)

  END DO


  ! Read elements in parallel mode

  IF(comm_rank.EQ.0) CALL write_test_header("Testing reading mixed element data in parallel")

  DO iZone = 1, nb_zones

     WRITE(ichr1,'(I1.1)') iZone

     ! Open file in parallel
     CALL cgp_mpi_comm_f(MPI_COMM_WORLD, ierr)
     IF (ierr /= CG_OK) CALL cgp_error_exit_f
     CALL cgp_open_f('test_poly_unstructured_f90.cgns', CG_MODE_READ, F, ierr)
     IF (ierr /= CG_OK) CALL cgp_error_exit_f

     start_l = cellOnProcStart + 1
     end_l = cellOnProcEnd
     nb_read = cellOnProcEnd - cellOnProcStart

     ALLOCATE(offsets_read(nb_read + 1))
  
     CALL cgp_poly_elements_read_data_offsets_f(F, B, iZone, S, start_l, end_l, offsets_read, ierr)
     IF (ierr /= CG_OK) CALL cgp_error_exit_f

     size_read = offsets_read(nb_read + 1)
     ALLOCATE(cells_read(size_read))

     CALL cgp_poly_elements_read_data_elements_f(F, B, iZone, S, start_l, end_l, offsets_read, cells_read, ierr)
     IF (ierr /= CG_OK) CALL cgp_error_exit_f

     count = 1
     DO iCell = start_l, end_l
        jCell = iCell - 1
        i = FLOOR(jCell / REAL(nbCellSlice, dp))
        j = FLOOR((jCell - i * nbCellSlice) / REAL(nbCellSide, dp))
        k = jCell - i * nbCellSlice - j * nbCellSide

        IF( .NOT.check_eq(cells_Read(count + 0), INT(CGNS_ENUMV(HEXA_8), CGSIZE_T)) .OR. &
             .NOT.check_eq(cells_Read(count + 1), (i + 0) * nbNodeSlice + (j + 0) * nbNodeSide + (k + 0) + 1) .OR. &
             .NOT.check_eq(cells_Read(count + 2), (i + 1) * nbNodeSlice + (j + 0) * nbNodeSide + (k + 0) + 1) .OR. &
             .NOT.check_eq(cells_Read(count + 3), (i + 1) * nbNodeSlice + (j + 1) * nbNodeSide + (k + 0) + 1) .OR. &
             .NOT.check_eq(cells_Read(count + 4), (i + 0) * nbNodeSlice + (j + 1) * nbNodeSide + (k + 0) + 1) .OR. &
             .NOT.check_eq(cells_Read(count + 5), (i + 0) * nbNodeSlice + (j + 0) * nbNodeSide + (k + 1) + 1) .OR. &
             .NOT.check_eq(cells_Read(count + 6), (i + 1) * nbNodeSlice + (j + 0) * nbNodeSide + (k + 1) + 1) .OR. &
             .NOT.check_eq(cells_Read(count + 7), (i + 1) * nbNodeSlice + (j + 1) * nbNodeSide + (k + 1) + 1) .OR. &
             .NOT.check_eq(cells_Read(count + 8), (i + 0) * nbNodeSlice + (j + 1) * nbNodeSide + (k + 1) + 1)) THEN

           CALL write_test_status(failed, "read cg_poly_elements_partial_read_f values, Zone "//ichr1)
           CALL cgp_error_exit_f()

        ENDIF
        count = count + 9
     END DO

     IF(comm_rank.EQ.0) CALL write_test_status(passed, "read cg_poly_elements_partial_read_f values, Zone "//ichr1)

     DEALLOCATE(cells_read)
     DEALLOCATE(offsets_read)
  
     CALL cgp_close_f(F, ierr)
     IF (ierr /= CG_OK) CALL cgp_error_exit_f
  END DO

  ! free memory
  DEALLOCATE(nodeX)
  DEALLOCATE(nodeY)
  DEALLOCATE(nodeZ)
  DEALLOCATE(cells)
  DEALLOCATE(offsets)
  DEALLOCATE(offsets_sizes)

  IF(comm_rank.EQ.0) CALL write_test_footer()

  CALL MPI_BARRIER(MPI_COMM_WORLD, mpi_err)
  CALL MPI_FINALIZE(mpi_err)
END PROGRAM test_poly_unstructured_f

        PROGRAM write_cprop
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on August 2002

!       This example test the GridConnectivityProperty_t data structure and its children
!       It tests the functions:
!	- cg_conn_average_write_f(cg, B, Z, I, AverageInterfaceType, ier)
!	- cg_conn_periodic_write_f(cg, B, Z, I, RotationCenter, RotationAngle, Translation, ier)
!       And the following:
!       - multiple calls for the same I => must return error in mode write
!       - cg_descriptor_write under GridConnectivityProperty_t, AverageInterface_t, Periodic_t
!       - cg_user_data_write, under GridConnectivityProperty_t, AverageInterface_t, Periodic_t
!       - cg_array_write under Periodic_t => should return an error
!       - links under GridConnectivityProperty_t, AverageInterface_t, Periodic_t
!       - cg_goto to GridConnectivityProperty_t, AverageInterface_t, Periodic_t
!       - Memory check with Insure
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 3)
	integer index_dim, cell_dim, phys_dim
	character*100 linkpath

	integer cg, base, zone, conn, ier, i, num, n
	integer(cgsize_t) size(Ndim*3)
	integer AverageInterfaceType
        integer(cgsize_t) pnts(Ndim,20), donor_pnts(Ndim,20)
	real *4 RotationCenter(Ndim), RotationAngle(Ndim)
	real *4 Translation(Ndim)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	integer(cgsize_t) dim_vals(2)
	

! *** initialize
	ier = 0
	index_dim=Ndim
	cell_dim=Ndim
	phys_dim=Ndim

! *** open CGNS file for writing
 	call cg_open_f('Test_V2', MODE_WRITE, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f

! *** base
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
 	call cg_base_write_f(cg, 'Basename', cell_dim, phys_dim, &
                             base, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f

! *** write a descriptor under the base
        call cg_goto_f(cg, base, ier, 'end')
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_descriptor_write_f('BaseDescriptorName', &
            'BaseDescriptorText', ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** write 2 zones
	do i=1,index_dim                    	! zone#1: 3*4*5
	    size(i) = i+2			! nr of nodes in i,j,k
	    size(i+index_dim) = size(i)-1	! nr of elements in i,j,k
	    size(i+2*index_dim) = 0		! nr of bnd nodes if ordered
	    num = num * size(i)             	! nr of nodes
	enddo

	call cg_zone_write_f(cg, base, 'Zone#1', size, CGNS_ENUMV(Structured), &
       	    zone, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_zone_write_f(cg, base, 'Zone#2', size, CGNS_ENUMV(Structured), &
            zone, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	zone = 1

! *** write conns
        DO n=1, 5
           DO i=1,3
              pnts(i,n)=i             ! * dummy data
              donor_pnts(i,n)=i*2
           ENDDO
        ENDDO
        call cg_conn_write_f(cg, base, zone, 'Connect#1', &
            CGNS_ENUMV(Vertex), CGNS_ENUMV(Abutting1to1), CGNS_ENUMV(PointList), 5_cgsize_t, pnts, 'Zone#2', &
            CGNS_ENUMV(Structured), CGNS_ENUMV(PointListDonor), CGNS_ENUMV(Integer), 5_cgsize_t, donor_pnts, &
            conn, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_conn_write_f(cg, base, zone, 'Connect#2', &
            CGNS_ENUMV(Vertex), CGNS_ENUMV(Abutting1to1), CGNS_ENUMV(PointList), 5_cgsize_t, pnts, 'Zone#2', &
            CGNS_ENUMV(Structured), CGNS_ENUMV(PointListDonor), CGNS_ENUMV(Integer), 5_cgsize_t, donor_pnts, &
            conn, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
	
! *** write GridConnectivityProperty_t/AverageInterface_t node under conn#2
	AverageInterfaceType = CGNS_ENUMV(AverageCircumferential)
	call cg_conn_average_write_f(cg, base, zone, &
              conn, AverageInterfaceType, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** test calling it again
!	call cg_conn_average_write_f(cg, base, zone,
!    &        conn, AverageInterfaceType, ier)
!       if (ier .eq. ERROR) call cg_error_print_f

! *** write GridConnectivityProperty_t/Periodic_t node under conn#2
	do n=1, Ndim
	    RotationCenter(n) = n*1.1
	    RotationAngle(n) = (n+3)*1.1
	    Translation(n) = (n+6)*1.1
	enddo
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	call cg_conn_periodic_write_f(cg, base, zone, conn, &
       	     RotationCenter, RotationAngle, Translation, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! *** write Descriptor_t, UserDefinedData_t & Link under...
! ...   GridConnectivityProperty_t
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
            'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn, &
      	    'GridConnectivityProperty_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_descriptor_write_f('GridConnPropDescriptorName', &
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
            'GridConnPropDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_user_data_write_f('GridConnPropUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! ...   AverageInterface_t
	call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
      	    'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn, &
            'GridConnectivityProperty_t', 1, 'AverageInterface_t', 1, &
            'end')
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_descriptor_write_f('AverageInterfaceDescriptorName', &
      	    'AverageInterfaceDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_user_data_write_f('AverageInterfaceUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! ...   Periodic_t
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
            'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn, &
            'GridConnectivityProperty_t', 1, 'Periodic_t', 1, 'end')
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_descriptor_write_f('PeriodicDescriptorName', &
      	    'PeriodicDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_user_data_write_f('PeriodicUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * DataClass & DimensionalUnits under Periodic
        call cg_dataclass_write_f(CGNS_ENUMV(Dimensional), ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        call cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), CGNS_ENUMV(Kelvin), &
                              CGNS_ENUMV(Radian), ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * DataArray under Periodic
 	dim_vals(1)=3
 	dim_vals(2)=2
 	call cg_array_write_f('arraysize', CGNS_ENUMV(Integer), 2, dim_vals, &
              size, ier)
 	if (ier .ne. ERROR) write(6,'(a)') 'Error in API'

! * DataClass & DimensionalUnits under RotationCenter
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
            'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn, &
            'GridConnectivityProperty_t', 1, 'Periodic_t', 1, &
            'DataArray_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_dataclass_write_f(CGNS_ENUMV(Dimensional), ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	call cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), CGNS_ENUMV(Kelvin), &
      	    		      CGNS_ENUMV(Radian), ier)
	if (ier .eq. ERROR) call cg_error_exit_f

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

! *** close CGNS file
	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

        END PROGRAM write_cprop

        PROGRAM write_cgns_motion
	USE CGNS
        implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on November 2000
!       This example test the API functions for grid motion and time accurate data.
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif
        INTEGER Ndim, NumberOfSteps, Nnodes
	parameter (Ndim = 3, NumberOfSteps=2)
	parameter (Nnodes = 120)
	integer index_dim, cell_dim, phys_dim, pos
	integer base_no, zone_no, coord_no, sol_no, field_no
	integer num
        INTEGER i, j, k
	integer(cgsize_t) size(Ndim*3), data_size(2)
	integer cg, ier, coord, sol, field
	double precision Dxyz(Nnodes), values(Nnodes)
	character*32 zonename, solname, fieldname, coordname(Ndim)

! *** Variables for RigidGridMotion_t test
!	real*4 origin(Ndim,2), angle(Ndim), velocity(Ndim)
	double precision origin(Ndim,2), angle(Ndim), velocity(Ndim)
	integer rmotion_no, rmotion
	character*32 rmotionname

! *** Variables for ArbitraryGridMotion_t test
!	real*4 GridVelocity(Nnodes)
	double precision GridVelocity(Nnodes)
	integer amotion_no, amotion
	character*32 amotionname

! *** Multiple GridCoordinates_t node
	integer grid_no, grid
	character*32 gridname

! *** Base/Zone IterativeData_t nodes
!	real*4 time(2)
	double precision time(2)
	integer nsteps, step
	integer(cgsize_t) dimval(3)
	integer*4 nzones(NumberOfSteps), iteration(NumberOfSteps)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	character*32 bitername, zitername, zone_ptrs(2,NumberOfSteps)
	character*32 grid_ptrs(NumberOfSteps), sol_ptrs(NumberOfSteps)
	character*32 rmotion_ptrs(NumberOfSteps)
        character*32 amotion_ptrs(NumberOfSteps)

	coordname(1) = 'CoordinateX'
	coordname(2) = 'CoordinateY'
	coordname(3) = 'CoordinateZ'

! *** initialize
	ier = 0
	index_dim=Ndim
	cell_dim=Ndim
	phys_dim=Ndim

! *** open CGNS file for writing
 	call cg_open_f('Test_V2', MODE_WRITE, cg, ier)
 	if (ier .ne. ALL_OK) call cg_error_exit_f
	
! *** base
 	call cg_base_write_f(cg, 'Basename', cell_dim, phys_dim, &
                             base_no, ier)
 	if (ier .ne. ALL_OK) call cg_error_exit_f

! *** simulation type
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	call cg_simulation_type_write_f(cg, base_no, CGNS_ENUMV(TimeAccurate), ier)
	if (ier .ne. ALL_OK) call cg_error_exit_f

! *** Base iterative data
	write(bitername,100) 'BaseIterativeData'
	nsteps=2
	call cg_biter_write_f(cg, base_no, bitername, nsteps, ier)
	if (ier .ne. ALL_OK) call cg_error_exit_f

	call cg_goto_f(cg, base_no, ier, 'BaseIterativeData_t',1,'end')

	if (ier .ne. ALL_OK) call cg_error_exit_f

! *** TimeValues & IterationValues
	do step=1,nsteps
	    time(step) = 15.5*step
	    iteration(step) = 1000*step
	    nzones(step) = step
	    write(zone_ptrs(1,step),100) 'Zone#',1
	    write(zone_ptrs(2,step),100) 'Null'
	    if (step.eq.2) write(zone_ptrs(2,step),100) 'Zone#',2
	enddo
	!call cg_array_write_f('TimeValues', CGNS_ENUMV(RealSingle), 1, nsteps,
	call cg_array_write_f('TimeValues', CGNS_ENUMV(RealDouble), 1, &
                               [INT(nsteps,cgsize_t)], time, ier)
        if (ier .ne. ALL_OK) call cg_error_exit_f
	call cg_array_write_f('IterationValues', CGNS_ENUMV(Integer), 1, &
                               [INT(nsteps,cgsize_t)],iteration, ier)
	if (ier .ne. ALL_OK) call cg_error_exit_f
	call cg_array_write_f('NumberOfZones', CGNS_ENUMV(Integer), 1, &
                               [INT(nsteps,cgsize_t)],nzones, ier)
	if (ier .ne. ALL_OK) call cg_error_exit_f
	dimval(1)=32
	dimval(2)=2 		! *** MaxNumberOfZones in a step1
	dimval(3)=nsteps
        call cg_array_write_f('ZonePointers', CGNS_ENUMV(Character), 3, dimval, &
                               zone_ptrs(:,1), ier)

	if (ier .ne. ALL_OK) call cg_error_exit_f
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

! *** zone
        write(zonename,100) 'Zone#',1
        num = 1
	do i=1,index_dim      		! zone#1: 3*4*5
            size(i) = i+2		! nr of nodes in i,j,k
	    size(i+Ndim) = size(i)-1	! nr of elements in i,j,k
	    size(i+2*Ndim) = 0		! nr of bnd nodes if ordered
       	    num = num * size(i)		! nr of nodes &
         enddo
         call cg_zone_write_f(cg, base_no, zonename, size, &
                             CGNS_ENUMV(Structured), zone_no, ier)
        if (ier .ne. ALL_OK) call cg_error_exit_f

! *** Zone iterative data
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	write(zitername,100) 'ZoneIterativeData'
        call cg_ziter_write_f(cg, base_no, zone_no, zitername, ier)
        if (ier .ne. ALL_OK) call cg_error_exit_f

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
        call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no, &
                       'ZoneIterativeData_t',1,'end')
        if (ier .ne. ALL_OK) call cg_error_exit_f

	do step=1, nsteps
	    write(grid_ptrs(step),100)   'GridCoordinates#',    step
	    write(sol_ptrs(step),100)    'FlowSolution#',       step
	    write(rmotion_ptrs(step),100)'RigidGridMotion#',    step
	    write(amotion_ptrs(step),100)'ArbitraryGridMotion#',step
	enddo
	dimval(1)=32
	dimval(2)=nsteps

	call cg_array_write_f('GridCoordinatesPointers', CGNS_ENUMV(Character), 2, &
                               dimval, grid_ptrs, ier)
        if (ier .ne. ALL_OK) call cg_error_exit_f
	call cg_array_write_f('FlowSolutionPointers', CGNS_ENUMV(Character), 2, &
                               dimval, sol_ptrs, ier)
        if (ier .ne. ALL_OK) call cg_error_exit_f
	call cg_array_write_f('RigidGridMotionPointers', CGNS_ENUMV(Character), 2, &
                               dimval, rmotion_ptrs, ier)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	if (ier .ne. ALL_OK) call cg_error_exit_f
        call cg_array_write_f('ArbitraryGridMotionPointers', CGNS_ENUMV(Character), &
                               2, dimval, amotion_ptrs, ier)
	if (ier .ne. ALL_OK) call cg_error_exit_f

! *** coordinate
      do coord=1, phys_dim
 	    do k=1, size(3)
 	    do j=1, size(2)
 	    do i=1, size(1)
	        pos = i + (j-1)*size(1) + (k-1)*size(1)*size(2)
		! * make up some dummy coordinates just for the test:
 	        if (coord.eq.1) Dxyz(pos) = i
 	        if (coord.eq.2) Dxyz(pos) = j
 	        if (coord.eq.3) Dxyz(pos) = k
 	    enddo
 	    enddo
 	    enddo

            call cg_coord_write_f(cg, base_no, zone_no, CGNS_ENUMV(RealDouble), &
                                  coordname(coord), Dxyz, coord_no, ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f

      enddo

! *** additional GridCoordinates_t Descriptions
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	do grid = 1,2
	    write(gridname,100)'GridCoordinates#',grid
	    call cg_grid_write_f(cg, base_no, zone_no, gridname, &
                                 grid_no, ier)
	    if (ier .ne. ALL_OK) call cg_error_exit_f

	    call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no, &
                           'GridCoordinates_t', grid_no, 'end')
            if (ier .ne. ALL_OK) call cg_error_exit_f
	
	    call cg_array_write_f('CoordinateX', CGNS_ENUMV(RealDouble), 3, &
                                   size, Dxyz, ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f
            call cg_array_write_f('CoordinateY', CGNS_ENUMV(RealDouble), 3, &
                                   size, Dxyz, ier)
            call cg_array_write_f('CoordinateZ', CGNS_ENUMV(RealDouble), 3, &
                                   size, Dxyz, ier)

      ! *** Write DataClass_t under CoordinateX
	    call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no, &
              'GridCoordinates_t', grid_no, 'DataArray_t', 1, 'end')
            if (ier .ne. ALL_OK) call cg_error_exit_f

	    call cg_dataclass_write_f(CGNS_ENUMV(Dimensional), ier)
	    if (ier .ne. ALL_OK) call cg_error_exit_f
	enddo

! *** solution
      do sol=1, 2
 	    write(solname,100) 'Solution#',sol
 	    call cg_sol_write_f(cg, base_no, zone_no, solname, &
                                CGNS_ENUMV(Vertex), sol_no, ier)
 	    if (ier .ne. ALL_OK) call cg_error_exit_f

! *** solution field
 	    do field=1, 2
	    ! make up some dummy solution values
 	  	do i=1, num
 		    values(i) = i*field*sol
 	    	enddo
 	    	write(fieldname,100) 'Field#',field
 	    	call cg_field_write_f(cg, base_no, zone_no, sol_no, &
                    CGNS_ENUMV(RealDouble), fieldname, values, field_no, ier)
 	    	if (ier .ne. ALL_OK) call cg_error_exit_f

 	    enddo				! field loop
        enddo				! solution loop

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
! *** Rigid Grid Motion
	do rmotion=1, 2
	    write(rmotionname,100) 'RigidGridMotion#',rmotion
	    do coord=1, phys_dim
	        origin(coord,1) = (rmotion-1)*10.0
	        origin(coord,2) = origin(coord,1) + 10.0
	        angle(coord) = 5.0 * rmotion
		velocity(coord) = 7.0
	    enddo
	    call cg_rigid_motion_write_f(cg, base_no, zone_no, &
            rmotionname, CGNS_ENUMV(ConstantRate), rmotion_no, ier)
	    if (ier .ne. ALL_OK) call cg_error_exit_f

! ** Goto RigidGridMotion_t node
	    call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no, &
                           'RigidGridMotion_t', rmotion_no, 'end')
	    if (ier .ne. ALL_OK) call cg_error_exit_f

! *** Add an attribute under RigidGridMotion_t
	    call cg_descriptor_write_f('DescriptorName', &
                                       'DescriptotText', ier)
	    if (ier .ne. ALL_OK) call cg_error_exit_f

! *** Add a DataArray_t under RigidGridMotion_t
	    data_size(1)=phys_dim
	    data_size(2)=2
            !call cg_array_write_f('OriginLocation', CGNS_ENUMV(RealSingle), 2,
            call cg_array_write_f('OriginLocation', CGNS_ENUMV(RealDouble), 2, &
                                   data_size, origin(1,1), ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f

            !call cg_array_write_f('RigidRotationAngle', CGNS_ENUMV(RealSingle), 1,
            call cg_array_write_f('RigidRotationAngle', CGNS_ENUMV(RealDouble), 1, &
                                  [INT(phys_dim,cgsize_t)], angle, ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f

	    !call cg_array_write_f('RigidVelocity', CGNS_ENUMV(RealSingle), 1,
	    call cg_array_write_f('RigidVelocity', CGNS_ENUMV(RealDouble), 1, &
                                  [INT(phys_dim,cgsize_t)], velocity, ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f

! *** Add an attribute for this data array: GOTO DataArray node
	    call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no, &
                           'RigidGridMotion_t', rmotion_no, &
                           'DataArray_t', 3, 'end')
	    if (ier .ne. ALL_OK) call cg_error_exit_f

            call cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), CGNS_ENUMV(Kelvin), &
                                  CGNS_ENUMV(Radian), ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f

	enddo

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
! *** Arbitrary Grid Motion

        do amotion=1, 2

! *** Create the ArbitraryGridMotion_t node
            write(amotionname,100)'ArbitraryGridMotion#',amotion
	    call cg_arbitrary_motion_write_f(cg, base_no, zone_no, &
                 amotionname, CGNS_ENUMV(DeformingGrid), amotion_no, ier)
	    if (ier .ne. ALL_OK) call cg_error_exit_f

! *** Goto the ArbitraryGridMotion_t node
            call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no, &
                          'ArbitraryGridMotion_t', amotion_no, 'end')
            if (ier .ne. ALL_OK) call cg_error_exit_f

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
! *** Add an attribute under ArbitraryGridMotion_t
            call cg_descriptor_write_f('DescriptorName', &
                                       'DescriptotText', ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f

! *** make up some dummy GridVelocityX values just for the test:
            DO k=1, SIZE(3)
              DO j=1, SIZE(2)
                 DO  i=1, SIZE(1)
                    pos = i + (j-1)*SIZE(1) + (k-1)*SIZE(1)*SIZE(2)
                    GridVelocity(pos) = pos
                 ENDDO
              ENDDO
           ENDDO

! *** Add a DataArray_t 'GridVelocityX' under ArbitraryGridMotion_t
            !call cg_array_write_f('GridVelocityX', CGNS_ENUMV(RealSingle),
            call cg_array_write_f('GridVelocityX', CGNS_ENUMV(RealDouble), &
      		                  index_dim, size, GridVelocity, ier)
	    if (ier .ne. ALL_OK) call cg_error_exit_f

! *** Add an attribute for this data array: GOTO DataArray node
            call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no, &
                          'ArbitraryGridMotion_t', amotion_no, &
                          'DataArray_t', 1, 'end')
            if (ier .ne. ALL_OK) call cg_error_exit_f

            call cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), CGNS_ENUMV(Kelvin), &
                                  CGNS_ENUMV(Radian), ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f
	enddo

! *** close CGNS file
	call cg_close_f(cg, ier)
	if (ier .ne. ALL_OK) call cg_error_exit_f

 100	format(a,i1)
        END PROGRAM write_cgns_motion

	program modify_bprop
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on August 2002

!       This example test modifying BCProperty_t data structure and its children

#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 3)
	integer index_dim, cell_dim, phys_dim
	character*100 linkpath

	integer cg, base, zone, boco, ier, size(Ndim*3), i, num
	integer WallFunctionType, AreaType, pnts(Ndim,2), nbases
	character*32 RegionName32, basename
	real *4 SurfaceArea, version
	integer dim_vals(2)
	

! *** initialize
	ier = 0
	index_dim=Ndim
	cell_dim=Ndim
	phys_dim=Ndim

! *** open CGNS file for writing
 	call cg_open_f('Test_V2', MODE_MODIFY, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,600)'MODIFYING FILE Test_V2'

! *** CGNS Library Version used for file creation:
        call cg_version_f(cg, version, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,102)
     &     'Library Version used for file creation:',version

! *** base
	call cg_nbases_f(cg, nbases, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,200)'nbases=',nbases

	base=1

        call cg_base_read_f(cg, base, basename, cell_dim, phys_dim, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,300)'BaseName = "',basename,'"',
     &                'cell_dimension=',cell_dim

	zone =1
	boco=2

! *** write BCProperty_t/WallFunction_t node under boco#2
	WallFunctionType = Generic
	call cg_bc_wallfunction_write_f(cg, base, zone,
     &        boco, WallFunctionType, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	write(6,*)'WallFunction_t written'

! *** write BCProperty_t/Area_t node under boco#2
	AreaType = BleedArea
	SurfaceArea = 123.456
 	RegionName32 = 'myRegion'
	call cg_bc_area_write_f(cg, base, zone, boco, AreaType,
     & 	     SurfaceArea, RegionName32, ier)

	write(6,*)'Area_t written'

! *** write Descriptor_t, UserDefinedData_t & Link under...
! ...   BCProperty_t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1,
     &	    'BC_t', boco, 'BCProperty_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

	write(6,*)'cg_goto BCProperty_t: ier=',ier

        call cg_descriptor_write_f('BCpropDescriptorName',
     &      'BCpropDescriptorText', ier)
	write(6,*)'cg_descriptor_write_f: ier=',ier
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_user_data_write_f('BCPropUserData', ier)
	write(6,*)'cg_user_data_write_f: ier=',ier
        if (ier .eq. ERROR) call cg_error_exit_f

! ...   WallFunction_t
	call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1,
     &      'BC_t', boco, 'BCProperty_t', 1, 'WallFunction_t', 1, 'end')

	call cg_descriptor_write_f('WFDescriptorName',
     &	    'WFDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_user_data_write_f('WFUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! ...   Area_t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1,
     &      'BC_t', boco, 'BCProperty_t', 1, 'Area_t', 1, 'end')
	call cg_descriptor_write_f('AreaDescriptorName',
     &	    'AreaDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_user_data_write_f('AreaUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

 	dim_vals(1)=3
 	dim_vals(2)=2
 	call cg_array_write_f('arraysize', Integer, 2, dim_vals,
     &        size, ier)
 	if (ier .ne. ERROR) write(6,'(a)') 'Error in API'

! * DataClass & DimensionalUnits under SurfaceArea
	call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1,
     &      'BC_t', boco, 'BCProperty_t', 1, 'Area_t', 1, 'DataArray_t',
     &	    1, 'end')

	call cg_dataclass_write_f(Dimensional, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	call cg_units_write_f(Kilogram, Meter, Second, Kelvin,
     &	    		      Radian, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

! *** close CGNS file
	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

 102    format(a,f8.3)
 200    format(a,i5)
 300    format(3a/a,i2)
 600    format(3a)
	end

        PROGRAM read_bprop
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on August 2002

!       This example test the BCProperty_t data structure and its children
!	It tests the functions:
!	- cg_bc_wallfunction_read_f(fn, B, Z, BC, WallFunctionType, ier)
!	- cg_bc_area_read_f(fn, B, Z, BC, AreaType, SurfaceArea, RegionName, ier)
!	And the following:
!	- return value when BCProperty_t doesn't exist, or when WallFunction/Area doesn't exist
!	- printing WallFunctionTypeName, & type<=>name association.
!	- cg_ndescriptors, cg_descriptor_read under BCProperty_t, WallFunction_t, Area_t
!	- cg_nuser_data, cg_user_data_read, under BCProperty_t, WallFunction_t, Area_t
!	- cg_narray, cg_array_read under Area_t
!	- links under BCProperty_t, WallFunction_t, Area_t
!	- cg_goto to BCProperty_t, WallFunction_t, Area_t
! 	- Memory check with Insure
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 3)
	integer ier, cg, nbases, base, nzones, zone, nbocos, boco
	integer CellDim, PhysDim, IndexDim, datatype
	integer(cgsize_t) NormalListFlag
	integer ndescriptors, idescr, zonetype, ndataset
	integer(cgsize_t) size(3*Ndim)
	integer bocotype, ptset_type, NormalIndex(3), AreaType
	integer(cgsize_t) npnts
	integer WallFunctionType, nuser_data, n
	integer(cgsize_t) pnts(100000)
	integer type, mass, length, time, temp, deg
	character*32 filename, basename, zonename, boconame, bpropname
	character*32 name, RegionName, user_data_name
	character*100 text
	real*4 version, data_single(100), SurfaceArea
        double precision data_double(100)

! *** open file
!	write(6,*) 'Input filename'
!	read(5,600) filename
 	write(filename,'(a)')'Test_V2'
	call cg_open_f(filename, MODE_READ, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,600)'READING FILE ',filename

! *** CGNS Library Version used for file creation:
	call cg_version_f(cg, version, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,102) &
           'Library Version used for file creation:',version

! *** base
	call cg_nbases_f(cg, nbases, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,200)'nbases=',nbases
	
	base=1

	call cg_base_read_f(cg, base, basename, CellDim, PhysDim, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,300)'BaseName = "',basename,'"', &
                      'cell_dimension=',CellDim

! *** base attribute:  GOTO base node
	call cg_goto_f(cg, base, ier, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

! ***   base attribute:  Descriptor
	call cg_ndescriptors_f(ndescriptors, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,400)'Base Descriptor_t Information:'
        write(6,105) 'No. of descriptors=',ndescriptors

	do idescr=1, ndescriptors
          call cg_descriptor_read_f(idescr, name, text, ier)
          if (ier .eq. ERROR) call cg_error_exit_f
          if (ier.eq.ALL_OK) then
            write(6,500)' DescriptorName="',name,'"', &
                        ' DescriptorText="',text,'"'
          endif
	enddo

! *** read Zone
        call cg_nzones_f(cg, base, nzones, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,200)'nzones=',nzones

	zone = 1

	call cg_zone_read_f(cg, base, zone, zonename, size, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,104)'Name of Zone',zone,' is "',zonename,'"'

        call cg_zone_type_f(cg, base, zone, zonetype, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,600)'  Zone type is ', ZoneTypeName(zonetype)

        if (zonetype.eq.CGNS_ENUMV(Structured)) then
            IndexDim=CellDim
        else
            IndexDim=1
        endif

	write(6,104)'  IndexDimension=',IndexDim

! *** read BC_t's
        call cg_nbocos_f(cg, base, zone, nbocos, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,113)nbocos,' bound. conditions found for ', &
                   zonename

        do boco=1, nbocos
            call cg_boco_info_f(cg, base, zone, boco, boconame, &
                   bocotype, ptset_type, npnts, NormalIndex, &
                   NormalListFlag, datatype, ndataset, ier)
            if (ier .eq. ERROR) call cg_error_exit_f
            write(6,105) ' boundary condition #',boco
            write(6,600) '  boconame=',boconame
            write(6,600) '  bocotype=',BCTypeName(bocotype)
            write(6,600) '  ptset_type=', PointSetTypeName(ptset_type)
	    if (NormalIndex(1).eq.0 .and. NormalIndex(2).eq.0 .and. &
                NormalIndex(3).eq.0) then
	        write(6,103) '  NormalIndex undefined'
	    else
                write(6,103) '  NormalIndex=', NormalIndex(1), &
                                NormalIndex(2), NormalIndex(3)
	    endif
            write(6,104) '  NormalListFlag=',NormalListFlag
	    if (NormalListFlag .eq. 1) then
                write(6,600) '  datatype for normals=', &
      		    	        DataTypeName(datatype)
	    endif

           ! read patch points and InwardNormalList
            if (datatype.eq.CGNS_ENUMV(RealSingle) .or. datatype.eq.CG_Null) then
               call cg_boco_read_f(cg, base, zone, boco, pnts, &
                data_single, ier)
               if (ier .eq. ERROR) call cg_error_exit_f
            elseif (datatype.eq.CGNS_ENUMV(RealDouble)) then
               call cg_boco_read_f(cg, base, zone, boco, pnts, &
                data_double, ier)
               if (ier .eq. ERROR) call cg_error_exit_f
            endif

            write(6,119) '   Bound. Condition Patch:', &
             '    first point:', pnts(1),pnts(2),pnts(3), &
             '    last point :', pnts(3*npnts-2), pnts(3*npnts-1), &
                                 pnts(3*npnts)

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
! *** read BCProperty_t node

	    call cg_bc_wallfunction_read_f(cg, base, zone, boco, &
      		WallFunctionType, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

	    if (ier .eq. ALL_OK) then
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	        write(6,600) '   WallFunctionTypeName= "', &
       		    WallFunctionTypeName(WallFunctionType),'"'
	    endif

	    call cg_bc_area_read_f(cg, base, zone, boco, AreaType, &
      		SurfaceArea, RegionName, ier)
            if (ier .eq. ERROR) call cg_error_exit_f

            if (ier .eq. ALL_OK) then
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
                write(6,600)'   AreaTypeName= "',AreaTypeName(AreaType), &
      			    '"'
                write(6,600)'   RegionName= "',RegionName,'"'
	 	write(6,102)'   SurfaceArea=',SurfaceArea
	    endif

! *** read Descriptor_t & UserDefinedData_t under...
! ...   BCProperty_t
            call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1, &
            		   'BC_t', boco, 'BCProperty_t', 1, 'end')
	    if (ier .eq. ERROR) call cg_error_exit_f
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

            if (ier .eq. ALL_OK) then

                call cg_ndescriptors_f(ndescriptors, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'BCProperty Descriptor_t Information:'
                write(6,105) 'No. of descriptors=',ndescriptors
                do idescr=1, ndescriptors
                    call cg_descriptor_read_f(idescr, name, text, ier)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' DescriptorName="',name,'"', &
                                 ' DescriptorText="',text,'"'
                enddo

                call cg_nuser_data_f(nuser_data, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'BCProperty User Data Information:'
                write(6,105) 'No. of UserData=',nuser_data
                do n=1, nuser_data
                    call cg_user_data_read_f(n, user_data_name, ier)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' user_data_name="',user_data_name,'"'
                enddo

	    endif

! ...   WallFunction_t
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
            call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1, &
            'BC_t', boco, 'BCProperty_t', 1, 'WallFunction_t', 1, 'end')
	    if (ier .eq. ERROR) call cg_error_exit_f

            if (ier .eq. ALL_OK) then

                call cg_ndescriptors_f(ndescriptors, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'WallFunction Descriptor_t Information:'
                write(6,105) 'No. of descriptors=',ndescriptors
                do idescr=1, ndescriptors
                    call cg_descriptor_read_f(idescr, name, text, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' DescriptorName="',name,'"', &
                                 ' DescriptorText="',text,'"'
                enddo

                call cg_nuser_data_f(nuser_data, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'WallFunction User Data Information:'
                write(6,105) 'No. of UserData=',nuser_data
                do n=1, nuser_data
                    call cg_user_data_read_f(n, user_data_name, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' user_data_name="',user_data_name,'"'
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
                enddo

            endif

! ...   Area_t
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
            call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1, &
                'BC_t', boco, 'BCProperty_t', 1, 'Area_t', 1, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f

            if (ier .eq. ALL_OK) then

                call cg_ndescriptors_f(ndescriptors, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'Area Descriptor_t Information:'
                write(6,105) 'No. of descriptors=',ndescriptors
                do idescr=1, ndescriptors
                    call cg_descriptor_read_f(idescr, name, text, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' DescriptorName="',name,'"', &
                                 ' DescriptorText="',text,'"'
                enddo

                call cg_nuser_data_f(nuser_data, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'Area User Data Information:'
                write(6,105) 'No. of UserData=',nuser_data
                do n=1, nuser_data
                    call cg_user_data_read_f(n, user_data_name, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' user_data_name="',user_data_name,'"'
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
                enddo

! * Read DataClass & DimensionalUnits under SurfaceArea
		call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
      		    'ZoneBC_t', 1, 'BC_t', boco, 'BCProperty_t', 1, &
      		    'Area_t', 1, 'DataArray_t', 1, 'end')

		call cg_dataclass_read_f(type,ier)
		if (ier .eq. ERROR) call cg_error_exit_f
		write(6,600)'DataClassName=',DataClassName(type)

        	call cg_units_read_f(mass, length, time, temp, deg, ier)
        	if (ier .eq. ERROR) call cg_error_exit_f
        	if (ier .eq. ALL_OK) then
          	    write(6,100) &
            	    'SurfaceArea Dimensional Units:', &
            	    MassUnitsName(mass), LengthUnitsName(length), &
            	    TemperatureUnitsName(temp), TimeUnitsName(time), &
            	    AngleUnitsName(deg)
        	endif

            endif

	enddo ! boco loop

! Close file
        call cg_close_f(cg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

 100 	format(a/,'    Mass units: ',a/,'    Length units: ',a/, &
          '    Temperature units: ',a/,'    Time units: ',a/, &
          '    Angle units:',a)
 102 	format(a,f8.3)
 103    format(a,6i2)
 104    format(a,i5,3a)
 105	format(a,i2,a)
 113    format(i1,3a)
 119    format(a/a,3i2/a,3i2)
 200    format(a,i5)
 300	format(3a/a,i2)
 400	format(/a/)
 500	format(3a/3a)
 600	format(3a)

        END PROGRAM read_bprop

      program testgeneralrindf

#include "cgnstypes_f03.h"
#ifdef WINNT
      include 'cgnswin_f.h'
#endif
      USE CGNS
      implicit none
      
      INTEGER, PARAMETER :: sp = KIND(1.0)

      integer, parameter :: celldim = 3, physdim = 3
      integer(cgsize_t), parameter :: size(3,3) = &
     &  reshape((/5,5,5, 4,4,4, 0,0,0 /), (/3, 3/))
      integer, parameter :: rind(2,3) = &
     &  reshape((/2,2, 2,2, 1,1/), (/2, 3/))
      integer(cgsize_t), parameter :: NUM_I = &
     &  size(1,1) + rind(1,1) + rind(2,1)
      integer(cgsize_t), parameter :: NUM_J = &
     &  size(2,1) + rind(1,2) + rind(2,2)
      integer(cgsize_t), parameter :: NUM_K = &
     &  size(3,1) + rind(1,3) + rind(2,3)
      integer(cgsize_t), parameter :: num_coord = NUM_I * NUM_J * NUM_K

      integer :: ierr
      integer :: cgfile, cgbase, cgzone, cggrid, cgcoord, cgsol, cgfld
      integer :: n, nn, np

      integer(cgsize_t) :: i, j, k
      integer(cgsize_t) :: dims(3)
      integer(cgsize_t) :: rmin(3), rmax(3)
      integer(cgsize_t) :: m_rmin(3), m_rmax(3)

      real(kind=sp), dimension(NUM_I, NUM_J, NUM_K) :: xcoord, ycoord, zcoord
      real(kind=sp), dimension(NUM_I, NUM_J, NUM_K) :: solution, fbuf

      character(len=32) coordname(3)
      character(len=32) fieldname

      coordname(1) = 'CoordinateX'
      coordname(2) = 'CoordinateY'
      coordname(3) = 'CoordinateZ'

      fieldname = 'Density'

      do k = 1, NUM_K
        do j = 1, NUM_J
           do i = 1, NUM_I
              call compute_coord()
              call compute_sol()
          enddo
        enddo
      enddo

!     open

      call cg_open_f('rindf.cgns', CG_MODE_WRITE, cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

!---- structured grid with rind ----

      print *,'writing structured base with rind'

!     write base and zone

      call cg_base_write_f(cgfile, 'Structured', celldim, physdim, &
     &                     cgbase, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_zone_write_f(cgfile, cgbase, 'Zone', size,              &
     &                     CGNS_ENUMV(Structured), cgzone, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

!     use cg_coord_general_write to write coordinates with all rinds
!     need to use cg_grid_write to create the node, cg_goto to set
!     position at the node, then write rind */

      dims(1) = NUM_I
      dims(2) = NUM_J
      dims(3) = NUM_K

      do n=1,3
        rmin(n)   = get_s_rmin(n, rind(1,n))
        rmax(n)   = get_s_rmax(n, rind(2,n))
        m_rmin(n) = get_m_rmin(n, rind(1,n))
        m_rmax(n) = get_m_rmax(n, rind(2,n))
      enddo

!     write coordinates with rind

      call cg_grid_write_f(cgfile, cgbase, cgzone, 'GridCoordinates', &
     &                     cggrid, ierr)
      call cg_goto_f(cgfile, cgbase, ierr, 'Zone_t', cgzone, &
     &               'GridCoordinates_t', cggrid, 'end')
      call cg_rind_write_f(rind, ierr)

      call cg_coord_general_write_f(cgfile, cgbase, cgzone, &
     &                              coordname(1), CGNS_ENUMV(RealSingle), &
     &                              rmin, rmax, CGNS_ENUMV(RealSingle), &
     &                              3, dims, m_rmin, m_rmax, &
     &                              xcoord, cgcoord, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_coord_general_write_f(cgfile, cgbase, cgzone, &
     &                              coordname(2), CGNS_ENUMV(RealSingle), &
     &                              rmin, rmax, CGNS_ENUMV(RealSingle), &
     &                              3, dims, m_rmin, m_rmax, &
     &                              ycoord, cgcoord, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_coord_general_write_f(cgfile, cgbase, cgzone, &
     &                              coordname(3), CGNS_ENUMV(RealSingle), &
     &                              rmin, rmax, CGNS_ENUMV(RealSingle), &
     &                              3, dims, m_rmin, m_rmax, &
     &                              zcoord, cgcoord, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

!     write solution with rind, and the solution dimensions come from the zone
!     sizes

      call cg_sol_write_f(cgfile, cgbase, cgzone, 'VertexSolution', &
     &                    CGNS_ENUMV(Vertex), cgsol, ierr)
      call cg_goto_f(cgfile, cgbase, ierr, 'Zone_t', cgzone, &
     &               'FlowSolution_t', cgsol, 'end')
      call cg_rind_write_f(rind, ierr)
      call cg_field_general_write_f(cgfile, cgbase, cgzone, cgsol, &
     &                              fieldname, CGNS_ENUMV(RealSingle), &
     &                              rmin, rmax, CGNS_ENUMV(RealSingle), &
     &                              3, dims, m_rmin, m_rmax, &
     &                              solution, cgfld, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

!     close the file and reopen in read mode

      call cg_close_f(cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      print *,'closing and reopening in read mode '     

!     read file and check the data

      call cg_open_f('rindf.cgns', CG_MODE_READ, cgfile, ierr)
      if (ierr .eq. ERROR) call cg_error_exit_f

      write(6,*)'checking the data '
      cgbase = 1
      cgzone = 1
      cggrid = 1
      cgsol  = 1

      nn = 0

!     check coordinates
!     Only load core coordinates without rind but inside memory with rind

      do n=1,3
        rmin(n)   = get_s_rmin(n, 0)
        rmax(n)   = get_s_rmax(n, 0)
        m_rmin(n) = get_m_rmin(n, 0)
        m_rmax(n) = get_m_rmax(n, 0)
      enddo

!     X
      call cg_coord_general_read_f(cgfile, cgbase, cgzone, &
     &                             'CoordinateX', &
     &                             rmin, rmax, CGNS_ENUMV(RealSingle), &
     &                             3, dims, m_rmin, m_rmax, fbuf, ierr)
      if (ierr .eq. ERROR) call cg_error_exit_f
      np = 0
      do k = idxmin(3,0), idxmax(3,0)
         do j = idxmin(2,0), idxmax(2,0)
            do i = idxmin(1,0), idxmax(1,0)
              if (fbuf(i,j,k) .ne. xcoord(i,j,k)) then
                np = np + 1
              endif
          enddo
        enddo
      enddo
      nn = nn + np
      if (np .ne. 0) then
        print *,'differences in CoordinateX'
      endif

!     Y
      call cg_coord_general_read_f(cgfile, cgbase, cgzone, &
     &                             'CoordinateY', &
     &                             rmin, rmax, CGNS_ENUMV(RealSingle), &
     &                             3, dims, m_rmin, m_rmax, fbuf, ierr)
      if (ierr .eq. ERROR) call cg_error_exit_f
      np = 0
      do k = idxmin(3,0), idxmax(3,0)
         do j = idxmin(2,0), idxmax(2,0)
            do i = idxmin(1,0), idxmax(1,0)
              if (fbuf(i,j,k) .ne. ycoord(i,j,k)) then
                np = np + 1
              endif
          enddo
        enddo
      enddo
      nn = nn + np
      if (np .ne. 0) then
        print *,'differences in CoordinateY'
      endif

!     Z
      call cg_coord_general_read_f(cgfile, cgbase, cgzone, &
     &                             'CoordinateZ', &
     &                             rmin, rmax, CGNS_ENUMV(RealSingle), &
     &                             3, dims, m_rmin, m_rmax, fbuf, ierr)
      if (ierr .eq. ERROR) call cg_error_exit_f
      np = 0
      do k = idxmin(3,0), idxmax(3,0)
         do j = idxmin(2,0), idxmax(2,0)
            do i = idxmin(1,0), idxmax(1,0)
              if (fbuf(i,j,k) .ne. zcoord(i,j,k)) then
                np = np + 1
              endif
          enddo
        enddo
      enddo
      nn = nn + np
      if (np .ne. 0) then
        print *,'differences in CoordinateZ'
      endif

!     check field with only one rind layer

      do n=1,3
        rmin(n)   = get_s_rmin(n, 1)
        rmax(n)   = get_s_rmax(n, 1)
        m_rmin(n) = get_m_rmin(n, 1)
        m_rmax(n) = get_m_rmax(n, 1)
      enddo

      call cg_field_general_read_f(cgfile, cgbase, cgzone, cgsol, &
     &                             'Density', &
     &                             rmin, rmax, CGNS_ENUMV(RealSingle), &
     &                             3, dims, m_rmin, m_rmax, fbuf, ierr)
      if (ierr .eq. ERROR) call cg_error_exit_f
      np = 0
      do k = idxmin(3,1), idxmax(3,1)
         do j = idxmin(2,1), idxmax(2,1)
            do i = idxmin(1,1), idxmax(1,1)
              if (fbuf(i,j,k) .ne. solution(i,j,k)) then
                np = np + 1
              endif
          enddo
        enddo
      enddo
      nn = nn + np
      if (np .ne. 0) then
        print *, np, ' differences in Field'
      endif

      if (nn .eq. 0) then
        print *,'no differences (part 1)'
      endif

!===============================================================================

!-----We now go to modify mode and repeadtely test writing and reading of the
!-----field

!     close the file and reopen in modify mode
      print *, 'closing and reopening in modify mode'
      call cg_close_f(cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_open_f('rindf.cgns', CG_MODE_MODIFY, cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

!     delete the node
      call cg_goto_f(cgfile, cgbase, ierr, 'Zone_t', cgzone, &
     &     'FlowSolution_t', cgsol, 'end')
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_delete_node_f('Density', ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

!     write the field using high-level routine
      call cg_field_write_f(cgfile, cgbase, cgzone, cgsol, CGNS_ENUMV(RealSingle), &
     &                      fieldname, solution, cgfld, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

!     verify the written data
      do n=1,3
        rmin(n) = get_s_rmin(n, -1)
        rmax(n) = get_s_rmax(n, -1)
      enddo
      call cg_field_read_f(cgfile, cgbase, cgzone, cgsol, fieldname, &
     &                     CGNS_ENUMV(RealSingle), rmin, rmax, fbuf, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      np = 0
      do k = idxmin(3,-1), idxmax(3,-1)
         do j = idxmin(2,-1), idxmax(2,-1)
            do i = idxmin(1,-1), idxmax(1,-1)
              if (fbuf(i,j,k) .ne. solution(i,j,k)) then
                np = np + 1
              endif
          enddo
        enddo
      enddo
      nn = nn + np
      if (np .ne. 0) then
        print *, np, ' differences in Field (T1)'
      endif

!     if given ranges span the full dimensions, the read should succeed no
!     matter what the range is (this behavior is for backwards compatibility and
!     is not documented)
      do n=1,3
        rmin(n) = 1
        rmax(n) = dims(n)
      enddo
      call cg_field_read_f(cgfile, cgbase, cgzone, cgsol, fieldname, &
     &                     CGNS_ENUMV(RealSingle), rmin, rmax, fbuf, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      np = 0
      do k = idxmin(3,-1), idxmax(3,-1)
         do j = idxmin(2,-1), idxmax(2,-1)
            do i = idxmin(1,-1), idxmax(1,-1)
              if (fbuf(i,j,k) .ne. solution(i,j,k)) then
                np = np + 1
              endif
          enddo
        enddo
      enddo
      nn = nn + np
      if (np .ne. 0) then
        print *, np, ' differences in Field (T2)'
      endif

!     try again with really weird dimensions
      do n=1,3
        rmin(n) = -100*n
        rmax(n) = rmin(n) + dims(n) - 1
      enddo
      call cg_field_read_f(cgfile, cgbase, cgzone, cgsol, fieldname, &
     &                     CGNS_ENUMV(RealSingle), rmin, rmax, fbuf, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      np = 0
      do k = idxmin(3,-1), idxmax(3,-1)
         do j = idxmin(2,-1), idxmax(2,-1)
            do i = idxmin(1,-1), idxmax(1,-1)
              if (fbuf(i,j,k) .ne. solution(i,j,k)) then
                np = np + 1
              endif
          enddo
        enddo
      enddo
      nn = nn + np
      if (np .ne. 0) then
        print *, np, ' differences in Field (T3)'
      endif

!     however, if given ranges do not span the full dimensions, ranges are
!     checked
      do n=1,3
        rmin(n) = 1
        rmax(n) = dims(n) - 1
      enddo
      write (*, '(" Next error is required: ")', advance='no')
      call cg_field_read_f(cgfile, cgbase, cgzone, cgsol, fieldname, &
     &                     CGNS_ENUMV(RealSingle), rmin, rmax, fbuf, ierr)
      if (ierr == CG_OK) then
         print *, 'read failed to produce error (T4)'
         nn = nn + 1
      endif
      call cg_error_print_f

!     test old behavior where first rind plane is index 1 */
      call cg_set_rind_zero_f(ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

!     this is the proper range for old behavior
      do n=1,3
        rmin(n) = 1
        rmax(n) = dims(n)
      enddo
      call cg_field_read_f(cgfile, cgbase, cgzone, cgsol, fieldname, &
     &                     CGNS_ENUMV(RealSingle), rmin, rmax, fbuf, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      np = 0
      do k = idxmin(3,-1), idxmax(3,-1)
         do j = idxmin(2,-1), idxmax(2,-1)
            do i = idxmin(1,-1), idxmax(1,-1)
              if (fbuf(i,j,k) .ne. solution(i,j,k)) then
                np = np + 1
              endif
          enddo
        enddo
      enddo
      nn = nn + np
      if (np .ne. 0) then
        print *, np, ' differences in Field (T5)'
      endif

!     reading full range should still work for any dimension
      do n=1,3
        rmin(n) = -200*n
        rmax(n) = rmin(n) + dims(n) - 1
      enddo
      call cg_field_read_f(cgfile, cgbase, cgzone, cgsol, fieldname, &
     &                     CGNS_ENUMV(RealSingle), rmin, rmax, fbuf, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      np = 0
      do k = idxmin(3,-1), idxmax(3,-1)
         do j = idxmin(2,-1), idxmax(2,-1)
            do i = idxmin(1,-1), idxmax(1,-1)
              if (fbuf(i,j,k) .ne. solution(i,j,k)) then
                np = np + 1
              endif
          enddo
        enddo
      enddo
      nn = nn + np
      if (np .ne. 0) then
        print *, np, ' differences in Field (T6)'
      endif

!     ranges are checked if they do not span the full dimensions.  Now,
!     rmin < 1 is a failure
      do n=1,3
        rmin(n) = get_s_rmin(n, 1)
        rmax(n) = get_s_rmax(n, 1)
      enddo
      write (*, '(" Next error is required: ")', advance='no')
      call cg_field_read_f(cgfile, cgbase, cgzone, cgsol, fieldname, &
     &                     CGNS_ENUMV(RealSingle), rmin, rmax, fbuf, ierr)
      if (ierr == CG_OK) then
         print *, 'read failed to produce error (T7)'
         nn = nn + 1
      endif
      call cg_error_print_f

      nn = nn + np
      if (nn .eq. 0) then
        print *,'no differences (part 2)'
      endif

!===============================================================================

!     back to testing new behavior
      call cg_set_rind_core_f(ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

!     Tests in part 3 should not encounter anything different than C and are not
!     repeated.  But put the file in the same state by doing tests T13 and T14.
      solution(idxmin(1, 1)  , idxmin(2, 0)  , idxmin(3, 0)) = 8888.5
      solution(idxmin(1, 1)+1, idxmin(2, 0)  , idxmin(3, 0)) = 8888.6
      solution(idxmin(1, 1)  , idxmin(2, 0)+1, idxmin(3, 0)) = 8888.7
      solution(idxmin(1, 1)+1, idxmin(2, 0)+1, idxmin(3, 0)) = 8888.8
      rmin(1)   = get_s_rmin(1, 1)
      rmax(1)   = get_s_rmin(1, 1) + 1
      rmin(2)   = get_s_rmin(2, 0)
      rmax(2)   = get_s_rmin(2, 0) + 1
      rmin(3)   = get_s_rmin(3, 0)
      rmax(3)   = get_s_rmax(3, 0)
      m_rmin(1) = get_m_rmin(1, 1)
      m_rmax(1) = get_m_rmin(1, 1) + 1
      m_rmin(2) = get_m_rmin(2, 0)
      m_rmax(2) = get_m_rmin(2, 0) + 1
      m_rmin(3) = get_m_rmin(3, 0)
      m_rmax(3) = get_m_rmax(3, 0)
      call cg_field_general_write_f(cgfile, cgbase, cgzone, cgsol, &
     &                              fieldname, CGNS_ENUMV(RealSingle), &
     &                              rmin, rmax, CGNS_ENUMV(RealSingle), &
     &                              3, dims, m_rmin, m_rmax, &
     &                              solution, cgfld, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
!     verify the written data
      do n=1,3
        rmin(n) = get_s_rmin(n, -1)
        rmax(n) = get_s_rmax(n, -1)
      enddo
      call cg_field_read_f(cgfile, cgbase, cgzone, cgsol, fieldname, &
     &                     CGNS_ENUMV(RealSingle), rmin, rmax, fbuf, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      np = 0
      do k = idxmin(3,-1), idxmax(3,-1)
         do j = idxmin(2,-1), idxmax(2,-1)
            do i = idxmin(1,-1), idxmax(1,-1)
              if (fbuf(i,j,k) .ne. solution(i,j,k)) then
                np = np + 1
              endif
          enddo
        enddo
      enddo
      nn = nn + np
      if (np .ne. 0) then
        print *, np, ' differences in Field (T13)'
      endif

!     verify again by only reading the 4 locations
      fbuf(idxmin(1, 1)  , idxmin(2, 0)  , idxmin(3, 0)) = 0.
      fbuf(idxmin(1, 1)+1, idxmin(2, 0)  , idxmin(3, 0)) = 0.
      fbuf(idxmin(1, 1)  , idxmin(2, 0)+1, idxmin(3, 0)) = 0.
      fbuf(idxmin(1, 1)+1, idxmin(2, 0)+1, idxmin(3, 0)) = 0.
      rmin(1) = get_s_rmin(1, 1)
      rmax(1) = get_s_rmin(1, 1) + 1
      rmin(2) = get_s_rmin(2, 0)
      rmax(2) = get_s_rmin(2, 0) + 1
      rmin(3) = get_s_rmin(3, 0)
      rmax(3) = get_s_rmax(3, 0)
      call cg_field_general_read_f(cgfile, cgbase, cgzone, cgsol, &
     &                             'Density', &
     &                             rmin, rmax, CGNS_ENUMV(RealSingle), &
     &                             3, dims, m_rmin, m_rmax, fbuf, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      np = 0
      do k = idxmin(3,-1), idxmax(3,-1)
         do j = idxmin(2,-1), idxmax(2,-1)
            do i = idxmin(1,-1), idxmax(1,-1)
              if (fbuf(i,j,k) .ne. solution(i,j,k)) then
                np = np + 1
              endif
          enddo
        enddo
      enddo
      nn = nn + np
      if (np .ne. 0) then
        print *, np, ' differences in Field (T14)'
      endif

      if (nn .eq. 0) then
        print *,'no differences (part 3)'
      endif

      print *, 'closing file'
      call cg_close_f(cgfile, ierr)
      if (ierr .eq. ERROR) call cg_error_exit_f

      if (nn .ne. 0) then
        stop
      endif

!- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

      contains

      function INDEX(ii, jj, kk)
      integer(cgsize_t) :: INDEX, ii, jj, kk
      INDEX = ii + NUM_I*(jj + NUM_J*(kk))
      end function

!     ranges for arrays sent to CGNS
!     s_ is the range in file space.  Core cells start at 1 so rind planes are
!     <= 0.
      function get_s_rmin(n, nr)
      integer(cgsize_t) :: get_s_rmin
      integer :: n, nr
      integer :: nrl
      if (nr < 0) then
         nrl = rind(1,n)
      else
         nrl = nr
      endif
      get_s_rmin = int(1 - nrl, kind=cgsize_t)
      end function

      function get_s_rmax(n, nr)
      integer(cgsize_t) :: get_s_rmax
      integer :: n, nr
      integer :: nrl
      if (nr < 0) then
         nrl = rind(2,n)
      else
         nrl = nr
      endif
      get_s_rmax = int(size(n,1) + nrl, kind=cgsize_t)
      end function

!     m_ is the range in memory.  The lowest index in each dimension is 1.  If
!     there are rind planes, then he core cells start at a value > 1.
      function get_m_rmin(n, nr)
      integer(cgsize_t) :: get_m_rmin
      integer :: n, nr
      integer :: nrl
      if (nr < 0) then
         nrl = rind(1,n)
      else
         nrl = nr
      endif
      get_m_rmin =  int(1 + rind(1,n) - nrl, kind=cgsize_t)
      end function

      function get_m_rmax(n, nr)
      integer(cgsize_t) :: get_m_rmax
      integer :: n, nr
      integer :: nrl
      if (nr < 0) then
         nrl = rind(2,n)
      else
         nrl = nr
      endif
      get_m_rmax = int(rind(1,n) + size(n,1) + nrl, kind=cgsize_t)
      end function

!     ranges for accessing arrays
      function idxmin(n, nr)
      integer(cgsize_t) :: idxmin
      integer :: n, nr
      idxmin = get_m_rmin(n, nr);
      end function

      function idxmax(n, nr)
      integer(cgsize_t) :: idxmax
      integer :: n, nr
      idxmax = get_m_rmax(n, nr);
      end function

!     initial data
      subroutine compute_coord()
      xcoord(i, j, k) = i - 1 - rind(1,1)
      ycoord(i, j, k) = j - 1 - rind(1,2)
      zcoord(i, j, k) = k - 1 - rind(1,3)
      end subroutine

      subroutine compute_sol()
      integer :: sign
      if ((i - 1 < rind(1,1)) .or. (i - 1 >= size(1,1) + rind(1,1)) .or. &
     &    (j - 1 < rind(1,2)) .or. (j - 1 >= size(2,1) + rind(1,2)) .or. &
     &    (k - 1 < rind(1,3)) .or. (k - 1 >= size(3,1) + rind(1,3))) &
     &  then
        sign = -1
      else
        sign = 1
      endif
      solution(i, j, k) = sign*(1 + (k)*1100 + &
     &  INDEX(i - 1, j - 1, 0_cgsize_t))
      end subroutine

      end program

      program write_descriptor
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Adds descriptor node to an existing CGNS file (under the
!   CGNSBase_t node).
!
!   The CGNS grid file 'grid.cgns' must already exist.
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c write_descriptor.F90
!   ifort -o write_descriptor write_descriptor.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
      integer index_base,index_file,ier
      character text1*36,text2*36,textstring*73
!
      write(6,'('' Program write_descriptor'')')
      if (CG_BUILD_64BIT) then
        write(6,'('' ...compiled in 64-bit mode, but not needed'')')
      end if
!
!  WRITE DESCRIPTOR NODE AT BASE LEVEL
!  open CGNS file for modify
      call cg_open_f('grid.cgns',CG_MODE_MODIFY,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!  we know there is only one base (real working code would check!)
      index_base=1
!   go to base node
      call cg_goto_f(index_file,index_base,ier,'end')
!   write descriptor node (user can give any name)
      text1='Supersonic vehicle with landing gear'
      text2='M=4.6, Re=6 million'
      textstring=text1//char(10)//text2
      call cg_descriptor_write_f('Information',textstring,ier)
!  close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully wrote descriptor node to file'',               &
        '' grid.cgns'')')
      stop
      end

c
c***********************************************************************
c   R1: Get Children names of a Node.  Return the name of children nodes
c   directly associated with a parent node.  The names of the children
c   are NOT guaranteed to be returned in any particular order.  If a
c   new child is added, it is NOT guaranteed to be returned as the last
c   child.  Note:  To start with the first child, use an istart value of 1.
c
c   f77: ADFCNAM( ID, istart, inum, inamlen, inumret, names, ierr )
c   input:  real*8 ID.         The ID of the Node to use.
c   input:  integer istart.    The Nth child's name to start with (first=1).
c   input:  integer inum.      Maximum number of names to return.
c   input:  integer inamlen.   Length of names.
c   output:  integer inumret.  The number of names returned.
c   output:  character*(*) names   Array of names.
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFCNAM( ID, istart, inum, inamlen, inumret, names,
     1                    ierr )
      IMPLICIT NONE
      real*8 ID
      integer istart
      integer inum
      integer inamlen
      integer inumret
      character*(*) names
      integer ierr

      call ADFCNA2( ID, istart, inum, inamlen, len(names), inumret,
     1              names, ierr )
      return
      end

c***********************************************************************
c   R1: Create a Node.  Create a new node (not a link-node) as a child
c   of a given parent.  Default values in this new node are: label=blank,
c   number of sub-nodes = 0, data-type = "MT", number of dimensions
c   = 0, data = NULL.
c
c   f77: ADFCRE( PID, name, ID, ierr )
c   input:  real*8 PID.  The ID of the parent node, to whom we are
c                        creating a new child node.
c   input:  character*(*) name.
c   output:  real*8 ID.  The ID of the newly created node.
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFCRE( PID, name, ID, ierr )
      IMPLICIT NONE
      real*8 PID
      character*(*) name
      real*8 ID
      integer ierr

      call ADFCRE2( PID, name, LEN( name ), ID, ierr )
      return
      end

c***********************************************************************
c   R1: Close an opened database.  If the ADF database spans multiple
c   files then all files used will also be closed.  If an ADF file which
c   is linked to by this database is also opened through another
c   database, only the opened file stream associated with this database
c   will be closed.
c
c   f77: ADFDCLO( RootID, ierr )
c   input:  real*8 RootID  Root ID of the database.
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFDCLO( RootID, ierr )
      IMPLICIT NONE
      real*8 RootID
      integer ierr

      call ADFDCL2( RootID, ierr )
      return
      end

c***********************************************************************
c   Rn: Delete an existing database.  This will delete one or more ADF
c   files which are linked together under file top ADF file named
c   "filename".
c
c   f77: ADFDDEL( filename, ierr )
c   input:  character*(*) filename
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFDDEL( filename, ierr )
      IMPLICIT NONE
      character*(*) filename
      integer ierr

      call ADFDDE2( filename, LEN( filename ), ierr )
      return
      end

c***********************************************************************
c   R2: Delete a Node.   If the node is NOT a link, then the specified
c   node and all
c   sub-nodes anywhere under it are also deleted.  For a link, and also
c   for links farther down in the tree, the link-node will be deleted,
c   but the node which the link is linked to is not affected.  When a
c   node is deleted, other link-nodes which point to it are left
c   dangling.  For example, if N13 is deleted, then L1 and L2 point to a
c   non-existing node.  This is OK until L1 and L2 are used.
c
c   f77: ADFDEL( PID, ID, ierr )
c   input:  real*8 PID.  The ID of the node's parent.
c   input:  real*8 ID.  The ID of the node to use.
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFDEL( PID, ID, ierr )
      IMPLICIT NONE
      real*8 PID
      real*8 ID
      integer ierr

      call ADFDEL2( PID, ID, ierr )
      return
      end

c***********************************************************************
c   Rn: Garbage Collection.  Redistribute data in the file to  use free-
c   space which is not located at the end of the file.  Neighboring free
c   spaces will be merged.  Note:  For better file compaction a utility
c   could be written to copy an ADF file, creating a new ADF file
c   without any wasted space.
c
c   f77: ADFDGC( ID, ierr )
c   input:  real*8 ID.  The ID of a node in the ADF file in which to do
c                       garbage collection.
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFDGC( ID, ierr )
      IMPLICIT NONE
      real*8 ID
      integer ierr

      call ADFDGC2( ID, ierr )
      return
      end

c***********************************************************************
c   R1: Get the data format used in an existing database.
c
c   f77: ADFDGF( RootID, format, ierr )
c   input:  real*8 RootID The rootID of the ADF file.
c   output:  character*20 format.  See format for ADFDOPN.
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFDGF( RootID, format, ierr )
      IMPLICIT NONE
      real*8 RootID
      character*(*) format
      integer ierr

      call ADFDGF2( RootID, format, LEN( format ), ierr )
      return
      end

c***********************************************************************
c   R1: Open a database.  Open either a new or an existing ADF file.
c   If links to other ADF files are used, these additional files will be
c   opened automatically as required.
c
c   f77: ADFDOPN( filename, status, format, rootID, ierr)
c   input:  character*(*) filename.  Not used if status SCRATCH is
c               used.  Filename must be a legal name and may
c               include a relative or absolute path.  It must be
c               directly usable by the C fopen() system
c               routine (no environment expansion is done).
c   input:  character*(*) status.  Like FORTRAN OPEN() status.
c                This field is required.  Allowable values are:
c           READ_ONLY - File must exist.  Writing NOT allowed.
c           OLD - File must exist.  Reading and writing allowed.
c           NEW - File must not exist.
c           SCRATCH - New file.  Filename is ignored.
c           UNKNOWN - OLD if file exists, else NEW is used.
c   input:  character*(*) format.  Specifies the numeric format for
c               the file.  If blank, the machine's native
c               format is used.  This field is only used when a
c               file is created.
c           NATIVE - Determine the format on the machine.  If the
c               native format is not one of the formats
c               supported, the created file cannot be used on
c               other machines.
c           IEEE_BIG - Use the IEEE big ENDIAN format.
c           IEEE_LITTLE - Use the IEEE little ENDIAN format.
c           CRAY - Use the native Cray format.
c   output:  real*8 rootID
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFDOPN( filename, status, format, rootID, ierr)
      IMPLICIT NONE
      character*(*) filename
      character*(*) status
      character*(*) format
      real*8 rootID
      integer ierr

      call ADFDOP2( filename, len( filename ), status, len( status ),
     1      format, len( format ), rootID, ierr )
      return
      end

c***********************************************************************
c   R1: Set the data format used in an existing database.
c    Note:  Use with extreme caution.  Needed only
c   for data conversion utilities and NOT intended
c   for the general user!!!
c
c   f77: ADFDSF( RootID, format, ierr )
c   input:  real*8 RootID The rootID if the ADF file.
c   input:  character*(*) format.  See format for ADFDOPN.
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFDSF( RootID, format, ierr )
      IMPLICIT NONE
      real*8 RootID
      character*(*) format
      integer ierr

      call ADFDSF2( RootID, format, len( format ), ierr )
      return
      end

c***********************************************************************
c   R1: Get ADF File Version ID.  This is the version number of the ADF
c   library routines which created an ADF database.  Modified ADF databases
c   will take on the version ID of the current ADF library version if
c   it is higher than the version indicated in the file.
c    The format of the version ID is:  "ADF Database Version 000.01"
c
c   f77: ADFDVER( RootID, version, cdate, mdate, ierr )
c   input:  real*8 RootID.  The ID of the root node in the ADF file.
c   output:  character(32) version.  A 32-byte character string
c               containing the version ID.
c   output:  character(32) cdate.  A 32-byte character string
c               containing the creation date of the file.
c   output:  character(32) mdate.  A 32-byte character
c               string containing the last modification date of the file.
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFDVER( RootID, version, cdate, mdate, ierr )
      IMPLICIT NONE
      real*8 RootID
      character*(*) version
      character*(*) cdate
      character*(*) mdate
      integer ierr

      call ADFDVE2( RootID, version, cdate, mdate,
     1  len( version ), len( cdate ), len( mdate ), ierr )
      return
      end

c***********************************************************************
c   R1: Return Error Message.  Given an ierr from an ADF routine,
c   get a textual description of the error.
c
c   f77: ADFERR( ierr, errstr )
c   input:  integer ierr.
c   output:  character(80) errstr.  An 80-byte description of
c             the specified error.  If the number is bad, the
c             string "Unknown error #nnn" is returned.
c***********************************************************************
      subroutine ADFERR( ierr, errstr )
      IMPLICIT NONE
      integer ierr
      character*(*) errstr

      call ADFERR2( ierr, errstr, len( errstr ) )
      return
      end

c***********************************************************************
c   R1: Flush data to disk.  This routine is used to force any modified
c   information to be flushed to the physical disk.  This ensures that
c   data will not be lost if a program aborts.  This control of when to
c   flush all data to disk is provided to the user rather than to flush
c   the data every time it is modified, which would result in reduced
c   performance.
c
c   f77: ADFFTD( ID, ierr )
c   input:  real*8 ID.  The ID of a node in the ADF file in which to flush.
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFFTD( ID, ierr )
      IMPLICIT NONE
      real*8 ID
      integer ierr

      call ADFFTD2( ID, ierr )
      return
      end

c***********************************************************************
c   R1: Get Data Type.  Return the 32 character string in a node's data-
c   type field.  In C, the data-type will be null terminated after the last
c   non-blank character.  A maximum of 33 characters may be used
c   (32 for the data-type plus 1 for the null).
c
c   f77: ADFGDT( ID, dtype, ierr )
c   input:  real*8 ID.  The ID of the node to use.
c   output:  character*(*) dtype.  The 32-character data-type of the node.
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFGDT( ID, dtype, ierr )
      IMPLICIT NONE
      real*8 ID
      character*(*) dtype
      integer ierr

      call ADFGDT2( ID, dtype, len( dtype ), ierr )
      return
      end

c***********************************************************************
c   R1: Get Dimension Values.  Return the dimension values for a node.
c   Values will only be returned for the number of dimensions defined in
c   the node.  If the number of dimensions for the node is zero, an
c   error is returned.
c
c   f77: ADFGDV( ID, dvals, ierr )
c   input:  real*8 ID.  The ID of the node to use.
c   output:  integer dvals(12).
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFGDV( ID, dvals, ierr )
      IMPLICIT NONE
      real*8 ID
      integer dvals(12)
      integer ierr

      call ADFGDV2( ID, dvals, ierr )
      return
      end

c***********************************************************************
c   R1      Get Error State.  Return the active error state.
c
c   f77: ADFGES( estate, ierr )
c   output:  integer estate.  Flag for ABORT on error (1) or return
c                 error status (0).  Set on a per database basis.
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFGES( estate, ierr )
      IMPLICIT NONE
      integer estate
      integer ierr

      call ADFGES2( estate, ierr )
      return
      end

c***********************************************************************
c   R1: Get Label.  Return the 32 character string in a node's label field.
c   In C, the label will be null terminated after the last non-blank
c   character.  A maximum of 33 characters may be used (32 for the
c   label plus 1 for the null).
c
c   f77: ADFGLB( ID, label, ierr )
c   input:  real*8 ID.  The ID of the node to use.
c   output:  character*(*) label.  The 32-character label of the node.
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFGLB( ID, label, ierr )
      IMPLICIT NONE
      real*8 ID
      character*(*) label
      integer ierr

      call ADFGLB2( ID, label, len( label ), ierr )
      return
      end

c***********************************************************************
c   R1: Get path information from a link.  If the node is a link-node,
c   return the path information.  Else, return an error.
c   If the link is in the same file, then a blank filename is returned.
c
c   f77: ADFGLKP( ID, file, name, ierr )
c   input:  real*8 ID.  The ID of the node to use.
c   output:  character*(*) file.  The filename.
c   output:  character*(*) name.  The name of node.
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFGLKP( ID, file, name, ierr )
      IMPLICIT NONE
      real*8 ID
      character*(*) file
      character*(*) name
      integer ierr

      call ADFGLK2( ID, file, len( file ), name, len( name ), ierr )
      return
      end

c***********************************************************************
c   R1: Get Name of a Node.  Given a node's ID, return the 32 character
c   name of that node.  In C, the name will be null terminated after the
c   last non-blank character.  A maximum of 33 characters may be used
c   (32 for the name plus 1 for the null).
c
c   f77: ADFGNAM( ID, name, ierr )
c   input:  real*8 ID.  The ID of the node to use.
c   output:  character*(*) name.  The simple name of the node.
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFGNAM( ID, name, ierr )
      IMPLICIT NONE
      real*8 ID
      character*(*) name
      integer ierr

      call ADFGNA2( ID, name, len( name ), ierr )
      return
      end

c***********************************************************************
c   R1: Get Number of Dimensions.  Return the number of data dimensions
c   used in a node.  Valid values are from 0 to 12.
c
c   f77: ADFGND( ID, ndims, ierr )
c   input:  real*8 ID.  The ID of the node to use.
c   output:  integer ndims.
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFGND( ID, ndims, ierr )
      IMPLICIT NONE
      real*8 ID
      integer ndims
      integer ierr

      call ADFGND2( ID, ndims, ierr )
      return
      end

c***********************************************************************
c   R1: Get Unique-Identifier of a Node.  Given a parent node ID and a
c   a name of child node, return the ID of the child.  To return the ID
c   of the root-node in an ADF file, use any known ID in the ADF file
c   and a name of "/".
c
c   f77: ADFGNID( PID, name, ID, ierr )
c   input:  real*8 PID.  The ID of the Node's parent.
c   input:  character*(*) name.  The name of the node.  Compound
c                names including path information use a slash
c                "/" notation between node names.  If a
c                leading slash is used, then PID can be any
c                valid node ID in the ADF database.
c   output:  real*8 ID.  The ID of the named node.
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFGNID( PID, name, ID, ierr )
      IMPLICIT NONE
      real*8 PID
      character*(*) name
      real*8 ID
      integer ierr

      call ADFGNI2( PID, name, len( name ), ID, ierr )
      return
      end

c***********************************************************************
c   R1: Get root-ID for an ADF system from any ID in the system.
c
c   f77: ADFGRID( ID, RootID, ierr )
c   input:  real*8 ID.  The ID of the node to use.
c   output: real*8 RootID.  The ID of the root node.
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFGRID( ID, RootID, ierr )
      IMPLICIT NONE
      real*8 ID
      real*8 RootID
      integer ierr

      call ADFGRI2( ID, RootID, ierr )
      return
      end

c***********************************************************************
c   R1: Test if a Node is a link.  If the actual data-type of the node
c   is "LK" (created with ADF_Link), return the link path length.
c   Otherwise, return 0.
c
c   f77: ADFISLK( ID, lplen, ierr )
c   input:  real*8 ID.  The ID of the node to use.
c   input:  integer lplen.  0 if the node is NOT a link.  If
c             the node is a link, the length of the path string is returned.
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFISLK( ID, lplen, ierr )
      IMPLICIT NONE
      real*8 ID
      integer lplen
      integer ierr

      call ADFISL2( ID, lplen, ierr )
      return
      end

c***********************************************************************
c   R1: Create a link.  Note:  The Node linked to does not have to exist
c   when the link is created (but it may exist and that is OK).  However,
c   when the link is used, an error will occur if the linked to node does
c   not exist.
c
c   f77: ADFLINK( PID, name, file, nfile, ID, ierr )
c   input:  real*8 PID.  The ID of the Node's parent.
c   input:  character*(*) name.  The name of the link node.
c   input:  character*(*) file.  The filename to use for the link
c             (directly usable by a C open() routine).  If
c             blank (null), the link will be within the same file.
c   input:  character*(*) nfile.  The name of the node which
c             the link will point to.  This can be a simple or
c             compound name.
c   output:  real*8 ID.  The ID of the link-node.
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFLINK( PID, name, file, nfile, ID, ierr )
      IMPLICIT NONE
      real*8 PID
      character*(*) name
      character*(*) file
      character*(*) nfile
      real*8 ID
      integer ierr

      call ADFLIN2( PID, name, file, nfile, len( name ),
     1      len( file ), len( nfile ), ID, ierr )
      return
      end

c***********************************************************************
c   R1: Get ADF Library Version ID.  This is the version number of the
c   ADF library routines which your program is currently using.
c    The format of the version ID is:  "ADF Library  Version 000.01"
c    Note:  There is a double space between Library and Version.  This
c   lines up the number with the Database Version string.
c
c   f77: ADFLVER( version, ierr )
c   output:  character(32) version.  A 32-byte character string
c                containing the ADF Library version ID information.
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFLVER( version, ierr )
      IMPLICIT NONE
      character*(*) version
      integer ierr

      call ADFLVE2( version, len( version ), ierr )
      return
      end

c***********************************************************************
c   R2: Change Parent (move a Child Node).  The node and the 2 parents
c   must all exist within a single ADF file.  If the node is pointed to
c   by a link-node, changing the node's parent will break the link.
c
c   f77: ADFMOVE( PID, ID, NPID, ierr )
c   input:  real*8 PID.  The ID of the Node's parent.
c   input:  real*8 ID.  The ID of the node to use.
c   input:  real*8 NPID.  The ID of the Node's New Parent
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFMOVE( PID, ID, NPID, ierr )
      IMPLICIT NONE
      real*8 PID
      real*8 ID
      real*8 NPID
      integer ierr

      call ADFMOV2( PID, ID, NPID, ierr )
      return
      end

c***********************************************************************
c   R1: Get Number of Children of a Node.  Return the number of children
c   nodes directly associated with a parent node.
c
c   f77: ADFNCLD( ID, numcld, ierr )
c   input:  real*8 ID.  The ID of the node to use.
c   output:  integer numcld.  The number of children directly
c                associated with this node.
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFNCLD( ID, numcld, ierr )
      IMPLICIT NONE
      real*8 ID
      integer numcld
      integer ierr

      call ADFNCL2( ID, numcld, ierr )
      return
      end

c***********************************************************************
c   R1: Set/change the data-type and Dimension Information of a Node.
c   Valid user-definable data-types are:
c
c   No data    MT
c   Integer 32    I4
c   Integer 64    I8
c   Unsigned Int 32   U4
c   Unsigned Int 64   U8
c   Real 32    R4
c   Real 64    R8
c   Complex 64    X4
c   Complex 128    X8
c   Character (unsigned byte) C1
c   Byte (unsigned byte)  B1
c   Compound data-types can be used which combine types
c   ("I4,I4,R8"), define an array ("I4[25]"), or a combination of these
c   ("I4,C1[20],R8[3]").
c   dims can be a number from 0 to 12.
c   dim_vals is an array of integers.  The number of integers used is
c   determined by the dims argument.  If dims is zero, the dim_values
c   are not used.  Valid range for dim_values are from 1 to
c   2,147,483,648.  The total data size, calculated by the data-type-size
c   times the dimension value(s), cannot exceed 2,147,483,648.
c   Note:  When this routine is called and the data-type or the
c   number of dimensions changes, any data currently associated
c   with the node is lost!!   The dimension values can be changed and
c   the data space will be extended as needed.
c-
c   f77: ADFPDIM( ID, dtype, dims, dvals, ierr)
c   input:  real*8 ID.  The ID of the node.
c   input:  character*(*) dtype.
c   input:  integer dims.  The number of dimensions this node has.
c   input:  integer dvals(12).  The dimension values for this node.
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFPDIM( ID, dtype, dims, dvals, ierr)
      IMPLICIT NONE
      real*8 ID
      character*(*) dtype
      integer dims
      integer dvals(12)
      integer ierr

      call ADFPDI2( ID, dtype, len( dtype ), dims, dvals, ierr)
      return
      end

c***********************************************************************
c   R2: Put (change) Name of a Node.  Warning:  If the node is pointed
c   to by a link-node, changing the node's name will break the link.
c
c   f77: ADFPNAM( PID, ID, name, ierr )
c   input:  real*8 PID.  The ID of the Node's parent.
c   input:  real*8 ID.  The ID of the node to use.
c   input:  character*(*) name.  The new name of the node.
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFPNAM( PID, ID, name, ierr )
      IMPLICIT NONE
      real*8 PID
      real*8 ID
      character*(*) name
      integer ierr

      call ADFPNA2( PID, ID, name, len( name ), ierr )
      return
      end

c***********************************************************************
c   R1      Set Error State.  For all ADF calls, set the error handling
c   convention; either return error codes, or abort the program on an error.
c   The default state for the ADF interface is to return error codes and NOT
c   abort.
c
c   f77: ADFSES( estate, ierr )
c   input:  integer estate.  Flag for ABORT on error (1) or return
c                 error status (0).  Set on a per database basis.
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFSES( estate, ierr )
      IMPLICIT NONE
      integer estate
      integer ierr

      call ADFSES2( estate, ierr )
      return
      end

c***********************************************************************
c   R1: Set Label.  Set the 32 character string in a node's label field.
c
c   f77: ADFSLB( ID, label, ierr )
c   input:  real*8 ID.  The ID of the node to use.
c   input:  character*(*) label.  The 32-character label of the node.
c   output:  integer ierr.
c***********************************************************************
      subroutine ADFSLB( ID, label, ierr )
      IMPLICIT NONE
      real*8 ID
      character*(*) label
      integer ierr

      call ADFSLB2( ID, label, len( label ), ierr )
      return
      end

        PROGRAM write_mixed_grid
	USE CGNS

!	author: Diane Poirier
!	last revised on March 8 2000

! 	This example test the new data structures created for
! 	unstructured data and geometry reference data.  The
! 	model being create is composed of 2 zones.  The 1st
!	one is a structured 3x3x3 block, and the 2nd is
!	an unstructured 3x3x3 block composed of 8 hexa elements.
! 	The 2 zones interface (Abutting1to1) on one 9-nodes face.
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	parameter (Ndim = 3)
	integer index_dim, cell_dim, phys_dim
	integer cg, base, zone, num, ier, index, ZoneType
        integer(cgsize_t) size(Ndim*3)
	integer i, j, k, n, pos, coord
        integer(cgsize_t) element(8,8)
	integer hexa_section_no, quad_section_no
        integer(cgsize_t) parent(4,4)
        integer(cgsize_t) elist(4)
	integer(cgsize_t) quads(4,4)
        integer(cgsize_t) dim_vals(12)
        integer(cgsize_t) pnts(3,9), uns_pnts(9)
	integer(cgsize_t) Nindex(3)
	double precision VertexNormals(3,9), FaceNormals(3,4)
	integer fam, geo, part, bc
	integer sol_no, field_no
	character*32 ZoneName, coordname(3), geoname, fambcname
	character*200 cadfile, partname
        double precision data_double(200*3), interpolants(3,9)
	integer grid_no
        real rot_vec(3), rot_center(3), rm_arr(6)
        integer rm_len(2)

!       initialize
        ier = 0
	cell_dim=3
	phys_dim=3

!       open CGNS file for writing

        call cg_open_f('Test_V2', MODE_WRITE, cg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

!*******write CGNSBase
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	call cg_base_write_f(cg, 'Name of my Base', cell_dim, phys_dim, &
      			     base, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

!****** Create 2 volume and 1 face families
	call cg_family_write_f(cg, base, 'Family#1', index, ier)
!	write(6,*)'index1=',index
	if (ier .eq. ERROR) call cg_error_exit_f
	call cg_family_write_f(cg, base, 'Family#2', index, ier)
!	write(6,*)'index2=',index
	if (ier .eq. ERROR) call cg_error_exit_f
        call cg_family_write_f(cg, base, 'Outflow', index, ier)
!	write(6,*)'index3=',index
        if (ier .eq. ERROR) call cg_error_exit_f

! ******write CGNSBase substructure: Zone
	do zone=1, 2

! Structured zone:
	    if (zone .eq. 1) then
		ZoneType=CGNS_ENUMV(Structured)
	        write(ZoneName,100) 'StructuredZone#1'
		
		index_dim = 3
		do i=1, index_dim
		    size(i) = 3
		    size(i+index_dim) = size(i)-1
		    size(i+2*index_dim) = 0              ! unsorted data
		enddo

! Unstructured zone:
	    else if (zone .eq. 2) then
		ZoneType=CGNS_ENUMV(Unstructured)
		write(ZoneName,'(a)') 'UnstructuredZone#1'
		index_dim = 1
		size(1) = 27		! no of nodes
	 	size(2) = 8		! no of elements
		size(3) = 0		! unsorted nodes
	    endif

	    num = 1
            do i=1, index_dim               		
                num = num * size(i)
            enddo
	    call cg_zone_write_f(cg,base,ZoneName,size,ZoneType, &
                                 index,ier)
            if (ier .eq. ERROR) call cg_error_exit_f

! GOTO Zone node and write family name :
            call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f
	    if (zone.eq.1) then
	  	call cg_famname_write_f('Family#1', ier)
	    else
		call cg_famname_write_f('Family#2', ier)
	    endif
	    if (ier .eq. ERROR) call cg_error_exit_f

! Name convention
            coordname(1) = 'CoordinateX'
            coordname(2) = 'CoordinateY'
            coordname(3) = 'CoordinateZ'

! Create GridCoordinates_t node
            call cg_grid_write_f(cg,base,index,'GridCoordinates', &
                               grid_no, ier)
            if (ier.ne. ALL_OK) call cg_error_exit_f

! create coordinate data
            do coord=1,phys_dim
               DO k=1, 3
                  DO j=1, 3
                     DO i=1, 3
                        pos = i + (j-1)*3 + (k-1)*9
                        IF (coord.EQ.1) data_double(pos) = (i-1)*5 + &
                             (zone-1)*10
                        IF (coord.EQ.2) data_double(pos) = (j-1)*5
                        IF (coord.EQ.3) data_double(pos) = (k-1)*5
                     ENDDO
                  ENDDO
               ENDDO

! GOTO GridCoordinatesNode & write DataArray
                call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                    'GridCoordinates_t', 1, 'end')
                if (ier .eq. ERROR) call cg_error_exit_f

                call cg_array_write_f(coordname(coord), CGNS_ENUMV(RealDouble), &
                    index_dim, size, data_double, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
	    enddo	! coord. loop

! Flow Solution

	    do n=1,8
		data_double(n) = 1.0 + n/10.0
	    enddo
	    call cg_sol_write_f(cg, base, zone,'Solution1',CGNS_ENUMV(CellCenter), &
               sol_no,ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
	    call cg_field_write_f(cg, base, zone, sol_no, CGNS_ENUMV(RealDouble), &
                'DummySolution', data_double, field_no, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

! Grid Connectivity 1to1:  From a structured zone to an unstructured zone
	    ! Unstructured point list:
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	    uns_pnts(1)=1
	    do n=2,9
		uns_pnts(n) = uns_pnts(n-1)+3
	    enddo

	    if (zone .eq. 1) then
		! PointRange for structured zone:
	        pnts(1,1)=3
	        pnts(2,1)=1
	        pnts(3,1)=1
	        pnts(1,2)=3
                pnts(2,2)=3
                pnts(3,2)=3

	        call cg_conn_write_f(cg, base, zone, 'str_to_unstr', &
       	            CGNS_ENUMV(Vertex), CGNS_ENUMV(Abutting1to1), CGNS_ENUMV(PointRange), 2_cgsize_t, pnts, &
                    'UnstructuredZone#1', CGNS_ENUMV(Unstructured), &
                    CGNS_ENUMV(PointListDonor), CGNS_ENUMV(Integer), 9_cgsize_t, uns_pnts, index, &
                    ier)
		if (ier .eq. ERROR) call cg_error_exit_f

! Fake similation of Overset or Abutting-mismatch: str to unstr
		call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                    'ZoneGridConnectivity_t', 1, &
                    'GridConnectivity_t', 1, 'end')
                if (ier .eq. ERROR) call cg_error_exit_f

! make up some dummy data
		do n=1,9
		do i=1,cell_dim
		    interpolants(i,n)=1.0/(i+n)
		enddo
		enddo

		dim_vals(1)=cell_dim
		dim_vals(2)=9
		call cg_array_write_f('InterpolantsDonor', CGNS_ENUMV(RealDouble), &
                    2, dim_vals, interpolants(1,1), ier)
                if (ier .eq. ERROR) call cg_error_exit_f
		
	    endif

	

! Grid Connectivity 1to1:  From an unstructured zone to a structured zone
	    if (zone .eq. 2) then

		! PointList of structured donor
		n=0
		do k=1,3
		do j=1,3
		    n=n+1
		    pnts(1,n) = 3
		    pnts(2,n) = j
		    pnts(3,n) = k
		enddo
		enddo

		call cg_conn_write_f(cg, base, zone, 'unstr_to_str', &
                    CGNS_ENUMV(Vertex), CGNS_ENUMV(Abutting1to1), CGNS_ENUMV(PointList),9_cgsize_t,uns_pnts, &
                    'StructuredZone#1', CGNS_ENUMV(Structured), CGNS_ENUMV(PointListDonor), &
      		    CGNS_ENUMV(Integer), 9_cgsize_t, pnts, index, ier)
		if (ier .eq. ERROR) call cg_error_exit_f
            endif

! BOUNDARY CONDITION PATCH: Put a user defined b.c. at interface
	    if (zone.eq.1) then
	      ! write a PointRange patch (3,1,1) to (3,3,3) for a structured zone
	        call cg_boco_write_f(cg, base, zone, 'myboco', &
                  CG_UserDefined, CGNS_ENUMV(PointRange), 2_cgsize_t, pnts, index, ier)
	        if (ier .eq. ERROR) call cg_error_exit_f

	      ! Write Normal index and Normal vectors
		Nindex(1)=-1
		Nindex(2)=0
		Nindex(3)=0
		do n=1, 9
		    VertexNormals(1,n) = -1.0	! x-coord
		    VertexNormals(2,n) = 0	! y-coord
		    VertexNormals(3,n) = 0	! z-coord
		enddo
		
		call cg_boco_normal_write_f(cg, base, zone, index, Nindex, &
                      1, CGNS_ENUMV(RealDouble), VertexNormals, ier)
		if (ier .eq. ERROR) call cg_error_exit_f


	    else if (zone.eq.2) then
	      ! BC patch defined using points and normals at the points:
		call cg_boco_write_f(cg, base, zone, 'point_patch', &
                  CG_UserDefined, CGNS_ENUMV(PointList), 9_cgsize_t, uns_pnts, index, &
                  ier)
                if (ier .eq. ERROR) call cg_error_exit_f

	      ! note: Normal index has no definition in unstructured
		do n=1, 9
		    VertexNormals(1,n) = 1.0
		enddo
		call cg_boco_normal_write_f(cg, base, zone, index, Nindex, &
                      1, CGNS_ENUMV(RealDouble), VertexNormals, ier)
                if (ier .eq. ERROR) call cg_error_exit_f

	      ! BC patch defined using face elements & normals at the faces
		do n=1, 4
		  elist(n)=8+n
		  FaceNormals(1,n)=1.0
		  FaceNormals(2,n)=0
		  FaceNormals(3,n)=0
		enddo
		call cg_boco_write_f(cg, base, zone, 'shell_patch', &
                  CGNS_ENUMV(FamilySpecified), CGNS_ENUMV(PointList), 4_cgsize_t, elist, index, ier)
		if (ier .eq. ERROR) call cg_error_exit_f

	     ! Specify that the GridLocation is FaceCenter
		call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                   'ZoneBC_t', 1, 'BC_t', index, 'end')
                if (ier .eq. ERROR) call cg_error_exit_f

		call cg_gridlocation_write_f(CGNS_ENUMV(FaceCenter), ier)
		if (ier .eq. ERROR) call cg_error_exit_f

                call cg_boco_normal_write_f(cg, base, zone, index, &
                      Nindex, 1, CGNS_ENUMV(RealDouble), FaceNormals, ier)
                if (ier .eq. ERROR) call cg_error_exit_f

	      ! Define family name for BC patch
		call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                   'ZoneBC_t', 1, 'BC_t', index, 'end')
		if (ier .eq. ERROR) call cg_error_exit_f

		call cg_famname_write_f('Outflow', ier)
		if (ier .eq. ERROR) call cg_error_exit_f
	    endif

! ********** SPECIAL FOR UNSTRUCTURED ZONES ONLY **********

	    if (ZoneType .eq. CGNS_ENUMV(Unstructured)) then

            ! Generate HEXA_8 Element Connectivity
                n=0
                DO k=1,2
                   DO j=1,2
                      DO i=1,2
                         n=n+1
                         pos = i + (j-1)*3 + (k-1)*9
                         element(1,n) = pos
                         element(2,n) = pos+1
                         element(3,n) = pos+4
                         element(4,n) = pos+3
                         element(5,n) = pos+9
                         element(6,n) = pos+10
                         element(7,n) = pos+13
                         element(8,n) = pos+12
                      ENDDO
                   ENDDO
                ENDDO

		call cg_section_write_f(cg, base, zone, &
                  'VolumeElements', CGNS_ENUMV(HEXA_8), 1_cgsize_t, 8_cgsize_t, 0, &
                   element, hexa_section_no, ier)
		if (ier .eq. ERROR) call cg_error_exit_f

	      ! GENERATE some quad elements
                ! 1st node of each element
                quads(1,1) = 3
                quads(1,2) = 6
                quads(1,3) = 12
                quads(1,4) = 15
                ! remaining nodes of each element
                do n=1, 4
                    quads(2,n)=quads(1,n)+3
                    quads(3,n)=quads(1,n)+12
                    quads(4,n)=quads(1,n)+9
                enddo

		call cg_section_write_f(cg, base, zone, 'outflow', &
                  CGNS_ENUMV(QUAD_4), 9_cgsize_t, 12_cgsize_t, 0, quads, &
                  quad_section_no,ier)
		if (ier .eq. ERROR) call cg_error_exit_f

	     !  GENERATE Parent Data for shell elements
		do n=1, 4
		    parent(n,1) = 2*n	! first parent
		    parent(n,2) = 0	! no second parent
		    parent(n,3) = 3	! face of first parent
		    parent(n,4) = 0	! face of 2nd parent
		enddo

		call cg_parent_data_write_f(cg, base, zone, &
                     quad_section_no, parent, ier)
		if (ier .eq. ERROR) call cg_error_exit_f

! Auxiliary info:
                call cg_goto_f(cg,base,ier,'Zone_t',zone,'Elements_t', &
                  hexa_section_no, 'end')
                if (ier .eq. ERROR) call cg_error_exit_f

                call cg_descriptor_write_f('Descriptor_Name', &
                    'Descriptor_Text', ier)
                if (ier .eq. ERROR) call cg_error_exit_f


	    endif	! IF UNSTRUCTURED ZONE


! *********************************************************************

        enddo	! zone loop

! FAMILY and GEOMETRY

	do fam=1,3
          ! A family may have several GeometryReference_t node
            do geo=1, 2
                write(geoname, 200) 'Geo#',geo,'_of_fam#',fam
		write(cadfile, 200)'CADFile#',geo
                call cg_geo_write_f(cg, base, fam, geoname, &
                    cadfile, 'IGES', index, ier)
                if (ier .eq. ERROR) call cg_error_exit_f

		! A GeometryReference_t may encompass several parts
		do part = 1, 2
		    write(partname, 200)'Part#',part
		    call cg_part_write_f(cg, base, fam, geo, &
                        partname, index, ier)
		    if (ier .eq. ERROR) call cg_error_exit_f
		enddo

	      ! GeometryReference_t descriptor
		call cg_goto_f(cg, base, ier, 'Family_t', fam, &
                 'GeometryReference_t',geo,'end')
		if (ier .eq. ERROR) call cg_error_exit_f

		call cg_descriptor_write_f('Descriptor', &
                 geoname, ier)
		if (ier .eq. ERROR) call cg_error_exit_f
	    enddo

            if (fam .eq. 3) then
                call cg_fambc_write_f(cg, base, fam, "FamBC", &
                     CGNS_ENUMV(BCOutflow), index, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
            else
	  ! A family may have only one FamilyBC_t node ACCORDING TO THE SIDS
                do bc=1,2
! Only write one FamilyBC_t node
                   if (bc .ne. fam) then 
                       cycle
                   endif
                   write(fambcname,'(a,i1)')'FamBC#',bc
                   call cg_fambc_write_f(cg, base, fam, fambcname, &
                       CGNS_ENUMV(BCGeneral), index, ier)
                   if (ier .eq. ERROR) call cg_error_exit_f
                enddo
            endif

! ** begin KMW Family Functionality Extension
            if (fam .ne. 3) then
          ! add to the first and only FamilyBC_t
	    call cg_goto_f(cg, base, ier, 'Family_t', fam, &
                           'FamilyBC_t', 1,'end')
	    if (ier .eq. ERROR) call cg_error_exit_f

!           call cg_bcdataset_write_f('FamBCDataSet', CGNS_ENUMV(BCWall), &
!                         0, ier)
!	    if (ier .eq. ERROR)  call cg_error_exit_f

            call cg_bcdataset_write_f('FamBCDataSet', CGNS_ENUMV(BCWall), &
                           CGNS_ENUMV(Dirichlet), ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

            call cg_bcdataset_write_f('FamBCDataSet', CGNS_ENUMV(BCWall), &
                           CGNS_ENUMV(Neumann), ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

            call cg_goto_f(cg, base, ier, 'Family_t', fam, &
                           'FamilyBC_t', 1, 'BCDataSet_t', 1, &
                           'BCData_t', CGNS_ENUMV(Dirichlet), 'end')
	    if (ier .eq. ERROR) call cg_error_exit_f

            call cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), CGNS_ENUMV(Celsius), &
                           CGNS_ENUMV(Degree), ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

! ** end KMW Family Functionality Extension
            endif

	 !  Family Descriptor and Ordinal
	    call cg_goto_f(cg, base, ier, 'Family_t', fam, 'end')
	    if (ier .eq. ERROR) call cg_error_exit_f

	    call cg_descriptor_write_f('Fam_Descr_Name', &
                  'Fam_Descr_Text', ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

	    call cg_ordinal_write_f(fam, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

! ** begin KMW Family Functionality Extension

            do i=1,3
               rot_vec(i) = i
               rot_center(i) = -i
            enddo

            call cg_rotating_write_f(rot_vec, rot_center, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

! ** end KMW Family Functionality Extension

	enddo

! Auxiliary nodes for FAMILY and GEOMETRY

! *********************************************************************

	call cg_close_f(cg, ier)
	if (ier.eq. ERROR) call cg_error_exit_f()
 100	format(a)
 200	format(a,i1,a,i1)

        END PROGRAM write_mixed_grid

	program delete_cprop
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on August 2002

!       This example test deleting the GridConnectivityProperty_t data structure and its children
!       It tests cg_delete for the following nodes:
!       - child of GridConnectivity_t: GridConnectivityProperty_t
!       - children of GridConnectivityProperty_t: AverageInterface_t, Periodic_t, Descriptor_t, UserDef._t
!       - children of AverageInterface_t: AverageInterfaceType_t, Descriptor_t, UserDef._t
!       - children of Periodic_t: PeriodicType_t, RotationCenter, RotationAngle, Translation,
!				  Descriptor_t, UserDef._t
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 3)
	integer index_dim, cell_dim, phys_dim
	character*100 linkpath

	integer cg, base, zone, conn, ier, size(Ndim*3), i, num
	integer AverageInterfaceType, pnts(Ndim,2), nbases, n
	character*32 RegionName32, basename, dummy
	real *4 version, Translation(Ndim)
	real *4 RotationCenter(Ndim), RotationAngle(Ndim)
	integer(cgsize_t) dim_vals(2)
	

! *** initialize
	ier = 0
	index_dim=Ndim
	cell_dim=Ndim
	phys_dim=Ndim

! *** open CGNS file for writing
 	call cg_open_f('Test_V2', MODE_MODIFY, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,600)'MODIFYING FILE Test_V2'

! *** CGNS Library Version used for file creation:
        call cg_version_f(cg, version, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,102) &
           'Library Version used for file creation:',version

! *** base
	call cg_nbases_f(cg, nbases, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,200)'nbases=',nbases

	base=1

        call cg_base_read_f(cg, base, basename, cell_dim, phys_dim, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,300)'BaseName = "',basename,'"', &
                      'cell_dimension=',cell_dim

	zone = 1
	conn = 2

! *** delete children of DataArray_t "RotationCenter"
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
      	    'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn, &
            'GridConnectivityProperty_t', 1, 'Periodic_t', 1, &
      	    'DataArray_t', 1, 'end')

        if (ier .eq. ALL_OK) then
            call cg_delete_node_f('DataClass', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_delete_node_f('DimensionalUnits', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

            write(6,*) 'Children of RotationCenter deleted.  Continue?'
	    read(5,600) dummy
        endif

! *** delete children of Periodic_t: RotationCenter, RotationAngle,
!     Translation, Descriptor_t, UserDef._t, DataClass, DimensionalUnits
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
            'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn, &
            'GridConnectivityProperty_t', 1, 'Periodic_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        if (ier .eq. ALL_OK) then
!           RotationCenter, RotationAngle, Translation can't be deleted,
!           so we expect an error from the API
            call cg_delete_node_f('RotationCenter', ier)
            if (ier .eq. ERROR) call cg_error_print_f

            call cg_delete_node_f('RotationAngle', ier)
            if (ier .eq. ERROR) call cg_error_print_f

            call cg_delete_node_f('Translation',ier)
            if (ier .eq. ERROR) call cg_error_print_f

            call cg_delete_node_f('PeriodicDescriptorName', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_delete_node_f('PeriodicUserData', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

	    call cg_delete_node_f('DataClass', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_delete_node_f('DimensionalUnits', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

	    write(6,*) 'Children of Periodic deleted.  Continue?'
            read(5,600) dummy
        endif

! *** delete children of AverageInterface_t: AverageInterfaceType_t, Descriptor_t, UserDef._t
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
            'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn, &
            'GridConnectivityProperty_t', 1, 'AverageInterface_t', 1, &
      	    'end')

        if (ier .eq. ALL_OK) then
            call cg_delete_node_f('AverageInterfaceType', ier)
            if (ier .eq. ERROR) call cg_error_print_f

            call cg_delete_node_f('AverageInterfaceDescriptorName', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_delete_node_f('AverageInterfaceUserData', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

	    write(6,*)'Children of AverageInterface deleted.  Continue?'
            read(5,600) dummy
        endif

! *** delete children of GridConnectivityProperty_t: AverageInterface_t,
!	Periodic_t, Descriptor_t, UserDef._t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
            'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn, &
            'GridConnectivityProperty_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

	if (ier .eq. ALL_OK) then
            call cg_delete_node_f('AverageInterface', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_delete_node_f('Periodic', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_delete_node_f('GridConnPropDescriptorName', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_delete_node_f('GridConnPropUserData', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	    write(6,*)'Children of GridConnProperty deleted.  Continue?'
            read(5,600) dummy
	endif

! *** delete child of GridConnectivity_:  GridConnectivityProperty_t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
            'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn, &
      	    'end')
	if (ier .eq. ERROR) call cg_error_exit_f

	if (ier .eq. ALL_OK) then
            call cg_delete_node_f('GridConnectivityProperty', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

	    write(6,*) 'GridConnectivityProperty deleted.  Continue?'
	    read(5,600) dummy
	endif

! Rewrite everything back

! *** write GridConnectivityProperty_t/AverageInterface_t node under conn#2
        AverageInterfaceType = CGNS_ENUMV(AverageCircumferential)
        call cg_conn_average_write_f(cg, base, zone, &
              conn, AverageInterfaceType, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! *** write GridConnectivityProperty_t/Periodic_t node under conn#2
        do n=1, Ndim
            RotationCenter(n) = n*1.1
            RotationAngle(n) = (n+3)*1.1
            Translation(n) = (n+6)*1.1
        enddo
        call cg_conn_periodic_write_f(cg, base, zone, conn, &
             RotationCenter, RotationAngle, Translation, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! *** write Descriptor_t, UserDefinedData_t & Link under...
! ...   GridConnectivityProperty_t
       call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
            'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn, &
            'GridConnectivityProperty_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_descriptor_write_f('GridConnPropDescriptorName', &
            'GridConnPropDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_user_data_write_f('GridConnPropUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! ...   AverageInterface_t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
            'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn, &
            'GridConnectivityProperty_t', 1, 'AverageInterface_t', 1, &
            'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_descriptor_write_f('AverageInterfaceDescriptorName', &
            'AverageInterfaceDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_user_data_write_f('AverageInterfaceUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! ...   Periodic_t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
            'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn, &
            'GridConnectivityProperty_t', 1, 'Periodic_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_descriptor_write_f('PeriodicDescriptorName', &
            'PeriodicDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_user_data_write_f('PeriodicUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * DataClass & DimensionalUnits under Periodic
        call cg_dataclass_write_f(CGNS_ENUMV(Dimensional), ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        call cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), CGNS_ENUMV(Kelvin), &
                              CGNS_ENUMV(Radian), ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * DataArray under Periodic
        dim_vals(1)=3
        dim_vals(2)=2
        call cg_array_write_f('arraysize', CGNS_ENUMV(Integer), 2, dim_vals, &
              size, ier)
        if (ier .ne. ERROR) write(6,'(a)') 'Error in API'

! * DataClass & DimensionalUnits under RotationCenter
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
            'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn, &
            'GridConnectivityProperty_t', 1, 'Periodic_t', 1, &
            'DataArray_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_dataclass_write_f(CGNS_ENUMV(Dimensional), ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        call cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), CGNS_ENUMV(Kelvin), &
                              CGNS_ENUMV(Radian), ier)
        if (ier .eq. ERROR) call cg_error_exit_f

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

! *** close CGNS file
	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

 102    format(a,f8.3)
 200    format(a,i5)
 300    format(3a/a,i2)
 600    format(3a)
	end

        PROGRAM read_axisym
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on June 7 2002

!       This example test the Axisymmetry_t data structure and its children
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 2)
	integer CellDim, PhysDim
	integer ier, n, cg, nbases, base, type
	integer ndescriptors, idescr, nuser_data
	integer mass, length, time, temp, deg, i
        integer narrays, iarray, datatype, nndim, num
	integer(cgsize_t) dim_vals(12)
	real*4 version, ref_point(Ndim), axis(Ndim), angle(1)
	character*32 name, filename, basename, user_data_name
	character*100 text
        character*32 arrayname, CoordinateNames(2)

! *** open file
!	write(6,*) 'Input filename'
!	read(5,600) filename
 	write(filename,'(a)')'Test_V2'
	call cg_open_f(filename, MODE_READ, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,600)'READING FILE ',filename

! *** CGNS Library Version used for file creation:
	call cg_version_f(cg, version, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,102) &
          'Library Version used for file creation:',version

! *** base
	call cg_nbases_f(cg, nbases, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,200)'nbases=',nbases
	
	base=1

	call cg_base_read_f(cg, base, basename, CellDim, PhysDim, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,300)'BaseName = "',basename,'"', &
                     'cell_dimension=',CellDim

! *** base attribute:  GOTO base node
	call cg_goto_f(cg, base, ier, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

! ***   base attribute:  Descriptor
	call cg_ndescriptors_f(ndescriptors, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,400)'Base Descriptor_t Information:'
        write(6,105) 'No. of descriptors=',ndescriptors

	do idescr=1, ndescriptors
          call cg_descriptor_read_f(idescr, name, text, ier)
          if (ier .eq. ERROR) call cg_error_exit_f
          if (ier.eq.ALL_OK) then
            write(6,500)' DescriptorName="',name,'"', &
                       ' DescriptorText="',text,'"'
          endif
	enddo

! *** read Axisymmetry_t node
	call cg_axisym_read_f(cg, base, ref_point, axis, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	write(6,110)'ref_point=',ref_point(1),ref_point(2)
	write(6,110)'axis=',axis(1),axis(2)

! *** read children of Axisymmetry_t
	call cg_goto_f(cg, base, ier, 'Axisymmetry_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

! * Descriptor
 	call cg_ndescriptors_f(ndescriptors, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
 	write(6,400)'Axisymmetry Descriptor_t Information:'
        write(6,105) 'No. of descriptors=',ndescriptors

        do idescr=1, ndescriptors
          call cg_descriptor_read_f(idescr, name, text, ier)
          if (ier .eq. ERROR) call cg_error_exit_f
          write(6,500) ' DescriptorName="',name,'"', &
                      ' DescriptorText="',text,'"'
        enddo

! * DataClass
        call cg_dataclass_read_f(type,ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,600)'DataClassName=',DataClassName(type)

! * DimensionalUnits
        call cg_units_read_f(mass, length, time, temp, deg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        if (ier .eq. ALL_OK) then
          write(6,100) &
           'Axisymmetry Dimensional Units:',&
           MassUnitsName(mass), LengthUnitsName(length),&
           TemperatureUnitsName(temp), TimeUnitsName(time),&
           AngleUnitsName(deg)
        endif

! * UserDefinedData
	call cg_nuser_data_f(nuser_data, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,400)'Axisymmetry User Data Information:'
	write(6,105) 'No. of UserData=',nuser_data

	do n=1, nuser_data
          call cg_user_data_read_f(n, user_data_name, ier)
          if (ier .eq. ERROR) call cg_error_exit_f
	  write(6,500) ' user_data_name="',user_data_name,'"'
	enddo

! * DataArray_t
	call cg_narrays_f(narrays, ier)
        if (ier .ne. ALL_OK) call cg_error_exit_f
        write(6,105) 'No. of DataArray_t=',narrays

	do iarray=1,narrays

            call cg_array_info_f(iarray, arrayname, datatype,&
                     nndim, dim_vals, ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f

            write(6,108)'     DataArray_t #',iarray,':'
            write(6,600)'       Name = ',arrayname
            write(6,600)'       Type = ',DataTypeName(datatype)
            write(6,104)'       Ndim=',nndim
            num = 1
            do i=1,nndim
                write(6,111)'       DataDim(',i,')=',dim_vals(i)
                num = num*dim_vals(i)
            enddo

            if (datatype .eq. CGNS_ENUMV(Character)) then
                call cg_array_read_f(iarray, CoordinateNames, ier)
                if (ier .ne. ALL_OK) call cg_error_exit_f

		write(6,600)'1st coord=',CoordinateNames(1)
		write(6,600)'2nd coord=',CoordinateNames(2)

            else if (datatype .eq. CGNS_ENUMV(RealSingle)) then
	 	if (arrayname.eq.'AxisymmetryAngle') then
		    call cg_array_read_f(iarray, angle, ier)
		    if (ier .ne. ALL_OK) call cg_error_exit_f
		else if (arrayname.eq.'AxisymmetryReferencePoint') then
		    call cg_array_read_f(iarray, ref_point, ier)
		    if (ier .ne. ALL_OK) call cg_error_exit_f
		else if (arrayname.eq.'AxisymmetryAxisVector') then
		    call cg_array_read_f(iarray, axis, ier)
                    if (ier .ne. ALL_OK) call cg_error_exit_f
		endif

	    endif

	enddo     ! loop through arrays
	
        write(6,106)'  ref_point=',(ref_point(i),i=1,2)
        write(6,106)'  axis     =',(axis     (i),i=1,2)
        write(6,106)'  angle    =',angle

! * Axisymmetry_t/DataArray_t/Descriptor
        do iarray=1,narrays
            call cg_goto_f(cg, base, ier, 'Axisymmetry_t', 1,&
                          'DataArray_t', iarray, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_ndescriptors_f(ndescriptors, ier)
            if (ier .eq. ERROR) call cg_error_exit_f
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
            write(6,400)'Axisymmetry DataArray # ',iarray,&
                       ' Descriptor Information:'
            write(6,105) 'No. of descriptors=',ndescriptors

            do idescr=1, ndescriptors
              call cg_descriptor_read_f(idescr, name, text, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              write(6,500) ' DescriptorName="',name,'"',&
                            ' DescriptorText="',text,'"'
            enddo

! * Axisymmetry_t/DataArray_t/DimensionalUnits
            call cg_units_read_f(mass, length, time, temp, deg, ier)
            if (ier .eq. ERROR) call cg_error_exit_f
            if (ier .eq. ALL_OK) then
              write(6,100) &
               'Axisymmetry DataArray Dimensional Units:',&
               MassUnitsName(mass), LengthUnitsName(length),&
               TemperatureUnitsName(temp), TimeUnitsName(time),&
               AngleUnitsName(deg)
            endif
	enddo


        call cg_close_f(cg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

 100 	format(a/,'    Mass units: ',a/,'    Length units: ',a/,&
         '    Temperature units: ',a/,'    Time units: ',a/,&
         '    Angle units:',a)
 102 	format(a,f5.3)
 104	format(a,i2,3a)
 105	format(a,i2,a)
 106    format(a,6f10.3)
 108    format(a,i2,a,i2,a)
 110	format(a,5f5.1)
 111    format(a,i1,a,i8)
 200    format(a,i5)
 300	format(3a/a,i2)
 400	format(/a,i1,a/)
 500	format(3a/3a)
 600	format(3a)

        END PROGRAM read_axisym

        PROGRAM read_gravity
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on May 31 2002

!       This example test the RotatingCoordinates_t data structure and its children
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 3)
	integer CellDim, PhysDim
	integer(cgsize_t) size(Ndim*3)
	integer ier, n, cg, nbases, base, type, zone, nzones
	integer ndescriptors, idescr, nuser_data
	integer mass, length, time, temp, deg
	integer narrays, iarray, nndim, datatype, zonetype
	integer(cgsize_t) dim_vals(12)
	real*4 version, rot_rate(Ndim), rot_center(Ndim), data_single(100)
	character*32 name, filename, basename, user_data_name, zonename
	character*100 text

! *** open file
!	write(6,*) 'Input filename'
!	read(5,600) filename
 	write(filename,'(a)')'Test_V2'
	call cg_open_f(filename, MODE_READ, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,600)'READING FILE ',filename

! *** CGNS Library Version used for file creation:
	call cg_version_f(cg, version, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,102) &
          'Library Version used for file creation:',version

! *** base
	call cg_nbases_f(cg, nbases, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,200)'nbases=',nbases
	
	base=1

	call cg_base_read_f(cg, base, basename, CellDim, PhysDim, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,300)'BaseName = "',basename,'"',  &
                      'cell_dimension=',CellDim

! *** base attribute:  GOTO base node
	call cg_goto_f(cg, base, ier, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

! ***   base attribute:  Descriptor
	call cg_ndescriptors_f(ndescriptors, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,400)'Base Descriptor_t Information:'
        write(6,105) 'No. of descriptors=',ndescriptors

	do idescr=1, ndescriptors
          call cg_descriptor_read_f(idescr, name, text, ier)
          if (ier .eq. ERROR) call cg_error_exit_f
          if (ier.eq.ALL_OK) then
            write(6,500)' DescriptorName="',name,'"', &
                        ' DescriptorText="',text,'"'
          endif
	enddo

! *** read RotatingCoordinates_t node
	call cg_rotating_read_f(rot_rate, rot_center, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	write(6,110)'rot_rate=',rot_rate(1), &
                     rot_rate(2), rot_rate(3)
	write(6,110)'rot_center=',rot_center(1), &
                     rot_center(2), rot_center(3)

! *** read children of RotatingCoordinates_t
	call cg_goto_f(cg, base, ier, 'RotatingCoordinates_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

! * Descriptor
 	call cg_ndescriptors_f(ndescriptors, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
 	write(6,400)'RotatingCoordinates Descriptor_t Information:'
        write(6,105) 'No. of descriptors=',ndescriptors

        do idescr=1, ndescriptors
          call cg_descriptor_read_f(idescr, name, text, ier)
          if (ier .eq. ERROR) call cg_error_exit_f
          write(6,500) ' DescriptorName="',name,'"', &
                             ' DescriptorText="',text,'"'
        enddo

! * DataClass
        call cg_dataclass_read_f(type,ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,600)'DataClassName=',DataClassName(type)

! * DimensionalUnits
        call cg_units_read_f(mass, length, time, temp, deg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        if (ier .eq. ALL_OK) then
          write(6,100) &
            'RotatingCoordinates Dimensional Units:', &
            MassUnitsName(mass), LengthUnitsName(length), &
            TemperatureUnitsName(temp), TimeUnitsName(time), &
            AngleUnitsName(deg)
        endif

! * UserDefinedData
	call cg_nuser_data_f(nuser_data, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,400)'RotatingCoordinates User Data Information:'
	write(6,105) 'No. of UserData=',nuser_data

	do n=1, nuser_data
          call cg_user_data_read_f(n, user_data_name, ier)
          if (ier .eq. ERROR) call cg_error_exit_f
	  write(6,500) ' user_data_name="',user_data_name,'"'
	enddo

! * DataArray_t

	call cg_narrays_f(narrays, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,105) 'RotatingCoordinates contains ', &
                            narrays,' array(s)'
	do iarray=1, narrays
            call cg_goto_f(cg, base, ier, 'RotatingCoordinates_t', &
                           1, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f
            call cg_array_info_f(iarray, name, datatype, &
                               nndim, dim_vals, ier)
            if (ier .eq. ERROR) call cg_error_exit_f
            write(6,600) ' DataArrayName="',name,'"'
            write(6,600) ' DataType="',DataTypeName(datatype),'"'
            write(6,200) ' DataNdim=',nndim
            write(6,200) ' DataDim=',dim_vals(1)
            write(6,105) ' Data:'
            call cg_array_read_f(iarray, data_single, ier)
            if (ier .eq. ERROR) call cg_error_exit_f
            write(6,106) (data_single(n),n=1,dim_vals(1))

! * Descriptor for DataArray_t (RotationCenter & RotationRateVector)
            call cg_goto_f(cg, base, ier, 'RotatingCoordinates_t', 1,  &
                       'DataArray_t', iarray, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_ndescriptors_f(ndescriptors, ier)
            if (ier .eq. ERROR) call cg_error_exit_f
            write(6,400)'Descriptor_t Information:'
            write(6,105) 'No. of descriptors=',ndescriptors

            do idescr=1, ndescriptors
              call cg_descriptor_read_f(idescr, name, text, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              write(6,500) ' DescriptorName="',name,'"', &
                             ' DescriptorText="',text,'"'
            enddo

! * DimensionalUnits for DataArray_t (RotationCenter & RotationRateVector)
            call cg_units_read_f(mass, length, time, temp, deg, ier)
            if (ier .eq. ERROR) call cg_error_exit_f
            if (ier .eq. ALL_OK) then
              write(6,100) &
              'DataArray_t Dimensional Units:', &
              MassUnitsName(mass), LengthUnitsName(length), &
              TemperatureUnitsName(temp), TimeUnitsName(time), &
              AngleUnitsName(deg)
            endif
	    write(6,102) ' '
	enddo

! * Zone

        call cg_nzones_f(cg, base, nzones, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,200)'nzones=',nzones

	zone=1

        call cg_zone_read_f(cg, base, zone, zonename, size, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,104)'Name of Zone',zone,' is "',zonename,'"'

	call cg_zone_type_f(cg, base, zone, zonetype, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,600)'  Zone type is ', ZoneTypeName(zonetype)

      ! *** zone attribute:  GOTO zone node
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

! ***   zone attribute:  Descriptor
	call cg_ndescriptors_f(ndescriptors, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,400)'Zone Descriptor_t Information:'
        write(6,105) 'No. of descriptors=',ndescriptors

	do idescr=1, ndescriptors
          call cg_descriptor_read_f(idescr, name, text, ier)
          if (ier .eq. ERROR) call cg_error_exit_f
          if (ier.eq.ALL_OK) then
            write(6,500)' DescriptorName="',name,'"', &
                        ' DescriptorText="',text,'"'
          endif
	enddo

! *** read RotatingCoordinates_t node
	call cg_rotating_read_f(rot_rate, rot_center, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	write(6,110)'rot_rate=',rot_rate(1), &
                     rot_rate(2), rot_rate(3)
	write(6,110)'rot_center=',rot_center(1), &
                     rot_center(2), rot_center(3)

! *** read children of RotatingCoordinates_t
	call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                       'RotatingCoordinates_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

! * Descriptor
 	call cg_ndescriptors_f(ndescriptors, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
 	write(6,400)'RotatingCoordinates Descriptor_t Information:'
        write(6,105) 'No. of descriptors=',ndescriptors

        do idescr=1, ndescriptors
          call cg_descriptor_read_f(idescr, name, text, ier)
          if (ier .eq. ERROR) call cg_error_exit_f
          write(6,500) ' DescriptorName="',name,'"', &
                       ' DescriptorText="',text,'"'
        enddo

! * DataClass
        call cg_dataclass_read_f(type,ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,600)'DataClassName=',DataClassName(type)

! * DimensionalUnits
        call cg_units_read_f(mass, length, time, temp, deg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        if (ier .eq. ALL_OK) then
          write(6,100) &
            'RotatingCoordinates Dimensional Units:', &
            MassUnitsName(mass), LengthUnitsName(length), &
            TemperatureUnitsName(temp), TimeUnitsName(time), &
            AngleUnitsName(deg)
        endif

! * UserDefinedData
	call cg_nuser_data_f(nuser_data, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,400)'RotatingCoordinates User Data Information:'
	write(6,105) 'No. of UserData=',nuser_data

	do n=1, nuser_data
          call cg_user_data_read_f(n, user_data_name, ier)
          if (ier .eq. ERROR) call cg_error_exit_f
	  write(6,500) ' user_data_name="',user_data_name,'"'
	enddo

! * DataArray_t

	call cg_narrays_f(narrays, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,105) 'RotatingCoordinates contains ', &
                            narrays,' array(s)'
	do iarray=1, narrays
            call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                       'RotatingCoordinates_t', 1, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_array_info_f(iarray, name, datatype, &
                               nndim, dim_vals, ier)
            if (ier .eq. ERROR) call cg_error_exit_f
            write(6,600) ' DataArrayName="',name,'"'
            write(6,600) ' DataType="',DataTypeName(datatype),'"'
            write(6,200) ' DataNdim=',nndim
            write(6,200) ' DataDim=',dim_vals(1)
            write(6,105) ' Data:'
            call cg_array_read_f(iarray, data_single, ier)
            if (ier .eq. ERROR) call cg_error_exit_f
            write(6,106) (data_single(n),n=1,dim_vals(1))

! * Descriptor for DataArray_t (RotationCenter & RotationRateVector)
            call cg_goto_f(cg, base, ier, 'RotatingCoordinates_t', 1,  &
                       'DataArray_t', iarray, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_ndescriptors_f(ndescriptors, ier)
            if (ier .eq. ERROR) call cg_error_exit_f
            write(6,400)'Descriptor_t Information:'
            write(6,105) 'No. of descriptors=',ndescriptors

            do idescr=1, ndescriptors
              call cg_descriptor_read_f(idescr, name, text, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              write(6,500) ' DescriptorName="',name,'"', &
                           ' DescriptorText="',text,'"'
            enddo

! * DimensionalUnits for DataArray_t (RotationCenter & RotationRateVector)
            call cg_units_read_f(mass, length, time, temp, deg, ier)
            if (ier .eq. ERROR) call cg_error_exit_f
            if (ier .eq. ALL_OK) then
              write(6,100) &
              'DataArray_t Dimensional Units:', &
              MassUnitsName(mass), LengthUnitsName(length), &
              TemperatureUnitsName(temp), TimeUnitsName(time), &
              AngleUnitsName(deg)
	      write(6,102) ' '
            endif
	enddo

        call cg_close_f(cg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

 100 	format(a/,'    Mass units: ',a/,'    Length units: ',a/, &
          '    Temperature units: ',a/,'    Time units: ',a/, &
          '    Angle units:',a)
 102 	format(a,f5.3)
 104    format(a,i5,3a)
 105	format(a,i2,a)
 106    format(6f10.3)
 110	format(a,5f5.1)
 200    format(a,i5)
 300	format(3a/a,i2)
 400	format(/a/)
 500	format(3a/3a)
 600	format(3a)

        END PROGRAM read_gravity

MODULE testing_utils

  USE ISO_C_BINDING
  IMPLICIT NONE

  INTEGER, PARAMETER :: TAB_SPACE = 90 ! Tab spacing for printing results

  INTEGER, PARAMETER :: skip   = -1
  INTEGER, PARAMETER :: passed =  0
  INTEGER, PARAMETER :: failed =  1

  !
  ! Contains functions to verify values
  !
  INTERFACE check_eq
     MODULE PROCEDURE c_float_eq, c_double_eq, c_long_eq, c_long_long_eq, character_eq
  END INTERFACE

  PRIVATE c_float_eq, c_double_eq, c_long_eq, c_long_long_eq, character_eq


CONTAINS
  !
  ! Formatting routines for presenting testing results
  !
  SUBROUTINE write_test_header(title_header)

    ! Writes the test header

    IMPLICIT NONE

    CHARACTER(LEN=*), INTENT(IN) :: title_header ! test name
    INTEGER, PARAMETER :: width = TAB_SPACE+10
    CHARACTER(LEN=2*width) :: title_centered
    INTEGER :: len, i

    title_centered(:) = " "

    len=LEN_TRIM(title_header)
    title_centered(1:3) ="| |"
    title_centered((width-len)/2:(width-len)/2+len) = TRIM(title_header)
    title_centered(width-1:width+2) ="| |"

    WRITE(*,'(1X)', ADVANCE="NO")
    DO i = 1, width-1
       WRITE(*,'("_")', ADVANCE="NO")
    ENDDO
    WRITE(*,'()')
    WRITE(*,'("|  ")', ADVANCE="NO")
    DO i = 1, width-5
       WRITE(*,'("_")', ADVANCE="NO")
    ENDDO
    WRITE(*,'("  |")')

    WRITE(*,'("| |")', ADVANCE="NO")
    DO i = 1, width-5
       WRITE(*,'(1X)', ADVANCE="NO")
    ENDDO
    WRITE(*,'("| |")')

    WRITE(*,'(A)') TRIM(title_centered)

    WRITE(*,'("| |")', ADVANCE="NO")
    DO i = 1, width-5
       WRITE(*,'(1X)', ADVANCE="NO")
    ENDDO
    WRITE(*,'("| |")')

    WRITE(*,'("| |")', ADVANCE="NO")
    DO i = 1, width-5
       WRITE(*,'("_")', ADVANCE="NO")
    ENDDO
    WRITE(*,'("| |")')

    WRITE(*,'("|")', ADVANCE="NO")
    DO i = 1, width-1
       WRITE(*,'("_")', ADVANCE="NO")
    ENDDO
    WRITE(*,'("|",/)')

  END SUBROUTINE write_test_header

  SUBROUTINE write_test_status( test_result, test_title, cause)

    ! Writes the results of the tests

    IMPLICIT NONE

    INTEGER, INTENT(IN) :: test_result  ! negative,  --skip --
                                        ! 0       ,   passed
                                        ! positive,   failed

    CHARACTER(LEN=*), INTENT(IN) :: test_title ! Short description of test
    CHARACTER(LEN=*), INTENT(IN), OPTIONAL :: cause ! Print error cause

    ! Controls the output style for reporting test results

    CHARACTER(LEN=8) :: error_string
    CHARACTER(LEN=8), PARAMETER :: passed = ' PASSED '
    CHARACTER(LEN=8), PARAMETER :: failed = '*FAILED*'
    CHARACTER(LEN=8), PARAMETER :: skip    = '--SKIP--'
    CHARACTER(LEN=10) :: FMT

    error_string = failed
    IF (test_result ==  0) THEN
       error_string = passed
    ELSE IF (test_result == -1) THEN
       error_string = skip
    ENDIF
    WRITE(FMT,'("(A,T",I0,",A)")') TAB_SPACE
    WRITE(*, fmt = FMT) test_title, error_string

    IF(PRESENT(cause)) WRITE(*,'(3X,"FAILURE REPORTED --", A)') cause

  END SUBROUTINE write_test_status

  SUBROUTINE write_test_footer()

    ! Writes the test footer

    IMPLICIT NONE
    INTEGER, PARAMETER :: width = TAB_SPACE+10
    INTEGER :: i

    DO i = 1, width
       WRITE(*,'("_")', ADVANCE="NO")
    ENDDO
    WRITE(*,'(/)')

  END SUBROUTINE write_test_footer
!
! Routines for comparing values
!
  LOGICAL FUNCTION c_float_eq(a,b,ulp)
    IMPLICIT NONE
    ! Check if two C_FLOAT reals are equivalent
    REAL*4, INTENT(IN):: a,b
    REAL*4  :: Rel
    INTEGER, OPTIONAL, INTENT(IN)  :: ulp
    Rel = 1.0
    IF ( PRESENT(ulp) ) Rel = REAL( ABS(ulp), KIND(1.0))
    c_float_eq = ABS( a - b ) < ( Rel * SPACING( MAX(ABS(a),ABS(b)) ) )
  END FUNCTION c_float_eq

  LOGICAL FUNCTION c_double_eq(a,b,ulp)
    IMPLICIT NONE
    ! Check if two C_DOUBLE reals are equivalent
    REAL*8, INTENT(IN):: a,b
    REAL*8  :: Rel
    INTEGER, OPTIONAL, INTENT(IN)  :: ulp
    Rel = 1.D0
    IF ( PRESENT(ulp) ) Rel = REAL( ABS(ulp), KIND(1.D0))
    c_double_eq = ABS( a - b ) < ( Rel * SPACING( MAX(ABS(a),ABS(b)) ) )
  END FUNCTION c_double_eq

  LOGICAL FUNCTION c_long_eq(a,b)
    IMPLICIT NONE
    ! Check if two C_LONG integers are equivalent
    INTEGER*4, INTENT(IN):: a,b
    c_long_eq = a-b .EQ. 0
  END FUNCTION c_long_eq

  LOGICAL FUNCTION c_long_long_eq(a,b)
    IMPLICIT NONE
    ! Check if two C_LONG_LONG integers are equivalent
    INTEGER*8, INTENT(IN):: a,b
    c_long_long_eq = a-b .EQ. 0
  END FUNCTION c_long_long_eq

  LOGICAL FUNCTION character_eq(value,correct_value)
    IMPLICIT NONE
    CHARACTER*(*) :: value, correct_value
    character_eq = .FALSE.
    IF (TRIM(value) .EQ. TRIM(correct_value)) THEN
       character_eq = .TRUE.
    ENDIF
  END FUNCTION character_eq

END MODULE testing_utils

MODULE cgns_particle_test

#include "cgnstypes_f03.h"

  USE iso_c_binding
  USE testing_utils
  USE cgns

  IMPLICIT NONE
  !#define CHECK(L,B) if(!(B)){fprintf(stderr,"mismatch in %s\n",L);exit(1);}

  INTEGER, PARAMETER :: sp = SELECTED_REAL_KIND(5)  ! This should map to REAL*4 on most modern processors
  INTEGER, PARAMETER :: dp = SELECTED_REAL_KIND(10) ! This should map to REAL*8 on most modern processors


  !void cgi_error(const char *format, ...);

  ! Define constants
  INTEGER, PARAMETER :: MAX_NAME_LENGTH = 32
  INTEGER, PARAMETER :: NUM_XC = 42
  INTEGER, PARAMETER :: npoly = 16
  INTEGER, PARAMETER :: NUM_FACES = 4
  INTEGER, PARAMETER :: NUM_PARTICLE_TYPES = 3

  ! Define global variables
  REAL(c_double), DIMENSION(NUM_XC) :: xc, yc, zc
  INTEGER(cgsize_t), DIMENSION(:), ALLOCATABLE :: poly
  INTEGER(cgsize_t), DIMENSION(:), ALLOCATABLE :: poly_offsets
  INTEGER :: nface
  INTEGER(cgsize_t), DIMENSION(:), ALLOCATABLE :: face
  INTEGER(cgsize_t), DIMENSION(:), ALLOCATABLE :: face_offsets

CONTAINS

  ! Callback to print errors
  SUBROUTINE print_error(error_code, error_msg) BIND(C)

    IMPLICIT NONE

    INTEGER :: i
    INTEGER(C_INT), VALUE :: error_code
    CHARACTER(LEN=1), DIMENSION(*) :: error_msg
    INTEGER :: eol

    eol = 0
    DO i = 1, 80 !CGIO_MAX_ERROR_LENGTH
       IF(error_msg(i)(1:1).EQ.C_NULL_CHAR) EXIT
       eol = eol + 1
    END DO

    SELECT CASE (error_code)
    CASE (0)
       PRINT *, "Warning: ", error_msg(1:eol)
    CASE (1)
       PRINT *, "Error: ", error_msg(1:eol)
    CASE (-1)
       PRINT *, "Fatal Error: ", error_msg(1:eol)
       !  CALL cgio_cleanup_f()
       STOP 1
    CASE default
       PRINT *, "Unknown error code ", error_code, " encountered. Aborting..."
       !   CALL cgio_cleanup_f()
       STOP 1
    END SELECT

  END SUBROUTINE print_error

  ! This tests MLL functions that handle reading and writing of core particle nodes i.e. ParticleZone_t,
  ! ParticleCoordinates_t, ParticleSolution_t, ParticleIterativeData_t and particle fields i.e. DataArray_t

  SUBROUTINE test_particle_io_main()

    IMPLICIT NONE

    INTEGER fnum, bnum, znum, snum, cnum;
    CHARACTER(LEN=19) :: outfile = "test_particlef.cgns"
    INTEGER :: ier

    REAL, DIMENSION(1:5) :: exp
    DOUBLE PRECISION, DIMENSION(1:1) :: output_time = (/0/)
    DOUBLE PRECISION, DIMENSION(1:1) :: iteration = (/1/)
    INTEGER(cgsize_t) :: length = 1
    INTEGER(cgsize_t), DIMENSION(1:3) :: zone_size
    INTEGER(cgsize_t) :: ne
    INTEGER :: pnum, pcnum
    CHARACTER(LEN=32), DIMENSION(1:3) :: particle_names
    INTEGER(CGSIZE_T), DIMENSION(1:3) :: particle_sizes

    DOUBLE PRECISION, DIMENSION(1:2), TARGET :: water_xc, water_yc, water_zc
    INTEGER :: psolnum ! particle solution index
    TYPE(C_FUNPTR) :: f_funptr

    CHARACTER(LEN=32), PARAMETER :: ParticleSolutionName = "ParticleSolution"
    INTEGER :: ii, jj, kk
    REAL, DIMENSION(1:2), TARGET :: radius = (/0.001, 0.005/)
    REAL, DIMENSION(1:2), TARGET :: temperature = (/275., 298./)
    INTEGER :: fieldnum
    INTEGER :: nparticles = 0
    INTEGER :: iparticle
    CHARACTER(LEN=32) :: pname, fname
    INTEGER(cgsize_t) :: size
    DOUBLE PRECISION :: id, coord_id
    INTEGER :: ncoords
    CHARACTER(LEN=32), DIMENSION(1:3) :: coordnames

    INTEGER(cgenum_t), DIMENSION(1:3) :: datatypes

    INTEGER(CGSIZE_T), DIMENSION(1:2) :: dim = (/32,1/)

    INTEGER(CGSIZE_T), DIMENSION(1:3) :: rmin, rmax
    TYPE(C_PTR) :: f_ptr

    DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE, TARGET :: coord_x, coord_y, coord_z

    INTEGER :: eq_dim, gov_flag, coll, breakup, force, wall_inter, phase_change
    INTEGER(cgenum_t) :: petype, datatype
    INTEGER :: npsols, isol
    DOUBLE PRECISION :: sol_id, field_id
    INTEGER :: nfields, ifield

    REAL, DIMENSION(:), ALLOCATABLE, TARGET :: field


    xc = (/ 0.0d0, 2.0d0, 2.0d0, 0.0d0, 0.0d0, 2.0d0, 2.0d0, 0.0d0, 1.0d0, 1.0d0, 1.0d0, &
         1.0d0, 2.0d0, 1.0d0, 0.0d0, 0.0d0, 2.0d0, 2.0d0, 0.0d0, 1.0d0, 2.0d0, 1.0d0, 0.0d0, &
         1.0d0, 1.0d0, 2.0d0, 1.0d0, 0.0d0, 1.0d0, 1.0d0, &
         1.5d0, 0.5d0, 1.0d0, 1.5d0, 0.5d0, 1.5d0, 0.5d0, &
         0.5d0, 1.5d0, 1.5d0, 0.5d0, &
         1.0d0 /)

    yc = (/ 0.0d0, 0.0d0, 2.0d0, 2.0d0, 0.0d0, 0.0d0, 2.0d0, 2.0d0, 4.0d0, 4.0d0, 2.0d0, &
         0.0d0, 1.0d0, 2.0d0, 1.0d0, 0.0d0, 0.0d0, 2.0d0, 2.0d0, 0.0d0, 1.0d0, 2.0d0, 1.0d0, &
         1.0d0, 0.0d0, 1.0d0, 2.0d0, 1.0d0, 1.0d0, 1.0d0, &
         3.0d0, 3.0d0, 4.0d0, 3.0d0, 3.0d0, 3.0d0, 3.0d0, &
         1.0d0, 1.0d0, 2.0d0, 2.0d0, &
         3.0d0 /)

    zc = (/ 0.0d0, 0.0d0, 0.0d0, 0.0d0, 2.0d0, 2.0d0, 2.0d0, 2.0d0, 0.0d0, 2.0d0, 4.0d0, &
         0.0d0, 0.0d0, 0.0d0, 0.0d0, 1.0d0, 1.0d0, 1.0d0, 1.0d0, 2.0d0, 2.0d0, 2.0d0, 2.0d0, &
         0.0d0, 1.0d0, 1.0d0, 1.0d0, 1.0d0, 2.0d0, 1.0d0, &
         0.0d0, 0.0d0, 1.0d0, 2.0d0, 2.0d0, 1.0d0, 1.0d0, &
         3.0d0, 3.0d0, 3.0d0, 3.0d0, &
         3.0d0 /)

    ALLOCATE(poly(1:56))
    poly(1:56) = (/ 1, 4, 3, 2, 2, 3, 7, 6, 3, 4, 8, 7, 1, 5, 8, 4, 1, 5, 6, 2, 5, 6, 7, 8, 3, 4, 9, &
         8, 7, 10, 3, 9, 10, 7, 4, 8, 10, 9, 5, 6, 11, 6, 7, 11, 7, 8, 11, 5, 11, 8, 7, 10, 11, &
         8, 11, 10 /)

    ALLOCATE(poly_offsets(1:17))
    poly_offsets = (/ 0, 4, 8, 12, 16, 20, 24, 27, 30, 34, 38, 41, 44, 47, 50, 53, 56 /)

    nface = 4
    ALLOCATE(face(1:20))
    face = (/ 1, 2, 3, 4, 5, 6, -3, 7, 8, 9, 10,-6, 11, 12, 13, 14, -8, -13, 15, 16/)

    ALLOCATE(face_offsets(1:5))
    face_offsets = (/0, 6, 11, 16, 20/)

    WRITE(*,'(A)') "creating CGNS file "//outfile

    f_funptr = C_FUNLOC(print_error)

    CALL cg_configure_f(CG_CONFIG_ERROR, f_funptr, ier)

    CALL cg_open_f(outfile, CG_MODE_WRITE, fnum, ier)
    CALL cg_base_write_f(fnum, "Base", 3, 3, bnum, ier)
    CALL cg_goto_f(fnum, bnum, ier, 'end')

    CALL cg_dataclass_write_f(CGNS_ENUMV(NormalizedByDimensional), ier)

    ! Write BaseIterativeData_t so that we can write out ParticleIterativeData_t later on
    CALL cg_goto_f(fnum, bnum, ier, 'end')

    CALL cg_biter_write_f(fnum, bnum, "BaseIterativeData", 1, ier)

    CALL cg_gopath_f(fnum, "./BaseIterativeData", ier)
    CALL cg_array_write_f("TimeValues", CGNS_ENUMV(RealDouble), 1_CGSIZE_T, length, output_time, ier)
    CALL cg_array_write_f("IterationValues", CGNS_ENUMV(INTEGER), 1_CGSIZE_T, length, iteration, ier)

    exp(:) = 0.0
    exp(2) = 1.0

    zone_size(1) = 11
    zone_size(2) = 4
    zone_size(3) = 0

    CALL cg_zone_write_f(fnum, bnum, "Cells", zone_size, CGNS_ENUMV(Unstructured), znum, ier)
    CALL cg_coord_write_f(fnum, bnum, znum, CGNS_ENUMV(RealDouble), "CoordinateX", xc, cnum, ier)
    CALL cg_goto_f(fnum, bnum, ier, "Zone_t", znum, "GridCoordinates", 0, "CoordinateX", 0, "end")
    CALL cg_exponents_write_f(CGNS_ENUMV(RealSingle), exp, ier)
    CALL cg_coord_write_f(fnum, bnum, znum, CGNS_ENUMV(RealDouble), "CoordinateY", yc, cnum, ier)
    CALL cg_gopath_f(fnum, "../CoordinateY",ier)
    CALL cg_exponents_write_f(CGNS_ENUMV(RealSingle), exp, ier)
    CALL cg_coord_write_f(fnum, bnum, znum, CGNS_ENUMV(RealDouble), "CoordinateZ", zc, cnum, ier)
    CALL cg_gopath_f(fnum, "../CoordinateZ", ier)
    CALL cg_exponents_write_f(CGNS_ENUMV(RealSingle), exp, ier)

    ne = 0

    ! NGON_n first so polyhedra face references are correct
    CALL cg_poly_section_write_f(fnum, bnum, znum, "NGON_n", CGNS_ENUMV(NGON_n), &
         ne+1, ne+npoly, 0, poly, poly_offsets, snum, ier)
    ne = ne + npoly

    ! NFACE_n
    CALL cg_poly_section_write_f(fnum, bnum, znum, "NFACE_n", CGNS_ENUMV(NFACE_n), &
         ne+1, ne+nface, 0, face, face_offsets, snum, ier)

    particle_names(1) = "IsoOctane"
    particle_names(2) = "Oil"
    particle_names(3) = "Water"

    particle_sizes(1:3) = (/0, 0, 2/)

    ! Create ParticleZone_t nodes
    ! It is okay to define ParticleZone_t nodes with 0 particles
    ! this implies that for the current solution time, no particles
    ! of said type (IsoOctane and Oil) are in the Base

    CALL cg_particle_write_f(fnum, bnum, "IsoOctane", 0_CGSIZE_T, pnum, ier) ! 0 IsoOctane particles
    CALL cg_particle_write_f(fnum, bnum, "Oil", 0_CGSIZE_T, pnum, ier)       ! 0 Oil particles
    CALL cg_particle_write_f(fnum, bnum, "Water", 2_CGSIZE_T, pnum, ier)     ! 2 Water particles

    ! Write coordinates for the water particle */
    water_xc(1:2) = (/0.7, 0.01/)
    water_yc(1:2) = (/0.8, 0.02/)
    water_zc(1:2) = (/0.9, 0.03/)

    CALL cg_particle_coord_write_f(fnum, bnum, pnum, CGNS_ENUMV(RealDouble), "CoordinateX", C_LOC(water_xc(1)), pcnum, ier)
    CALL cg_particle_coord_write_f(fnum, bnum, pnum, CGNS_ENUMV(RealDouble), "CoordinateY", C_LOC(water_yc(1)), pcnum, ier)
    CALL cg_particle_coord_write_f(fnum, bnum, pnum, CGNS_ENUMV(RealDouble), "CoordinateZ", C_LOC(water_zc(1)), pcnum, ier)

    CALL cg_goto_f(fnum, bnum, ier, "ParticleZone_t", 3, "ParticleCoordinates_t", 1, "end")
    CALL cg_dataclass_write_f(CGNS_ENUMV(Dimensional), ier)
    CALL cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), CGNS_ENUMV(Kelvin), CGNS_ENUMV(Degree), ier)

    DO ii = 1, 3
       CALL cg_goto_f(fnum, bnum, ier, "ParticleZone_t", 3, "ParticleCoordinates_t", 1, "DataArray_t", ii, "end")
       CALL cg_exponents_write_f(CGNS_ENUMV(RealSingle), exp, ier)
    ENDDO

    ! Write particle solution

    CALL cg_particle_sol_write_f(fnum, bnum, pnum, ParticleSolutionName, psolnum, ier)

    CALL cg_particle_field_write_f(fnum, bnum, pnum, psolnum, CGNS_ENUMV(RealSingle), &
         "Radius", C_LOC(radius(1)), fieldnum, ier)
    CALL cg_particle_field_write_f(fnum, bnum, pnum, psolnum, CGNS_ENUMV(RealSingle), &
         "Temperature", C_LOC(temperature(1)), fieldnum, ier)

    ! Write particle iterative data
    CALL cg_piter_write_f(fnum, bnum, pnum, "ParticleIterativeData", ier)
    CALL cg_goto_f(fnum, bnum, ier, "ParticleZone_t", pnum, "end")
    CALL cg_gopath_f(fnum, "./ParticleIterativeData", ier)

    CALL cg_array_write_f("ParticleSolutionPointers",  CGNS_ENUMT(Character), 2_CGSIZE_T, dim, ParticleSolutionName, ier)

    ! Write particle governing equations and models
    CALL cg_goto_f(fnum, bnum, ier, "ParticleZone_t", pnum, "end")
    CALL cg_particle_equationset_write_f(3, ier)
    CALL cg_gopath_f(fnum, "./ParticleEquationSet", ier)
    CALL cg_particle_governing_write_f(CGNS_ENUMV(DEM), ier)

    CALL cg_particle_model_write_f("ParticleCollisionModel_t", CGNS_ENUMV(SoftSphere), ier)
    CALL cg_particle_model_write_f("ParticleBreakupModel_t", CGNS_ENUMV(RayleighTaylor), ier)
    CALL cg_particle_model_write_f("ParticleForceModel_t", CGNS_ENUMV(Gidaspow), ier)
    CALL cg_particle_model_write_f("ParticleWallInteractionModel_t", CGNS_ENUMV(BaiGosman), ier)
    CALL cg_particle_model_write_f("ParticlePhaseChangeModel_t", CGNS_ENUMV(Boil), ier)

    CALL cg_close_f(fnum, ier)

    ! Reopen the file and verify that the particle data matches what we wrote in

    CALL cg_open_f(outfile, CG_MODE_READ, fnum, ier)

    CALL cg_nbases_f(fnum, bnum, ier)

    CALL cg_nparticle_zones_f(fnum, bnum, nparticles, ier)

    IF(nparticles .NE. 3)THEN
       WRITE(*,'(A,I0,A)')"Expected 3 ParticleZone_t nodes but found ", nparticles, " ParticleZone_t nodes instead"
       CALL cg_error_exit_f
    ENDIF

    DO iparticle = 1, nparticles

       CALL cg_particle_read_f(fnum, bnum, iparticle, pname, size, ier)
       CALL cg_particle_id_f(fnum, bnum, iparticle, id, ier)

       IF(.NOT.check_eq(particle_names(iparticle),pname))THEN
          WRITE(*,'(A)') "Expected "//TRIM(particle_names(iparticle))//" as the ParticleZone_t node name but found " &
               //TRIM(pname)//" instead"
          CALL cg_error_exit_f()
       END IF

       IF(.NOT.check_eq(size, particle_sizes(iparticle)))THEN
          WRITE(*,'(A, I0, A, I0, A)') "Expected ", particle_sizes(iparticle)," as the ParticleZone_t node size but found",&
               size, " instead"
          CALL cg_error_exit_f()
       END IF

       ! Check to see if we have coordinates
       CALL cg_particle_ncoords_f(fnum, bnum, iparticle, ncoords, ier)
       IF(ncoords .NE. 3) CYCLE

       ! Since we wrote out coordinates for water alone, verify that they match
       DO jj = 1, ncoords
          CALL cg_particle_coord_id_f(fnum, bnum, iparticle, jj, coord_id, ier)
          CALL cg_particle_coord_info_f(fnum, bnum, iparticle, jj, datatypes(jj), coordnames(jj), ier)
       ENDDO

       rmin = 1
       rmax = size
       ALLOCATE(coord_x(1:size), coord_y(1:size), coord_z(1:size))

       f_ptr = C_LOC(coord_x(1))
       CALL cg_particle_coord_read_f(fnum, bnum, iparticle, coordnames(1), datatypes(1), rmin, rmax, f_ptr, ier)
       f_ptr = C_LOC(coord_y(1))
       CALL cg_particle_coord_read_f(fnum, bnum, iparticle, coordnames(2), datatypes(2), rmin, rmax, f_ptr, ier)
       f_ptr = C_LOC(coord_z(1))
       CALL cg_particle_coord_read_f(fnum, bnum, iparticle, coordnames(3), datatypes(3), rmin, rmax, f_ptr, ier)

       DO kk = 1, size
          IF(.NOT.check_eq(coord_x(kk), water_xc(kk)) .OR. &
               .NOT.check_eq(coord_y(kk), water_yc(kk)) .OR. &
               .NOT.check_eq(coord_z(kk), water_zc(kk)) ) THEN
             WRITE(*,'(A)') "Invalid particle coordinate data - written value doesn't match the read value"
             CALL cg_error_exit_f()
          ENDIF
       ENDDO
       DEALLOCATE(coord_x, coord_y, coord_z)

       CALL cg_goto_f(fnum, bnum, ier, "ParticleZone_t", iparticle, "end")

       CALL cg_particle_equationset_read_f(eq_dim, gov_flag, coll, breakup, force, wall_inter, phase_change, ier)


       IF(eq_dim .NE. 3)THEN
          WRITE(*,'(A,I0,A)') "Expected particle equation dimension of 3 but found ", eq_dim, " instead"
          CALL cg_error_exit_f()
       ENDIF

       IF(gov_flag .NE. 1)THEN
          WRITE(*,'(A)') "Particle governing equations cannot be found"
          CALL cg_error_exit_f()
       ELSE
          CALL cg_gopath_f(fnum, "./ParticleEquationSet", ier)
          CALL cg_particle_governing_read_f(petype, ier)
          IF(petype .NE. CGNS_ENUMV(DEM))THEN
             WRITE(*,'(A)') "Invalid particle governing equation type"
             CALL cg_error_exit_f()
          ENDIF
       ENDIF

       ! Read solution data
       CALL cg_particle_nsols_f(fnum, bnum, iparticle, npsols, ier)
       IF(npsols .NE. psolnum)THEN
          WRITE(*,'(A,I0,A,I0,A)') "For ParticleZone_t ", iparticle, " expected ", &
               psolnum," ParticleSolution_t node(s) but found ",npsols," instead"
          CALL cg_error_exit_f()
       ENDIF

       DO isol = 1, npsols
          CALL cg_particle_sol_id_f(fnum, bnum, iparticle, isol, sol_id, ier)

          CALL cg_particle_nfields_f(fnum, bnum, iparticle, isol, nfields, ier)
          IF(nfields .NE. fieldnum)THEN
             WRITE(*,'(A,I0,A,I0,A)') "For ParticleZone_t ",iparticle," > ParticleSolution_t ", psolnum, &
                  " expected ", fieldnum," DataArray_t node(s) but found ", nfields," instead"
             CALL cg_error_exit_f()
          ENDIF

          DO ifield = 1, nfields

             CALL cg_particle_field_id_f(fnum, bnum, iparticle, isol, ifield, field_id, ier)

             CALL cg_particle_field_info_f(fnum, bnum, iparticle, isol, ifield, datatype, fname, ier)

             rmin = 1
             rmax = size
             ALLOCATE(field(1:size))
             f_ptr = C_LOC(field(1))
             CALL cg_particle_field_read_f(fnum, bnum, iparticle, isol, fname, datatype, rmin, rmax, f_ptr, ier)

             IF(ifield.EQ.1)THEN
                PRINT*,field(1),radius(1)
                IF(field(1).NE.radius(1))THEN
                   CALL cg_error_exit_f()
                ENDIF
             ELSE
                IF(field(1).NE.temperature(1))THEN
                   CALL cg_error_exit_f()
                ENDIF
             ENDIF
             DEALLOCATE(field)
          ENDDO
       ENDDO
    ENDDO

    CALL cg_close_f(fnum, ier)

  END SUBROUTINE test_particle_io_main

  SUBROUTINE test_particle_io_partial()

    IMPLICIT NONE

    INTEGER :: fnum, bnum, pnum, cgcoord, cgsol
    CHARACTER(LEN=27) :: fname = "particle_partial_testf.cgns"
    INTEGER(cgsize_t) :: num_particles = 100
    INTEGER :: n, k, i
    INTEGER :: ier
    REAL, DIMENSION(:), ALLOCATABLE, TARGET :: coord, coord_read
    INTEGER(cgsize_t), DIMENSION(1:3) :: rmin, rmax
    INTEGER :: cgfld
    CHARACTER(LEN=32) :: field_name
    INTEGER(cgenum_t) :: type
    REAL, DIMENSION(:), ALLOCATABLE, TARGET :: field
    TYPE(C_PTR) :: f_ptr

    ! Allocate arrays
    ALLOCATE(coord(1:num_particles))
    DO n = 1, num_particles
       coord(n) = REAL(n)
    END DO

    ! Delete existing file if present
    OPEN(10, FILE=fname, STATUS='OLD', IOSTAT=ier)
    IF(ier == 0) THEN
       CLOSE(10, STATUS='DELETE')
    END IF

    WRITE(*,'(A)') "creating CGNS file "//TRIM(fname)

    ! Configure error handler
    CALL cg_configure_f(CG_CONFIG_ERROR, C_FUNLOC(print_error), ier)

    ! Create file and write base
    CALL cg_open_f(fname, CG_MODE_WRITE, fnum, ier)
    CALL cg_base_write_f(fnum, "Base", 3, 3, bnum, ier)

    WRITE(*,*) "writing particle zone"
    CALL cg_particle_write_f(fnum, bnum, "ParticleZone", num_particles, pnum, ier)

    ! Write coordinates for odd numbered particles
    WRITE(*,*) "coordinates -> 1,3,5,7 ..."
    DO k = 1, num_particles, 2
       rmin = k
       rmax = k
       f_ptr = C_LOC(coord(k))
       CALL cg_particle_coord_partial_write_f(fnum, bnum, pnum, CGNS_ENUMV(RealSingle), &
            "CoordinateX", rmin, rmax, f_ptr, cgcoord, ier)
       f_ptr = C_LOC(coord(k))
       CALL cg_particle_coord_partial_write_f(fnum, bnum, pnum, CGNS_ENUMV(RealSingle), &
            "CoordinateY", rmin, rmax, f_ptr, cgcoord, ier)
       f_ptr = C_LOC(coord(k))
       CALL cg_particle_coord_partial_write_f(fnum, bnum, pnum, CGNS_ENUMV(RealSingle), &
            "CoordinateZ", rmin, rmax, f_ptr, cgcoord, ier)
    END DO

    ! Write solution
    CALL cg_particle_sol_write_f(fnum, bnum, pnum, "Solution", cgsol, ier)
    IF(ier .NE. 0) CALL cg_error_exit_f()

    ! Write field data for odd numbered particles
    WRITE(*,'(A)') "field -> 1,3,5,7 ..."
    DO n = 1, num_particles, 2
       rmin = n
       rmax = n
       f_ptr = C_LOC(coord(n))
       CALL cg_particle_field_partial_write_f(fnum, bnum, pnum, cgsol, CGNS_ENUMV(RealSingle), &
            "Field", rmin, rmax, f_ptr, cgfld, ier)
    END DO

    ! Close and reopen in modify mode
    WRITE(*,*) "closing and reopening in modify mode"
    CALL cg_close_f(fnum, ier)
    CALL cg_open_f(fname, CG_MODE_MODIFY, fnum, ier)
    pnum = 1

    ! Fill in even numbered particles
    WRITE(*,*) "coordinates -> 2,4,6,8 ..."
    DO k = 1, num_particles-1, 2
       rmin = k + 1
       rmax = k + 1
       f_ptr = C_LOC(coord(k+1))
       CALL cg_particle_coord_partial_write_f(fnum, bnum, pnum, CGNS_ENUMV(RealSingle), &
            "CoordinateX", rmin, rmax, f_ptr, cgcoord, ier)
       f_ptr = C_LOC(coord(k+1))
       CALL cg_particle_coord_partial_write_f(fnum, bnum, pnum, CGNS_ENUMV(RealSingle), &
            "CoordinateY", rmin, rmax, f_ptr, cgcoord, ier)
       f_ptr = C_LOC(coord(k+1))
       CALL cg_particle_coord_partial_write_f(fnum, bnum, pnum, CGNS_ENUMV(RealSingle), &
            "CoordinateZ", rmin, rmax, f_ptr, cgcoord, ier)
    END DO

    ! Fill in field data for even numbered particles
    WRITE(*,*) "field -> 2,4,6,8 ..."
    DO n = 1, num_particles-1, 2
       rmin = n + 1
       rmax = n + 1
       f_ptr = C_LOC(coord(n+1))
       CALL cg_particle_field_partial_write_f(fnum, bnum, pnum, cgsol, CGNS_ENUMV(RealSingle), &
            "Field", rmin, rmax, f_ptr, cgfld, ier)
    END DO

    ! Close and reopen in read mode
    WRITE(*,*) "closing and reopening in read mode" 
    CALL cg_close_f(fnum, ier)

    CALL cg_open_f(fname, CG_MODE_READ, fnum, ier)

    ! Verify data
    ALLOCATE(coord_read(num_particles))
    coord_read = -1.0
    rmin = 1
    rmax = num_particles

    ! Read and verify coordinates
    f_ptr = C_LOC(coord_read(1))
    CALL cg_particle_coord_read_f(fnum, bnum, pnum, "CoordinateX", CGNS_ENUMV(RealSingle), &
         rmin, rmax, f_ptr, ier)

    DO i = 1, rmax(1)-1
       IF(.NOT. check_eq(coord(i), coord_read(i))) THEN
          WRITE(*,*) "Particle partial coordinate write (CoordinateX) failed"
          CALL cg_error_exit_f()
       END IF
    END DO

    coord_read = -1.0
    f_ptr = C_LOC(coord_read(1))
    CALL cg_particle_coord_read_f(fnum, bnum, pnum, "CoordinateY", CGNS_ENUMV(RealSingle), &
         rmin, rmax, f_ptr, ier)
    DO i = 1, rmax(1)-1
       IF(.NOT. check_eq(coord(i), coord_read(i))) THEN
          WRITE(*,*) "Particle partial coordinate write (CoordinateY) failed"
          CALL cg_error_exit_f()
       END IF
    END DO

    coord_read = -1.0
    f_ptr = C_LOC(coord_read(1))
    CALL cg_particle_coord_read_f(fnum, bnum, pnum, "CoordinateZ", CGNS_ENUMV(RealSingle), &
         rmin, rmax, f_ptr, ier)
    DO i = 1, rmax(1)-1
       IF(.NOT. check_eq(coord(i), coord_read(i))) THEN
          WRITE(*,*) "Particle partial coordinate write (CoordinateZ) failed"
          CALL cg_error_exit_f()
       END IF
    END DO

    DEALLOCATE(coord_read)

    ! Verify field data
    CALL cg_particle_field_info_f(fnum, bnum, pnum, 1, 1, type, field_name, ier)

    ALLOCATE(field(num_particles))
    f_ptr = C_LOC(field(1))
    CALL cg_particle_field_read_f(fnum, bnum, pnum, 1, field_name, type, rmin, rmax, f_ptr, ier)

    DO i = 1, rmax(1)-1
       IF(.NOT. check_eq(coord(i), field(i))) THEN
          WRITE(*,*) "Particle partial field write failed"
          CALL cg_error_exit_f()
       END IF
    END DO

    DEALLOCATE(field)
    DEALLOCATE(coord)

    CALL cg_close_f(fnum, ier)

  END SUBROUTINE test_particle_io_partial

  SUBROUTINE test_particle_bbox()
    IMPLICIT NONE

    INTEGER :: ier, fnum, bnum, pnum, cgcoord
    CHARACTER(LEN=19) :: fname = "particle_bboxf.cgns"
    DOUBLE PRECISION, DIMENSION(1:2,1:3), TARGET :: bbox
    INTEGER(cgsize_t) :: num_particles = 10
    INTEGER :: n
    REAL, DIMENSION(:), ALLOCATABLE, TARGET :: coord
    REAL, DIMENSION(1:2,1:3), TARGET :: bbox_float
    TYPE(C_PTR) :: f_ptr

    ! Allocate and initialize coord array
    ALLOCATE(coord(1:num_particles))
    DO n = 1, num_particles
       coord(n) = REAL(n-1)
    END DO

    ! Delete existing file if present
    OPEN(10, FILE=fname, STATUS='OLD', IOSTAT=ier)
    IF(ier == 0) THEN
       CLOSE(10, STATUS='DELETE')
    END IF

    WRITE(*,'(A)') "creating CGNS file "//TRIM(fname)

    CALL cg_configure_f(CG_CONFIG_ERROR, C_FUNLOC(print_error), ier)

    CALL cg_open_f(fname, CG_MODE_WRITE, fnum, ier)
    CALL cg_base_write_f(fnum, "Base", 3, 3, bnum, ier)

    WRITE(*,*) "writing particle zone"

    CALL cg_particle_write_f(fnum, bnum, "ParticleZone", num_particles, pnum, ier)
    f_ptr = C_LOC(coord(1))
    CALL cg_particle_coord_write_f(fnum, bnum, pnum, CGNS_ENUMV(RealSingle), "CoordinateX", f_ptr, cgcoord, ier)
    f_ptr = C_LOC(coord(1))
    CALL cg_particle_coord_write_f(fnum, bnum, pnum, CGNS_ENUMV(RealSingle), "CoordinateY", f_ptr, cgcoord, ier)
    f_ptr = C_LOC(coord(1))
    CALL cg_particle_coord_write_f(fnum, bnum, pnum, CGNS_ENUMV(RealSingle), "CoordinateZ", f_ptr, cgcoord, ier)

    WRITE(*,*) "closing and reopening in read mode"
    CALL cg_close_f(fnum, ier)
    ! Read file
    CALL cg_open_f(fname, CG_MODE_READ, fnum, ier)
    bnum = 1
    pnum = 1

    bbox(1,:) =  1.D0
    bbox(2,:) = -1.D0
    ! Check bounding box is not modified
    f_ptr = C_LOC(bbox(1,1))
    CALL cg_particle_bounding_box_read_f(fnum, bnum, pnum, 1, CGNS_ENUMV(RealDouble), f_ptr, ier)
    IF (ier .NE. CG_NODE_NOT_FOUND) CALL cg_error_exit_f()

    IF (.NOT. check_eq(bbox(2,1), -1.D0)) THEN
       WRITE(*,*) "Unmodified bounding box data when missing data in ParticleCoordinates node"
       CALL cg_error_exit_f()
    END IF
    IF (.NOT. check_eq(bbox(1,1), 1.D0)) THEN
       WRITE(*,*) "Unmodified bounding box data when missing data in ParticleCoordinates node"
       CALL cg_error_exit_f()
    END IF

    WRITE(*,*) "closing and reopening in modify mode"
    CALL cg_close_f(fnum, ier)

    CALL cg_open_f(fname, CG_MODE_MODIFY, fnum, ier)
    bnum = 1
    pnum = 1

    bbox(1,:) = 0.D0
    bbox(2,:) = REAL(num_particles - 1, KIND(1.D0))

    f_ptr = C_LOC(bbox(1,1))
    CALL cg_particle_bounding_box_write_f(fnum, bnum, pnum, 1, CGNS_ENUMV(RealDouble), f_ptr, ier)

    WRITE(*,*) "closing and reopening in read mode"
    CALL cg_close_f(fnum, ier)

    CALL cg_open_f(fname, CG_MODE_READ, fnum, ier)
    bnum = 1
    pnum = 1

    bbox(1,:) = 1.D0
    bbox(2,:) = -1.D0

    f_ptr = C_LOC(bbox(1,1))
    CALL cg_particle_bounding_box_read_f(fnum, bnum, pnum, 1, CGNS_ENUMV(RealDouble), f_ptr, ier)

    IF (.NOT. check_eq(bbox(1,1), 0.D0)) THEN
       WRITE(*,*) "Read bounding box failed"
       CALL cg_error_exit_f()
    END IF
    IF (.NOT. check_eq(bbox(2,1), REAL(num_particles - 1, KIND(1.D0)))) THEN
       WRITE(*,*) "Read bounding box failed"
       CALL cg_error_exit_f()
    END IF
    ! Check datatype conversion
    bbox_float(1,:) = 1.0
    bbox_float(2,:) = -1.0
    f_ptr = C_LOC(bbox_float(1,1))
    CALL cg_particle_bounding_box_read_f(fnum, bnum, pnum, 1, CGNS_ENUMV(RealSingle), f_ptr, ier)

    IF (.NOT. check_eq(bbox_float(1,1), 0.0)) THEN
       WRITE(*,*) "Read bounding box failed"
       CALL cg_error_exit_f()
    END IF
    IF (.NOT. check_eq(bbox_float(2,1), REAL(num_particles - 1))) THEN
       WRITE(*,*) "Read bounding box failed"
       CALL cg_error_exit_f()
    END IF

    WRITE(*,*) "closing and reopening to test limit cases"
    CALL cg_close_f(fnum, ier)

    CALL cg_open_f(fname, CG_MODE_MODIFY, fnum, ier)
    bnum = 1
    pnum = 1

    ! Writing integer type should fail
    f_ptr = C_LOC(bbox(1,1))
    CALL cg_particle_bounding_box_write_f(fnum, bnum, pnum, 1, CGNS_ENUMV(INTEGER), f_ptr, ier)
    IF (ier == 0) THEN
       WRITE(*,*) "writing Integer bounding box data failed to produce error"
       CALL cg_error_exit_f()
    END IF

    ! Reset error state
    ! CALL cgi_error_f("no CGNS error reported")

    DEALLOCATE(coord)

    WRITE(*,*) "closing file"
    CALL cg_close_f(fnum, ier)

  END SUBROUTINE test_particle_bbox

  SUBROUTINE test_particle_coord_io_and_ptset()

    IMPLICIT NONE

    INTEGER :: fnum, bnum, pnum, cgcoord
    CHARACTER(LEN=35) :: fname = "particle_coord_and_ptset_testf.cgns"
    INTEGER(cgsize_t), DIMENSION(1:1) :: num_particles = (/100/)
    INTEGER :: n, i, j
    REAL, DIMENSION(:), ALLOCATABLE, TARGET :: coord, DATA
    INTEGER :: snum, field
    INTEGER(cgsize_t), DIMENSION(2) :: pnts = (/1, 10/)
    INTEGER(cgsize_t), DIMENSION(:), ALLOCATABLE, TARGET :: pnts_list, pnts_read
    INTEGER :: ncoord_nodes
    CHARACTER(LEN=32) :: coordname
    INTEGER(cgenum_t) :: ptset_type
    INTEGER(cgsize_t) :: npnts, sol_size
    INTEGER(cgsize_t), DIMENSION(1:3) :: rmin, rmax
    CHARACTER(LEN=32) :: field_name
    INTEGER :: ier
    TYPE(C_PTR) :: f_ptr

    ! Allocate and initialize coord array
    ALLOCATE(coord(1:num_particles(1)))
    DO n = 1, num_particles(1)
       coord(n) = REAL(n)
    END DO

    ! Delete existing file if present
    OPEN(10, FILE=fname, STATUS='OLD', IOSTAT=i)
    IF(i == 0) THEN
       CLOSE(10, STATUS='DELETE')
    END IF

    WRITE(*,*) "creating CGNS file ", TRIM(fname)

    CALL cg_configure_f(CG_CONFIG_ERROR, C_FUNLOC(print_error), ier)

    CALL cg_open_f(fname, CG_MODE_WRITE, fnum, ier)
    CALL cg_base_write_f(fnum, "Base", 3, 3, bnum, ier)

    WRITE(*,*) "writing particle zone"
    CALL cg_particle_write_f(fnum, bnum, "ParticleZone", num_particles(1), pnum, ier)

    WRITE(*,*) "writing coordinate nodes"

    CALL cg_particle_coord_node_write_f(fnum, bnum, pnum, "ParticleCoordinates", cgcoord, ier)
    CALL cg_goto_f(fnum, bnum, ier, "ParticleZone_t", pnum, "ParticleCoordinates_t", cgcoord, "end")
    CALL cg_array_write_f("CoordinateX", CGNS_ENUMV(RealSingle), 1_CGSIZE_T, num_particles, coord, ier)
    CALL cg_array_write_f("CoordinateY", CGNS_ENUMV(RealSingle), 1_CGSIZE_T, num_particles, coord, ier)
    CALL cg_array_write_f("CoordinateZ", CGNS_ENUMV(RealSingle), 1_CGSIZE_T, num_particles, coord, ier)

    CALL cg_particle_sol_ptset_write_f(fnum, bnum, pnum, "Solution 1", CGNS_ENUMV(PointRange), 2_CGSIZE_T, pnts, snum, ier)
    f_ptr = C_LOC(coord)
    CALL cg_particle_field_write_f(fnum, bnum, pnum, snum, CGNS_ENUMV(RealSingle), "Field", f_ptr, field, ier)
    ALLOCATE(pnts_list(num_particles(1)))
    DO n = 1, num_particles(1)
       pnts_list(n) = n
    END DO

    CALL cg_particle_sol_ptset_write_f(fnum, bnum, pnum, "Solution 2", CGNS_ENUMV(PointList), num_particles(1), pnts_list, snum, ier)
    f_ptr = C_LOC(coord)
    CALL cg_particle_field_write_f(fnum, bnum, pnum, snum, CGNS_ENUMV(RealSingle), "Field", f_ptr, field, ier)

    DEALLOCATE(pnts_list)

    WRITE(*,*) "closing and reopening in read mode"
    CALL cg_close_f(fnum, ier)

    CALL cg_open_f(fname, CG_MODE_READ, fnum, ier)

    ! Verify coordinate count
    CALL cg_particle_ncoord_nodes_f(fnum, bnum, pnum, ncoord_nodes, ier)

    DO i = 1, ncoord_nodes
       CALL cg_particle_coord_node_read_f(fnum, bnum, pnum, i, coordname, ier)

       IF (.NOT.check_eq(coordname,"ParticleCoordinates")) THEN
          WRITE(*,*) "Invalid coordinate name"
          CALL cg_error_exit_f()
       END IF
    END DO

    ! Read and verify PointRange solution
    snum = 1
    CALL cg_particle_sol_ptset_info_f(fnum, bnum, pnum, snum, ptset_type, npnts, ier)

    IF (ptset_type .NE. CGNS_ENUMV(PointRange)) THEN
       WRITE(*,*) "Particle solution point set type mismatch"
       CALL cg_error_exit_f()
    END IF

    IF (npnts .NE. 2) THEN
       WRITE(*,*) "Particle solution point set size mismatch"
       CALL cg_error_exit_f()
    END IF

    ALLOCATE(pnts_read(1:npnts))
    CALL cg_particle_sol_ptset_read_f(fnum, bnum, pnum, snum, pnts_read, ier)

    CALL cg_particle_sol_size_f(fnum, bnum, pnum, snum, sol_size, ier)
    IF (sol_size .NE. pnts_read(2) - pnts_read(1) + 1) THEN
       WRITE(*,*) "Particle sol size mismatch"
       CALL cg_error_exit_f()
    END IF

    ! Read and verify field data for PointRange
    rmin(1) = 1
    rmax(1) = pnts_read(2) - pnts_read(1) + 1
    ALLOCATE(DATA(sol_size))
    f_ptr = C_LOC(data)
    CALL cg_particle_field_read_f(fnum, bnum, pnum, snum, "Field", CGNS_ENUMV(RealSingle), rmin, rmax, f_ptr, ier)

    DO i = pnts_read(1), pnts_read(2)
       j = i - pnts_read(1) + 1
       IF (.NOT. check_eq(coord(i), DATA(j))) THEN
          WRITE(*,*) "Particle field data mismatch"
          CALL cg_error_exit_f()
       END IF
    END DO

    DEALLOCATE(DATA)
    DEALLOCATE(pnts_read)

    ! Read and verify PointList solution
    snum = 2
    CALL cg_particle_sol_ptset_info_f(fnum, bnum, pnum, snum, ptset_type, npnts, ier)

    IF (ptset_type .NE. CGNS_ENUMV(PointList)) THEN
       WRITE(*,*) "Particle solution point set type mismatch"
       CALL cg_error_exit_f()
    END IF

    IF (npnts .NE. num_particles(1)) THEN
       WRITE(*,*) "Particle solution point set size mismatch"
       CALL cg_error_exit_f()
    END IF

    ALLOCATE(pnts_read(npnts))
    CALL cg_particle_sol_ptset_read_f(fnum, bnum, pnum, snum, pnts_read, ier)

    CALL cg_particle_sol_size_f(fnum, bnum, pnum, snum, sol_size, ier)
    IF (sol_size .NE. npnts) THEN
       WRITE(*,*) "Particle sol size mismatch"
       CALL cg_error_exit_f()
    END IF

    ! Read and verify field data for PointList
    rmin(1) = 1
    rmax(1) = npnts
    ALLOCATE(DATA(sol_size))
    f_ptr = C_LOC(data(1))
    CALL cg_particle_field_read_f(fnum, bnum, pnum, snum, "Field", CGNS_ENUMV(RealSingle), rmin, rmax, f_ptr, ier)

    DO i = 1, npnts
       IF (.NOT. check_eq(coord(pnts_read(i)), DATA(i))) THEN
          WRITE(*,*) "Particle field data mismatch"
          CALL cg_error_exit_f()
       END IF
    END DO

    DEALLOCATE(DATA)
    DEALLOCATE(pnts_read)
    DEALLOCATE(coord)

    CALL cg_close_f(fnum, ier)
  END SUBROUTINE test_particle_coord_io_and_ptset

END MODULE cgns_particle_test

PROGRAM main

  USE cgns_particle_test

  ! These tests should cover all serial MLL functions related to particles
  ! that were added as a part of CPEX 0046 (V4.5)

  CALL test_particle_io_main()
  CALL test_particle_io_partial()
  CALL test_particle_bbox()
  CALL test_particle_coord_io_and_ptset()

  WRITE(*,"(A)") "All particle tests completed successfully"

END PROGRAM main

	program delete_cprop
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on August 2002

!       This example test deleting the GridConnectivityProperty_t data structure and its children
!       It tests cg_delete for the following nodes:
!       - child of GridConnectivity_t: GridConnectivityProperty_t
!       - children of GridConnectivityProperty_t: AverageInterface_t, Periodic_t, Descriptor_t, UserDef._t
!       - children of AverageInterface_t: AverageInterfaceType_t, Descriptor_t, UserDef._t
!       - children of Periodic_t: PeriodicType_t, RotationCenter, RotationAngle, Translation,
!				  Descriptor_t, UserDef._t

#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 3)
	integer index_dim, cell_dim, phys_dim
	character*100 linkpath

	integer cg, base, zone, conn, ier, size(Ndim*3), i, num
	integer AverageInterfaceType, pnts(Ndim,2), nbases, n
	character*32 RegionName32, basename, dummy
	real *4 version, Translation(Ndim)
	real *4 RotationCenter(Ndim), RotationAngle(Ndim)
	integer dim_vals(2)
	

! *** initialize
	ier = 0
	index_dim=Ndim
	cell_dim=Ndim
	phys_dim=Ndim

! *** open CGNS file for writing
 	call cg_open_f('Test_V2', MODE_MODIFY, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,600)'MODIFYING FILE Test_V2'

! *** CGNS Library Version used for file creation:
        call cg_version_f(cg, version, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,102)
     &     'Library Version used for file creation:',version

! *** base
	call cg_nbases_f(cg, nbases, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,200)'nbases=',nbases

	base=1

        call cg_base_read_f(cg, base, basename, cell_dim, phys_dim, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,300)'BaseName = "',basename,'"',
     &                'cell_dimension=',cell_dim

	zone = 1
	conn = 2

! *** delete children of DataArray_t "RotationCenter"
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
        call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &	    'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn,
     &      'GridConnectivityProperty_t', 1, 'Periodic_t', 1,
     &	    'DataArray_t', 1, 'end')

        if (ier. eq. ALL_OK) then
            call cg_delete_node_f('DataClass', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_delete_node_f('DimensionalUnits', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

            write(6,*) 'Children of RotationCenter deleted.  Continue?'
	    read(5,600) dummy
        endif

! *** delete children of Periodic_t: RotationCenter, RotationAngle,
!     Translation, Descriptor_t, UserDef._t, DataClass, DimensionalUnits
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
        call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &      'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn,
     &      'GridConnectivityProperty_t', 1, 'Periodic_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        if (ier. eq. ALL_OK) then
!           RotationCenter, RotationAngle, Translation can't be deleted,
!           so we expect an error from the API
            call cg_delete_node_f('RotationCenter', ier)
            if (ier .eq. ERROR) call cg_error_print_f

            call cg_delete_node_f('RotationAngle', ier)
            if (ier .eq. ERROR) call cg_error_print_f

            call cg_delete_node_f('Translation',ier)
            if (ier .eq. ERROR) call cg_error_print_f

            call cg_delete_node_f('PeriodicDescriptorName', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_delete_node_f('PeriodicUserData', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

	    call cg_delete_node_f('DataClass', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_delete_node_f('DimensionalUnits', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

	    write(6,*) 'Children of Periodic deleted.  Continue?'
            read(5,600) dummy
        endif

! *** delete children of AverageInterface_t: AverageInterfaceType_t, Descriptor_t, UserDef._t
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
        call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &      'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn,
     &      'GridConnectivityProperty_t', 1, 'AverageInterface_t', 1,
     &	    'end')

        if (ier. eq. ALL_OK) then
            call cg_delete_node_f('AverageInterfaceType', ier)
            if (ier .eq. ERROR) call cg_error_print_f

            call cg_delete_node_f('AverageInterfaceDescriptorName', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_delete_node_f('AverageInterfaceUserData', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

	    write(6,*)'Children of AverageInterface deleted.  Continue?'
            read(5,600) dummy
        endif

! *** delete children of GridConnectivityProperty_t: AverageInterface_t,
!	Periodic_t, Descriptor_t, UserDef._t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &      'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn,
     &      'GridConnectivityProperty_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

	if (ier .eq. ALL_OK) then
            call cg_delete_node_f('AverageInterface', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_delete_node_f('Periodic', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_delete_node_f('GridConnPropDescriptorName', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_delete_node_f('GridConnPropUserData', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	    write(6,*)'Children of GridConnProperty deleted.  Continue?'
            read(5,600) dummy
	endif

! *** delete child of GridConnectivity_:  GridConnectivityProperty_t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &      'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn,
     &	    'end')
	if (ier .eq. ERROR) call cg_error_exit_f

	if (ier .eq. ALL_OK) then
            call cg_delete_node_f('GridConnectivityProperty', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

	    write(6,*) 'GridConnectivityProperty deleted.  Continue?'
	    read(5,600) dummy
	endif

! Rewrite everything back

! *** write GridConnectivityProperty_t/AverageInterface_t node under conn#2
        AverageInterfaceType = AverageCircumferential
        call cg_conn_average_write_f(cg, base, zone,
     &        conn, AverageInterfaceType, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! *** write GridConnectivityProperty_t/Periodic_t node under conn#2
        do n=1, Ndim
            RotationCenter(n) = n*1.1
            RotationAngle(n) = (n+3)*1.1
            Translation(n) = (n+6)*1.1
        enddo
        call cg_conn_periodic_write_f(cg, base, zone, conn,
     &       RotationCenter, RotationAngle, Translation, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! *** write Descriptor_t, UserDefinedData_t & Link under...
! ...   GridConnectivityProperty_t
       call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &      'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn,
     &      'GridConnectivityProperty_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_descriptor_write_f('GridConnPropDescriptorName',
     &      'GridConnPropDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_user_data_write_f('GridConnPropUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! ...   AverageInterface_t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &      'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn,
     &      'GridConnectivityProperty_t', 1, 'AverageInterface_t', 1,
     &      'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_descriptor_write_f('AverageInterfaceDescriptorName',
     &      'AverageInterfaceDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_user_data_write_f('AverageInterfaceUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! ...   Periodic_t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &      'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn,
     &      'GridConnectivityProperty_t', 1, 'Periodic_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_descriptor_write_f('PeriodicDescriptorName',
     &      'PeriodicDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_user_data_write_f('PeriodicUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * DataClass & DimensionalUnits under Periodic
        call cg_dataclass_write_f(Dimensional, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        call cg_units_write_f(Kilogram, Meter, Second, Kelvin,
     &                        Radian, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * DataArray under Periodic
        dim_vals(1)=3
        dim_vals(2)=2
        call cg_array_write_f('arraysize', Integer, 2, dim_vals,
     &        size, ier)
        if (ier .ne. ERROR) write(6,'(a)') 'Error in API'

! * DataClass & DimensionalUnits under RotationCenter
        call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &      'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn,
     &      'GridConnectivityProperty_t', 1, 'Periodic_t', 1,
     &      'DataArray_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_dataclass_write_f(Dimensional, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        call cg_units_write_f(Kilogram, Meter, Second, Kelvin,
     &                        Radian, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

! *** close CGNS file
	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

 102    format(a,f8.3)
 200    format(a,i5)
 300    format(3a/a,i2)
 600    format(3a)
	end

        PROGRAM write_mixed_elements
        USE CGNS

!	author: Diane Poirier
!	last revised on March 15 2000

! 	This example test the writing of and element section of
!	type CGNS_ENUMV(MIXED), which includes some NGON_x elements of different size
!	The model is not realistic, as all the data is dummy.
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer index_dim, cell_dim, phys_dim
	integer cg, base, zone, ier, index, ZoneType
        integer(cgsize_t) size(3)
	integer i, j, k, n, pos, coord, section_no
        integer(cgsize_t) element(20)
        integer(cgsize_t) connect_offsets(10)
	character*32 ZoneName, coordname(3)
        double precision data_double(27)
	integer grid_no, count

!       initialize
        ier = 0
	index_dim = 1
	cell_dim=3
	phys_dim=3

!       open CGNS file for writing

        call cg_open_f('Test_V2', MODE_WRITE, cg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

!*******write CGNSBase
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	call cg_base_write_f(cg, 'MixedElementBase', cell_dim, phys_dim, &
      			     base, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

!*******write only 1 unstructured zone
	zone = 1
	ZoneType=CGNS_ENUMV(Unstructured)
	write(ZoneName,100) 'UnstructuredZone#1'
 100	format(a)
	size(1) = 27		! no of nodes
	size(2) = 3		! no of elements
	size(3) = 0		! unsorted nodes

	call cg_zone_write_f(cg, base, 'UnstructuredZone#1', size, &
                             ZoneType, index, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! Name convention
        coordname(1) = 'CoordinateX'
        coordname(2) = 'CoordinateY'
        coordname(3) = 'CoordinateZ'


! Create GridCoordinates_t node
            call cg_grid_write_f(cg,base,index,'GridCoordinates', &
                               grid_no, ier)
            if (ier.ne. ALL_OK) call cg_error_exit_f

! create coordinate data(10x10x10 box with 3x3x3 equidistant nodes)
        do coord=1,phys_dim
           DO k=1, 3
              DO j=1, 3
                 DO i=1, 3
                    pos = i + (j-1)*3 + (k-1)*9
                    IF (coord.EQ.1) data_double(pos) = (i-1)*5
                    IF (coord.EQ.2) data_double(pos) = (j-1)*5
                    IF (coord.EQ.3) data_double(pos) = (k-1)*5
                 ENDDO
              ENDDO
           ENDDO

! GOTO GridCoordinatesNode & write DataArray
            call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                           'GridCoordinates_t', 1, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_array_write_f(coordname(coord), CGNS_ENUMV(RealDouble), &
                                  index_dim, size, data_double, ier)
            if (ier .eq. ERROR) call cg_error_exit_f
	enddo	! coord. loop

! Generate dummy elements

	count = 0
	connect_offsets(1) = 0
! first element HEXA_8
        count = count + 1
        element(count)=CGNS_ENUMV(HEXA_8)
        do i=1,8
          count = count + 1
          element(count)=i
        enddo
! second element TETRA_4
        connect_offsets(2) = count
        count = count + 1
        element(count)=CGNS_ENUMV(TETRA_4)
        do i=1,4
          count = count + 1
          element(count)=i
        enddo
! third element PYRA_5
        connect_offsets(3) = count
        count = count + 1
        element(count)=CGNS_ENUMV(PYRA_5)
        do i=1,5
          count = count + 1
          element(count)=i
        enddo
        connect_offsets(4) = count

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
! Write MIXED element section
	call cg_poly_section_write_f(cg, base, zone, 'MixedElements', &
                                CGNS_ENUMV(MIXED), 1_cgsize_t, 3_cgsize_t, 0, &
                                element, connect_offsets, section_no, &
                                ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! Write section of 4  NGON_n of 3 nodes
        count = 0
	do n=1,4
	    !count = count + 1
	    !element(count)=3
	    connect_offsets(n) = count
	    do i=1,3
		count = count + 1
		element(count)=10*n+i
	    enddo
	enddo
	connect_offsets(5) = count
	call cg_poly_section_write_f(cg, base, zone, ' NGON_n(3)', &
                       CGNS_ENUMV(NGON_n), 1_cgsize_t, 4_cgsize_t, 0, element, &
                       connect_offsets, section_no, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! Write & close CGNS file

	call cg_close_f(cg, ier)
	if (ier.eq. ERROR) call cg_error_exit_f()

        END PROGRAM write_mixed_elements

      program read_flowvert_str
      use cgns
      implicit none
!
!   Opens an existing CGNS file that contains a simple 3-D
!   structured grid plus a flow solution (at VERTICES),
!   and reads it.
!
!   The CGNS grid file 'grid.cgns' must already exist
!   (created using write_grid_str.f followed by
!   write_flowvert_str.f)
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c read_flowvert_str.F90
!   ifort -o read_flowvert_str read_flowvert_str.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superceded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
!   dimension statements (note that tri-dimensional arrays
!   r and p must be dimensioned exactly as (21,17,N) (N>=9)
!   for this particular case or else they will be read from
!   the CGNS file incorrectly!  Other options are to use 1-D
!   arrays, use dynamic memory, or pass index values to a
!   subroutine and dimension exactly there):
      real*4 r(21,17,9),p(21,17,9)
      integer(cgsize_t) isize(3,3),irmin(3),irmax(3)
      integer loc,index_flow,index_zone,index_base,index_file,ier
      character*32 zonename,solname
!
!   READ FLOW SOLUTION FROM CGNS FILE
!   open CGNS file for read-only
      call cg_open_f('grid.cgns',CG_MODE_READ,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!   we know there is only one base (real working code would check!)
      index_base=1
!   we know there is only one zone (real working code would check!)
      index_zone=1
!   we know there is only one FlowSolution_t (real working code would check!)
      index_flow=1
!   get zone size (and name - although not needed here)
      call cg_zone_read_f(index_file,index_base,index_zone,zonename,isize,ier)
!   lower range index
      irmin(1)=1
      irmin(2)=1
      irmin(3)=1
!   upper range index - use vertex dimensions
!   checking GridLocation first (real working code would check
!   to make sure there are no Rind cells also!):
      call cg_sol_info_f(index_file,index_base,index_zone,index_flow,          &
           solname,loc,ier)
      if (loc .ne. Vertex) then
        write(6,'('' Error, GridLocation must be Vertex!  Currently:'',        &
         a32)') GridLocationName(loc)
        stop
      end if
      irmax(1)=isize(1,1)
      irmax(2)=isize(2,1)
      irmax(3)=isize(3,1)
!   read flow solution
      call cg_field_read_f(index_file,index_base,index_zone,index_flow,        &
           'Density',RealSingle,irmin,irmax,r,ier)
      call cg_field_read_f(index_file,index_base,index_zone,index_flow,        &
           'Pressure',RealSingle,irmin,irmax,p,ier)
!   close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully read flow solution from file'',                &
       '' grid.cgns'')')
      write(6,'(''   For example, r,p(21,17,9)='',2f12.5)')                    &
       r(21,17,9),p(21,17,9)
      write(6,'('' Program successful... ending now'')')
      stop
      end

        PROGRAM read_cprop
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on August 2002

!       This example test the GridConnectivityProperty_t data structure and its children
!	It tests the functions:
!	- cg_conn_average_read_f(fn, B, Z, I, AverageInterfaceType, ier)
!	- cg_conn_periodic_read_f(fn, B, Z, I, RotationCenter, RotationAngle, Translation, ier)
!	And the following:
!	- return value when GridConnectivityProperty_t doesn't exist, or when AverageInterface/Periodic doesn't exist
!	- printing AverageInterfaceTypeName, & type<=>name association.
!	- cg_ndescriptors, cg_descriptor_read under GridConnectivityProperty_t, AverageInterface_t, Periodic_t
!	- cg_nuser_data, cg_user_data_read, under GridConnectivityProperty_t, AverageInterface_t, Periodic_t
!	- cg_narray, cg_array_read under Periodic_t
!	- links under GridConnectivityProperty_t, AverageInterface_t, Periodic_t
!	- cg_goto to GridConnectivityProperty_t, AverageInterface_t, Periodic_t
! 	- Memory check with Insure
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 3)
	integer ier, cg, nbases, base, nzones, zone, nconns, conn
	integer CellDim, PhysDim, IndexDim
	integer(cgsize_t) size(3*Ndim)
	integer ndescriptors, idescr, zonetype
	integer ptset_type, ndonor_ptset_type
	integer(cgsize_t) npnts, npnts_donor
	integer location, nzonetype, donor_datatype
	integer AverageInterfaceType, nuser_data, n
	integer type, mass, length, time, temp, deg
	character*32 filename, basename, zonename
	character*32 name, user_data_name, connectname, donorname
	character*100 text
	real*4 version, Translation(Ndim)
	real *4 RotationCenter(Ndim), RotationAngle(Ndim)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

! *** open file
!	write(6,*) 'Input filename'
!	read(5,600) filename
 	write(filename,'(a)')'Test_V2'
	call cg_open_f(filename, MODE_READ, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,600)'READING FILE ',filename

! *** CGNS Library Version used for file creation:
	call cg_version_f(cg, version, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,102) &
           'Library Version used for file creation:',version

! *** base
	call cg_nbases_f(cg, nbases, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,200)'nbases=',nbases
	
	base=1

	call cg_base_read_f(cg, base, basename, CellDim, PhysDim, ier)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,300)'BaseName = "',basename,'"', &
                      'cell_dimension=',CellDim

! *** base attribute:  GOTO base node
	call cg_goto_f(cg, base, ier, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

! ***   base attribute:  Descriptor
	call cg_ndescriptors_f(ndescriptors, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,400)'Base Descriptor_t Information:'
        write(6,105) 'No. of descriptors=',ndescriptors

	do idescr=1, ndescriptors
          call cg_descriptor_read_f(idescr, name, text, ier)
          if (ier .eq. ERROR) call cg_error_exit_f
          if (ier.eq.ALL_OK) then
            write(6,500)' DescriptorName="',name,'"', &
                        ' DescriptorText="',text,'"'
          endif
	enddo

! *** read Zone
        call cg_nzones_f(cg, base, nzones, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,200)'nzones=',nzones

	zone = 1

	call cg_zone_read_f(cg, base, zone, zonename, size, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,104)'Name of Zone',zone,' is "',zonename,'"'

        call cg_zone_type_f(cg, base, zone, zonetype, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,600)'  Zone type is ', ZoneTypeName(zonetype)
	
        if (zonetype.eq.CGNS_ENUMV(Structured)) then
            IndexDim=CellDim
        else
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
            IndexDim=1
        endif

	write(6,104)'  IndexDimension=',IndexDim

! *** read GridConnectivity_t's
        call cg_nconns_f(cg, base, zone, nconns, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,113)nconns,' GridConnectivity_t found for ', &
                   zonename

        do conn=1, nconns
            call cg_conn_info_f(cg, base, zone, conn, connectname, &
               location, type, ptset_type, npnts, donorname, &
               nzonetype, ndonor_ptset_type, donor_datatype, &
               npnts_donor, ier)
            if (ier .eq. ERROR) call cg_error_exit_f
            write(6, 101) &
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
              '  GridConnectivity #',conn,':', &
              '   connect name=',connectname, &
              '   Grid location=',GridLocationName(location), &
              '   Connect-type=',GridConnectivityTypeName(type), &
              '   ptset type="',PointSetTypeName(ptset_type),'"', &
              '   npnts=',npnts,'   donorname="',donorname,'"', &
              '   donor zonetype=',ZoneTypeName(nzonetype), &
              '   donor ptset type=', &
                  PointSetTypeName(ndonor_ptset_type), &
              '   DonorDatatype=',DataTypeName(donor_datatype), &
              '   npnts_donor=',npnts_donor


!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
! *** read GridConnectivityProperty_t node

	    call cg_conn_average_read_f(cg, base, zone, conn, &
      		AverageInterfaceType, ier)
!	    if (ier .ne. ALL_OK) call cg_error_print_f
	    if (ier .eq. ERROR) call cg_error_exit_f

	    if (ier .eq. ALL_OK) then
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	        write(6,600) '   AverageInterfaceTypeName= "', &
       		    AverageInterfaceTypeName(AverageInterfaceType),'"'
	    endif

	    call cg_conn_periodic_read_f(cg, base, zone, conn, &
      		RotationCenter, RotationAngle, Translation, ier)
!           if (ier .ne. ALL_OK) call cg_error_print_f
	    if (ier .eq. ERROR) call cg_error_exit_f

            if (ier .eq. ALL_OK) then
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	 	write(6,110)'   RotationCenter=',RotationCenter(1), &
      				RotationCenter(2), RotationCenter(3)
                write(6,110)'   RotationAngle=',RotationAngle(1), &
                                RotationAngle(2), RotationAngle(3)
                write(6,110)'   Translation=',Translation(1), &
                                Translation(2), Translation(3)
	    endif

! *** read Descriptor_t & UserDefinedData_t under...
! ...   GridConnectivityProperty_t
            call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
      		'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn, &
      		'GridConnectivityProperty_t', 1, 'end')
!	    if (ier .ne. ALL_OK) call cg_error_print_f
	    if (ier .eq. ERROR) call cg_error_exit_f
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

            if (ier .eq. ALL_OK) then

                call cg_ndescriptors_f(ndescriptors, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'GridConnProperty Descriptor_t Information:'
                write(6,105) 'No. of descriptors=',ndescriptors
                do idescr=1, ndescriptors
                    call cg_descriptor_read_f(idescr, name, text, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' DescriptorName="',name,'"', &
                                 ' DescriptorText="',text,'"'
                enddo

                call cg_nuser_data_f(nuser_data, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'GridConnProperty User Data Information:'
                write(6,105) 'No. of UserData=',nuser_data
                do n=1, nuser_data
                    call cg_user_data_read_f(n, user_data_name, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' user_data_name="',user_data_name,'"'
                enddo

	    endif

! ...   AverageInterface_t
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
            call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
       		'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn, &
      		'GridConnectivityProperty_t', 1, 'AverageInterface_t', &
      		1, 'end')
!	    if (ier .ne. ALL_OK) call cg_error_print_f
	    if (ier .eq. ERROR) call cg_error_exit_f

            if (ier .eq. ALL_OK) then

                call cg_ndescriptors_f(ndescriptors, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'AverageInterface Descriptor_t Information:'
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
                write(6,105) 'No. of descriptors=',ndescriptors
                do idescr=1, ndescriptors
                    call cg_descriptor_read_f(idescr, name, text, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' DescriptorName="',name,'"', &
                                 ' DescriptorText="',text,'"'
                enddo

                call cg_nuser_data_f(nuser_data, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'AverageInterface User Data Information:'
                write(6,105) 'No. of UserData=',nuser_data
                do n=1, nuser_data
                    call cg_user_data_read_f(n, user_data_name, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' user_data_name="',user_data_name,'"'
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
                enddo

            endif

! ...   Periodic_t
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
            call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
      		'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn, &
      		'GridConnectivityProperty_t', 1, 'Periodic_t', 1, 'end')
!           if (ier .ne. ALL_OK) call cg_error_print_f
	    if (ier .eq. ERROR) call cg_error_exit_f

            if (ier .eq. ALL_OK) then

                call cg_ndescriptors_f(ndescriptors, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'Periodic Descriptor_t Information:'
                write(6,105) 'No. of descriptors=',ndescriptors
                do idescr=1, ndescriptors
                    call cg_descriptor_read_f(idescr, name, text, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' DescriptorName="',name,'"', &
                                 ' DescriptorText="',text,'"'
                enddo

                call cg_nuser_data_f(nuser_data, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'Periodic User Data Information:'
                write(6,105) 'No. of UserData=',nuser_data
                do n=1, nuser_data
                    call cg_user_data_read_f(n, user_data_name, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' user_data_name="',user_data_name,'"'
                enddo

! * Read DataClass & DimensionalUnits under RotationCenter
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
		call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
      		    'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', &
       		    conn, 'GridConnectivityProperty_t', 1, &
      		    'Periodic_t', 1, 'DataArray_t', 1, 'end')

		call cg_dataclass_read_f(type,ier)
		if (ier .eq. ERROR) call cg_error_exit_f
		write(6,600)'DataClassName=',DataClassName(type)

        	call cg_units_read_f(mass, length, time, temp, deg, ier)
        	if (ier .eq. ERROR) call cg_error_exit_f
        	if (ier .eq. ALL_OK) then
          	    write(6,100) &
            	    'SurfacePeriodic Dimensional Units:', &
            	    MassUnitsName(mass), LengthUnitsName(length), &
            	    TemperatureUnitsName(temp), TimeUnitsName(time), &
            	    AngleUnitsName(deg)
        	endif

            endif

	enddo ! conn loop

! Close file
        call cg_close_f(cg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

 100 	format(a/,'    Mass units: ',a/,'    Length units: ',a/, &
          '    Temperature units: ',a/,'    Time units: ',a/, &
          '    Angle units:',a)
 101    format(a,i1,a,/2a,/2a,/2a,/3a,/a,i4,3a,/2a,/2a,/2a,/a,i4)
 102 	format(a,f8.3)
 103    format(a,6i2)
 104    format(a,i5,3a)
 105	format(a,i2,a)
 110    format(a,5f5.1)
 113    format(i1,3a)
 119    format(a/a,3i2/a,3i2)
 200    format(a,i5)
 300	format(3a/a,i2)
 400	format(/a/)
 500	format(3a/3a)
 600	format(3a)

        END PROGRAM read_cprop

PROGRAM fexample

  USE MPI
  USE ISO_C_BINDING
  USE CGNS
  IMPLICIT NONE

#include "cgnstypes_f03.h"
#ifdef WINNT
  INCLUDE 'cgnswin_f.h'
#endif

  INTEGER(cgsize_t) :: nperside, totnodes, totelems
  PARAMETER (nperside = 50)
  PARAMETER (totnodes=nperside*nperside*nperside)
  PARAMETER (totelems=(nperside-1)*(nperside-1)*(nperside-1))

  INTEGER(C_INT) commsize, commrank, mpi_err
  INTEGER ierr
  INTEGER F, B, Z, E, S, Fs, Cx, Cy, Cz, A
  INTEGER(cgsize_t) :: i, j, k, n, nn, ne
  INTEGER(cgsize_t) :: nnodes, nelems
  INTEGER(cgsize_t) :: sizes(3), start, END
  INTEGER(cgsize_t), PARAMETER :: start_1 = 1
  REAL*4 fx(totnodes), fy(totnodes), fz(totnodes), fd(totelems)
  INTEGER(cgsize_t) :: ie(8*totelems)
!
!---- initialize MPI
  CALL MPI_INIT(mpi_err)
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD, commsize, mpi_err)
  CALL MPI_COMM_RANK(MPI_COMM_WORLD, commrank, mpi_err)

!---- open file and create base and zone
  sizes(1) = totnodes
  sizes(2) = totelems
  sizes(3) = 0

  CALL cgp_open_f('fexample.cgns', CG_MODE_WRITE, F, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
  CALL cg_base_write_f(F, 'Base', 3, 3, B, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
  CALL cg_zone_write_f(F, B, 'Zone', sizes, CGNS_ENUMV(Unstructured), Z, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

!---- print info
  IF (commrank .EQ. 0) THEN
     PRINT *, 'writing',totnodes,' coordinates and', totelems, &
          ' hex elements to fexample.cgns'
  ENDIF

!---- create data nodes for coordinates
  CALL cgp_coord_write_f(F, B, Z, CGNS_ENUMV(RealSingle), 'CoordinateX', Cx, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
  CALL cgp_coord_write_f(F, B, Z, CGNS_ENUMV(RealSingle), 'CoordinateY', Cy, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
  CALL cgp_coord_write_f(F, B, Z, CGNS_ENUMV(RealSingle), 'CoordinateZ', Cz, ierr)

!---- number of nodes and range this process will write
  nnodes = (totnodes + commsize - 1) / commsize
  start  = nnodes * commrank + 1
  end= nnodes * (commrank + 1)
  IF (end .GT. totnodes) END = totnodes

!---- create the coordinate data for this process
  nn = 1
  n  = 1
  DO k=1,nperside
     DO j=1,nperside
        DO i=1,nperside
           IF (n .GE. start .AND. n .LE. END) THEN
              fx(nn) = i
              fy(nn) = j
              fz(nn) = k
              nn = nn + 1
           ENDIF
           n = n + 1
        ENDDO
     ENDDO
  ENDDO

!---- write the coordinate data in parallel
  CALL cgp_coord_write_data_f(F, B, Z, Cx, start, END, fx, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
  CALL cgp_coord_write_data_f(F, B, Z, Cy, start, END, fy, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
  CALL cgp_coord_write_data_f(F, B, Z, Cz, start, END, fz, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

!---- create data node for elements
  CALL cgp_section_write_f(F, B, Z, 'Hex', CGNS_ENUMV(HEXA_8), start_1, totelems, 0, E, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

!---- number of elements and range this process will write
  nelems = (totelems + commsize - 1) / commsize
  start  = nelems * commrank + 1
  end = nelems * (commrank + 1)
  IF (end .GT. totelems) END = totelems

!---- create the hex element data for this process
  nn = 0
  n  = 1
  DO k=1,nperside-1
     DO j=1,nperside-1
        DO i=1,nperside-1
           IF (n .GE. start .AND. n .LE. END) THEN
              ne = i + nperside*((j-1)+nperside*(k-1))
              ie(nn+1) = ne
              ie(nn+2) = ne + 1
              ie(nn+3) = ne + 1 + nperside
              ie(nn+4) = ne + nperside
              ne = ne + nperside*nperside
              ie(nn+5) = ne
              ie(nn+6) = ne + 1
              ie(nn+7) = ne + 1 + nperside
              ie(nn+8) = ne + nperside
              nn = nn + 8
           ENDIF
           n = n + 1
        ENDDO
     ENDDO
  ENDDO

!---- write the element connectivity in parallel
  CALL cgp_elements_write_data_f(F, B, Z, E, start, END, ie, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

!---- create a centered solution
  CALL cg_sol_write_f(F, B, Z, 'Solution', CGNS_ENUMV(CellCenter), S, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
  CALL cgp_field_write_f(F, B, Z, S, CGNS_ENUMV(RealSingle), 'CellIndex', Fs, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

!---- create the field data for this process
  nn = 1
  DO n=1, totelems
     IF (n .GE. start .AND. n .LE. END) THEN
        fd(nn) = n
        nn = nn + 1
     ENDIF
  ENDDO

!---- write the solution field data in parallel
  CALL cgp_field_write_data_f(F, B, Z, S, Fs, start, END, fd, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

!---- create user data under the zone and duplicate solution data
  CALL cg_goto_f(F, B, ierr, 'Zone_t', 1, 'end')
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
  CALL cg_user_data_write_f('User Data', ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
  CALL cg_gorel_f(F, ierr, 'User Data', 0, 'end')
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
  CALL cgp_array_write_f('CellIndex', CGNS_ENUMV(RealSingle), 1, totelems, A, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

!---- write the array data in parallel
  CALL cgp_array_write_data_f(A, start, END, fd, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
!---- close the file and terminate MPI
  CALL cgp_close_f(F, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
  CALL MPI_FINALIZE(mpi_err)
END PROGRAM fexample

      program read_descriptor
      use cgns
      implicit none
!
!   Reads descriptor node (under CGNSBase_t) from an existing CGNS file.
!
!   The CGNS grid file 'grid.cgns' must already exist
!   and a descriptor node should be in it (using write_descriptor.f).
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c read_descriptor.F90
!   ifort -o read_descriptor read_descriptor.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
!   maxsize should match the length of 'text':
      integer, parameter :: maxsize=70
      integer isize,n,ndescriptors,index_base,index_file,ier
      character text*70,name*32
!
!  READ DESCRIPTOR FROM EXISTING CGNS FILE
!  open CGNS file for read-only
      call cg_open_f('grid.cgns',CG_MODE_READ,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!  we know there is only one base (real working code would check!)
      index_base=1
!   go to base node
      call cg_goto_f(index_file,index_base,ier,'end')
!   find out how many descriptors are here:
      call cg_ndescriptors_f(ndescriptors,ier)
      do n=1,ndescriptors
        call cg_descriptor_size_f(n,isize,ier)
        if (isize .gt. maxsize) then
          write(6,'('' Error!  must increase maxsize to at least '',           &
            i5)') isize
          stop
        end if
!   read descriptor
        call cg_descriptor_read_f(n,name,text,ier)
        write(6,'('' The descriptor is:'',/,/,a)') text
      enddo
!  close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'(/,'' Successfully read descriptors from file'',                &
        '' grid.cgns'')')
      stop
      end

	program read_cgns_1
	implicit none

! This program reads a 3D mesh, structured or unstructured.

#include "cgnstypes_f.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif
	include 'cgnslib_f.h'

	integer Ndim, Nglobal
	parameter (Ndim = 3)
	parameter (Nglobal = 500)

	cgsize_t i, narrays, iarray, nintegrals, integral
	cgsize_t ndescriptors, idescr, nptsets, nzonetype
	cgsize_t ndonor_ptset_type, ndonor_data_type
	cgsize_t idataset, dirichletflag, neumannflag
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	cgsize_t IndexDim, CellDim, PhysDim
	cgsize_t ier, n, zonetype
	cgsize_t nbases, nzones
	cgsize_t rmin(3), DataSize(Ndim)
	cgsize_t size(Ndim*3)
	cgsize_t ncoords, type, nsols, nfields, location
	cgsize_t nholes, nconns, n1to1, n1to1_global, nbocos
	cgsize_t ptset_type
	cgsize_t npnts, pnts(100000), donor_pnts(100000)
        cgsize_t npnts_donor
        cgsize_t bocotype, datatype
	character*32 basename, zonename, solname, fieldname
	character*32 coordname, holename, connectname
	character*32 boconame, donorname
	cgsize_t cg, base, zone, coord, sol, field, discr
	cgsize_t hole, conn, one21, boco
	cgsize_t range(Ndim, 2), donor_range(Ndim, 2)
 	cgsize_t transform(Ndim)
  	cgsize_t G_range(Ndim*2, Nglobal)
	cgsize_t G_donor_range(Ndim*2, Nglobal)
	cgsize_t G_transform(Ndim, Nglobal)
	character*32 G_connectname(Nglobal), G_zonename(Nglobal)
	character*32 G_donorname(Nglobal)
	character*32 name, filename
	character*40 text, NormDefinitions, StateDescription
	cgsize_t equation_dimension, GoverningEquationsFlag
	cgsize_t GasModelFlag, ViscosityModelFlag
	cgsize_t ThermalConductivityModelFlag
	cgsize_t TurbulenceClosureFlag, TurbulenceModelFlag
	cgsize_t diffusion_model(6), niterations
	cgsize_t nndim, rind(6), ndiscrete, num
	cgsize_t dim_vals(12)
	cgsize_t mass, length, time, temp, deg
	cgsize_t NormalIndex(3), ndataset
	cgsize_t NormalListFlag
	real*4 data_single(100000)
	double precision data_double(100000)
	real*4 version

        cgsize_t one
        parameter (one = 1)

! *** open file
!	write(6,*) 'Input filename'
!	read(5,600) filename
 	write(filename,'(a)')'cgtest.cgns'
	call cg_open_f(filename, CG_MODE_READ, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,600)'READING FILE ',filename

! *** CGNS Library Version used for file creation:
	call cg_version_f(cg, version, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,102)
     &     'Library Version used for file creation:',version

! *** base
	call cg_nbases_f(cg, nbases, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,200)'nbases=',nbases

	do base=1, nbases

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	  call cg_base_read_f(cg, base, basename, CellDim, PhysDim, ier)
	  if (ier .eq. ERROR) call cg_error_exit_f
	  write(6,300)'BaseName = "',basename,'"',
     &                'cell_dimension=',CellDim

! *** base attribute:  GOTO base node
	  call cg_goto_f(cg, base, ier, 'end')
          if (ier .eq. ERROR) call cg_error_exit_f

! ***     base attribute:  Descriptor
          call cg_descriptor_read_f(one, name, text, ier)
          if (ier .eq. ERROR) call cg_error_exit_f
          if (ier.eq.ALL_OK) then
            write(6,400)'Base Descriptor_t Information:'
            write(6,500)' DescriptorName="',name,'"',
     &                  ' DescriptorText="',text,'"'
          endif

! ***     base attribute: flow equation set:
	  call cg_equationset_read_f(equation_dimension,
     &      GoverningEquationsFlag,  GasModelFlag,
     &      ViscosityModelFlag, ThermalConductivityModelFlag,
     &      TurbulenceClosureFlag,  TurbulenceModelFlag, ier)
	  if (ier .eq. ERROR) then
	    call cg_error_exit_f
	  elseif (ier .eq. NODE_NOT_FOUND) then
	    write(6,200)
     &      'FlowEquationSet_t not defined under CGNSBase_t #',base
	  elseif (ier .eq. INCORRECT_PATH) then
  	    write(6,400)'Incorrect path input to cg_goto_f'
	  else
	    write(6,400) 'FlowEquationSet_t Information:'
	    write(6,100)' equation_dimension=',equation_dimension

! ***       flow equation set attributes:  GOTO FlowEquationSet_t node
            call cg_goto_f(cg,base,ier,'FlowEquationSet_t',one,'end')
            if (ier .eq. ERROR) call cg_error_exit_f

! ***       flow equation set attribute: Descriptor
            call cg_descriptor_read_f(one, name,text,ier)
            if (ier .eq. ERROR) call cg_error_exit_f
            if (ier .eq. ALL_OK) write(6,500)
     &        ' DescriptorName="',name,'"',' DescriptorText="',text,'"'

! ***       flow equation set attribute: Gas Model Type
	    if (GasModelFlag.eq.1) then
                call cg_model_read_f('GasModel_t', type, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                if (ier .eq. ALL_OK) write(6,600)
     &            ' GasModelType="',ModelTypeName(type),'"'
            endif

! ***       flow equation set attribute: ViscosityModel Type
            if (ViscosityModelFlag.eq.1) then
              call cg_model_read_f('ViscosityModel_t', type, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              if (ier .eq. ALL_OK) write(6,600)
     &          ' ViscosityModelType="',ModelTypeName(type),'"'
            endif

! ***       flow equation set attribute:  TypmlConductivityModel Type
            if (ThermalConductivityModelFlag.eq.1) then
              call cg_model_read_f('ThermalConductivityModel_t',
     &                  type, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              if (ier .eq. ALL_OK) write(6,600)
     &          ' ThermalConductivityModelType=',
     &            ModelTypeName(type),'"'
            endif

! ***   flow equation set attribute: TurbulenceClosureType
            if (TurbulenceClosureFlag.eq.1) then
              call cg_model_read_f('TurbulenceClosure_t', type, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              if (ier .eq. ALL_OK) write(6,600)
     &          ' TurbulenceClosureType="', ModelTypeName(type),'"'
            endif

! ***   flow equation set attribute: TurbulenceModelType
            if (TurbulenceModelFlag.eq.1) then
              call cg_model_read_f('TurbulenceModel_t', type, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              if (ier .eq. ALL_OK) write(6,600)
     &          ' TurbulenceModelType="',ModelTypeName(type),'"'
            endif

! ***   flow equation set attribute: Governing Equations Type
            if (GoverningEquationsFlag .eq. 1) then
              call cg_governing_read_f(type, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              if (ier.eq.ALL_OK)
     &          write(6,600)' GoverningEquationsType="',
     &                          GoverningEquationsTypeName(type),'"'

    	! *** Governing Equations attribute:  GOTO GoverningEquations_t node
	      call cg_goto_f(cg,base,ier, 'FlowEquationSet_t', one,
     &            'GoverningEquations_t', one ,'end')
	      if (ier .eq. ERROR) call cg_error_exit_f


        ! *** Governing Equations attribute:  Diffusion model
	      call cg_diffusion_read_f(diffusion_model, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      if (ier.eq.ALL_OK)write(6,103)'   Diffusion model=',
     &                           (diffusion_model(i), i=1,6)
            endif       ! If Governing Equations are defined
	  endif		! If FlowEquationSet_t exists under CGNSBase_t


	  write(6,400)'                              *     *     *'

	  call cg_nzones_f(cg, base, nzones, ier)
	  if (ier .eq. ERROR) call cg_error_exit_f
	  write(6,200)'nzones=',nzones

! *** zone
	  do zone=1, nzones
	    call cg_zone_read_f(cg, base, zone, zonename, size, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
	    write(6,104)'Name of Zone',zone,' is "',zonename,'"'

	    call cg_zone_type_f(cg, base, zone, zonetype, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
	    write(6,600)'  Zone type is ', ZoneTypeName(zonetype)


	    if (zonetype.eq.Structured) then
		IndexDim=CellDim
	    else
		IndexDim=1
	    endif


	    write(6,104)'  IndexDimension=',IndexDim

      ! *** zone attribute:  GOTO zone node
	    call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'end')
	    if (ier .eq. ERROR) call cg_error_exit_f

      ! *** zone attribute:  ordinal
	    call cg_ordinal_read_f(num, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
	    if (ier .eq. ALL_OK)
     &          write(6,200)' Zone ordinal=',num


      ! *** zone attribute:  convergence history
	    call cg_convergence_read_f(niterations,
     &            NormDefinitions, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

	    if (ier .eq. ALL_OK) then
	      write(6,600)'Convergence History of ',zonename
	      write(6,104) ' niterations=',niterations,
     &                     ' NormDefinitions="',NormDefinitions,'"'

         ! ** ConvergenceHistory_t attributes:
	      call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &                      'ConvergenceHistory_t', one, 'end')
	      if (ier .eq. ERROR) call cg_error_exit_f

         ! ** ConvergenceHistory_t attributes: DataArray_t
	      call cg_narrays_f(narrays, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      write(6,105) 'ConvergenceHistory_t contains ',
     &                      narrays,' array(s)'
	      do iarray=1, narrays
                call cg_array_info_f(iarray, name, datatype,
     &                             nndim, dim_vals, ier)
                if (ier .eq. ERROR) call cg_error_exit_f

	        write(6,600) ' DataArrayName="',name,'"'
	        write(6,600) ' DataType="',DataTypeName(datatype),'"'
	        write(6,200) ' DataNdim=',nndim
	        write(6,200) ' DataDim=',dim_vals(1)

	        write(6,105) ' Data:'
	        if (datatype .eq. RealSingle) then
	          call cg_array_read_f(iarray, data_single, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
	          write(6,106) (data_single(n),n=1,dim_vals(1))
	        elseif (datatype .eq. RealDouble) then
		  call cg_array_read_f(iarray, data_double, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
	 	  write(6,106) (data_double(n),n=1,dim_vals(1))
	        endif
	      enddo

         ! ** ConvergenceHistory_t attributes: DataClass_t
	      call cg_dataclass_read_f(type,ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      write(6,600)'DataClassName=',DataClassName(type)

         ! ** ConvergenceHistory_t attributes: DimensionalUnits_t
	      call cg_units_read_f(mass, length, time, temp, deg, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      if (ier .eq. ALL_OK) then
	        write(6,100)
     &	 	  'Dimensional Units:',
     &            MassUnitsName(mass), LengthUnitsName(length),
     &            TemperatureUnitsName(temp), TimeUnitsName(time),
     &            AngleUnitsName(deg)
	      endif
	    endif
            write(6,400)'                             *     *     *'

! *** zone attribute:  return to Zone_t node
	    call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'end')
	    if (ier .eq. ERROR) call cg_error_exit_f
	    write(6,401)'Integral Data Information of ',zonename

	    call cg_nintegrals_f(nintegrals, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
	    write(6,107) nintegrals, ' IntegralData_t node in ',
     &                    zonename

! *** zone attribute:  IntegralData_t
	    do integral=1, nintegrals
	      call cg_integral_read_f(integral, name, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      write(6,104) 'IntegralData_t #',integral,
     &                             ' is named "', name,'"'

        ! *** IntegralData_t attribute:  GOTO IntegralData_t node
	      call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &                       'IntegralData_t', integral, 'end')
              if (ier .eq. ERROR) call cg_error_exit_f

	      call cg_narrays_f(narrays, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
              write(6,108) 'IntegralData_t #',integral,
     &                     ' contains ', narrays,' data'

	      do iarray=1, narrays

          ! *** IntegralData_t attribute: DataArray_t
                call cg_array_info_f(iarray, name, datatype,
     &                               nndim, dim_vals, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,600) ' DataArrayName="',name,'"'
                write(6,600) ' DataType=',DataTypeName(datatype)
                write(6,108) ' DataNdim=',nndim,
     &                       ', DataDim=',dim_vals(1)

                if (datatype .eq. RealSingle) then
                  call cg_array_read_f(iarray, data_single, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
                  write(6,109) ' integraldata=',data_single(1)
                elseif (datatype .eq. RealDouble) then
                  call cg_array_read_f(iarray, data_double, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
                  write(6,109) 'integraldata=',data_double(1)
                endif

	  ! *** DattaArray_t attribute: GOTO DataArray_t
		call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &                         'IntegralData_t', integral,
     &                         'DataArray_t', iarray, 'end')
                if (ier .eq. ERROR) call cg_error_exit_f


          ! *** DattaArray_t attribute: DimensionalExponents_t
	        call cg_exponents_info_f(datatype, ier)
                if (ier .eq. ERROR) then
	          call cg_error_exit_f
	        elseif (ier .eq. ALL_OK) then
		  write(6,600)' Datatype for exponents is ',
     &               DataTypeName(datatype)
                  if (datatype .eq. RealSingle) then
	            call cg_exponents_read_f(data_single, ier)
		    if (ier .eq. ERROR) call cg_error_exit_f
		    write(6,110)' Exponents:',(data_single(n),n=1,5)
                  elseif (datatype .eq. RealDouble) then
                    call cg_exponents_read_f(data_double, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,110)' Exponents:',(data_double(n),n=1,5)
                  endif
	        endif

          ! *** DattaArray_t attribute: DataConversion_t
	        call cg_conversion_info_f(datatype, ier)
                if (ier .eq. ERROR) then
		  call cg_error_exit_f
                elseif (ier .eq. ALL_OK) then
		  write(6,600)' Datatype for conversion is ',
     &               DataTypeName(datatype)
                  if (datatype .eq. RealSingle) then
                    call cg_conversion_read_f(data_single, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,110)' Conversion:',(data_single(n),n=1,2)
                  elseif (datatype .eq. RealDouble) then
                    call cg_conversion_read_f(data_double, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,110)' Conversion:',(data_double(n),n=1,2)
                  endif
		endif

	      enddo	! loop through DataArray_t
	    enddo	! loop through IntegralData_t

            write(6,400)'                             *     *     *'

      ! *** zone coordinate attribute:  GOTO GridCoordinates_t node
            call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &            'GridCoordinates_t', one, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f
	    if (ier .eq. ALL_OK) then

        ! *** GridCoordinates_t attribute: dimensional units
              call cg_units_read_f(mass, length, time, temp, deg, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
	      if (ier .eq. ALL_OK) write(6,400)
     &            'Dimensional Units for GridCoordinates_t: ',
     &            LengthUnitsName(length)

	! *** GridCoordinates_t attribute:  Rind
              call cg_rind_read_f(rind, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              write(6,103)'GC Rind Data is ',(rind(i),i=1,6)

        ! *** coordinate array
	      call cg_narrays_f(narrays, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
              write(6,105) 'GridCoordinates_t contains ',
     &                            narrays,' arrays'
	      do iarray=1,narrays

		call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &            'GridCoordinates_t', one, 'end')
                if (ier .eq. ERROR) call cg_error_exit_f

	  ! *** GridCoordinates_t attribute: DataArray_t
                call cg_array_info_f(iarray, name, datatype,
     &                               nndim, dim_vals, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,600)' DataArrayName="',name,'"'
                write(6,600)' DataType=',DataTypeName(datatype)
                write(6,104)' DataNdim=',nndim
		do i=1,nndim
                  write(6,111)' DataDim(',i,')=',dim_vals(i)
		enddo

	  ! *** Compute nr of data in data array:
	   	num = 1
		do i=1,nndim
		  num = num*dim_vals(i)
		enddo

                if (datatype .eq. RealSingle) then
                  call cg_array_read_f(iarray, data_single, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
                  write(6,106) (data_single(i),i=1,2)
                  write(6,106) (data_single(i),i=num-1,num)
                elseif (datatype .eq. RealDouble) then
                  call cg_array_read_f(iarray, data_double, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
                  write(6,106) (data_double(i),i=1,2)
                  write(6,106) (data_double(i),i=num-1,num)
                endif

          ! *** coordinate attribute:  GOTO coordinate array node
                call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &          'GridCoordinates_t', one, 'DataArray_t', iarray, 'end')
                if (ier .eq. ERROR) call cg_error_exit_f

                call cg_ndescriptors_f(ndescriptors, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,105) 'No. of descriptors=',ndescriptors
                do idescr=1, ndescriptors
                  call cg_descriptor_read_f(idescr, name, text, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
                  write(6,500) ' DescriptorName="',name,'"',
     &                               ' DescriptorText="',text,'"'
                enddo

	      enddo	! loop through data arrays

        ! *** read coordinates using coordinate arrays' specific functions:

	      write(6,400)'Specific functions to read coordinates arrays'
	      call cg_ncoords_f(cg, base, zone, ncoords, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      write(6,103)'no. of coordinates=',ncoords

	 ! ** Compute the nr of data to be read
              do i=1,IndexDim
                rmin(i)=1
                DataSize(i)=size(i) + rind(2*i-1) + rind(2*i)
              enddo

	      do coord=1, ncoords
	  	call cg_coord_info_f(cg, base, zone, coord, datatype,
     &                               coordname, ier)
		if (ier .eq. ERROR) call cg_error_exit_f
 		write(6,112)'coord #',coord,
     &            '   datatype=',DataTypeName(datatype),
     &            '   name="',coordname,'"'

                if (datatype .eq. RealSingle) then
        	    call cg_coord_read_f(cg, base, zone, coordname,
     &                  RealSingle, rmin, DataSize, data_single, ier)
        	    if (ier .eq. ERROR) call cg_error_exit_f

                elseif (datatype .eq. RealDouble) then
                    call cg_coord_read_f(cg, base, zone, coordname,
     &                  RealDouble, rmin, DataSize, data_double, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                endif
	      enddo
	    endif 	! if GridCoordinates_t exists

            write(6,400)'                             *     *     *'

! *** solution

	    call cg_nsols_f(cg, base, zone, nsols, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
	    write(6,113) nsols,' FlowSolution_t node(s)',
     &              'found for ',zonename

      ! *** Read solution with general cg_array_read function
	    do sol=1, nsols
	      call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &            'FlowSolution_t', sol, 'end')
	      if (ier .eq. ERROR) call cg_error_exit_f

	! *** FlowSolution_t attribute:  DataArray_t
	      call cg_narrays_f(narrays, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
              write(6,108) ' FlowSolution_t #',sol,
     &              ' contains ',narrays,' solution arrays'

	! *** FlowSolution_t attribute:  GridLocation
	      call cg_gridlocation_read_f(location, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      write(6,600)'  The solution data are recorded at the ',
     &                 GridLocationName(location)

	! *** FlowSolution_t attribute:  Rind
	      call cg_rind_read_f(rind, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
	      write(6,103)'  The Rind Data is ',(rind(i),i=1,6)

              do iarray=1,narrays
	        call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &            'FlowSolution_t', sol, 'end')
                if (ier .eq. ERROR) call cg_error_exit_f

                call cg_array_info_f(iarray, name, datatype,
     &                               nndim, dim_vals, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
	        write(6,114) '  DataArray #',iarray
                write(6,600) '   Name="',name,'"'
                write(6,600) '   DataType=',DataTypeName(datatype)
                write(6,103) '   DataNdim=',nndim
                do i=1,nndim
                  write(6,111)'   DataDim(',i,')=',dim_vals(i)
                enddo

	 ! *** For dynamic memory allocation, compute the number of data to be read:
                num = 1
                do i=1,nndim
                    num = num*dim_vals(i)
                enddo
                write(6,200) 'Nr of data in solution vector=',num

                if (datatype .eq. RealSingle) then
                  call cg_array_read_f(iarray, data_single, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
                  !write(6,106) (data_single(i),i=1,num)
                elseif (datatype .eq. RealDouble) then
                  call cg_array_read_f(iarray, data_double, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
                  !write(6,106) (data_double(i),i=1,num)
                endif

          ! *** solution field attribute:  GOTO solution array node
                call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &          'FlowSolution_t',sol,'DataArray_t',iarray,'end')
                    if (ier .eq. ERROR) call cg_error_exit_f

          ! *** solution field attribute:  DimensionalUnits
                call cg_units_read_f(mass, length, time, temp,
     &                   deg, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                if (ier .eq. ALL_OK) then
                write(6,100)
     &		  '   Dimensional Units:',
     &            MassUnitsName(mass), LengthUnitsName(length),
     &            TemperatureUnitsName(temp), TimeUnitsName(time),
     &            AngleUnitsName(deg)
                endif

	      enddo	! loop through DataArray_t
	      write(6,103)' '

      ! *** Reading solution data with solution specific functions:
              call cg_sol_info_f(cg, base, zone, sol, solname,
     &                           location, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              write(6,115)'sol #',sol,':',
     &           '   solname="',solname,'"',
     &           '   location=',GridLocationName(location)

        ! *** Compute the nr of data to be read

              if (zonetype.eq.Structured) then
                do i=1,3
                  DataSize(i)=size(i) + rind(2*i-1) + rind(2*i)
                  if (location.eq.CellCenter) DataSize(i)=DataSize(i)-1
                enddo
              else
                DataSize(1)=size(2)
              endif

        ! *** solution field
              call cg_nfields_f(cg, base, zone, sol, nfields, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              write(6,105)'  nfields=',nfields

              do field=1, nfields
                call cg_field_info_f(cg, base, zone, sol, field,
     &                               type, fieldname, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,115)'  field #',field,':',
     &                    '   fieldname="',fieldname,'"',
     &                    '   datatype=',DataTypeName(type)

          ! *** read entire range of solution data and record in double precision
                call cg_field_read_f(cg, base, zone, sol, fieldname,
     &              RealDouble, rmin, DataSize, data_double, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
              enddo                             ! field loop

            enddo	! loop through FlowSolution_t

            write(6,400)'                             *     *     *'

! *** discrete data under zone
	    call cg_ndiscrete_f(cg, base, zone, ndiscrete, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
	    if (ier .eq. ALL_OK) write(6,113)ndiscrete,
     &        ' DiscreteData_t node(s) found under ',zonename

	    do discr=1, ndiscrete
	      call cg_discrete_read_f(cg, base,zone, discr, name, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      write(6,600)' name=',name

        ! *** discrete data attribute:  GOTO DiscreteData_t node
	      call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &                'DiscreteData_t',  discr, 'end')
	      if (ier .eq. ERROR) call cg_error_exit_f

        ! *** discrete data attribute:  GridLocation_t
	      call cg_gridlocation_read_f(location, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      if (ier .eq. ALL_OK) write(6,600)
     &           ' The location of the DiscreteData vector is ',
     &                 GridLocationName(location)

  	! *** discrete data arrays:
              call cg_narrays_f(narrays, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              write(6,116) ' DiscreteData #', discr,
     &                         ' contains ', narrays,' arrays'
	      do iarray=1, narrays
	        call cg_array_info_f(iarray, name, datatype,
     &                              nndim, dim_vals, ier)
                if (ier .eq. ERROR) call cg_error_exit_f

		write(6,116) 'DataArray #',iarray,':'
	        write(6,600)'  Name =',name
		write(6,600)'  Datatype=',
     &            DataTypeName(datatype)

	  ! *** compute nr of data to be read
		num=1
		do n=1, nndim
		  num=num*dim_vals(n)
		enddo

                if (datatype .eq. RealSingle) then
                  call cg_array_read_f(iarray, data_single, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
                  !write(6,*) (data_single(n),n=1,num)
                elseif (datatype .eq. RealDouble) then
                  call cg_array_read_f(iarray, data_double, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
                  !write(6,*) (data_double(n),n=1,num)
                endif

          ! *** discrete data arrays attribute: GOTO DataArray node
                call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &            'DiscreteData_t', discr, 'DataArray_t', iarray, 'end')
	        if (ier .eq. ERROR) call cg_error_exit_f

	        call cg_units_read_f(mass, length, time, temp, deg, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
		if (ier .eq. ALL_OK) then
                  write(6,100)
     &		    '  Dimensional Units for DiscreteData_t:',
     &              MassUnitsName(mass), LengthUnitsName(length),
     &              TemperatureUnitsName(temp), TimeUnitsName(time),
     &              AngleUnitsName(deg)
                endif
	      enddo		! loop through DataArray_t
	    enddo

            write(6,400)'                             *     *     *'

! *** Interblock Connectivity:
	    write(6,401)'Interblock Connectivity for ',zonename

! *** ZoneGridConnectivity attributes:  GOTO ZoneGridConnectivity_t node
            call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &         'ZoneGridConnectivity_t', one, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f

	    if (ier.eq. ALL_OK) then
! *** ZoneGridConnectivity attributes: Descriptor_t
              call cg_ndescriptors_f(ndescriptors, ier)
              if (ier .ne. 0) call cg_error_exit_f
              write(6,117)
     &        ndescriptors, ' descriptors for ZoneGridConnectivity_t'
              do idescr=1, ndescriptors
                call cg_descriptor_read_f(idescr, name, text, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,500) '     DescriptorName="',name,'"',
     &                             '     DescriptorText="',text,'"'
              enddo


        ! *** overset holes
	      call cg_nholes_f(cg, base, zone, nholes, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      write(6,107) nholes, ' holes found'

	      do hole=1, nholes
	        call cg_hole_info_f(cg, base, zone, hole, holename,
     &             location, ptset_type, nptsets, npnts, ier)
	        if (ier .eq. ERROR) call cg_error_exit_f
	        write(6,118)
     &	      	  '  hole #',hole,':', '   holename="',holename,'"',
     &            '   data location=',GridLocationName(location),
     &            '   nptsets = ',nptsets,
     &            ', total no. of points =',npnts

	        if (npnts .lt. 30000) then
	 	  call cg_hole_read_f(cg, base, zone, hole, pnts, ier)
	  	  if (ier .eq. ERROR) call cg_error_exit_f
	        endif

          ! *** overset holes attributes:  GOTO OversetHoles_t node
	        call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &             'ZoneGridConnectivity_t', one,
     &             'OversetHoles_t', hole, 'end')
                if (ier .ne. 0) call cg_error_exit_f

	        call cg_ndescriptors_f(ndescriptors, ier)
	        if (ier .ne. 0) call cg_error_exit_f
	        write(6,117)
     &            ndescriptors, ' descriptors for ',holename
                do idescr=1, ndescriptors
                  call cg_descriptor_read_f(idescr, name, text, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
                  write(6,500) '     DescriptorName="',name,'"',
     &                               '     DescriptorText="',text,'"'
                enddo
	      enddo	!hole loop



! *** general connectivity
	      call cg_nconns_f(cg, base, zone, nconns, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              write(6,107) nconns,' GridConnectivity_t found'

	      do conn=1, nconns
                call cg_conn_info_f(cg, base, zone, conn, connectname,
     &             location, type, ptset_type, npnts, donorname,
     &             nzonetype, ndonor_ptset_type, ndonor_data_type,
     &             npnts_donor, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
	        write(6, 101)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
     &            '  GridConnectivity #',conn,':',
     &            '   connect name=',connectname,
     &            '   Grid location=',GridLocationName(location),
     &            '   Connect-type=',GridConnectivityTypeName(type),
     &            '   ptset type="',PointSetTypeName(ptset_type),'"',
     &            '   npnts=',npnts,'   donorname="',donorname,'"',
     &            '   donor zonetype=',ZoneTypeName(nzonetype),
     &            '   donor ptset type=',
     &                PointSetTypeName(ndonor_ptset_type),
     &            '   npnts_donor=',npnts_donor

                call cg_conn_read_f(cg, base, zone, conn, pnts,
     &                            Integer, donor_pnts, ier)
                if (ier .eq. ERROR) call cg_error_exit_f

	        write(6,119) '   Current zone:',
     &           '    first point:', pnts(1),pnts(2),pnts(3),
     &           '    last point :', pnts(3*npnts-2), pnts(3*npnts-1),
     &                               pnts(3*npnts)
	        write(6,119) '   Donor zone:',
     &           '    first point:', donor_pnts(1),donor_pnts(2),
     &                               donor_pnts(3),
     &           '    last point :', donor_pnts(3*npnts-2),
     &                               donor_pnts(3*npnts-1),
     &                               donor_pnts(3*npnts)

! *** general connectivity attributes:  GOTO GridConnectivity_t node
	        call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &              'ZoneGridConnectivity_t', one,
     &              'GridConnectivity_t', conn, 'end')
	        if (ier .eq. ERROR) call cg_error_exit_f

	        call cg_ordinal_read_f(num, ier)
	        if (ier .eq. ERROR) call cg_error_exit_f
	        if (ier .eq. ALL_OK) write(6,200)'  Ordinal=',num
              enddo

! *** connectivity 1to1
	      call cg_n1to1_f(cg, base, zone, n1to1, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
              write(6,107) n1to1,' GridConnectivity1to1_t found'

              do one21=1, n1to1
                call cg_1to1_read_f(cg, base, zone, one21, connectname,
     &             donorname, range, donor_range, transform, ier)
                if (ier .eq. ERROR) call cg_error_exit_f

                write(6,105) 'GridConnectivity1to1 #',one21
                write(6,600) 'connectname="',connectname,'"'
                write(6,600) 'donorname  ="',donorname,'"'

                write(6,120) ' range: ',
     &           '(',range(1,1),',',range(2,1),',',range(3,1),
     &           ') to (',range(1,2),',',range(2,2),',',range(3,2),')'

                write(6,121)' donor_range: ',
     &          '(', donor_range(1,1), ',', donor_range(2,1), ',',
     &            donor_range(3,1), ') to (',
     &            donor_range(1,2), ',', donor_range(2,2), ',',
     &            donor_range(3,2), ')'

                write(6,122) ' Transform: ', '(',
     &            transform(1), ',',
     &            transform(2), ',', transform(3), ')'


! *** connectivity 1to1 attributes:  GOTO GridConnectivity1to1_t node
	        call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &              'ZoneGridConnectivity_t', one,
     &           'GridConnectivity1to1_t', one21, 'end')
		  if (ier .eq. ERROR) call cg_error_exit_f
		  if (ier .eq. ALL_OK) then

! *** connectivity 1to1 attributes:  Descriptor_t
	            call cg_ndescriptors_f(ndescriptors, ier)
                    if (ier .ne. 0) call cg_error_exit_f
                    write(6,117)
     &              ndescriptors, ' descriptors for ',connectname
                    do idescr=1, ndescriptors
                      call cg_descriptor_read_f(idescr, name, text, ier)
                      if (ier .eq. ERROR) call cg_error_exit_f
                      write(6,500) '   DescriptorName="',name,'"',
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
     &                               '   DescriptorText="',text,'"'
                    enddo
		endif
              enddo
	    endif	! if ZoneGridConnectivity exists

            write(6,400)'                             *     *     *'

! *** bocos
	    write(6,600)'Boundary Conditions for ',zonename


! *** Zone bound. condition attributes: GOTO ZoneBC_t node
            call cg_goto_f(cg, base,ier, 'Zone_t', zone,
     &                     'ZoneBC_t', one, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f
	    if (ier .eq. ALL_OK) then

  	! *** Zone bound. condition attributes: ReferenceState_t
              call cg_state_read_f(StateDescription, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
	      if (ier.eq.ALL_OK) then
		write(6,600)' ReferenceState defined under ZoneBC_t'
                write(6,600)'  StateDescription=',StateDescription

         ! ** ReferenceState_t attributes:  GOTO ReferenceState_t
                call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &            'ZoneBC_t', one, 'ReferenceState_t', one, 'end')
                if (ier .eq. ERROR) call cg_error_exit_f

                call cg_narrays_f(narrays, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,105) '  ReferenceState_t contains ',
     &                          narrays,' array(s)'

                do iarray=1, narrays

                  call cg_array_info_f(iarray, name, datatype,
     &              nndim, dim_vals, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f

		  write(6,105) '   DataArray #',iarray,':'
                  write(6,600)'    Name =',name
                  write(6,600)'    Datatype=',DataTypeName(datatype)

		  write(6,600)'    Data:'
                  if (datatype .eq. RealSingle) then
                    call cg_array_read_f(iarray, data_single, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,124) data_single(1)
                  elseif (datatype .eq. RealDouble) then
                    call cg_array_read_f(iarray, data_double, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,124) data_double(1)
                  endif
                enddo


           ! ** ReferenceState_t attributes: DimensionalUnits_t
                call cg_units_read_f(mass, length, time, temp,
     &                   deg, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                if (ier .eq. ALL_OK) then
                  write(6,100)
     &		    '  Dimensional Units:',
     &              MassUnitsName(mass), LengthUnitsName(length),
     &              TemperatureUnitsName(temp), TimeUnitsName(time),
     &              AngleUnitsName(deg)
                endif
	      endif	!if ReferenceState exists under ZoneBC_t

	      call cg_nbocos_f(cg, base, zone, nbocos, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              write(6,113)nbocos,' bound. conditions found for ',
     &                   zonename

	      do boco=1, nbocos
	        call cg_boco_info_f(cg, base, zone, boco, boconame,
     &             bocotype, ptset_type, npnts,
     &             NormalIndex, NormalListFlag, datatype,
     &             ndataset, ier)
	   	if (ier .eq. ERROR) call cg_error_exit_f
           	write(6,105) ' boundary condition #',boco
		write(6,600) '  boconame=',boconame
	  	write(6,600) '  bocotype=',BCTypeName(bocotype)
		write(6,600) '  ptset_type=',
     &            PointSetTypeName(ptset_type)
		write(6,103) '  NormalIndex=',
     &            NormalIndex(1),NormalIndex(2), NormalIndex(3)
		write(6,104) '  NormalListFlag=',NormalListFlag
		write(6,600) '  datatype for normals=',
     &            DataTypeName(datatype)

	       ! read patch points and InwardNormalList
	        if (datatype.eq.RealSingle) then
		   call cg_boco_read_f(cg, base, zone, boco, pnts,
     &              data_single, ier)
		   if (ier .eq. ERROR) call cg_error_exit_f
	        elseif (datatype.eq.RealDouble) then
		   call cg_boco_read_f(cg, base, zone, boco, pnts,
     &              data_double, ier)
		   if (ier .eq. ERROR) call cg_error_exit_f
		endif

                write(6,119) '   Bound. Condition Patch:',
     &           '    first point:', pnts(1),pnts(2),pnts(3),
     &           '    last point :', pnts(3*npnts-2), pnts(3*npnts-1),
     &                               pnts(3*npnts)

	 	if (NormalListFlag .ne. 0) then
		  if (datatype.eq.RealSingle)
     &              write(6,126) '   Normals:',
     &           '    first point:', data_single(1),data_single(2),
     &                               data_single(3),
     &           '    last point :', data_single(3*npnts-2),
     &                               data_single(3*npnts-1),
     &                               data_single(3*npnts)
		  if (datatype.eq.RealDouble)
     &              write(6,126) '   Normals:',
     &           '    first point:', data_double(1),data_double(2),
     &                               data_double(3),
     &           '    last point :', data_double(3*npnts-2),
     &                               data_double(3*npnts-1),
     &                               data_double(3*npnts)
		endif
         ! ***  bound. condition attributes: GOTO BC_t node
		call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &              'ZoneBC_t', one, 'BC_t', boco, 'end')
		if (ier .eq. ERROR) call cg_error_exit_f

         ! ***  bound. condition attributes: DataClass_t
	        call cg_dataclass_read_f(type,ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                if (ier.eq.ALL_OK)
     &            write(6,600)'  B.C. DataClass=',
     &                           DataClassName(type)

         ! ***  boundary condition attributes:  GridLocation_t
                call cg_gridlocation_read_f(location, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
		if (ier.eq.ALL_OK)
     &            write(6,600)'    data location=',
     &                   GridLocationName(location)

           ! ** boundary condition dataset
	        write(6,103) '  ndataset=',ndataset
		do idataset=1, ndataset
                  call cg_dataset_read_f(cg, base, zone, boco,idataset,
     &            name, type, DirichletFlag, NeumannFlag, ier)
		  if (ier .eq. ERROR) call cg_error_exit_f

		  write(6,103)'   Dataset #',idataset
		  write(6,600)'    Name=',name
		  write(6,600)'    BCType=',BCTypeName(type)

             ! ** boundary condition data:  GOTO BCData_t node
		  if (DirichletFlag.eq.1) then
		    call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &                'ZoneBC_t', one, 'BC_t', boco, 'BCDataSet_t',
     &                idataset,'BCData_t',Dirichlet,'end')
		      if (ier .eq. ERROR) call cg_error_exit_f

               ! ** boundary condition data attributes: DataClass_t
		    write(6,401)'   Dirichlet DataSet:'
		    call cg_dataclass_read_f(type,ier)
		    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,600)'    DataClass=',
     &                              DataClassName(type)

	       ! ** boundary condition data attributes: DataArray_t
		    call cg_narrays_f(narrays, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,127) '    DirichletData',
     &                         ' contains ', narrays,' data arrays'
                    do iarray=1, narrays
                      call cg_array_info_f(iarray, name, datatype,
     &                              nndim, dim_vals, ier)
                      if (ier .eq. ERROR) call cg_error_exit_f

                      write(6,105) '    DataArray #',iarray,':'
                      write(6,600)'     Name =',name
                      write(6,600)'     Datatype=',
     &                  DataTypeName(datatype)

		      write(6,105)'    Dirichlet Data:'
                      if (datatype .eq. RealSingle) then
                        call cg_array_read_f(iarray, data_single, ier)
                        if (ier .eq. ERROR) call cg_error_exit_f
                        write(6,106)
     &                      (data_single(n),n=1,dim_vals(1))

                      elseif (datatype .eq. RealDouble) then
                        call cg_array_read_f(iarray, data_double, ier)
                        if (ier .eq. ERROR) call cg_error_exit_f
                        write(6,106)
     &                      (data_double(n),n=1,dim_vals(1))
                      endif
		    enddo
		  endif

		  if (NeumannFlag.eq.1) then
		    call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &                  'ZoneBC_t', one, 'BC_t', boco, 'BCDataSet_t',
     &                  idataset, 'BCData_t', Neumann,'end')
                      if (ier .eq. ERROR) call cg_error_exit_f

               ! ** boundary condition data attributes: DataClass_t
                    call cg_dataclass_read_f(type,ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,600)'    DataClass=',
     &                              DataClassName(type)

               ! ** boundary condition data attributes: DataArray_t
                    call cg_narrays_f(narrays, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,105)
     &              '    Neumann Data contains ', narrays,' data arrays'
                    do iarray=1, narrays
                      call cg_array_info_f(iarray, name, datatype,
     &                              nndim, dim_vals, ier)
                      if (ier .eq. ERROR) call cg_error_exit_f

                      write(6,105) '    DataArray #',iarray,':'
                      write(6,600)'     Name =',name
                      write(6,600)'     Datatype=',
     &                  DataTypeName(datatype)

                      write(6,400)'    Neumann Data:'
                      if (datatype .eq. RealSingle) then
                        call cg_array_read_f(iarray, data_single, ier)
                        if (ier .eq. ERROR) call cg_error_exit_f
                        write(6,106)
     &                      (data_single(n),n=1,dim_vals(1))

                      elseif (datatype .eq. RealDouble) then
                        call cg_array_read_f(iarray, data_double, ier)
                        if (ier .eq. ERROR) call cg_error_exit_f
                        write(6,106)
     &                      (data_double(n),n=1,num)
                      endif

                    enddo	! loop through DataArray
		  endif		! if Neumann
		enddo		! loop through dataset
              enddo		! loop through boco
	    endif		! if ZoneBC_t exists
 	  enddo			! zone loop

          write(6,400)'                             *     *     *'

! *** connectivity 1to1 - Global
          write(6,600)' Reading 1to1 connectivity for entire Base'
          call cg_n1to1_global_f(cg, base, n1to1_global, ier)
          if (ier .eq. ERROR) call cg_error_exit_f
          write(6,200)'n1to1_global=',n1to1_global

	  if (n1to1_global .gt. 0) then
	  call cg_1to1_read_global_f(cg, base,
     &       G_connectname, G_zonename, G_donorname,
     &       G_range, G_donor_range, G_transform, ier)
	  if (ier .eq. ERROR) call cg_error_exit_f

	  do i=1, n1to1_global
	    write(6,600) ' '
	    write(6,130) '*** interface #',i,' ***'
	    write(6,600) 'G_connectname="',G_connectname(i),'"'
	    write(6,600) 'G_zonename   ="',G_zonename(i),'"'
	    write(6,600) 'G_donorname  ="',G_donorname(i),'"'

	    write(6,131) 'G_range: ',
     &           '(',G_range(1,i),',',G_range(2,i),',',G_range(3,i),
     &      ') to (',G_range(4,i),',',G_range(5,i),',',G_range(6,i),')'

            write(6,132) 'G_donor_range: ',
     &     '(', G_donor_range(1,i), ',', G_donor_range(2,i), ',',
     &          G_donor_range(3,i), ') to (',
     &          G_donor_range(4,i), ',', G_donor_range(5,i), ',',
     &          G_donor_range(6,i), ')'

	   write(6,133) 'Transform: ', '(',
     &          G_transform(1,i), ',',
     &          G_transform(2,i), ',', G_transform(3,i), ')'
	  enddo
	  endif


 	enddo    				! loop through bases

        write(6,400)'                             *     *     *'

        call cg_close_f(cg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

 100 	format(a/,'    Mass units: ',a/,'    Length units: ',a/,
     &    '    Temperature units: ',a/,'    Time units: ',a/,
     &    '    Angle units:',a)
 101	format(a,i1,a,/2a,/2a,/2a,/3a,/a,i4,3a,/2a,/2a,/2a,/a,i4)
 102 	format(a,f5.3)
 103	format(a,6i2)
 104	format(a,i5,3a)
 105	format(a,i2,a)
 106    format(6f10.3)
 107	format(i2,2a)
 108    format(a,i2,a,i2,a)
 109	format(a,f5.1)
 110	format(a,5f5.1)
 111	format(a,i1,a,i8)
 112	format(a,i1/2a/3a)
 113	format(i1,3a)
 114	format(/a, i1)
 115	format(a,i1,a/3a/2a)
 116	format(a,i1,a,i1,a)
 117	format(/i4,2a)
 118	format(a,i1,a/3a/2a/a,i1,a,i5)
 119	format(a/a,3i2/a,3i2)
 120	format(a10, 3(a1,i1),a6,3(i1,a1))
 121 	format(a16,3(a1,i1),a6,3(i1,a1))
 122	format(a12,3(a1,i2),a1)
 124	format(4x, f7.2)
 126	format(a/a,3f5.2/a,3f5.2)
 127	format(2a,i1,a)
 130	format(a15, i2, a4)
 131	format(a10, 3(a1,i1),a6,3(i1,a1))
 132	format(a16,3(a1,i1),a6,3(i1,a1))
 133	format(a12,3(a1,i2),a1)
 200    format(a,i5)
 300	format(3a/a,i2)
 400	format(/a/)
 401	format(/2a/)
 500	format(3a/3a)
 600	format(3a)

 9999	end

      program read_grid_str
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Reads simple 3-D structured grid from CGNS file
!   (companion program to write_grid_str.f)
!
!   The CGNS grid file 'grid.cgns' must already exist.
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c read_grid_str.F90
!   ifort -o read_grid_str read_grid_str.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
!   dimension statements (note that tri-dimensional arrays
!   x,y,z must be dimensioned exactly as (21,17,N) (N>=9)
!   for this particular case or else they will be read from
!   the CGNS file incorrectly!  Other options are to use 1-D
!   arrays, use dynamic memory, or pass index values to a
!   subroutine and dimension exactly there):
      real*4 x(21,17,9),y(21,17,9),z(21,17,9)
      integer(cgsize_t) isize(3,3),irmin(3),irmax(3)
      integer index_zone,index_base,index_file,ier
      character zonename*32
!
!   READ X, Y, Z GRID POINTS FROM CGNS FILE
!   open CGNS file for read-only
      call cg_open_f('grid.cgns',CG_MODE_READ,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!   we know there is only one base (real working code would check!)
      index_base=1
!   we know there is only one zone (real working code would check!)
      index_zone=1
!   get zone size (and name - although not needed here)
      call cg_zone_read_f(index_file,index_base,index_zone,zonename,           &
           isize,ier)
!   lower range index
      irmin(1)=1
      irmin(2)=1
      irmin(3)=1
!   upper range index of vertices
      irmax(1)=isize(1,1)
      irmax(2)=isize(2,1)
      irmax(3)=isize(3,1)
!   read grid coordinates
      call cg_coord_read_f(index_file,index_base,index_zone,                   &
           'CoordinateX',CGNS_ENUMV(RealSingle),irmin,irmax,x,ier)
      call cg_coord_read_f(index_file,index_base,index_zone,                   &
           'CoordinateY',CGNS_ENUMV(RealSingle),irmin,irmax,y,ier)
      call cg_coord_read_f(index_file,index_base,index_zone,                   &
           'CoordinateZ',CGNS_ENUMV(RealSingle),irmin,irmax,z,ier)
!   close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully read grid from file grid.cgns'')')
      write(6,'(''   For example, x,y,z(21,17,9)='',3f12.5)')                  &
       x(21,17,9),y(21,17,9),z(21,17,9)
      write(6,'('' Program successful... ending now'')')
      stop
      end

        program read_mixed_grid
	USE CGNS

!	author: Diane Poirier
!       last revised on August 24 00

!       This example read a CGNS file composed of structured and/or
!       unstructured zones.
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif

        parameter (NNODES=200000, NELEMENTS=200000)

	integer Cdim, Pdim, Idim, Idim_donor
	integer cg, base, zone, size(3*3), ier, ZoneType
	integer nbases, nzones, ncoords, nsections, nconns, nbocos
	integer nfambc, ngeo, nfamilies, nparts, dim_vals(12)
	integer i, n, sect, range_min(3), range_max(3)
	integer start, end, nbndry, type
        integer elements(NELEMENTS*8), parent_data(NELEMENTS*4)
	integer pnts(3*NNODES), donor_data(3*NNODES)
	integer fam, geo, part,bc, bctype, location, connect_type
	integer ptset_type, npnts, ndata_donor, datatype
	integer donor_ptset_type, donor_datatype, donor_zonetype
	character*32 nodename, cadformat, filename, donorname
	character*32 coordname(3)
	character*200 cadfile, descriptor
        double precision data_double(NNODES)
	integer NormalIndex(3), NormalListFlag, ndataset
	double precision NormalListDouble(3*NNODES)
	real*4 NormalListSingle(3*NNODES)
	integer size_of_patch, multiplier
	
	integer ilen, ilen2
	integer ordinal

!       initialize
        ier = 0

        write(6,100) 'Input filename'
        read(5,100) filename
!       open CGNS file for reading
!       write(filename,100)'Test_Uns_V1.27'
 100	format(a)

 	call cg_open_f(filename, MODE_READ, cg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
	write(6,101)'File Opened and Read '
 101	format(/a/)

!*******read CGNSBase
	call cg_nbases_f(cg, nbases, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	if (nbases .gt. 1) then
	    write(6,100)'This program reads only the first base'
	else if (nbases .le. 0) then
	    write(6,100)'No base found'
	    goto 9999
	endif
	base = 1
	call cg_base_read_f(cg, base, nodename, Cdim, Pdim, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	ilen=32
        call no_blank(nodename, ilen)
        write(6,100)'*** CGNSBase_t node ***'
        write(6,102)'Name= "',nodename(1:ilen),'"'
        write(6,103)'CellDimension=',Cdim
        write(6,103)'PhysDimension=',Pdim
	write(6,100)' '

! FAMILY and GEOMETRY
!****** Read number of families and family names
	call cg_nfamilies_f(cg, base, nfamilies, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

        do fam=1,nfamilies
	   call cg_family_read_f(cg, base, fam, nodename, nfambc, ngeo,
     &             ier)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	   if (ier .eq. ERROR) call cg_error_exit_f

	    ilen=32
	    call no_blank(nodename, ilen)
            write(6,103)'*** Family_t nodes ***'
	    write(6,106)'Name= "',nodename(1:ilen),'"'
	    write(6,107)'no.of FamilyBC_t=',nfambc
	    write(6,107)'no.of GEO=',ngeo
	    write(6,100)' '

          ! A family may have several GeometryReference_t node
            do geo=1, ngeo
                call cg_geo_read_f(cg, base, fam, geo, nodename,
     &              cadfile, cadformat, nparts, ier)
                if (ier .eq. ERROR) call cg_error_exit_f

		write(6,106)'*** GeometryReference_t nodes ***'
		ilen=32
                call no_blank(nodename, ilen)
		write(6,109)'Name= "',nodename(1:ilen),'"'
                ilen=32
                call no_blank(cadfile, ilen)
		write(6,109)'cadfile= "',cadfile(1:ilen),'"'
                ilen=32
                call no_blank(cadformat, ilen)
		write(6,109)'cadformat= "',cadformat(1:ilen),'"'
		write(6,110)'nparts=',nparts
		write(6,100)' '

                ! A GeometryReference_t may encompass several parts
                do part = 1, nparts
                    call cg_part_read_f(cg, base, fam, geo, part,
     &                  nodename, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
		    ilen=32
		    call no_blank(nodename, ilen)
		    write(6,111)'part= "',nodename(1:ilen),'"'
                enddo

              ! GeometryReference_t descriptor
                call cg_goto_f(cg, base, ier, 'Family_t', fam,
     &           'GeometryReference_t',geo,'end')
                if (ier .eq. ERROR) call cg_error_exit_f

		if (ier .eq. ALL_OK) then

		    call cg_ndescriptors_f(n, ier)
		    if (ier .eq. ERROR) call cg_error_exit_f
		    write(6,100)' '
		    write(6,110)'ndescr=',n
		    write(6,100)' '

		    do i=1, n
                        call cg_descriptor_read_f(i,nodename,
     &                     descriptor, ier)
                        if (ier .eq. ERROR) call cg_error_exit_f
			ilen = 32
			ilen2=200
			call no_blank(nodename, ilen)
			call no_blank(descriptor, ilen2)
		        write(6,111)'Descriptor_t: "',nodename(1:ilen),
     &                    '" is "',descriptor(1:ilen2),'"'
		    enddo
		endif
            enddo

            do bc=1,nfambc, 1
	        write(6,106)'*** FamilyBC_t nodes ***'
                call cg_fambc_read_f(cg, base, fam, bc, nodename,
     &            bctype, ier)
                if (ier .eq. ERROR) call cg_error_exit_f

		ilen=32
		call no_blank(nodename, ilen)
		write(6,109)'Name= "',nodename(1:ilen),'"'
		write(6,109)
     &            'BCType= ',BCTypeName(bctype)
		write(6,100)' '
            enddo

         !  Family Descriptor and Ordinal
            call cg_goto_f(cg, base, ier, 'Family_t', fam, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f

	    if (ier .eq. ALL_OK) then

	        call cg_ndescriptors_f(n, ier)
	        if (ier .eq. ERROR) call cg_error_exit_f
		write(6,107)'ndescriptors=',n
                do i=1, n
                    call cg_descriptor_read_f(i,nodename,
     &                 descriptor, ier)
		    if (ier .eq. ERROR) call cg_error_exit_f

		    ilen = 32
                    ilen2=200
                    call no_blank(nodename, ilen)
                    call no_blank(descriptor, ilen2)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
                    write(6,111)'Descriptor_t: "',
     &              nodename(1:ilen),'" is "',descriptor(1:ilen2),'"'
                enddo

                call cg_ordinal_read_f(ordinal, ier)
	        if (ier .eq. ERROR) call cg_error_exit_f
                if (ier.eq.ALL_OK)
     &              write(6,108)'Ordinal=',ordinal
		    write(6,100)' '
	    endif
        enddo

! ******read CGNSBase substructure: Zone
	call cg_nzones_f(cg, base, nzones, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

        write(6,103)'nzones=',nzones
	write(6,100)' '

	! ******read CGNSBase substructure: Zone
        do zone=1, nzones
            call cg_zone_read_f(cg,base,zone, nodename,size,ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

	    call cg_zone_type_f(cg, base, zone, ZoneType, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

	    Idim=Cdim
	    if (ZoneType .eq. CGNS_ENUMV(Unstructured)) Idim=1

            write(6,100)'*** Zone_t node ***'
            ilen=32
            call no_blank(nodename, ilen)
            write(6,102)'Name= "',nodename(1:ilen),'"'
            write(6,102)'ZoneType= ',ZoneTypeName(ZoneType)
            write(6,113)'Size= ', (size(i),i=1,Idim*3)

! COORDINATES
	    call cg_ncoords_f(cg, base, zone, ncoords, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
	    write(6,103)'ncoords=',ncoords

	    write(6,103)'Idim=',Idim
	    do i=1, Idim
		range_min(i)=1
		range_max(i)=size(i)
	    enddo
	    write(6,113)
     &           'range:',(range_min(i),i=1,Idim),
     &                    (range_max(i),i=1,Idim)
! Name convention
            coordname(1) = 'CoordinateX'
            coordname(2) = 'CoordinateY'
            coordname(3) = 'CoordinateZ'
	    do i=1, Pdim
	        call cg_coord_read_f(cg, base, zone, coordname(i),
     &            CGNS_ENUMV(RealDouble), range_min, range_max, data_double, ier)
	        if (ier .eq. ERROR) call cg_error_exit_f
		write(6,114)coordname(i),'=',data_double(1)
	    enddo

! GOTO Zone node and read family name :
            call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f
	    if (ier .eq. ALL_OK) then
	  	call cg_famname_read_f(nodename, ier)
	        if (ier .eq. ERROR) call cg_error_exit_f
		if (ier .eq. ALL_OK) then
		    ilen=32
              	    call no_blank(nodename, ilen)
		    if (ilen.gt.0) then
		      write(6,102) 'FamilyName= "',
     &                                    nodename(1:ilen),'"'
		    endif
		endif
	    endif


! CONNECTIVITY
	    call cg_nconns_f(cg, base, zone, nconns, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

	    do n=1, nconns
		call cg_conn_info_f(cg, base, zone, n, nodename,
     &           location, connect_type, ptset_type, npnts,
     &           donorname, donor_zonetype, donor_ptset_type,
     &           donor_datatype, ndata_donor, ier)
		if (ier .eq. ERROR) call cg_error_exit_f

                write(6,100)'*** GridConnectivity_t node ***'
                ilen=32
                call no_blank(nodename, ilen)
                write(6,102)'Name= "',nodename(1:ilen),'"'
                write(6,102)'GridLocation=',
     &                             GridLocationName(location)
                write(6,102)'Connectivity Type=',
     &              GridConnectivityTypeName(connect_type)
                write(6,102)'PtsetType=',
     &                             PointSetTypeName(ptset_type)
                write(6,104)'npnts=',npnts
                ilen=32
                call no_blank(donorname, ilen)
                write(6,102)'DonorName="',donorname(1:ilen),'"'
                write(6,102)'DonorZonetype=',
     &              ZoneTypeName(donor_zonetype)
                write(6,102)'DonorDatatype=',
     &              DataTypeName(donor_datatype)
                write(6,102)'DonorPtsetType=',
     &              PointSetTypeName(donor_ptset_type)
                write(6,104)'ndata_donor=',ndata_donor

                call cg_conn_read_f(cg, base, zone, n,
     &              pnts, CGNS_ENUMV(Integer), donor_data, ier)
                if (ier .eq. ERROR) call cg_error_exit_f

		write(6,102) 'pnts receiver:'
		write(6,112)(pnts(i),i=1,Idim)
		write(6,108)' to ',
     &               (pnts((npnts-1)*Idim+i),i=1,Idim)

		if (donor_zonetype .eq. CGNS_ENUMV(Unstructured)) then
		    Idim_donor = 1
		else
		    Idim_donor = Cdim
		endif
		write(6,102) 'pnts donor:'
		write(6,112)(donor_data(i), i=1,Idim_donor)
		write(6,108)' to ',
     &		    (donor_data((ndata_donor-1)*Idim_donor+i),
     &			i=1,Idim_donor)
		
! Look for interpolants
	        if (donor_ptset_type .eq. CGNS_ENUMV(CellListDonor)) then
		    call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &                  'ZoneGridConnectivity_t', 1,
     &                  'GridConnectivity_t', 1, 'end')
                    if (ier .eq. ERROR) call cg_error_exit_f

		    if (ier .eq. ALL_OK) then

			call cg_array_info_f(1, nodename, datatype,
     &                       ndim, dim_vals, ier)
			if (ier .eq. ERROR) call cg_error_exit_f

			call cg_array_read_f(1, data_double, ier)
			if (ier .eq. ERROR) call cg_error_exit_f
		    endif
		endif
	    enddo

! BOUNDARY CONDITION PATCH: Put a user defined b.c. at interface
            write(6,100)'*** ZoneBC_t node ***'
	    call cg_nbocos_f(cg, base, zone, nbocos, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

	    write(6,103)'nbocos=',nbocos

	    do bc=1, nbocos, 1
	
		write(6,100)'*** BC_t node ***'
		call cg_boco_info_f(cg, base, zone, bc, nodename,
     &           bctype, ptset_type, npnts, NormalIndex, NormalListFlag,
     &           datatype, ndataset, ier)

                ilen=32
                call no_blank(nodename, ilen)
                write(6,102)'Name= "',nodename(1:ilen),'"'
                write(6,102)'BCType= ',BCTypeName(bctype)
                write(6,102)'PtsetType= ',
     &                             PointSetTypeName(ptset_type)
                write(6,105)'npnts=',npnts

		write(6,102)'NormalIndex:'
		write(6,112)(NormalIndex(i),i=1,Idim)
		write(6,105)'NormalListFlag=',NormalListFlag
		write(6,102)'NormalDataType= ',
     &                             DataTypeName(datatype)
		write(6,105)'ndataset=',ndataset

		if (datatype.eq.CGNS_ENUMV(RealSingle)) then
	            call cg_boco_read_f(cg, base, zone, bc, pnts,
     &              	NormalListSingle, ier)
	            if (ier .eq. ERROR) call cg_error_exit_f
		else
		    call cg_boco_read_f(cg, base, zone, bc, pnts,
     &                  NormalListDouble, ier)
		    if (ier .eq. ERROR) call cg_error_exit_f
		endif

                write(6,102) 'pnts range:'
		write(6,112)(pnts(i),i=1,Idim)
                write(6,108)' to ',
     &               (pnts((npnts-1)*Idim+i),i=1,Idim)

              ! number of points or faces in bcpatch
                if (ptset_type.eq. CGNS_ENUMV(PointList) .or.
     &              ptset_type.eq. CGNS_ENUMV(ElementList)) then
                    size_of_patch = npnts
                else if (ptset_type.eq. CGNS_ENUMV(PointRange) .or.
     &                   ptset_type.eq. CGNS_ENUMV(ElementRange)) then
                    size_of_patch=1
                    do i=1,Idim
                        multiplier=pnts((npnts-1)*Idim+i) - pnts(i) + 1
                        size_of_patch = size_of_patch * multiplier
                    enddo
                endif
                write(6,105)'size_of_patch=',size_of_patch

	      ! InwardNormalList
		if (NormalListFlag.eq.1) then
		    if (datatype.eq.CGNS_ENUMV(RealSingle)) then
			write(6,102) '1st and last normal vector:'
			write(6,118)(NormalListSingle(i),i=1,Pdim)
			write(6,118)
     &                  (NormalListSingle((npnts-1)*Pdim+i),i=1,Pdim)
		    else
		  	write(6,102) '1st and last normal vector:'
                        write(6,118)(NormalListDouble(i),i=1,Pdim)
                        write(6,118)
     &                  (NormalListDouble((npnts-1)*Pdim+i),i=1,Pdim)
		    endif
		endif


		call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &             'ZoneBC_t', 1, 'BC_t', bc, 'end')
		if (ier .eq. ERROR) call cg_error_exit_f

		if (ier .eq. ALL_OK) then
		    call cg_famname_read_f(nodename, ier)
		    if (ier .eq. ERROR) call cg_error_exit_f

		    ilen=32
		    call no_blank(nodename, ilen)
		    if (ilen.gt.0) then
		      write(6,102)'FamilyName= "',
     &                                   nodename(1:ilen),'"'
		    endif
		endif
	    enddo

! ********** SPECIAL FOR UNSTRUCTURED ZONES ONLY **********

	    if (ZoneType .eq. CGNS_ENUMV(Unstructured)) then

! read element sections (Element_t) :
		call cg_nsections_f(cg, base, zone, nsections, ier)
		if (ier .eq. ERROR) call cg_error_exit_f

		write(6,100)'*** Elements_t Nodes ***'

		write(6,103)'nsections=',nsections

		do sect=1, nsections
		    write(6,201)'  *** Section ',sect,' ***'
 201	format(/a,i2,a)
		    call cg_section_read_f(cg, base, zone, sect,
     &                  nodename, type, start, end, nbndry,
     &                  parent_flag, ier)
		    if (ier .eq. ERROR) call cg_error_exit_f

		    if (type .ne. CGNS_ENUMV(MIXED)) then
		       call cg_npe_f(type, npe, ier)
		       if (ier .eq. ERROR) call cg_error_exit_f
  		       write(6,103)'npe=',npe
  		       write(6,103)'type=',type
		    endif

                    ilen=32
                    call no_blank(nodename, ilen)
                    write(6,102)'Name= "',nodename(1:ilen),'"'
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
		    if (type .gt. CGNS_ENUMV(NGON_n)) then
                         write(6,100) 'Element Type=  NGON_n'
                    else
			write(6,102)'Element Type= ',
     &                                ElementTypeName(type)
		    endif
		    write(6,113)'Range= ',start,end
		    if (nbndry .ne. 0) write(6,102)'Sorted elements'

		    call cg_elements_read_f(cg, base, zone, sect,
     &                 elements, parent_data, ier)
		    if (ier.eq.ERROR)  call cg_error_exit_f

		    nelem = end-start+1
		    write(6,102)'Element Connectivity:'
		
		    icount = 1
		    do i=1, nelem
		        if (type.eq.MIXED) then
			  call cg_npe_f(elements(icount), npe, ier)
			  write(6,115)(elements(icount+n),n=1,npe)
			  icount = icount + npe + 1
		        else
		         write(6,115)(elements((i-1)*npe+n),n=1,npe)
		        endif
			if (i.eq.10) goto 17
		    enddo
 17		    continue

		    if (parent_flag .ne. 0) then
			write(6,102)'Parent Data:'
			do i=1, 4
			     write(6,116)
     & 				(parent_data((i-1)*nelem+n), n=1,nelem)
			enddo
		    endif
! Auxiliary data
		    call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &                  'Elements_t', sect, 'end')
		    if (ier .eq. ERROR) call cg_error_exit_f

		    if (ier .eq. ALL_OK) then
			call cg_ndescriptors_f(n, ier)
                	if (ier .eq. ERROR) call cg_error_exit_f
                	do i=1, n
                    	    call cg_descriptor_read_f(i,nodename,
     &                 	                              descriptor, ier)
                    	    if (ier .eq. ERROR) call cg_error_exit_f

                            ilen = 32
                            ilen2=200
                            call no_blank(nodename, ilen)
                            call no_blank(descriptor, ilen2)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
                            write(6,117)'Descriptor_t: "',
     &                                  nodename(1:ilen),'" is "',
     &                                    descriptor(1:ilen2),'"'
                	enddo
		    endif
		enddo
	    endif

! *********************************************************************

        enddo	! zone loop

	write(6,100)'calling cg_close_f'
	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f()

 102    format(6x,3a)
 103    format(6x,a,i3)
 104    format(6x,a,i3)
 105    format(6x,a,i5)
 106    format(8x,3a)
 107    format(8x,a,i3)
 108    format(8x,a,3i6)
 109    format(10x,3a)
 110    format(10x,a,i3)
 111    format(12x,5a/)
 112    format(12x,3i6)
 113    format(6x, a, 9i6)
 114    format(6x,2a,e13.6)
 115    format(6x,8i6)
 116    format(6x,4i3)
 117    format(6x,5a/)
 118    format(12x,3e13.6)


 9999   end


        subroutine no_blank(Text, length)

        character*(*) Text
        integer i, ilen, length

        ilen=0
        do i=length,1,-1
             if (Text(i:i).ne.' ') then
                 ilen=i
                 goto 17
             endif
        enddo

 17     length = ilen

        return
        end

      program read_flowvert_unst
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Opens an existing CGNS file that contains a simple 3-D
!   unstructured grid plus a flow solution (at VERTICES),
!   and reads it.
!
!   The CGNS grid file 'grid.cgns' must already exist
!   (created using write_grid_unst.f followed by
!   write_flowvert_unst.f)
!   Note that, other than the dimensions of the variables
!   r and p, this program is very similar to that for
!   reading flow solutions from a structured zone:
!   read_flowvert_str.f
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c read_flowvert_unst.F90
!   ifort -o read_flowvert_unst read_flowvert_unst.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
      real*4 r(21*17*9),p(21*17*9)
      integer(cgsize_t) isize(1,3),irmin,irmax
      integer loc,index_flow,index_zone,index_base,index_file,ier
      character*32 zonename,solname
!
!   READ FLOW SOLUTION FROM CGNS FILE
!   open CGNS file for read-only
      call cg_open_f('grid.cgns',CG_MODE_READ,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!   we know there is only one base (real working code would check!)
      index_base=1
!   we know there is only one zone (real working code would check!)
      index_zone=1
!   we know there is only one FlowSolution_t (real working code would check!)
      index_flow=1
!   get zone size (and name - although not needed here)
      call cg_zone_read_f(index_file,index_base,index_zone,zonename,isize,ier)
!   lower range index
      irmin=1
!   upper range index - use vertex dimensions
!   checking GridLocation first (real working code would check
!   to make sure there are no Rind cells also!):
      call cg_sol_info_f(index_file,index_base,index_zone,index_flow,          &
           solname,loc,ier)
      if (loc .ne. CGNS_ENUMV(Vertex)) then
        write(6,'('' Error, GridLocation must be Vertex!  Currently:'',        &
         a32)') GridLocationName(loc)
        stop
      end if
      irmax=isize(1,1)
!   read flow solution
      call cg_field_read_f(index_file,index_base,index_zone,index_flow,        &
           'Density',CGNS_ENUMV(RealSingle),irmin,irmax,r,ier)
      call cg_field_read_f(index_file,index_base,index_zone,index_flow,        &
           'Pressure',CGNS_ENUMV(RealSingle),irmin,irmax,p,ier)
!   close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully read flow solution from file'',                &
       '' grid.cgns'')')
      write(6,'(''   For example, r,p(380) ='',2f12.5)')                       &
       r(380),p(380)
      write(6,'(''                r,p(3213)='',2f12.5)')                       &
       r(3213),p(3213)
      write(6,'('' Program successful... ending now'')')
      stop
      end

	program write_cprop
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on August 2002

!       This example test the GridConnectivityProperty_t data structure and its children
!       It tests the functions:
!	- cg_conn_average_write_f(cg, B, Z, I, AverageInterfaceType, ier)
!	- cg_conn_periodic_write_f(cg, B, Z, I, RotationCenter, RotationAngle, Translation, ier)
!       And the following:
!       - multiple calls for the same I => must return error in mode write
!       - cg_descriptor_write under GridConnectivityProperty_t, AverageInterface_t, Periodic_t
!       - cg_user_data_write, under GridConnectivityProperty_t, AverageInterface_t, Periodic_t
!       - cg_array_write under Periodic_t => should return an error
!       - links under GridConnectivityProperty_t, AverageInterface_t, Periodic_t
!       - cg_goto to GridConnectivityProperty_t, AverageInterface_t, Periodic_t
!       - Memory check with Insure

#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 3)
	integer index_dim, cell_dim, phys_dim
	character*100 linkpath

	integer cg, base, zone, conn, ier, i, num, n
	integer(cgsize_t) size(Ndim*3)
	integer AverageInterfaceType
        integer(cgsize_t) pnts(Ndim,20), donor_pnts(Ndim,20)
	real *4 RotationCenter(Ndim), RotationAngle(Ndim)
	real *4 Translation(Ndim)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	integer dim_vals(2)
	

! *** initialize
	ier = 0
	index_dim=Ndim
	cell_dim=Ndim
	phys_dim=Ndim

! *** open CGNS file for writing
 	call cg_open_f('Test_V2', MODE_WRITE, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f

! *** base
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
 	call cg_base_write_f(cg, 'Basename', cell_dim, phys_dim,
     &                       base, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f

! *** write a descriptor under the base
        call cg_goto_f(cg, base, ier, 'end')
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_descriptor_write_f('BaseDescriptorName',
     &      'BaseDescriptorText', ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** write 2 zones
	do i=1,index_dim                    	! zone#1: 3*4*5
	    size(i) = i+2			! nr of nodes in i,j,k
	    size(i+index_dim) = size(i)-1	! nr of elements in i,j,k
	    size(i+2*index_dim) = 0		! nr of bnd nodes if ordered
	    num = num * size(i)             	! nr of nodes
	enddo

	call cg_zone_write_f(cg, base, 'Zone#1', size, Structured,
     & 	    zone, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_zone_write_f(cg, base, 'Zone#2', size, Structured,
     &      zone, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	zone = 1

! *** write conns
	do 100 n=1, 5
        do 100 i=1,3
            pnts(i,n)=i             ! * dummy data
            donor_pnts(i,n)=i*2
 100    continue
        call cg_conn_write_f(cg, base, zone, 'Connect#1',
     &      Vertex, Abutting1to1, PointList, 5_cgsize_t, pnts, 'Zone#2',
     &      Structured, PointListDonor, Integer, 5_cgsize_t, donor_pnts,
     &      conn, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_conn_write_f(cg, base, zone, 'Connect#2',
     &      Vertex, Abutting1to1, PointList, 5_cgsize_t, pnts, 'Zone#2',
     &      Structured, PointListDonor, Integer, 5_cgsize_t, donor_pnts,
     &      conn, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
	
! *** write GridConnectivityProperty_t/AverageInterface_t node under conn#2
	AverageInterfaceType = AverageCircumferential
	call cg_conn_average_write_f(cg, base, zone,
     &        conn, AverageInterfaceType, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** test calling it again
!	call cg_conn_average_write_f(cg, base, zone,
!    &        conn, AverageInterfaceType, ier)
!       if (ier .eq. ERROR) call cg_error_print_f

! *** write GridConnectivityProperty_t/Periodic_t node under conn#2
	do n=1, Ndim
	    RotationCenter(n) = n*1.1
	    RotationAngle(n) = (n+3)*1.1
	    Translation(n) = (n+6)*1.1
	enddo
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	call cg_conn_periodic_write_f(cg, base, zone, conn,
     & 	     RotationCenter, RotationAngle, Translation, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! *** write Descriptor_t, UserDefinedData_t & Link under...
! ...   GridConnectivityProperty_t
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
        call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &      'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn,
     &	    'GridConnectivityProperty_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_descriptor_write_f('GridConnPropDescriptorName',
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
     &      'GridConnPropDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_user_data_write_f('GridConnPropUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! ...   AverageInterface_t
	call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &	    'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn,
     &      'GridConnectivityProperty_t', 1, 'AverageInterface_t', 1,
     &      'end')
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_descriptor_write_f('AverageInterfaceDescriptorName',
     &	    'AverageInterfaceDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_user_data_write_f('AverageInterfaceUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! ...   Periodic_t
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
        call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &      'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn,
     &      'GridConnectivityProperty_t', 1, 'Periodic_t', 1, 'end')
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_descriptor_write_f('PeriodicDescriptorName',
     &	    'PeriodicDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_user_data_write_f('PeriodicUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * DataClass & DimensionalUnits under Periodic
        call cg_dataclass_write_f(Dimensional, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        call cg_units_write_f(Kilogram, Meter, Second, Kelvin,
     &                        Radian, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * DataArray under Periodic
 	dim_vals(1)=3
 	dim_vals(2)=2
 	call cg_array_write_f('arraysize', Integer, 2, dim_vals,
     &        size, ier)
 	if (ier .ne. ERROR) write(6,'(a)') 'Error in API'

! * DataClass & DimensionalUnits under RotationCenter
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &      'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn,
     &      'GridConnectivityProperty_t', 1, 'Periodic_t', 1,
     &      'DataArray_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_dataclass_write_f(Dimensional, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	call cg_units_write_f(Kilogram, Meter, Second, Kelvin,
     &	    		      Radian, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

! *** close CGNS file
	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	end

	program write_bprop
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on August 2002

!       This example test the BCProperty_t data structure and its children
!       It tests cg_delete for the following nodes:
!       - child of BC_t: BCProperty_t
!       - children of BCProperty_t: WallFunction_t, Area_t, Descriptor_t, UserDef._t
!       - children of WallFunction_t: WallFunctionType_t, Descriptor_t, UserDef._t
!       - children of Area_t: AreaType_t, SurfaceArea, RegionName, Descriptor_t, UserDef._t

#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 3)
	integer index_dim, cell_dim, phys_dim
	character*100 linkpath

	integer cg, base, zone, boco, ier, size(Ndim*3), i, num
	integer WallFunctionType, AreaType, pnts(Ndim,2), nbases
	character*32 RegionName32, basename, dummy
	real *4 SurfaceArea, version
	integer dim_vals(2)
	

! *** initialize
	ier = 0
	index_dim=Ndim
	cell_dim=Ndim
	phys_dim=Ndim

! *** open CGNS file for writing
 	call cg_open_f('Test_V2', MODE_MODIFY, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,600)'MODIFYING FILE Test_V2'

! *** CGNS Library Version used for file creation:
        call cg_version_f(cg, version, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,102)
     &     'Library Version used for file creation:',version

! *** base
	call cg_nbases_f(cg, nbases, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,200)'nbases=',nbases

	base=1

        call cg_base_read_f(cg, base, basename, cell_dim, phys_dim, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,300)'BaseName = "',basename,'"',
     &                'cell_dimension=',cell_dim

	zone = 1
	boco = 2

! *** delete children of DataArray_t "SurfaceArea"
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1,
     &      'BC_t', boco, 'BCProperty_t', 1, 'Area_t', 1, 'DataArray_t',
     &      1, 'end')

        if (ier. eq. ALL_OK) then
            call cg_delete_node_f('DataClass', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_delete_node_f('DimensionalUnits', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

            write(6,*) 'Children of SurfaceArea deleted.  Continue?'
	    read(5,600) dummy
        endif

! *** delete children of Area_t: AreaType_t, SurfaceArea, RegionName, Descriptor_t, UserDef._t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1,
     &      'BC_t', boco, 'BCProperty_t', 1, 'Area_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        if (ier. eq. ALL_OK) then
!           AreaType, SurfaceArea, RegionName can't be deleted,
!           so we expect an error from the API
            call cg_delete_node_f('AreaType', ier)
            if (ier .eq. ERROR) call cg_error_print_f

            call cg_delete_node_f('SurfaceArea', ier)
            if (ier .eq. ERROR) call cg_error_print_f

            call cg_delete_node_f('RegionName',ier)
            if (ier .eq. ERROR) call cg_error_print_f

            call cg_delete_node_f('AreaDescriptorName', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_delete_node_f('AreaUserData', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

	    write(6,*) 'Children of Area deleted.  Continue?'
            read(5,600) dummy
        endif

! *** delete children of WallFunction_t: WallFunctionType_t, Descriptor_t, UserDef._t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1,
     &      'BC_t', boco, 'BCProperty_t', 1, 'WallFunction_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        if (ier. eq. ALL_OK) then
            call cg_delete_node_f('WallFunctionType', ier)
            if (ier .eq. ERROR) call cg_error_print_f

            call cg_delete_node_f('WFDescriptorName', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_delete_node_f('WFUserData', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

	    write(6,*) 'Children of WallFunction deleted.  Continue?'
            read(5,600) dummy
        endif

! *** delete children of BCProperty_t: WallFunction_t, Area_t, Descriptor_t, UserDef._t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1,
     &      'BC_t', boco, 'BCProperty_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

	if (ier .eq. ALL_OK) then
            call cg_delete_node_f('WallFunction', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_delete_node_f('Area', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_delete_node_f('BCpropDescriptorName', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_delete_node_f('BCPropUserData', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

	    write(6,*) 'Children of BCProperty deleted.  Continue?'
            read(5,600) dummy
	endif

! *** delete child of BC_:  BCProperty_t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1,
     &      'BC_t', boco, 'end')
	if (ier .eq. ERROR) call cg_error_exit_f

	if (ier .eq. ALL_OK) then
            call cg_delete_node_f('BCProperty', ier)
            if (ier .eq. ERROR) call cg_error_exit_f

	    write(6,*) 'BCProperty deleted.  Continue?'
	    read(5,600) dummy
	endif

! Rewrite everything back

! *** write BCProperty_t/WallFunction_t node under boco#2
        WallFunctionType = Generic
        call cg_bc_wallfunction_write_f(cg, base, zone,
     &        boco, WallFunctionType, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(6,*)'WallFunction_t written'

! *** write BCProperty_t/Area_t node under boco#2
        AreaType = BleedArea
        SurfaceArea = 123.456
        RegionName32 = 'myRegion'
        call cg_bc_area_write_f(cg, base, zone, boco, AreaType,
     &       SurfaceArea, RegionName32, ier)

        write(6,*)'Area_t written'


! *** write Descriptor_t, UserDefinedData_t & Link under...
! ...   BCProperty_t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1,
     &      'BC_t', boco, 'BCProperty_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_descriptor_write_f('BCpropDescriptorName',
     &      'BCpropDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_user_data_write_f('BCPropUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! ...   WallFunction_t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1,
     &      'BC_t', boco, 'BCProperty_t', 1, 'WallFunction_t', 1, 'end')

        call cg_descriptor_write_f('WFDescriptorName',
     &      'WFDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_user_data_write_f('WFUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! ...   Area_t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1,
     &      'BC_t', boco, 'BCProperty_t', 1, 'Area_t', 1, 'end')

        call cg_descriptor_write_f('AreaDescriptorName',
     &      'AreaDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_user_data_write_f('AreaUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        dim_vals(1)=3
        dim_vals(2)=2
        call cg_array_write_f('arraysize', Integer, 2, dim_vals,
     &        size, ier)
        if (ier .ne. ERROR) write(6,'(a)') 'Error in API'

! * DataClass & DimensionalUnits under SurfaceArea
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1,
     &      'BC_t', boco, 'BCProperty_t', 1, 'Area_t', 1, 'DataArray_t',
     &      1, 'end')

        call cg_dataclass_write_f(Dimensional, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        call cg_units_write_f(Kilogram, Meter, Second, Kelvin,
     &                        Radian, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

! *** close CGNS file
	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

 102    format(a,f8.3)
 200    format(a,i5)
 300    format(3a/a,i2)
 600    format(3a)
	end

        program write_partial_data
        USE CGNS

!	original author (of write_mixed_elements): Diane Poirier
!       author: Ken Wall
!	May 13 2004

!       Original code came from the example write_mixed_elements.

! 	This example test the writing of and element section of
!	type MIXED, which includes some NGON_x elements of different size
!	The model is not realistic, as all the data is dummy.

#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer index_dim, cell_dim, phys_dim
	integer cg, base, zone, ier, index, ZoneType
        integer(cgsize_t) size(3)
	integer i, j, k, n, pos, coord, section_no
        integer(cgsize_t) element(20)
	character*32 ZoneName, coordname(3)
        real*8 data_double(27)
	integer grid_no, C, count
        integer(cgsize_t) rmin, rmax, parent(12)

!       initialize
        ier = 0
	index_dim = 1
	cell_dim=3
	phys_dim=3

!       open CGNS file for writing

        call cg_open_f('Test_V2', MODE_WRITE, cg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

!*******write CGNSBase
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	call cg_base_write_f(cg, 'PartialReadWriteBase', cell_dim,
     &                       phys_dim, base, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

!*******write only 1 unstructured zone
	zone = 1
	ZoneType=Unstructured
	write(ZoneName,100) 'UnstructuredZone#1'
 100	format(a)
	size(1) = 27		! no of nodes
	size(2) = 3		! no of elements
	size(3) = 0		! unsorted nodes

	call cg_zone_write_f(cg, base, 'UnstructuredZone#1', size,
     &                       ZoneType, index, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! Name convention
        coordname(1) = 'CoordinateX'
        coordname(2) = 'CoordinateY'
        coordname(3) = 'CoordinateZ'

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

! write coordinate data in 2 separate calls

! Set the ranges for the first partial write of the Coordinate data
            rmin = 15
            rmax = 27

! create coordinate data(10x10x10 box with 3x3x3 equidistant nodes)
        do coord=1,phys_dim
            pos = 0
            do 20 i= rmin, rmax
                pos = pos + 1
                if (coord.eq.1) data_double(pos) = i
                if (coord.eq.2) data_double(pos) = -i
                if (coord.eq.3) data_double(pos) = i
 20         continue

            call cg_coord_partial_write_f(cg, base, zone, RealDouble,
     &                  coordname(coord), rmin, rmax, data_double, C,
     &                  ier)
            if (ier .eq. ERROR) call cg_error_exit_f

	enddo	! coord. loop

! Set the ranges for the second partial write of the Coordinate data
            rmin = 1
            rmax = 14

! create coordinate data(10x10x10 box with 3x3x3 equidistant nodes)

        do coord=1,phys_dim
            pos = 0
            do 21 i=rmin, rmax
                pos = pos + 1
                if (coord.eq.1) data_double(pos) = -i
                if (coord.eq.2) data_double(pos) = i
                if (coord.eq.3) data_double(pos) = -i
 21          continue

            call cg_coord_partial_write_f(cg, base, zone, RealDouble,
     &                  coordname(coord), rmin, rmax, data_double, C,
     &                  ier)
            if (ier .eq. ERROR) call cg_error_exit_f

	enddo	! coord. loop

! create section with 3 elements

	call cg_section_partial_write_f(cg, base, zone, 'MixedElements',
     &       MIXED, 1_cgsize_t, 3_cgsize_t, 0, section_no, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! Generate dummy elements

	count = 0
! first element HEXA_8
	count = count + 1
	element(count)=HEXA_8
	do i=1,8
	    count = count + 1
	    element(count)=i
	enddo
! second element TETRA_4
	count = count + 1
	element(count)=TETRA_4
	do i=1,4
	    count = count + 1
            element(count)=i
        enddo

! Write first 2 elements of the MIXED element section
        rmin = 1
        rmax = 2
	call cg_elements_partial_write_f(cg, base, zone, section_no,
     &       rmin, rmax, element, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
! second element TETRA_4
	count = 1
	element(count)=TETRA_4
	do i=1,4
	    count = count + 1
            element(count)= -i
        enddo

! third element PYRA_5
        count = count + 1
        element(count)=PYRA_5
        do i=1,5
            count = count + 1
            element(count)=i
        enddo

! Write second and third elements of the MIXED element section
        rmin = 2
        rmax = 3
	call cg_elements_partial_write_f(cg, base, zone, section_no,
     &       rmin, rmax, element, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

! Write parent data in 2 separate calls

        count = 0
	do i=5,12
            count = count + 1
            parent(count)=i
        enddo

        ! write parent data for the second and third elements
        call cg_parent_data_partial_write_f(cg, base, zone, section_no,
     &       2_cgsize_t, 3_cgsize_t, parent, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

        count = 0
	do i=1,4
            count = count + 1
            parent(count)= -i
        enddo

        ! write parent data for the first element
        call cg_parent_data_partial_write_f(cg, base, zone, section_no,
     &       1_cgsize_t, 1_cgsize_t, parent, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! Write & close CGNS file

	call cg_close_f(cg, ier)
	if (ier.eq. ERROR) call cg_error_exit_f()

	end

PROGRAM ftest_zone

  USE cgns
  USE mpi
  
  IMPLICIT NONE

#include "cgnstypes_f03.h"
#ifdef WINNT
  INCLUDE 'cgnswin_f.h'
#endif
      
  INTEGER ierr, mrank, msize, fid 
  INTEGER basenum, zonenum, blocknum
  INTEGER blocksize, subblocksize, lowerblock, upperblock
  INTEGER nharms, ipde, n, npde, solnum 
  INTEGER fieldnum, arraynum
  INTEGER xnum, ynum, znum, i, j, k, l, m
  INTEGER(cgsize_t) sizes(3,3)
  INTEGER(cgsize_t) qsizes(5),minarrrange(5),maxarrrange(5)
  CHARACTER*11 zonename,tempzonename,fieldname
  DOUBLE PRECISION starttime, endtime
  DOUBLE PRECISION, ALLOCATABLE, DIMENSION(:,:,:,:,:,:) :: q
  DOUBLE PRECISION  tempq(5,5,5,5,5)


  CALL MPI_INIT(ierr)
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,msize,ierr)
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,mrank,ierr)
  
  npde = 5
  nharms = 5
  qsizes=5
  qsizes(4)=npde
  qsizes(5)=nharms
  
  blocksize= 128
  subblocksize = blocksize/msize
  
  IF(MOD(blocksize,msize) .NE. 0) THEN
     WRITE(*,*) 'error with block size'
  END IF
  
  sizes(1,1) = 20
  sizes(2,1) = 20
  sizes(3,1) = 20
  
  sizes(1,2) = sizes(1,1)-1
  sizes(2,2) = sizes(2,1)-1
  sizes(3,2) = sizes(3,1)-1
  
  sizes(1,3) = 0
  sizes(2,3) = 0
  sizes(3,3) = 0
  
  
  ALLOCATE(q(5,5,5,npde,nharms,subblocksize))

  fid = 0
  
  IF(mrank .EQ. 0) THEN
     
     WRITE(*,*) 'starting restart stuff'
     
     CALL cg_open_f('rest.cgns',CG_MODE_WRITE,fid,ierr)     
     IF(ierr .NE. CG_OK) THEN
        WRITE(*,*) 'cg_open_f restart error'
        CALL cg_error_print_f()
     END IF
     
     starttime = MPI_WTIME()
     
     CALL cg_base_write_f(fid,'gridbase',3,3,basenum,ierr)
     IF(ierr .NE. CG_OK) THEN
        WRITE(*,*) 'cg_base_write_f error'
        CALL cg_error_print_f()
     END IF
     
     endtime = MPI_WTIME()
     IF(mrank .EQ. 0) THEN
        WRITE(*,*) 'base write',endtime-starttime
     END IF
     
     starttime = MPI_WTIME()
     
     DO i = 1,blocksize
        blocknum = i
        WRITE(zonename, "(A5,I6)") "block",blocknum
        CALL cg_zone_write_f(fid,basenum,zonename,sizes, &
             CGNS_ENUMV(Structured),zonenum,ierr)
        IF(ierr .NE. CG_OK) THEN
           WRITE(*,*) 'cg_zone_write_f error'
           CALL cg_error_print_f()
        END IF
        CALL cg_goto_f(fid,basenum,ierr,'Zone_t',zonenum,'end')
        IF(ierr .NE. CG_OK) THEN
           WRITE(*,*) 'cg_goto_f error'
           CALL cg_error_print_f()
        END IF
        CALL cg_user_data_write_f('User Data',ierr)
        
        IF(ierr .NE. CG_OK) THEN
           WRITE(*,*) 'cg_user_write_f error'
           CALL cg_error_print_f()
        END IF
     END DO
     
     endtime = MPI_WTIME()
     IF(mrank .EQ. 0) THEN
        WRITE(*,*) 'zone and user data write',endtime-starttime
     END IF
     
     CALL cg_close_f(fid,ierr)
     IF(ierr .NE. CG_OK) THEN
        WRITE(*,*) 'cg_close_f error'
        CALL cg_error_print_f()
     END IF
     
  END IF

  basenum = 1
  
  IF(mrank .EQ. 0) THEN
     WRITE(*,*) 'restart',mrank,msize
  END IF
  
  CALL MPI_BARRIER(MPI_COMM_WORLD,ierr)
  starttime = MPI_WTIME()
  
  CALL cgp_open_f('rest.cgns',CG_MODE_MODIFY,fid,ierr)     
  IF(ierr .NE. CG_OK) THEN
     WRITE(*,*) 'cgp_open_f error parallelwrite'
     CALL cg_error_print_f()
  END IF
  
  CALL MPI_BARRIER(MPI_COMM_WORLD,ierr)
  endtime = MPI_WTIME()
  IF(mrank .EQ. 0) THEN
     WRITE(*,*) 'open restart file',endtime-starttime
  END IF
  
  CALL MPI_BARRIER(MPI_COMM_WORLD,ierr)
  starttime = MPI_WTIME()
  
  solnum = 1
  
  DO i = 1,blocksize
     zonenum = i
     CALL cg_goto_f(fid,basenum,ierr,'Zone_t',zonenum, &
          'UserDefinedData_t',solnum,'end')
     WRITE(fieldname, "(A5,I6)") "array",1
     CALL cgp_array_write_f(fieldname,CGNS_ENUMV(RealDouble),5,qsizes, &
          arraynum,ierr)
     IF(ierr .NE. CG_OK) THEN
        WRITE(*,*) 'cg_array_write_f error'
        CALL cg_error_print_f()
     END IF
  END DO
  
  CALL MPI_BARRIER(MPI_COMM_WORLD,ierr)
  endtime = MPI_WTIME()
  IF(mrank .EQ. 0) THEN
     WRITE(*,*) 'initial array create',endtime-starttime
  END IF
  
  CALL MPI_BARRIER(MPI_COMM_WORLD,ierr)
  starttime = MPI_WTIME()
  
  lowerblock = mrank*subblocksize+1
  upperblock = lowerblock + subblocksize - 1
  
  
  minarrrange = 1
  maxarrrange = 5
  PRINT*,'npde,nharms',npde,nharms
  maxarrrange(4) = npde
  maxarrrange(5) = nharms

  solnum = 1
  
  blocknum = 1
  DO i = lowerblock,upperblock
     zonenum = i
     q(:,:,:,:,:,blocknum) = i*101
     arraynum = 1
     CALL cg_goto_f(fid,basenum,ierr,'Zone_t',zonenum, &
          'UserDefinedData_t',solnum,'end')
     IF(ierr .NE. CG_OK) THEN
        WRITE(*,*) 'cg_goto_f error'
        CALL cg_error_print_f()
     END IF
     CALL cgp_array_write_data_f(arraynum,minarrrange,maxarrrange, &
          q(:,:,:,:,:,blocknum),ierr)
     IF(ierr .NE. CG_OK) THEN
        WRITE(*,*) 'q cgp_array_write_data_f error',ierr
        CALL cg_error_print_f()
     END IF
     
     blocknum = blocknum + 1
  END DO
  
  CALL MPI_BARRIER(MPI_COMM_WORLD,ierr)
  endtime = MPI_WTIME()
  IF(mrank .EQ. 0) THEN
     WRITE(*,*) 'array data write',endtime-starttime
  END IF
  
  CALL MPI_BARRIER(MPI_COMM_WORLD,ierr)
  
  
  starttime = MPI_WTIME()
  
  blocknum = 1
  solnum = 1
  
  DO i = lowerblock,upperblock
     
     zonenum = i
     tempq = 0.0
     arraynum = 1
     
     CALL cg_goto_f(fid,basenum,ierr,'Zone_t',zonenum, &
          'UserDefinedData_t',solnum,'end')
     IF(ierr .NE. CG_OK) THEN
        WRITE(*,*) 'cg_goto_f error'
        CALL cg_error_print_f()
     END IF
     CALL cgp_array_read_data_f(arraynum,minarrrange,maxarrrange, &
          tempq(:,:,:,:,:),ierr)
     IF(ierr .NE. CG_OK) THEN
        WRITE(*,*) 'q cgp_array_read_data_f error'
        CALL cg_error_print_f()
     END IF
     
     
     DO n = 1,nharms
        DO j = 1,npde
           DO k = 1,5
              DO l = 1,5
                 DO m = 1,5
                    IF(q(m,l,k,j,n,blocknum) .NE. &
                         tempq(m,l,k,j,n)) THEN
                       WRITE(*,*) 'error with solution', &
                            q(m,l,k,j,n,blocknum), &
                            tempq(m,l,k,j,n)
                    END IF
                 END DO
              END DO
           END DO
        END DO
     END DO
     
     blocknum = blocknum + 1
         
  END DO
  

  CALL MPI_BARRIER(MPI_COMM_WORLD,ierr)
  endtime = MPI_WTIME()
  IF(mrank .EQ. 0) THEN
     WRITE(*,*) 'array data read',endtime-starttime
  END IF
  
  CALL MPI_BARRIER(MPI_COMM_WORLD,ierr)
  starttime = MPI_WTIME()
  
  CALL cgp_close_f(fid,ierr)
  IF(ierr .NE. CG_OK) THEN
     WRITE(*,*) 'cgp_close_f error'
     CALL cg_error_print_f()
  END IF
  
  CALL MPI_BARRIER(MPI_COMM_WORLD,ierr)
  endtime = MPI_WTIME()
  IF(mrank .EQ. 0) THEN
     WRITE(*,*) 'close file',endtime-starttime
  END IF
  
  DEALLOCATE(q)
  
  
  CALL MPI_FINALIZE(ierr)

END PROGRAM ftest_zone

        program read_mixed_grid
        USE CGNS

!	author: Diane Poirier
!       last revised on October 12 2001

! 	This example test the new data structures created for
! 	unstructured data and geometry reference data.  The
! 	model being read is composed of 2 zones.  The 1st
!	one is a structured 3x3x3 block, and the 2nd is
!	an unstructured 3x3x3 block composed of 8 hexa elements.
! 	The 2 zones interface (Abutting1to1) on one 9-nodes face.

#ifdef WINNT
	include 'cgnswin_f.h'
#endif

        parameter (NNODES=200000, NELEMENTS=200000)

	integer Cdim, Pdim, Idim, Idim_donor
	integer cg, base, zone, ier, ZoneType
        integer(cgsize_t) size(3*3)
	integer nbases, nzones, ncoords, nsections, nconns, nbocos
	integer nfambc, ngeo, nfamilies, nparts
        integer(cgsize_t) dim_vals(12)
	integer i, n, sect
        integer(cgsize_t) range_min(3), range_max(3)
	integer nbndry, type
        integer(cgsize_t) start, end
	integer(cgsize_t) pnts(3*NNODES), donor_data(3*NNODES)
	integer fam, geo, part,bc, bctype, location, connect_type
	integer ptset_type, datatype
        integer(cgsize_t) npnts, ndata_donor
	integer donor_ptset_type, donor_datatype, donor_zonetype
	character*32 nodename, cadformat, filename, donorname
	character*32 coordname(3)
	character*200 cadfile, descriptor
        double precision data_double(NNODES)
	integer NormalIndex(3), ndataset
        integer(cgsize_t) NormalListFlag
	integer size_of_patch, multiplier, narrays, pos, parent_flag
	integer ilen, ilen2
	integer ordinal

! The following seg fault on hp11...
!       integer elements(NELEMENTS*8), parent_data(NELEMENTS*4)
!	double precision NormalListDouble(3*NNODES)
!	real*4 NormalListSingle(3*NNODES)

! Replace with the following fixed size, but without understanding the problem
	integer(cgsize_t) elements(8000), parent_data(4000)
	double precision NormalListDouble(3000)
	real*4 NormalListSingle(3000)

!       initialize
        ier = 0

!       write(6,100) 'Input filename'
!       read(5,100) filename
!       open CGNS file for reading
        write(filename,100)'Test_V2'
 100	format(a)

 	call cg_open_f(filename, MODE_READ, cg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
	write(6,101)'File Opened and Read '
 101	format(/a/)

!*******read CGNSBase
	call cg_nbases_f(cg, nbases, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	if (nbases .gt. 1) then
	    write(6,100)'This program reads only the first base'
	else if (nbases .le. 0) then
	    write(6,100)'No base found'
	    goto 9999
	endif
	base = 1
	call cg_base_read_f(cg, base, nodename, Cdim, Pdim, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	ilen=32
        call no_blank(nodename, ilen)
        write(6,100)'*** CGNSBase_t node ***'
        write(6,102)'Name= "',nodename(1:ilen),'"'
        write(6,103)'CellDimension=',Cdim
        write(6,103)'PhysDimension=',Pdim
	write(6,100)' '

! FAMILY and GEOMETRY
!****** Read number of families and family names
	call cg_nfamilies_f(cg, base, nfamilies, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

        do fam=1,nfamilies
	   call cg_family_read_f(cg, base, fam, nodename, nfambc, ngeo, &
                  ier)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	   if (ier .eq. ERROR) call cg_error_exit_f

	    ilen=32
	    call no_blank(nodename, ilen)
            write(6,103)'*** Family_t nodes ***'
	    write(6,106)'Name= "',nodename(1:ilen),'"'
	    write(6,107)'no.of FamilyBC_t=',nfambc
	    write(6,107)'no.of GEO=',ngeo
	    write(6,100)' '

          ! A family may have several GeometryReference_t node
            do geo=1, ngeo
                call cg_geo_read_f(cg, base, fam, geo, nodename, &
                   cadfile, cadformat, nparts, ier)
                if (ier .eq. ERROR) call cg_error_exit_f

		write(6,106)'*** GeometryReference_t nodes ***'
		ilen=32
                call no_blank(nodename, ilen)
		write(6,109)'Name= "',nodename(1:ilen),'"'
                ilen=32
                call no_blank(cadfile, ilen)
		write(6,109)'cadfile= "',cadfile(1:ilen),'"'
                ilen=32
                call no_blank(cadformat, ilen)
		write(6,109)'cadformat= "',cadformat(1:ilen),'"'
		write(6,110)'nparts=',nparts
		write(6,100)' '

                ! A GeometryReference_t may encompass several parts
                do part = 1, nparts
                    call cg_part_read_f(cg, base, fam, geo, part, &
                       nodename, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
		    ilen=32
		    call no_blank(nodename, ilen)
		    write(6,111)'part= "',nodename(1:ilen),'"'
                enddo

              ! GeometryReference_t descriptor
                call cg_goto_f(cg, base, ier, 'Family_t', fam, &
                 'GeometryReference_t',geo,'end')
                if (ier .eq. ERROR) call cg_error_exit_f

		if (ier .eq. ALL_OK) then

		    call cg_ndescriptors_f(n, ier)
		    if (ier .eq. ERROR) call cg_error_exit_f
		    write(6,100)' '
		    write(6,110)'ndescr=',n
		    write(6,100)' '

		    do i=1, n
                        call cg_descriptor_read_f(i,nodename, &
                           descriptor, ier)
                        if (ier .eq. ERROR) call cg_error_exit_f
			ilen = 32
			ilen2=200
			call no_blank(nodename, ilen)
			call no_blank(descriptor, ilen2)
		        write(6,111)'Descriptor_t: "',nodename(1:ilen), &
                          '" is "',descriptor(1:ilen2),'"'
		    enddo
		endif
            enddo

            do bc=1,nfambc, 1
	        write(6,106)'*** FamilyBC_t nodes ***'
                call cg_fambc_read_f(cg, base, fam, bc, nodename, &
                  bctype, ier)
                if (ier .eq. ERROR) call cg_error_exit_f

		ilen=32
		call no_blank(nodename, ilen)
		write(6,109)'Name= "',nodename(1:ilen),'"'
		write(6,109) &
                  'BCType= ',BCTypeName(bctype)
		write(6,100)' '
            enddo

         !  Family Descriptor and Ordinal
            call cg_goto_f(cg, base, ier, 'Family_t', fam, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f

	    if (ier .eq. ALL_OK) then

	        call cg_ndescriptors_f(n, ier)
	        if (ier .eq. ERROR) call cg_error_exit_f
		write(6,107)'ndescriptors=',n
                do i=1, n
                    call cg_descriptor_read_f(i,nodename, &
                       descriptor, ier)
		    if (ier .eq. ERROR) call cg_error_exit_f

		    ilen = 32
                    ilen2=200
                    call no_blank(nodename, ilen)
                    call no_blank(descriptor, ilen2)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
                    write(6,111)'Descriptor_t: "', &
                    nodename(1:ilen),'" is "',descriptor(1:ilen2),'"'
                enddo

                call cg_ordinal_read_f(ordinal, ier)
	        if (ier .eq. ERROR) call cg_error_exit_f
                if (ier.eq.ALL_OK) &
                    write(6,108)'Ordinal=',ordinal
		    write(6,100)' '
	    endif
        enddo

! ******read CGNSBase substructure: Zone
	call cg_nzones_f(cg, base, nzones, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

        write(6,103)'nzones=',nzones
	write(6,100)' '

	! ******read CGNSBase substructure: Zone
        do zone=1, nzones
            call cg_zone_read_f(cg,base,zone, nodename,size,ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

	    call cg_zone_type_f(cg, base, zone, ZoneType, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

	    Idim=Cdim
	    if (ZoneType .eq. Unstructured) Idim=1

            write(6,100)'*** Zone_t node ***'
            ilen=32
            call no_blank(nodename, ilen)
            write(6,102)'Name= "',nodename(1:ilen),'"'
            write(6,102)'ZoneType= ',ZoneTypeName(ZoneType)
            write(6,113)'Size= ', (size(i),i=1,Idim*3)

! COORDINATES
	    call cg_ncoords_f(cg, base, zone, ncoords, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
	    write(6,103)'ncoords=',ncoords

	    write(6,103)'Idim=',Idim
	    do i=1, Idim
		range_min(i)=1
		range_max(i)=size(i)
	    enddo
	    write(6,113) &
                 'range:',(range_min(i),i=1,Idim), &
                          (range_max(i),i=1,Idim)
! Name convention
            coordname(1) = 'CoordinateX'
            coordname(2) = 'CoordinateY'
            coordname(3) = 'CoordinateZ'
	    do i=1, Pdim
	        call cg_coord_read_f(cg, base, zone, coordname(i), &
                  RealDouble, range_min, range_max, data_double, ier)
	        if (ier .eq. ERROR) call cg_error_exit_f
		write(6,114)coordname(i),'=',data_double(1)
	    enddo

! GOTO Zone node and read family name :
            call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f
	    if (ier .eq. ALL_OK) then
	  	call cg_famname_read_f(nodename, ier)
	        if (ier .eq. ERROR) call cg_error_exit_f
		if (ier .eq. ALL_OK) then
		    ilen=32
              	    call no_blank(nodename, ilen)
		    if (ilen.gt.0) then
		      write(6,102) 'FamilyName= "', &
                                          nodename(1:ilen),'"'
		    endif
		endif
	    endif


! CONNECTIVITY
	    call cg_nconns_f(cg, base, zone, nconns, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

	    do n=1, nconns
		call cg_conn_info_f(cg, base, zone, n, nodename, &
                 location, connect_type, ptset_type, npnts, &
                 donorname, donor_zonetype, donor_ptset_type, &
                 donor_datatype, ndata_donor, ier)
		if (ier .eq. ERROR) call cg_error_exit_f

                write(6,100)'*** GridConnectivity_t node ***'
                ilen=32
                call no_blank(nodename, ilen)
                write(6,102)'Name= "',nodename(1:ilen),'"'
                write(6,102)'GridLocation=', &
                                   GridLocationName(location)
                write(6,102)'Connectivity Type=', &
                    GridConnectivityTypeName(connect_type)
                write(6,102)'PtsetType=', &
                                   PointSetTypeName(ptset_type)
                write(6,104)'npnts=',npnts
                ilen=32
                call no_blank(donorname, ilen)
                write(6,102)'DonorName="',donorname(1:ilen),'"'
                write(6,102)'DonorZonetype=', &
                    ZoneTypeName(donor_zonetype)
                write(6,102)'DonorDatatype=', &
                    DataTypeName(donor_datatype)
                write(6,102)'DonorPtsetType=', &
                    PointSetTypeName(donor_ptset_type)
                write(6,104)'ndata_donor=',ndata_donor

                call cg_conn_read_f(cg, base, zone, n, &
                    pnts, Integer, donor_data, ier)
                if (ier .eq. ERROR) call cg_error_exit_f

		write(6,102) 'pnts receiver:'
		write(6,112)(pnts(i),i=1,Idim)
		write(6,108)' to ', &
                     (pnts((npnts-1)*Idim+i),i=1,Idim)

		if (donor_zonetype .eq. Unstructured) then
		    Idim_donor = 1
		else
		    Idim_donor = Cdim
		endif
		write(6,102) 'pnts donor:'
		write(6,112)(donor_data(i), i=1,Idim_donor)
		write(6,108)' to ', &
      		    (donor_data((ndata_donor-1)*Idim_donor+i), &
      			i=1,Idim_donor)
		
! Look for interpolants
	        if (donor_ptset_type .eq. CellListDonor) then
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
		
		    call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                        'ZoneGridConnectivity_t', 1, &
                        'GridConnectivity_t', 1, 'end')
                    if (ier .eq. ERROR) call cg_error_exit_f

		    if (ier .eq. ALL_OK) then
		        call cg_narrays_f(narrays, ier)
		        if (ier .eq. ERROR) call cg_error_exit_f
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
			write(6,103)'narrays under GridConnectivity_t=', &
      			    narrays
		    endif

		    if (narrays .eq. 1) then
			call cg_array_info_f(1, nodename, datatype, &
                             ndim, dim_vals, ier)
			if (ier .eq. ERROR) call cg_error_exit_f
			write(6,114)'nodename=',nodename
			write(6,103)'ndim=',ndim
			do i=1,ndim
			   write(6,103)'dim_vals=',dim_vals(i)
			enddo
	                write(6,102)'Interpolants Datatype=', &
                    		DataTypeName(datatype)

			call cg_array_read_f(1, data_double, ier)
			if (ier .eq. ERROR) call cg_error_exit_f
			do j=1,dim_vals(2)
			do i=1,dim_vals(1)
			  pos = (j-1)*dim_vals(1) + i
		          write(6,120)'Interpolants(',i,',',j,')=', &
                                       data_double(pos)
			enddo
			enddo
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

		    endif
		endif
	    enddo

! BOUNDARY CONDITION PATCH: Put a user defined b.c. at interface
            write(6,100)'*** ZoneBC_t node ***'
	    call cg_nbocos_f(cg, base, zone, nbocos, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

	    write(6,103)'nbocos=',nbocos

	    do bc=1, nbocos, 1
	
		write(6,100)'*** BC_t node ***'
		call cg_boco_info_f(cg, base, zone, bc, nodename, &
                 bctype, ptset_type, npnts, NormalIndex, NormalListFlag, &
                 datatype, ndataset, ier)

                ilen=32
                call no_blank(nodename, ilen)
                write(6,102)'Name= "',nodename(1:ilen),'"'
                write(6,102)'BCType= ',BCTypeName(bctype)
                write(6,102)'PtsetType= ', &
                                   PointSetTypeName(ptset_type)
                write(6,105)'npnts=',npnts

              ! note: Normal index has no definition in unstructured
                if (Idim /= 1) then
                  write(6,102)'NormalIndex:'
                  write(6,112)(NormalIndex(i),i=1,Idim)
                end if
		write(6,105)'NormalListFlag=',NormalListFlag
		write(6,102)'NormalDataType= ', &
                                   DataTypeName(datatype)
		write(6,105)'ndataset=',ndataset

		if (datatype.eq.RealSingle) then
	            call cg_boco_read_f(cg, base, zone, bc, pnts, &
                    	NormalListSingle, ier)
	            if (ier .eq. ERROR) call cg_error_exit_f
		else
		    call cg_boco_read_f(cg, base, zone, bc, pnts, &
                        NormalListDouble, ier)
		    if (ier .eq. ERROR) call cg_error_exit_f
		endif

                write(6,102) 'pnts range:'
		write(6,112)(pnts(i),i=1,Idim)
                write(6,108)' to ', &
                     (pnts((npnts-1)*Idim+i),i=1,Idim)

              ! number of points or faces in bcpatch
                if (ptset_type.eq.PointList .or. &
                    ptset_type.eq.ElementList) then
                    size_of_patch = npnts
                else if (ptset_type.eq.PointRange .or. &
                         ptset_type.eq.ElementRange) then
                    size_of_patch=1
                    do i=1,Idim
                        multiplier=pnts((npnts-1)*Idim+i) - pnts(i) + 1
                        size_of_patch = size_of_patch * multiplier
                    enddo
                endif
                write(6,105)'size_of_patch=',size_of_patch

	      ! InwardNormalList
		if (NormalListFlag.ne.0) then
		    if (datatype.eq.RealSingle) then
			write(6,102) '1st and last normal vector:'
			write(6,118)(NormalListSingle(i),i=1,Pdim)
			write(6,118) &
                        (NormalListSingle((npnts-1)*Pdim+i),i=1,Pdim)
		    else
		  	write(6,102) '1st and last normal vector:'
                        write(6,118)(NormalListDouble(i),i=1,Pdim)
                        write(6,118) &
                        (NormalListDouble((npnts-1)*Pdim+i),i=1,Pdim)
		    endif
		endif


		call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                   'ZoneBC_t', 1, 'BC_t', bc, 'end')
		if (ier .eq. ERROR) call cg_error_exit_f

		if (ier .eq. ALL_OK) then
		    call cg_famname_read_f(nodename, ier)
		    if (ier .eq. ERROR) call cg_error_exit_f

		    ilen=32
		    call no_blank(nodename, ilen)
		    if (ilen.gt.0) then
		      write(6,102)'FamilyName= "', &
                                         nodename(1:ilen),'"'
		    endif
		endif
	    enddo

! ********** SPECIAL FOR UNSTRUCTURED ZONES ONLY **********

	    if (ZoneType .eq. Unstructured) then

! read element sections (Element_t) :
		call cg_nsections_f(cg, base, zone, nsections, ier)
		if (ier .eq. ERROR) call cg_error_exit_f

		write(6,100)'*** Elements_t Nodes ***'

		write(6,103)'nsections=',nsections

		do sect=1, nsections
		    write(6,201)'  *** Section ',sect,' ***'
 201	format(/a,i2,a)
		    call cg_section_read_f(cg, base, zone, sect, &
                        nodename, type, start, end, nbndry, &
                        parent_flag, ier)
		    if (ier .eq. ERROR) call cg_error_exit_f

		    call cg_npe_f(type, npe, ier)
		    if (ier .eq. ERROR) call cg_error_exit_f
  		    write(6,103)'npe=',npe
  		    write(6,103)'type=',type

                    ilen=32
                    call no_blank(nodename, ilen)
                    write(6,102)'Name= "',nodename(1:ilen),'"'
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
		    if (type .gt. NGON_n) then
                         write(6,100) 'Element Type= NGON_n'
                    else
			write(6,102)'Element Type= ', &
                                      ElementTypeName(type)
		    endif
		    write(6,113)'Range= ',start,end
		    if (nbndry .ne. 0) write(6,102)'Sorted elements'

		    call cg_elements_read_f(cg, base, zone, sect, &
                       elements, parent_data, ier)
		    if (ier.eq.ERROR)  call cg_error_exit_f

		    nelem = end-start+1
		    write(6,102)'Element Connectivity:'
		
		    do i=1, nelem
		       write(6,115)(elements((i-1)*npe+n),n=1,npe)
			if (i.eq.10) goto 17
		    enddo
 17		    continue

		    if (parent_flag .ne. 0) then
			write(6,102)'Parent Data:'
			do i=1, 4
			     write(6,116) &
       				(parent_data((i-1)*nelem+n), n=1,nelem)
			enddo
		    endif
! Auxiliary data
		    call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                        'Elements_t', sect, 'end')
		    if (ier .eq. ERROR) call cg_error_exit_f

		    if (ier .eq. ALL_OK) then
			call cg_ndescriptors_f(n, ier)
                	if (ier .eq. ERROR) call cg_error_exit_f
                	do i=1, n
                    	    call cg_descriptor_read_f(i,nodename, &
                       	                              descriptor, ier)
                    	    if (ier .eq. ERROR) call cg_error_exit_f

                            ilen = 32
                            ilen2=200
                            call no_blank(nodename, ilen)
                            call no_blank(descriptor, ilen2)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
                            write(6,117)'Descriptor_t: "', &
                                        nodename(1:ilen),'" is "', &
                                          descriptor(1:ilen2),'"'
                	enddo
		    endif
		enddo
	    endif

! *********************************************************************

        enddo	! zone loop

	write(6,100)'calling cg_close_f'
	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f()

 102    format(6x,3a)
 103    format(6x,a,i3)
 104    format(6x,a,i3)
 105    format(6x,a,i5)
 106    format(8x,3a)
 107    format(8x,a,i3)
 108    format(8x,a,3i3)
 109    format(10x,3a)
 110    format(10x,a,i3)
 111    format(12x,5a/)
 112    format(12x,3i3)
 113    format(6x, a, 9i6)
 114    format(6x,2a,e13.6)
 115    format(6x,8i6)
 116    format(6x,4i3)
 117    format(6x,5a/)
 118    format(12x,3e13.6)
 120    format(a,i1,a,i3,a,e13.6)


 9999   end


        subroutine no_blank(Text, length)

        character*(*) Text
        integer i, ilen, length

        ilen=0
        do i=length,1,-1
             if (Text(i:i).ne.' ') then
                 ilen=i
                 goto 17
             endif
        enddo

 17     length = ilen

        return
        end

      program read_con2zn_str
      use cgns
      implicit none
!
!   Opens an existing CGNS file that contains a simple 3-D
!   structured grid (2 zones) plus 1-to-1 connectivity
!   information, and reads the connectivity info.
!
!   The CGNS grid file 'grid.cgns' must already exist
!   (created using write_grid2zn_str.f plus write_con2zn_str.f)
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c read_con2zn_str.F90
!   ifort -o read_con2zn_str read_con2zn_str.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
      integer(cgsize_t) ipnts(3,2),ipntsdonor(3,2)
      integer itranfrm(3)
      integer nzone,n1to1
      integer index_conn,index_zone,index_base,index_file,ier
      character donorname*32,connectname*32
!
!  READ 1-TO-1 CONNECTIVITY INFORMATION FROM EXISTING CGNS FILE
!  open CGNS file for read-only
      call cg_open_f('grid.cgns',CG_MODE_READ,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!  we know there is only one base (real working code would check!)
      index_base=1
!   get number of zones (should be 2 for our case)
      call cg_nzones_f(index_file,index_base,nzone,ier)
      if (nzone .ne. 2) then
         write(6,'('' Error.  This program expects 2 zones. '',i5,             &
          '' read'')') nzone
         stop
      end if
!   loop over zones
      do index_zone=1,nzone
!   find out how many 1-to-1 interfaces there are in this zone
!   (for this program, there should only be one)
        call cg_n1to1_f(index_file,index_base,index_zone,n1to1,ier)
        if (n1to1 .ne. 1) then
          write(6,'('' Error.  Expecting one 1-to-1 interface.'',              &
            i6,'' read'')') n1to1
          stop
        end if
        index_conn=n1to1
!   read 1-to-1 info
        call cg_1to1_read_f(index_file,index_base,index_zone,index_conn,       &
             connectname,donorname,ipnts,ipntsdonor,itranfrm,ier)
        write(6,'('' In zone '',i5,'':'')') index_zone
        write(6,'(''    donor name='',a32)') donorname
        write(6,'(''    range  (this zone)='',6i5)') ipnts(1,1),               &
         ipnts(2,1),ipnts(3,1),ipnts(1,2),ipnts(2,2),ipnts(3,2)
        write(6,'(''    range (donor zone)='',6i5)') ipntsdonor(1,1),          &
         ipntsdonor(2,1),ipntsdonor(3,1),ipntsdonor(1,2),                      &
         ipntsdonor(2,2),ipntsdonor(3,2)
        write(6,'(''    transform='',3i5)') itranfrm(1),itranfrm(2),           &
         itranfrm(3)
      enddo
!  close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully read 1-to-1 connectivity info from'',          &
       '' file grid.cgns'')')
      stop
      end

        program read_partial_data
        USE CGNS
        IMPLICIT NONE

!	original author (of write_mixed_elements): Diane Poirier
!       author: Ken Wall
!	May 13 2004

! 	This example reads an unstructured zone mixed element section
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif
        INTEGER NNODES, NELEMENTS
        parameter (NNODES=27, NELEMENTS=3)

	integer Cdim, Pdim, Idim, ier
	integer cg, base, zone, ZoneType
        integer(cgsize_t) size(3)
	integer nbases, nzones, ncoords, nsections
	integer i, n, sect
        integer(cgsize_t) range_min(3), range_max(3)
	integer nbndry, type, count
        integer(cgsize_t) elements(1000)
        integer(cgsize_t) connect_offsets(100)
        integer(cgsize_t) ElementDataSize
	character*32 coordname(3), filename, nodename
        double precision data_double(NNODES)
        INTEGER(cgsize_t) el_st, el_end, nelem
        integer(cgsize_t) parent(1000)
        integer parent_flag
        INTEGER npe

!       initialize
        ier = 0

!       write(6,100) 'Input filename'
!       read(5,100) filename
!       open CGNS file for reading
        write(filename,100)'Test_V2'

 	call cg_open_f(filename, MODE_READ, cg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
	write(6,100)'File Opened and Read '

!*******read CGNSBase
	call cg_nbases_f(cg, nbases, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	if (nbases .gt. 1) then
	    write(6,100)'This program reads only the first base'
	else if (nbases .le. 0) then
	    write(6,100)'No base found'
	    goto 9999
	endif
	base = 1
	call cg_base_read_f(cg, base, nodename, Cdim, Pdim, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(6,100)'*** CGNSBase_t node ***'
        write(6,103)'Name= ',nodename
        write(6,104)'CellDimension=',Cdim
        write(6,105)'PhysDimension=',Pdim

! ******read CGNSBase substructure: Zone
	call cg_nzones_f(cg, base, nzones, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	if (nzones .gt. 1) then
	    write(6,100)'This program reads only the first zone'
	else if (nzones .le. 0) then
	    write(6,100)'No zone found'
	    goto 9999
	endif
	zone = 1

        call cg_zone_read_f(cg,base,zone, nodename,size,ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_zone_type_f(cg, base, zone, ZoneType, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	Idim=Cdim
	if (ZoneType .eq. CGNS_ENUMV(Unstructured)) Idim=1

        write(6,100)'*** Zone_t node ***'
        write(6,103)'Name= ',nodename
        write(6,103)'ZoneType= ',ZoneTypeName(ZoneType)
        write(6,106)'Size= ', (size(i),i=1,Idim*3)

! COORDINATES
	call cg_ncoords_f(cg, base, zone, ncoords, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,104)'ncoords=',ncoords

	write(6,104)'Idim=',Idim
	do i=1, Idim
	    range_min(i)= 5
	    range_max(i)=size(i)
        enddo
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	write(6,107) 'range:',(range_min(i),i=1,Idim), &
                                       (range_max(i),i=1,Idim)
! Name convention
        coordname(1) = 'CoordinateX'
        coordname(2) = 'CoordinateY'
        coordname(3) = 'CoordinateZ'
	do i=1, Pdim
	    call cg_coord_read_f(cg, base, zone, coordname(i), &
                  CGNS_ENUMV(RealDouble), range_min, range_max, data_double, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
	    write(6,103)coordname(i)
	    write(6,109)'first point:',data_double(1)
	    write(6,109)'last point :',data_double(size(1)-range_min(1)+1)
	enddo

! ELEMENTS
	write(6,102)'*** Elements_t Nodes ***'
	call cg_nsections_f(cg, base, zone, nsections, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	do sect=1, nsections

! Read all element info:
	    call cg_section_read_f(cg, base, zone, sect, &
                    nodename, type, el_st, el_end, nbndry, &
                    parent_flag, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

	    call cg_ElementDataSize_f(cg, base, zone, sect, &
                                      ElementDataSize, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

! Print out element info:
	    write(6,113)'  *** Section ',sect,' ***'
	    write(6,103)'Name= ',nodename
            write(6,108)'Connectivity data range = ', el_st, el_end
            if (nbndry .ne. 0) write(6,103)'Sorted elements'

	    write(6,107) 'ElementDataSize =',ElementDataSize
            write(6,103) 'Section Element Type= ', &
                               ElementTypeName(type)

            el_st = el_st + 1
            if (type .ge. CGNS_ENUMV(MIXED)) then
                call cg_poly_elements_partial_read_f(cg, base, zone, &
                       sect, el_st, el_end, elements, connect_offsets, &
                       parent, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
            else
                call cg_elements_partial_read_f(cg, base, zone, sect, &
                       el_st, el_end, elements, parent, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
            endif

            write(6,108)'Connect and Parent data for element range  = ', &
                       el_st, el_end

            call cg_npe_f(type, npe, ier)
            if (ier .eq. ERROR) call cg_error_exit_f

	    nelem = el_end - el_st +1
	    write(6,103)'Element Connectivity:'
	    if (type .lt. CGNS_ENUMV(MIXED)) then
	        do i=1, nelem
	            write(6,110)(elements((i-1)*npe+n),n=1,npe)
	    	enddo
	    elseif (type .eq. CGNS_ENUMV(MIXED)) then
		count = 0
	        do i=1, nelem
		    count = count + 1
		    type = elements(count)
		    if (type .gt. CGNS_ENUMV(NGON_n)) then
			npe = type - CGNS_ENUMV(NGON_n)
			write(6,111) &
                          'Element Type=  NGON_n, npe =',npe
		    else
			call cg_npe_f(type, npe, ier)
			write(6,112)'Element Type= ', &
                                   ElementTypeName(type)
		    endif
		    write(6,110)(elements(count+n),n=1,npe)
		    count = count+npe
		enddo
	    else
		count = 0
	        do i=1, nelem
		    !count = count + 1
		    !npe = elements(count)
                    npe = connect_offsets(n+1) - connect_offsets(n)
		    write(6,111) &
                          'Element Number Points = ',npe
		    write(6,110)(elements(count+n),n=1,npe)
		    count = count+npe
		enddo
	    endif

            write(6,103)'Parent Data:'
            do i=1, nelem
	        write(6,110)(parent((i-1)*4+n),n=1,4)
    	    enddo
	enddo

! Write & close CGNS file

	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f()
	write(6,102)'CGNS File written & closed'

 100	format(a)
 101	format(/a/)
 102	format(/a)
 103	format(6x,2a)
 104 	format(6x,a,i2)
 105	format(6x,a,i2/)
 106	format(6x,a,3i2)
 107	format(6x,a,6i3)
 108	format(6x,a,2i5)
 109	format(8x,a,f8.3)
 110	format(8x,8i3)
 111	format(8x,a,i3)
 112	format(8x,2a)
 113	format(/a,i2,a)
 9999   end

      program read_convergence
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Reads convergence history from an existing CGNS file.
!
!   The CGNS grid file 'grid.cgns' must already exist
!   and a convergence history should be in it (using write_convergence.f).
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c read_convergence.F90
!   ifort -o read_convergence read_convergence.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
      integer, parameter :: ntt=20
      real*4 cl(ntt)
      integer(cgsize_t) idim(1)
      integer ndim,itype,index_array,narrays
      integer index_base,index_file,ier
      character arrayname*32
!
!  READ CONVERGENCE HISTORY INFORMATION FROM EXISTING CGNS FILE
!  open CGNS file for read-only
      call cg_open_f('grid.cgns',CG_MODE_READ,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!  we know there is only one base (real working code would check!)
      index_base=1
!   go to base node
      call cg_goto_f(index_file,index_base,ier,'end')
!   go to history node (we assume it exists and that there is only one -
!   real working code would check!)
      call cg_goto_f(index_file,index_base,ier,'ConvergenceHistory_t',         &
           1,'end')
!   find out how many arrays are here (there should be only one!):
      call cg_narrays_f(narrays,ier)
      index_array=narrays
!   some checks:
      if (narrays .ne. 1) then
        write(6,'('' Error!  Expecting only one array, read'',i5)') narrays
        stop
      end if
      call cg_array_info_f(index_array,arrayname,itype,ndim,idim,ier)
      if (idim(1) .gt. ntt) then
        write(6,'('' Error! must increase ntt to at least '',i5)') idim(1)
        stop
      end if
      if (arrayname .ne. 'CoefLift') then
        write(6,'('' Error!  expecting CoefLift, read'',a32)') arrayname
        stop
      end if
!   read lift coefficient array
      call cg_array_read_as_f(index_array,CGNS_ENUMV(RealSingle),cl,ier)
!   close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully read cl history from file grid.cgns'')')
      write(6,'(''    values are: '',5f12.5)') cl(1),cl(2),cl(3),              &
        cl(4),cl(5)
      write(6,'(''                '',5f12.5)') cl(6),cl(7),cl(8),              &
        cl(9),cl(10)
      stop
      end

        program read_mixed_elements
        USE CGNS

!	author: Diane Poirier
!       last revised on April 19 2000

! 	This example reads an unstructured zone mixed element section

#ifdef WINNT
	include 'cgnswin_f.h'
#endif

        parameter (NNODES=27, NELEMENTS=3)

	integer Cdim, Pdim, Idim, ier, count
	integer cg, base, zone, ZoneType
        integer(cgsize_t) size(3)
	integer nbases, nzones, ncoords, nsections
	integer i, n, sect
        integer(cgsize_t) range_min(3), range_max(3)
	integer(cgsize_t)  start, end
        integer nbndry, type
        integer(cgsize_t) elements(1000)
        integer(cgsize_t) connect_offsets(100)
        integer(cgsize_t) ElementDataSize
	character*32 coordname(3), filename, nodename
        double precision data_double(NNODES)
        integer parent_flag
        integer(cgsize_t) parent_data

!       initialize
        ier = 0

!       write(6,100) 'Input filename'
!       read(5,100) filename
!       open CGNS file for reading
        write(filename,100)'Test_V2'

 	call cg_open_f(filename, MODE_READ, cg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
	write(6,100)'File Opened and Read '

!*******read CGNSBase
	call cg_nbases_f(cg, nbases, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	if (nbases .gt. 1) then
	    write(6,100)'This program reads only the first base'
	else if (nbases .le. 0) then
	    write(6,100)'No base found'
	    goto 9999
	endif
	base = 1
	call cg_base_read_f(cg, base, nodename, Cdim, Pdim, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(6,100)'*** CGNSBase_t node ***'
        write(6,103)'Name= ',nodename
        write(6,104)'CellDimension=',Cdim
        write(6,105)'PhysDimension=',Pdim

! ******read CGNSBase substructure: Zone
	call cg_nzones_f(cg, base, nzones, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	if (nzones .gt. 1) then
	    write(6,100)'This program reads only the first zone'
	else if (nzones .le. 0) then
	    write(6,100)'No zone found'
	    goto 9999
	endif
	zone = 1

        call cg_zone_read_f(cg,base,zone, nodename,size,ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_zone_type_f(cg, base, zone, ZoneType, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	Idim=Cdim
	if (ZoneType .eq. Unstructured) Idim=1

        write(6,100)'*** Zone_t node ***'
        write(6,103)'Name= ',nodename
        write(6,103)'ZoneType= ',ZoneTypeName(ZoneType)
        write(6,106)'Size= ', (size(i),i=1,Idim*3)

! COORDINATES
	call cg_ncoords_f(cg, base, zone, ncoords, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,104)'ncoords=',ncoords

	write(6,104)'Idim=',Idim
	do i=1, Idim
	    range_min(i)=1
	    range_max(i)=size(i)
        enddo
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	write(6,107) 'range:',(range_min(i),i=1,Idim), &
                                      (range_max(i),i=1,Idim)
! Name convention
        coordname(1) = 'CoordinateX'
        coordname(2) = 'CoordinateY'
        coordname(3) = 'CoordinateZ'
	do i=1, Pdim
	    call cg_coord_read_f(cg, base, zone, coordname(i), &
                  RealDouble, range_min, range_max, data_double, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
	    write(6,103)coordname(i)
	    write(6,109)'first point:',data_double(1)
	    write(6,109)'last point :',data_double(size(1))
	enddo

! ELEMENTS
	write(6,102)'*** Elements_t Nodes ***'
	call cg_nsections_f(cg, base, zone, nsections, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	do sect=1, nsections

! Read all element info:
	    call cg_section_read_f(cg, base, zone, sect, &
                    nodename, type, start, end, nbndry, &
                    parent_flag, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

	    call cg_ElementDataSize_f(cg, base, zone, sect, &
                                      ElementDataSize, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
	
	    if (type .ge. MIXED) then
	        call cg_poly_elements_read_f(cg, base, zone, sect, &
	            elements, connect_offsets, parent_data, ier)
	        if (ier.eq.ERROR)  call cg_error_exit_f
	    else
	        call cg_elements_read_f(cg, base, zone, sect, &
                    elements, parent_data, ier)
	        if (ier.eq.ERROR)  call cg_error_exit_f
	    endif

! Print out element info:
	    write(6,113)'  *** Section ',sect,' ***'
	    write(6,103)'Name= ',nodename
            write(6,108)'Range= ',start,end
            if (nbndry .ne. 0) write(6,103)'Sorted elements'

            call cg_npe_f(type, npe, ier)
            if (ier .eq. ERROR) call cg_error_exit_f
	
	    write(6,107) 'ElementDataSize =',ElementDataSize
            write(6,103) 'Section Element Type= ', &
                                   ElementTypeName(type)

	    nelem = end-start+1
	    write(6,103)'Element Connectivity:'
	    if (type .lt. MIXED) then
	        do i=1, nelem
	            write(6,110)(elements((i-1)*npe+n),n=1,npe)
	    	enddo
	    elseif (type .eq. MIXED) then
		count = 0
	        do i=1, nelem
		    count = count + 1
		    type = elements(count)
		    if (type .gt. NGON_n) then
			npe = type - NGON_n
			write(6,111) &
                          'Element Type= NGON_n, npe =',npe
		    else
			call cg_npe_f(type, npe, ier)
			write(6,112)'Element Type= ', &
                                   ElementTypeName(type)
		    endif
		    write(6,110)(elements(count+n),n=1,npe)
		    count = count+npe
		enddo
	    else
		count = 0
        do i=1, nelem
		    !count = count + 1
		    npe = connect_offsets(i+1)-connect_offsets(i)
		    !npe = elements(count)
		    write(6,111) &
                          'Element Number Points=',npe
		    write(6,110)(elements(count+n),n=1,npe)
		    count = count+npe
		enddo
	    endif
	enddo

! Write & close CGNS file

	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f()
	write(6,102)'CGNS File written & closed'

 100	format(a)
 101	format(/a/)
 102	format(/a)
 103	format(6x,2a)
 104 	format(6x,a,i2)
 105	format(6x,a,i2/)
 106	format(6x,a,3i2)
 107	format(6x,a,6i3)
 108	format(6x,a,2i5)
 109	format(8x,a,f8.3)
 110	format(8x,8i3)
 111	format(8x,a,i3)
 112	format(8x,2a)
 113	format(/a,i2,a)
 9999   end

	program write_chemistry
	USE CGNS

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on March 8 2000

!       This example test the complete SIDS for multi-block data.
!	It creates a dummy mesh composed of 2 structured blocks in 3D.

! Modified for Version 2.1 chemistry extensions.
! D. Leich, Intelligent Light 11-Jan-02

#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	parameter (Ndim = 3)
	integer index_dim, cell_dim, phys_dim, pos
	integer base_no, zone_no, coord_no, sol_no, discr_no, conn_no
	integer hole_no, boco_no, field_no, dset_no
	integer num, NormalIndex(Ndim)
	integer(cgsize_t) npnts
	integer(cgsize_t) size(Ndim*3)
	integer cg, ier, zone, coord, i, sol, field
	integer(cgsize_t) pnts(Ndim,120), donor_pnts(Ndim,120)
	integer transform(Ndim)
        real*4 units(5)
	real*4 data(120), normals(360)
	double precision Dxyz(120), values(120)
	character*32 zonename, solname, fieldname
	character*32 coordname(Ndim)
	character*32 donorname
        real*4 hofCO, hofO2, hofCO2, RThof

	hofCO  = -26.42
	hofO2  = 0.0
	hofCO2 = -94.054
	RThof  = 298.15

	coordname(1) = 'CoordinateX'
	coordname(2) = 'CoordinateY'
	coordname(3) = 'CoordinateZ'

! *** initialize
	ier = 0
	index_dim=Ndim
	cell_dim=Ndim
	phys_dim=Ndim

! *** open CGNS file for writing
 	call cg_open_f('Test_V2', MODE_WRITE, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f

! *** base
 	call cg_base_write_f(cg, 'Basename', cell_dim, phys_dim,
     &                       base_no, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f

! *** Create 'FlowEquationSet' node under 'CGNSBase_t'
	call cg_goto_f(cg, base_no, ier, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_equationset_write_f(Ndim,ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! *** Create 'ChemicalKinetics' under 'FlowEquationSet'
        call cg_goto_f(cg, base_no, ier,
     &    'FlowEquationSet_t',1,'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_model_write_f('ChemicalKineticsModel_t',
     &    ChemicalEquilibCurveFit,ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! *** Create 'ThermalRelaxation' under 'FlowEquationSet'
        call cg_model_write_f('ThermalRelaxationModel_t',
     &    Frozen,ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! *** Create 'GasModel' under 'FlowEquationSet'
        call cg_model_write_f('GasModel_t',
     &    ConstantDensity,ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! *** Create 'HeatOfFormationCO' under 'ChemicalKineticsModel'
        call cg_goto_f(cg, base_no, ier,
     &    'FlowEquationSet_t',1,'ChemicalKineticsModel_t',1,'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_array_write_f('HeatOfFormationCO',RealSingle,1,
     &    1_cgsize_t,hofCO,ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_goto_f(cg, base_no, ier,
     &    'FlowEquationSet_t',1,'ChemicalKineticsModel_t',1,
     &    'DataArray_t',1,'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_dataclass_write_f(Dimensional,ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_units_write_f(UserDefined,UserDefined,UserDefined,
     &      UserDefined,UserDefined,ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_descriptor_write_f('Units','kcal/mole',ier)
        if (ier .eq. ERROR) call cg_error_exit_f


! *** Create 'HeatOfFormationO2' under 'ChemicalKineticsModel'
        call cg_goto_f(cg, base_no, ier,
     &    'FlowEquationSet_t',1,'ChemicalKineticsModel_t',1,'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_array_write_f('HeatOfFormationO2',RealSingle,1,
     &    1_cgsize_t,hofO2,ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_goto_f(cg, base_no, ier,
     &    'FlowEquationSet_t',1,'ChemicalKineticsModel_t',1,
     &    'DataArray_t',2,'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_dataclass_write_f(Dimensional,ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_units_write_f(UserDefined,UserDefined,UserDefined,
     &      UserDefined,UserDefined,ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_descriptor_write_f('Units','kcal/mole',ier)
        if (ier .eq. ERROR) call cg_error_exit_f


! *** Create 'HeatOfFormationCO2' under 'ChemicalKineticsModel'
        call cg_goto_f(cg, base_no, ier,
     &    'FlowEquationSet_t',1,'ChemicalKineticsModel_t',1,'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_array_write_f('HeatOfFormationCO2',RealSingle,1,
     &    1_cgsize_t,hofCO2,ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_goto_f(cg, base_no, ier,
     &    'FlowEquationSet_t',1,'ChemicalKineticsModel_t',1,
     &    'DataArray_t',3,'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_dataclass_write_f(Dimensional,ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_units_write_f(UserDefined,UserDefined,UserDefined,
     &      UserDefined,UserDefined,ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_descriptor_write_f('Units','kcal/mole',ier)
        if (ier .eq. ERROR) call cg_error_exit_f


! *** Create 'ReferenceTemperatureHOF' under 'ChemicalKineticsModel'
        call cg_goto_f(cg, base_no, ier,
     &    'FlowEquationSet_t',1,'ChemicalKineticsModel_t',1,'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_array_write_f('ReferenceTemperatureHOF',RealSingle,1,
     &    1_cgsize_t,RThof,ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_goto_f(cg, base_no, ier,
     &    'FlowEquationSet_t',1,'ChemicalKineticsModel_t',1,
     &    'DataArray_t',4,'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_dataclass_write_f(Dimensional,ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_units_write_f(Null,Null,Null,Kelvin,Null,ierr)
        if (ier .eq. ERROR) call cg_error_exit_f

        units(1)=0
        units(2)=0
        units(3)=0
        units(4)=1
        units(5)=0
        call cg_exponents_write_f(RealSingle,units,ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! *** Create 'ReactionEquation' under 'ChemicalKineticsModel'
        call cg_goto_f(cg, base_no, ier,
     &    'FlowEquationSet_t',1,'ChemicalKineticsModel_t',1,'end')
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_descriptor_write_f('ReactionEquation',
     &      'CO + 0.5O2 = CO2',ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! *** zone
	do zone=1, 2
    	    write(zonename,'(a5,i1)') 'zone#',zone
    	    num = 1
	    do i=1,index_dim          		! zone#1: 3*4*5, zone#2: 4*5*6
                size(i) = i+zone+1		! nr of nodes in i,j,k
		size(i+Ndim) = size(i)-1	! nr of elements in i,j,k
	 	size(i+2*Ndim) = 0		! nr of bnd nodes if ordered
       		num = num * size(i)		! nr of nodes
    	    enddo
    	    call cg_zone_write_f(cg, base_no, zonename, size,
     &                           Structured, zone_no, ier)
    	    if (ier .eq. ERROR) call cg_error_exit_f

! *** coordinate
     	    do coord=1, phys_dim
 		do k=1, size(3)
 		do j=1, size(2)
 		do i=1, size(1)
		    pos = i + (j-1)*size(1) + (k-1)*size(1)*size(2)
		! * make up some dummy coordinates just for the test:
 	    	    if (coord.eq.1) Dxyz(pos) = i
 	    	    if (coord.eq.2) Dxyz(pos) = j
 	    	    if (coord.eq.3) Dxyz(pos) = k
 		enddo
 		enddo
 		enddo

         	call cg_coord_write_f(cg, base_no, zone_no, RealDouble,
     &                            coordname(coord), Dxyz, coord_no, ier)
         	if (ier .eq. ERROR) call cg_error_exit_f

     	    enddo

! *** solution
     	    do sol=1, 2
 		write(solname,'(a5,i1,a5,i1)') 'Zone#',zone,' sol#',sol
 		call cg_sol_write_f(cg, base_no, zone_no, solname,
     &                              Vertex, sol_no, ier)
 		if (ier .eq. ERROR) call cg_error_exit_f

! *** solution field
 		do field=1, 2
		    ! make up some dummy solution values
 	    	    do i=1, num
 		  	values(i) = i*field*sol
 	    	    enddo
 	    	    write(fieldname,'(a6,i1)') 'Field#',field
 	    	    call cg_field_write_f(cg, base_no, zone_no, sol_no,
     &                  RealDouble, fieldname, values, field_no, ier)
 	    	    if (ier .eq. ERROR) call cg_error_exit_f

 		enddo				! field loop
            enddo				! solution loop

! *** discrete data
	    call cg_discrete_write_f(cg, base_no, zone_no, 'discrete#1',
     &                               discr_no, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

  	! *** discrete data arrays, defined on vertices:
	    call cg_goto_f(cg, base_no, ier, 'Zone_t', zone,
     &                     'DiscreteData_t', discr_no, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f

	    do 123 k=1, size(3)
            do 123 j=1, size(2)
            do 123 i=1, size(1)
                pos = i + (j-1)*size(1) + (k-1)*size(1)*size(2)
	        data(pos) = pos	! * make up some dummy data
 123	    continue
	    call cg_array_write_f('arrayname', RealSingle, index_dim,
     &                             size, data, ier)
            if (ier .eq. ERROR) call cg_error_exit_f

  	! *** discrete data arrays attribute: GOTO DataArray node
	    call cg_goto_f(cg, base_no, ier, 'Zone_t', zone,
     &	            'DiscreteData_t', discr_no, 'DataArray_t', 1, 'end')
	    if (ier .eq. ERROR) call cg_error_exit_f

	    call cg_units_write_f(Kilogram, Meter, Second, Kelvin,
     &                            Radian, ier)
            if (ier .eq. ERROR) call cg_error_exit_f

! *** overset holes
	 !  create dummy data
	    do i=1,3
	      ! Define 2 separate PointRange, for 2 patches in the hole
		pnts(i,1)=1
		pnts(i,2)=size(i)
	      ! second PointRange of hole
		pnts(i,3)=2
		pnts(i,4)=size(i)
	    enddo
	  ! Hole defined with 2 point set type PointRange, so 4 points:
	    call cg_hole_write_f(cg, base_no, zone_no, 'hole#1', Vertex,
     &                           PointRange, 2, 4_cgsize_t, pnts,
     &                           hole_no, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

! *** general connectivity
	    do 100 n=1, 5
	    do 100 i=1,3
	        pnts(i,n)=i		! * dummy data
		donor_pnts(i,n)=i*2
 100        continue
	  ! create a point matching connectivity
	    call cg_conn_write_f(cg, base_no, zone_no, 'Connect#1',
     &          Vertex, Abutting1to1, PointList, 5_cgsize_t, pnts,
     &          'zone#2',
     &          Structured, PointListDonor, Integer, 5_cgsize_t,
     &          donor_pnts, conn_no, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

! *** connectivity 1to1
	 !  generate data
	    do i=1,3
	     !**make up some dummy data:
                pnts(i,1)=1
                pnts(i,2)=size(i)
		donor_pnts(i,1)=1
		donor_pnts(i,2)=size(i)
		transform(i)=i*(-1)
            enddo
	    if (zone .eq. 1) then
		donorname='zone#2'
	    else if (zone .eq. 2) then
		donorname='zone#1'
	    endif

	    call cg_1to1_write_f(cg, base_no, zone_no, '1to1_#1',
     &		donorname, pnts, donor_pnts, transform, conn_no, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

! *** ZoneGridConnectivity attributes:  GOTO ZoneGridConnectivity_t node
	    call cg_goto_f(cg, base_no, ier, 'Zone_t', zone,
     &                     'ZoneGridConnectivity_t', 1, 'end')
	    if (ier .eq. ERROR) call cg_error_exit_f

! *** ZoneGridConnectivity attributes: Descriptor_t
	    call cg_descriptor_write_f('DescriptorName',
     &                                 'Zone Connectivity', ier)

! *** bocos
	    call cg_boco_write_f(cg, base_no, zone_no, 'boco#1',
     &           BCInflow, PointRange, 2_cgsize_t, pnts, boco_no, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

! *** boco normal
	    npnts = 1
	    do i=1,Ndim
	        NormalIndex(i)=0
		! compute nr of points on bc patch:
		npnts = npnts * (pnts(i,2)-pnts(i,1)+1)
	    enddo
	    NormalIndex(1)=1
	    do i=1,phys_dim*npnts
		normals(i)=i
	    enddo

	    call cg_boco_normal_write_f(cg, base_no, zone_no, boco_no,
     &         NormalIndex, 1, RealSingle, normals, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

! ** boundary condition attributes: GOTO BC_t node
            call cg_goto_f(cg, base_no, ier, 'Zone_t', zone, 'ZoneBC_t',
     &          1, 'BC_t', boco_no, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f

! ** boundary condition attributes:  GridLocation_t
            call cg_gridlocation_write_f(Vertex, ier)
            if (ier .eq. ERROR) call cg_error_exit_f

! ** boundary condition dataset
	    call cg_dataset_write_f(cg, base_no, zone,
     &         boco_no, 'DataSetName', BCInflow, dset_no, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

! ** boundary condition data:
	    call cg_bcdata_write_f(cg, base_no, zone,
     &         boco_no, dset_no, Neumann, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

! ** boundary condition data arrays: GOTO BCData_t node
	    call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no,
     &          'ZoneBC_t', 1, 'BC_t', boco_no, 'BCDataSet_t', dset_no,
     &          'BCData_t', Neumann, 'end')
	    if (ier .eq. ERROR) call cg_error_exit_f

	    do i=1, npnts
		data(i) = i
	    enddo
	    call cg_array_write_f('dataset_arrayname', RealSingle,
     &           1, npnts, data, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

 	enddo					! zone loop

! *** close CGNS file
	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	end

	program modify_cprop
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on August 2002

!       This example test modifying the GridConnectivityProperty_t data structure and its children
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 3)
	integer index_dim, cell_dim, phys_dim
	integer cg, base, zone, conn, ier, size(Ndim*3), i, num, n
	integer nbases
	integer(cgsize_t) dim_vals(2)
	integer AverageInterfaceType, pnts(Ndim,20), donor_pnts(Ndim,20)
	real *4 RotationCenter(Ndim), RotationAngle(Ndim)
	real *4 Translation(Ndim), version
	character*100 linkpath
	character*32 basename

! *** initialize
	ier = 0
	index_dim=Ndim
	cell_dim=Ndim
	phys_dim=Ndim

! *** open CGNS file for writing
 	call cg_open_f('Test_V2', MODE_MODIFY, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,600)'MODIFYING FILE Test_V2'

! *** CGNS Library Version used for file creation:
        call cg_version_f(cg, version, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,102) &
           'Library Version used for file creation:',version

! *** base
        call cg_nbases_f(cg, nbases, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,200)'nbases=',nbases

        base=1

        call cg_base_read_f(cg, base, basename, cell_dim, phys_dim, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,300)'BaseName = "',basename,'"', &
                      'cell_dimension=',cell_dim

        zone = 1
	conn = 2

! *** write GridConnectivityProperty_t/AverageInterface_t node under conn#2
	AverageInterfaceType = CGNS_ENUMV(AverageCircumferential)
	call cg_conn_average_write_f(cg, base, zone, &
              conn, AverageInterfaceType, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** test calling it again
!	call cg_conn_average_write_f(cg, base, zone,
!    &        conn, AverageInterfaceType, ier)
!       if (ier .eq. ERROR) call cg_error_print_f

! *** write GridConnectivityProperty_t/Periodic_t node under conn#2
	do n=1, Ndim
	    RotationCenter(n) = n*1.1
	    RotationAngle(n) = (n+3)*1.1
	    Translation(n) = (n+6)*1.1
	enddo
	call cg_conn_periodic_write_f(cg, base, zone, conn, &
       	     RotationCenter, RotationAngle, Translation, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! *** write Descriptor_t, UserDefinedData_t & Link under...
! ...   GridConnectivityProperty_t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
            'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn, &
      	    'GridConnectivityProperty_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_descriptor_write_f('GridConnPropDescriptorName', &
            'GridConnPropDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_user_data_write_f('GridConnPropUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

!	write(linkpath,'(a)') '/Basename/BaseDescriptorName'
!       call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
!       if (ier .eq. ERROR) call cg_error_exit_f

! ...   AverageInterface_t
	call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
      	    'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn, &
            'GridConnectivityProperty_t', 1, 'AverageInterface_t', 1, &
            'end')
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_descriptor_write_f('AverageInterfaceDescriptorName', &
      	    'AverageInterfaceDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_user_data_write_f('AverageInterfaceUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! ...   Periodic_t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
            'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn, &
            'GridConnectivityProperty_t', 1, 'Periodic_t', 1, 'end')
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_descriptor_write_f('PeriodicDescriptorName', &
      	    'PeriodicDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_user_data_write_f('PeriodicUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * DataClass & DimensionalUnits under Periodic
        call cg_dataclass_write_f(CGNS_ENUMV(Dimensional), ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        call cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), CGNS_ENUMV(Kelvin), &
                              CGNS_ENUMV(Radian), ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * DataArray under Periodic
 	dim_vals(1)=3
 	dim_vals(2)=2
 	call cg_array_write_f('arraysize', CGNS_ENUMV(Integer), 2, dim_vals, &
              size, ier)
 	if (ier .ne. ERROR) write(6,'(a)') 'Error in API'

! * DataClass & DimensionalUnits under RotationCenter
	call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
            'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn, &
            'GridConnectivityProperty_t', 1, 'Periodic_t', 1, &
            'DataArray_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_dataclass_write_f(CGNS_ENUMV(Dimensional), ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	call cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), CGNS_ENUMV(Kelvin), &
      	    		      CGNS_ENUMV(Radian), ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** close CGNS file
	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

 102    format(a,f8.3)
 200    format(a,i5)
 300    format(3a/a,i2)
 600    format(3a)

	end

      program testcomplexf
#ifdef WINNT
      include 'cgnswin_f.h'
#endif
      USE CGNS
      IMPLICIT NONE
#if CG_BUILD_COMPLEX_C99_EXT
      INTEGER, PARAMETER :: dp = KIND(1.d0)
      
      integer, parameter :: celldim = 3, physdim = 3
      integer(cgsize_t), parameter :: size(3,3) = &
     &  reshape((/5,5,5, 4,4,4, 0,0,0 /), (/3, 3/))
      integer(cgsize_t), parameter :: NUM_I = &
     &  size(1,1)
      integer(cgsize_t), parameter :: NUM_J = &
     &  size(2,1)
      integer(cgsize_t), parameter :: NUM_K = &
     &  size(3,1)
      integer(cgsize_t), parameter :: num_coord = NUM_I * NUM_J * NUM_K

      integer :: ierr
      integer :: cgfile, cgbase, cgzone, cggrid, cgcoord, cgsol, cgfld
      integer :: n, np

      integer(cgsize_t) :: i, j, k
      integer(cgsize_t) :: dims(3)
      integer(cgsize_t) :: rmin(3), rmax(3)
      integer(cgsize_t) :: m_rmin(3), m_rmax(3)

      REAL(KIND=dp), DIMENSION(NUM_I, NUM_J, NUM_K) :: xcoord, ycoord, zcoord
      COMPLEX(KIND=dp), DIMENSION(NUM_I, NUM_J, NUM_K) :: solution, fbuf

      character*32 coordname(3)
      character*32 fieldname

      coordname(1) = 'CoordinateX'
      coordname(2) = 'CoordinateY'
      coordname(3) = 'CoordinateZ'

      fieldname = 'Pressure'

      do k = 1, NUM_K
        do j = 1, NUM_J
           do i = 1, NUM_I
              call compute_coord()
              call compute_sol()
          enddo
        enddo
      enddo

!     open

      call cg_open_f('complex_dataf.cgns', CG_MODE_WRITE, cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

!---- structured grid ----

      print *,'writing structured base with complex data'

!     write base and zone

      call cg_base_write_f(cgfile, 'Structured', celldim, physdim, &
     &                     cgbase, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_zone_write_f(cgfile, cgbase, 'Zone', size,              &
     &                     Structured, cgzone, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      dims(1) = NUM_I
      dims(2) = NUM_J
      dims(3) = NUM_K

      do n=1,3
        rmin(n)   = 1
        rmax(n)   = dims(n)
        m_rmin(n) = 1
        m_rmax(n) = dims(n)
      enddo

!     write coordinates

      call cg_grid_write_f(cgfile, cgbase, cgzone, 'GridCoordinates', &
     &                     cggrid, ierr)
      call cg_goto_f(cgfile, cgbase, ierr, 'Zone_t', cgzone, &
     &               'GridCoordinates_t', cggrid, 'end')

      call cg_coord_general_write_f(cgfile, cgbase, cgzone, &
     &                           coordname(1), RealDouble, &
     &                           rmin, rmax, RealDouble, &
     &                           3, dims, m_rmin, m_rmax, &
     &                           xcoord, cgcoord, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_coord_general_write_f(cgfile, cgbase, cgzone, &
     &                           coordname(2), RealDouble, &
     &                           rmin, rmax, RealDouble, &
     &                           3, dims, m_rmin, m_rmax, &
     &                           ycoord, cgcoord, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_coord_general_write_f(cgfile, cgbase, cgzone, &
     &                           coordname(3), RealDouble, &
     &                           rmin, rmax, RealDouble, &
     &                           3, dims, m_rmin, m_rmax, &
     &                           zcoord, cgcoord, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

!     write solution

      call cg_sol_write_f(cgfile, cgbase, cgzone, 'Solution', &
     &                    Vertex, cgsol, ierr)
      call cg_goto_f(cgfile, cgbase, ierr, 'Zone_t', cgzone, &
     &               'FlowSolution_t', cgsol, 'end')
      call cg_field_general_write_f(cgfile, cgbase, cgzone, cgsol, &
     &                          fieldname, ComplexSingle, &
     &                          rmin, rmax, ComplexDouble, &
     &                          3, dims, m_rmin, m_rmax, &
     &                          solution, cgfld, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

!     close the file and reopen in read mode

      call cg_close_f(cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      print *,'closing and reopening in read mode '     

!     read file and check the data

      call cg_open_f('complex_dataf.cgns', CG_MODE_READ, cgfile, ierr)
      if (ierr .eq. ERROR) call cg_error_exit_f

      write(6,*)'checking the data '
      cgbase = 1
      cgzone = 1
      cggrid = 1
      cgsol  = 1

!     check field

      call cg_field_general_read_f(cgfile, cgbase, cgzone, cgsol, &
     &                         'Pressure', &
     &                          rmin, rmax, ComplexDouble, &
     &                          3, dims, m_rmin, m_rmax, fbuf, ierr)
      if (ierr .eq. ERROR) call cg_error_exit_f
      np = 0
      do k = 1, NUM_K
         do j = 1, NUM_J
            do i = 1, NUM_I
              if (fbuf(i,j,k) .ne. solution(i,j,k)) then
                np = np + 1
              endif
          enddo
        enddo
      enddo
      if (np .ne. 0) then
        print *, np, ' differences in Field'
      endif

!     close the file
      print *, 'closing file'
      call cg_close_f(cgfile, ierr)
      if (ierr .eq. ERROR) call cg_error_exit_f

      if (np .ne. 0) then
        stop
      endif

!- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

      contains

!     initial data
      subroutine compute_coord()
      xcoord(i, j, k) = i
      ycoord(i, j, k) = j
      zcoord(i, j, k) = k
      end subroutine

      subroutine compute_sol()
      solution(i, j, k) = CMPLX(REAL(i,KIND=dp), REAL(j,KIND=dp), KIND=dp)
      end subroutine
#endif
      end program

        program write_mixed_grid
	USE CGNS

!	author: Diane Poirier
!	last revised on March 8 2000

! 	This example test the new data structures created for
! 	unstructured data and geometry reference data.  The
! 	model being create is composed of 2 zones.  The 1st
!	one is a structured 3x3x3 block, and the 2nd is
!	an unstructured 3x3x3 block composed of 8 hexa elements.
! 	The 2 zones interface (Abutting1to1) on one 9-nodes face.
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	parameter (Ndim = 3)
	integer index_dim, cell_dim, phys_dim
	integer cg, base, zone, num, ier, index, ZoneType
        integer(cgsize_t) size(Ndim*3)
	integer i, j, k, n, pos, coord, element(8,8)
	integer hexa_section_no, quad_section_no, parent(4,4)
        integer(cgsize_t) elist(4)
	integer quads(4,4)
        integer(cgsize_t)  pnts(3,9), uns_pnts(9)
        integer(cgsize_t) dim_vals(12)
	integer Nindex(3)
	double precision VertexNormals(3,9), FaceNormals(3,4)
	integer fam, geo, part, bc
	integer sol_no, field_no
	character*32 ZoneName, coordname(3), geoname, fambcname
	character*200 cadfile, partname
        double precision data_double(200*3), interpolants(3,9)
	integer grid_no

!       initialize
        ier = 0
	cell_dim=3
	phys_dim=3

!       open CGNS file for writing

        call cg_open_f('Test_V2M', MODE_MODIFY, cg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

!*******write CGNSBase
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	call cg_base_write_f(cg, 'Name of my Base', cell_dim, phys_dim, &
      			     base, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

!****** Create 2 volume and 1 face families
	call cg_family_write_f(cg, base, 'Family#1', index, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	call cg_family_write_f(cg, base, 'Family#2', index, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
        call cg_family_write_f(cg, base, 'Outflow', index, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! ******write CGNSBase substructure: Zone
	do zone=1, 2

! Structured zone:
	    if (zone .eq. 1) then
		ZoneType=CGNS_ENUMV(Structured)
	        write(ZoneName,100) 'StructuredZone#1'
		
		index_dim = 3
		do i=1, index_dim
		    size(i) = 3
		    size(i+index_dim) = size(i)-1
		    size(i+2*index_dim) = 0              ! unsorted data
		enddo

! Unstructured zone:
	    else if (zone .eq. 2) then
		ZoneType=CGNS_ENUMV(Unstructured)
		write(ZoneName,'(a)') 'UnstructuredZone#1'
		index_dim = 1
		size(1) = 27		! no of nodes
	 	size(2) = 8		! no of elements
		size(3) = 0		! unsorted nodes
	    endif

	    num = 1
            do i=1, index_dim               		
                num = num * size(i)
            enddo
	    call cg_zone_write_f(cg,base,ZoneName,size,ZoneType, &
                                 index,ier)
            if (ier .eq. ERROR) call cg_error_exit_f

! GOTO Zone node and write family name :
            call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f
	    if (zone.eq.1) then
	  	call cg_famname_write_f('Family#1', ier)
	    else
		call cg_famname_write_f('Family#2', ier)
	    endif
	    if (ier .eq. ERROR) call cg_error_exit_f

! Name convention
            coordname(1) = 'CoordinateX'
            coordname(2) = 'CoordinateY'
            coordname(3) = 'CoordinateZ'

! Create GridCoordinates_t node
            call cg_grid_write_f(cg,base,index,'GridCoordinates', &
                               grid_no, ier)
            if (ier.ne. ALL_OK) call cg_error_exit_f

! create coordinate data
            do coord=1,phys_dim
               DO k=1, 3
                  DO j=1, 3
                     DO i=1, 3
                        pos = i + (j-1)*3 + (k-1)*9
                        IF (coord.EQ.1) data_double(pos) = (i-1)*5 + &
                             (zone-1)*10
                        IF (coord.EQ.2) data_double(pos) = (j-1)*5
                        IF (coord.EQ.3) data_double(pos) = (k-1)*5
                     ENDDO
                  ENDDO
               ENDDO

! GOTO GridCoordinatesNode & write DataArray
                call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                    'GridCoordinates_t', 1, 'end')
                if (ier .eq. ERROR) call cg_error_exit_f

                call cg_array_write_f(coordname(coord), CGNS_ENUMV(RealDouble), &
                    index_dim, size, data_double, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
	    enddo	! coord. loop

! Flow Solution

	    do n=1,8
		data_double(n) = 1.0 + n/10.0
	    enddo
	    call cg_sol_write_f(cg, base, zone,'Solution1',CGNS_ENUMV(CellCenter), &
               sol_no,ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
	    call cg_field_write_f(cg, base, zone, sol_no, CGNS_ENUMV(RealDouble), &
                'DummySolution', data_double, field_no, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

! Grid Connectivity 1to1:  From a structured zone to an unstructured zone
	    ! Unstructured point list:
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	    uns_pnts(1)=1
	    do n=2,9
		uns_pnts(n) = uns_pnts(n-1)+3
	    enddo

	    if (zone .eq. 1) then
		! PointRange for structured zone:
	        pnts(1,1)=3
	        pnts(2,1)=1
	        pnts(3,1)=1
	        pnts(1,2)=3
                pnts(2,2)=3
                pnts(3,2)=3

	        call cg_conn_write_f(cg, base, zone, 'str_to_unstr', &
       	            CGNS_ENUMV(Vertex), CGNS_ENUMV(Abutting1to1), CGNS_ENUMV(PointRange), 2_cgsize_t, pnts, &
                    'UnstructuredZone#1', CGNS_ENUMV(Unstructured), &
                    CGNS_ENUMV(PointListDonor), CGNS_ENUMV(Integer), 9_cgsize_t, uns_pnts,index, &
                    ier)
		if (ier .eq. ERROR) call cg_error_exit_f

! Fake similation of Overset or Abutting-mismatch: str to unstr
		call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                    'ZoneGridConnectivity_t', 1, &
                    'GridConnectivity_t', 1, 'end')
                if (ier .eq. ERROR) call cg_error_exit_f

		do n=1,9
		do i=1,cell_dim
		    interpolants(i,n)=0.1*i+n
		enddo
		enddo

		dim_vals(1)=cell_dim
		dim_vals(2)=9
		call cg_array_write_f('InterpolantsDonor', CGNS_ENUMV(RealDouble), &
                    2, dim_vals, interpolants(1,1), ier)
                if (ier .eq. ERROR) call cg_error_exit_f
		
	    endif

	

! Grid Connectivity 1to1:  From an unstructured zone to a structured zone
	    if (zone .eq. 2) then

		! PointList of structured donor
		n=0
		do k=1,3
		do j=1,3
		    n=n+1
		    pnts(1,n) = 3
		    pnts(2,n) = j
		    pnts(3,n) = k
		enddo
		enddo

		call cg_conn_write_f(cg, base, zone, 'unstr_to_str', &
                    CGNS_ENUMV(Vertex), CGNS_ENUMV(Abutting1to1), CGNS_ENUMV(PointList), 9_cgsize_t, &
                    uns_pnts, &
                    'StructuredZone#1', CGNS_ENUMV(Structured), CGNS_ENUMV(PointListDonor), &
      		    CGNS_ENUMV(Integer), 9_cgsize_t, pnts, index, ier)
		if (ier .eq. ERROR) call cg_error_exit_f
            endif


! BOUNDARY CONDITION PATCH: Put a user defined b.c. at interface
	    if (zone.eq.1) then
	      ! write a PointRange patch (3,1,1) to (3,3,3) for a structured zone
	        call cg_boco_write_f(cg, base, zone, 'myboco', &
                  CG_UserDefined, CGNS_ENUMV(PointRange), 2_cgsize_t, pnts, index, ier)
	        if (ier .eq. ERROR) call cg_error_exit_f

	      ! Write Normal index and Normal vectors
		Nindex(1)=-1
		Nindex(2)=0
		Nindex(3)=0
		do n=1, 9
		    VertexNormals(1,n) = -1.0	! x-coord
		    VertexNormals(2,n) = 0	! y-coord
		    VertexNormals(3,n) = 0	! z-coord
		enddo
		
		call cg_boco_normal_write_f(cg, base, zone, index, Nindex, &
                      1, CGNS_ENUMV(RealDouble), VertexNormals, ier)
		if (ier .eq. ERROR) call cg_error_exit_f


	    else if (zone.eq.2) then
	      ! BC patch defined using points and normals at the points:
		call cg_boco_write_f(cg, base, zone, 'point_patch', &
                  CG_UserDefined, CGNS_ENUMV(PointList), 9_cgsize_t, uns_pnts, index, &
                  ier)
                if (ier .eq. ERROR) call cg_error_exit_f

	      ! note: Normal index has no definition in unstructured
		do n=1, 9
		    VertexNormals(1,n) = 1.0
		enddo
		call cg_boco_normal_write_f(cg, base, zone, index, Nindex, &
                      1, CGNS_ENUMV(RealDouble), VertexNormals, ier)
                if (ier .eq. ERROR) call cg_error_exit_f

	      ! BC patch defined using face elements & normals at the faces
		do n=1, 4
		  elist(n)=8+n
		  FaceNormals(1,n)=1.0
		  FaceNormals(2,n)=0
		  FaceNormals(3,n)=0
		enddo
		call cg_boco_write_f(cg, base, zone, 'shell_patch', &
                  CGNS_ENUMV(BCOutflow), CGNS_ENUMV(PointList), 4_cgsize_t, elist, index, ier)
		if (ier .eq. ERROR) call cg_error_exit_f

	     ! Specify that the GridLocation is FaceCenter
		call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                   'ZoneBC_t', 1, 'BC_t', index, 'end')
                if (ier .eq. ERROR) call cg_error_exit_f

		call cg_gridlocation_write_f(CGNS_ENUMV(FaceCenter), ier)
		if (ier .eq. ERROR) call cg_error_exit_f

                call cg_boco_normal_write_f(cg, base, zone, index, &
                      Nindex, 1, CGNS_ENUMV(RealDouble), FaceNormals, ier)
                if (ier .eq. ERROR) call cg_error_exit_f

	      ! Define family name for BC patch
		call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                   'ZoneBC_t', 1, 'BC_t', index, 'end')
		if (ier .eq. ERROR) call cg_error_exit_f

		call cg_famname_write_f("Outflow", ier)
		if (ier .eq. ERROR) call cg_error_exit_f
	    endif

! ********** SPECIAL FOR UNSTRUCTURED ZONES ONLY **********

	    if (ZoneType .eq. CGNS_ENUMV(Unstructured)) then

            ! Generate HEXA_8 Element Connectivity
                n=0
                DO k=1,2
                   DO j=1,2
                      DO i=1,2
                         n=n+1
                         pos = i + (j-1)*3 + (k-1)*9
                         element(1,n) = pos
                         element(2,n) = pos+1
                         element(3,n) = pos+4
                         element(4,n) = pos+3
                         element(5,n) = pos+9
                         element(6,n) = pos+10
                         element(7,n) = pos+13
                         element(8,n) = pos+12
                      ENDDO
                   ENDDO
                ENDDO

		call cg_section_write_f(cg, base, zone, &
                  'VolumeElements', CGNS_ENUMV(HEXA_8), 1, 8, 0, &
                   element, hexa_section_no, ier)
		if (ier .eq. ERROR) call cg_error_exit_f

	      ! GENERATE some quad elements
                ! 1st node of each element
                quads(1,1) = 3
                quads(1,2) = 6
                quads(1,3) = 12
                quads(1,4) = 15
                ! remaining nodes of each element
                do n=1, 4
                    quads(2,n)=quads(1,n)+3
                    quads(3,n)=quads(1,n)+12
                    quads(4,n)=quads(1,n)+9
                enddo

		call cg_section_write_f(cg, base, zone, 'outflow', &
                  CGNS_ENUMV(QUAD_4), 9, 12, 0, quads, quad_section_no, ier)
		if (ier .eq. ERROR) call cg_error_exit_f

	     !  GENERATE Parent Data for shell elements
		do n=1, 4
		    parent(n,1) = 2*n	! first parent
		    parent(n,2) = 0	! no second parent
		    parent(n,3) = 3	! face of first parent
		    parent(n,4) = 0	! face of 2nd parent
		enddo

		call cg_parent_data_write_f(cg, base, zone, &
                     quad_section_no, parent, ier)
		if (ier .eq. ERROR) call cg_error_exit_f

! Auxiliary info:
                call cg_goto_f(cg,base,ier,'Zone_t',zone,'Elements_t', &
                  hexa_section_no, 'end')
                if (ier .eq. ERROR) call cg_error_exit_f

                call cg_descriptor_write_f('Descriptor_Name', &
                    'Descriptor_Text', ier)
                if (ier .eq. ERROR) call cg_error_exit_f


	    endif	! IF UNSTRUCTURED ZONE


! *********************************************************************

        enddo	! zone loop

! FAMILY and GEOMETRY

	do fam=1,3
          ! A family may have several GeometryReference_t node
            do geo=1, 2
                write(geoname, 200) 'Geo#',geo,'_of_fam#',fam
		write(cadfile, 200)'CADFile#',geo
                call cg_geo_write_f(cg, base, fam, geoname, &
                    cadfile, 'IGES', index, ier)
                if (ier .eq. ERROR) call cg_error_exit_f

		! A GeometryReference_t may encompass several parts
		do part = 1, 2
		    write(partname, 200)'Part#',part
		    call cg_part_write_f(cg, base, fam, geo, &
                        partname, index, ier)
		    if (ier .eq. ERROR) call cg_error_exit_f
		enddo

	      ! GeometryReference_t descriptor
		call cg_goto_f(cg, base, ier, 'Family_t', fam, &
                 'GeometryReference_t',geo,'end')
		if (ier .eq. ERROR) call cg_error_exit_f

		call cg_descriptor_write_f('Descriptor', &
                 geoname, ier)
		if (ier .eq. ERROR) call cg_error_exit_f
	    enddo

	  ! A family may have several FamilyBC_t node
	    do bc=1,2
		write(fambcname,'(a,i1)')'FamBC#',bc
	 	call cg_fambc_write_f(cg, base, fam, fambcname, &
                  CGNS_ENUMV(BCGeneral), index, ier)
		if (ier .eq. ERROR) call cg_error_exit_f
	    enddo

	 !  Family Descriptor and Ordinal
	    call cg_goto_f(cg, base, ier, 'Family_t', fam, 'end')
	    if (ier .eq. ERROR) call cg_error_exit_f

	    call cg_descriptor_write_f('Fam_Descr_Name', &
                  'Fam_Descr_Text', ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

	    call cg_ordinal_write_f(fam, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
	enddo

! Auxiliary nodes for FAMILY and GEOMETRY

! *********************************************************************

	call cg_close_f(cg, ier)
	if (ier.eq. ERROR) call cg_error_exit_f()
 100	format(a)
 200	format(a,i1,a,i1)

	end

	program modify_bprop
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on August 2002

!       This example test modifying BCProperty_t data structure and its children
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 3)
	integer index_dim, cell_dim, phys_dim
	character*100 linkpath

	integer cg, base, zone, boco, ier, size(Ndim*3), i, num
	integer WallFunctionType, AreaType, pnts(Ndim,2), nbases
	character*32 RegionName32, basename
	real *4 SurfaceArea, version
	integer(cgsize_t) dim_vals(2)
	

! *** initialize
	ier = 0
	index_dim=Ndim
	cell_dim=Ndim
	phys_dim=Ndim

! *** open CGNS file for writing
 	call cg_open_f('Test_V2', MODE_MODIFY, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,600)'MODIFYING FILE Test_V2'

! *** CGNS Library Version used for file creation:
        call cg_version_f(cg, version, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,102) &
           'Library Version used for file creation:',version

! *** base
	call cg_nbases_f(cg, nbases, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,200)'nbases=',nbases

	base=1

        call cg_base_read_f(cg, base, basename, cell_dim, phys_dim, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,300)'BaseName = "',basename,'"', &
                      'cell_dimension=',cell_dim

	zone =1
	boco=2

! *** write BCProperty_t/WallFunction_t node under boco#2
	WallFunctionType = CGNS_ENUMV(Generic)
	call cg_bc_wallfunction_write_f(cg, base, zone, &
              boco, WallFunctionType, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	write(6,*)'WallFunction_t written'

! *** write BCProperty_t/Area_t node under boco#2
	AreaType = CGNS_ENUMV(BleedArea)
	SurfaceArea = 123.456
 	RegionName32 = 'myRegion'
	call cg_bc_area_write_f(cg, base, zone, boco, AreaType, &
       	     SurfaceArea, RegionName32, ier)

	write(6,*)'Area_t written'

! *** write Descriptor_t, UserDefinedData_t & Link under...
! ...   BCProperty_t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1, &
      	    'BC_t', boco, 'BCProperty_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

	write(6,*)'cg_goto BCProperty_t: ier=',ier

        call cg_descriptor_write_f('BCpropDescriptorName', &
            'BCpropDescriptorText', ier)
	write(6,*)'cg_descriptor_write_f: ier=',ier
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_user_data_write_f('BCPropUserData', ier)
	write(6,*)'cg_user_data_write_f: ier=',ier
        if (ier .eq. ERROR) call cg_error_exit_f

! ...   WallFunction_t
	call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1, &
            'BC_t', boco, 'BCProperty_t', 1, 'WallFunction_t', 1, 'end')

	call cg_descriptor_write_f('WFDescriptorName', &
      	    'WFDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_user_data_write_f('WFUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! ...   Area_t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1, &
            'BC_t', boco, 'BCProperty_t', 1, 'Area_t', 1, 'end')
	call cg_descriptor_write_f('AreaDescriptorName', &
      	    'AreaDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_user_data_write_f('AreaUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

 	dim_vals(1)=3
 	dim_vals(2)=2
 	call cg_array_write_f('arraysize', CGNS_ENUMV(Integer), 2, dim_vals, &
              size, ier)
 	if (ier .ne. ERROR) write(6,'(a)') 'Error in API'

! * DataClass & DimensionalUnits under SurfaceArea
	call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1, &
            'BC_t', boco, 'BCProperty_t', 1, 'Area_t', 1, 'DataArray_t', &
      	    1, 'end')

	call cg_dataclass_write_f(CGNS_ENUMV(Dimensional), ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	call cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), CGNS_ENUMV(Kelvin), &
      	    		      CGNS_ENUMV(Radian), ier)
	if (ier .eq. ERROR) call cg_error_exit_f

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

! *** close CGNS file
	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

 102    format(a,f8.3)
 200    format(a,i5)
 300    format(3a/a,i2)
 600    format(3a)
	end

      program read_bcpnts_str
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Opens an existing CGNS file that contains a simple 3-D
!   structured grid + BCs (in PointList format), and reads the BCs
!
!   The CGNS grid file 'grid.cgns' must already exist
!   (created using write_grid_str.f), and the BCs must also
!   already have been written (using write_bcpnts_str.f).  Note: whether the
!   existing CGNS file has a flow solution in it already or
!   not is irrelevant.
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c read_bcpnts_str.F90
!   ifort -o read_bcpnts_str read_bcpnts_str.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
      integer, parameter :: maxpnts=400
      integer(cgsize_t) ipnts(3,maxpnts),npts,normallistflag
      integer normalindex(3)
      integer i,normallist,ndataset,normaldatatype,iptset,ibocotype
      integer ib,nbocos
      integer index_zone,index_base,index_file,ier
      character boconame*32
!
!  READ BOUNDARY CONDITIONS FROM EXISTING CGNS FILE
!  open CGNS file for read-only
      call cg_open_f('grid.cgns',CG_MODE_READ,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!  we know there is only one base (real working code would check!)
      index_base=1
!  we know there is only one zone (real working code would check!)
      index_zone=1
!  find out number of BCs that exist under this zone
      call cg_nbocos_f(index_file,index_base,index_zone,nbocos,ier)
!  do loop over the total number of BCs
      do ib=1,nbocos
!  get BC info
        call cg_boco_info_f(index_file,index_base,index_zone,ib,               &
             boconame,ibocotype,iptset,npts,normalindex,normallistflag,        &
             normaldatatype,ndataset,ier)
        if (iptset .ne. CGNS_ENUMV(PointList)) then
          write(6,'('' Error.  For this program, BCs must be set'',            &
           ''  up as PointList type'',a32)') PointSetTypeName(iptset)
          stop
        end if
        write(6,'('' BC number: '',i5)') ib
        write(6,'(''    name='',a32)') boconame
        write(6,'(''    type='',a32)') BCTypeName(ibocotype)
        write(6,'(''    no of pts='',i5)') npts
        if (npts .gt. maxpnts) then
          write(6,'('' Error.  Must increase maxpnts to at least '',i5)') npts
          stop
        end if
!  read point list in here (nothing done with them in this program)
        call cg_boco_read_f(index_file,index_base,index_zone,ib,               &
             ipnts,normallist,ier)
        write(6,'(''      (these points read here, but only some'',            &
          '' printed out:)'')')
        do i=1,10
          write(6,'('' ipnts(1,'',i2,''), (2,'',i2,''), (3,'',i2,'')='',       &
            3i4)') i,i,i,ipnts(1,i),ipnts(2,i),ipnts(3,i)
        enddo
      enddo
!  close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully read BCs (PointList format)'',                 &
       '' from file grid.cgns'')')
      stop
      end

MODULE cgns_write_test
  USE CGNS
  USE ISO_C_BINDING
  IMPLICIT NONE

CONTAINS
  ! Callback checks
  SUBROUTINE print_error(error_code, error_msg) BIND(C)

    IMPLICIT NONE

    INTEGER :: i
    INTEGER(C_INT), VALUE :: error_code
    CHARACTER(LEN=1), DIMENSION(*) :: error_msg
    INTEGER :: eol
    INTEGER :: check

    eol = 0
    DO i = 1, 80 !CGIO_MAX_ERROR_LENGTH
       IF(error_msg(i)(1:1).EQ.C_NULL_CHAR) EXIT
       eol = eol + 1
    END DO

    ! error_msg should be "cgio_open_file:invalid configuration option"
    IF(error_code.NE.1 .OR. eol .NE. 43 .OR. &
         error_msg(1)(1:1) .NE. "c" .OR. error_msg(4)(1:1) .NE. "o") THEN
       STOP 1
    END IF

  END SUBROUTINE print_error

END MODULE cgns_write_test


PROGRAM write_cgns_1
#include "cgnstypes_f03.h"
#ifdef WINNT
  INCLUDE 'cgnswin_f.h'
#endif
  USE CGNS
  USE ISO_C_BINDING
  USE cgns_write_test
  IMPLICIT NONE

  ! author: Diane Poirier (diane@icemcfd.com)

  ! This example test the complete SIDS for multi-block data.
  ! It creates a dummy mesh composed of 2 structured blocks in 3D.
  ! It also tests the cg_configure_f API.

  INTEGER Ndim
  PARAMETER (Ndim = 3)
  INTEGER :: one
  PARAMETER (one = 1)
  INTEGER, PARAMETER :: sp = KIND(1.0)

  INTEGER :: index_dim, cell_dim, phys_dim
  INTEGER :: base_no, zone_no, coord_no, sol_no, discr_no, conn_no
  INTEGER :: hole_no, boco_no, field_no, dset_no
  INTEGER :: num, NormalIndex(Ndim)
  INTEGER :: ndims
  INTEGER(CGSIZE_T) :: size(Ndim*3)
  INTEGER(CGSIZE_T) :: npnts
  INTEGER :: zone, coord, i, j, k, n, pos, sol, field
  INTEGER cg, ier
  INTEGER(CGSIZE_T) :: pnts(Ndim,120), donor_pnts(Ndim,120)
  INTEGER transform(Ndim)
  INTEGER :: nptsets, nrmlistflag
  REAL(KIND=sp) DATA(120), normals(360)
  DOUBLE PRECISION Dxyz(120), values(120)
  CHARACTER(LEN=32) zonename, solname, fieldname
  CHARACTER(LEN=32) coordname(Ndim)
  CHARACTER(LEN=32) donorname

  INTEGER, TARGET :: value_f
  INTEGER(C_SIZE_T), TARGET :: value_size_t_f
  CHARACTER(LEN=32), TARGET :: path

  TYPE(C_FUNPTR) :: f_funptr
  TYPE(C_PTR) :: f_ptr

  coordname(1) = 'CoordinateX'
  coordname(2) = 'CoordinateY'
  coordname(3) = 'CoordinateZ'

! *** initialize
  ier = 0
  index_dim=Ndim
  cell_dim=Ndim
  phys_dim=Ndim

  ! *** open CGNS file for writing
  CALL cg_open_f('cgtest.cgns', CG_MODE_WRITE, cg, ier)
  IF (ier .EQ. ERROR) CALL cg_error_exit_f

  ! *** base
  CALL cg_base_write_f(cg, 'Basename', cell_dim, phys_dim, base_no, ier)
  IF (ier .EQ. ERROR) CALL cg_error_exit_f

! *** zone
  DO zone=1, 2
     WRITE(zonename,'(a5,i1)') 'zone#',zone
     num = 1
     DO i=1,index_dim                    ! zone#1: 3*4*5, zone#2: 4*5*6
        size(i) = i+zone+1              ! nr of nodes in i,j,k
        size(i+Ndim) = size(i)-1        ! nr of elements in i,j,k
        size(i+2*Ndim) = 0              ! nr of bnd nodes if ordered
        num = num * size(i)             ! nr of nodes
     ENDDO
     CALL cg_zone_write_f(cg, base_no, zonename, size, &
          CGNS_ENUMV(Structured), zone_no, ier)
     IF (ier .EQ. ERROR) CALL cg_error_exit_f

     ! *** coordinate
     DO coord=1, phys_dim
        DO k=1, SIZE(3)
           DO j=1, SIZE(2)
              DO i=1, SIZE(1)
                 pos = i + (j-1)*SIZE(1) + (k-1)*SIZE(1)*SIZE(2)
                 ! * make up some dummy coordinates just for the test:
                 IF (coord.EQ.1) Dxyz(pos) = i
                 IF (coord.EQ.2) Dxyz(pos) = j
                 IF (coord.EQ.3) Dxyz(pos) = k
              ENDDO
           ENDDO
        ENDDO
 
        CALL cg_coord_write_f(cg, base_no, zone_no, CGNS_ENUMV(RealDouble), &
             coordname(coord), Dxyz, coord_no, ier)
        IF (ier .EQ. ERROR) CALL cg_error_exit_f

     ENDDO

     ! *** solution
     DO sol=1, 2
        WRITE(solname,'(a5,i1,a5,i1)') 'Zone#',zone,' sol#',sol
        CALL cg_sol_write_f(cg, base_no, zone_no, solname, &
             CGNS_ENUMV(Vertex), sol_no, ier)
        IF (ier .EQ. ERROR) CALL cg_error_exit_f

        ! *** solution field
        DO field=1, 2
           ! make up some dummy solution values
           DO i=1, num
              values(i) = i*field*sol
           ENDDO
           WRITE(fieldname,'(a6,i1)') 'Field#',field
           CALL cg_field_write_f(cg, base_no, zone_no, sol_no, &
                CGNS_ENUMV(RealDouble), fieldname, values, field_no, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           
        ENDDO                ! field loop
     ENDDO                ! solution loop
     
     ! *** discrete data
     CALL cg_discrete_write_f(cg, base_no, zone_no, 'discrete#1', &
          discr_no, ier)
     IF (ier .EQ. ERROR) CALL cg_error_exit_f

! *** discrete data arrays, defined on vertices:
     CALL cg_goto_f(cg, base_no, ier, 'Zone_t', zone, &
          'DiscreteData_t', discr_no, 'end')
     IF (ier .EQ. ERROR) CALL cg_error_exit_f

     DO k=1, SIZE(3)
        DO j=1, SIZE(2)
           DO i=1, SIZE(1)
              pos = i + (j-1)*SIZE(1) + (k-1)*SIZE(1)*SIZE(2)
              DATA(pos) = pos    ! * make up some dummy data
           ENDDO
        ENDDO
     ENDDO
     CALL cg_array_write_f('arrayname', CGNS_ENUMV(RealSingle), index_dim, &
          size, DATA, ier)
     IF (ier .EQ. ERROR) CALL cg_error_exit_f

! *** discrete data arrays attribute: GOTO DataArray node
     CALL cg_goto_f(cg, base_no, ier, 'Zone_t', zone, &
          'DiscreteData_t', discr_no, 'DataArray_t', 1, 'end')
     IF (ier .EQ. ERROR) CALL cg_error_exit_f

     CALL cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), &
          CGNS_ENUMV(Kelvin), CGNS_ENUMV(Radian), ier)
     IF (ier .EQ. ERROR) CALL cg_error_exit_f

     ! *** overset holes
     !  create dummy data
     DO i=1,3
        ! Define 2 separate PointRange, for 2 patches in the hole
        pnts(i,1)=1
        pnts(i,2)=SIZE(i)
        ! second PointRange of hole
        pnts(i,3)=2
        pnts(i,4)=SIZE(i)
     ENDDO
     ! Hole defined with 2 point set type PointRange, so 4 points:
     nptsets = 2
     npnts = 4
     CALL cg_hole_write_f(cg, base_no, zone_no, 'hole#1', CGNS_ENUMV(Vertex),&
          CGNS_ENUMV(PointRange), nptsets, npnts, pnts, hole_no, ier)
     IF (ier .EQ. ERROR) CALL cg_error_exit_f

! *** general connectivity
     DO n=1, 5
        DO i=1,3
           pnts(i,n)=i        ! * dummy data
           donor_pnts(i,n)=i*2
        ENDDO
     ENDDO
     ! create a point matching connectivity
     npnts = 5
     CALL cg_conn_write_f(cg, base_no, zone_no, 'Connect#1', &
          CGNS_ENUMV(Vertex), CGNS_ENUMV(Abutting1to1), CGNS_ENUMV(PointList), npnts, pnts, 'zone#2', &
          CGNS_ENUMV(Structured), CGNS_ENUMV(PointListDonor), CGNS_ENUMV(integer), &
          npnts, donor_pnts, conn_no, ier)
     IF (ier .EQ. ERROR) CALL cg_error_exit_f

! *** connectivity 1to1
     !  generate data
     DO i=1,3
        !**make up some dummy data:
        pnts(i,1)=1
        pnts(i,2)=SIZE(i)
        donor_pnts(i,1)=1
        donor_pnts(i,2)=SIZE(i)
        transform(i)=i*(-1)
     ENDDO
     IF (zone .EQ. 1) THEN
        donorname='zone#2'
     ELSE IF (zone .EQ. 2) THEN
        donorname='zone#1'
     ENDIF

     CALL cg_1to1_write_f(cg, base_no, zone_no, '1to1_#1', &
          donorname, pnts, donor_pnts, transform, conn_no, ier)
     IF (ier .EQ. ERROR) CALL cg_error_exit_f
     ! *** ZoneGridConnectivity attributes:  GOTO ZoneGridConnectivity_t node
     CALL cg_goto_f(cg, base_no, ier, 'Zone_t', zone, &
          'ZoneGridConnectivity_t', one, 'end')
     IF (ier .EQ. ERROR) CALL cg_error_exit_f

     ! *** ZoneGridConnectivity attributes: Descriptor_t
     CALL cg_descriptor_write_f('DescriptorName', &
          'Zone Connectivity', ier)

     ! *** bocos
     npnts = 2
     CALL cg_boco_write_f(cg, base_no, zone_no, 'boco#1', &
          CGNS_ENUMV(BCInflow), CGNS_ENUMV(PointRange), npnts, pnts, boco_no, ier)
     IF (ier .EQ. ERROR) CALL cg_error_exit_f

     ! *** boco normal
     npnts = 1
     DO i=1,Ndim
        NormalIndex(i)=0
        ! compute nr of points on bc patch:
        npnts = npnts * (pnts(i,2)-pnts(i,1)+1)
     ENDDO
     NormalIndex(1)=1
     DO i=1,phys_dim*npnts
        normals(i)=i
     ENDDO

     nrmlistflag = 1
     CALL cg_boco_normal_write_f(cg, base_no, zone_no, boco_no, &
          NormalIndex, nrmlistflag, CGNS_ENUMV(RealSingle), normals, ier)
     IF (ier .EQ. ERROR) CALL cg_error_exit_f

     ! ** boundary condition attributes: GOTO BC_t node
     CALL cg_goto_f(cg, base_no, ier, 'Zone_t', zone, 'ZoneBC_t', &
          one, 'BC_t', boco_no, 'end')
     IF (ier .EQ. ERROR) CALL cg_error_exit_f

     ! ** boundary condition attributes:  GridLocation_t
     CALL cg_gridlocation_write_f(CGNS_ENUMV(Vertex), ier)
     IF (ier .EQ. ERROR) CALL cg_error_exit_f

     ! ** boundary condition dataset
     CALL cg_dataset_write_f(cg, base_no, zone, &
          boco_no, 'DataSetName', CGNS_ENUMV(BCInflow), dset_no, ier)
     IF (ier .EQ. ERROR) CALL cg_error_exit_f

     ! ** boundary condition data:
     CALL cg_bcdata_write_f(cg, base_no, zone, &
          boco_no, dset_no, CGNS_ENUMV(Neumann), ier)
     IF (ier .EQ. ERROR) CALL cg_error_exit_f

! ** boundary condition data arrays: GOTO BCData_t node
     CALL cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no, &
          'ZoneBC_t', one, 'BC_t', boco_no, 'BCDataSet_t', &
          dset_no, 'BCData_t', CGNS_ENUMV(Neumann), 'end')
     IF (ier .EQ. ERROR) CALL cg_error_exit_f

     DO i=1, npnts
        DATA(i) = i
     ENDDO
     ndims = 1
     CALL cg_array_write_f('dataset_arrayname', CGNS_ENUMV(RealSingle), &
          ndims, [npnts], DATA, ier)
     IF (ier .EQ. ERROR) CALL cg_error_exit_f

! ** boundary condition data attributes:
     CALL cg_dataclass_write_f(CGNS_ENUMV(NormalizedByDimensional), ier)
     IF (ier .EQ. ERROR) CALL cg_error_exit_f

  ENDDO ! zone loop

  ! *** close CGNS file
  CALL cg_close_f(cg, ier)
  IF (ier .EQ. ERROR) CALL cg_error_exit_f

#if CG_BUILD_HDF5
  ! **************************
  ! Test cg_configure options
  ! **************************
  value_f = 1
  CALL cg_configure_f(CG_CONFIG_HDF5_DISKLESS, C_LOC(value_f), ier)
  IF (ier .EQ. ERROR) CALL cg_error_exit_f

  ! enable committing memory to disk
  value_f = 1
  CALL cg_configure_f(CG_CONFIG_HDF5_DISKLESS_WRITE, C_LOC(value_f), ier)
  IF (ier .EQ. ERROR) CALL cg_error_exit_f
  value_size_t_f = INT(20*1024*1024,C_SIZE_T)
  CALL cg_configure_f(CG_CONFIG_HDF5_DISKLESS_INCR, C_LOC(value_size_t_f), ier)
  IF (ier .EQ. ERROR) CALL cg_error_exit_f

  CALL cg_open_f('cgtest_core.cgns', CG_MODE_WRITE, cg, ier)
  IF (ier .EQ. ERROR) CALL cg_error_exit_f

  ! *** base
  CALL cg_base_write_f(cg, 'Basename', cell_dim, phys_dim, base_no, ier)
  IF (ier .EQ. ERROR) CALL cg_error_exit_f

  CALL cg_close_f(cg, ier)
  IF (ier .EQ. ERROR) CALL cg_error_exit_f

  value_f = 0
  CALL cg_configure_f(CG_CONFIG_HDF5_DISKLESS, C_LOC(value_f), ier)
  IF (ier .EQ. ERROR) CALL cg_error_exit_f

  value_f = CG_FILE_ADF2
  value_f = CG_FILE_ADF
  f_ptr = C_LOC(value_f)
  CALL cg_configure_f(CG_CONFIG_FILE_TYPE, f_ptr, ier)
  IF (ier .EQ. ERROR) CALL cg_error_exit_f
  value_f = CG_FILE_HDF5
  CALL cg_configure_f(CG_CONFIG_FILE_TYPE, C_LOC(value_f), ier)
  IF (ier .EQ. ERROR) CALL cg_error_exit_f
  value_f = -1
  CALL cg_configure_f(CG_CONFIG_HDF5_COMPRESS, C_LOC(value_f), ier)
  IF (ier .EQ. ERROR) CALL cg_error_exit_f
  value_f = -1
  CALL cg_configure_f(CG_CONFIG_COMPRESS, C_LOC(value_f), ier)
  IF (ier .EQ. ERROR) CALL cg_error_exit_f
  value_f =  CG_CONFIG_RIND_ZERO

  CALL cg_configure_f(CG_CONFIG_RIND_INDEX, C_LOC(value_f), ier)
  IF (ier .EQ. ERROR) CALL cg_error_exit_f
  value_f = CG_CONFIG_RIND_CORE
  CALL cg_configure_f(CG_CONFIG_RIND_INDEX, C_LOC(value_f), ier)
  IF (ier .EQ. ERROR) CALL cg_error_exit_f

  path = "/test/a/b"//C_NULL_CHAR
  CALL cg_configure_f(CG_CONFIG_SET_PATH, C_LOC(path(1:1)), ier)
  IF (ier .EQ. ERROR) CALL cg_error_exit_f

  path = "/test/c/d"//C_NULL_CHAR
  CALL cg_configure_f(CG_CONFIG_ADD_PATH, C_LOC(path(1:1)), ier)

  path = C_NULL_CHAR
  CALL cg_configure_f(CG_CONFIG_SET_PATH, C_LOC(path(1:1)), ier)
  IF (ier .EQ. ERROR) CALL cg_error_exit_f

  value_f = 100 ! Trigger an error
  CALL cg_configure_f(CG_CONFIG_FILE_TYPE, C_LOC(value_f), ier)
  IF (ier .NE. ERROR) CALL cg_error_exit_f

! testing using callbacks with CG_CONFIGURE
  f_funptr = C_FUNLOC(print_error)

  CALL cg_configure_f(CG_CONFIG_ERROR, f_funptr, ier)
  IF (ier .EQ. ERROR) CALL cg_error_exit_f

  CALL cg_open_f('nonexists.cgns', CG_MODE_READ, cg, ier)
  IF (ier .NE. ERROR) CALL cg_error_exit_f

#endif

END PROGRAM write_cgns_1

!-------------------------------------------------------------------------
!This software is provided 'as-is', without any express or implied warranty.
!In no event will the authors be held liable for any damages arising from
!the use of this software.
!
!Permission is granted to anyone to use this software for any purpose,
!including commercial applications, and to alter it and redistribute it
!freely, subject to the following restrictions:
!
!1. The origin of this software must not be misrepresented; you must not
!   claim that you wrote the original software. If you use this software
!   in a product, an acknowledgment in the product documentation would be
!   appreciated but is not required.
!
!2. Altered source versions must be plainly marked as such, and must not
!   be misrepresented as being the original software.
!
!3. This notice may not be removed or altered from any source distribution.
!-------------------------------------------------------------------------
!   _____ _____ _   _  _____
!  / ____/ ____| \ | |/ ____|
! | |   | |  __|  \| | (___
! | |   | | |_ | . ` |\___ \
! | |___| |__| | |\  |____) |
!  \_____\_____|_| \_|_____/
!
!  PURPOSE:
!    Provides a module for the Fortran wrapper interfaces and CGNS
!    constant parameters.
!
!
!  KNOWN ISSUES:
!    Routines passing an argument to a C API argument of type
!    void * do not have explicit interfaces. They are the routines which
!    are commented out.
!
MODULE cgns

  USE ISO_C_BINDING
  IMPLICIT NONE

#include "cgnstypes_f03.h"

!These definitions are needed for Windows DLLs
!DEC$ IF DEFINED(WINNT)
!DEC$ ATTRIBUTES REFERENCE, C, VARYING :: cg_goto_f
!DEC$ ATTRIBUTES REFERENCE, C, VARYING :: cg_array_read_f
!DEC$ ATTRIBUTES REFERENCE, C, VARYING :: cg_array_read_as_f
!DEC$ ATTRIBUTES REFERENCE, C, VARYING :: cg_array_write_f
!DEC$ ENDIF


#if CG_BUILD_64BIT_F
#  if HAVE_FORTRAN_2003
  INTEGER, PARAMETER :: CGSIZE_T = C_LONG_LONG
  INTEGER, PARAMETER :: CGID_T   = C_DOUBLE
  INTEGER, PARAMETER :: CGLONG_T = C_LONG_LONG
#  else
  INTEGER, PARAMETER :: cgint_kind    = SELECTED_INT_KIND(15) ! should map to INTEGER*8 on most modern processors
  INTEGER, PARAMETER :: cgdouble_kind = SELECTED_REAL_KIND(10) ! should map to REAL*8 on most modern processors
  INTEGER, PARAMETER :: CGSIZE_T      = cgint_kind
  INTEGER, PARAMETER :: CGID_T        = cgdouble_kind
  INTEGER, PARAMETER :: CGLONG_T      = cgint_kind
#  endif
  LOGICAL, PARAMETER :: CG_BUILD_64BIT = .TRUE.
#else
#  if HAVE_FORTRAN_2003
  INTEGER, PARAMETER :: CGSIZE_T = C_INT
  INTEGER, PARAMETER :: CGID_T   = C_DOUBLE
  INTEGER, PARAMETER :: CGLONG_T = C_LONG_LONG
#  else
  INTEGER, PARAMETER :: cgint_kind    = SELECTED_INT_KIND(5) ! should map to INTEGER*4 on most modern processors
  INTEGER, PARAMETER :: cglong_kind   = SELECTED_INT_KIND(15) ! should map to INTEGER*8 on most modern processors
  INTEGER, PARAMETER :: cgdouble_kind = SELECTED_REAL_KIND(10) ! should map to REAL*8 on most modern processors
  INTEGER, PARAMETER :: CGSIZE_T      = cgint_kind
  INTEGER, PARAMETER :: CGID_T        = cgdouble_kind
  INTEGER, PARAMETER :: CGLONG_T      = cglong_kind
#  endif
  LOGICAL, PARAMETER :: CG_BUILD_64BIT = .FALSE.
#endif

  INTEGER, PARAMETER, PRIVATE :: MAX_LEN = 32

  INTERFACE cgio_set_dimensions_f
     MODULE PROCEDURE cgio_set_dimensions_f_0
     MODULE PROCEDURE cgio_set_dimensions_f_1
  END INTERFACE

  INTERFACE cgio_get_dimensions_f
     MODULE PROCEDURE cgio_get_dimensions_f_0
     MODULE PROCEDURE cgio_get_dimensions_f_1
  END INTERFACE

  ! Fortran version of cgnslib.h
  !
  !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
  !*      modes for cgns file                                            *
  !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

  INTEGER(C_INT), PARAMETER :: CG_MODE_READ   = 0
  INTEGER(C_INT), PARAMETER :: CG_MODE_WRITE  = 1
  INTEGER(C_INT), PARAMETER :: CG_MODE_MODIFY = 2
  INTEGER(C_INT), PARAMETER :: CG_MODE_CLOSED = 3

  ! file open modes (found in cgns_io.h)
  INTEGER(C_INT), PARAMETER :: CGIO_MODE_READ   = 0
  INTEGER(C_INT), PARAMETER :: CGIO_MODE_WRITE  = 1
  INTEGER(C_INT), PARAMETER :: CGIO_MODE_MODIFY = 2

  ! database file types (found in cgns_io.h)
  INTEGER(C_INT), PARAMETER :: CGIO_FILE_NONE = 0
  INTEGER(C_INT), PARAMETER :: CGIO_FILE_ADF  = 1
  INTEGER(C_INT), PARAMETER :: CGIO_FILE_HDF5 = 2
  INTEGER(C_INT), PARAMETER :: CGIO_FILE_ADF2 = 3



  !* legacy code support
  INTEGER(C_INT) MODE_READ, MODE_WRITE, MODE_MODIFY
  PARAMETER (MODE_READ   = 0)
  PARAMETER (MODE_WRITE  = 1)
  PARAMETER (MODE_MODIFY = 2)

  !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
  !*      file types (found in cgnslib.h)                                *
  !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

  INTEGER(C_INT), PARAMETER :: CG_FILE_NONE  = 0
  INTEGER(C_INT), PARAMETER :: CG_FILE_ADF   = 1
  INTEGER(C_INT), PARAMETER :: CG_FILE_HDF5  = 2
  INTEGER(C_INT), PARAMETER :: CG_FILE_ADF2  = 3
  INTEGER(C_INT), PARAMETER :: CG_FILE_PHDF5 = 4

  !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
  !*      some error code (found in cgnslib.h)                           *
  !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

  INTEGER(C_INT), PARAMETER :: CG_OK              = 0
  INTEGER(C_INT), PARAMETER :: CG_ERROR           = 1
  INTEGER(C_INT), PARAMETER :: CG_NODE_NOT_FOUND  = 2
  INTEGER(C_INT), PARAMETER :: CG_INCORRECT_PATH  = 3
  INTEGER(C_INT), PARAMETER :: CG_CG_NO_INDEX_DIM = 4

  !* legacy code support
  INTEGER(C_INT) ALL_OK, ERROR, NODE_NOT_FOUND, INCORRECT_PATH
  PARAMETER (ALL_OK         = 0)
  PARAMETER (ERROR          = 1)
  PARAMETER (NODE_NOT_FOUND = 2)
  PARAMETER (INCORRECT_PATH = 3)

  !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
  !*      Parallel CGNS parameters                                       *
  !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
  ENUM, BIND(C)
      ENUMERATOR :: CGP_INDEPENDENT = 0
      ENUMERATOR :: CGP_COLLECTIVE  = 1
  END ENUM

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Dimensional Units (found in cgnslib.h)                         *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

  INTEGER(C_INT), PARAMETER :: CG_Null = 0
  INTEGER(C_INT), PARAMETER :: CG_UserDefined = 1

!* legacy code support
  INTEGER(C_INT) Null, UserDefined
  PARAMETER (Null = 0)
  PARAMETER (UserDefined = 1)

  CHARACTER(LEN=MAX_LEN) :: MassUnitsName(0:5)
  ENUM, BIND(C)
      ENUMERATOR :: CGNS_ENUMV(MassUnitsNull)        = CG_Null
      ENUMERATOR :: CGNS_ENUMV(MassUnitsUserDefined) = CG_UserDefined
      ENUMERATOR :: CGNS_ENUMV(Kilogram)             = 2
      ENUMERATOR :: CGNS_ENUMV(Gram)                 = 3
      ENUMERATOR :: CGNS_ENUMV(Slug)                 = 4
      ENUMERATOR :: CGNS_ENUMV(PoundMass)            = 5
  END ENUM

  CHARACTER(LEN=MAX_LEN) :: LengthUnitsName(0:6)
  ENUM, BIND(C)
      ENUMERATOR :: CGNS_ENUMV(LengthUnitsNull)         = CG_Null
      ENUMERATOR :: CGNS_ENUMV(LengthUnitsUserDefined)  = CG_UserDefined
      ENUMERATOR :: CGNS_ENUMV(Meter)                   = 2
      ENUMERATOR :: CGNS_ENUMV(Centimeter)              = 3
      ENUMERATOR :: CGNS_ENUMV(Millimeter)              = 4
      ENUMERATOR :: CGNS_ENUMV(Foot)                    = 5
      ENUMERATOR :: CGNS_ENUMV(Inch)                    = 6
  END ENUM

  CHARACTER(LEN=MAX_LEN) :: TimeUnitsName(0:2)
  ENUM, BIND(C)
      ENUMERATOR :: CGNS_ENUMV(TimeUnitsNull)         = CG_Null
      ENUMERATOR :: CGNS_ENUMV(TimeUnitsUserDefined)  = CG_UserDefined
      ENUMERATOR :: CGNS_ENUMV(Second)                = 2
  END ENUM

  CHARACTER(LEN=MAX_LEN) :: TemperatureUnitsName(0:5)
  ENUM, BIND(C)
      ENUMERATOR :: CGNS_ENUMV(TemperatureUnitsNull)        = CG_Null
      ENUMERATOR :: CGNS_ENUMV(TemperatureUnitsUserDefined) = CG_UserDefined
      ENUMERATOR :: CGNS_ENUMV(Kelvin)                      = 2
      ENUMERATOR :: CGNS_ENUMV(Celsius)                     = 3
      ENUMERATOR :: CGNS_ENUMV(Rankine)                     = 4
      ENUMERATOR :: CGNS_ENUMV(Fahrenheit)                  = 5
  END ENUM

  CHARACTER(LEN=MAX_LEN) :: AngleUnitsName(0:3)
  ENUM, BIND(C)
      ENUMERATOR :: CGNS_ENUMV(AngleUnitsNull)              = CG_Null
      ENUMERATOR :: CGNS_ENUMV(AngleUnitsUserDefined)       = CG_UserDefined
      ENUMERATOR :: CGNS_ENUMV(Degree)                      = 2
      ENUMERATOR :: CGNS_ENUMV(Radian)                      = 3
  END ENUM

  CHARACTER(LEN=MAX_LEN) :: ElectricCurrentUnitsName(0:6)
  ENUM, BIND(C)
      ENUMERATOR :: CGNS_ENUMV(ElectricCurrentUnitsNull)        = CG_Null
      ENUMERATOR :: CGNS_ENUMV(ElectricCurrentUnitsUserDefined) = CG_UserDefined
      ENUMERATOR :: CGNS_ENUMV(Ampere)                          = 2
      ENUMERATOR :: CGNS_ENUMV(Abampere)                        = 3
      ENUMERATOR :: CGNS_ENUMV(Statampere)                      = 4
      ENUMERATOR :: CGNS_ENUMV(Edison)                          = 5
      ENUMERATOR :: CGNS_ENUMV(auCurrent)                       = 6
  END ENUM

  CHARACTER(LEN=MAX_LEN) :: SubstanceAmountUnitsName(0:5)
  ENUM, BIND(C)
      ENUMERATOR :: CGNS_ENUMV(SubstanceAmountUnitsNull)        = CG_Null
      ENUMERATOR :: CGNS_ENUMV(SubstanceAmountUnitsUserDefined) = CG_UserDefined
      ENUMERATOR :: CGNS_ENUMV(Mole)                            = 2
      ENUMERATOR :: CGNS_ENUMV(Entities)                        = 3
      ENUMERATOR :: CGNS_ENUMV(StandardCubicFoot)               = 4
      ENUMERATOR :: CGNS_ENUMV(StandardCubicMeter)              = 5
  END ENUM

  CHARACTER(LEN=MAX_LEN) :: LuminousIntensityUnitsName(0:6)
  ENUM, BIND(C)
      ENUMERATOR :: CGNS_ENUMV(LuminousIntensityUnitsNull)        = CG_Null
      ENUMERATOR :: CGNS_ENUMV(LuminousIntensityUnitsUserDefined) = CG_UserDefined
      ENUMERATOR :: CGNS_ENUMV(Candela)                            = 2
      ENUMERATOR :: CGNS_ENUMV(Candle)                             = 3
      ENUMERATOR :: CGNS_ENUMV(Carcel)                             = 4
      ENUMERATOR :: CGNS_ENUMV(Hefner)                             = 5
      ENUMERATOR :: CGNS_ENUMV(Violle)                             = 6
  END ENUM

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Data Class (found in cgnslib.h                                 *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

  CHARACTER(LEN=MAX_LEN) :: DataClassName(0:6)
  ENUM, BIND(C)
      ENUMERATOR :: CGNS_ENUMV(DataClassNull)                       = CG_Null
      ENUMERATOR :: CGNS_ENUMV(DataClassUserDefined)                = CG_UserDefined
      ENUMERATOR :: CGNS_ENUMV(Dimensional)                         = 2
      ENUMERATOR :: CGNS_ENUMV(NormalizedByDimensional)             = 3
      ENUMERATOR :: CGNS_ENUMV(NormalizedByUnknownDimensional)      = 4
      ENUMERATOR :: CGNS_ENUMV(NondimensionalParameter)             = 5
      ENUMERATOR :: CGNS_ENUMV(DimensionlessConstant)               = 6
  END ENUM

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Grid Location                                                  *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
  CHARACTER(LEN=MAX_LEN) :: GridLocationName(0:8)
  ENUM, BIND(C)
      ENUMERATOR :: CGNS_ENUMV(GridLocationNull)        = CG_Null
      ENUMERATOR :: CGNS_ENUMV(GridLocationUserDefined) = CG_UserDefined
      ENUMERATOR :: CGNS_ENUMV(Vertex)                  = 2
      ENUMERATOR :: CGNS_ENUMV(CellCenter)              = 3
      ENUMERATOR :: CGNS_ENUMV(FaceCenter)              = 4
      ENUMERATOR :: CGNS_ENUMV(IFaceCenter)             = 5
      ENUMERATOR :: CGNS_ENUMV(JFaceCenter)             = 6
      ENUMERATOR :: CGNS_ENUMV(KFaceCenter)             = 7
      ENUMERATOR :: CGNS_ENUMV(EdgeCenter)              = 8
  END ENUM

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Grid Connectivity Types                                        *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
  CHARACTER(LEN=MAX_LEN) :: GridConnectivityTypeName(0:4)
  ENUM, BIND(C)
      ENUMERATOR :: CGNS_ENUMV(GridConnectivityTypeNull)       = CG_Null
      ENUMERATOR :: CGNS_ENUMV(GridConnectivityTypeUserDefined) = CG_UserDefined
      ENUMERATOR :: CGNS_ENUMV(Overset)                         = 2
      ENUMERATOR :: CGNS_ENUMV(Abutting)                        = 3
      ENUMERATOR :: CGNS_ENUMV(Abutting1to1)                    = 4
  END ENUM

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Point Set Types                                                *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
  CHARACTER(LEN=MAX_LEN) :: PointSetTypeName(0:8)
  ENUM, BIND(C)
      ENUMERATOR :: CGNS_ENUMV(PointSetTypeNull)        = CG_Null
      ENUMERATOR :: CGNS_ENUMV(PointSetTypeUserDefined) = CG_UserDefined
      ENUMERATOR :: CGNS_ENUMV(PointList)               = 2
      ENUMERATOR :: CGNS_ENUMV(PointListDonor)          = 3
      ENUMERATOR :: CGNS_ENUMV(PointRange)              = 4
      ENUMERATOR :: CGNS_ENUMV(PointRangeDonor)         = 5
      ENUMERATOR :: CGNS_ENUMV(ElementRange)            = 6
      ENUMERATOR :: CGNS_ENUMV(ElementList)             = 7
      ENUMERATOR :: CGNS_ENUMV(CellListDonor)           = 8
  END ENUM

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Governing Equations and Physical Models Types                  *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
  CHARACTER(LEN=MAX_LEN) :: GoverningEquationsTypeName(0:7)
  ENUM, BIND(C)
      ENUMERATOR :: CGNS_ENUMV(GoverningEquationsNull)        = CG_Null
      ENUMERATOR :: CGNS_ENUMV(GoverningEquationsUserDefined) = CG_UserDefined
      ENUMERATOR :: CGNS_ENUMV(FullPotential)                 = 2
      ENUMERATOR :: CGNS_ENUMV(Euler)                         = 3
      ENUMERATOR :: CGNS_ENUMV(NSLaminar)                     = 4
      ENUMERATOR :: CGNS_ENUMV(NSTurbulent)                   = 5
      ENUMERATOR :: CGNS_ENUMV(NSLaminarIncompressible)       = 6
      ENUMERATOR :: CGNS_ENUMV(NSTurbulentIncompressible)     = 7
  END ENUM

!** Any model type will accept both ModelTypeNull and ModelTypeUserDefined.
!** The following models will accept these values as vaild...
!**
!** GasModel_t: Ideal, VanderWaals, CaloricallyPerfect, ThermallyPerfect,
!**    ConstantDensity, RedlichKwong
!**
!** ViscosityModel_t: Constant, PowerLaw, SutherlandLaw
!**
!** ThermalConductivityModel_t: PowerLaw, SutherlandLaw, ConstantPrandtl
!**
!** TurbulenceModel_t: Algebraic_BaldwinLomax, Algebraic_CebeciSmith,
!**    HalfEquation_JohnsonKing, OneEquation_BaldwinBarth,
!**    OneEquation_SpalartAllmaras, TwoEquation_JonesLaunder,
!**    TwoEquation_MenterSST,TwoEquation_Wilcox
!**
!** TurbulenceClosure_t: EddyViscosity, ReynoldsStress,
!**    ReynoldsStressAlgebraic
!**
!** ThermalRelaxationModel_t: Frozen, ThermalEquilib, ThermalNonequilib
!**
!** ChemicalKineticsModel_t: Frozen, ChemicalEquilibCurveFit,
!**    ChemicalEquilibMinimization, ChemicalNonequilib
!**
!** EMElectricFieldModel_t: Voltage, Interpolated, Constant, Frozen
!**
!** EMMagneticFieldModel_t: Interpolated, Constant, Frozen
!**
!** EMConductivityModel_t: Constant, Frozen, Equilibrium_LinRessler,
!**                             Chemistry_LinRessler

  CHARACTER(LEN=MAX_LEN) :: ModelTypeName(0:35)
  ENUM, BIND(C)
      ENUMERATOR :: CGNS_ENUMV(ModelTypeNull)               = CG_Null
      ENUMERATOR :: CGNS_ENUMV(ModelTypeUserDefined)        = CG_UserDefined
      ENUMERATOR :: CGNS_ENUMV(Ideal)                       = 2
      ENUMERATOR :: CGNS_ENUMV(VanderWaals)                 = 3
      ENUMERATOR :: CGNS_ENUMV(Constant)                    = 4
      ENUMERATOR :: CGNS_ENUMV(PowerLaw)                    = 5
      ENUMERATOR :: CGNS_ENUMV(SutherlandLaw)               = 6
      ENUMERATOR :: CGNS_ENUMV(ConstantPrandtl)             = 7
      ENUMERATOR :: CGNS_ENUMV(EddyViscosity)               = 8
      ENUMERATOR :: CGNS_ENUMV(ReynoldsStress)              = 9
      ENUMERATOR :: CGNS_ENUMV(ReynoldsStressAlgebraic)     = 10
      ENUMERATOR :: CGNS_ENUMV(Algebraic_BaldwinLomax)      = 11
      ENUMERATOR :: CGNS_ENUMV(Algebraic_CebeciSmith)       = 12
      ENUMERATOR :: CGNS_ENUMV(HalfEquation_JohnsonKing)    = 13
      ENUMERATOR :: CGNS_ENUMV(OneEquation_BaldwinBarth)    = 14
      ENUMERATOR :: CGNS_ENUMV(OneEquation_SpalartAllmaras) = 15
      ENUMERATOR :: CGNS_ENUMV(TwoEquation_JonesLaunder)    = 16
      ENUMERATOR :: CGNS_ENUMV(TwoEquation_MenterSST)       = 17
      ENUMERATOR :: CGNS_ENUMV(TwoEquation_Wilcox)          = 18
      ENUMERATOR :: CGNS_ENUMV(CaloricallyPerfect)          = 19
      ENUMERATOR :: CGNS_ENUMV(ThermallyPerfect)            = 20
      ENUMERATOR :: CGNS_ENUMV(ConstantDensity)             = 21
      ENUMERATOR :: CGNS_ENUMV(RedlichKwong)                = 22
      ENUMERATOR :: CGNS_ENUMV(Frozen)                      = 23
      ENUMERATOR :: CGNS_ENUMV(ThermalEquilib)              = 24
      ENUMERATOR :: CGNS_ENUMV(ThermalNonequilib)           = 25
      ENUMERATOR :: CGNS_ENUMV(ChemicalEquilibCurveFit)     = 26
      ENUMERATOR :: CGNS_ENUMV(ChemicalEquilibMinimization) = 27
      ENUMERATOR :: CGNS_ENUMV(ChemicalNonequilib)          = 28
      ENUMERATOR :: CGNS_ENUMV(EMElectricField)             = 29
      ENUMERATOR :: CGNS_ENUMV(EMMagneticField)             = 30
      ENUMERATOR :: CGNS_ENUMV(EMConductivity)              = 31
      ENUMERATOR :: CGNS_ENUMV(Voltage)                     = 32
      ENUMERATOR :: CGNS_ENUMV(Interpolated)                = 33
      ENUMERATOR :: CGNS_ENUMV(Equilibrium_LinRessler)      = 34
      ENUMERATOR :: CGNS_ENUMV(Chemistry_LinRessler)        = 35
  END ENUM

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Boundary Condition Types                                       *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
  CHARACTER(LEN=MAX_LEN) :: BCTypeName(0:25)
  ENUM, BIND(C)
      ENUMERATOR :: CGNS_ENUMV(BCTypeNull)              = CG_Null
      ENUMERATOR :: CGNS_ENUMV(BCTypeUserDefined)       = CG_UserDefined
      ENUMERATOR :: CGNS_ENUMV(BCAxisymmetricWedge)     = 2
      ENUMERATOR :: CGNS_ENUMV(BCDegenerateLine)        = 3
      ENUMERATOR :: CGNS_ENUMV(BCDegeneratePoint)       = 4
      ENUMERATOR :: CGNS_ENUMV(BCDirichlet)             = 5
      ENUMERATOR :: CGNS_ENUMV(BCExtrapolate)           = 6
      ENUMERATOR :: CGNS_ENUMV(BCFarfield)              = 7
      ENUMERATOR :: CGNS_ENUMV(BCGeneral)               = 8
      ENUMERATOR :: CGNS_ENUMV(BCInflow)                = 9
      ENUMERATOR :: CGNS_ENUMV(BCInflowSubsonic)        = 10
      ENUMERATOR :: CGNS_ENUMV(BCInflowSupersonic)      = 11
      ENUMERATOR :: CGNS_ENUMV(BCNeumann)               = 12
      ENUMERATOR :: CGNS_ENUMV(BCOutflow)               = 13
      ENUMERATOR :: CGNS_ENUMV(BCOutflowSubsonic)       = 14
      ENUMERATOR :: CGNS_ENUMV(BCOutflowSupersonic)     = 15
      ENUMERATOR :: CGNS_ENUMV(BCSymmetryPlane)         = 16
      ENUMERATOR :: CGNS_ENUMV(BCSymmetryPolar)         = 17
      ENUMERATOR :: CGNS_ENUMV(BCTunnelInflow)          = 18
      ENUMERATOR :: CGNS_ENUMV(BCTunnelOutflow)         = 19
      ENUMERATOR :: CGNS_ENUMV(BCWall)                  = 20
      ENUMERATOR :: CGNS_ENUMV(BCWallInviscid)          = 21
      ENUMERATOR :: CGNS_ENUMV(BCWallViscous)           = 22
      ENUMERATOR :: CGNS_ENUMV(BCWallViscousHeatFlux)   = 23
      ENUMERATOR :: CGNS_ENUMV(BCWallViscousIsothermal) = 24
      ENUMERATOR :: CGNS_ENUMV(FamilySpecified)         = 25
  END ENUM

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Data types                                                     *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
  CHARACTER(LEN=MAX_LEN) :: DataTypeName(0:6)
  ENUM, BIND(C)
      ENUMERATOR :: CGNS_ENUMV(DataTypeNull)
      ENUMERATOR :: CGNS_ENUMV(DataTypeUserDefined)
      ENUMERATOR :: CGNS_ENUMV(Integer)
      ENUMERATOR :: CGNS_ENUMV(RealSingle)
      ENUMERATOR :: CGNS_ENUMV(RealDouble)
      ENUMERATOR :: CGNS_ENUMV(Character)
      ENUMERATOR :: CGNS_ENUMV(LongInteger)
  END ENUM

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      BCData_t types                                                 *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
  CHARACTER(LEN=MAX_LEN) :: BCDataTypeName(0:3)
  ENUM, BIND(C)
      ENUMERATOR :: CGNS_ENUMV(BCDataTypeNull)        = CG_Null
      ENUMERATOR :: CGNS_ENUMV(BCDataTypeUserDefined) = CG_UserDefined
      ENUMERATOR :: CGNS_ENUMV(Dirichlet)             = 2
      ENUMERATOR :: CGNS_ENUMV(Neumann)               = 3
  END ENUM

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Element types                                                  *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

  CHARACTER(LEN=MAX_LEN) :: ElementTypeName(0:56)
  ENUM, BIND(C)
      ENUMERATOR :: CGNS_ENUMV(ElementTypeNull) = CG_Null
      ENUMERATOR :: CGNS_ENUMV(ElementTypeUserDefined)
      ENUMERATOR :: CGNS_ENUMV(NODE)
      ENUMERATOR :: CGNS_ENUMV(BAR_2)
      ENUMERATOR :: CGNS_ENUMV(BAR_3)
      ENUMERATOR :: CGNS_ENUMV(TRI_3)
      ENUMERATOR :: CGNS_ENUMV(TRI_6)
      ENUMERATOR :: CGNS_ENUMV(QUAD_4)
      ENUMERATOR :: CGNS_ENUMV(QUAD_8)
      ENUMERATOR :: CGNS_ENUMV(QUAD_9)
      ENUMERATOR :: CGNS_ENUMV(TETRA_4)
      ENUMERATOR :: CGNS_ENUMV(TETRA_10)
      ENUMERATOR :: CGNS_ENUMV(PYRA_5)
      ENUMERATOR :: CGNS_ENUMV(PYRA_14)
      ENUMERATOR :: CGNS_ENUMV(PENTA_6)
      ENUMERATOR :: CGNS_ENUMV(PENTA_15)
      ENUMERATOR :: CGNS_ENUMV(PENTA_18)
      ENUMERATOR :: CGNS_ENUMV(HEXA_8)
      ENUMERATOR :: CGNS_ENUMV(HEXA_20)
      ENUMERATOR :: CGNS_ENUMV(HEXA_27)
      ENUMERATOR :: CGNS_ENUMV(MIXED)
      ENUMERATOR :: CGNS_ENUMV(PYRA_13)
      ENUMERATOR :: CGNS_ENUMV(NGON_n)
      ENUMERATOR :: CGNS_ENUMV(NFACE_n)
      ENUMERATOR :: CGNS_ENUMV(BAR_4)
      ENUMERATOR :: CGNS_ENUMV(TRI_9)
      ENUMERATOR :: CGNS_ENUMV(TRI_10)
      ENUMERATOR :: CGNS_ENUMV(QUAD_12)
      ENUMERATOR :: CGNS_ENUMV(QUAD_16)
      ENUMERATOR :: CGNS_ENUMV(TETRA_16)
      ENUMERATOR :: CGNS_ENUMV(TETRA_20)
      ENUMERATOR :: CGNS_ENUMV(PYRA_21)
      ENUMERATOR :: CGNS_ENUMV(PYRA_29)
      ENUMERATOR :: CGNS_ENUMV(PYRA_30)
      ENUMERATOR :: CGNS_ENUMV(PENTA_24)
      ENUMERATOR :: CGNS_ENUMV(PENTA_38)
      ENUMERATOR :: CGNS_ENUMV(PENTA_40)
      ENUMERATOR :: CGNS_ENUMV(HEXA_32)
      ENUMERATOR :: CGNS_ENUMV(HEXA_56)
      ENUMERATOR :: CGNS_ENUMV(HEXA_64)
      ENUMERATOR :: CGNS_ENUMV(BAR_5)
      ENUMERATOR :: CGNS_ENUMV(TRI_12)
      ENUMERATOR :: CGNS_ENUMV(TRI_15)
      ENUMERATOR :: CGNS_ENUMV(QUAD_P4_16)
      ENUMERATOR :: CGNS_ENUMV(QUAD_25)
      ENUMERATOR :: CGNS_ENUMV(TETRA_22)
      ENUMERATOR :: CGNS_ENUMV(TETRA_34)
      ENUMERATOR :: CGNS_ENUMV(TETRA_35)
      ENUMERATOR :: CGNS_ENUMV(PYRA_P4_29)
      ENUMERATOR :: CGNS_ENUMV(PYRA_50)
      ENUMERATOR :: CGNS_ENUMV(PYRA_55)
      ENUMERATOR :: CGNS_ENUMV(PENTA_33)
      ENUMERATOR :: CGNS_ENUMV(PENTA_66)
      ENUMERATOR :: CGNS_ENUMV(PENTA_75)
      ENUMERATOR :: CGNS_ENUMV(HEXA_44)
      ENUMERATOR :: CGNS_ENUMV(HEXA_98)
      ENUMERATOR :: CGNS_ENUMV(HEXA_125)
  END ENUM

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Zone types                                                     *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

  CHARACTER(LEN=MAX_LEN) :: ZoneTypeName(0:3)
  ENUM, BIND(C)
      ENUMERATOR :: CGNS_ENUMV(ZoneTypeNull) = CG_Null
      ENUMERATOR :: CGNS_ENUMV(ZoneTypeUserDefined)
      ENUMERATOR :: CGNS_ENUMV(Structured)
      ENUMERATOR :: CGNS_ENUMV(Unstructured)
  END ENUM

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Rigid Grid Motion types                                        *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
  CHARACTER(LEN=MAX_LEN) :: RigidGridMotionTypeName(0:3)
  ENUM, BIND(C)
      ENUMERATOR :: CGNS_ENUMV(RigidGridMotionTypeNull) = CG_Null
      ENUMERATOR :: CGNS_ENUMV(RigidGridMotionTypeUserDefined)
      ENUMERATOR :: CGNS_ENUMV(ConstantRate)
      ENUMERATOR :: CGNS_ENUMV(VariableRate)
  END ENUM

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Arbitrary Grid Motion types                                    *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
  CHARACTER(LEN=MAX_LEN) :: ArbitraryGridMotionTypeName(0:3)
  ENUM, BIND(C)
      ENUMERATOR :: CGNS_ENUMV(ArbitraryGridMotionTypeNull) = CG_Null
      ENUMERATOR :: CGNS_ENUMV(ArbitraryGridMotionTypeUserDefined)
      ENUMERATOR :: CGNS_ENUMV(NonDeformingGrid)
      ENUMERATOR :: CGNS_ENUMV(DeformingGrid)
  END ENUM

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Simulation type                                                *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
  CHARACTER(LEN=MAX_LEN) :: SimulationTypeName(0:3)
  ENUM, BIND(C)
      ENUMERATOR :: CGNS_ENUMV(SimulationTypeNull) = CG_Null
      ENUMERATOR :: CGNS_ENUMV(SimulationTypeUserDefined)
      ENUMERATOR :: CGNS_ENUMV(TimeAccurate)
      ENUMERATOR :: CGNS_ENUMV(NonTimeAccurate)
  END ENUM

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      BC Property types                                              *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

  CHARACTER(LEN=MAX_LEN) :: WallFunctionTypeName(0:2)
  ENUM, BIND(C)
      ENUMERATOR :: CGNS_ENUMV(WallFunctionTypeNull) = CG_Null
      ENUMERATOR :: CGNS_ENUMV(WallFunctionTypeUserDefined)
      ENUMERATOR :: CGNS_ENUMV(Generic)
  END ENUM

  CHARACTER(LEN=MAX_LEN) :: AreaTypeName(0:3)
  ENUM, BIND(C)
      ENUMERATOR :: CGNS_ENUMV(AreaTypeNull) = CG_Null
      ENUMERATOR :: CGNS_ENUMV(AreaTypeUserDefined)
      ENUMERATOR :: CGNS_ENUMV(BleedArea)
      ENUMERATOR :: CGNS_ENUMV(CaptureArea)
  END ENUM

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Grid Connectivity Property types                               *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

  CHARACTER(LEN=MAX_LEN) :: AverageInterfaceTypeName(0:7)
  ENUM, BIND(C)
      ENUMERATOR :: CGNS_ENUMV(AverageInterfaceTypeNull) = CG_Null
      ENUMERATOR :: CGNS_ENUMV(AverageInterfaceTypeUserDefined)
      ENUMERATOR :: CGNS_ENUMV(AverageAll)
      ENUMERATOR :: CGNS_ENUMV(AverageCircumferential)
      ENUMERATOR :: CGNS_ENUMV(AverageRadial)
      ENUMERATOR :: CGNS_ENUMV(AverageI)
      ENUMERATOR :: CGNS_ENUMV(AverageJ)
      ENUMERATOR :: CGNS_ENUMV(AverageK)
  END ENUM

! For portability to Linux Absoft, all data statements were moved after the
! variables and parametres declarations

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Dimensional Units                                              *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
  DATA MassUnitsName /'Null','UserDefined','Kilogram','Gram', &
       'Slug','PoundMass'/
  DATA LengthUnitsName / 'Null', 'UserDefined', &
       'Meter','Centimeter','Millimeter','Foot','Inch'/

  DATA TimeUnitsName /'Null','UserDefined','Second'/

  DATA TemperatureUnitsName /'Null','UserDefined', &
       'Kelvin','Celsius','Rankine','Fahrenheit'/

  DATA AngleUnitsName /'Null','UserDefined','Degree','Radian'/

  DATA ElectricCurrentUnitsName /'Null', 'UserDefined', 'Ampere', &
       'Abampere', 'Statampere', 'Edison', 'a.u.'/

  DATA SubstanceAmountUnitsName /'Null', 'UserDefined', 'Mole', &
       'Entities', 'StandardCubicFoot', 'StandardCubicMeter'/

  DATA LuminousIntensityUnitsName /'Null', 'UserDefined', &
       'Candela', 'Candle', 'Carcel', 'Hefner', 'Violle'/

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Data Class                                                     *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
  DATA DataClassName / 'Null','UserDefined', &
       'Dimensional','NormalizedByDimensional', &
       'NormalizedByUnknownDimensional', &
       'NondimensionalParameter','DimensionlessConstant'/

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Grid Location                                                  *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

  DATA GridLocationName / 'Null','UserDefined', &
       'Vertex','CellCenter','FaceCenter','IFaceCenter', &
       'JFaceCenter','KFaceCenter','EdgeCenter' /

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Grid Connectivity Types                                        *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

  DATA GridConnectivityTypeName / 'Null','UserDefined', &
       'Overset','Abutting','Abutting1to1'/

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Point Set Types                                                *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

  DATA PointSetTypeName / 'Null','UserDefined', &
       'PointList','PointListDonor',  &
       'PointRange','PointRangeDonor', &
       'ElementRange','ElementList','CellListDonor'/

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Governing Equations and Physical Models Types                  *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

  DATA GoverningEquationsTypeName / 'Null','UserDefined', &
       'FullPotential','Euler', 'NSLaminar', 'NSTurbulent', &
       'NSLaminarIncompressible', 'NSTurbulentIncompressible'/

  DATA ModelTypeName / 'Null','UserDefined', &
       'Ideal','VanderWaals', 'Constant','PowerLaw', &
       'SutherlandLaw','ConstantPrandtl','EddyViscosity', &
       'ReynoldsStress','ReynoldsStressAlgebraic', &
       'Algebraic_BaldwinLomax','Algebraic_CebeciSmith', &
       'HalfEquation_JohnsonKing','OneEquation_BaldwinBarth', &
       'OneEquation_SpalartAllmaras','TwoEquation_JonesLaunder', &
       'TwoEquation_MenterSST','TwoEquation_Wilcox', &
       'CaloricallyPerfect', 'ThermallyPerfect', &
       'ConstantDensity', 'RedlichKwong', 'Frozen', &
       'ThermalEquilib', 'ThermalNonequilib', &
       'ChemicalEquilibCurveFit', 'ChemicalEquilibMinimization', &
       'ChemicalNonequilib', 'EMElectricField', &
       'EMMagneticField', 'EMConductivity', 'Voltage', &
       'Interpolated', 'Equilibrium_LinRessler', &
       'Chemistry_LinRessler'/

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Boundary Condition Types                                       *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

  DATA BCTypeName / 'Null','UserDefined', &
       'BCAxisymmetricWedge','BCDegenerateLine', &
       'BCDegeneratePoint','BCDirichlet','BCExtrapolate', &
       'BCFarfield','BCGeneral','BCInflow','BCInflowSubsonic', &
       'BCInflowSupersonic','BCNeumann','BCOutflow', &
       'BCOutflowSubsonic','BCOutflowSupersonic', &
       'BCSymmetryPlane','BCSymmetryPolar','BCTunnelInflow', &
       'BCTunnelOutflow','BCWall','BCWallInviscid', &
       'BCWallViscous','BCWallViscousHeatFlux', &
       'BCWallViscousIsothermal','FamilySpecified' /

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Data types                                                     *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

  DATA DataTypeName / 'Null','UserDefined', &
       'Integer','RealSingle','RealDouble','Character', &
       'LongInteger' /

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      BCData_t types                                                 *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

  DATA BCDataTypeName / 'Null','UserDefined', &
       'Dirichlet', 'Neumann' /

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Element types                                                  *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

  DATA ElementTypeName / 'Null','UserDefined', &
       'NODE', 'BAR_2', 'BAR_3', 'TRI_3', 'TRI_6', &
       'QUAD_4', 'QUAD_8', 'QUAD_9', 'TETRA_4', 'TETRA_10', &
       'PYRA_5', 'PYRA_14', 'PENTA_6', 'PENTA_15', &
       'PENTA_18', 'HEXA_8', 'HEXA_20', 'HEXA_27', 'MIXED', &
       'PYRA_13', 'NGON_n', 'NFACE_n', &
       'BAR_4', 'TRI_9', 'TRI_10', &
       'QUAD_12', 'QUAD_16', &
       'TETRA_16', 'TETRA_20', &
       'PYRA_21', 'PYRA_29', 'PYRA_30', &
       'PENTA_24', 'PENTA_38', 'PENTA_40', &
       'HEXA_32', 'HEXA_56', 'HEXA_64', &
       'BAR_5', 'TRI_12', 'TRI_15', &
       'QUAD_P4_16', 'QUAD_25', &
       'TETRA_22', 'TETRA_34', 'TETRA_35', &
       'PYRA_P4_29', 'PYRA_50', 'PYRA_55', &
       'PENTA_33', 'PENTA_66', 'PENTA_75', &
       'HEXA_44', 'HEXA_98', 'HEXA_125' /

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Zone types                                                     *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

  DATA ZoneTypeName / 'Null','UserDefined', &
       'Structured', 'Unstructured' /

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Rigid Grid Motion types                                        *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

  DATA RigidGridMotionTypeName / 'Null','UserDefined', &
       'ConstantRate', 'VariableRate' /

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Arbitrary Grid Motion types                                    *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

  DATA ArbitraryGridMotionTypeName / 'Null','UserDefined', &
       'NonDeformingGrid', 'DeformingGrid' /

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Simulation type                                                *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

  DATA SimulationTypeName / 'Null','UserDefined', &
       'TimeAccurate', 'NonTimeAccurate' /

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      BC Property types                                              *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

  DATA WallFunctionTypeName / 'Null','UserDefined',&
       'Generic' /

  DATA AreaTypeName / 'Null','UserDefined', &
       'BleedArea', 'CaptureArea' /

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      Grid Connectivity Property types                               *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

  DATA AverageInterfaceTypeName / 'Null','UserDefined', &
       'AverageAll', 'AverageCircumferential', 'AverageRadial', &
       'AverageI', 'AverageJ', 'AverageK' /

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      ENUMTYPE FOR FORTRAN FUNCTIONS                                 *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

  INTEGER, PARAMETER :: cgenum_t = KIND(CGP_INDEPENDENT)

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      INTERFACES FOR THE FORTRAN FUNCTIONS                           *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

  INTERFACE
     INTEGER(C_INT) FUNCTION cg_is_cgns(filename, file_type) BIND(C,NAME="cg_is_cgns")
       USE ISO_C_BINDING
       IMPLICIT NONE
       CHARACTER(KIND=C_CHAR), DIMENSION(*), INTENT(IN) :: filename
       INTEGER, INTENT(OUT) :: file_type
     END FUNCTION cg_is_cgns
  END INTERFACE

  INTERFACE
     INTEGER(C_INT) FUNCTION cg_open(filename, mode, fn) BIND(C,NAME="cg_open")
       USE ISO_C_BINDING
       IMPLICIT NONE
       CHARACTER(KIND=C_CHAR), DIMENSION(*), INTENT(IN) :: filename
       INTEGER(C_INT), INTENT(IN), VALUE  :: mode
       INTEGER, INTENT(OUT) :: fn
     END FUNCTION cg_open
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_version_f(fn,FileVersion, ier) BIND(C,NAME="cg_version_f")
       USE ISO_C_BINDING
       IMPLICIT NONE
       INTEGER :: fn
       REAL(C_FLOAT)    :: FileVersion
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_version_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_precision_f(fn, PRECISION, ier) BIND(C,NAME="cg_precision_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: PRECISION
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_precision_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_close_f(fn, ier) BIND(C,NAME="cg_close_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_close_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_save_as_f(fn, filename, file_type, follow_links, ier) ! BIND(C,NAME="cg_save_as_f")
       USE ISO_C_BINDING
       IMPLICIT NONE
       INTEGER :: fn
       CHARACTER(KIND=C_CHAR), DIMENSION(*), INTENT(IN) :: filename
       INTEGER :: file_type
       INTEGER :: follow_links
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_save_as_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_set_file_type_f(ft, ier) BIND(C,NAME="cg_set_file_type_f")
       IMPLICIT NONE
       INTEGER :: ft
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_set_file_type_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_get_file_type_f(fn, ft, ier) BIND(C,NAME="cg_get_file_type_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: ft
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_get_file_type_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_set_compress_f(cmpr, ier) BIND(C, NAME="cg_set_compress_f")
       IMPLICIT NONE
       INTEGER :: cmpr
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_set_compress_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_get_compress_f(cmpr, ier) BIND(C, NAME="cg_get_compress_f")
       INTEGER :: cmpr
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_get_compress_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_set_path_f(pathname, ier) !BIND(C, NAME="cg_set_path_f")
       USE ISO_C_BINDING
       IMPLICIT NONE
       CHARACTER(KIND=C_CHAR), DIMENSION(*), INTENT(IN) :: pathname
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_set_path_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_add_path_f(pathname, ier) !BIND(C, NAME="cg_add_path_f")
       USE ISO_C_BINDING
       IMPLICIT NONE
       CHARACTER(KIND=C_CHAR), DIMENSION(*), INTENT(IN) :: pathname
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_add_path_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_get_cgio_f(fn, cgio_num, ier) BIND(C, NAME="cg_get_cgio_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: cgio_num
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_get_cgio_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_root_id_f(fn, rootid, ier) BIND(C, NAME="cg_root_id_f")
       USE ISO_C_BINDING
       IMPLICIT NONE
       INTEGER :: fn
       REAL(C_DOUBLE) :: rootid
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_root_id_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  !      Read and write CGNSBase_t Nodes
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  INTERFACE
     SUBROUTINE cg_nbases_f(fn, nbases, ier) BIND(C, NAME="cg_nbases_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: nbases
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_nbases_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_base_read_f(fn, B, basename, cell_dim, phys_dim, ier) !BIND(C, NAME="cg_base_read_f")
       USE ISO_C_BINDING
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       CHARACTER(KIND=C_CHAR), DIMENSION(*), INTENT(IN) :: basename
       INTEGER :: cell_dim
       INTEGER :: phys_dim
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_base_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_base_id_f(fn, B, base_id, ier) BIND(C, NAME="cg_base_id_f")
       USE ISO_C_BINDING
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       REAL(C_DOUBLE) :: base_id
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_base_id_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_base_write_f(fn, basename, cell_dim, phys_dim, B, ier) !BIND(C, NAME="cg_base_write_f")
       USE ISO_C_BINDING
       IMPLICIT NONE
       INTEGER :: fn
       CHARACTER(KIND=C_CHAR), DIMENSION(*), INTENT(IN) :: basename
       INTEGER :: cell_dim
       INTEGER :: phys_dim
       INTEGER :: B
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_base_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_cell_dim_f(fn, B, dim, ier) BIND(C, NAME="cg_cell_dim_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: dim
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_cell_dim_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  !       Read and write Zone_t Nodes
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

  INTERFACE
     SUBROUTINE cg_nzones_f(fn, B, nzones, ier) BIND(C, NAME="cg_nzones_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: nzones
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_nzones_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_zone_type_f(fn, B, Z, type, ier) BIND(C, NAME="cg_zone_type_f")
       IMPORT :: cgenum_t, c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER(cgenum_t) :: type
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_zone_type_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_zone_read_f(fn, B, Z, zonename, size, ier) !BIND(C, NAME="cg_zone_read_f")
       IMPORT :: CGSIZE_T, c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: zonename
       INTEGER(CGSIZE_T), DIMENSION(*) :: size
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_zone_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_zone_id_f(fn, B, Z, zone_id, ier) BIND(C, NAME="cg_zone_id_f")
       IMPORT :: c_double
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       REAL(C_DOUBLE) :: zone_id
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_zone_id_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_zone_write_f(fn, B, zonename, size, TYPE, Z, ier) !BIND(C, NAME="cg_zone_write_f")
       IMPORT :: cgenum_t, c_char, cgsize_t
       IMPLICIT NONE
       INTEGER, INTENT(IN) :: fn
       INTEGER, INTENT(IN) :: B
       CHARACTER(KIND=C_CHAR), DIMENSION(*), INTENT(IN) :: zonename
       INTEGER(CGSIZE_T), DIMENSION(*), INTENT(IN) :: size
       INTEGER(cgenum_t), INTENT(IN) :: TYPE
       INTEGER, INTENT(OUT) :: Z
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_zone_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_index_dim_f(fn, B, Z, dim, ier) BIND(C, NAME="cg_index_dim_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: dim
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_index_dim_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write Family_t Nodes                                    *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_nfamilies_f(fn, B, nfamilies, ier) BIND(C, NAME="cg_nfamilies_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: nfamilies
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_nfamilies_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_family_read_f(fn, B, F, family_name, nboco, ngeos, ier) !BIND(C, NAME="cg_family_read_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: F
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: family_name
       INTEGER :: nboco
       INTEGER :: ngeos
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_family_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_family_write_f(fn, B, family_name, F, ier) !BIND(C, NAME="cg_family_write_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: family_name
       INTEGER :: F
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_family_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_nfamily_names_f(fn, B, F, nnames, ier) BIND(C, NAME="cg_nfamily_names_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: F
       INTEGER :: nnames
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_nfamily_names_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_family_name_read_f(fn, B, F, N, name, family, ier) !BIND(C, NAME="cg_family_name_read_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: F
       INTEGER :: N
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: name
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: family
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_family_name_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_family_name_write_f(fn, B, F, name, family, ier) !BIND(C, NAME="cg_family_name_write_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: F
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: name
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: family
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_family_name_write_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write FamBC_t Nodes                                     *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_fambc_read_f(fn, B, F, BC, fambc_name, bocotype, ier) !BIND(C, NAME="cg_fambc_read_f")
       IMPORT :: c_char, cgenum_t
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: F
       INTEGER :: BC
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: fambc_name
       INTEGER(cgenum_t) :: bocotype
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_fambc_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_fambc_write_f(fn, B, F, fambc_name, bocotype, BC, ier) !BIND(C, NAME="cg_fambc_write_f")
       IMPORT :: c_char, cgenum_t
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: F
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: fambc_name
       INTEGER(cgenum_t) :: bocotype
       INTEGER :: BC
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_fambc_write_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write GeometryReference_t Nodes                         *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_geo_read_f(fn, B, F, G, geo_name, geo_file, CAD_name, npart, ier) !BIND(C, NAME="cg_geo_read_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: F
       INTEGER :: G
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: geo_name
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: geo_file
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: CAD_name
       INTEGER :: npart
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_geo_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_geo_write_f(fn, B, F, geo_name, geo_file, CAD_name, G, ier) !BIND(C, NAME="cg_geo_write_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: F
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: geo_name
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: geo_file
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: CAD_name
       INTEGER :: G
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_geo_write_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write GeometryEntity_t Nodes                            *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_part_read_f(fn, B, F,G, P, part_name, ier) !BIND(C, NAME="cg_part_read_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: F
       INTEGER :: G
       INTEGER :: P
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: part_name
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_part_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_part_write_f(fn, B, F, G, part_name, P, ier) !BIND(C, NAME="cg_part_write_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: F
       INTEGER :: G
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: part_name
       INTEGER :: P
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_part_write_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write DiscreteData_t Nodes                              *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_ndiscrete_f(fn, B, Z, ndiscrete, ier) BIND(C, NAME="cg_ndiscrete_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: ndiscrete
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_ndiscrete_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_discrete_read_f(fn, B, Z, D, discrete_name, ier) !BIND(C, NAME="cg_discrete_read_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: D
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: discrete_name
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_discrete_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_discrete_write_f(fn, B, Z, discrete_name, D, ier) !BIND(C, NAME="cg_discrete_write_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: discrete_name
       INTEGER :: D
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_discrete_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_discrete_size_f(fn, B, Z, D, ndim, dims, ier) BIND(C, NAME="cg_discrete_size_f")
       IMPORT :: CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: D
       INTEGER :: ndim
       INTEGER(CGSIZE_T), DIMENSION(*) :: dims
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_discrete_size_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_discrete_ptset_info_f(fn, B, Z, S, ptype, npnts, ier) BIND(C, NAME="cg_discrete_ptset_info_f")
       IMPORT :: cgenum_t, CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: S
       INTEGER(cgenum_t) :: ptype
       INTEGER(CGSIZE_T) :: npnts
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_discrete_ptset_info_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_discrete_ptset_read_f( fn, B, Z, S, pnts, ier) BIND(C, NAME="cg_discrete_ptset_read_f")
       IMPORT :: CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: S
       INTEGER(CGSIZE_T) :: pnts
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_discrete_ptset_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_discrete_ptset_write_f( fn, B, Z, name, location, ptype, npnts, pnts, D, ier) !BIND(C, NAME="cg_discrete_ptset_write_f")
       IMPORT :: CGSIZE_T, cgenum_t, c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: name
       INTEGER(cgenum_t) :: location
       INTEGER(cgenum_t) :: ptype
       INTEGER(CGSIZE_T) :: npnts
       INTEGER(CGSIZE_T) :: pnts
       INTEGER :: D
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_discrete_ptset_write_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write GridCoordinates_t/DataArray_t Nodes               *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_ncoords_f(fn, B, Z, ncoords, ier) BIND(C, NAME="cg_ncoords_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: ncoords
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_ncoords_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_coord_info_f(fn, B, Z, C, TYPE, coordname, ier) !BIND(C, NAME="cg_coord_info_f")
       IMPORT :: c_char, cgenum_t
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: C
       INTEGER(cgenum_t) :: TYPE
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: coordname
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_coord_info_f
  END INTERFACE

#if HAVE_FORTRAN_2008
  INTERFACE cg_coord_read_f
    SUBROUTINE cg_coord_read_c_double (fn, B, Z, coordname, TYPE, rmin, rmax, coord, ier) !BIND(C, NAME="cg_coord_read_c_double")
      IMPORT :: c_char, cgenum_t, CGSIZE_T, c_double
      IMPLICIT NONE
      INTEGER :: fn
      INTEGER :: B
      INTEGER :: Z
      CHARACTER(KIND=C_CHAR), DIMENSION(*) :: coordname
      INTEGER(cgenum_t) :: TYPE
      INTEGER(CGSIZE_T) :: rmin
      INTEGER(CGSIZE_T) :: rmax
      REAL(C_DOUBLE), DIMENSION(*) :: coord
      INTEGER, INTENT(OUT) :: ier
    END SUBROUTINE cg_coord_read_c_double

    SUBROUTINE cg_coord_read_c_float (fn, B, Z, coordname, TYPE, rmin, rmax, coord, ier) !BIND(C, NAME="cg_coord_read_c_float")
      IMPORT :: c_char, cgenum_t, CGSIZE_T, c_float
      IMPLICIT NONE
      INTEGER :: fn
      INTEGER :: B
      INTEGER :: Z
      CHARACTER(KIND=C_CHAR), DIMENSION(*) :: coordname
      INTEGER(cgenum_t) :: TYPE
      INTEGER(CGSIZE_T) :: rmin
      INTEGER(CGSIZE_T) :: rmax
      REAL(C_FLOAT), DIMENSION(*) :: coord
      INTEGER, INTENT(OUT) :: ier
    END SUBROUTINE cg_coord_read_c_float

    SUBROUTINE cg_coord_read_f03 (fn, B, Z, coordname, TYPE, rmin, rmax, coord, ier) BIND(C, NAME="cg_coord_read_f03")
      IMPORT :: c_char, cgenum_t, CGSIZE_T, c_ptr
      IMPLICIT NONE
      INTEGER :: fn
      INTEGER :: B
      INTEGER :: Z
      CHARACTER(KIND=C_CHAR), DIMENSION(*) :: coordname
      INTEGER(cgenum_t) :: TYPE
      INTEGER(CGSIZE_T) :: rmin
      INTEGER(CGSIZE_T) :: rmax
      TYPE(C_PTR), VALUE :: coord
      INTEGER, INTENT(OUT) :: ier
    END SUBROUTINE cg_coord_read_f03
  END INTERFACE
#endif

  INTERFACE
     SUBROUTINE cg_coord_id_f(fn, B, Z, C, coord_id, ier) BIND(C, NAME="cg_coord_id_f")
       IMPORT :: c_double
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: C
       REAL(C_DOUBLE) :: coord_id
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_coord_id_f
  END INTERFACE

!!$ INTERFACE
!!$    SUBROUTINE cg_coord_write_f(fn, B, Z, TYPE, coordname, coord, C, ier) BIND(C, NAME="")
!!$      IMPORT :: c_char, cgenum_t, c_ptr
!!$      IMPLICIT NONE
!!$      INTEGER :: fn
!!$      INTEGER :: B
!!$      INTEGER :: Z
!!$      INTEGER(cgenum_t) :: TYPE
!!$      CHARACTER(KIND=C_CHAR), DIMENSION(*) :: coordname
!!$      TYPE(C_PTR), VALUE :: coord
!!$      INTEGER :: C
!!$      INTEGER, INTENT(OUT) :: ier
!!$    END SUBROUTINE cg_coord_write_f
!!$ END INTERFACE

!!$ INTERFACE
!!$    SUBROUTINE cg_coord_partial_write_f( fn, B, Z, TYPE, coordname, rmin, rmax, coord, C, ier) BIND(C, NAME="")
!!$      IMPORT :: c_char, cgenum_t, CGSIZE_T, c_ptr
!!$      IMPLICIT NONE
!!$      INTEGER :: fn
!!$      INTEGER :: B
!!$      INTEGER :: Z
!!$      INTEGER(cgenum_t) :: TYPE
!!$      CHARACTER(KIND=C_CHAR), DIMENSION(*) :: coordname
!!$      INTEGER(CGSIZE_T) :: rmin
!!$      INTEGER(CGSIZE_T) :: rmax
!!$      TYPE(C_PTR) :: coord
!!$      INTEGER :: C
!!$      INTEGER, INTENT(OUT) :: ier
!!$    END SUBROUTINE cg_coord_partial_write_f
!!$ END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write Elements_t Nodes                                  *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_nsections_f(fn, B, Z, nsections, ier) BIND(C, NAME="cg_nsections_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: nsections
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_nsections_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_section_read_f(fn, B, Z, E, section_name, TYPE, start, END, nbndry, parent_flag, ier) !BIND(C, NAME="cg_section_read_f")
       IMPORT :: c_char, cgenum_t, CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: E
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: section_name
       INTEGER(cgenum_t) :: TYPE
       INTEGER(CGSIZE_T) ::start
       INTEGER(CGSIZE_T) ::END
       INTEGER :: nbndry
       INTEGER :: parent_flag
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_section_read_f
  END INTERFACE

!!$  INTERFACE
!!$     SUBROUTINE cg_elements_read_f(fn, B, Z, E, elements, parent_data, ier) BIND(C, NAME="cg_elements_read_f")
!!$       IMPORT :: CGSIZE_T
!!$       IMPLICIT NONE
!!$       INTEGER :: fn
!!$       INTEGER :: B
!!$       INTEGER :: Z
!!$       INTEGER :: E
!!$       INTEGER(CGSIZE_T), DIMENSION(*) :: elements
!!$       INTEGER(CGSIZE_T), DIMENSION(*) :: parent_data
!!$       INTEGER, INTENT(OUT) :: ier
!!$     END SUBROUTINE cg_elements_read_f
!!$  END INTERFACE

  INTERFACE
     SUBROUTINE cg_elementdatasize_f(fn, B, Z, E, ElementDataSize, ier) BIND(C, NAME="cg_elementdatasize_f")
       IMPORT :: CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: E
       INTEGER(CGSIZE_T) :: ElementDataSize
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_elementdatasize_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_elementpartialsize_f(fn, B, Z, E, start, END, ElementDataSize, ier) BIND(C, NAME="cg_elementpartialsize_f")
       IMPORT :: CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: E
       INTEGER(CGSIZE_T) :: start
       INTEGER(CGSIZE_T) :: END
       INTEGER(CGSIZE_T) :: ElementDataSize
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_elementpartialsize_f
  END INTERFACE

!!$  INTERFACE
!!$     SUBROUTINE cg_section_write_f(fn, B, Z, section_name, TYPE, start, END, nbndry, elements, S, ier) !BIND(C, NAME="cg_section_write_f")
!!$       IMPORT :: c_char, cgenum_t, CGSIZE_T
!!$       IMPLICIT NONE
!!$       INTEGER :: fn
!!$       INTEGER :: B
!!$       INTEGER :: Z
!!$       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: section_name
!!$       INTEGER(cgenum_t) :: TYPE
!!$       INTEGER(CGSIZE_T) :: start
!!$       INTEGER(CGSIZE_T) :: END
!!$       INTEGER :: nbndry
!!$       INTEGER(CGSIZE_T), DIMENSION() :: elements
!!$       INTEGER :: S
!!$       INTEGER, INTENT(OUT) :: ier
!!$     END SUBROUTINE cg_section_write_f
!!$  END INTERFACE

!!$  INTERFACE
!!$     SUBROUTINE cg_parent_data_write_f(fn, B, Z, S, parent_data, ier) BIND(C, NAME="cg_parent_data_write_f")
!!$       IMPORT :: CGSIZE_T
!!$       IMPLICIT NONE
!!$       INTEGER :: fn
!!$       INTEGER :: B
!!$       INTEGER :: Z
!!$       INTEGER :: S
!!$       INTEGER(CGSIZE_T), DIMENSION(*) :: parent_data
!!$       INTEGER, INTENT(OUT) :: ier
!!$     END SUBROUTINE cg_parent_data_write_f
!!$  END INTERFACE

  INTERFACE
     SUBROUTINE cg_section_partial_write_f( fn, B, Z, section_name, TYPE, start, END, nbndry, S, ier) !BIND(C, NAME="cg_section_partial_write_f")
       IMPORT :: c_char, CGSIZE_T, cgenum_t
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: section_name
       INTEGER(cgenum_t) ::TYPE
       INTEGER(CGSIZE_T) ::start
       INTEGER(CGSIZE_T) ::END
       INTEGER :: nbndry
       INTEGER :: S
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_section_partial_write_f
  END INTERFACE

!!$  INTERFACE
!!$     SUBROUTINE cg_elements_partial_write_f(fn, B, Z, S, rmin, rmax, elements, ier) &
!!$          BIND(C, NAME="cg_elements_partial_write_f")
!!$       IMPORT :: CGSIZE_T
!!$       IMPLICIT NONE
!!$       INTEGER :: fn
!!$       INTEGER :: B
!!$       INTEGER :: Z
!!$       INTEGER :: S
!!$       INTEGER(CGSIZE_T) :: rmin
!!$       INTEGER(CGSIZE_T) :: rmax
!!$       INTEGER(CGSIZE_T), DIMENSION(*) :: elements
!!$       INTEGER, INTENT(OUT) :: ier
!!$     END SUBROUTINE cg_elements_partial_write_f
!!$  END INTERFACE

!!$  INTERFACE
!!$     SUBROUTINE cg_parent_data_partial_write_f(fn, B, Z, S, rmin, rmax, parent_data, ier) &
!!$          BIND(C, NAME="cg_parent_data_partial_write_f")
!!$       IMPORT :: CGSIZE_T
!!$       IMPLICIT NONE
!!$
!!$       INTEGER :: fn
!!$       INTEGER :: B
!!$       INTEGER :: Z
!!$       INTEGER :: S
!!$       INTEGER(CGSIZE_T) :: rmin
!!$       INTEGER(CGSIZE_T) :: rmax
!!$       INTEGER(CGSIZE_T), DIMENSION(*) :: parent_data
!!$       INTEGER, INTENT(OUT) :: ier
!!$     END SUBROUTINE cg_parent_data_partial_write_f
!!$  END INTERFACE
!!$
!!$  INTERFACE
!!$     SUBROUTINE cg_elements_partial_read_f(fn, B, Z, S, rmin, rmax, elements, parent, ier) &
!!$          BIND(C, NAME="cg_elements_partial_read_f")
!!$       IMPORT :: CGSIZE_T
!!$       IMPLICIT NONE
!!$
!!$       INTEGER :: fn
!!$       INTEGER :: B
!!$       INTEGER :: Z
!!$       INTEGER :: S
!!$       INTEGER(CGSIZE_T) ::rmin
!!$       INTEGER(CGSIZE_T) ::rmax
!!$       INTEGER(CGSIZE_T), DIMENSION(*) :: elements
!!$       INTEGER(CGSIZE_T), DIMENSION(*) :: parent
!!$       INTEGER, INTENT(OUT) :: ier
!!$     END SUBROUTINE cg_elements_partial_read_f
!!$  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write FlowSolution_t Nodes                              *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_nsols_f(fn, B, Z, nsols, ier) BIND(C, NAME="cg_nsols_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: nsols
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_nsols_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_sol_info_f(fn, B, Z, S, solname, location, ier) !BIND(C, NAME="cg_sol_info_f")
       IMPORT :: c_char, cgenum_t
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: S
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: solname
       INTEGER(cgenum_t) :: location
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_sol_info_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_sol_id_f(fn, B, Z, S, sol_id, ier) BIND(C, NAME="cg_sol_id_f")
       IMPORT :: c_double
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: S
       REAL(C_DOUBLE) :: sol_id
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_sol_id_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_sol_write_f(fn, B, Z, solname, location, S, ier) !BIND(C, NAME="cg_sol_write_f")
       IMPORT :: c_char, cgenum_t
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: solname
       INTEGER(cgenum_t) :: location
       INTEGER :: S
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_sol_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_sol_size_f(fn, B, Z, S, ndim, dims, ier) BIND(C, NAME="cg_sol_size_f")
       IMPORT :: CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: S
       INTEGER :: ndim
       INTEGER(CGSIZE_T), DIMENSION(*) :: dims
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_sol_size_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_sol_ptset_info_f( fn, B, Z, S, ptype, npnts, ier) BIND(C, NAME="cg_sol_ptset_info_f")
       IMPORT :: cgenum_t, CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: S
       INTEGER(cgenum_t) :: ptype
       INTEGER(CGSIZE_T) :: npnts
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_sol_ptset_info_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_sol_ptset_read_f(fn, B, Z, S, pnts, ier) BIND(C, NAME="cg_sol_ptset_read_f")
       IMPORT :: CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: S
       INTEGER(CGSIZE_T) ::pnts
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_sol_ptset_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_sol_ptset_write_f(fn, B, Z, name, location, ptype, npnts, pnts, S, ier) !BIND(C, NAME="cg_sol_ptset_write_f")
       IMPORT :: c_char, cgenum_t, CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: name
       INTEGER(cgenum_t) :: location
       INTEGER(cgenum_t) :: ptype
       INTEGER(CGSIZE_T) :: npnts
       INTEGER(CGSIZE_T) :: pnts
       INTEGER :: S
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_sol_ptset_write_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write solution DataArray_t Nodes                        *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_nfields_f(fn, B, Z, S, nfields, ier) BIND(C, NAME="cg_nfields_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: S
       INTEGER :: nfields
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_nfields_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_field_info_f(fn, B, Z, S, F, TYPE, fieldname, ier) !BIND(C, NAME="cg_field_info_f")
       IMPORT :: c_char, cgenum_t
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: S
       INTEGER :: F
       INTEGER(cgenum_t) :: TYPE
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: fieldname
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_field_info_f
  END INTERFACE

!!$INTERFACE
!!$   SUBROUTINE cg_field_read_f(fn, B, Z, S, fieldname), TYPE, rmin, rmax, field_ptr, ier) BIND(C, NAME="")
!!$     INTEGER :: fn
!!$     INTEGER :: B,
!!$     INTEGER :: Z
!!$     INTEGER :: S, CHARACTER(KIND=C_CHAR), DIMENSION(*) :: fieldname), INTEGER(cgenum_t) :: TYPE
!!$     INTEGER(CGSIZE_T) ::rmin,
!!$     INTEGER(CGSIZE_T) ::rmax
!!$     void *field_ptr,
!!$     INTEGER, INTENT(OUT) :: ier
!!$   END SUBROUTINE cg_field_read_f
!!$END INTERFACE

  INTERFACE
     SUBROUTINE cg_field_id_f(fn, B, Z, S, F, field_id, ier) !BIND(C, NAME="cg_field_id_f")
       IMPORT :: c_double
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: S
       INTEGER :: F
       REAL(C_DOUBLE) :: field_id
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_field_id_f
  END INTERFACE

!!$INTERFACE
!!$   SUBROUTINE cg_field_write_f(fn, B, Z, S, TYPE, fieldname, field_ptr, F, ier) BIND(C, NAME="")
!!$     INTEGER :: fn
!!$     INTEGER :: B,
!!$     INTEGER :: Z
!!$     INTEGER :: S
!!$     INTEGER(cgenum_t) :: TYPE
!!$     CHARACTER(KIND=C_CHAR), DIMENSION(*) :: fieldname
!!$     void *field_ptr,
!!$     INTEGER :: F
!!$     INTEGER, INTENT(OUT) :: ier
!!$   END SUBROUTINE cg_field_write_f
!!$END INTERFACE

!!$INTERFACE
!!$   SUBROUTINE cg_field_partial_write_f) (fn, B, Z, S, TYPE, fieldname, rmin, rmax, void *field_ptr, F, ier) BIND(C, NAME="")
!!$     INTEGER :: fn,
!!$     INTEGER :: B
!!$     INTEGER :: Z
!!$     INTEGER :: S, INTEGER(cgenum_t) :: TYPE
!!$     CHARACTER(KIND=C_CHAR), DIMENSION(*) :: fieldname
!!$     INTEGER(CGSIZE_T) :: rmin
!!$     INTEGER(CGSIZE_T) :: rmax
!!$     void *field_ptr
!!$     INTEGER :: F
!!$     INTEGER, INTENT(OUT) :: ier
!!$   END SUBROUTINE cg_field_partial_write_f
!!$END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write ZoneSubRegion_t Nodes                              *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_nsubregs_f(fn, B, Z, nsubreg, ier) BIND(C, NAME="cg_nsubregs_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: nsubreg
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_nsubregs_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_subreg_info_f(fn, B, Z, S, regname, DIMENSION, &
          location, ptset_type, npnts, bcname_len, gcname_len, ier) !BIND(C, NAME="cg_subreg_info_f")
       IMPORT :: c_char, cgenum_t, CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: S
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: regname
       INTEGER :: DIMENSION
       INTEGER(cgenum_t) :: location
       INTEGER(cgenum_t) :: ptset_type
       INTEGER(CGSIZE_T) ::npnts
       INTEGER :: bcname_len
       INTEGER :: gcname_len
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_subreg_info_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_subreg_ptset_read_f( fn, B, Z, S, pnts, ier) BIND(C, NAME="cg_subreg_ptset_read_f")
       IMPORT :: CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: S
       INTEGER(CGSIZE_T), DIMENSION(*) :: pnts
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_subreg_ptset_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_subreg_bcname_read_f( fn, B, Z, S, bcname, ier) !BIND(C, NAME="cg_subreg_bcname_read_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: S
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: bcname
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_subreg_bcname_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_subreg_gcname_read_f(fn, B, Z, S, gcname, ier) !BIND(C, NAME="cg_subreg_gcname_read_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: S
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: gcname
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_subreg_gcname_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_subreg_ptset_write_f(fn, B, Z, regname, DIMENSION, location, ptset_type, npnts, pnts, S, ier) !BIND(C, NAME="cg_subreg_ptset_write_f")
       IMPORT :: cgenum_t, c_char, CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: regname
       INTEGER :: DIMENSION
       INTEGER(cgenum_t) :: location
       INTEGER(cgenum_t) :: ptset_type
       INTEGER(CGSIZE_T) :: npnts
       INTEGER(CGSIZE_T), DIMENSION(*) :: pnts
       INTEGER :: S
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_subreg_ptset_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_subreg_bcname_write_f( fn, B, Z, regname, DIMENSION, bcname, S, ier) !BIND(C, NAME="cg_subreg_bcname_write_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: regname
       INTEGER :: DIMENSION
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: bcname
       INTEGER :: S
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_subreg_bcname_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_subreg_gcname_write_f( fn, B, Z, regname, DIMENSION, gcname, S, ier) !BIND(C, NAME="cg_subreg_gcname_write_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: regname
       INTEGER :: DIMENSION
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: gcname
       INTEGER :: S
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_subreg_gcname_write_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write ZoneGridConnectivity_t Nodes                       *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_nzconns_f(fn, B, Z, nzconns, ier) BIND(C, NAME="cg_nzconns_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: nzconns
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_nzconns_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_zconn_read_f(fn, B, Z, C, name, ier) !BIND(C, NAME="cg_zconn_read_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: C
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: name
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_zconn_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_zconn_write_f(fn, B, Z, name, C, ier) !BIND(C, NAME="cg_zconn_write_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: name
       INTEGER :: C
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_zconn_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_zconn_get_f(fn, B, Z, C, ier) BIND(C, NAME="cg_zconn_get_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: C
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_zconn_get_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_zconn_set_f(fn, B, Z, C, ier) BIND(C, NAME="cg_zconn_set_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: C
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_zconn_set_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write OversetHoles_t Nodes                              *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_nholes_f(fn, B, Z, nholes, ier) BIND(C, NAME="cg_nholes_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: nholes
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_nholes_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_hole_info_f(fn, B, Z, I, holename, location, ptset_type, nptsets, npnts, ier) !BIND(C, NAME="cg_hole_info_f")
       IMPORT :: c_char, cgenum_t, CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: I
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: holename
       INTEGER(cgenum_t) :: location
       INTEGER(cgenum_t) :: ptset_type
       INTEGER(CGSIZE_T) :: nptsets
       INTEGER(CGSIZE_T) :: npnts
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_hole_info_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_hole_read_f(fn, B, Z, I, pnts, ier) BIND(C, NAME="cg_hole_read_f")
       IMPORT :: CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: I
       INTEGER(CGSIZE_T), DIMENSION(*) :: pnts
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_hole_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_hole_id_f(fn, B, Z, I, hole_id, ier) BIND(C, NAME="cg_hole_id_f")
       IMPORT :: c_double
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: I
       REAL(C_DOUBLE) :: hole_id
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_hole_id_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_hole_write_f(fn, B, Z, holename, location, ptset_type, nptsets, npnts, pnts, I, ier) !BIND(C, NAME="cg_hole_write_f")
       IMPORT :: c_char, cgenum_t, CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: holename
       INTEGER(cgenum_t) :: location
       INTEGER(cgenum_t) :: ptset_type
       INTEGER :: nptsets
       INTEGER(CGSIZE_T) :: npnts
       INTEGER(CGSIZE_T), DIMENSION(*) :: pnts
       INTEGER :: I
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_hole_write_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write GridConnectivity_t Nodes                          *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_nconns_f(fn, B, Z, nconns, ier) BIND(C, NAME="cg_nconns_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: nconns
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_nconns_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_conn_info_f(fn, B, Z, I, connectname, location, &
          TYPE, ptset_type, npnts, donorname, donor_zonetype, donor_ptset_type, &
          donor_datatype, ndata_donor, ier) !BIND(C, NAME="cg_conn_info_f")
       IMPORT :: c_char, cgenum_t, CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: I
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: connectname
       INTEGER(cgenum_t) :: location
       INTEGER(cgenum_t) :: TYPE
       INTEGER(cgenum_t) :: ptset_type
       INTEGER(CGSIZE_T) :: npnts
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: donorname
       INTEGER(cgenum_t) :: donor_zonetype
       INTEGER(cgenum_t) :: donor_ptset_type
       INTEGER(cgenum_t) :: donor_datatype
       INTEGER(CGSIZE_T) :: ndata_donor
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_conn_info_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_conn_read_f(fn, B, Z, I, pnts, donor_datatype, donor_data, ier) BIND(C, NAME="cg_conn_read_f")
       IMPORT :: cgenum_t, CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: I
       INTEGER(CGSIZE_T), DIMENSION(*) :: pnts
       INTEGER(cgenum_t) :: donor_datatype
       INTEGER(CGSIZE_T), DIMENSION(*) :: donor_data
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_conn_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_conn_read_short_f(fn, B, Z, I, pnts, ier) BIND(C, NAME="cg_conn_read_short_f")
       IMPORT :: CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: I
       INTEGER(CGSIZE_T) ::pnts
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_conn_read_short_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_conn_id_f(fn, B, Z, I, conn_id, ier) BIND(C, NAME="cg_conn_id_f")
       IMPORT :: c_double
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: I
       REAL(C_DOUBLE) :: conn_id
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_conn_id_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_conn_write_f(fn, B, Z, connectname, location, TYPE, ptset_type, &
          npnts, pnts, donorname, donor_zonetype, donor_ptset_type, &
          donor_datatype, ndata_donor, donor_data, I, ier) !BIND(C, NAME="cg_conn_write_f")
       IMPORT :: c_char, cgenum_t, CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: connectname
       INTEGER(cgenum_t) :: location
       INTEGER(cgenum_t) :: TYPE
       INTEGER(cgenum_t) :: ptset_type
       INTEGER(CGSIZE_T) :: npnts
       INTEGER(CGSIZE_T), DIMENSION(*) :: pnts
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: donorname
       INTEGER(cgenum_t) :: donor_zonetype
       INTEGER(cgenum_t) :: donor_ptset_type
       INTEGER(cgenum_t) :: donor_datatype
       INTEGER(CGSIZE_T) :: ndata_donor
       INTEGER(CGSIZE_T), DIMENSION(*) :: donor_data
       INTEGER :: I
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_conn_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_conn_write_short_f(fn, B, Z, connectname, location, &
          TYPE, ptset_type, npnts, pnts, donorname, I, ier) !BIND(C, NAME="cg_conn_write_short_f")
       IMPORT :: c_char, cgenum_t, CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: connectname
       INTEGER(cgenum_t) :: location
       INTEGER(cgenum_t) :: TYPE
       INTEGER(cgenum_t) :: ptset_type
       INTEGER(CGSIZE_T) :: npnts
       INTEGER(CGSIZE_T) :: pnts
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: donorname
       INTEGER :: I
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_conn_write_short_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write GridConnectivity1to1_t Nodes in a zone            *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_n1to1_f(fn, B, Z, n1to1, ier) BIND(C, NAME="cg_n1to1_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: n1to1
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_n1to1_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_1to1_read_f(fn, B, Z, I, connectname, donorname, &
          range, donor_range, transform, ier) !BIND(C, NAME="cg_1to1_read_f")
       IMPORT :: c_char, CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: I
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: connectname
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: donorname
       INTEGER(CGSIZE_T), DIMENSION(*) :: range
       INTEGER(CGSIZE_T), DIMENSION(*) :: donor_range
       INTEGER, DIMENSION(*) :: transform
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_1to1_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_1to1_id_f(fn, B, Z, I, one21_id, ier) !BIND(C, NAME="cg_1to1_id_f")
       IMPORT :: c_double
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: I
       REAL(C_DOUBLE) :: one21_id
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_1to1_id_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_1to1_write_f(fn, B, Z, connectname, donorname, range, &
          donor_range, transform, I, ier) !BIND(C, NAME="cg_1to1_write_f")
       IMPORT :: c_char, CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: connectname
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: donorname
       INTEGER(CGSIZE_T), DIMENSION(*) :: range
       INTEGER(CGSIZE_T), DIMENSION(*) :: donor_range
       INTEGER, DIMENSION(*) :: transform
       INTEGER :: I
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_1to1_write_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read all GridConnectivity1to1_t Nodes of a base                  *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_n1to1_global_f(fn, B, n1to1_global, ier) BIND(C, NAME="cg_n1to1_global_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: n1to1_global
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_n1to1_global_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_1to1_read_global_f(fn, B, connectname, zonename, donorname, &
          range, donor_range, transform, ier) !BIND(C, NAME="cg_1to1_read_global_f")
       IMPORT :: c_char, CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: connectname
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: zonename
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: donorname
       INTEGER(CGSIZE_T), DIMENSION(*) :: range
       INTEGER(CGSIZE_T), DIMENSION(*) :: donor_range
       INTEGER, DIMENSION(*) :: transform
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_1to1_read_global_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write BC_t Nodes                                        *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_nbocos_f(fn, B, Z, nbocos, ier) BIND(C, NAME="cg_nbocos_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: nbocos
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_nbocos_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_boco_info_f(fn, B, Z, BC, boconame, bocotype, &
          ptset_type, npnts, NormalIndex, &
          NormalListSize, NormalDataType, ndataset, ier) !BIND(C, NAME="cg_boco_info_f")
       IMPORT :: c_char, cgenum_t, CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: BC
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: boconame
       INTEGER(cgenum_t) :: bocotype
       INTEGER(cgenum_t) :: ptset_type
       INTEGER(CGSIZE_T) :: npnts
       INTEGER, DIMENSION(*) :: NormalIndex
       INTEGER(CGSIZE_T) :: NormalListSize
       INTEGER(cgenum_t) :: NormalDataType
       INTEGER :: ndataset
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_boco_info_f
  END INTERFACE

!!$ INTERFACE
!!$    SUBROUTINE cg_boco_read_f(fn, B, Z, BC, pnts, NormalList, ier) BIND(C, NAME="")
!!$      IMPORT :: CGSIZE_T
!!$      IMPLICIT NONE
!!$      INTEGER :: fn
!!$      INTEGER :: B
!!$      INTEGER :: Z
!!$      INTEGER :: BC
!!$      INTEGER(CGSIZE_T) :: pnts
!!$      void *NormalList
!!$      INTEGER, INTENT(OUT) :: ier
!!$    END SUBROUTINE cg_boco_read_f
!!$ END INTERFACE

  INTERFACE
     SUBROUTINE cg_boco_id_f(fn, B, Z, BC, boco_id, ier) BIND(C, NAME="cg_boco_id_f")
       IMPORT :: c_double
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: BC
       REAL(C_DOUBLE) :: boco_id
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_boco_id_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_boco_write_f(fn, B, Z, boconame, bocotype, ptset_type, npnts, pnts, BC, ier) !BIND(C, NAME="cg_boco_write_f")
       IMPORT :: c_char, cgenum_t, CGSIZE_T
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: boconame
       INTEGER(cgenum_t) :: bocotype
       INTEGER(cgenum_t) :: ptset_type
       INTEGER(CGSIZE_T) :: npnts
       INTEGER(CGSIZE_T), DIMENSION(*) :: pnts
       INTEGER :: BC
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_boco_write_f
  END INTERFACE

!!$ INTERFACE
!!$    SUBROUTINE cg_boco_normal_write_f( fn, B, Z, BC, NormalIndex, NormalListFlag,
!!$      NormalDataType, NormalList, ier) BIND(C, NAME="")
!!$
!!$      INTEGER :: fn
!!$      INTEGER :: B
!!$      INTEGER :: Z
!!$      INTEGER :: BC,
!!$      INTEGER(CGSIZE_T) ::NormalIndex
!!$      INTEGER :: NormalListFlag,
!!$      INTEGER(cgenum_t) :: NormalDataType
!!$      ! void *NormalList,
!!$      INTEGER, INTENT(OUT) :: ier
!!$    END SUBROUTINE cg_boco_normal_write_f
!!$ END INTERFACE

  INTERFACE
     SUBROUTINE cg_boco_gridlocation_read_f(fn, B, Z, BC, location, ier) BIND(C, NAME="cg_boco_gridlocation_read_f")
       IMPORT :: cgenum_t
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: BC
       INTEGER(cgenum_t) :: location
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_boco_gridlocation_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_boco_gridlocation_write_f( fn, B, Z, BC, location, ier) BIND(C, NAME="cg_boco_gridlocation_write_f")
       IMPORT :: cgenum_t
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: BC
       INTEGER(cgenum_t) :: location
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_boco_gridlocation_write_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write BCProperty_t/WallFunction_t Nodes                 *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_bc_wallfunction_read_f(fn, B, Z, BC, WallFunctionType, ier) BIND(C, NAME="cg_bc_wallfunction_read_f")
       IMPORT :: cgenum_t
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: BC
       INTEGER(cgenum_t) :: WallFunctionType
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_bc_wallfunction_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_bc_wallfunction_write_f(fn, B, Z, BC, WallFunctionType, ier) BIND(C, NAME="cg_bc_wallfunction_write_f")
       IMPORT :: cgenum_t
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: BC
       INTEGER(cgenum_t) :: WallFunctionType
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_bc_wallfunction_write_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write BCProperty_t/Area_t Nodes                         *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_bc_area_read_f(fn, B, Z, BC, AreaType, SurfaceArea, RegionName, ier) !BIND(C, NAME="cg_bc_area_read_f")
       IMPORT :: c_char, cgenum_t, c_float
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: BC
       INTEGER(cgenum_t) :: AreaType
       REAL(C_FLOAT) :: SurfaceArea
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: RegionName
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_bc_area_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_bc_area_write_f(fn, B, Z, BC, AreaType, SurfaceArea, RegionName, ier) !BIND(C, NAME="cg_bc_area_write_f")
       IMPORT :: c_char, cgenum_t, c_float
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: BC
       INTEGER(cgenum_t) :: AreaType
       REAL(C_FLOAT) :: SurfaceArea
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: RegionName
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_bc_area_write_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write GridConnectivityProperty_t/Periodic_t Nodes       *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_conn_periodic_read_f(fn, B, Z, I, RotationCenter, RotationAngle, Translation, ier) &
          BIND(C, NAME="cg_conn_periodic_read_f")
       IMPORT :: c_float
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: I
       REAL(C_FLOAT), DIMENSION(*) :: RotationCenter
       REAL(C_FLOAT), DIMENSION(*) :: RotationAngle
       REAL(C_FLOAT), DIMENSION(*) :: Translation
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_conn_periodic_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_conn_periodic_write_f( fn, B, Z, I, RotationCenter, RotationAngle, Translation, ier) &
          BIND(C, NAME="cg_conn_periodic_write_f")
       IMPORT :: c_float
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: I
       REAL(C_FLOAT), DIMENSION(*)  :: RotationCenter
       REAL(C_FLOAT), DIMENSION(*)  :: RotationAngle
       REAL(C_FLOAT), DIMENSION(*)  :: Translation
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_conn_periodic_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_1to1_periodic_read_f(fn, B, Z, I, RotationCenter, RotationAngle, Translation, ier) &
          BIND(C, NAME="cg_1to1_periodic_read_f")
       IMPORT :: c_float
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: I
       REAL(C_FLOAT), DIMENSION(*)  :: RotationCenter
       REAL(C_FLOAT), DIMENSION(*)  :: RotationAngle
       REAL(C_FLOAT), DIMENSION(*)  :: Translation
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_1to1_periodic_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_1to1_periodic_write_f(fn, B, Z, I, RotationCenter, RotationAngle, Translation, ier) &
          BIND(C, NAME="cg_1to1_periodic_write_f")
       IMPORT :: c_float
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: I
       REAL(C_FLOAT), DIMENSION(*)  :: RotationCenter
       REAL(C_FLOAT), DIMENSION(*)  :: RotationAngle
       REAL(C_FLOAT), DIMENSION(*)  :: Translation
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_1to1_periodic_write_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !   Read and write GridConnectivityProperty_t/AverageInterface_t Nodes  *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_conn_average_read_f(fn, B, Z, I, AverageInterfaceType, ier) &
          BIND(C, NAME="cg_conn_average_read_f")
       IMPORT :: cgenum_t
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: I
       INTEGER(cgenum_t) :: AverageInterfaceType
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_conn_average_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_conn_average_write_f(fn, B, Z, I, AverageInterfaceType, ier) &
          BIND(C, NAME="cg_conn_average_write_f")
       IMPORT :: cgenum_t
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: I
       INTEGER(cgenum_t) :: AverageInterfaceType
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_conn_average_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_1to1_average_read_f(fn, B, Z, I, AverageInterfaceType, ier) &
          BIND(C, NAME="cg_1to1_average_read_f")
       IMPORT :: cgenum_t
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: I
       INTEGER(cgenum_t) :: AverageInterfaceType
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_1to1_average_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_1to1_average_write_f(fn, B, Z, I,AverageInterfaceType, ier) BIND(C, NAME="cg_1to1_average_write_f")
       IMPORT :: cgenum_t
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: I
       INTEGER(cgenum_t) :: AverageInterfaceType
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_1to1_average_write_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write BCDataSet_t Nodes                                 *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_dataset_read_f(fn, B, Z, BC, DSet, Dataset_name, BCType, DirichletFlag, &
          NeumannFlag, ier) !BIND(C, NAME="cg_dataset_read_f")
       IMPORT :: c_char, cgenum_t
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: BC
       INTEGER :: DSet
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: Dataset_name
       INTEGER(cgenum_t) :: BCType
       INTEGER :: DirichletFlag
       INTEGER :: NeumannFlag
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_dataset_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_dataset_write_f(fn, B, Z, BC, Dataset_name,BCType, Dset, ier) !BIND(C, NAME="cg_dataset_write_f")
       IMPORT :: c_char, cgenum_t
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: BC
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: Dataset_name
       INTEGER(cgenum_t) :: BCType
       INTEGER :: Dset
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_dataset_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_bcdataset_write_f(Dataset_name, BCType, BCDataType, ier) !BIND(C, NAME="cg_bcdataset_write_f")
       IMPORT :: c_char, cgenum_t
       IMPLICIT NONE
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: Dataset_name
       INTEGER(cgenum_t) :: BCType
       INTEGER(cgenum_t) :: BCDataType
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_bcdataset_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_bcdataset_info_f(ndataset, ier) BIND(C, NAME="cg_bcdataset_info_f")
       IMPLICIT NONE
       INTEGER :: ndataset
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_bcdataset_info_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_bcdataset_read_f(index, Dataset_name, BCType, &
          DirichletFlag, NeumannFlag,ier) !BIND(C, NAME="cg_bcdataset_read_f")
       IMPORT :: c_char, cgenum_t, CGSIZE_T
       IMPLICIT NONE
       INTEGER ::index
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: Dataset_name
       INTEGER(cgenum_t) :: BCType
       INTEGER :: DirichletFlag
       INTEGER :: NeumannFlag
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_bcdataset_read_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write BCData_t Nodes                                    *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_bcdata_write_f(fn, B, Z, BC, Dset, BCDataType, ier) BIND(C, NAME="cg_bcdata_write_f")
       IMPORT :: cgenum_t
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: BC
       INTEGER :: Dset
       INTEGER(cgenum_t) :: BCDataType
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_bcdata_write_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write RigidGridMotion_t Nodes                           *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_n_rigid_motions_f(fn, B, Z, n_rigid_motions, ier) BIND(C, NAME="cg_n_rigid_motions_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: n_rigid_motions
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_n_rigid_motions_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_rigid_motion_read_f(fn, B, Z, R, rmotion_name, TYPE, ier) !BIND(C, NAME="cg_rigid_motion_read_f")
       IMPORT :: c_char, cgenum_t
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: R
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: rmotion_name
       INTEGER(cgenum_t) :: TYPE
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_rigid_motion_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_rigid_motion_write_f(fn, B, Z, rmotion_name, TYPE, R, ier) !BIND(C, NAME="cg_rigid_motion_write_f")
       IMPORT :: c_char, cgenum_t
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: rmotion_name
       INTEGER(cgenum_t) :: TYPE
       INTEGER :: R
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_rigid_motion_write_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write ArbitraryGridMotion_t Nodes                       *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_n_arbitrary_motions_f( fn, B, Z, n_arbitrary_motions, ier) BIND(C, NAME="cg_n_arbitrary_motions_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: n_arbitrary_motions
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_n_arbitrary_motions_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_arbitrary_motion_read_f(fn, B, Z, A, amotion_name, TYPE, ier) !BIND(C, NAME="cg_arbitrary_motion_read_f")
       IMPORT :: c_char, cgenum_t
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: A
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: amotion_name
       INTEGER(cgenum_t) :: TYPE
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_arbitrary_motion_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_arbitrary_motion_write_f(fn, B, Z, amotion_name, TYPE, A, ier) !BIND(C, NAME="cg_arbitrary_motion_write_f")
       IMPORT :: c_char, cgenum_t
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: amotion_name
       INTEGER(cgenum_t) :: TYPE
       INTEGER :: A
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_arbitrary_motion_write_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write GridCoordinates_t Nodes                           *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_ngrids_f(fn, B, Z, ngrids, ier) BIND(C, NAME="cg_ngrids_f")
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: ngrids
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_ngrids_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_grid_read_f(fn, B, Z, G, gridname, ier) ! BIND(C, NAME="cg_grid_read_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: G
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: gridname
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_grid_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_grid_write_f(fn, B, Z, gridname, G, ier) !BIND(C, NAME="cg_grid_write_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: gridname
       INTEGER :: G
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_grid_write_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write SimulationType_t Node                             *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_simulation_type_read_f(fn, B, TYPE, ier) BIND(C, NAME="cg_simulation_type_read_f")
       IMPORT :: cgenum_t
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER(cgenum_t) :: TYPE
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_simulation_type_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_simulation_type_write_f(fn, B, TYPE, ier) BIND(C, NAME="cg_simulation_type_write_f")
       IMPORT :: cgenum_t
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER(cgenum_t) :: TYPE
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_simulation_type_write_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write BaseIterativeData_t Node                          *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_biter_read_f(fn, B, bitername, nsteps, ier) !BIND(C, NAME="cg_biter_read_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: bitername
       INTEGER :: nsteps
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_biter_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_biter_write_f(fn, B, bitername, nsteps, ier) !BIND(C, NAME="cg_biter_write_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: bitername
       INTEGER :: nsteps
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_biter_write_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write ZoneIterativeData_t Nodes                         *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_ziter_read_f(fn, B, Z, zitername, ier) !BIND(C, NAME="cg_ziter_read_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: zitername
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_ziter_read_f
  END INTERFACE


  INTERFACE
     SUBROUTINE cg_ziter_write_f(fn, B, Z, zitername, ier) !BIND(C, NAME="cg_ziter_write_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: zitername
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_ziter_write_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write Gravity_t Node                                    *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_gravity_read_f(fn, B, gravity_vector, ier) BIND(C, NAME="cg_gravity_read_f")
       IMPORT :: c_float
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       REAL(C_FLOAT), DIMENSION(*) :: gravity_vector
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_gravity_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_gravity_write_f(fn, B, gravity_vector, ier) BIND(C, NAME="cg_gravity_write_f")
       IMPORT :: c_float
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       REAL(C_FLOAT), DIMENSION(*) :: gravity_vector
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_gravity_write_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write Axisymmetry_t Node                                *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_axisym_read_f(fn, B, ref_point, axis, ier) BIND(C, NAME="cg_axisym_read_f")
       IMPORT :: c_float
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       REAL(C_FLOAT), DIMENSION(*) :: ref_point
       REAL(C_FLOAT), DIMENSION(*) :: axis
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_axisym_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_axisym_write_f(fn, B, ref_point, axis, ier) BIND(C, NAME="cg_axisym_write_f")
       IMPORT :: c_float
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       REAL(C_FLOAT), DIMENSION(*) :: ref_point
       REAL(C_FLOAT), DIMENSION(*) :: axis
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_axisym_write_f
  END INTERFACE


  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write RotatingCoordinates_t Node                        *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_rotating_read_f(rot_rate, rot_center, ier) BIND(C, NAME="cg_rotating_read_f")
       IMPORT :: c_float
       IMPLICIT NONE
       REAL(C_FLOAT), DIMENSION(*) :: rot_rate
       REAL(C_FLOAT), DIMENSION(*) :: rot_center
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_rotating_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_rotating_write_f(rot_rate, rot_center, ier) BIND(C, NAME="cg_rotating_write_f")
       IMPORT :: c_float
       IMPLICIT NONE
       REAL(C_FLOAT), DIMENSION(*) :: rot_rate
       REAL(C_FLOAT), DIMENSION(*) :: rot_center
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_rotating_write_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Read and write  IndexArray/Range_t Nodes                         *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_ptset_info_f(ptset_type, npnts, ier) BIND(C, NAME="cg_ptset_info_f")
       IMPORT :: cgenum_t, CGSIZE_T
       IMPLICIT NONE
       INTEGER(cgenum_t) :: ptset_type
       INTEGER(CGSIZE_T) :: npnts
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_ptset_info_f
  END INTERFACE

!!$  INTERFACE
!!$     SUBROUTINE cg_ptset_read_f(pnts, ier) BIND(C, NAME="cg_ptset_read_f")
!!$       IMPORT :: cgenum_t, CGSIZE_T
!!$       IMPLICIT NONE
!!$       INTEGER(CGSIZE_T), DIMENSION(*) :: pnts
!!$       INTEGER, INTENT(OUT) :: ier
!!$     END SUBROUTINE cg_ptset_read_f
!!$  END INTERFACE

!!$  INTERFACE
!!$     SUBROUTINE cg_ptset_write_f(ptset_type, npnts, pnts, ier) BIND(C, NAME="cg_ptset_write_f")
!!$       IMPORT :: cgenum_t, CGSIZE_T
!!$       IMPLICIT NONE
!!$       INTEGER(cgenum_t) :: ptset_type
!!$       INTEGER(CGSIZE_T) :: npnts
!!$       INTEGER(CGSIZE_T), DIMENSION() :: pnts
!!$       INTEGER, INTENT(OUT) :: ier
!!$     END SUBROUTINE cg_ptset_write_f
!!$  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Go - To Function                                                 *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

!!$     INTERFACE
!!$           SUBROUTINE cg_goto_f, CG_GOTO_F)(cgint_f *fn, cgint_f *B, ier, ...)
!!$cgint_f *fn, cgint_f *B, ier, ...)
!!$
!!$          INTEGER, INTENT(OUT) :: ier
!!$           END SUBROUTINE
!!$        END INTERFACE
!!$
!!$     INTERFACE
!!$           SUBROUTINE cg_gorel_f, CG_GOREL_F)(cgint_f *fn, ier, ...)
!!$cgint_f *fn, ier, ...)
!!$          INTEGER, INTENT(OUT) :: ier
!!$           END SUBROUTINE
!!$        END INTERFACE

  INTERFACE
     SUBROUTINE cg_gopath_f(fn,path, ier) !BIND(C, NAME="cg_gopath_f")
       IMPORT :: C_CHAR
       IMPLICIT NONE
       INTEGER :: fn
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: path
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_gopath_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !              Read Multiple path nodes                         *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_famname_read_f(famname, ier) !BIND(C, NAME="cg_famname_read_f")
       IMPORT :: c_char
       IMPLICIT NONE
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: famname
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_famname_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_nmultifam_f(nfam, ier) BIND(C, NAME="cg_nmultifam_f")
       IMPLICIT NONE
       INTEGER :: nfam
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_nmultifam_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_multifam_read_f(N,name, family, ier) !BIND(C, NAME="cg_multifam_read_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: N
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: name
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: family
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_multifam_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_convergence_read_f(iterations, NormDefinitions, ier) !BIND(C, NAME="cg_convergence_read_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: iterations
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: NormDefinitions
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_convergence_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_state_size_f(size, ier) !BIND(C, NAME="cg_state_size_f")
       IMPLICIT NONE
       INTEGER :: size
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_state_size_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_state_read_f(StateDescription, ier) !BIND(C, NAME="cg_state_read_f")
       IMPORT :: c_char
       IMPLICIT NONE
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: StateDescription
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_state_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_equationset_read_f(EquationDimension, GoverningEquationsFlag, &
          GasModelFlag, ViscosityModelFlag, ThermalConductivityModelFlag, &
          TurbulenceClosureFlag, TurbulenceModelFlag, ier) BIND(C, NAME="cg_equationset_read_f")
       IMPLICIT NONE
       INTEGER :: EquationDimension
       INTEGER :: GoverningEquationsFlag
       INTEGER :: GasModelFlag
       INTEGER :: ViscosityModelFlag
       INTEGER :: ThermalConductivityModelFlag
       INTEGER :: TurbulenceClosureFlag
       INTEGER :: TurbulenceModelFlag
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_equationset_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_equationset_chemistry_read_f(ThermalRelaxationFlag, ChemicalKineticsFlag, ier) &
          BIND(C, NAME="cg_equationset_chemistry_read_f")
       IMPLICIT NONE
       INTEGER :: ThermalRelaxationFlag
       INTEGER :: ChemicalKineticsFlag
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_equationset_chemistry_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_equationset_elecmagn_read_f(ElecFldModelFlag, MagnFldModelFlag, &
          ConductivityModelFlag, ier) BIND(C, NAME="cg_equationset_elecmagn_read_f")
       IMPLICIT NONE
       INTEGER :: ElecFldModelFlag
       INTEGER :: MagnFldModelFlag
       INTEGER :: ConductivityModelFlag
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_equationset_elecmagn_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_governing_read_f(EquationsType, ier) BIND(C, NAME="cg_governing_read_f")
       IMPORT :: cgenum_t
       IMPLICIT NONE
       INTEGER(cgenum_t) :: EquationsType
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_governing_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_diffusion_read_f(diffusion_model, ier) BIND(C, NAME="cg_diffusion_read_f")
       IMPLICIT NONE
       INTEGER, DIMENSION(*) :: diffusion_model
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_diffusion_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_model_read_f(ModelLabel, ModelType, ier) !BIND(C, NAME="cg_model_read_f")
       IMPORT :: c_char, cgenum_t
       IMPLICIT NONE
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: ModelLabel
       INTEGER(cgenum_t) :: ModelType
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_model_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_narrays_f(narrays, ier) BIND(C, NAME="cg_narrays_f")
       IMPLICIT NONE
       INTEGER :: narrays
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_narrays_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_array_info_f(A, ArrayName, DataType, DataDimension, DimensionVector, ier) !BIND(C, NAME="cg_array_info_f")
       IMPORT :: c_char, CGSIZE_T, cgenum_t
       IMPLICIT NONE
       INTEGER :: A
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: ArrayName
       INTEGER(cgenum_t) :: DataType
       INTEGER :: DataDimension
       INTEGER(CGSIZE_T), DIMENSION(*) :: DimensionVector
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_array_info_f
  END INTERFACE

!!$ INTERFACE
!!$    SUBROUTINE cg_array_read_f(A, DATA, ier) BIND(C, NAME="")
!!$      INTEGER :: A,
!!$      void *DATA,
!!$      INTEGER, INTENT(OUT) :: ier
!!$    END SUBROUTINE cg_array_read_f
!!$ END INTERFACE

!!$ INTERFACE
!!$    SUBROUTINE cg_array_read_as_f(A, TYPE, DATA, ier) BIND(C, NAME="")
!!$      IMPORT :: cgenum_t
!!$      IMPLICIT NONE
!!$      INTEGER :: A
!!$      INTEGER(cgenum_t) :: TYPE
!!$      void *DATA
!!$      INTEGER, INTENT(OUT) :: ier
!!$    END SUBROUTINE cg_array_read_as_f
!!$ END INTERFACE

  INTERFACE
     SUBROUTINE cg_nintegrals_f(nintegrals, ier) BIND(C, NAME="cg_nintegrals_f")
       IMPLICIT NONE
       INTEGER :: nintegrals
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_nintegrals_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_integral_read_f(IntegralDataIndex, IntegralDataName,ier) !BIND(C, NAME="cg_integral_read_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: IntegralDataIndex
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: IntegralDataName
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_integral_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_rind_read_f(RindData, ier) BIND(C, NAME="cg_rind_read_f")
       IMPLICIT NONE
       INTEGER, DIMENSION(*) :: RindData
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_rind_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_ndescriptors_f(ndescriptors, ier) BIND(C, NAME="cg_ndescriptors_f")
       IMPLICIT NONE
       INTEGER :: ndescriptors
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_ndescriptors_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_descriptor_size_f(descr_no, descr_size, ier) BIND(C, NAME="cg_descriptor_size_f")
       IMPLICIT NONE
       INTEGER :: descr_no
       INTEGER :: descr_size
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_descriptor_size_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_descriptor_read_f(descr_no, descr_name, descr_text, ier) !BIND(C, NAME="cg_descriptor_read_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: descr_no
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: descr_name
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: descr_text
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_descriptor_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_nunits_f(nunits, ier) BIND(C, NAME="cg_nunits_f")
       IMPLICIT NONE
       INTEGER :: nunits
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_nunits_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_units_read_f(mass, length,  time, temperature, angle, ier) BIND(C, NAME="cg_units_read_f")
       IMPORT :: cgenum_t
       IMPLICIT NONE
       INTEGER(cgenum_t) :: mass
       INTEGER(cgenum_t) :: length
       INTEGER(cgenum_t) :: time
       INTEGER(cgenum_t) :: temperature
       INTEGER(cgenum_t) :: angle
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_units_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_unitsfull_read_f(mass, length, time, temperature, angle, current, &
          amount, intensity, ier) BIND(C, NAME="cg_unitsfull_read_f")
       IMPORT :: cgenum_t
       IMPLICIT NONE
       INTEGER(cgenum_t) :: mass
       INTEGER(cgenum_t) :: length
       INTEGER(cgenum_t) :: time
       INTEGER(cgenum_t) :: temperature
       INTEGER(cgenum_t) :: angle
       INTEGER(cgenum_t) :: current
       INTEGER(cgenum_t) :: amount
       INTEGER(cgenum_t) :: intensity
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_unitsfull_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_exponents_info_f(DataType, ier) BIND(C, NAME="cg_exponents_info_f")
       IMPORT :: cgenum_t
       IMPLICIT NONE
       INTEGER(cgenum_t) :: DataType
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_exponents_info_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_nexponents_f(nexps, ier) BIND(C, NAME="cg_nexponents_f")
       IMPLICIT NONE
       INTEGER :: nexps
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_nexponents_f
  END INTERFACE

!!$ INTERFACE
!!$    SUBROUTINE cg_exponents_read_f(void *exponents, ier) BIND(C, NAME="")
!!$      void *exponents
!!$      INTEGER, INTENT(OUT) :: ier
!!$    END SUBROUTINE cg_exponents_read_f
!!$ END INTERFACE

!!$ INTERFACE
!!$    SUBROUTINE cg_expfull_read_f(exponents, ier) BIND(C, NAME="")
!!$      void *exponents,
!!$      INTEGER, INTENT(OUT) :: ier
!!$    END SUBROUTINE cg_expfull_read_f
!!$ END INTERFACE

  INTERFACE
     SUBROUTINE cg_conversion_info_f(DataType, ier) BIND(C, NAME="cg_conversion_info_f")
       IMPORT :: cgenum_t
       IMPLICIT NONE
       INTEGER(cgenum_t) :: DataType
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_conversion_info_f
  END INTERFACE

!!$ INTERFACE
!!$    SUBROUTINE cg_conversion_read_f(ConversionFactors, ier) BIND(C, NAME="")
!!$      void *ConversionFactors,
!!$      INTEGER, INTENT(OUT) :: ier
!!$    END SUBROUTINE cg_conversion_read_f
!!$ END INTERFACE

  INTERFACE
     SUBROUTINE cg_dataclass_read_f(dataclass, ier) BIND(C, NAME="cg_dataclass_read_f")
       IMPORT :: cgenum_t
       IMPLICIT NONE
       INTEGER(cgenum_t) :: dataclass
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_dataclass_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_gridlocation_read_f(GridLocation, ier) BIND(C, NAME="cg_gridlocation_read_f")
       IMPORT :: cgenum_t
       IMPLICIT NONE
       INTEGER(cgenum_t) :: GridLocation
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_gridlocation_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_ordinal_read_f(Ordinal, ier) BIND(C, NAME="cg_ordinal_read_f")
       IMPORT :: cgenum_t
       IMPLICIT NONE
       INTEGER :: Ordinal
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_ordinal_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_npe_f(TYPE,npe, ier) BIND(C, NAME="cg_npe_f")
       IMPORT :: cgenum_t
       IMPLICIT NONE
       INTEGER(cgenum_t) :: TYPE
       INTEGER :: npe
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_npe_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_is_link_f(path_length, ier) BIND(C, NAME="cg_is_link_f")
       IMPLICIT NONE
       INTEGER :: path_length
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_is_link_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_link_read_f(filename, link_path, ier) !BIND(C, NAME="cg_link_read_f")
       IMPORT :: c_char
       IMPLICIT NONE
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: filename
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: link_path
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_link_read_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_nuser_data_f(nuser_data, ier) BIND(C, NAME="cg_nuser_data_f")
       IMPLICIT NONE
       INTEGER :: nuser_data
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_nuser_data_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_user_data_read_f(index,dataname, ier) !BIND(C, NAME="cg_user_data_read_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: index
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: dataname
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_user_data_read_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !                   Write Multiple path nodes                           *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_famname_write_f(family_name, ier) !BIND(C, NAME="cg_famname_write_f")
       IMPORT :: c_char
       IMPLICIT NONE
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: family_name
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_famname_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_multifam_write_f(name, family, ier) !BIND(C, NAME="cg_multifam_write_f")
       IMPORT :: c_char
       IMPLICIT NONE
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: name
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: family
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_multifam_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_convergence_write_f(iterations, NormDefinitions, ier) !BIND(C, NAME="cg_convergence_write_f")
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: iterations
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: NormDefinitions
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_convergence_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_state_write_f(StateDescription, ier) !BIND(C, NAME="cg_state_write_f")
       IMPORT :: c_char
       IMPLICIT NONE
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: StateDescription
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_state_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_equationset_write_f(EquationDimension, ier) BIND(C, NAME="cg_equationset_write_f")
       IMPLICIT NONE
       INTEGER :: EquationDimension
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_equationset_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_governing_write_f(Equationstype, ier) BIND(C, NAME="cg_governing_write_f")
       IMPORT :: cgenum_t
       IMPLICIT NONE
       INTEGER(cgenum_t) :: Equationstype
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_governing_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_diffusion_write_f(diffusion_model, ier) BIND(C, NAME="cg_diffusion_write_f")
       IMPLICIT NONE
       INTEGER, DIMENSION(*) :: diffusion_model
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_diffusion_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_model_write_f(ModelLabel, ModelType, ier) !BIND(C, NAME="cg_model_write_f")
       IMPORT :: c_char, cgenum_t
       IMPLICIT NONE
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: ModelLabel
       INTEGER(cgenum_t) :: ModelType
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_model_write_f
  END INTERFACE

!!$ INTERFACE
!!$    SUBROUTINE cg_array_write_f(ArrayName, DataType, DataDimension, DimensionVector, &
!!$     void *Data, ier) BIND(C, NAME="")
!!$      CHARACTER(KIND=C_CHAR), DIMENSION(*) :: ArrayName
!!$      INTEGER(cgenum_t) :: DataType
!!$      INTEGER :: DataDimension
!!$      INTEGER(CGSIZE_T) :: DimensionVector
!!$      void *DATA
!!$      INTEGER, INTENT(OUT) :: ier
!!$    END SUBROUTINE cg_array_write_f
!!$ END INTERFACE

!!$ INTERFACE
!!$    SUBROUTINE cg_array_write_f03(ArrayName, DataType, DataDimension, DimensionVector, DATA, ier) &
!!$         BIND(C, NAME="cg_array_write_f03")
!!$      IMPORT :: c_char, cgenum_t, cgsize_t, c_ptr
!!$      CHARACTER(KIND=C_CHAR), DIMENSION(*) :: ArrayName
!!$      INTEGER(cgenum_t) :: DataType
!!$      INTEGER :: DataDimension
!!$      INTEGER(cgsize_t), DIMENSION(*) :: DimensionVector
!!$      TYPE(C_PTR), VALUE :: Data
!!$      INTEGER, INTENT(OUT) :: ier
!!$    END SUBROUTINE cg_array_write_f03
!!$ END INTERFACE

  INTERFACE
     SUBROUTINE cg_integral_write_f(IntegralDataName, ier) !BIND(C, NAME="cg_integral_write_f")
       IMPORT :: c_char
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: IntegralDataName
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_integral_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_rind_write_f(RindData, ier) BIND(C, NAME="cg_rind_write_f")
       IMPLICIT NONE
       INTEGER, DIMENSION(*) :: RindData
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_rind_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_descriptor_write_f(descr_name, descr_text, ier) !BIND(C, NAME="cg_descriptor_write_f")
       IMPORT :: c_char
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: descr_name
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: descr_text
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_descriptor_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_units_write_f(mass, length, time, temperature, angle, ier) BIND(C, NAME="cg_units_write_f")
       IMPORT :: cgenum_t
       IMPLICIT NONE
       INTEGER(cgenum_t) :: mass
       INTEGER(cgenum_t) :: length
       INTEGER(cgenum_t) :: time
       INTEGER(cgenum_t) :: temperature
       INTEGER(cgenum_t) :: angle
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_units_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_unitsfull_write_f(mass, length, time, temperature, angle, current, &
          amount, intensity, ier) BIND(C, NAME="cg_unitsfull_write_f")
       IMPORT :: cgenum_t
       IMPLICIT NONE
       INTEGER(cgenum_t) :: mass
       INTEGER(cgenum_t) :: length
       INTEGER(cgenum_t) :: time
       INTEGER(cgenum_t) :: temperature
       INTEGER(cgenum_t) :: angle
       INTEGER(cgenum_t) :: current
       INTEGER(cgenum_t) :: amount
       INTEGER(cgenum_t) :: intensity
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_unitsfull_write_f
  END INTERFACE

!!$ INTERFACE
!!$    SUBROUTINE cg_exponents_write_f(DataType, void *exponents, ier) BIND(C, NAME="")
!!$
!!$      INTEGER(cgenum_t) :: DataType_t)*DataType, void *exponents,
!!$      INTEGER, INTENT(OUT) :: ier
!!$    END SUBROUTINE cg_exponents_write_f
!!$ END INTERFACE

!!$ INTERFACE
!!$    SUBROUTINE cg_expfull_write_f(DataType, void *exponents, ier) BIND(C, NAME="")
!!$      INTEGER(cgenum_t) :: DataType
!!$      void *exponents,
!!$      INTEGER, INTENT(OUT) :: ier
!!$    END SUBROUTINE cg_expfull_write_f
!!$ END INTERFACE

!!$ INTERFACE
!!$    SUBROUTINE cg_conversion_write_f( DataType, ConversionFactors, ier) BIND(C, NAME="")
!!$      INTEGER(cgenum_t) :: DataType
!!$      void *ConversionFactors
!!$      INTEGER, INTENT(OUT) :: ier
!!$    END SUBROUTINE cg_conversion_write_f
!!$ END INTERFACE

  INTERFACE
     SUBROUTINE cg_dataclass_write_f(dataclass, ier) BIND(C, NAME="cg_dataclass_write_f")
       IMPORT :: cgenum_t
       IMPLICIT NONE
       INTEGER(cgenum_t) :: dataclass
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_dataclass_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_gridlocation_write_f(GridLocation, ier) BIND(C, NAME="cg_gridlocation_write_f")
       IMPORT :: cgenum_t
       IMPLICIT NONE
       INTEGER(cgenum_t) :: GridLocation
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_gridlocation_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_ordinal_write_f(Ordinal, ier) BIND(C, NAME="cg_ordinal_write_f")
       IMPLICIT NONE
       INTEGER :: Ordinal
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_ordinal_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_link_write_f(nodename, filename, name_in_file, ier) !BIND(C, NAME="cg_link_write_f")
       IMPORT :: c_char
       IMPLICIT NONE
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: nodename
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: filename
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: name_in_file
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_link_write_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_user_data_write_f(dataname, ier) ! BIND(C, NAME="cg_user_data_write_f")
       IMPORT :: c_char
       IMPLICIT NONE
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: dataname
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_user_data_write_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      General Delete Function                      *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_delete_node_f(node_name, ier) !BIND(C, NAME="cg_delete_node_f")
       IMPORT :: c_char
       IMPLICIT NONE
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: node_name
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_delete_node_f
  END INTERFACE

  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
  !      Error Handling Functions                                         *
  ! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

  INTERFACE
     SUBROUTINE cg_get_error_f(errmsg) !BIND(C, NAME="cg_get_error_f")
       IMPORT :: c_char
       IMPLICIT NONE
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: errmsg
     END SUBROUTINE cg_get_error_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_error_exit_f() BIND(C, NAME="cg_error_exit_f")
       IMPLICIT NONE
     END SUBROUTINE cg_error_exit_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_error_print_f() BIND(C, NAME="cg_error_print_f")
       IMPLICIT NONE
     END SUBROUTINE cg_error_print_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_exit_on_error_f(flag) BIND(C, NAME="cg_exit_on_error_f")
       IMPLICIT NONE
       INTEGER :: flag
     END SUBROUTINE cg_exit_on_error_f
  END INTERFACE

#ifdef BUILD_PARALLEL

  !======================================================================
  ! parallel IO interface
  !======================================================================

  INTERFACE
     SUBROUTINE cgp_mpi_comm_f( mpi_comm_f, ier) BIND(C, NAME="cgp_mpi_comm_f")
       IMPLICIT NONE
       INTEGER :: mpi_comm_f
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgp_mpi_comm_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cgp_pio_mode_f( mode, ier) BIND(C, NAME="cgp_pio_mode_f")
       IMPORT :: C_INT
       IMPLICIT NONE
       INTEGER(C_INT) :: mode
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgp_pio_mode_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cgp_open_f(filename, mode, fn, ier) !BIND(C, NAME="cgp_open_f")
       IMPORT :: C_CHAR, C_INT
       IMPLICIT NONE
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: filename
       INTEGER(C_INT) :: mode
       INTEGER :: fn
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgp_open_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cgp_close_f(fn, ier) BIND(C, NAME="cgp_close_f")
       IMPLICIT NONE
       INTEGER, INTENT(IN)  :: fn
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgp_close_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cgp_coord_write_f(fn, B, Z, type, coordname, C, ier) !BIND(C, NAME="cgp_coord_write_f")
       IMPORT :: cgenum_t, c_char
       IMPLICIT NONE
       INTEGER, INTENT(IN) :: fn
       INTEGER, INTENT(IN) :: B
       INTEGER, INTENT(IN) :: Z
       INTEGER(cgenum_t), INTENT(IN) :: type
       CHARACTER(KIND=C_CHAR), DIMENSION(*), INTENT(IN) :: coordname
       INTEGER, INTENT(IN)  :: C
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgp_coord_write_f
  END INTERFACE

!!$ INTERFACE
!!$    SUBROUTINE cgp_coord_write_data_f(fn, B, Z, C,
!!$     CGSIZE_T *rmin, CGSIZE_T *rmax, void *data, ier) BIND(C, NAME="")
!!$
!!$ INTEGER :: fn
!!$ INTEGER :: B
!!$ INTEGER :: Z
!!$ INTEGER :: C,
!!$ INTEGER(CGSIZE_T) :: rmin, INTEGER(CGSIZE_T) :: rmax, void *DATA,
!!$ INTEGER, INTENT(OUT) :: ier
!!$END SUBROUTINE cgp_coord_write_data_f
!!$END INTERFACE

!!$     INTERFACE
!!$           SUBROUTINE cgp_coord_read_data_f(
!!$     fn, B, Z, C,
!!$     CGSIZE_T *rmin, CGSIZE_T *rmax, void *data, ier) BIND(C, NAME="")
!!$
!!$     INTEGER :: fn
!!$      INTEGER :: B
!!$      INTEGER :: Z
!!$      INTEGER :: C,
!!$     INTEGER(CGSIZE_T) :: rmin, INTEGER(CGSIZE_T) :: rmax, void *data,
!!$          INTEGER, INTENT(OUT) :: ier
!!$           END SUBROUTINE
!!$        END INTERFACE

  INTERFACE
     SUBROUTINE cgp_section_write_f( fn, B, Z, section_name, &
          TYPE,start,END, nbndry, S, ier) !BIND(C, NAME="cgp_section_write_f")
       IMPORT :: cgenum_t, cgsize_t, c_char
       IMPLICIT NONE
       INTEGER, INTENT(IN) :: fn
       INTEGER, INTENT(IN) :: B
       INTEGER, INTENT(IN) :: Z
       CHARACTER(KIND=C_CHAR), DIMENSION(*), INTENT(IN) :: section_name
       INTEGER(cgenum_t) :: TYPE
       INTEGER(CGSIZE_T), INTENT(IN) :: start
       INTEGER(CGSIZE_T), INTENT(IN) :: END
       INTEGER, INTENT(IN) :: nbndry
       INTEGER, INTENT(IN) :: S
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgp_section_write_f
  END INTERFACE

!!$  INTERFACE
!!$     SUBROUTINE cgp_elements_write_data_f( fn, B, Z, S, CGSIZE_T *start, &
!!$          CGSIZE_T *END, CGSIZE_T *elements, ier) BIND(C, NAME="cgp_elements_write_data_f")
!!$       IMPORT :: cgsize_t
!!$       IMPLICIT NONE
!!$       IMPLICIT NONE
!!$       INTEGER, INTENT(IN) :: fn
!!$       INTEGER, INTENT(IN) :: B
!!$       INTEGER, INTENT(IN) :: Z
!!$       INTEGER, INTENT(IN) :: S
!!$       INTEGER(CGSIZE_T), INTENT(IN)  :: start
!!$       INTEGER(CGSIZE_T), INTENT(IN)  :: end
!!$       INTEGER(CGSIZE_T) , INTENT(IN) :: elements
!!$       INTEGER, INTENT(OUT) :: ier
!!$     END SUBROUTINE cgp_elements_write_data_f
!!$  END INTERFACE

!!$  INTERFACE
!!$     SUBROUTINE cgp_elements_read_data_f(fn, B, Z, S, start, &
!!$          end, elements, ier) BIND(C, NAME="cgp_elements_read_data_f")
!!$       IMPORT :: cgsize_t
!!$       IMPLICIT NONE
!!$       INTEGER, INTENT(IN) :: fn
!!$       INTEGER, INTENT(IN) :: B
!!$       INTEGER, INTENT(IN) :: Z
!!$       INTEGER, INTENT(IN) :: S
!!$       INTEGER(CGSIZE_T), INTENT(IN) :: start
!!$       INTEGER(CGSIZE_T), INTENT(IN) :: end
!!$       INTEGER(CGSIZE_T) :: elements
!!$       INTEGER, INTENT(OUT) :: ier
!!$     END SUBROUTINE cgp_elements_read_data_f
!!$  END INTERFACE

  INTERFACE
     SUBROUTINE cgp_field_write_f(fn, B, Z, S, TYPE, fieldname, F, ier)! BIND(C, NAME="cgp_field_write_f")
       IMPORT :: cgenum_t, c_char
       IMPLICIT NONE
       INTEGER :: fn
       INTEGER :: B
       INTEGER :: Z
       INTEGER :: S
       INTEGER(cgenum_t) :: type
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: fieldname
       INTEGER :: F
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgp_field_write_f
  END INTERFACE

!!$ INTERFACE
!!$    SUBROUTINE cgp_field_read_data_f( fn, B, Z, S, F, rmin, rmax, void *field_ptr,
!!$     ier) BIND(C, NAME="")
!!$
!!$     INTEGER :: fn
!!$      INTEGER :: B
!!$      INTEGER :: Z
!!$      INTEGER :: S,
!!$     INTEGER :: F, INTEGER(CGSIZE_T) :: rmin, INTEGER(CGSIZE_T) :: rmax, void *field_ptr
!!$          INTEGER, INTENT(OUT) :: ier
!!$           END SUBROUTINE
!!$        END INTERFACE

!!$  INTERFACE
!!$     SUBROUTINE cgp_array_write_f(ArrayName, DataType, DataDimension, DimensionVector, A, ier) !BIND(C, NAME="cgp_array_write_f")
!!$       IMPORT :: cgenum_t, cgsize_t, c_char
!!$       IMPLICIT NONE
!!$       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: ArrayName
!!$       INTEGER(cgenum_t) :: DataType
!!$       INTEGER :: DataDimension
!!$       INTEGER(CGSIZE_T) :: DimensionVector
!!$       INTEGER :: A
!!$       INTEGER, INTENT(OUT) :: ier
!!$     END SUBROUTINE cgp_array_write_f
!!$  END INTERFACE

!!$     INTERFACE
!!$           SUBROUTINE cgp_array_write_data_f(
!!$     A, CGSIZE_T *rmin, CGSIZE_T *rmax, void *data,
!!$     ier) BIND(C, NAME="")
!!$     INTEGER :: A, INTEGER(CGSIZE_T) :: rmin, INTEGER(CGSIZE_T) :: rmax, void *data,
!!$          INTEGER, INTENT(OUT) :: ier
!!$           END SUBROUTINE
!!$        END INTERFACE

!!$     INTERFACE
!!$           SUBROUTINE cgp_array_read_data_f(
!!$     A, CGSIZE_T *rmin, CGSIZE_T *rmax, void *data,
!!$     ier) BIND(C, NAME="")
!!$     INTEGER :: A, INTEGER(CGSIZE_T) :: rmin, INTEGER(CGSIZE_T) :: rmax, void *data,
!!$
!!$          INTEGER, INTENT(OUT) :: ier
!!$           END SUBROUTINE
!!$        END INTERFACE

  INTERFACE
     SUBROUTINE cgp_error_exit_f() BIND(C, NAME="cgp_error_exit_f")
       IMPLICIT NONE
     END SUBROUTINE cgp_error_exit_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cgp_mpi_info_f(pcg_mpi_info_f, ier) BIND(C,NAME='cgp_mpi_info_f')
       IMPORT :: C_INT
       IMPLICIT NONE
       INTEGER(C_INT), INTENT(IN)  :: pcg_mpi_info_f
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgp_mpi_info_f
  END INTERFACE
!!$
!!$     INTERFACE
!!$           SUBROUTINE cgp_coord_multi_read_data_f, CGP_COORD_MULTI_READ_DATA_F)(fn, B, Z, C,
!!$     CGSIZE_T *rmin, CGSIZE_T *rmax,
!!$     void *coordsX, void *coordsY, void *coordsZ, ier) BIND(C, NAME="")
!!$INTEGER :: fn
!!$      INTEGER :: B
!!$      INTEGER :: Z
!!$      INTEGER :: C,
!!$     INTEGER(CGSIZE_T) :: rmin, INTEGER(CGSIZE_T) :: rmax,
!!$     void *coordsX, void *coordsY, void *coordsZ,
!!$          INTEGER, INTENT(OUT) :: ier
!!$           END SUBROUTINE
!!$        END INTERFACE
!!$
!!$
!!$! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
!!$!       cgp_coord_multi_write_data Function                              *
!!$! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
!!$
!!$
!!$     INTERFACE
!!$           SUBROUTINE cgp_coord_multi_write_data_f, CGP_COORD_MULTI_WRITE_DATA_F)(fn, B, Z, C,
!!$                                                 CGSIZE_T *rmin, CGSIZE_T *rmax,
!!$                                                 void *coordsX, void *coordsY, void *coordsZ, ier) BIND(C, NAME="")
!!$INTEGER :: fn
!!$      INTEGER :: B
!!$      INTEGER :: Z
!!$      INTEGER :: C,
!!$                                                 INTEGER(CGSIZE_T) :: rmin, INTEGER(CGSIZE_T) :: rmax,
!!$                                                 void *coordsX, void *coordsY, void *coordsZ
!!$
!!$          INTEGER, INTENT(OUT) :: ier
!!$           END SUBROUTINE
!!$        END INTERFACE
!!$
!!$! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
!!$!       cgp_field_multi_write_data Function                              *
!!$! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
!!$
!!$     INTERFACE
!!$           SUBROUTINE cgp_field_multi_write_data_f(
!!$     fn, B, Z, S,
!!$     F, CGSIZE_T *rmin, CGSIZE_T *rmax, ier, CGSIZE_T *nsets, ...)
!!$     fn, B, Z, S,
!!$     F, INTEGER(CGSIZE_T) :: rmin, INTEGER(CGSIZE_T) :: rmax, ier, INTEGER(CGSIZE_T) :: nsets, ...
!!$
!!$          INTEGER, INTENT(OUT) :: ier
!!$           END SUBROUTINE
!!$        END INTERFACE
!!$! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
!!$!       cgp_field_multi_read_data Function                              *
!!$! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
!!$
!!$     INTERFACE
!!$           SUBROUTINE cgp_field_multi_read_data_f(
!!$     INTEGER :: fn
!!$      INTEGER :: B
!!$      INTEGER :: Z
!!$      INTEGER :: S,
!!$     F, INTEGER(CGSIZE_T) :: rmin, INTEGER(CGSIZE_T) :: rmax, ier, nsets, ...)
!!$
!!$     INTEGER :: fn
!!$      INTEGER :: B
!!$      INTEGER :: Z
!!$      INTEGER :: S,
!!$     INTEGER :: F, INTEGER(CGSIZE_T) :: rmin, INTEGER(CGSIZE_T) :: rmax, ier
!!$      INTEGER :: nsets, ...
!!$          INTEGER, INTENT(OUT) :: ier
!!$           END SUBROUTINE
!!$        END INTERFACE
!!$! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
!!$!        cgp_array_multi_write_data Function                              *
!!$! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
!!$
!!$     INTERFACE
!!$           SUBROUTINE cgp_array_multi_write_data_f(
!!$     fn, A, CGSIZE_T *rmin, CGSIZE_T *rmax,
!!$     ier, nsets, ...)
!!$     INTEGER :: fn
!!$      INTEGER :: A, INTEGER(CGSIZE_T) :: rmin, INTEGER(CGSIZE_T) :: rmax,
!!$     ier
!!$      INTEGER :: nsets, ...
!!$          INTEGER, INTENT(OUT) :: ier
!!$           END SUBROUTINE
!!$        END INTERFACE
!!$
!!$
!!$! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *\
!!$!        cgp_array_multi_read_data Function                              *
!!$! - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
!!$
!!$     INTERFACE
!!$           SUBROUTINE cgp_array_multi_read_data_f(
!!$     fn, A, CGSIZE_T *rmin, CGSIZE_T *rmax,
!!$     ier, nsets, ...)
!!$
!!$     INTEGER :: fn
!!$      INTEGER :: A, INTEGER(CGSIZE_T) :: rmin, INTEGER(CGSIZE_T) :: rmax,
!!$          INTEGER, INTENT(OUT) :: ier
!!$           END SUBROUTINE
!!$        END INTERFACE
!!$
!!$#endif HDF5_HAVE_MULTI_DATASETS
#endif

  !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
  !*      INTERFACES FOR THE C FUNCTIONS                                 *
  !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!!$  INTERFACE
!!$     INTEGER(C_INT) FUNCTION cgp_open(filename, mode, fn) BIND(C, name='cgp_open')
!!$       IMPORT :: c_int, c_char
!!$       IMPLICIT NONE
!!$       CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN)  :: filename
!!$       INTEGER(C_INT), INTENT(IN), VALUE  :: mode
!!$       INTEGER(C_INT), INTENT(OUT) :: fn
!!$     END FUNCTION cgp_open
!!$  END INTERFACE
!!$
!!$  INTERFACE
!!$     INTEGER(C_INT) FUNCTION cgp_pio_mode(mode) BIND(C, name='cgp_pio_mode')
!!$       USE ISO_C_BINDING
!!$       INTEGER(KIND(CGP_COLLECTIVE)), INTENT(IN), VALUE  :: mode
!!$     END FUNCTION cgp_pio_mode
!!$  END INTERFACE
!!$
!!$  INTERFACE
!!$     INTEGER(C_INT) FUNCTION cg_base_write(fn, basename, cell_dim, phys_dim, B) BIND(C, name='cg_base_write')
!!$       USE ISO_C_BINDING
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: fn
!!$       CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN)  :: basename
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE  :: cell_dim
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE  :: phys_dim
!!$       INTEGER(C_INT)   , INTENT(OUT)  :: B
!!$     END FUNCTION cg_base_write
!!$  END INTERFACE
!!$
!!$  INTERFACE
!!$     INTEGER(C_INT) FUNCTION cg_zone_write(fn, B, zonename, nijk, itype, Z) BIND(C, name='cg_zone_write')
!!$       USE ISO_C_BINDING
!!$       IMPORT :: CGSIZE_T
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: fn
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE  :: B
!!$       CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN)  :: zonename
!!$       INTEGER(CGSIZE_T), DIMENSION(*), INTENT(IN)  :: nijk
!!$       INTEGER(KIND(CGP_COLLECTIVE)), INTENT(IN), VALUE  :: itype
!!$       INTEGER(C_INT)   , INTENT(OUT)  :: Z
!!$     END FUNCTION cg_zone_write
!!$  END INTERFACE
!!$
!!$  INTERFACE
!!$     INTEGER(C_INT) FUNCTION cg_base_read(fn, B, basename, cell_dim, phys_dim) BIND(C, name='cg_base_read')
!!$       USE ISO_C_BINDING
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: fn
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: B
!!$       CHARACTER(C_CHAR), DIMENSION(*), INTENT(OUT)  :: basename
!!$       INTEGER(C_INT)   , INTENT(OUT)  :: cell_dim
!!$       INTEGER(C_INT)   , INTENT(OUT)  :: phys_dim
!!$     END FUNCTION cg_base_read
!!$  END INTERFACE
!!$
!!$  INTERFACE
!!$     INTEGER(C_INT) FUNCTION cg_zone_read(fn, B, Z, zonename, nijk) !BIND(C, name='cg_zone_read')
!!$       USE ISO_C_BINDING
!!$       IMPORT :: CGSIZE_T
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: fn
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: B
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: Z
!!$       CHARACTER(C_CHAR), DIMENSION(*), INTENT(OUT)  :: zonename
!!$       INTEGER(CGSIZE_T), DIMENSION(*), INTENT(OUT)  :: nijk
!!$     END FUNCTION cg_zone_read
!!$  END INTERFACE
!!$
!!$  INTERFACE
!!$     INTEGER(C_INT) FUNCTION cgp_coord_write(fn, B, Z, itype, coordname, C) BIND(C, name='cgp_coord_write')
!!$       USE ISO_C_BINDING
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: fn
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: B
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: Z
!!$       INTEGER(KIND(CGP_INDEPENDENT)), INTENT(IN), VALUE :: itype
!!$       CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN)  :: coordname
!!$       INTEGER(C_INT)   , INTENT(OUT)  :: C
!!$     END FUNCTION cgp_coord_write
!!$  END INTERFACE
!!$
!!$  INTERFACE
!!$     INTEGER(C_INT) FUNCTION cgp_coord_write_data(fn, B, Z, C, rmin, rmax, coords) BIND(C, name='cgp_coord_write_data')
!!$       USE ISO_C_BINDING
!!$       IMPORT :: CGSIZE_T
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: fn
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: B
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: Z
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: C
!!$       INTEGER(CGSIZE_T), INTENT(IN) :: rmin
!!$       INTEGER(CGSIZE_T), INTENT(IN) :: rmax
!!$       TYPE(C_PTR), VALUE :: coords
!!$     END FUNCTION cgp_coord_write_data
!!$  END INTERFACE
!!$
!!$  INTERFACE
!!$     INTEGER(C_INT) FUNCTION cgp_field_write(fn, B, Z, S, itype, fieldname, F) BIND(C, name='cgp_field_write')
!!$       USE ISO_C_BINDING
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: fn
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: B
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: Z
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: S
!!$       INTEGER(KIND(CGP_INDEPENDENT)), INTENT(IN), VALUE :: itype
!!$       CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN)  :: fieldname
!!$       INTEGER(C_INT)   , INTENT(OUT)  :: F
!!$     END FUNCTION cgp_field_write
!!$  END INTERFACE
!!$
!!$  INTERFACE
!!$     INTEGER(C_INT) FUNCTION cgp_field_write_data(fn, B, Z, S, F, rmin, rmax, data) BIND(C, name='cgp_field_write_data')
!!$       USE ISO_C_BINDING
!!$       IMPORT :: CGSIZE_T
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: fn
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: B
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: Z
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: S
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: F
!!$       INTEGER(CGSIZE_T), INTENT(IN) :: rmin
!!$       INTEGER(CGSIZE_T), INTENT(IN) :: rmax
!!$       TYPE(C_PTR), VALUE :: data
!!$     END FUNCTION cgp_field_write_data
!!$  END INTERFACE
!!$
!!$  INTERFACE
!!$     INTEGER(C_INT) FUNCTION cgp_field_read_data(fn, B, Z, S, F, rmin, rmax, data) BIND(C, name='cgp_field_read_data')
!!$       USE ISO_C_BINDING
!!$       IMPORT :: CGSIZE_T
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: fn
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: B
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: Z
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: S
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: F
!!$       INTEGER(CGSIZE_T), INTENT(IN) :: rmin
!!$       INTEGER(CGSIZE_T), INTENT(IN) :: rmax
!!$       TYPE(C_PTR), VALUE :: data
!!$     END FUNCTION cgp_field_read_data
!!$  END INTERFACE
!!$
!!$  INTERFACE
!!$     INTEGER(C_INT) FUNCTION cgp_coord_read_data(fn, B, Z, C, rmin, rmax, coords) BIND(C, name='cgp_coord_read_data')
!!$       USE ISO_C_BINDING
!!$       IMPORT :: CGSIZE_T
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: fn
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: B
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: Z
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: C
!!$       INTEGER(CGSIZE_T), INTENT(IN) :: rmin
!!$       INTEGER(CGSIZE_T), INTENT(IN) :: rmax
!!$       TYPE(C_PTR), VALUE :: coords
!!$     END FUNCTION cgp_coord_read_data
!!$  END INTERFACE
!!$
!!$  INTERFACE
!!$     INTEGER(C_INT) FUNCTION cgp_section_write(fn,B,Z,sectionname,itype,start,end,nbndry,S) BIND(C, name='cgp_section_write')
!!$       USE ISO_C_BINDING
!!$       IMPORT :: CGSIZE_T
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: fn
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: B
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: Z
!!$       CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN)  :: sectionname
!!$       INTEGER(KIND(CGP_INDEPENDENT)), INTENT(IN), VALUE :: itype
!!$       INTEGER(CGSIZE_T), INTENT(IN), VALUE :: start
!!$       INTEGER(CGSIZE_T), INTENT(IN), VALUE :: end
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: nbndry
!!$       INTEGER(C_INT)   , INTENT(OUT) :: S
!!$     END FUNCTION cgp_section_write
!!$  END INTERFACE
!!$
!!$  INTERFACE
!!$     INTEGER(C_INT) FUNCTION cgp_array_write(arrayname,itype,DataDimension,DimensionVector,A) BIND(C, name='cgp_array_write')
!!$       USE ISO_C_BINDING
!!$       IMPORT :: CGSIZE_T
!!$       CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN)  :: arrayname
!!$       INTEGER(KIND(CGP_INDEPENDENT)), INTENT(IN), VALUE :: itype
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: DataDimension
!!$       INTEGER(CGSIZE_T), DIMENSION(1:DataDimension), INTENT(IN) :: DimensionVector
!!$       INTEGER(C_INT)   , INTENT(OUT) :: A
!!$     END FUNCTION cgp_array_write
!!$  END INTERFACE
!!$
!!$  INTERFACE
!!$     INTEGER(C_INT) FUNCTION cgp_array_write_data(A, rmin, rmax, data) BIND(C, name='cgp_array_write_data')
!!$       USE ISO_C_BINDING
!!$       IMPORT :: CGSIZE_T
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: A
!!$       INTEGER(CGSIZE_T), INTENT(IN) :: rmin
!!$       INTEGER(CGSIZE_T), INTENT(IN) :: rmax
!!$       TYPE(C_PTR), VALUE :: data
!!$     END FUNCTION cgp_array_write_data
!!$  END INTERFACE
!!$
!!$  INTERFACE
!!$     INTEGER(C_INT) FUNCTION cgp_elements_write_data(fn,B,Z,S,emin,emax,elements) BIND(C, name='cgp_elements_write_data')
!!$       USE ISO_C_BINDING
!!$       IMPORT :: CGSIZE_T
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: fn
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: B
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: Z
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: S
!!$       INTEGER(CGSIZE_T), INTENT(IN), VALUE :: emin
!!$       INTEGER(CGSIZE_T), INTENT(IN), VALUE :: emax
!!$       TYPE(C_PTR), VALUE :: elements
!!$     END FUNCTION cgp_elements_write_data
!!$  END INTERFACE
!!$
!!$  INTERFACE
!!$     INTEGER(C_INT) FUNCTION cgp_elements_read_data(fn,B,Z,S,start,end,elements) BIND(C, name='cgp_elements_read_data')
!!$       USE ISO_C_BINDING
!!$       IMPORT :: CGSIZE_T
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: fn
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: B
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: Z
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: S
!!$       INTEGER(CGSIZE_T), INTENT(IN), VALUE :: start
!!$       INTEGER(CGSIZE_T), INTENT(IN), VALUE :: end
!!$       TYPE(C_PTR), VALUE :: elements
!!$     END FUNCTION cgp_elements_read_data
!!$  END INTERFACE
!!$
!!$  INTERFACE
!!$     INTEGER(C_INT) FUNCTION cgp_array_read_data(A, rmin, rmax, data) BIND(C, name='cgp_array_read_data')
!!$       USE ISO_C_BINDING
!!$       IMPORT :: CGSIZE_T
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: A
!!$       INTEGER(CGSIZE_T), INTENT(IN) :: rmin
!!$       INTEGER(CGSIZE_T), INTENT(IN) :: rmax
!!$       TYPE(C_PTR), VALUE :: data
!!$     END FUNCTION cgp_array_read_data
!!$  END INTERFACE
!!$
!!$  INTERFACE
!!$     INTEGER(C_INT) FUNCTION cg_sol_write(fn,B,Z,solname,location,S) BIND(C, name='cg_sol_write')
!!$       USE ISO_C_BINDING
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: fn
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: B
!!$       INTEGER(C_INT)   , INTENT(IN), VALUE :: Z
!!$       CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN) :: solname
!!$       INTEGER(KIND(CGP_INDEPENDENT)), INTENT(IN), VALUE :: location
!!$       INTEGER(C_INT)   , INTENT(OUT) :: S
!!$     END FUNCTION cg_sol_write
!!$  END INTERFACE
!!$
!!$  INTERFACE
!!$     INTEGER(C_INT) FUNCTION cgp_error_exit() BIND(C, name='cgp_error_exit')
!!$       USE ISO_C_BINDING
!!$     END FUNCTION cgp_error_exit
!!$  END INTERFACE
!!$
!!$  INTERFACE
!!$     INTEGER(C_INT) FUNCTION cgp_close(fn) BIND(C, name='cgp_close')
!!$       USE ISO_C_BINDING
!!$       INTEGER(C_INT), INTENT(IN), VALUE :: fn
!!$     END FUNCTION cgp_close
!!$  END INTERFACE
!!$
!!$  INTERFACE
!!$     INTEGER(C_INT) FUNCTION cgp_queue_set(use_queue) BIND(C, name='cgp_queue_set')
!!$       USE ISO_C_BINDING
!!$       INTEGER(C_INT), INTENT(IN), VALUE :: use_queue
!!$     END FUNCTION cgp_queue_set
!!$  END INTERFACE
!!$
!!$  INTERFACE
!!$     INTEGER(C_INT) FUNCTION cgp_queue_flush() BIND(C, name='cgp_queue_flush')
!!$       USE ISO_C_BINDING
!!$     END FUNCTION cgp_queue_flush
!!$  END INTERFACE
!!$
!!$  INTERFACE
!!$     INTEGER(C_INT) FUNCTION cg_user_data_write(UserDataName) BIND(C, name='cg_user_data_write')
!!$       USE ISO_C_BINDING
!!$       CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN) :: UserDataName
!!$     END FUNCTION cg_user_data_write
!!$  END INTERFACE

#if HAVE_FORTRAN_2008TS
  ! THE FOLLOWING CODE ONLY WORKS FOR COMPILERS HAVING F2008 STANDARD EXTENSION:
  ! TS 29113 Further Interoperability of FORTRAN with C WG5/N1942

  ! The number of optional parameters should be set to
  ! CG_MAX_GOTO_DEPTH, which is currently set to 20.
  INTERFACE
     INTEGER(C_INT) FUNCTION cg_gorel(fn, &
          UserDataName1, i1, UserDataName2, i2, &
          UserDataName3, i3, UserDataName4, i4, &
          UserDataName5, i5, UserDataName6, i6, &
          UserDataName7, i7, UserDataName8, i8, &
          UserDataName9, i9, UserDataName10, i10, &
          UserDataName11, i11, UserDataName12, i12, &
          UserDataName13, i13, UserDataName14, i14, &
          UserDataName15, i15, UserDataName16, i16, &
          UserDataName17, i17, UserDataName18, i18, &
          UserDataName19, i19, UserDataName20, i20, &
          end) BIND(C, name='cg_gorel_f08')

       USE ISO_C_BINDING
       INTEGER(C_INT) , INTENT(IN), VALUE :: fn
       CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN), OPTIONAL :: UserDataName1,UserDataName2, &
            UserDataName3,UserDataName4,UserDataName5,UserDataName6,UserDataName7,UserDataName8, &
            UserDataName9,UserDataName10,UserDataName11,UserDataName12,UserDataName13,UserDataName14, &
            UserDataName15,UserDataName16,UserDataName17,UserDataName18,UserDataName19,UserDataName20

       INTEGER(C_INT), INTENT(IN), OPTIONAL :: i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14,i15,i16, &
            i17, i18, i19, i20
       CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN), OPTIONAL :: end
     END FUNCTION cg_gorel
  END INTERFACE

  ! The number of optional parameters should be set to
  ! CG_MAX_GOTO_DEPTH, which is currently set to 20.

  INTERFACE
     INTEGER(C_INT) FUNCTION cg_goto(fn, B, &
          UserDataName1, i1, UserDataName2, i2, &
          UserDataName3, i3, UserDataName4, i4, &
          UserDataName5, i5, UserDataName6, i6, &
          UserDataName7, i7, UserDataName8, i8, &
          UserDataName9, i9, UserDataName10, i10, &
          UserDataName11, i11, UserDataName12, i12, &
          UserDataName13, i13, UserDataName14, i14, &
          UserDataName15, i15, UserDataName16, i16, &
          UserDataName17, i17, UserDataName18, i18, &
          UserDataName19, i19, UserDataName20, i20, &
          end) BIND(C, name='cg_goto_f08')

       USE ISO_C_BINDING
       INTEGER(C_INT) , INTENT(IN), VALUE :: fn
       INTEGER(C_INT) , INTENT(IN), VALUE :: B
       CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN), OPTIONAL :: UserDataName1,UserDataName2, &
            UserDataName3,UserDataName4,UserDataName5,UserDataName6,UserDataName7,UserDataName8, &
            UserDataName9,UserDataName10,UserDataName11,UserDataName12,UserDataName13,UserDataName14, &
            UserDataName15,UserDataName16,UserDataName17,UserDataName18,UserDataName19,UserDataName20
       INTEGER(C_INT), INTENT(IN), OPTIONAL :: i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14,i15,i16, &
            i17, i18, i19, i20
       CHARACTER(C_CHAR), DIMENSION(*), INTENT(IN), OPTIONAL :: end
     END FUNCTION cg_goto
  END INTERFACE

#endif
  INTERFACE
     SUBROUTINE cg_open_f(filename, mode, fn, ier)
       IMPORT :: C_CHAR, C_INT
       IMPLICIT NONE
       CHARACTER(KIND=C_CHAR), DIMENSION(*), INTENT(IN) :: filename
       INTEGER(C_INT), INTENT(IN) :: mode
       INTEGER, INTENT(OUT) :: fn
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_open_f
  END INTERFACE

  INTERFACE
     SUBROUTINE cg_is_cgns_f(filename, file_type, ier)
        IMPORT :: C_CHAR
        IMPLICIT NONE
        CHARACTER(KIND=C_CHAR), DIMENSION(*), INTENT(IN) :: filename
        INTEGER, INTENT(OUT) :: file_type
        INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cg_is_cgns_f
  END INTERFACE

  INTERFACE cg_get_type
     MODULE PROCEDURE cg_get_type_c_int
     MODULE PROCEDURE cg_get_type_c_long_long
     MODULE PROCEDURE cg_get_type_c_float
     MODULE PROCEDURE cg_get_type_c_double
  END INTERFACE

!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *
!*      INTERFACES FOR THE CGIO FORTRAN FUNCTIONS                      *
!* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *

!*=========================================================
!* paths for searching for linked-to files
!*=========================================================

  INTERFACE
     SUBROUTINE cgio_path_add_f(path, ier) ! BIND(C,NAME='cgio_path_add_f')
       IMPORT :: c_char
       IMPLICIT NONE
       CHARACTER(KIND=C_CHAR), DIMENSION(*), INTENT(IN) :: path
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_path_add_f
  END INTERFACE

!*---------------------------------------------------------
  INTERFACE
     SUBROUTINE cgio_path_delete_f(path, ier) ! BIND(C,NAME='cgio_path_delete_f')
       IMPORT :: c_char
       IMPLICIT NONE
       CHARACTER(KIND=C_CHAR), DIMENSION(*), INTENT(IN) :: path
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_path_delete_f
    END INTERFACE

!*=========================================================
!* utility routines independent of open files
!*=========================================================
    INTERFACE
       SUBROUTINE cgio_is_supported_f(file_type, ier) BIND(C,NAME='cgio_is_supported_f')
         IMPORT :: CGSIZE_T
         IMPLICIT NONE
         INTEGER(CGSIZE_T) :: file_type
         INTEGER, INTENT(OUT) :: ier
       END SUBROUTINE cgio_is_supported_f
    END INTERFACE

!*---------------------------------------------------------
  INTERFACE
     SUBROUTINE cgio_check_file_f(filename, file_type, ier) !BIND(C,NAME='cgio_check_file_f')
       IMPORT :: c_char
       IMPLICIT NONE
       CHARACTER(KIND=C_CHAR), DIMENSION(*), INTENT(IN) :: filename
       INTEGER :: file_type
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_check_file_f
  END INTERFACE

!*=========================================================
!* file operations
!*=========================================================
  INTERFACE
     SUBROUTINE cgio_open_file_f(filename, file_mode, file_type, cgio_num, ier) ! BIND(C,NAME='cgio_open_file_f')
       IMPORT :: c_char
       IMPLICIT NONE
       CHARACTER(KIND=C_CHAR), DIMENSION(*), INTENT(IN) :: filename
       INTEGER :: file_mode
       INTEGER :: file_type
       INTEGER :: cgio_num
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_open_file_f
  END INTERFACE

  !*---------------------------------------------------------
  INTERFACE
     SUBROUTINE cgio_close_file_f(cgio_num, ier) BIND(C,NAME='cgio_close_file_f')
       IMPLICIT NONE
       INTEGER :: cgio_num
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_close_file_f
  END INTERFACE

  !*---------------------------------------------------------
  INTERFACE
     SUBROUTINE cgio_flush_to_disk_f(cgio_num, ier) BIND(C,NAME='cgio_flush_to_disk_f')
       IMPLICIT NONE
       INTEGER :: cgio_num
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_flush_to_disk_f
  END INTERFACE

!*=========================================================
!* file information
!*=========================================================
  INTERFACE
     SUBROUTINE cgio_library_version_f(cgio_num, version, ier) ! BIND(C,NAME='cgio_library_version_f')
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: cgio_num
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: version
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_library_version_f
  END INTERFACE

!*---------------------------------------------------------
  INTERFACE
     SUBROUTINE cgio_file_version_f(cgio_num, file_version, creation_date, modified_date, ier) ! BIND(C,NAME='cgio_file_version_f')
       IMPORT :: c_char
       IMPLICIT NONE
       INTEGER :: cgio_num
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: file_version
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: creation_date
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: modified_date
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE
  END INTERFACE

!*---------------------------------------------------------
  INTERFACE
     SUBROUTINE cgio_get_root_id_f(cgio_num, rootid, ier) BIND(C,NAME='cgio_get_root_id_f')
       IMPORT :: c_double
       IMPLICIT NONE
       INTEGER :: cgio_num
       REAL(c_double) :: rootid
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_get_root_id_f
  END INTERFACE

!*---------------------------------------------------------
  INTERFACE
     SUBROUTINE cgio_get_file_type_f(cgio_num, file_type, ier) BIND(C,NAME='cgio_get_file_type_f')
       IMPLICIT NONE
       INTEGER :: cgio_num
       INTEGER :: file_type
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_get_file_type_f
  END INTERFACE

!*=========================================================
!* error handling
!*=========================================================
  INTERFACE
     SUBROUTINE cgio_error_code_f(errcode, file_type) BIND(C,NAME='cgio_error_code_f')
       IMPLICIT NONE
       INTEGER :: errcode
       INTEGER :: file_type
     END SUBROUTINE cgio_error_code_f
  END INTERFACE

!*---------------------------------------------------------
  INTERFACE
     SUBROUTINE cgio_error_message_f(errmsg, ier) ! BIND(C,NAME='cgio_error_message_f')
       IMPORT :: c_char
       IMPLICIT NONE
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: errmsg
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_error_message_f
  END INTERFACE

!*---------------------------------------------------------
  INTERFACE
     SUBROUTINE cgio_error_exit_f(errmsg) ! BIND(C,NAME='cgio_error_exit_f')
       IMPORT :: c_char
       IMPLICIT NONE
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: errmsg
     END SUBROUTINE cgio_error_exit_f
  END INTERFACE

!*---------------------------------------------------------
  INTERFACE
     SUBROUTINE cgio_error_abort_f(abort_flag) BIND(C,NAME='cgio_error_abort_f')
       IMPLICIT NONE
       INTEGER :: abort_flag
     END SUBROUTINE cgio_error_abort_f
  END INTERFACE

!*=========================================================
!* basic node operations
!*=========================================================
  INTERFACE
     SUBROUTINE cgio_create_node_f(cgio_num, pid, name, id, ier) ! BIND(C,NAME='cgio_create_node_f')
       IMPORT :: c_char, c_double
       IMPLICIT NONE
       INTEGER :: cgio_num
       REAL(C_DOUBLE) :: pid
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: name
       REAL(C_DOUBLE) :: id
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_create_node_f
  END INTERFACE

!*---------------------------------------------------------
!!$  INTERFACE
!!$     SUBROUTINE cgio_new_node_f(cgio_num, pid, name, label, data_type, ndims, dims, DATA, id, ier) BIND(C,NAME='')
!!$       IMPORT :: c_char, c_double
!!$       IMPLICIT NONE
!!$       INTEGER :: cgio_num
!!$       REAL(C_DOUBLE) :: pid
!!$       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: name
!!$       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: label
!!$       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: data_type
!!$       INTEGER :: ndims
!!$       INTEGER(CGSIZE_T), DIMENSION(*) :: dims
!!$       TYPE(C_PTR) ::  DATA
!!$       REAL(C_DOUBLE) :: id
!!$       INTEGER, INTENT(OUT) :: ier
!!$     END SUBROUTINE cgio_new_node_f
!!$  END INTERFACE

!*---------------------------------------------------------
  INTERFACE
     SUBROUTINE cgio_delete_node_f(cgio_num, pid, id, ier) BIND(C,NAME='cgio_delete_node_f')
       IMPORT :: c_double
       IMPLICIT NONE
       INTEGER :: cgio_num
       REAL(C_DOUBLE) :: pid
       REAL(C_DOUBLE) :: id
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_delete_node_f
  END INTERFACE

!*---------------------------------------------------------
  INTERFACE
     SUBROUTINE cgio_move_node_f(cgio_num, pid, id, npid, ier) BIND(C,NAME='cgio_move_node_f')
       IMPORT :: c_double
       IMPLICIT NONE
       INTEGER :: cgio_num
       REAL(C_DOUBLE) :: pid
       REAL(C_DOUBLE) :: id
       REAL(C_DOUBLE) :: npid
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_move_node_f
  END INTERFACE

!*---------------------------------------------------------
  INTERFACE
     SUBROUTINE cgio_release_id_f(cgio_num, id, ier) BIND(C,NAME='cgio_release_id_f')
       IMPORT :: c_double
       IMPLICIT NONE
       INTEGER :: cgio_num
       REAL(C_DOUBLE) :: id
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_release_id_f
  END INTERFACE

!*=========================================================
!* links
!*=========================================================
  INTERFACE
     SUBROUTINE cgio_is_link_f(cgio_num, id, link_len, ier) BIND(C,NAME='cgio_is_link_f')
       IMPORT :: c_double
       IMPLICIT NONE
       INTEGER :: cgio_num
       REAL(C_DOUBLE) :: id
       INTEGER :: link_len
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_is_link_f
  END INTERFACE

!*---------------------------------------------------------
  INTERFACE
     SUBROUTINE cgio_link_size_f(cgio_num, id, file_len, name_len, ier) BIND(C,NAME='cgio_link_size_f')
       IMPORT :: c_double
       IMPLICIT NONE
       INTEGER :: cgio_num
       REAL(C_DOUBLE) :: id
       INTEGER :: file_len
       INTEGER :: name_len
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_link_size_f
  END INTERFACE

!*---------------------------------------------------------
  INTERFACE
     SUBROUTINE cgio_create_link_f(cgio_num, pid, name, filename, name_in_file, id, ier) ! BIND(C,NAME='cgio_create_link_f')
       IMPORT :: c_char, c_double
       IMPLICIT NONE
       INTEGER :: cgio_num
       REAL(C_DOUBLE) :: pid
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: name
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: filename
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: name_in_file
       REAL(C_DOUBLE) :: id
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_create_link_f
  END INTERFACE

!*---------------------------------------------------------
  INTERFACE
     SUBROUTINE cgio_get_link_f(cgio_num, id, filename, name_in_file, ier) ! BIND(C,NAME='cgio_get_link_f')
       IMPORT :: c_char, c_double
       IMPLICIT NONE
       INTEGER :: cgio_num
       REAL(C_DOUBLE) :: id
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: filename
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: name_in_file
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_get_link_f
  END INTERFACE

!*=========================================================
!* node children
!*=========================================================
  INTERFACE
     SUBROUTINE cgio_number_children_f(cgio_num, pid, num_children, ier) BIND(C,NAME='cgio_number_children_f')
       IMPORT :: c_double
       IMPLICIT NONE
       INTEGER :: cgio_num
       REAL(C_DOUBLE) :: pid
       INTEGER :: num_children
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_number_children_f
  END INTERFACE

!*---------------------------------------------------------
  INTERFACE
     SUBROUTINE cgio_children_ids_f(cgio_num, pid, start, max_ret, num_ret, ids, ier) BIND(C,NAME='cgio_children_ids_f')
       IMPORT :: c_double
       IMPLICIT NONE
       INTEGER :: cgio_num
       REAL(C_DOUBLE) :: pid
       INTEGER :: start
       INTEGER :: max_ret
       INTEGER :: num_ret
       REAL(C_DOUBLE) :: ids
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_children_ids_f
  END INTERFACE

!*---------------------------------------------------------
  INTERFACE
     SUBROUTINE cgio_children_names_f(cgio_num, pid, start, max_ret, name_len, num_ret, names, ier)!BIND(C,NAME='cgio_children_names_f')
       IMPORT :: c_char, c_double
       IMPLICIT NONE
       INTEGER :: cgio_num
       REAL(C_DOUBLE) :: pid
       INTEGER :: start
       INTEGER :: max_ret
       INTEGER :: name_len
       INTEGER :: num_ret
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: names
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_children_names_f
  END INTERFACE

!*=========================================================
!* read nodes
!*=========================================================
  INTERFACE
     SUBROUTINE cgio_get_node_id_f(cgio_num, pid, name, id, ier) !BIND(C,NAME='cgio_get_node_id_f')
       IMPORT :: c_char, c_double
       IMPLICIT NONE
       INTEGER :: cgio_num
       REAL(C_DOUBLE) :: pid
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: name
       REAL(C_DOUBLE) :: id
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_get_node_id_f
  END INTERFACE

!*---------------------------------------------------------
  INTERFACE
     SUBROUTINE cgio_get_name_f(cgio_num, id, name, ier) !BIND(C,NAME='cgio_get_name_f')
       IMPORT :: c_char, c_double
       IMPLICIT NONE
       INTEGER :: cgio_num
       REAL(C_DOUBLE) :: id
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: name
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_get_name_f
  END INTERFACE

!*---------------------------------------------------------
  INTERFACE
     SUBROUTINE cgio_get_label_f(cgio_num, id, label, ier) !BIND(C,NAME='cgio_get_label_f')
       IMPORT :: c_char, c_double
       IMPLICIT NONE
       INTEGER :: cgio_num
       REAL(C_DOUBLE) :: id
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: label
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_get_label_f
  END INTERFACE

!*---------------------------------------------------------
  INTERFACE
     SUBROUTINE cgio_get_data_type_f(cgio_num, id, data_type, ier) !BIND(C,NAME='cgio_get_data_type_f')
       IMPORT :: c_char, c_double
       IMPLICIT NONE
       INTEGER :: cgio_num
       REAL(C_DOUBLE) :: id
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: data_type
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_get_data_type_f
  END INTERFACE

!*---------------------------------------------------------
  INTERFACE
     SUBROUTINE cgio_get_data_size_f(cgio_num, id, size, ier) BIND(C,NAME='cgio_get_data_size_f')
       IMPORT :: c_double, cgsize_t
       IMPLICIT NONE
       INTEGER :: cgio_num
       REAL(C_DOUBLE) :: id
       INTEGER(CGSIZE_T) :: size
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_get_data_size_f
  END INTERFACE

!*---------------------------------------------------------


!*---------------------------------------------------------
!!$  INTERFACE
!!$     SUBROUTINE cgio_read_all_data_f(cgio_num, id, DATA, ier) BIND(C,NAME='')
!!$       IMPORT :: c_double, cgsize_t
!!$       IMPLICIT NONE
!!$       INTEGER :: cgio_num
!!$       REAL(C_DOUBLE) :: id
!!$       TYPE(C_PTR) :: data
!!$       INTEGER, INTENT(OUT) :: ier
!!$     END SUBROUTINE cgio_read_all_data_f
!!$  END INTERFACE

!*---------------------------------------------------------
!!$  INTERFACE
!!$     SUBROUTINE cgio_read_block_data_f(cgio_num, id, b_start, b_end, DATA, ier) BIND(C,NAME='')
!!$       IMPORT :: c_double, cgsize_t, C_PTR
!!$       IMPLICIT NONE
!!$       INTEGER :: cgio_num
!!$       REAL(C_DOUBLE) :: id
!!$       INTEGER(CGSIZE_T) :: b_start
!!$       INTEGER(CGSIZE_T) :: b_end
!!$       TYPE(C_PTR) :: data
!!$       INTEGER, INTENT(OUT) :: ier
!!$     END SUBROUTINE cgio_read_block_data_f
!!$  END INTERFACE

!*---------------------------------------------------------
!!$  INTERFACE
!!$     SUBROUTINE cgio_read_data_f(
!!$    cgint_f *cgio_num, double *id, cgsize_t *s_start, cgsize_t *s_end,
!!$    cgsize_t *s_stride, cgint_f *m_ndims, cgsize_t *m_dims, cgsize_t *m_start,
!!$    cgsize_t *m_end, cgsize_t *m_stride, void *data, cgint_f *ier) BIND(C,NAME='')
!!$    END INTERFACE

!*=========================================================
!* write nodes
!*=========================================================
  INTERFACE
     SUBROUTINE cgio_set_name_f(cgio_num, pid, id, name, ier) !BIND(C,NAME='cgio_set_name_f')
       IMPORT :: c_char, c_double
       IMPLICIT NONE
       INTEGER :: cgio_num
       REAL(C_DOUBLE) :: pid
       REAL(C_DOUBLE) :: id
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: name
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_set_name_f
  END INTERFACE

!*---------------------------------------------------------
  INTERFACE
     SUBROUTINE cgio_set_label_f(cgio_num, id, label, ier) !BIND(C,NAME='cgio_set_label_f')
       IMPORT :: c_char, c_double
       IMPLICIT NONE
       INTEGER :: cgio_num
       REAL(C_DOUBLE) :: id
       CHARACTER(KIND=C_CHAR), DIMENSION(*) :: label
       INTEGER, INTENT(OUT) :: ier
     END SUBROUTINE cgio_set_label_f
  END INTERFACE


!*---------------------------------------------------------
!!$  INTERFACE
!!$     SUBROUTINE cgio_write_all_data_f(
!!$    cgint_f *cgio_num, double *id, void *data, cgint_f *ier) BIND(C,NAME='')
!!$    END INTERFACE

!*---------------------------------------------------------
!!$  INTERFACE
!!$     SUBROUTINE cgio_write_block_data_f(
!!$    cgint_f *cgio_num, double *id, cgsize_t *b_start, cgsize_t *b_end,
!!$    void *data, cgint_f *ier) BIND(C,NAME='')
!!$
!!$    END INTERFACE

!*---------------------------------------------------------
!!$  INTERFACE
!!$     SUBROUTINE cgio_write_data_f(
!!$    cgint_f *cgio_num, double *id, cgsize_t *s_start, cgsize_t *s_end,
!!$    cgsize_t *s_stride, cgsize_t *m_ndims, cgsize_t *m_dims, cgsize_t *m_start,
!!$    cgsize_t *m_end, cgsize_t *m_stride, void *data, cgint_f *ier) BIND(C,NAME='')
!!$
!!$    END INTERFACE



CONTAINS

  FUNCTION cg_get_type_c_int(a)
    USE ISO_C_BINDING
    INTEGER(C_INT) :: a
    INTEGER(KIND(CGNS_ENUMV(Integer))) :: cg_get_type_c_int
    cg_get_type_c_int = CGNS_ENUMV(Integer)
  END FUNCTION cg_get_type_c_int

  FUNCTION cg_get_type_c_long_long(a)
    USE ISO_C_BINDING
    INTEGER(C_LONG_LONG) :: a
    INTEGER(KIND(CGNS_ENUMV(Longinteger))) :: cg_get_type_c_long_long
    cg_get_type_c_long_long = CGNS_ENUMV(LongInteger)
  END FUNCTION cg_get_type_c_long_long

  FUNCTION cg_get_type_c_float(a)
    USE ISO_C_BINDING
    REAL(C_FLOAT) :: a
    INTEGER(KIND(CGNS_ENUMV(RealSingle))) :: cg_get_type_c_float
    cg_get_type_c_float = CGNS_ENUMV(RealSingle)
  END FUNCTION cg_get_type_c_float

  FUNCTION cg_get_type_c_double(a)
    USE ISO_C_BINDING
    REAL(C_DOUBLE) :: a
    INTEGER(KIND(CGNS_ENUMV(RealDouble))) :: cg_get_type_c_double
    cg_get_type_c_double = CGNS_ENUMV(RealDouble)
  END FUNCTION cg_get_type_c_double

!  These have issues when using xlf and the calling
!  program does not use the modules, CGNS-25
!  SUBROUTINE cg_is_cgns_f(filename, file_type, ier) BIND(C,NAME='')
!    USE ISO_C_BINDING
!    IMPLICIT NONE
!    CHARACTER(KIND=C_CHAR, LEN=*), INTENT(IN) :: filename
!    INTEGER, INTENT(OUT) :: file_type
!    INTEGER, INTENT(OUT) :: ier
!
!    ier = cg_is_cgns(TRIM(filename)//C_NULL_CHAR, file_type)
!
!  END SUBROUTINE cg_is_cgns_f
!
!  SUBROUTINE cg_open_f(filename, mode, fn, ier) BIND(C,NAME='')
!    USE ISO_C_BINDING
!    IMPLICIT NONE
!    CHARACTER(KIND=C_CHAR, LEN=*), INTENT(IN) :: filename
!    INTEGER(C_INT), INTENT(IN) :: mode
!    INTEGER, INTENT(OUT) :: fn
!    INTEGER, INTENT(OUT) :: ier
!
!    ier = cg_open(TRIM(filename)//C_NULL_CHAR, mode, fn)
!
!  END SUBROUTINE cg_open_f

  SUBROUTINE cgio_set_dimensions_f_0(cgio_num, id, data_type, ndims, dims, ier)
    IMPLICIT NONE
    INTEGER :: cgio_num
    REAL(C_DOUBLE) :: id
    CHARACTER(KIND=C_CHAR, LEN=*) :: data_type
    INTEGER :: ndims
    INTEGER(CGSIZE_T) :: dims
    INTEGER, INTENT(OUT) :: ier

    CALL cgio_set_dimensions_f_c(cgio_num, id, data_type, ndims, dims, ier)

  END SUBROUTINE cgio_set_dimensions_f_0

  SUBROUTINE cgio_set_dimensions_f_1(cgio_num, id, data_type, ndims, dims, ier)
    IMPLICIT NONE
    INTEGER :: cgio_num
    REAL(C_DOUBLE) :: id
    CHARACTER(KIND=C_CHAR, LEN=*) :: data_type
    INTEGER :: ndims
    INTEGER(CGSIZE_T), DIMENSION(*) :: dims
    INTEGER, INTENT(OUT) :: ier

    CALL cgio_set_dimensions_f_c(cgio_num, id, data_type, ndims, dims, ier)

  END SUBROUTINE cgio_set_dimensions_f_1

  SUBROUTINE cgio_get_dimensions_f_0(cgio_num, id, ndims, dims, ier)
    IMPLICIT NONE
    INTEGER :: cgio_num
    REAL(C_DOUBLE) :: id
    INTEGER :: ndims
    INTEGER(CGSIZE_T) :: dims
    INTEGER, INTENT(OUT) :: ier

    CALL cgio_get_dimensions_f_c(cgio_num, id, ndims, dims, ier)

  END SUBROUTINE cgio_get_dimensions_f_0

  SUBROUTINE cgio_get_dimensions_f_1(cgio_num, id, ndims, dims, ier)
    IMPLICIT NONE
    INTEGER :: cgio_num
    REAL(C_DOUBLE) :: id
    INTEGER :: ndims
    INTEGER(CGSIZE_T), DIMENSION(*) :: dims
    INTEGER, INTENT(OUT) :: ier

    CALL cgio_get_dimensions_f_c(cgio_num, id, ndims, dims, ier)

  END SUBROUTINE cgio_get_dimensions_f_1

END MODULE cgns

      program cgzconn

#include "cgnstypes_f03.h"
#ifdef WINNT
      include 'cgnswin_f.h'
#endif
      USE CGNS
      IMPLICIT NONE

      INTEGER, PARAMETER :: sp = KIND(1.0)

      INTEGER ierr, cgfile, cgbase, cgzone, cgcoord, cgconn
      INTEGER dim
      INTEGER nzconn, nconn
      INTEGER n1to1, cgz1, cgz2
      INTEGER(cgsize_t) i, j, k, n, size(9)
      INTEGER transform(3)
      INTEGER(cgsize_t) ptlist(125)
      INTEGER(cgsize_t) ptrange(6)
      INTEGER(cgsize_t) npts
      INTEGER(cgenum_t) loc, type,  ptype, dztype, dptype, ddtype
      INTEGER(cgsize_t) dnpts
      real(kind=sp) x(125), y(125), z(125), exp(5)
      character(len=32) zname, dname, cname

! open and write base
      dim = 3
      call cg_open_f('cgzconn.cgns', CG_MODE_WRITE, cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_base_write_f(cgfile, 'Base', dim, dim, cgbase, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

! create some bogus data
      do n=1,3
        size(n)   = 5
        size(n+3) = 4
        size(n+6) = 0
      enddo
      n = 0
      do k=1,5
        do j=1,5
          do i=1,5
            n = n + 1
            x(n) = i
            y(n) = j
            z(n) = k
          enddo
        enddo
      enddo
      do n=1,3
        ptrange(n) = 1
        ptrange(n+3) = 5
        transform(n) = n
      enddo
      ptrange(4) = 1
      n = 0
      do j=1,5
        do i=1,5
          n = n + 1
          ptlist(n) = i
          n = n + 1
          ptlist(n) = j
          n = n + 1
          ptlist(n) = 1
        enddo
      enddo
      do n=1,5
        exp(n) = 0
      enddo
      exp(2) = 1
! loop over zones
      do n=1,2
        if (n .eq. 1) then
          zname = 'Zone1'
          dname = 'Zone2'
        else
          zname = 'Zone2'
          dname = 'Zone1'
        endif
! write zone
        call cg_zone_write_f(cgfile, cgbase, zname, size,               &
     &                       CGNS_ENUMV(Structured), cgzone, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        call cg_goto_f(cgfile, cgbase, ierr, 'Zone_t', cgzone, 'end')
        if (ierr .ne. CG_OK) call cg_error_exit_f
        call cg_dataclass_write_f(CGNS_ENUMV(NormalizedByDimensional), ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
! write coordinates
        call cg_coord_write_f(cgfile, cgbase, cgzone, CGNS_ENUMV(RealSingle),       &
     &                        'CoordinateX', x, cgcoord, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        call cg_gopath_f(cgfile, 'GridCoordinates/CoordinateX', ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        call cg_exponents_write_f(CGNS_ENUMV(RealSingle), exp, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f

        call cg_coord_write_f(cgfile, cgbase, cgzone, CGNS_ENUMV(RealSingle),       &
     &                        'CoordinateY', y, cgcoord, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        call cg_gopath_f(cgfile, '../CoordinateY', ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        call cg_exponents_write_f(CGNS_ENUMV(RealSingle), exp, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f

        call cg_coord_write_f(cgfile, cgbase, cgzone, CGNS_ENUMV(RealSingle),       &
     &                        'CoordinateZ', z, cgcoord, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        call cg_gopath_f(cgfile, '../CoordinateZ', ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        call cg_exponents_write_f(CGNS_ENUMV(RealSingle), exp, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
! write first ZoneGridConnectivity - will be active
        call cg_zconn_write_f(cgfile, cgbase, cgzone,                   &
     &                        'ZoneConnectivity1', cgz1, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f

! write second ZoneGridConnectivity - will be active
        call cg_zconn_write_f(cgfile, cgbase, cgzone,                   &
     &                        'ZoneConnectivity2', cgz2, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
! write general connectivity
        npts = 2
        dnpts = 25
        call cg_conn_write_f(cgfile, cgbase, cgzone, 'conn', CGNS_ENUMV(Vertex),    &
     &                       CGNS_ENUMV(Abutting1to1), CGNS_ENUMV(PointRange), npts, ptrange,   &
     &                       dname, CGNS_ENUMV(Structured), CGNS_ENUMV(PointListDonor),         &
     &                       CGNS_ENUMV(Integer), dnpts, ptlist, cgconn, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
! set it back to previous ZoneGridConnectivity and write 1to1
        call cg_zconn_set_f(cgfile, cgbase, cgzone, cgz1, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f

        call cg_1to1_write_f(cgfile, cgbase, cgzone, '1to1', dname,     &
     &                       ptrange, ptrange, transform, cgconn, ierr)

        if (ierr .ne. CG_OK) call cg_error_exit_f
      enddo

! close the file and reopen in read mode
      call cg_close_f(cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_open_f('cgzconn.cgns', CG_MODE_READ, cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      cgbase = 1
      cgz1 = 1
      cgz2 = 2
      cgconn = 1
      do cgzone=1,2
        call cg_nzconns_f(cgfile, cgbase, cgzone, nzconn, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        if (nzconn .ne. 2) then
          print *,'nzconn != 2'
          stop
        endif
! read should make ZoneGridConnectivity active
        call cg_zconn_read_f(cgfile, cgbase, cgzone, cgz2, zname, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        if (zname .ne. 'ZoneConnectivity2') then
          print *,'expecting Zoneconnectivity2 - got',zname
          stop
        endif
        call cg_nconns_f(cgfile, cgbase, cgzone, nconn, ierr);
        if (ierr .ne. CG_OK) call cg_error_exit_f
        call cg_n1to1_f(cgfile, cgbase, cgzone, n1to1, ierr);
        if (ierr .ne. CG_OK) call cg_error_exit_f
        if (nconn .ne. 1 .or. n1to1 .ne. 0) then
          print *,'expecting nconn=1,n1to1=0 - got',nconn,n1to1
          stop
        endif
        call cg_conn_info_f(cgfile, cgbase, cgzone, cgconn, cname,      &
     &                      loc, type, ptype, npts, dname, dztype,      &
     &                      dptype, ddtype, dnpts, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        IF (cname .NE. 'conn' .OR. loc .NE. CGNS_ENUMV(Vertex) .OR.     &
     &      TYPE .NE. CGNS_ENUMV(Abutting1to1) .OR.                     &
     &      ptype .NE. CGNS_ENUMV(PointRange) .OR.                      &
     &      npts .NE. 2 .OR. dztype .NE. CGNS_ENUMV(Structured) .OR.    &
     &      dptype .NE. CGNS_ENUMV(PointListDonor) .OR.                 &
     &      dnpts .NE. 25) THEN
          print *,'invalid conn data'
          stop
        endif
! read should make ZoneGridConnectivity active
        call cg_zconn_read_f(cgfile, cgbase, cgzone, cgz1, zname, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        if (zname .ne. 'ZoneConnectivity1') then
          print *,'expecting Zoneconnectivity1 - got',zname
          stop
        endif
        call cg_nconns_f(cgfile, cgbase, cgzone, nconn, ierr);
        if (ierr .ne. CG_OK) call cg_error_exit_f
        call cg_n1to1_f(cgfile, cgbase, cgzone, n1to1, ierr);
        if (ierr .ne. CG_OK) call cg_error_exit_f
        if (nconn .ne. 0 .or. n1to1 .ne. 1) then
          print *,'expecting nconn=0,n1to1=1 - got',nconn,n1to1
          stop
        endif
        call cg_1to1_read_f(cgfile, cgbase, cgzone, cgconn, cname,      &
     &                      dname, ptrange, ptrange, transform, ierr)

        if (ierr .ne. CG_OK) call cg_error_exit_f
        if (cname .ne. '1to1') then
          print *,'invalid 1to1 data'
          stop
        endif
      enddo

      call cg_close_f(cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      end

PROGRAM read_cgns_1
#include "cgnstypes_f03.h"
#ifdef WINNT
  INCLUDE 'cgnswin_f.h'
#endif
  USE ISO_C_BINDING
  USE CGNS
  IMPLICIT NONE

  ! This program reads a 3D mesh, structured or unstructured.

  INTEGER :: Ndim, Nglobal
  PARAMETER (Ndim = 3)
  PARAMETER (Nglobal = 500)
  INTEGER, PARAMETER :: sp = KIND(1.0)
  INTEGER, PARAMETER :: dp = KIND(1.d0)
  
  INTEGER :: i, narrays, iarray
  INTEGER :: nintegrals, integral
  INTEGER :: ndescriptors, idescr
  INTEGER(cgenum_t) :: nzonetype
  INTEGER(cgsize_t) :: nptsets
  INTEGER(cgenum_t) :: ndonor_ptset_type, ndonor_data_type
  INTEGER :: idataset, dirichletflag, neumannflag
  INTEGER IndexDim, CellDim, PhysDim
  INTEGER ier, n
  INTEGER(cgenum_t) :: zonetype
  INTEGER nbases, nzones
  INTEGER(cgsize_t) :: rmin(3), DataSize(Ndim)
  INTEGER(cgsize_t) :: SIZE(Ndim*3)
  INTEGER :: ncoords, nsols, nfields
  INTEGER(cgenum_t) :: location
  INTEGER(cgenum_t) :: TYPE
  INTEGER :: nholes, nconns, n1to1, n1to1_global, nbocos
  INTEGER(cgenum_t) :: ptset_type
  INTEGER(cgsize_t) :: npnts, pnts(100000), donor_pnts(100000)
  INTEGER(cgsize_t) :: npnts_donor
  INTEGER(cgenum_t) :: bocotype, datatype
  CHARACTER(len=32) basename, zonename, solname, fieldname
  CHARACTER(len=32) coordname, holename
#ifndef CG_BASESCOPE
  CHARACTER(len=32) connectname, donorname
#else
  CHARACTER(len=65) connectname, donorname
#endif
  CHARACTER(len=32) boconame
  INTEGER cg, base, zone, coord, sol, field, discr
  INTEGER :: hole, conn, one21, boco
  INTEGER(cgsize_t) :: RANGE(Ndim, 2), donor_range(Ndim, 2)
  INTEGER transform(Ndim)
  INTEGER(cgsize_t) :: G_range(Ndim*2, Nglobal)
  INTEGER(cgsize_t) :: G_donor_range(Ndim*2, Nglobal)
  INTEGER :: G_transform(Ndim, Nglobal)
  CHARACTER(len=32) G_zonename(Nglobal)
#ifndef CG_BASESCOPE
  CHARACTER(len=32) G_connectname(Nglobal), G_donorname(Nglobal)
#else
  CHARACTER(len=65) G_connectname(Nglobal), G_donorname(Nglobal)
#endif
  CHARACTER(len=32) name, filename
  CHARACTER(len=40) text, NormDefinitions, StateDescription
  INTEGER :: equation_dimension, GoverningEquationsFlag
  INTEGER :: GasModelFlag, ViscosityModelFlag
  INTEGER :: ThermalConductivityModelFlag
  INTEGER :: TurbulenceClosureFlag, TurbulenceModelFlag
  INTEGER :: diffusion_model(6)
  INTEGER :: niterations
  INTEGER :: rind(6), ndiscrete, num
  INTEGER :: nndim
  INTEGER(cgsize_t) :: dim_vals(12)
  INTEGER(cgenum_t) :: mass, length, time, temp, deg
  INTEGER :: NormalIndex(3), ndataset
  INTEGER(cgsize_t) :: NormalListSize
  REAL(KIND=sp) data_single(100000)
  REAL(KIND=dp) data_double(100000)
  REAL(KIND=sp) version

  INTEGER one, is_cgns
  PARAMETER (one = 1)

  ! *** open file
  !     write(6,*) 'Input filename'
  !     read(5,600) filename
  WRITE(filename,'(a)')'cgtest.cgns'

  ! *** check if the file is CGNS
  CALL cg_is_cgns_f(filename, is_cgns, ier)
  IF (ier .EQ. ERROR) CALL cg_error_exit_f
  IF ((is_cgns.NE.CG_FILE_ADF).AND.(is_cgns.NE.CG_FILE_HDF5).AND. &
       (is_cgns.NE.CG_FILE_ADF2)) &
       CALL cg_error_exit_f

  ! *** check if the user passes a file name with the null terminator
  CALL cg_is_cgns_f(TRIM(filename)//C_NULL_CHAR, is_cgns, ier)
  IF (ier .EQ. ERROR) CALL cg_error_exit_f
  IF ((is_cgns.NE.CG_FILE_ADF).AND.(is_cgns.NE.CG_FILE_HDF5).AND. &
       (is_cgns.NE.CG_FILE_ADF2)) &
       CALL cg_error_exit_f

  CALL cg_open_f(filename, CG_MODE_READ, cg, ier)
  IF (ier .EQ. ERROR) CALL cg_error_exit_f
  WRITE(6,600)'READING FILE ',filename

  ! *** CGNS Library Version used for file creation:
  CALL cg_version_f(cg, version, ier)
  IF (ier .EQ. ERROR) CALL cg_error_exit_f
  WRITE(6,102) &
       'Library Version used for file creation: ',version

  ! *** base
  CALL cg_nbases_f(cg, nbases, ier)
  IF (ier .EQ. ERROR) CALL cg_error_exit_f
  WRITE(6,200)'nbases=',nbases

  DO base=1, nbases

     CALL cg_base_read_f(cg, base, basename, CellDim, PhysDim, ier)
     IF (ier .EQ. ERROR) CALL cg_error_exit_f
     WRITE(6,300)'BaseName = "',TRIM(basename),'"', &
          'cell_dimension=',CellDim

     ! *** base attribute:  GOTO base node
     CALL cg_goto_f(cg, base, ier, 'end')
     IF (ier .EQ. ERROR) CALL cg_error_exit_f

     ! ***     base attribute:  Descriptor
     CALL cg_descriptor_read_f(one, name, text, ier)
     IF (ier .EQ. ERROR) CALL cg_error_exit_f
     IF (ier.EQ.ALL_OK) THEN
        WRITE(6,400)'Base Descriptor_t Information:'
        WRITE(6,500)' DescriptorName="',TRIM(name),'"', &
             ' DescriptorText="',TRIM(text),'"'
     ENDIF

     ! ***     base attribute: flow equation set:
     CALL cg_equationset_read_f(equation_dimension, &
          GoverningEquationsFlag,  GasModelFlag, &
          ViscosityModelFlag, ThermalConductivityModelFlag, &
          TurbulenceClosureFlag,  TurbulenceModelFlag, ier)
     IF (ier .EQ. ERROR) THEN
        CALL cg_error_exit_f
     ELSEIF (ier .EQ. NODE_NOT_FOUND) THEN
        WRITE(6,200)&
             'FlowEquationSet_t not defined under CGNSBase_t #',base
     ELSEIF (ier .EQ. INCORRECT_PATH) THEN
        WRITE(6,400)'Incorrect path input to cg_goto_f'
     ELSE
        WRITE(6,400) 'FlowEquationSet_t Information:'
        WRITE(6,100)' equation_dimension=',equation_dimension

        ! ***       flow equation set attributes:  GOTO FlowEquationSet_t node
        CALL cg_goto_f(cg,base,ier,'FlowEquationSet_t',one,'end')
        IF (ier .EQ. ERROR) CALL cg_error_exit_f

        ! ***       flow equation set attribute: Descriptor
        CALL cg_descriptor_read_f(one, name,text,ier)
        IF (ier .EQ. ERROR) CALL cg_error_exit_f
        IF (ier .EQ. ALL_OK) WRITE(6,500) &
             ' DescriptorName="',TRIM(name),'"',' DescriptorText="',TRIM(text),'"'

        ! ***       flow equation set attribute: Gas Model Type
        IF (GasModelFlag.EQ.1) THEN
           CALL cg_model_read_f('GasModel_t', TYPE, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           IF (ier .EQ. ALL_OK) WRITE(6,600) &
                ' GasModelType="',TRIM(ModelTypeName(TYPE)),'"'
        ENDIF

        ! ***       flow equation set attribute: ViscosityModel Type
        IF (ViscosityModelFlag.EQ.1) THEN
           CALL cg_model_read_f('ViscosityModel_t', TYPE, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           IF (ier .EQ. ALL_OK) WRITE(6,600) &
                ' ViscosityModelType="',TRIM(ModelTypeName(TYPE)),'"'
        ENDIF

        ! ***       flow equation set attribute:  TypmlConductivityModel Type
        IF (ThermalConductivityModelFlag.EQ.1) THEN
           CALL cg_model_read_f('ThermalConductivityModel_t', &
                TYPE, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           IF (ier .EQ. ALL_OK) WRITE(6,600) &
                ' ThermalConductivityModelType=', &
                TRIM(ModelTypeName(TYPE)),'"'
        ENDIF

        ! ***   flow equation set attribute: TurbulenceClosureType
        IF (TurbulenceClosureFlag.EQ.1) THEN
           CALL cg_model_read_f('TurbulenceClosure_t', TYPE, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           IF (ier .EQ. ALL_OK) WRITE(6,600) &
                ' TurbulenceClosureType="', TRIM(ModelTypeName(TYPE)),'"'
        ENDIF

        ! ***   flow equation set attribute: TurbulenceModelType
        IF (TurbulenceModelFlag.EQ.1) THEN
           CALL cg_model_read_f('TurbulenceModel_t', TYPE, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           IF (ier .EQ. ALL_OK) WRITE(6,600) &
                ' TurbulenceModelType="',TRIM(ModelTypeName(TYPE)),'"'
        ENDIF

        ! ***   flow equation set attribute: Governing Equations Type
        IF (GoverningEquationsFlag .EQ. 1) THEN
           CALL cg_governing_read_f(TYPE, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           IF (ier.EQ.ALL_OK)&
                WRITE(6,600)' GoverningEquationsType="', &
                TRIM(GoverningEquationsTypeName(TYPE)),'"'

           ! *** Governing Equations attribute:  GOTO GoverningEquations_t node
           CALL cg_goto_f(cg,base,ier, 'FlowEquationSet_t', one, &
                'GoverningEquations_t', one ,'end')
           IF (ier .EQ. ERROR) CALL cg_error_exit_f


           ! *** Governing Equations attribute:  Diffusion model
           CALL cg_diffusion_read_f(diffusion_model, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           IF (ier.EQ.ALL_OK)WRITE(6,103)'   Diffusion model=', &
                (diffusion_model(i), i=1,6)
        ENDIF       ! If Governing Equations are defined
     ENDIF          ! If FlowEquationSet_t exists under CGNSBase_t


     WRITE(6,400)'                              *     *     *'

     CALL cg_nzones_f(cg, base, nzones, ier)
     IF (ier .EQ. ERROR) CALL cg_error_exit_f
     WRITE(6,200)'nzones=',nzones

     ! *** zone
     DO zone=1, nzones
        CALL cg_zone_read_f(cg, base, zone, zonename, size, ier)
        IF (ier .EQ. ERROR) CALL cg_error_exit_f
        WRITE(6,104)'Name of Zone',zone,' is "',TRIM(zonename),'"'

        CALL cg_zone_type_f(cg, base, zone, zonetype, ier)
        IF (ier .EQ. ERROR) CALL cg_error_exit_f
        WRITE(6,600)'  Zone type is ', ZoneTypeName(zonetype)


        IF (zonetype.EQ.CGNS_ENUMV(Structured)) THEN
           IndexDim=CellDim
        ELSE
           IndexDim=1
        ENDIF


        WRITE(6,104)'  IndexDimension=',IndexDim

        ! *** zone attribute:  GOTO zone node
        CALL cg_goto_f(cg, base, ier, 'Zone_t', zone, 'end')
        IF (ier .EQ. ERROR) CALL cg_error_exit_f

        ! *** zone attribute:  ordinal
        CALL cg_ordinal_read_f(num, ier)
        IF (ier .EQ. ERROR) CALL cg_error_exit_f
        IF (ier .EQ. ALL_OK)&
             WRITE(6,200)' Zone ordinal=',num


        ! *** zone attribute:  convergence history
        CALL cg_convergence_read_f(niterations, &
             NormDefinitions, ier)
        IF (ier .EQ. ERROR) CALL cg_error_exit_f

        IF (ier .EQ. ALL_OK) THEN
           WRITE(6,600)'Convergence History of ',zonename
           WRITE(6,104) ' niterations=',niterations, &
                ' NormDefinitions="',TRIM(NormDefinitions),'"'

           ! ** ConvergenceHistory_t attributes:
           CALL cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                'ConvergenceHistory_t', one, 'end')
           IF (ier .EQ. ERROR) CALL cg_error_exit_f

           ! ** ConvergenceHistory_t attributes: DataArray_t
           CALL cg_narrays_f(narrays, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           WRITE(6,105) 'ConvergenceHistory_t contains ', &
                narrays,' array(s)'
           DO iarray=1, narrays
              CALL cg_array_info_f(iarray, name, datatype, &
                   nndim, dim_vals, ier)
              IF (ier .EQ. ERROR) CALL cg_error_exit_f

              WRITE(6,600) ' DataArrayName="',TRIM(name),'"'
              WRITE(6,600) ' DataType="',TRIM(DataTypeName(datatype)),'"'
              WRITE(6,200) ' DataNdim=',nndim
              WRITE(6,200) ' DataDim=',dim_vals(1)

              WRITE(6,105) ' Data:'
              IF (datatype .EQ. CGNS_ENUMV(RealSingle)) THEN
                 CALL cg_array_read_f(iarray, data_single, ier)
                 IF (ier .EQ. ERROR) CALL cg_error_exit_f
                 WRITE(6,106) (data_single(n),n=1,dim_vals(1))
              ELSEIF (datatype .EQ. CGNS_ENUMV(RealDouble)) THEN
                 CALL cg_array_read_f(iarray, data_double, ier)
                 IF (ier .EQ. ERROR) CALL cg_error_exit_f
                 WRITE(6,106) (data_double(n),n=1,dim_vals(1))
              ENDIF
           ENDDO

           ! ** ConvergenceHistory_t attributes: DataClass_t
           CALL cg_dataclass_read_f(TYPE,ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           WRITE(6,600)'DataClassName=',DataClassName(TYPE)

           ! ** ConvergenceHistory_t attributes: DimensionalUnits_t
           CALL cg_units_read_f(mass, length, time, temp, deg, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           IF (ier .EQ. ALL_OK) THEN
              WRITE(6,100) &
                   'Dimensional Units:', &
                   MassUnitsName(mass), LengthUnitsName(length), &
                   TemperatureUnitsName(temp), TimeUnitsName(time), &
                   AngleUnitsName(deg)
           ENDIF
        ENDIF
        WRITE(6,400)'                             *     *     *'

        ! *** zone attribute:  return to Zone_t node
        CALL cg_goto_f(cg, base, ier, 'Zone_t', zone, 'end')
        IF (ier .EQ. ERROR) CALL cg_error_exit_f
        WRITE(6,401)'Integral Data Information of ',zonename

        CALL cg_nintegrals_f(nintegrals, ier)
        IF (ier .EQ. ERROR) CALL cg_error_exit_f
        WRITE(6,107) nintegrals, ' IntegralData_t node in ', &
             zonename

        ! *** zone attribute:  IntegralData_t
        DO integral=1, nintegrals
           CALL cg_integral_read_f(integral, name, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           WRITE(6,104) 'IntegralData_t #',integral, &
                ' is named "', TRIM(name),'"'

           ! *** IntegralData_t attribute:  GOTO IntegralData_t node
           CALL cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                'IntegralData_t', integral, 'end')
           IF (ier .EQ. ERROR) CALL cg_error_exit_f

           CALL cg_narrays_f(narrays, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           WRITE(6,108) 'IntegralData_t #',integral, &
                ' contains ', narrays,' data'

           DO iarray=1, narrays

              ! *** IntegralData_t attribute: DataArray_t
              CALL cg_array_info_f(iarray, name, datatype, &
                   nndim, dim_vals, ier)
              IF (ier .EQ. ERROR) CALL cg_error_exit_f
              WRITE(6,600) ' DataArrayName="',TRIM(name),'"'
              WRITE(6,600) ' DataType=',DataTypeName(datatype)
              WRITE(6,108) ' DataNdim=',nndim, &
                   ', DataDim=',dim_vals(1)

              IF (datatype .EQ. CGNS_ENUMV(RealSingle)) THEN
                 CALL cg_array_read_f(iarray, data_single, ier)
                 IF (ier .EQ. ERROR) CALL cg_error_exit_f
                 WRITE(6,109) ' integraldata=',data_single(1)
              ELSEIF (datatype .EQ. CGNS_ENUMV(RealDouble)) THEN
                 CALL cg_array_read_f(iarray, data_double, ier)
                 IF (ier .EQ. ERROR) CALL cg_error_exit_f
                 WRITE(6,109) 'integraldata=',data_double(1)
              ENDIF

              ! *** DattaArray_t attribute: GOTO DataArray_t
              CALL cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                   'IntegralData_t', integral, &
                   'DataArray_t', iarray, 'end')
              IF (ier .EQ. ERROR) CALL cg_error_exit_f


              ! *** DattaArray_t attribute: DimensionalExponents_t
              CALL cg_exponents_info_f(datatype, ier)
              IF (ier .EQ. ERROR) THEN
                 CALL cg_error_exit_f
              ELSEIF (ier .EQ. ALL_OK) THEN
                 WRITE(6,600)' Datatype for exponents is ', &
                      DataTypeName(datatype)
                 IF (datatype .EQ. CGNS_ENUMV(RealSingle)) THEN
                    CALL cg_exponents_read_f(data_single, ier)
                    IF (ier .EQ. ERROR) CALL cg_error_exit_f
                    WRITE(6,110)' Exponents:',(data_single(n),n=1,5)
                 ELSEIF (datatype .EQ. CGNS_ENUMV(RealDouble)) THEN
                    CALL cg_exponents_read_f(data_double, ier)
                    IF (ier .EQ. ERROR) CALL cg_error_exit_f
                    WRITE(6,110)' Exponents:',(data_double(n),n=1,5)
                 ENDIF
              ENDIF

              ! *** DattaArray_t attribute: DataConversion_t
              CALL cg_conversion_info_f(datatype, ier)
              IF (ier .EQ. ERROR) THEN
                 CALL cg_error_exit_f
              ELSEIF (ier .EQ. ALL_OK) THEN
                 WRITE(6,600)' Datatype for conversion is ', &
                      DataTypeName(datatype)
                 IF (datatype .EQ. CGNS_ENUMV(RealSingle)) THEN
                    CALL cg_conversion_read_f(data_single, ier)
                    IF (ier .EQ. ERROR) CALL cg_error_exit_f
                    WRITE(6,110)' Conversion:',(data_single(n),n=1,2)
                 ELSEIF (datatype .EQ. CGNS_ENUMV(RealDouble)) THEN
                    CALL cg_conversion_read_f(data_double, ier)
                    IF (ier .EQ. ERROR) CALL cg_error_exit_f
                    WRITE(6,110)' Conversion:',(data_double(n),n=1,2)
                 ENDIF
              ENDIF

           ENDDO ! loop through DataArray_t
        ENDDO ! loop through IntegralData_t

        WRITE(6,400)'                             *     *     *'

        ! *** zone coordinate attribute:  GOTO GridCoordinates_t node
        CALL cg_goto_f(cg, base, ier, 'Zone_t', zone, &
             'GridCoordinates_t', one, 'end')
        IF (ier .EQ. ERROR) CALL cg_error_exit_f
        IF (ier .EQ. ALL_OK) THEN

           ! *** GridCoordinates_t attribute: dimensional units
           CALL cg_units_read_f(mass, length, time, temp, deg, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           IF (ier .EQ. ALL_OK) WRITE(6,400) &
                'Dimensional Units for GridCoordinates_t: ', &
                LengthUnitsName(length)

           ! *** GridCoordinates_t attribute:  Rind
           CALL cg_rind_read_f(rind, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           WRITE(6,103)'GC Rind Data is ',(rind(i),i=1,6)

           ! *** coordinate array
           CALL cg_narrays_f(narrays, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           WRITE(6,105) 'GridCoordinates_t contains ', &
                narrays,' arrays'
           DO iarray=1,narrays

              CALL cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                   'GridCoordinates_t', one, 'end')
              IF (ier .EQ. ERROR) CALL cg_error_exit_f

              ! *** GridCoordinates_t attribute: DataArray_t
              CALL cg_array_info_f(iarray, name, datatype, &
                   nndim, dim_vals, ier)
              IF (ier .EQ. ERROR) CALL cg_error_exit_f
              WRITE(6,600)' DataArrayName="',TRIM(name),'"'
              WRITE(6,600)' DataType=',DataTypeName(datatype)
              WRITE(6,104)' DataNdim=',nndim
              DO i=1,nndim
                 WRITE(6,111)' DataDim(',i,')=',dim_vals(i)
              ENDDO

              ! *** Compute nr of data in data array:
              num = 1
              DO i=1,nndim
                 num = num*dim_vals(i)
              ENDDO

              IF (datatype .EQ. CGNS_ENUMV(RealSingle)) THEN
                 CALL cg_array_read_f(iarray, data_single, ier)
                 IF (ier .EQ. ERROR) CALL cg_error_exit_f
                 WRITE(6,106) (data_single(i),i=1,2)
                 WRITE(6,106) (data_single(i),i=num-1,num)
              ELSEIF (datatype .EQ. CGNS_ENUMV(RealDouble)) THEN
                 CALL cg_array_read_f(iarray, data_double, ier)
                 IF (ier .EQ. ERROR) CALL cg_error_exit_f
                 WRITE(6,106) (data_double(i),i=1,2)
                 WRITE(6,106) (data_double(i),i=num-1,num)
              ENDIF

              ! *** coordinate attribute:  GOTO coordinate array node
              CALL cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                   'GridCoordinates_t', one, 'DataArray_t', iarray, 'end')
              IF (ier .EQ. ERROR) CALL cg_error_exit_f

              CALL cg_ndescriptors_f(ndescriptors, ier)
              IF (ier .EQ. ERROR) CALL cg_error_exit_f
              WRITE(6,105) 'No. of descriptors=',ndescriptors
              DO idescr=1, ndescriptors
                 CALL cg_descriptor_read_f(idescr, name, text, ier)
                 IF (ier .EQ. ERROR) CALL cg_error_exit_f
                 WRITE(6,500) ' DescriptorName="',TRIM(name),'"', &
                      ' DescriptorText="',TRIM(text),'"'
              ENDDO

           ENDDO ! loop through data arrays

           ! *** read coordinates using coordinate arrays' specific functions:

           WRITE(6,400)'Specific functions to read coordinates arrays'
           CALL cg_ncoords_f(cg, base, zone, ncoords, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           WRITE(6,103)'no. of coordinates=',ncoords

           ! ** Compute the nr of data to be read
           DO i=1,IndexDim
              rmin(i)=1
              DataSize(i)=SIZE(i) + rind(2*i-1) + rind(2*i)
           ENDDO

           DO coord=1, ncoords
              CALL cg_coord_info_f(cg, base, zone, coord, datatype, &
                   coordname, ier)
              IF (ier .EQ. ERROR) CALL cg_error_exit_f
              WRITE(6,112)'coord #',coord, &
                   '   datatype=',DataTypeName(datatype), &
                   '   name="',TRIM(coordname),'"'

              IF (datatype .EQ. CGNS_ENUMV(RealSingle)) THEN
                 CALL cg_coord_read_f(cg, base, zone, coordname, &
                      cg_get_type(data_single(1)), rmin, DataSize, &
                      data_single, ier)
                 IF (ier .EQ. ERROR) CALL cg_error_exit_f

              ELSEIF (datatype .EQ. CGNS_ENUMV(RealDouble)) THEN
                 CALL cg_coord_read_f(cg, base, zone, coordname, &
                      cg_get_type(data_double(1)), rmin, DataSize, &
                      data_double, ier)
                 IF (ier .EQ. ERROR) CALL cg_error_exit_f
              ENDIF
           ENDDO
        ENDIF ! if GridCoordinates_t exists

        WRITE(6,400)'                             *     *     *'

        ! *** solution

        CALL cg_nsols_f(cg, base, zone, nsols, ier)
        IF (ier .EQ. ERROR) CALL cg_error_exit_f
        WRITE(6,113) nsols,' FlowSolution_t node(s)', &
             'found for ',zonename

        ! *** Read solution with general cg_array_read function
        DO sol=1, nsols
           CALL cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                'FlowSolution_t', sol, 'end')
           IF (ier .EQ. ERROR) CALL cg_error_exit_f

           ! *** FlowSolution_t attribute:  DataArray_t
           CALL cg_narrays_f(narrays, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           WRITE(6,108) ' FlowSolution_t #',sol, &
                ' contains ',narrays,' solution arrays'

           ! *** FlowSolution_t attribute:  GridLocation
           CALL cg_gridlocation_read_f(location, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           WRITE(6,600)'  The solution data are recorded at the ', &
                GridLocationName(location)

           ! *** FlowSolution_t attribute:  Rind
           CALL cg_rind_read_f(rind, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           WRITE(6,103)'  The Rind Data is ',(rind(i),i=1,6)

           DO iarray=1,narrays
              CALL cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                   'FlowSolution_t', sol, 'end')
              IF (ier .EQ. ERROR) CALL cg_error_exit_f

              CALL cg_array_info_f(iarray, name, datatype, &
                   nndim, dim_vals, ier)
              IF (ier .EQ. ERROR) CALL cg_error_exit_f
              WRITE(6,114) '  DataArray #',iarray
              WRITE(6,600) '   Name="',TRIM(name),'"'
              WRITE(6,600) '   DataType=',DataTypeName(datatype)
              WRITE(6,103) '   DataNdim=',nndim
              DO i=1,nndim
                 WRITE(6,111)'   DataDim(',i,')=',dim_vals(i)
              ENDDO

              ! *** For dynamic memory allocation, compute the number of data to be read:
              num = 1
              DO i=1,nndim
                 num = num*dim_vals(i)
              ENDDO
              WRITE(6,200) 'Nr of data in solution vector=',num

              IF (datatype .EQ. CGNS_ENUMV(RealSingle)) THEN
                 CALL cg_array_read_f(iarray, data_single, ier)
                 IF (ier .EQ. ERROR) CALL cg_error_exit_f
                 !write(6,106) (data_single(i),i=1,num)
              ELSEIF (datatype .EQ. CGNS_ENUMV(RealDouble)) THEN
                 CALL cg_array_read_f(iarray, data_double, ier)
                 IF (ier .EQ. ERROR) CALL cg_error_exit_f
                 !write(6,106) (data_double(i),i=1,num)
              ENDIF

              ! *** solution field attribute:  GOTO solution array node
              CALL cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                   'FlowSolution_t',sol,'DataArray_t',iarray,'end')
              IF (ier .EQ. ERROR) CALL cg_error_exit_f

              ! *** solution field attribute:  DimensionalUnits
              CALL cg_units_read_f(mass, length, time, temp, &
                   deg, ier)
              IF (ier .EQ. ERROR) CALL cg_error_exit_f
              IF (ier .EQ. ALL_OK) THEN
                 WRITE(6,100)&
                      '   Dimensional Units:', &
                      MassUnitsName(mass), LengthUnitsName(length), &
                      TemperatureUnitsName(temp), TimeUnitsName(time), &
                      AngleUnitsName(deg)
              ENDIF

           ENDDO     ! loop through DataArray_t
           WRITE(6,103)' '

           ! *** Reading solution data with solution specific functions:
           CALL cg_sol_info_f(cg, base, zone, sol, solname, &
                location, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           WRITE(6,115)'sol #',sol,':', &
                '   solname="',TRIM(solname),'"', &
                '   location=',GridLocationName(location)

           ! *** Compute the nr of data to be read

           IF (zonetype.EQ.CGNS_ENUMV(Structured)) THEN
              DO i=1,3
                 DataSize(i)=SIZE(i) + rind(2*i-1) + rind(2*i)
                 IF (location.EQ.CGNS_ENUMV(CellCenter)) DataSize(i)=DataSize(i)-1
              ENDDO
           ELSE
              DataSize(1)=SIZE(2)
           ENDIF

           ! *** solution field
           CALL cg_nfields_f(cg, base, zone, sol, nfields, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           WRITE(6,105)'  nfields=',nfields

           DO field=1, nfields
              CALL cg_field_info_f(cg, base, zone, sol, field, &
                   TYPE, fieldname, ier)
              IF (ier .EQ. ERROR) CALL cg_error_exit_f
              WRITE(6,115)'  field #',field,':', &
                   '   fieldname="',TRIM(fieldname),'"', &
                   '   datatype=',DataTypeName(TYPE)

              ! *** read entire range of solution data and record in double precision
              CALL cg_field_read_f(cg, base, zone, sol, fieldname, &
                   CGNS_ENUMV(RealDouble), rmin, DataSize, data_double, ier)
              IF (ier .EQ. ERROR) CALL cg_error_exit_f
           ENDDO                             ! field loop

        ENDDO     ! loop through FlowSolution_t

        WRITE(6,400)'                             *     *     *'

        ! *** discrete data under zone
        CALL cg_ndiscrete_f(cg, base, zone, ndiscrete, ier)
        IF (ier .EQ. ERROR) CALL cg_error_exit_f
        IF (ier .EQ. ALL_OK) WRITE(6,113)ndiscrete, &
             ' DiscreteData_t node(s) found under ',zonename

        DO discr=1, ndiscrete
           CALL cg_discrete_read_f(cg, base,zone, discr, name, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           WRITE(6,600)' name=',name

           ! *** discrete data attribute:  GOTO DiscreteData_t node
           CALL cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                'DiscreteData_t',  discr, 'end')
           IF (ier .EQ. ERROR) CALL cg_error_exit_f

           ! *** discrete data attribute:  GridLocation_t
           CALL cg_gridlocation_read_f(location, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           IF (ier .EQ. ALL_OK) WRITE(6,600) &
                ' The location of the DiscreteData vector is ', &
                GridLocationName(location)

           ! *** discrete data arrays:
           CALL cg_narrays_f(narrays, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           WRITE(6,116) ' DiscreteData #', discr, &
                ' contains ', narrays,' arrays'
           DO iarray=1, narrays
              CALL cg_array_info_f(iarray, name, datatype, &
                   nndim, dim_vals, ier)
              IF (ier .EQ. ERROR) CALL cg_error_exit_f

              WRITE(6,116) 'DataArray #',iarray,':'
              WRITE(6,600)'  Name =',name
              WRITE(6,600)'  Datatype=', &
                   DataTypeName(datatype)

              ! *** compute nr of data to be read
              num=1
              DO n=1, nndim
                 num=num*dim_vals(n)
              ENDDO

              IF (datatype .EQ. CGNS_ENUMV(RealSingle)) THEN
                 CALL cg_array_read_f(iarray, data_single, ier)
                 IF (ier .EQ. ERROR) CALL cg_error_exit_f
                 !write(6,*) (data_single(n),n=1,num)
              ELSEIF (datatype .EQ. CGNS_ENUMV(RealDouble)) THEN
                 CALL cg_array_read_f(iarray, data_double, ier)
                 IF (ier .EQ. ERROR) CALL cg_error_exit_f
                 !write(6,*) (data_double(n),n=1,num)
              ENDIF

              ! *** discrete data arrays attribute: GOTO DataArray node
              CALL cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                   'DiscreteData_t', discr, 'DataArray_t', iarray, 'end')
              IF (ier .EQ. ERROR) CALL cg_error_exit_f

              CALL cg_units_read_f(mass, length, time, temp, deg, ier)
              IF (ier .EQ. ERROR) CALL cg_error_exit_f
              IF (ier .EQ. ALL_OK) THEN
                 WRITE(6,100)&
                      '  Dimensional Units for DiscreteData_t:', &
                      MassUnitsName(mass), LengthUnitsName(length), &
                      TemperatureUnitsName(temp), TimeUnitsName(time), &
                      AngleUnitsName(deg)
              ENDIF
           ENDDO          ! loop through DataArray_t
        ENDDO

        WRITE(6,400)'                             *     *     *'

        ! *** Interblock Connectivity:
        WRITE(6,401)'Interblock Connectivity for ',zonename

        ! *** ZoneGridConnectivity attributes:  GOTO ZoneGridConnectivity_t node
        CALL cg_goto_f(cg, base, ier, 'Zone_t', zone, &
             'ZoneGridConnectivity_t', one, 'end')
        IF (ier .EQ. ERROR) CALL cg_error_exit_f

        IF (ier.EQ. ALL_OK) THEN
           ! *** ZoneGridConnectivity attributes: Descriptor_t
           CALL cg_ndescriptors_f(ndescriptors, ier)
           IF (ier .NE. 0) CALL cg_error_exit_f
           WRITE(6,117)&
                ndescriptors, ' descriptors for ZoneGridConnectivity_t'
           DO idescr=1, ndescriptors
              CALL cg_descriptor_read_f(idescr, name, text, ier)
              IF (ier .EQ. ERROR) CALL cg_error_exit_f
              WRITE(6,500) '     DescriptorName="',TRIM(name),'"', &
                   '     DescriptorText="',TRIM(text),'"'
           ENDDO


           ! *** overset holes
           CALL cg_nholes_f(cg, base, zone, nholes, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           WRITE(6,107) nholes, ' holes found'

           DO hole=1, nholes
              CALL cg_hole_info_f(cg, base, zone, hole, holename, &
                   location, ptset_type, nptsets, npnts, ier)
              IF (ier .EQ. ERROR) CALL cg_error_exit_f
              WRITE(6,118)&
                   '  hole #',hole,':', '   holename="',TRIM(holename),'"', &
                   '   data location=',GridLocationName(location), &
                   '   nptsets = ',nptsets, &
                   ', total no. of points =',npnts

              IF (npnts .LT. 30000) THEN
                 CALL cg_hole_read_f(cg, base, zone, hole, pnts, ier)
                 IF (ier .EQ. ERROR) CALL cg_error_exit_f
              ENDIF

              ! *** overset holes attributes:  GOTO OversetHoles_t node
              CALL cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                   'ZoneGridConnectivity_t', one, &
                   'OversetHoles_t', hole, 'end')
              IF (ier .NE. 0) CALL cg_error_exit_f

              CALL cg_ndescriptors_f(ndescriptors, ier)
              IF (ier .NE. 0) CALL cg_error_exit_f
              WRITE(6,117)&
                   ndescriptors, ' descriptors for ',holename
              DO idescr=1, ndescriptors
                 CALL cg_descriptor_read_f(idescr, name, text, ier)
                 IF (ier .EQ. ERROR) CALL cg_error_exit_f
                 WRITE(6,500) '     DescriptorName="',TRIM(name),'"', &
                      '     DescriptorText="',TRIM(text),'"'
              ENDDO
           ENDDO     !hole loop



           ! *** general connectivity
           CALL cg_nconns_f(cg, base, zone, nconns, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           WRITE(6,107) nconns,' GridConnectivity_t found'
           DO conn=1, nconns
              CALL cg_conn_info_f(cg, base, zone, conn, connectname, &
                   location, TYPE, ptset_type, npnts, donorname, &
                   nzonetype, ndonor_ptset_type, ndonor_data_type, &
                   npnts_donor, ier)
              IF (ier .EQ. ERROR) CALL cg_error_exit_f

              WRITE(6, 101) &
                   '  GridConnectivity #',conn,':', &
                   '   connect name ='//TRIM(connectname), &
                   '   Grid location='//TRIM(GridLocationName(location)), &
                   '   Connect-type ='//TRIM(GridConnectivityTypeName(TYPE)), &
                   '   ptset type   ="'//TRIM(PointSetTypeName(ptset_type))//'"', &
                   '   npnts=',npnts,'   donorname="'//TRIM(donorname)//'"', &
                   '   donor zonetype='//TRIM(ZoneTypeName(nzonetype)), &
                   '   donor ptset type='//TRIM(PointSetTypeName(ndonor_ptset_type)), &
                   '   npnts_donor=',npnts_donor

              CALL cg_conn_read_f(cg, base, zone, conn, pnts, &
                   cg_get_type(donor_pnts(1)), &
                   donor_pnts, ier)
              IF (ier .EQ. ERROR) CALL cg_error_exit_f

              WRITE(6,119) '   Current zone:', &
                   '    first point:', pnts(1),pnts(2),pnts(3), &
                   '    last point :', pnts(3*npnts-2), pnts(3*npnts-1), &
                   pnts(3*npnts)
              WRITE(6,119) '   Donor zone:', &
                   '    first point:', donor_pnts(1),donor_pnts(2), &
                   donor_pnts(3), &
                   '    last point :', donor_pnts(3*npnts-2), &
                   donor_pnts(3*npnts-1), &
                   donor_pnts(3*npnts)

              ! *** general connectivity attributes:  GOTO GridConnectivity_t node
              CALL cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                   'ZoneGridConnectivity_t', one, &
                   'GridConnectivity_t', conn, 'end')
              IF (ier .EQ. ERROR) CALL cg_error_exit_f

              CALL cg_ordinal_read_f(num, ier)
              IF (ier .EQ. ERROR) CALL cg_error_exit_f
              IF (ier .EQ. ALL_OK) WRITE(6,200)'  Ordinal=',num
           ENDDO

           ! *** connectivity 1to1
           CALL cg_n1to1_f(cg, base, zone, n1to1, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           WRITE(6,107) n1to1,' GridConnectivity1to1_t found'

           DO one21=1, n1to1
              CALL cg_1to1_read_f(cg, base, zone, one21, connectname, &
                   donorname, range, donor_range, transform, ier)
              IF (ier .EQ. ERROR) CALL cg_error_exit_f

              WRITE(6,105) 'GridConnectivity1to1 #',one21
              WRITE(6,600) 'connectname="',TRIM(connectname),'"'
              WRITE(6,600) 'donorname  ="',TRIM(donorname),'"'

              WRITE(6,120) ' range: ', &
                   '(',RANGE(1,1),',',RANGE(2,1),',',RANGE(3,1), &
                   ') to (',RANGE(1,2),',',RANGE(2,2),',',RANGE(3,2),')'

              WRITE(6,121)' donor_range: ', &
                   '(', donor_range(1,1), ',', donor_range(2,1), ',', &
                   donor_range(3,1), ') to (', &
                   donor_range(1,2), ',', donor_range(2,2), ',', &
                   donor_range(3,2), ')'

              WRITE(6,122) ' Transform: ', '(', &
                   transform(1), ',', &
                   transform(2), ',', transform(3), ')'


              ! *** connectivity 1to1 attributes:  GOTO GridConnectivity1to1_t node
              CALL cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                   'ZoneGridConnectivity_t', one, &
                   'GridConnectivity1to1_t', one21, 'end')
              IF (ier .EQ. ERROR) CALL cg_error_exit_f
              IF (ier .EQ. ALL_OK) THEN

                 ! *** connectivity 1to1 attributes:  Descriptor_t
                 CALL cg_ndescriptors_f(ndescriptors, ier)
                 IF (ier .NE. 0) CALL cg_error_exit_f
                 WRITE(6,117)&
                      ndescriptors, ' descriptors for ',connectname
                 DO idescr=1, ndescriptors
                    CALL cg_descriptor_read_f(idescr, name, text, ier)
                    IF (ier .EQ. ERROR) CALL cg_error_exit_f
                    WRITE(6,500) '   DescriptorName="',TRIM(name),'"', &
                         '   DescriptorText="',TRIM(text),'"'
                 ENDDO
              ENDIF
           ENDDO
        ENDIF ! if ZoneGridConnectivity exists

        WRITE(6,400)'                             *     *     *'

        ! *** bocos
        WRITE(6,600)'Boundary Conditions for ',zonename


        ! *** Zone bound. condition attributes: GOTO ZoneBC_t node
        CALL cg_goto_f(cg, base,ier, 'Zone_t', zone, &
             'ZoneBC_t', one, 'end')
        IF (ier .EQ. ERROR) CALL cg_error_exit_f
        IF (ier .EQ. ALL_OK) THEN

           ! *** Zone bound. condition attributes: ReferenceState_t
           CALL cg_state_read_f(StateDescription, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           IF (ier.EQ.ALL_OK) THEN
              WRITE(6,600)' ReferenceState defined under ZoneBC_t'
              WRITE(6,600)'  StateDescription=',StateDescription

              ! ** ReferenceState_t attributes:  GOTO ReferenceState_t
              CALL cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                   'ZoneBC_t', one, 'ReferenceState_t', one, 'end')
              IF (ier .EQ. ERROR) CALL cg_error_exit_f

              CALL cg_narrays_f(narrays, ier)
              IF (ier .EQ. ERROR) CALL cg_error_exit_f
              WRITE(6,105) '  ReferenceState_t contains ', &
                   narrays,' array(s)'

              DO iarray=1, narrays

                 CALL cg_array_info_f(iarray, name, datatype, &
                      nndim, dim_vals, ier)
                 IF (ier .EQ. ERROR) CALL cg_error_exit_f

                 WRITE(6,105) '   DataArray #',iarray,':'
                 WRITE(6,600)'    Name =',name
                 WRITE(6,600)'    Datatype=',DataTypeName(datatype)

                 WRITE(6,600)'    Data:'
                 IF (datatype .EQ. CGNS_ENUMV(RealSingle)) THEN
                    CALL cg_array_read_f(iarray, data_single, ier)
                    IF (ier .EQ. ERROR) CALL cg_error_exit_f
                    WRITE(6,124) data_single(1)
                 ELSEIF (datatype .EQ. CGNS_ENUMV(RealDouble)) THEN
                    CALL cg_array_read_f(iarray, data_double, ier)
                    IF (ier .EQ. ERROR) CALL cg_error_exit_f
                    WRITE(6,124) data_double(1)
                 ENDIF
              ENDDO


              ! ** ReferenceState_t attributes: DimensionalUnits_t
              CALL cg_units_read_f(mass, length, time, temp, &
                   deg, ier)
              IF (ier .EQ. ERROR) CALL cg_error_exit_f
              IF (ier .EQ. ALL_OK) THEN
                 WRITE(6,100)&
                      '  Dimensional Units:', &
                      MassUnitsName(mass), LengthUnitsName(length), &
                      TemperatureUnitsName(temp), TimeUnitsName(time), &
                      AngleUnitsName(deg)
              ENDIF
           ENDIF  !if ReferenceState exists under ZoneBC_t

           CALL cg_nbocos_f(cg, base, zone, nbocos, ier)
           IF (ier .EQ. ERROR) CALL cg_error_exit_f
           WRITE(6,113)nbocos,' bound. conditions found for ', &
                zonename

           DO boco=1, nbocos
              CALL cg_boco_info_f(cg, base, zone, boco, boconame, &
                   bocotype, ptset_type, npnts, &
                   NormalIndex, NormalListSize, datatype, &
                   ndataset, ier)
              IF (ier .EQ. ERROR) CALL cg_error_exit_f
              WRITE(6,105) ' boundary condition #',boco
              WRITE(6,600) '  boconame=',boconame
              WRITE(6,600) '  bocotype=',BCTypeName(bocotype)
              WRITE(6,600) '  ptset_type=', &
                   PointSetTypeName(ptset_type)
              WRITE(6,103) '  NormalIndex=', &
                   NormalIndex(1),NormalIndex(2), NormalIndex(3)
              WRITE(6,104) '  NormalListSize=',NormalListSize
              WRITE(6,600) '  datatype for normals=', &
                   DataTypeName(datatype)

              ! read patch points and InwardNormalList
              IF (datatype.EQ.CGNS_ENUMV(RealSingle)) THEN
                 CALL cg_boco_read_f(cg, base, zone, boco, pnts, &
                      data_single, ier)
                 IF (ier .EQ. ERROR) CALL cg_error_exit_f
              ELSEIF (datatype.EQ.CGNS_ENUMV(RealDouble)) THEN
                 CALL cg_boco_read_f(cg, base, zone, boco, pnts, &
                      data_double, ier)
                 IF (ier .EQ. ERROR) CALL cg_error_exit_f
              ENDIF

              WRITE(6,119) '   Bound. Condition Patch:', &
                   '    first point:', pnts(1),pnts(2),pnts(3), &
                   '    last point :', pnts(3*npnts-2), pnts(3*npnts-1), &
                   pnts(3*npnts)

              IF (NormalListSize .NE. 0) THEN
                 IF (datatype.EQ.CGNS_ENUMV(RealSingle)) &
                      WRITE(6,126) '   Normals:', &
                      '    first point:', data_single(1),data_single(2), &
                      data_single(3), &
                      '    last point :', data_single(3*npnts-2), &
                      data_single(3*npnts-1), &
                      data_single(3*npnts)
                 IF (datatype.EQ.CGNS_ENUMV(RealDouble)) &
                      WRITE(6,126) '   Normals:', &
                      '    first point:', data_double(1),data_double(2), &
                      data_double(3), &
                      '    last point :', data_double(3*npnts-2), &
                      data_double(3*npnts-1), &
                      data_double(3*npnts)
              ENDIF
              ! ***  bound. condition attributes: GOTO BC_t node
              CALL cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                   'ZoneBC_t', one, 'BC_t', boco, 'end')
              IF (ier .EQ. ERROR) CALL cg_error_exit_f

              ! ***  bound. condition attributes: DataClass_t
              CALL cg_dataclass_read_f(TYPE,ier)
              IF (ier .EQ. ERROR) CALL cg_error_exit_f
              IF (ier.EQ.ALL_OK)&
                   WRITE(6,600)'  B.C. DataClass=', &
                   DataClassName(TYPE)

              ! ***  boundary condition attributes:  GridLocation_t
              CALL cg_gridlocation_read_f(location, ier)
              IF (ier .EQ. ERROR) CALL cg_error_exit_f
              IF (ier.EQ.ALL_OK)&
                   WRITE(6,600)'    data location=', &
                   GridLocationName(location)

              ! ** boundary condition dataset
              WRITE(6,103) '  ndataset=',ndataset
              DO idataset=1, ndataset
                 CALL cg_dataset_read_f(cg, base, zone, boco,idataset, &
                      name, TYPE, DirichletFlag, NeumannFlag, ier)
                 IF (ier .EQ. ERROR) CALL cg_error_exit_f

                 WRITE(6,103)'   Dataset #',idataset
                 WRITE(6,600)'    Name=',name
                 WRITE(6,600)'    BCType=',BCTypeName(TYPE)

                 ! ** boundary condition data:  GOTO BCData_t node
                 IF (DirichletFlag.EQ.1) THEN
                    CALL cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                         'ZoneBC_t', one, 'BC_t', boco, 'BCDataSet_t', &
                         idataset,'BCData_t',CGNS_ENUMV(Dirichlet),'end')
                    IF (ier .EQ. ERROR) CALL cg_error_exit_f

                    ! ** boundary condition data attributes: DataClass_t
                    WRITE(6,401)'   Dirichlet DataSet:'
                    CALL cg_dataclass_read_f(TYPE,ier)
                    IF (ier .EQ. ERROR) CALL cg_error_exit_f
                    WRITE(6,600)'    DataClass=', &
                         DataClassName(TYPE)

                    ! ** boundary condition data attributes: DataArray_t
                    CALL cg_narrays_f(narrays, ier)
                    IF (ier .EQ. ERROR) CALL cg_error_exit_f
                    WRITE(6,127) '    DirichletData', &
                         ' contains ', narrays,' data arrays'
                    DO iarray=1, narrays
                       CALL cg_array_info_f(iarray, name, datatype, &
                            nndim, dim_vals, ier)
                       IF (ier .EQ. ERROR) CALL cg_error_exit_f

                       WRITE(6,105) '    DataArray #',iarray,':'
                       WRITE(6,600)'     Name =',name
                       WRITE(6,600)'     Datatype=', &
                            DataTypeName(datatype)

                       WRITE(6,105)'    Dirichlet Data:'
                       IF (datatype .EQ. CGNS_ENUMV(RealSingle)) THEN
                          CALL cg_array_read_f(iarray, data_single, ier)
                          IF (ier .EQ. ERROR) CALL cg_error_exit_f
                          WRITE(6,106)&
                               (data_single(n),n=1,dim_vals(1))

                       ELSEIF (datatype .EQ. CGNS_ENUMV(RealDouble)) THEN
                          CALL cg_array_read_f(iarray, data_double, ier)
                          IF (ier .EQ. ERROR) CALL cg_error_exit_f
                          WRITE(6,106)&
                               (data_double(n),n=1,dim_vals(1))
                       ENDIF
                    ENDDO
                 ENDIF

                 IF (NeumannFlag.EQ.1) THEN
                    CALL cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                         'ZoneBC_t', one, 'BC_t', boco, 'BCDataSet_t', &
                         idataset, 'BCData_t', CGNS_ENUMV(Neumann),'end')
                    IF (ier .EQ. ERROR) CALL cg_error_exit_f

                    ! ** boundary condition data attributes: DataClass_t
                    CALL cg_dataclass_read_f(TYPE,ier)
                    IF (ier .EQ. ERROR) CALL cg_error_exit_f
                    WRITE(6,600)'    DataClass=', &
                         DataClassName(TYPE)

                    ! ** boundary condition data attributes: DataArray_t
                    CALL cg_narrays_f(narrays, ier)
                    IF (ier .EQ. ERROR) CALL cg_error_exit_f
                    WRITE(6,105) &
                         '    Neumann Data contains ', narrays,' data arrays'
                    DO iarray=1, narrays
                       CALL cg_array_info_f(iarray, name, datatype, &
                            nndim, dim_vals, ier)
                       IF (ier .EQ. ERROR) CALL cg_error_exit_f

                       WRITE(6,105) '    DataArray #',iarray,':'
                       WRITE(6,600)'     Name =',name
                       WRITE(6,600)'     Datatype=', &
                            DataTypeName(datatype)

                       WRITE(6,400)'    Neumann Data:'
                       IF (datatype .EQ. CGNS_ENUMV(RealSingle)) THEN
                          CALL cg_array_read_f(iarray, data_single, ier)
                          IF (ier .EQ. ERROR) CALL cg_error_exit_f
                          WRITE(6,106)&
                               (data_single(n),n=1,dim_vals(1))

                       ELSEIF (datatype .EQ. CGNS_ENUMV(RealDouble)) THEN
                          CALL cg_array_read_f(iarray, data_double, ier)
                          IF (ier .EQ. ERROR) CALL cg_error_exit_f
                          WRITE(6,106)&
                               (data_double(n),n=1,num)
                       ENDIF

                    ENDDO     ! loop through DataArray
                 ENDIF          ! if Neumann
              ENDDO          ! loop through dataset
           ENDDO          ! loop through boco
        ENDIF                  ! if ZoneBC_t exists
     ENDDO               ! zone loop

     WRITE(6,400)'                             *     *     *'

     ! *** connectivity 1to1 - Global
     WRITE(6,600)' Reading 1to1 connectivity for entire Base'
     CALL cg_n1to1_global_f(cg, base, n1to1_global, ier)
     IF (ier .EQ. ERROR) CALL cg_error_exit_f
     WRITE(6,200)'n1to1_global=',n1to1_global

     IF (n1to1_global .GT. 0) THEN
        CALL cg_1to1_read_global_f(cg, base, &
             G_connectname, G_zonename, G_donorname, &
             G_range, G_donor_range, G_transform, ier)
        IF (ier .EQ. ERROR) CALL cg_error_exit_f

        DO i=1, n1to1_global
           WRITE(6,600) ' '
           WRITE(6,130) '*** interface #',i,' ***'
           WRITE(6,600) 'G_connectname="',TRIM(G_connectname(i)),'"'
           WRITE(6,600) 'G_zonename   ="',TRIM(G_zonename(i)),'"'
           WRITE(6,600) 'G_donorname  ="',TRIM(G_donorname(i)),'"'

           WRITE(6,131) 'G_range: ', &
                '(',G_range(1,i),',',G_range(2,i),',',G_range(3,i), &
                ') to (',G_range(4,i),',',G_range(5,i),',',G_range(6,i),')'

           WRITE(6,132) 'G_donor_range: ', &
                '(', G_donor_range(1,i), ',', G_donor_range(2,i), ',', &
                G_donor_range(3,i), ') to (', &
                G_donor_range(4,i), ',', G_donor_range(5,i), ',', &
                G_donor_range(6,i), ')'

           WRITE(6,133) 'Transform: ', '(', &
                G_transform(1,i), ',', &
                G_transform(2,i), ',', G_transform(3,i), ')'
        ENDDO
     ENDIF


  ENDDO        ! loop through bases

  WRITE(6,400)'                             *     *     *'

  CALL cg_close_f(cg, ier)
  IF (ier .EQ. ERROR) CALL cg_error_exit_f

100 FORMAT(a/,'    Mass units: ',a/,'    Length units: ',a/, &
       '    Temperature units: ',a/,'    Time units: ',a/, &
       '    Angle units:',a)
101 FORMAT(A,I1,A,4(/A),/A,i4,A,/A,/A,/A,I4)
102 FORMAT(a,f5.3)
103 FORMAT(a,6i2)
104 FORMAT(a,i5,3a)
105 FORMAT(a,i2,a)
106 FORMAT(6f10.3)
107 FORMAT(i2,2a)
108 FORMAT(a,i2,a,i2,a)
109 FORMAT(a,f5.1)
110 FORMAT(a,5f5.1)
111 FORMAT(a,i1,a,i8)
112 FORMAT(a,i1/2a/3a)
113 FORMAT(i1,3a)
114 FORMAT(/a, i1)
115 FORMAT(a,i1,a/3a/2a)
116 FORMAT(a,i1,a,i1,a)
117 FORMAT(/i4,2a)
118 FORMAT(a,i1,a/3a/2a/a,i1,a,i5)
119 FORMAT(a/a,3i2/a,3i2)
120 FORMAT(a10, 3(a1,i1),a6,3(i1,a1))
121 FORMAT(a16,3(a1,i1),a6,3(i1,a1))
122 FORMAT(a12,3(a1,i2),a1)
124 FORMAT(4x, f7.2)
126 FORMAT(a/a,3f5.2/a,3f5.2)
127 FORMAT(2a,i1,a)
130 FORMAT(a15, i2, a4)
131 FORMAT(a10, 3(a1,i1),a6,3(i1,a1))
132 FORMAT(a16,3(a1,i1),a6,3(i1,a1))
133 FORMAT(a12,3(a1,i2),a1)
200 FORMAT(a,i5)
300 FORMAT(3a/a,i2)
400 FORMAT(/a/)
401 FORMAT(/2a/)
500 FORMAT(3a/3a)
600 FORMAT(3a)

9999 END PROGRAM read_cgns_1

      PROGRAM TEST
      USE CGNS

!---- This code has been modified to use the cgio interface
!---- The old ADF code has been left in to show the difference
!
!     SAMPLE ADF TEST PROGRAM TO BUILD ADF FILES ILLUSTRATED
!     IN THE EXAMPLE DATABASE FIGURE
!
      PARAMETER (MAXCHR=32)
!
      CHARACTER*(MAXCHR) TSTLBL,DTYPE
      CHARACTER*(MAXCHR) FNAM,PATH
!
      REAL*8 RID,PID,CID,TMPID,RIDF2
      REAL*4 A(4,3),B(4,3)
!      INTEGER IC(6),ID(6)
      integer*4 ic(6),id(6)
      INTEGER IERR,cgnum
      INTEGER(CGSIZE_T) IDIMC, IDIMD, IDIM(2)
      INTEGER(CGSIZE_T) IDIMA(2)
!
      DATA A /1.1,2.1,3.1,4.1, &
              1.2,2.2,3.2,4.2, &
              1.3,2.3,3.3,4.3/
      DATA IDIMA /4,3/
!
      DATA IC /1,2,3,4,5,6/
      DATA IDIMC /6/
!
      integer FILE_NONE, FILE_ADF, FILE_HDF5
      parameter (FILE_NONE = 0)
      parameter (FILE_ADF  = 1)
      parameter (FILE_HDF5 = 2)
!
!     SET ERROR FLAG TO ABORT ON ERROR
!
!      CALL ADFSES(1,IERR)
!
! *** 1.) OPEN 1ST DATABASE (ADF_FILE_TWO.ADF)
!     2.) CREATE THREE NODES AT FIRST LEVEL
!     3.) PUT LABEL ON NODE F3
!     4.) PUT DATA IN F3
!     5.) CREATE TWO NODES BELOW F3
!     6.) CLOSE DATABASE
!
!      CALL ADFDOPN('adf_file_two.adf','NEW',' ',RID,IERR)
      call cgio_open_file_f('adf_file_two.adf',MODE_WRITE,FILE_ADF, &
                            cgnum,ierr)
      call cgio_get_root_id_f(cgnum,rid,ierr)
      RIDF2 = RID
!      CALL ADFCRE(RID,'F1',TMPID,IERR)
      call cgio_create_node_f(cgnum,rid,'F1',tmpid,ierr)
!      CALL ADFCRE(RID,'F2',TMPID,IERR)
      call cgio_create_node_f(cgnum,rid,'F2',tmpid,ierr)
!      CALL ADFCRE(RID,'F3',PID,IERR)
      call cgio_create_node_f(cgnum,rid,'F3',pid,ierr)
!      CALL ADFSLB(PID,'LABEL ON NODE F3',IERR)
      call cgio_set_label_f(cgnum,pid,'LABEL ON NODE F3',ierr)
!      CALL ADFPDIM(PID,'R4',2,IDIMA,IERR)
      call cgio_set_dimensions_f(cgnum,pid,'R4',2,idima,ierr)
!      CALL ADFWALL(PID,A,IERR)
      call cgio_write_all_data_f(cgnum,pid,a,ierr)
!
!      CALL ADFCRE(PID,'F4',CID,IERR)
      call cgio_create_node_f(cgnum,pid,'F4',cid,ierr)
!
!      CALL ADFCRE(PID,'F5',CID,IERR)
      call cgio_create_node_f(cgnum,pid,'F5',cid,ierr)
!
!      CALL ADFDCLO(RID,IERR)
      call cgio_close_file_f(cgnum,ierr)
!
! *** 1.) OPEN 2ND DATABASE
!     2.) CREATE NODES
!     3.) PUT DATA IN N13
!
!      CALL ADFDOPN('adf_file_one.adf','NEW',' ',RID,IERR)
      call cgio_open_file_f('adf_file_one.adf',MODE_WRITE,FILE_ADF, &
                            cgnum,ierr)
      call cgio_get_root_id_f(cgnum,rid,ierr)
!
!     THREE NODES UNDER ROOT
!
!      CALL ADFCRE(RID,'N1',TMPID,IERR)
      call cgio_create_node_f(cgnum,rid,'N1',tmpid,ierr)
!      CALL ADFCRE(RID,'N2',TMPID,IERR)
      call cgio_create_node_f(cgnum,rid,'N2',tmpid,ierr)
!      CALL ADFCRE(RID,'N3',TMPID,IERR)
      call cgio_create_node_f(cgnum,rid,'N3',tmpid,ierr)
!
!     THREE NODES UNDER N1 (TWO REGULAR AND ONE LINK)
!
!      CALL ADFGNID(RID,'N1',PID,IERR)
      call cgio_get_node_id_f(cgnum,rid,'N1',pid,ierr)
!      CALL ADFCRE(PID,'N4',TMPID,IERR)
      call cgio_create_node_f(cgnum,pid,'N4',tmpid,ierr)
!      CALL ADFLINK(PID,'L3','adf_file_two.adf','/F3',TMPID,IERR)
      call cgio_create_link_f(cgnum,pid,'L3','adf_file_two.adf','/F3', &
                              tmpid,ierr)
!      CALL ADFCRE(PID,'N5',TMPID,IERR)
      call cgio_create_node_f(cgnum,pid,'N5',tmpid,ierr)
!
!     TWO NODES UNDER N4
!
!      CALL ADFGNID(PID,'N4',CID,IERR)
      call cgio_get_node_id_f(cgnum,pid,'N4',cid,ierr)
!      CALL ADFCRE(CID,'N6',TMPID,IERR)
      call cgio_create_node_f(cgnum,cid,'N6',tmpid,ierr)
!      CALL ADFCRE(CID,'N7',TMPID,IERR)
      call cgio_create_node_f(cgnum,cid,'N7',tmpid,ierr)
!
!     ONE NODE UNDER N6
!
!      CALL ADFGNID(RID,'/N1/N4/N6',PID,IERR)
      call cgio_get_node_id_f(cgnum,rid,'/N1/N4/N6',pid,ierr)
!      CALL ADFCRE(PID,'N8',TMPID,IERR)
      call cgio_create_node_f(cgnum,pid,'N8',tmpid,ierr)
!
!     THREE NODES UNDER N3
!
!      CALL ADFGNID(RID,'N3',PID,IERR)
      call cgio_get_node_id_f(cgnum,rid,'N3',pid,ierr)
!      CALL ADFCRE(PID,'N9',TMPID,IERR)
      call cgio_create_node_f(cgnum,pid,'N9',tmpid,ierr)
!      CALL ADFCRE(PID,'N10',TMPID,IERR)
      call cgio_create_node_f(cgnum,pid,'N10',tmpid,ierr)
!      CALL ADFCRE(PID,'N11',TMPID,IERR)
      call cgio_create_node_f(cgnum,pid,'N11',tmpid,ierr)
!
!     TWO NODES UNDER N9
!
!      CALL ADFGNID(PID,'N9',CID,IERR)
      call cgio_get_node_id_f(cgnum,pid,'N9',cid,ierr)
!      CALL ADFCRE(CID,'N12',TMPID,IERR)
      call cgio_create_node_f(cgnum,cid,'N12',tmpid,ierr)
!      CALL ADFCRE(CID,'N13',TMPID,IERR)
      call cgio_create_node_f(cgnum,cid,'N13',tmpid,ierr)
!
!     PUT LABEL AND DATA IN N13
!
!      CALL ADFSLB(TMPID,'LABEL ON NODE N13',IERR)
      call cgio_set_label_f(cgnum,tmpid,'LABEL ON NODE N13',ierr)
!      CALL ADFPDIM(TMPID,'I4',1,IDIMC,IERR)
      call cgio_set_dimensions_f(cgnum,tmpid,'I4',1,idimc,ierr)
!      CALL ADFWALL(TMPID,IC,IERR)
      call cgio_write_all_data_f(cgnum,tmpid,ic,ierr)
!
!     TWO NODES UNDER N10
!
!      CALL ADFGNID(RID,'/N3/N10',PID,IERR)
      call cgio_get_node_id_f(cgnum,rid,'/N3/N10',pid,ierr)
!      CALL ADFLINK(PID,'L1',' ','/N3/N9/N13',TMPID,IERR)
      call cgio_create_link_f(cgnum,pid,'L1',CHAR(0),'/N3/N9/N13', &
                              tmpid,ierr)
!      CALL ADFCRE(PID,'N14',TMPID,IERR)
      call cgio_create_node_f(cgnum,pid,'N14',tmpid,ierr)
!
!     TWO NODES UNDER N11
!
!      CALL ADFGNID(RID,'/N3/N11',PID,IERR)
      call cgio_get_node_id_f(cgnum,rid,'/N3/N11',pid,ierr)
!      CALL ADFLINK(PID,'L2',' ','/N3/N9/N13',TMPID,IERR)
      call cgio_create_link_f(cgnum,pid,'L2',CHAR(0),'/N3/N9/N13', &
                              tmpid,ierr)
!      CALL ADFCRE(PID,'N15',TMPID,IERR)
      call cgio_create_node_f(cgnum,pid,'N15',tmpid,ierr)
!
! *** READ AND PRINT DATA FROM NODES
!     1.) NODE F5 THROUGH LINK L3
!
!      CALL ADFGNID(RID,'/N1/L3',PID,IERR)
      call cgio_get_node_id_f(cgnum,rid,'/N1/L3',pid,ierr)
!      CALL ADFGLB(PID,TSTLBL,IERR)
      call cgio_get_label_f(cgnum,pid,tstlbl,ierr)
!      CALL ADFGDT(PID,DTYPE,IERR)
      call cgio_get_data_type_f(cgnum,pid,dtype,ierr)
!      CALL ADFGND(PID,NUMDIM,IERR)
!      CALL ADFGDV(PID,IDIM,IERR)
      call cgio_get_dimensions_f(cgnum,pid,numdim,idim,ierr)
!      CALL ADFRALL(PID,B,IERR)
      call cgio_read_all_data_type_f(cgnum,pid,dtype,b,ierr)
      PRINT *,    ' NODE F3 THROUGH LINK L3:'
      PRINT *,    '   LABEL       = ',TSTLBL
      PRINT *,    '   DATA TYPE   = ',DTYPE
      WRITE(*,101)'   NUM OF DIMS = ',NUMDIM
      WRITE(*,102)'   DIM VALS    = ',IDIM
      PRINT *,'   DATA:'
      WRITE(*,100)((B(J,I),I=1,3),J=1,4)
  100 FORMAT(5X,3F10.2)
  101 FORMAT(A,I6)
  102 FORMAT(A,2I6)
!
!     2.) N13
!
!      CALL ADFGNID(RID,'N3/N9/N13',PID,IERR)
      call cgio_get_node_id_f(cgnum,rid,'N3/N9/N13',pid,ierr)
!      CALL ADFGLB(PID,TSTLBL,IERR)
      call cgio_get_label_f(cgnum,pid,tstlbl,ierr)
!      CALL ADFGDT(PID,DTYPE,IERR)
      call cgio_get_data_type_f(cgnum,pid,dtype,ierr)
!      CALL ADFGND(PID,NUMDIM,IERR)
!      CALL ADFGDV(PID,IDIMD,IERR)
      call cgio_get_dimensions_f(cgnum,pid,numdim,idimd,ierr)
!      CALL ADFRALL(PID,ID,IERR)
      call cgio_read_all_data_type_f(cgnum,pid,dtype,id,ierr)
      PRINT *,    ' '
      PRINT *,    ' NODE N13:'
      PRINT *,    '   LABEL       = ',TSTLBL
      PRINT *,    '   DATA TYPE   = ',DTYPE
      WRITE(*,101)'   NUM OF DIMS = ',NUMDIM
      WRITE(*,101)'   DIM VALS    = ',IDIMD
      PRINT *,    '   DATA:'
      WRITE(*,200)(ID(I),I=1,6)
  200 FORMAT(5X,6I6)
!
!     3.) N13 THROUGH L1
!
!      CALL ADFGNID(RID,'N3/N10/L1',TMPID,IERR)
      call cgio_get_node_id_f(cgnum,rid,'N3/N10/L1',tmpid,ierr)
!      CALL ADFGLB(TMPID,TSTLBL,IERR)
      call cgio_get_label_f(cgnum,tmpid,tstlbl,ierr)
!      CALL ADFRALL(TMPID,ID,IERR)
      call cgio_read_all_data_type_f(cgnum,tmpid,dtype,id,ierr)
      PRINT *,' '
      PRINT *,' NODE N13 THROUGH LINK L1:'
      PRINT *,'   LABEL       = ',TSTLBL
      PRINT *,'   DATA:'
      WRITE(*,200)(ID(I),I=1,6)
!
!     4.) N13 THROUGH L2
!
!      CALL ADFGNID(RID,'N3/N11/L2',CID,IERR)
      call cgio_get_node_id_f(cgnum,rid,'N3/N11/L2',cid,ierr)
!      CALL ADFGLB(CID,TSTLBL,IERR)
      call cgio_get_label_f(cgnum,cid,tstlbl,ierr)
!      CALL ADFRALL(CID,ID,IERR)
      call cgio_read_all_data_type_f(cgnum,cid,dtype,id,ierr)
      PRINT *,' '
      PRINT *,' NODE N13 THROUGH LINK L2:'
      PRINT *,'   LABEL       = ',TSTLBL
      PRINT *,'   DATA:'
      WRITE(*,200)(ID(I),I=1,6)
!
!     PRINT LIST OF CHILDREN UNDER ROOT NODE
!
!      CALL PRTCLD(RID)
      call prtcld(cgnum, rid)
!
!     PRINT LIST OF CHILDREN UNDER N3
!
!      CALL ADFGNID(RID,'N3',PID,IERR)
      call cgio_get_node_id_f(cgnum,rid,'N3',pid,ierr)
!      CALL PRTCLD(PID)
      call prtcld(cgnum, pid)
      call cgio_close_file_f(cgnum,ierr)
!
!     REOPEN ADF_FILE_TWO AND GET NEW ROOT ID
!
!      CALL ADFDOPN('adf_file_two.adf','OLD',' ',RID,IERR)
      call cgio_open_file_f('adf_file_two.adf',MODE_READ,FILE_NONE, &
                            cgnum,ierr)
      call cgio_get_root_id_f(cgnum,rid,ierr)
      call cgio_close_file_f(cgnum,ierr)
      PRINT *,' '
      PRINT *,' COMPARISON OF ROOT ID: '
      WRITE(*,'(A,F12.8)')' ADF_FILE_TWO.ADF ORIGINAL ROOT ID = ',RIDF2
      WRITE(*,'(A,F12.8)')' ADF_FILE_TWO.ADF NEW ROOT ID      = ',RID
!
      END
!
! ************* SUBROUTINES ****************
!
!      SUBROUTINE PRTCLD(PID)
      subroutine prtcld(cgnum, pid)
      USE CGNS
!
! *** PRINT TABLE OF CHILDREN GIVEN A PARENT NODE-ID
!
      integer cgnum,numc,ierr,istart,numret
      integer MAXCLD,MAXCHR
      PARAMETER (MAXCLD=10)
      PARAMETER (MAXCHR=32)
      REAL*8 PID
      CHARACTER*(MAXCHR) NODNAM,NDNMS(MAXCLD)

!      CALL ADFGNAM(PID,NODNAM,IERR)
      call cgio_get_name_f(cgnum,pid,nodnam,ierr)
!      CALL ADFNCLD(PID,NUMC,IERR)
      call cgio_number_children_f(cgnum,pid,numc,ierr)
      WRITE(*,120)NODNAM,NUMC
  120 FORMAT(/,' PARENT NODE NAME = ',A,/, &
             '     NUMBER OF CHILDREN = ',I2,/, &
             '     CHILDREN NAMES:')
      NLEFT = NUMC
      ISTART = 1
!     --- TOP OF DO-WHILE LOOP
  130 CONTINUE
!        CALL ADFCNAM(PID,ISTART,MAXCLD,LEN(NDNMS),
!---------------- g77 doesn't like this ^
!         CALL ADFCNAM(PID,ISTART,MAXCLD,MAXCHR,
!     X                NUMRET,NDNMS,IERR)
         call cgio_children_names_f(cgnum,pid,istart,maxcld,maxchr, &
                                    numret,ndnms,ierr)
         WRITE(*,140)(NDNMS(K),K=1,NUMRET)
  140    FORMAT(8X,A)
         NLEFT = NLEFT - MAXCLD
         ISTART = ISTART + MAXCLD
      IF (NLEFT .GT. 0) GO TO 130
      RETURN
      END

      program write_flowcent_str
      use cgns
      implicit none
!
!   Opens an existing CGNS file that contains a simple 3-D
!   structured grid, and adds a flow solution (at CELL CENTERS)
!   to it.  (Compare this program with write_flowvert_str)
!
!   The CGNS grid file 'grid.cgns' must already exist
!   (created using write_grid_str.f)
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c write_flowcent_str.F90
!   ifort -o write_flowcent_str write_flowcent_str.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superceded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
!   dimension statements (note that tri-dimensional arrays
!   r and p must be dimensioned exactly as (21-1,17-1,N-1) (N>=9)
!   for this particular case or else they will be written to
!   the CGNS file incorrectly!  Other options are to use 1-D
!   arrays, use dynamic memory, or pass index values to a
!   subroutine and dimension exactly there):
      real*8 r(20,16,8),p(20,16,8)
      integer index_field,index_flow,index_zone,index_base,index_file,ier
      integer i,j,k,ni,nj,nk
      character solname*32
!
      write(6,'('' Program write_flowcent_str'')')
      if (CG_BUILD_64BIT) then
        write(6,'('' ...compiled in 64-bit mode, but not needed'')')
      end if
!
!   create fake flow solution AT CELL CENTERS for simple example:
      ni=20
      nj=16
      nk=8
      do k=1,nk
        do j=1,nj
          do i=1,ni
            r(i,j,k)=float(i-1)
            p(i,j,k)=float(j-1)
          enddo
        enddo
      enddo
      write(6,'('' created simple 3-D rho and p flow solution'')')
!
!   WRITE FLOW SOLUTION TO EXISTING CGNS FILE
!   open CGNS file for modify
      call cg_open_f('grid.cgns',CG_MODE_MODIFY,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!   we know there is only one base (real working code would check!)
      index_base=1
!   we know there is only one zone (real working code would check!)
      index_zone=1
!   define flow solution node name (user can give any name)
      solname = 'FlowSolution'
!   create flow solution node (NOTE USE OF CellCenter HERE)
      call cg_sol_write_f(index_file,index_base,index_zone,solname,            &
           CellCenter,index_flow,ier)
!   write flow solution (user must use SIDS-standard names here)
      call cg_field_write_f(index_file,index_base,index_zone,index_flow,       &
           RealDouble,'Density',r,index_field,ier)
      call cg_field_write_f(index_file,index_base,index_zone,index_flow,       &
           RealDouble,'Pressure',p,index_field,ier)
!   close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully added CellCenter flow solution data'',         &
       '' to file grid.cgns'')')
      write(6,'(''   Note:  if the original CGNS file already had'',           &
       '' a FlowSolution_t node,'')')
      write(6,'(''          it has been overwritten'')')
      stop
      end

      program read_dimensional
      use cgns
      implicit none
!
!   Opens an existing CGNS file that contains a simple 3-D
!   grid plus a flow solution WITH DIMENSIONALITY, and reads
!   the dimensionality.
!
!   The CGNS grid file 'grid.cgns' must already exist
!   (for example, created using
!       write_grid_str.f followed by write_flowcent_str.f or
!       write_grid_str.f followed by write_flowvert_str.f or
!       write_grid_str.f followed by write_flowcentrind_str.f or
!       write_grid_unst.f followed by write_flowvert_unst.f
!   followed by write_dimensional.f)
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c read_dimensional.F90
!   ifort -o read_dimensional read_dimensional.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
      real*4 exponents(5)
      integer ic,ncoords,idatatype,iff,nfields,ia,ix,it,il,im,id
      integer index_grid,index_flow,index_zone,index_base,index_file,ier
      character fieldname*32,coordname*32
!
!   READ DIMENSIONAL INFO FOR GRID AND FLOW SOLN
!   open CGNS file for read-only
      call cg_open_f('grid.cgns',CG_MODE_READ,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!   we know there is only one base (real working code would check!)
      index_base=1
!   we know there is only one zone (real working code would check!)
      index_zone=1
!   we know there is only one FlowSolution_t (real working code would check!)
      index_flow=1
!   we know there is only one GridCoordinates_t (real working code would check!)
      index_grid=1
!   read DataClass and DimensionalUnits under Base
      call cg_goto_f(index_file,index_base,ier,'end')
      call cg_dataclass_read_f(id,ier)
      write(6,'('' DataClass = '',a32)') DataClassName(id)
      if (DataClassName(id) .ne. 'Dimensional') then
        write(6,'('' Error!  Expecting Dimensional'')')
        stop
      end if
      call cg_units_read_f(im,il,it,ix,ia,ier)
      write(6,'('' Units='',5(/,8x,a32))') MassUnitsName(im),                  &
       LengthUnitsName(il),TimeUnitsName(it),                                  &
       TemperatureUnitsName(ix),AngleUnitsName(ia)
!   read fields
      call cg_nfields_f(index_file,index_base,index_zone,index_flow,           &
           nfields,ier)
      if (nfields .ne. 2) then
        write(6,'('' Error! expecting 2 fields, read '',i5)') nfields
        stop
      end if
      do iff=1,nfields
!   read DimensionalExponents
        call cg_goto_f(index_file,index_base,ier,'Zone_t',1,                   &
             'FlowSolution_t',1,'DataArray_t',iff,'end')
        call cg_exponents_read_f(exponents,ier)
!   get field name
        call cg_field_info_f(index_file,index_base,index_zone,                 &
             index_flow,iff,idatatype,fieldname,ier)
        write(6,'('' For '',a32,'', exponents are:'',5(/,6x,f5.1))')           &
          fieldname,exponents(1),exponents(2),exponents(3),exponents(4),       &
          exponents(5)
      enddo
!   read grid
      call cg_ncoords_f(index_file,index_base,index_zone,ncoords,ier)
      do ic=1,ncoords
!   read DimensionalExponents
        call cg_goto_f(index_file,index_base,ier,'Zone_t',1,                   &
             'GridCoordinates_t',1,'DataArray_t',ic,'end')
        call cg_exponents_read_f(exponents,ier)
!   get coord name
        call cg_coord_info_f(index_file,index_base,index_zone,                 &
         ic,idatatype,coordname,ier)
        write(6,'('' For '',a32,'', exponents are:'',5(/,6x,f5.1))')           &
       coordname,exponents(1),exponents(2),exponents(3),exponents(4),          &
          exponents(5)
      enddo
!   close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully read dimensional data from file'',             &
       '' grid.cgns'')')
      stop
      end

      PROGRAM TEST
      USE CGNS

c---- This code has been modified to use the cgio interface
c---- The old ADF code has been left in to show the difference
C
C     SAMPLE ADF TEST PROGRAM TO BUILD ADF FILES ILLUSTRATED
C     IN THE EXAMPLE DATABASE FIGURE
C
      PARAMETER (MAXCHR=32)
C
      CHARACTER*(MAXCHR) TSTLBL,DTYPE
      CHARACTER*(MAXCHR) FNAM,PATH
C
      REAL*8 RID,PID,CID,TMPID,RIDF2
      REAL*4 A(4,3),B(4,3)
c      INTEGER IC(6),ID(6)
      integer*4 ic(6),id(6)
      INTEGER IERR,cgnum
      INTEGER(CGSIZE_T) IDIMC, IDIMD, IDIM(2)
      INTEGER(CGSIZE_T) IDIMA(2)
C
      DATA A /1.1,2.1,3.1,4.1,
     X        1.2,2.2,3.2,4.2,
     X        1.3,2.3,3.3,4.3/
      DATA IDIMA /4,3/
C
      DATA IC /1,2,3,4,5,6/
      DATA IDIMC /6/
c
      integer FILE_NONE, FILE_ADF, FILE_HDF5
      parameter (FILE_NONE = 0)
      parameter (FILE_ADF  = 1)
      parameter (FILE_HDF5 = 2)
C
C     SET ERROR FLAG TO ABORT ON ERROR
C
C      CALL ADFSES(1,IERR)
C
C *** 1.) OPEN 1ST DATABASE (ADF_FILE_TWO.ADF)
C     2.) CREATE THREE NODES AT FIRST LEVEL
C     3.) PUT LABEL ON NODE F3
C     4.) PUT DATA IN F3
C     5.) CREATE TWO NODES BELOW F3
C     6.) CLOSE DATABASE
C
c      CALL ADFDOPN('adf_file_two.adf','NEW',' ',RID,IERR)
      call cgio_open_file_f('adf_file_two.adf',MODE_WRITE,FILE_ADF,
     &                      cgnum,ierr)
      call cgio_get_root_id_f(cgnum,rid,ierr)
      RIDF2 = RID
c      CALL ADFCRE(RID,'F1',TMPID,IERR)
      call cgio_create_node_f(cgnum,rid,'F1',tmpid,ierr)
c      CALL ADFCRE(RID,'F2',TMPID,IERR)
      call cgio_create_node_f(cgnum,rid,'F2',tmpid,ierr)
c      CALL ADFCRE(RID,'F3',PID,IERR)
      call cgio_create_node_f(cgnum,rid,'F3',pid,ierr)
c      CALL ADFSLB(PID,'LABEL ON NODE F3',IERR)
      call cgio_set_label_f(cgnum,pid,'LABEL ON NODE F3',ierr)
c      CALL ADFPDIM(PID,'R4',2,IDIMA,IERR)
      call cgio_set_dimensions_f(cgnum,pid,'R4',2,idima,ierr)
c      CALL ADFWALL(PID,A,IERR)
      call cgio_write_all_data_f(cgnum,pid,a,ierr)
C
c      CALL ADFCRE(PID,'F4',CID,IERR)
      call cgio_create_node_f(cgnum,pid,'F4',cid,ierr)
C
c      CALL ADFCRE(PID,'F5',CID,IERR)
      call cgio_create_node_f(cgnum,pid,'F5',cid,ierr)
C
c      CALL ADFDCLO(RID,IERR)
      call cgio_close_file_f(cgnum,ierr)
C
C *** 1.) OPEN 2ND DATABASE
C     2.) CREATE NODES
C     3.) PUT DATA IN N13
C
c      CALL ADFDOPN('adf_file_one.adf','NEW',' ',RID,IERR)
      call cgio_open_file_f('adf_file_one.adf',MODE_WRITE,FILE_ADF,
     &                      cgnum,ierr)
      call cgio_get_root_id_f(cgnum,rid,ierr)
C
C     THREE NODES UNDER ROOT
C
c      CALL ADFCRE(RID,'N1',TMPID,IERR)
      call cgio_create_node_f(cgnum,rid,'N1',tmpid,ierr)
c      CALL ADFCRE(RID,'N2',TMPID,IERR)
      call cgio_create_node_f(cgnum,rid,'N2',tmpid,ierr)
c      CALL ADFCRE(RID,'N3',TMPID,IERR)
      call cgio_create_node_f(cgnum,rid,'N3',tmpid,ierr)
C
C     THREE NODES UNDER N1 (TWO REGULAR AND ONE LINK)
C
c      CALL ADFGNID(RID,'N1',PID,IERR)
      call cgio_get_node_id_f(cgnum,rid,'N1',pid,ierr)
c      CALL ADFCRE(PID,'N4',TMPID,IERR)
      call cgio_create_node_f(cgnum,pid,'N4',tmpid,ierr)
c      CALL ADFLINK(PID,'L3','adf_file_two.adf','/F3',TMPID,IERR)
      call cgio_create_link_f(cgnum,pid,'L3','adf_file_two.adf','/F3',
     &                        tmpid,ierr)
c      CALL ADFCRE(PID,'N5',TMPID,IERR)
      call cgio_create_node_f(cgnum,pid,'N5',tmpid,ierr)
C
C     TWO NODES UNDER N4
C
c      CALL ADFGNID(PID,'N4',CID,IERR)
      call cgio_get_node_id_f(cgnum,pid,'N4',cid,ierr)
c      CALL ADFCRE(CID,'N6',TMPID,IERR)
      call cgio_create_node_f(cgnum,cid,'N6',tmpid,ierr)
c      CALL ADFCRE(CID,'N7',TMPID,IERR)
      call cgio_create_node_f(cgnum,cid,'N7',tmpid,ierr)
C
C     ONE NODE UNDER N6
C
c      CALL ADFGNID(RID,'/N1/N4/N6',PID,IERR)
      call cgio_get_node_id_f(cgnum,rid,'/N1/N4/N6',pid,ierr)
c      CALL ADFCRE(PID,'N8',TMPID,IERR)
      call cgio_create_node_f(cgnum,pid,'N8',tmpid,ierr)
C
C     THREE NODES UNDER N3
C
c      CALL ADFGNID(RID,'N3',PID,IERR)
      call cgio_get_node_id_f(cgnum,rid,'N3',pid,ierr)
c      CALL ADFCRE(PID,'N9',TMPID,IERR)
      call cgio_create_node_f(cgnum,pid,'N9',tmpid,ierr)
c      CALL ADFCRE(PID,'N10',TMPID,IERR)
      call cgio_create_node_f(cgnum,pid,'N10',tmpid,ierr)
c      CALL ADFCRE(PID,'N11',TMPID,IERR)
      call cgio_create_node_f(cgnum,pid,'N11',tmpid,ierr)
C
C     TWO NODES UNDER N9
C
c      CALL ADFGNID(PID,'N9',CID,IERR)
      call cgio_get_node_id_f(cgnum,pid,'N9',cid,ierr)
c      CALL ADFCRE(CID,'N12',TMPID,IERR)
      call cgio_create_node_f(cgnum,cid,'N12',tmpid,ierr)
c      CALL ADFCRE(CID,'N13',TMPID,IERR)
      call cgio_create_node_f(cgnum,cid,'N13',tmpid,ierr)
C
C     PUT LABEL AND DATA IN N13
C
c      CALL ADFSLB(TMPID,'LABEL ON NODE N13',IERR)
      call cgio_set_label_f(cgnum,tmpid,'LABEL ON NODE N13',ierr)
c      CALL ADFPDIM(TMPID,'I4',1,IDIMC,IERR)
      call cgio_set_dimensions_f(cgnum,tmpid,'I4',1,idimc,ierr)
c      CALL ADFWALL(TMPID,IC,IERR)
      call cgio_write_all_data_f(cgnum,tmpid,ic,ierr)
C
C     TWO NODES UNDER N10
C
c      CALL ADFGNID(RID,'/N3/N10',PID,IERR)
      call cgio_get_node_id_f(cgnum,rid,'/N3/N10',pid,ierr)
c      CALL ADFLINK(PID,'L1',' ','/N3/N9/N13',TMPID,IERR)
      call cgio_create_link_f(cgnum,pid,'L1',CHAR(0),'/N3/N9/N13',
     &                        tmpid,ierr)
c      CALL ADFCRE(PID,'N14',TMPID,IERR)
      call cgio_create_node_f(cgnum,pid,'N14',tmpid,ierr)
C
C     TWO NODES UNDER N11
C
c      CALL ADFGNID(RID,'/N3/N11',PID,IERR)
      call cgio_get_node_id_f(cgnum,rid,'/N3/N11',pid,ierr)
c      CALL ADFLINK(PID,'L2',' ','/N3/N9/N13',TMPID,IERR)
      call cgio_create_link_f(cgnum,pid,'L2',CHAR(0),'/N3/N9/N13',
     &                        tmpid,ierr)
c      CALL ADFCRE(PID,'N15',TMPID,IERR)
      call cgio_create_node_f(cgnum,pid,'N15',tmpid,ierr)
C
C *** READ AND PRINT DATA FROM NODES
C     1.) NODE F5 THROUGH LINK L3
C
c      CALL ADFGNID(RID,'/N1/L3',PID,IERR)
      call cgio_get_node_id_f(cgnum,rid,'/N1/L3',pid,ierr)
c      CALL ADFGLB(PID,TSTLBL,IERR)
      call cgio_get_label_f(cgnum,pid,tstlbl,ierr)
c      CALL ADFGDT(PID,DTYPE,IERR)
      call cgio_get_data_type_f(cgnum,pid,dtype,ierr)
c      CALL ADFGND(PID,NUMDIM,IERR)
c      CALL ADFGDV(PID,IDIM,IERR)
      call cgio_get_dimensions_f(cgnum,pid,numdim,idim,ierr)
c      CALL ADFRALL(PID,B,IERR)
      call cgio_read_all_data_f(cgnum,pid,b,ierr)
      PRINT *,    ' NODE F3 THROUGH LINK L3:'
      PRINT *,    '   LABEL       = ',TSTLBL
      PRINT *,    '   DATA TYPE   = ',DTYPE
      WRITE(*,101)'   NUM OF DIMS = ',NUMDIM
      WRITE(*,102)'   DIM VALS    = ',IDIM
      PRINT *,'   DATA:'
      WRITE(*,100)((B(J,I),I=1,3),J=1,4)
  100 FORMAT(5X,3F10.2)
  101 FORMAT(A,I6)
  102 FORMAT(A,2I6)
C
C     2.) N13
C
c      CALL ADFGNID(RID,'N3/N9/N13',PID,IERR)
      call cgio_get_node_id_f(cgnum,rid,'N3/N9/N13',pid,ierr)
c      CALL ADFGLB(PID,TSTLBL,IERR)
      call cgio_get_label_f(cgnum,pid,tstlbl,ierr)
c      CALL ADFGDT(PID,DTYPE,IERR)
      call cgio_get_data_type_f(cgnum,pid,dtype,ierr)
c      CALL ADFGND(PID,NUMDIM,IERR)
c      CALL ADFGDV(PID,IDIMD,IERR)
      call cgio_get_dimensions_f(cgnum,pid,numdim,idimd,ierr)
c      CALL ADFRALL(PID,ID,IERR)
      call cgio_read_all_data_f(cgnum,pid,id,ierr)
      PRINT *,    ' '
      PRINT *,    ' NODE N13:'
      PRINT *,    '   LABEL       = ',TSTLBL
      PRINT *,    '   DATA TYPE   = ',DTYPE
      WRITE(*,101)'   NUM OF DIMS = ',NUMDIM
      WRITE(*,101)'   DIM VALS    = ',IDIMD
      PRINT *,    '   DATA:'
      WRITE(*,200)(ID(I),I=1,6)
  200 FORMAT(5X,6I6)
C
C     3.) N13 THROUGH L1
C
c      CALL ADFGNID(RID,'N3/N10/L1',TMPID,IERR)
      call cgio_get_node_id_f(cgnum,rid,'N3/N10/L1',tmpid,ierr)
c      CALL ADFGLB(TMPID,TSTLBL,IERR)
      call cgio_get_label_f(cgnum,tmpid,tstlbl,ierr)
c      CALL ADFRALL(TMPID,ID,IERR)
      call cgio_read_all_data_f(cgnum,tmpid,id,ierr)
      PRINT *,' '
      PRINT *,' NODE N13 THROUGH LINK L1:'
      PRINT *,'   LABEL       = ',TSTLBL
      PRINT *,'   DATA:'
      WRITE(*,200)(ID(I),I=1,6)
C
C     4.) N13 THROUTH L2
C
c      CALL ADFGNID(RID,'N3/N11/L2',CID,IERR)
      call cgio_get_node_id_f(cgnum,rid,'N3/N11/L2',cid,ierr)
c      CALL ADFGLB(CID,TSTLBL,IERR)
      call cgio_get_label_f(cgnum,cid,tstlbl,ierr)
c      CALL ADFRALL(CID,ID,IERR)
      call cgio_read_all_data_f(cgnum,cid,id,ierr)
      PRINT *,' '
      PRINT *,' NODE N13 THROUGH LINK L2:'
      PRINT *,'   LABEL       = ',TSTLBL
      PRINT *,'   DATA:'
      WRITE(*,200)(ID(I),I=1,6)
C
C     PRINT LIST OF CHILDREN UNDER ROOT NODE
C
c      CALL PRTCLD(RID)
      call prtcld(cgnum, rid)
C
C     PRINT LIST OF CHILDREN UNDER N3
C
c      CALL ADFGNID(RID,'N3',PID,IERR)
      call cgio_get_node_id_f(cgnum,rid,'N3',pid,ierr)
c      CALL PRTCLD(PID)
      call prtcld(cgnum, pid)
      call cgio_close_file_f(cgnum,ierr)
C
C     REOPEN ADF_FILE_TWO AND GET NEW ROOT ID
C
c      CALL ADFDOPN('adf_file_two.adf','OLD',' ',RID,IERR)
      call cgio_open_file_f('adf_file_two.adf',MODE_READ,FILE_NONE,
     &                      cgnum,ierr)
      call cgio_get_root_id_f(cgnum,rid,ierr)
      call cgio_close_file_f(cgnum,ierr)
      PRINT *,' '
      PRINT *,' COMPARISON OF ROOT ID: '
      WRITE(*,'(A,F12.8)')' ADF_FILE_TWO.ADF ORIGINAL ROOT ID = ',RIDF2
      WRITE(*,'(A,F12.8)')' ADF_FILE_TWO.ADF NEW ROOT ID      = ',RID
C
      END
C
C ************* SUBROUTINES ****************
C
c      SUBROUTINE PRTCLD(PID)
      subroutine prtcld(cgnum, pid)
      USE CGNS
C
C *** PRINT TABLE OF CHILDREN GIVEN A PARENT NODE-ID
C
      integer cgnum,numc,ierr,istart,numret
      integer MAXCLD,MAXCHR
      PARAMETER (MAXCLD=10)
      PARAMETER (MAXCHR=32)
      REAL*8 PID
      CHARACTER*(MAXCHR) NODNAM,NDNMS(MAXCLD)

c      CALL ADFGNAM(PID,NODNAM,IERR)
      call cgio_get_name_f(cgnum,pid,nodnam,ierr)
c      CALL ADFNCLD(PID,NUMC,IERR)
      call cgio_number_children_f(cgnum,pid,numc,ierr)
      WRITE(*,120)NODNAM,NUMC
  120 FORMAT(/,' PARENT NODE NAME = ',A,/,
     X       '     NUMBER OF CHILDREN = ',I2,/,
     X       '     CHILDREN NAMES:')
      NLEFT = NUMC
      ISTART = 1
C     --- TOP OF DO-WHILE LOOP
  130 CONTINUE
C        CALL ADFCNAM(PID,ISTART,MAXCLD,LEN(NDNMS),
C---------------- g77 doesn't like this ^
c         CALL ADFCNAM(PID,ISTART,MAXCLD,MAXCHR,
c     X                NUMRET,NDNMS,IERR)
         call cgio_children_names_f(cgnum,pid,istart,maxcld,maxchr,
     &                              numret,ndnms,ierr)
         WRITE(*,140)(NDNMS(K),K=1,NUMRET)
  140    FORMAT(8X,A)
         NLEFT = NLEFT - MAXCLD
         ISTART = ISTART + MAXCLD
      IF (NLEFT .GT. 0) GO TO 130
      RETURN
      END

      program testfamilytreef

#include "cgnstypes_f03.h"
#ifdef WINNT
      include 'cgnswin_f.h'
#endif
      USE CGNS
      implicit none

      INTEGER, PARAMETER :: sp = KIND(1.0)
      integer, parameter :: NUM_SIDE = 5

      integer(cgsize_t) :: sizes(9)
      integer(cgsize_t) :: ptrange(6)
      integer(cgsize_t) :: npts
      integer :: celldim, physdim

      real(kind=sp), dimension(NUM_SIDE*NUM_SIDE*NUM_SIDE) :: xcoord
      real(kind=sp), dimension(NUM_SIDE*NUM_SIDE*NUM_SIDE) :: ycoord
      real(kind=sp), dimension(NUM_SIDE*NUM_SIDE*NUM_SIDE) :: zcoord

      integer :: ierr
      integer :: i, j, k, n, nfam, nb, ng, nnames
      integer :: cgfile, cgbase, cgtree, cgzone, cgfam, cgcoord
      integer :: cgbc, cgsr

      real(kind=sp), dimension(5) :: exponents
      character(len=32) outfile
      character(len=32) name
      character(len=32) tname
      character(len=20*33) :: family_name
      character(len=20*33) :: tfamily_name

! ----  WRITING TESTS  ----

      outfile = "family_tree_f90.cgns"
      !call unlink( outfile )
      ! write(*, *) 'Create file'
      call cg_open_f(outfile, CG_MODE_WRITE, cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      ! write(*, *) 'Create Grid Base'
      CALL cg_base_write_f( cgfile, 'Structured', 3, 3, cgbase, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      CALL cg_gopath_f( cgfile, '/Structured', ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f     
      call cg_dataclass_write_f( CGNS_ENUMV(Dimensional), ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f     
      call cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), &
     &                      CGNS_ENUMV(Second), CGNS_ENUMV(Kelvin), &
     &                      CGNS_ENUMV(Radian), ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f     

! -- Create Family Tree Base
      ! write(*, *) 'Create Family Tree Base'
      call cg_base_write_f( cgfile, "FamilyTree", 3, 3, cgtree, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f     

! --  SOME GRID DATA
      do n=1,3
        sizes(n)   = NUM_SIDE;
        sizes(n+3) = NUM_SIDE - 1;
        sizes(n+6) = 0;
      enddo
      n = 1
      do k = 1, NUM_SIDE
        do j = 1, NUM_SIDE
          do i = 1, NUM_SIDE
            xcoord(n) = i
            ycoord(n) = j
            zcoord(n) = k
            n = n + 1
          enddo
        enddo
      enddo

      do n = 1,5
        exponents(n) = 0.0
      enddo
      exponents(2) = 1.0
      call cg_zone_write_f(cgfile, cgbase, "Zone", sizes, &
     &                    CGNS_ENUMV(Structured), cgzone, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_coord_write_f(cgfile, cgbase, cgzone, CGNS_ENUMV(RealSingle), &
     &       "CoordinateX", xcoord, cgcoord, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_coord_write_f(cgfile, cgbase, cgzone, CGNS_ENUMV(RealSingle), &
     &       "CoordinateY", ycoord, cgcoord, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_coord_write_f(cgfile, cgbase, cgzone, CGNS_ENUMV(RealSingle), &
     &       "CoordinateZ", zcoord, cgcoord, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_goto_f(cgfile, cgbase, ierr, "Zone_t", cgzone, &
     &       "GridCoordinates_t", 1, &
     &       "CoordinateX", 0, 'end')
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_gopath_f(cgfile,                                  &
     &    "/Structured/Zone/GridCoordinates/CoordinateX", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_exponents_write_f(CGNS_ENUMV(RealSingle), exponents, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_gopath_f(cgfile, "../CoordinateY", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_exponents_write_f(CGNS_ENUMV(RealSingle), exponents, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_gopath_f(cgfile, "../CoordinateZ", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_exponents_write_f(CGNS_ENUMV(RealSingle), exponents, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

! -- Write Family Tree
!    
! FamilyTree
!   +- Family1
!   |  +- Family1.1
!   |  |  +- Family1.1.1
!   |  +- Family1.2
!   |     +- Family1.2.1
!   |        +- Family1.2.1.1      will be deleted (direct deletion)
!   |        +- Family1.2.1.2      will be overwritten
!   +- Family2
!   |  +- Family2.1
!   |     +- Family2.1.1
!   +- Family3
!   +- Family4
!      +- Family4.1
!      +- Family4.2                will be deleted (and sub childs as well)
!      |  +- Family4.2.1
!      |  |  +- Family4.2.1.1
!      |  +- Family4.2.2
!      +- Family4.3
!

! PATH BASED FAMILY NODE CREATION
      call cg_family_write_f(cgfile, cgtree, "Family1", cgfam, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_family_write_f(cgfile, cgtree, &
     &                 "/FamilyTree/Family1/Family1.1", cgfam, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_family_write_f(cgfile, cgtree, &
     &     "/FamilyTree/Family1/Family1.1/Family1.1.1", cgfam, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_family_write_f(cgfile, cgtree, &
     &     "/FamilyTree/Family1/Family1.2/Family1.2.1", cgfam, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_family_write_f(cgfile, cgtree, &
     &                           "/FamilyTree/Family2", cgfam, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_family_write_f(cgfile, cgtree, "Family3", cgfam, ierr) 
      if (ierr .ne. CG_OK) call cg_error_exit_f

! NODE BASED FAMILY NODE CREATION

      call cg_gopath_f( cgfile, "/FamilyTree/Family2", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_node_family_write_f( "Family2.1", cgfam, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_goto_f( cgfile, cgtree, ierr, "Family2", 0, &
     &               "Family2.1", 0, 'end')
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_gopath_f(cgfile, &
     &        "/FamilyTree/Family1/Family1.2/Family1.2.1", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_node_family_write_f( "Family1.2.1.1", cgfam, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_node_family_write_f( "Family1.2.1.2", cgfam, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_node_nfamilies_f( nfam , ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      
      call cg_gopath_f( cgfile, "/FamilyTree/Family2/Family2.1", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_node_family_write_f( "Family2.1.1", cgfam, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f      


      call  cg_family_write_f(cgfile, cgtree, "Family4", cgfam, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_family_write_f(cgfile, cgtree, &
     &                  "/FamilyTree/Family4/Family4.1", cgfam, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_family_write_f(cgfile, cgtree, &
     & "/FamilyTree/Family4/Family4.2/Family4.2.1/Family4.2.1.1", cgfam, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_family_write_f(cgfile, cgtree, &
     &      "/FamilyTree/Family4/Family4.2/Family4.2.2", cgfam, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_family_write_f(cgfile, cgtree, &
     &                  "/FamilyTree/Family4/Family4.3", cgfam, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      CALL cg_goto_f(cgfile, cgtree, ierr, 'end')
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_gopath_f(cgfile, "/FamilyTree", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_node_family_write_f( "FamilyN", cgfam, ierr) 
      if (ierr .ne. CG_OK) call cg_error_exit_f

!  FAMILY (TREE) NAME CREATION

      call cg_goto_f(cgfile, cgbase, ierr, "Zone", 0, 'end')
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_gopath_f(cgfile, "/Structured/Zone", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_famname_write_f("/FamilyTree/Family1", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      do j=1,3
         write( name,'(a,i1)') 'ZoneFamily', j
         write( family_name,'(a,i1)') &
     &      '/FamilyTree/Family1/Family1.2/Family1.2.1/Family1.2.1.', j
         call cg_multifam_write_f(name, family_name, ierr)
         if (ierr .ne. CG_OK) call cg_error_exit_f
      enddo
      do n=1,3
        ptrange(n) = 1
        ptrange(n+3) = NUM_SIDE
      enddo
      ptrange(6) = 1
      npts = 2
      call cg_boco_write_f(cgfile, cgbase, 1, "Inflow", CGNS_ENUMV(BCInflow), &
     &            CGNS_ENUMV(PointRange), npts, ptrange, cgbc, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_goto_f(cgfile, cgbase, ierr, "Zone", 0, "ZoneBC", 0, &
     &               "Inflow", 0,'end')
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_gopath_f(cgfile, "/Structured/Zone/ZoneBC/Inflow", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_famname_write_f("/FamilyTree/Family2", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      do j = 1, 3
         write( name,'(a,i1)') 'BCFamily', j
         write( family_name,'(a,i1)') '/FamilyTree/Family', j
         call cg_multifam_write_f(name, family_name, ierr)
         if (ierr .ne. CG_OK) call cg_error_exit_f
      enddo

      call cg_subreg_bcname_write_f(cgfile, cgbase, cgzone, "SubRegion", &
     &       2, "Inflow", cgsr, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_goto_f(cgfile, cgbase, ierr, "Zone", 0, "SubRegion", 0, 'end')
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_gopath_f(cgfile, "/Structured/Zone/SubRegion", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_famname_write_f("/FamilyTree/Family3", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f     
      do j = 1,3
         write( name,'(a,i1)') 'SubRegionFamily', j
         write( family_name,'(a,i1)') '/FamilyTree/Family', j
         call cg_multifam_write_f(name, family_name, ierr)
         if (ierr .ne. CG_OK) call cg_error_exit_f
      enddo

      call cg_gopath_f(cgfile, "/Structured/Zone", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_user_data_write_f("UserData", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_user_data_write_f("UserData2", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_gopath_f(cgfile, "./UserData", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_famname_write_f("/FamilyTree/Family4", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      do j = 1,3
         write( name,'(a,i1)') 'UserDataFamily', j
         write( family_name,'(a,i1)') '/FamilyTree/Family', j
         call cg_multifam_write_f(name, family_name, ierr)
         if (ierr .ne. CG_OK) call cg_error_exit_f
      enddo
!    FAMILY NAMES IN TREE
      call cg_gopath_f( cgfile, "/FamilyTree/Family1/Family1.1", ierr)

      call cg_node_family_name_write_f( "FamilyN1.1-1", &
     &                          "/FamilyTree/Family2/Family2.1", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_node_family_name_write_f( "FamilyN1.1-2", &
     &                          "/FamilyTree/Family2/Family2.1", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_node_family_name_write_f( "FamilyN1.1-3", &
     &                          "/FamilyTree/Family2/Family2.1", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_node_nfamily_names_f( nnames, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      if (nnames .ne. 3) stop

      call cg_close_f(cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

! ---- MODIFYING TESTS ----
      call cg_open_f(outfile, CG_MODE_MODIFY, cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_nbases_f( cgfile, nb, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      if (nb .ne. 2) stop

      cgtree = -1
      cgbase = -1

      do n=1,nb
        call cg_base_read_f( cgfile, n, name, celldim, physdim, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        if( name .eq. "FamilyTree" ) then
            cgtree = n
        else
            cgbase = n
        endif
      enddo

      call cg_nfamilies_f(cgfile, cgtree, nfam, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      if (nfam .ne. 5) stop

!  FAMILY NODE DELETION

      call cg_gopath_f(cgfile,"/FamilyTree/Family1/Family1.2/Family1.2.1", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_gopath_f(cgfile, "/FamilyTree/Family1/Family1.2/Family1.2.1", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_delete_node_f("Family1.2.1.1", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_node_nfamilies_f(nfam, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      if (nfam .ne. 1) stop

      call cg_gopath_f(cgfile, "/FamilyTree/Family4", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_delete_node_f("Family4.2", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_node_nfamilies_f(nfam, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      if (nfam .ne. 2) stop

!  FAMILY NODE OVERWRITING
      call cg_gopath_f( cgfile, "/FamilyTree/Family1/Family1.2/Family1.2.1", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_node_family_write_f( "Family1.2.1.2", cgfam, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f 
      call cg_node_nfamilies_f(nfam, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      if (nfam .ne. 1) stop 

      call cg_gopath_f( cgfile, "/FamilyTree/Family1/Family1.1", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_node_nfamilies_f( nfam, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      if (nfam .ne. 1) stop 

      call cg_node_family_read_f( nfam, family_name, nb, ng, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      if (family_name .ne. "Family1.1.1") stop
      if (nb .ne. 0) stop
      if (ng .ne. 0) stop

      call cg_node_nfamily_names_f( nnames, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      if (nnames .ne. 3) stop

      do n=1,nnames
        call cg_node_family_name_read_f( n, name, family_name, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        write( tname,'(a,i1)') 'ZoneFamilyN1.1-', n
        write( tfamily_name,'(a)') '/FamilyTree/Family2/Family2.1'
        if (tname .ne. name) stop
        if (tfamily_name .ne. family_name) stop
      enddo

      call cg_delete_node_f( "FamilyN1.1-1", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_node_family_name_write_f( "FamilyN1.1-3", "/FamilyTree/Family2/Family3.1", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_node_nfamily_names_f(nnames, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      if (nnames .ne. 2) stop

      do n=1, nnames
        call cg_node_family_name_read_f( n, name, family_name, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        write( tname,'(a,i1)') 'FamilyN1.1-', n
        write( tfamily_name,'(a, i1, a)') '/FamilyTree/Family2/Family', n, '.1'
        if (tname .ne. name) stop
        if (tfamily_name .ne. family_name) stop
      enddo
 
      call cg_gopath_f( cgfile, "/Structured/Zone/UserData", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_nmultifam_f( nnames, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_famname_read_f( family_name, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_gopath_f(cgfile, "/Structured/Zone/UserData2", ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_nmultifam_f( nnames, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_famname_read_f( family_name, ierr)
      if( ierr .ne. CG_OK) then
        if( ierr .ne. CG_NODE_NOT_FOUND ) then
          call cg_error_exit_f
        endif
      endif

      call cg_close_f(cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      end program

      program write_grid_str
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Creates simple 3-D structured grid and writes it to a
!   CGNS file.
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c write_grid_str.F90
!   ifort -o write_grid_str write_grid_str.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!
!   dimension statements (note that tri-dimensional arrays
!   x,y,z must be dimensioned exactly as (21,17,N) (N>=9)
!   for this particular case or else they will be written to
!   the CGNS file incorrectly!  Other options are to use 1-D
!   arrays, use dynamic memory, or pass index values to a
!   subroutine and dimension exactly there):
      real*8 x(21,17,9),y(21,17,9),z(21,17,9)
      integer ni,nj,nk,i,j,k
      integer icelldim,iphysdim
      integer index_coord,index_file,ier
      integer index_base,index_zone
      integer(cgsize_t) isize(3,3)
      character basename*32,zonename*32
!
      write(6,'('' Program write_grid_str'')')
      if (CG_BUILD_64BIT) then
        write(6,'('' ...using 64-bit mode for particular integers'')')
      end if
!
!   create gridpoints for simple example:
      ni=21
      nj=17
      nk=9
      do k=1,nk
        do j=1,nj
          do i=1,ni
            x(i,j,k)=float(i-1)
            y(i,j,k)=float(j-1)
            z(i,j,k)=float(k-1)
          enddo
        enddo
      enddo
      write(6,'('' created simple 3-D grid points'')')
!
!   WRITE X, Y, Z GRID POINTS TO CGNS FILE
!   open CGNS file for write
      call cg_open_f('grid.cgns',CG_MODE_WRITE,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!   create base (user can give any name)
      basename='Base'
      icelldim=3
      iphysdim=3
      call cg_base_write_f(index_file,basename,icelldim,iphysdim,              &
           index_base,ier)
!   define zone name (user can give any name)
      zonename = 'Zone  1'
!   vertex size
      isize(1,1)=21
      isize(2,1)=17
      isize(3,1)=9
!   cell size
      isize(1,2)=isize(1,1)-1
      isize(2,2)=isize(2,1)-1
      isize(3,2)=isize(3,1)-1
!   boundary vertex size (always zero for structured grids)
      isize(1,3)=0
      isize(2,3)=0
      isize(3,3)=0
!   create zone
      call cg_zone_write_f(index_file,index_base,zonename,isize,               &
           CGNS_ENUMV(Structured),index_zone,ier)
!   write grid coordinates (user must use SIDS-standard names here)
      call cg_coord_write_f(index_file,index_base,index_zone,CGNS_ENUMV(RealDouble),       &
           'CoordinateX',x,index_coord,ier)
      call cg_coord_write_f(index_file,index_base,index_zone,CGNS_ENUMV(RealDouble),       &
           'CoordinateY',y,index_coord,ier)
      call cg_coord_write_f(index_file,index_base,index_zone,CGNS_ENUMV(RealDouble),       &
           'CoordinateZ',z,index_coord,ier)
!   close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully wrote grid to file grid.cgns'')')
      stop
      end

	program write_axisym
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on June 7 2002

!       This example tests the Axisymmetry_t data structure and its children

#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 2)
	integer index_dim, cell_dim, phys_dim, i
	integer cg, base_no, ier
        integer(cgsize_t) dimval(2)
	real*4 ref_point(Ndim), axis(Ndim), angle
	character*100 linkpath, DescriptorText
	character*32 CoordinateNames(2), DescriptorName


! *** initialize
	ier = 0
	index_dim=Ndim
	cell_dim=Ndim
	phys_dim=Ndim

! *** open CGNS file for writing
 	call cg_open_f('Test_V2', MODE_WRITE, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f

! *** base
 	call cg_base_write_f(cg, 'Basename', cell_dim, phys_dim,
     &                       base_no, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f

! *** write a descriptor under the base
        call cg_goto_f(cg, base_no, ier, 'end')
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_descriptor_write_f('BaseDescriptorName',
     &      'BaseDescriptorText', ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** write Axisymmetry_t node
	do i=1,Ndim
	    ref_point(i)=0
	    axis(i) = i-1
	enddo

	call cg_axisym_write_f(cg, base_no, ref_point, axis, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** write children of Axisymmetry_t
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	call cg_goto_f(cg, base_no, ier, 'Axisymmetry_t', 1, 'end')
	if (ier .eq. ERROR) call cg_error_exit_f

! * DataArray_t AxisymmetryAngle
	angle = 360
	dimval(1)=1
	call cg_array_write_f('AxisymmetryAngle', RealSingle, 1,
     &       1_cgsize_t, angle, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! * DataArray_t CoordinateNames
        dimval(1)=32
        dimval(2)=2
	write(CoordinateNames(1),'(a)')'CoordinateX'
	write(CoordinateNames(2),'(a)')'CoordinateZ'
	call cg_array_write_f('CoordinateNames', Character, 2,
     &       dimval, CoordinateNames, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! * Descriptor
	call cg_descriptor_write_f('AxisymDescriptorName',
     &       'AxisymDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * DataClass
        call cg_dataclass_write_f(Dimensional, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! * DimensionalUnits
	call cg_units_write_f(Kilogram, Meter, Second, Kelvin,
     &                        Radian, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! * UserDefinedData
        call cg_user_data_write_f('UserData1', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * Link to BaseDescriptorName
        write(linkpath,'(a)') 'Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * DataArray_t/Descriptor
	do i=1, 4
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	    call cg_goto_f(cg, base_no, ier, 'Axisymmetry_t', 1,
     &                     'DataArray_t', i, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f
	    write(DescriptorName,'(a,i1)') 'DescriptorName4Array',i
	    write(DescriptorText,'(a,i1)') 'DescriptorText4Array',i
	    call cg_descriptor_write_f(DescriptorName,
     &           DescriptorText, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

! * DataArray_t/DimensionalUnits
	    call cg_units_write_f(Kilogram, Meter, Second, Kelvin,
     &                            Degree, ier)
            if (ier .eq. ERROR) call cg_error_exit_f
	enddo

! *** close CGNS file
	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	end

      program cgsubreg

#ifdef WINNT
      include 'cgnswin_f.h'
#endif
      USE CGNS
      IMPLICIT NONE

      integer ierr, cgfile, cgbase, cgzone, cgcoord
      integer dim, csub, nsub
      integer(cgsize_t) i, j, k, n, size(9)
      integer(cgsize_t) ptrange(6), ptlist(125), npts
      integer(cgenum_t) loc, ptype
      integer bclen, gclen
      real*4 x(125), y(125), z(125)
      character*32 sname, cname

! open and write base
      dim = 3
      call cg_open_f('cgsubreg.cgns', CG_MODE_WRITE, cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_base_write_f(cgfile, 'Base', dim, dim, cgbase, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

! create some bogus data
      do n=1,3
        size(n)   = 5
        size(n+3) = 4
        size(n+6) = 0
      enddo
      n = 0
      do k=1,5
        do j=1,5
          do i=1,5
            n = n + 1
            x(n) = i
            y(n) = j
            z(n) = k
          enddo
        enddo
      enddo
      do n=1,3
        ptrange(n) = 1
        ptrange(n+3) = 5
      enddo
      ptrange(4) = 1
      n = 0
      do j=1,5
        do i=1,5
          n = n + 1
          ptlist(n) = i
          n = n + 1
          ptlist(n) = j
          n = n + 1
          ptlist(n) = 1
        enddo
      enddo

! write zone
      call cg_zone_write_f(cgfile, cgbase, 'Zone', size,                &
     &                     Structured, cgzone, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
! write coordinates
      call cg_coord_write_f(cgfile, cgbase, cgzone, RealSingle,         &
     &                      'CoordinateX', x, cgcoord, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_coord_write_f(cgfile, cgbase, cgzone, RealSingle,         &
     &                      'CoordinateY', y, cgcoord, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_coord_write_f(cgfile, cgbase, cgzone, RealSingle,         &
     &                      'CoordinateZ', z, cgcoord, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

! write first ZoneSubRegion as BCRegionName
      dim = 2
      call cg_subreg_bcname_write_f(cgfile, cgbase, cgzone, 'reg1',     &
     &                              dim, 'bcname', csub, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

! write second ZoneSubRegion as GridConnectivityRegionName
      call cg_subreg_gcname_write_f(cgfile, cgbase, cgzone, 'reg2',     &
     &                              dim, 'gcname', csub, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

! write third ZoneSubRegion as PointRange
      npts = 2
      call cg_subreg_ptset_write_f(cgfile, cgbase, cgzone, 'reg3',      &
     &                             dim, Vertex, PointRange, npts,       &
     &                             ptrange, csub, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

! write fourth ZoneSubRegion as PointList
      npts = 25
      call cg_subreg_ptset_write_f(cgfile, cgbase, cgzone, 'reg4',      &
     &                             dim, EdgeCenter, PointList, npts,    &
     &                             ptlist, csub, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

! close the file and reopen in read mode
      call cg_close_f(cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_open_f('cgsubreg.cgns', CG_MODE_READ, cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      cgbase = 1
      cgzone = 1
      call cg_nsubregs_f(cgfile, cgbase, cgzone, nsub, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      if (nsub .ne. 4) then
        print *,'expecting nsub=4 - got',nsub
        stop
      endif

      do csub=1,4
        call cg_subreg_info_f(cgfile, cgbase, cgzone, csub, sname, dim, &
     &                        loc, ptype, npts, bclen, gclen, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        if (sname .eq. 'reg1') then
          if (bclen .ne. 6 .or. gclen .ne. 0 .or.                       &
     &        ptype .ne. CG_NULL .or. npts .ne. 0) then
            print *,'bad info for',sname
            stop
          endif
          call cg_subreg_bcname_read_f(cgfile, cgbase, cgzone, csub,    &
     &                                 cname, ierr)
          if (ierr .ne. CG_OK) call cg_error_exit_f
          if (cname .ne. 'bcname') then
            print *,'expecting bcname - got ',cname
            stop
          endif

        elseif (sname .eq. 'reg2') then
          if (bclen .ne. 0 .or. gclen .ne. 6 .or.                       &
     &        ptype .ne. CG_NULL .or. npts .ne. 0) then
            print *,'bad info for',sname
            stop
          endif
          call cg_subreg_gcname_read_f(cgfile, cgbase, cgzone, csub,    &
     &                                 cname, ierr)
          if (ierr .ne. CG_OK) call cg_error_exit_f
          if (cname .ne. 'gcname') then
            print *,'expecting gcname - got ',cname
            stop
          endif

        elseif (sname .eq. 'reg3') then
          if (bclen .ne. 0 .or. gclen .ne. 0 .or.                       &
     &        ptype .ne. PointRange .or. npts .ne. 2 .or.               &
     &        loc .ne. Vertex) then
            print *,'bad info for',sname
            stop
          endif
          call cg_subreg_ptset_read_f(cgfile, cgbase, cgzone, csub,     &
     &                                ptrange, ierr)
          if (ierr .ne. CG_OK) call cg_error_exit_f
        elseif (sname .eq. 'reg4') then
          if (bclen .ne. 0 .or. gclen .ne. 0 .or.                       &
     &        ptype .ne. PointList .or. npts .ne. 25 .or.               &
     &        loc .ne. EdgeCenter) then
            print *,'bad info for',sname
            stop
          endif
          call cg_subreg_ptset_read_f(cgfile, cgbase, cgzone, csub,     &
     &                                ptlist, ierr)
          if (ierr .ne. CG_OK) call cg_error_exit_f

        else
          print *,'unknown subregion ',sname
          stop
        endif
      enddo

      call cg_close_f(cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      end

        program write_mixed_grid
	USE CGNS

!	author: Diane Poirier
!	last revised on March 8 2000

! 	This example test the new data structures created for
! 	unstructured data and geometry reference data.  The
! 	model being create is composed of 2 zones.  The 1st
!	one is a structured 3x3x3 block, and the 2nd is
!	an unstructured 3x3x3 block composed of 8 hexa elements.
! 	The 2 zones interface (Abutting1to1) on one 9-nodes face.

#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	parameter (Ndim = 3)
	integer index_dim, cell_dim, phys_dim
	integer cg, base, zone, num, ier, index, ZoneType
        integer(cgsize_t) size(Ndim*3)
	integer i, j, k, n, pos, coord
        integer(cgsize_t) element(8,8)
	integer hexa_section_no, quad_section_no
        integer(cgsize_t) parent(4,4)
        integer(cgsize_t) elist(4)
	integer(cgsize_t) quads(4,4)
        integer(cgsize_t) pnts(3,9), uns_pnts(9), dim_vals(12)
	integer(cgsize_t) Nindex(3)
	double precision VertexNormals(3,9), FaceNormals(3,4)
	integer fam, geo, part, bc
	integer sol_no, field_no
	character*32 ZoneName, coordname(3), geoname, fambcname
	character*200 cadfile, partname
        double precision data_double(200*3), interpolants(3,9)
	integer grid_no

!       initialize
        ier = 0
	cell_dim=3
	phys_dim=3

!       open CGNS file for writing

        call cg_open_f('Test_V2', MODE_WRITE, cg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

!*******write CGNSBase
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	call cg_base_write_f(cg, 'Name of my Base', cell_dim, phys_dim,
     &			     base, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

!****** Create 2 volume and 1 face families
	call cg_family_write_f(cg, base, 'Family#1', index, ier)
!	write(6,*)'index1=',index
	if (ier .eq. ERROR) call cg_error_exit_f
	call cg_family_write_f(cg, base, 'Family#2', index, ier)
!	write(6,*)'index2=',index
	if (ier .eq. ERROR) call cg_error_exit_f
        call cg_family_write_f(cg, base, 'Outflow', index, ier)
!	write(6,*)'index3=',index
        if (ier .eq. ERROR) call cg_error_exit_f

! ******write CGNSBase substructure: Zone
	do zone=1, 2

! Structured zone:
	    if (zone .eq. 1) then
		ZoneType=Structured
	        write(ZoneName,100) 'StructuredZone#1'
		
		index_dim = 3
		do i=1, index_dim
		    size(i) = 3
		    size(i+index_dim) = size(i)-1
		    size(i+2*index_dim) = 0              ! unsorted data
		enddo

! Unstructured zone:
	    else if (zone .eq. 2) then
		ZoneType=Unstructured
		write(ZoneName,'(a)') 'UnstructuredZone#1'
		index_dim = 1
		size(1) = 27		! no of nodes
	 	size(2) = 8		! no of elements
		size(3) = 0		! unsorted nodes
	    endif

	    num = 1
            do i=1, index_dim               		
                num = num * size(i)
            enddo
	    call cg_zone_write_f(cg,base,ZoneName,size,ZoneType,
     &                           index,ier)
            if (ier .eq. ERROR) call cg_error_exit_f

! GOTO Zone node and write family name :
            call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f
	    if (zone.eq.1) then
	  	call cg_famname_write_f('Family#1', ier)
	    else
		call cg_famname_write_f('Family#2', ier)
	    endif
	    if (ier .eq. ERROR) call cg_error_exit_f

! Name convention
            coordname(1) = 'CoordinateX'
            coordname(2) = 'CoordinateY'
            coordname(3) = 'CoordinateZ'

! Create GridCoordinates_t node
            call cg_grid_write_f(cg,base,index,'GridCoordinates',
     &                         grid_no, ier)
            if (ier.ne. ALL_OK) call cg_error_exit_f

! create coordinate data
            do coord=1,phys_dim
                do 20 k=1, 3
                do 20 j=1, 3
                do 20 i=1, 3
                    pos = i + (j-1)*3 + (k-1)*9
                    if (coord.eq.1) data_double(pos) = (i-1)*5 +
     &                  (zone-1)*10
                    if (coord.eq.2) data_double(pos) = (j-1)*5
                    if (coord.eq.3) data_double(pos) = (k-1)*5
 20             continue

! GOTO GridCoordinatesNode & write DataArray
                call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &              'GridCoordinates_t', 1, 'end')
                if (ier .eq. ERROR) call cg_error_exit_f

                call cg_array_write_f(coordname(coord), RealDouble,
     &              index_dim, size, data_double, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
	    enddo	! coord. loop

! Flow Solution

	    do n=1,8
		data_double(n) = 1.0 + n/10.0
	    enddo
	    call cg_sol_write_f(cg, base, zone,'Solution1',CellCenter,
     &         sol_no,ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
	    call cg_field_write_f(cg, base, zone, sol_no, RealDouble,
     &          'DummySolution', data_double, field_no, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

! Grid Connectivity 1to1:  From a structured zone to an unstructured zone
	    ! Unstructured point list:
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	    uns_pnts(1)=1
	    do n=2,9
		uns_pnts(n) = uns_pnts(n-1)+3
	    enddo

	    if (zone .eq. 1) then
		! PointRange for structured zone:
	        pnts(1,1)=3
	        pnts(2,1)=1
	        pnts(3,1)=1
	        pnts(1,2)=3
                pnts(2,2)=3
                pnts(3,2)=3

	        call cg_conn_write_f(cg, base, zone, 'str_to_unstr',
     & 	            Vertex, Abutting1to1, PointRange, 2_cgsize_t, pnts,
     &              'UnstructuredZone#1', Unstructured,
     &              CellListDonor, Integer, 9_cgsize_t, uns_pnts, index,
     &              ier)
		if (ier .eq. ERROR) call cg_error_exit_f

! Fake similation of Overset or Abutting-mismatch: str to unstr
		call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &              'ZoneGridConnectivity_t', 1,
     &              'GridConnectivity_t', 1, 'end')
                if (ier .eq. ERROR) call cg_error_exit_f

! make up some dummy data
		do n=1,9
		do i=1,cell_dim
		    interpolants(i,n)=1.0/(i+n)
		enddo
		enddo

		dim_vals(1)=cell_dim
		dim_vals(2)=9
		call cg_array_write_f('InterpolantsDonor', RealDouble,
     &              2, dim_vals, interpolants, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
		
	    endif

	

! Grid Connectivity 1to1:  From an unstructured zone to a structured zone
	    if (zone .eq. 2) then

		! PointList of structured donor
		n=0
		do k=1,3
		do j=1,3
		    n=n+1
		    pnts(1,n) = 3
		    pnts(2,n) = j
		    pnts(3,n) = k
		enddo
		enddo

		call cg_conn_write_f(cg, base, zone, 'unstr_to_str',
     &              Vertex, Abutting1to1, PointList,9_cgsize_t,uns_pnts,
     &              'StructuredZone#1', Structured, PointListDonor,
     &		    Integer, 9_cgsize_t, pnts, index, ier)
		if (ier .eq. ERROR) call cg_error_exit_f
            endif


! BOUNDARY CONDITION PATCH: Put a user defined b.c. at interface
	    if (zone.eq.1) then
	      ! write a PointRange patch (3,1,1) to (3,3,3) for a structured zone
	        call cg_boco_write_f(cg, base, zone, 'myboco',
     &            UserDefined, PointRange, 2_cgsize_t, pnts, index, ier)
	        if (ier .eq. ERROR) call cg_error_exit_f

	      ! Write Normal index and Normal vectors
		Nindex(1)=-1
		Nindex(2)=0
		Nindex(3)=0
		do n=1, 9
		    VertexNormals(1,n) = -1.0	! x-coord
		    VertexNormals(2,n) = 0	! y-coord
		    VertexNormals(3,n) = 0	! z-coord
		enddo
		
		call cg_boco_normal_write_f(cg, base, zone, index, Nindex,
     &                1, RealDouble, VertexNormals, ier)
		if (ier .eq. ERROR) call cg_error_exit_f


	    else if (zone.eq.2) then
	      ! BC patch defined using points and normals at the points:
		call cg_boco_write_f(cg, base, zone, 'point_patch',
     &            UserDefined, PointList, 9_cgsize_t, uns_pnts, index,
     &            ier)
                if (ier .eq. ERROR) call cg_error_exit_f

	      ! note: Normal index has no definition in unstructured
		do n=1, 9
		    VertexNormals(1,n) = 1.0
		enddo
		call cg_boco_normal_write_f(cg, base, zone, index, Nindex,
     &                1, RealDouble, VertexNormals, ier)
                if (ier .eq. ERROR) call cg_error_exit_f

	      ! BC patch defined using face elements & normals at the faces
		do n=1, 4
		  elist(n)=8+n
		  FaceNormals(1,n)=1.0
		  FaceNormals(2,n)=0
		  FaceNormals(3,n)=0
		enddo
		call cg_boco_write_f(cg, base, zone, 'shell_patch',
     &            BCOutflow, PointList, 4_cgsize_t, elist, index, ier)
		if (ier .eq. ERROR) call cg_error_exit_f

	     ! Specify that the GridLocation is FaceCenter
		call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &             'ZoneBC_t', 1, 'BC_t', index, 'end')
                if (ier .eq. ERROR) call cg_error_exit_f

		call cg_gridlocation_write_f(FaceCenter, ier)
		if (ier .eq. ERROR) call cg_error_exit_f

                call cg_boco_normal_write_f(cg, base, zone, index,
     &                Nindex, 1, RealDouble, FaceNormals, ier)
                if (ier .eq. ERROR) call cg_error_exit_f

	      ! Define family name for BC patch
		call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &             'ZoneBC_t', 1, 'BC_t', index, 'end')
		if (ier .eq. ERROR) call cg_error_exit_f

		call cg_famname_write_f('Outflow', ier)
		if (ier .eq. ERROR) call cg_error_exit_f
	    endif

! ********** SPECIAL FOR UNSTRUCTURED ZONES ONLY **********

	    if (ZoneType .eq. Unstructured) then

            ! Generate HEXA_8 Element Connectivity
                n=0
                do 30 k=1,2
                do 30 j=1,2
                do 30 i=1,2
                    n=n+1
                    pos = i + (j-1)*3 + (k-1)*9
                    element(1,n) = pos
                    element(2,n) = pos+1
                    element(3,n) = pos+4
                    element(4,n) = pos+3
                    element(5,n) = pos+9
                    element(6,n) = pos+10
                    element(7,n) = pos+13
                    element(8,n) = pos+12
 30             continue

		call cg_section_write_f(cg, base, zone,
     &            'VolumeElements', HEXA_8, 1_cgsize_t, 8_cgsize_t, 0,
     &             element, hexa_section_no, ier)
		if (ier .eq. ERROR) call cg_error_exit_f

	      ! GENERATE some quad elements
                ! 1st node of each element
                quads(1,1) = 3
                quads(1,2) = 6
                quads(1,3) = 12
                quads(1,4) = 15
                ! remaining nodes of each element
                do n=1, 4
                    quads(2,n)=quads(1,n)+3
                    quads(3,n)=quads(1,n)+12
                    quads(4,n)=quads(1,n)+9
                enddo

		call cg_section_write_f(cg, base, zone, 'outflow',
     &            QUAD_4, 9_cgsize_t, 12_cgsize_t, 0, quads,
     &            quad_section_no, ier)
		if (ier .eq. ERROR) call cg_error_exit_f

	     !  GENERATE Parent Data for shell elements
		do n=1, 4
		    parent(n,1) = 2*n	! first parent
		    parent(n,2) = 0	! no second parent
		    parent(n,3) = 3	! face of first parent
		    parent(n,4) = 0	! face of 2nd parent
		enddo

		call cg_parent_data_write_f(cg, base, zone,
     &               quad_section_no, parent, ier)
		if (ier .eq. ERROR) call cg_error_exit_f

! Auxiliary info:
                call cg_goto_f(cg,base,ier,'Zone_t',zone,'Elements_t',
     &            hexa_section_no, 'end')
                if (ier .eq. ERROR) call cg_error_exit_f

                call cg_descriptor_write_f('Descriptor_Name',
     &              'Descriptor_Text', ier)
                if (ier .eq. ERROR) call cg_error_exit_f


	    endif	! IF UNSTRUCTURED ZONE


! *********************************************************************

        enddo	! zone loop

! FAMILY and GEOMETRY

	do fam=1,3
          ! A family may have several GeometryReference_t node
            do geo=1, 2
                write(geoname, 200) 'Geo#',geo,'_of_fam#',fam
		write(cadfile, 200)'CADFile#',geo
                call cg_geo_write_f(cg, base, fam, geoname,
     &              cadfile, 'IGES', index, ier)
                if (ier .eq. ERROR) call cg_error_exit_f

		! A GeometryReference_t may encompass several parts
		do part = 1, 2
		    write(partname, 200)'Part#',part
		    call cg_part_write_f(cg, base, fam, geo,
     &                  partname, index, ier)
		    if (ier .eq. ERROR) call cg_error_exit_f
		enddo

	      ! GeometryReference_t descriptor
		call cg_goto_f(cg, base, ier, 'Family_t', fam,
     &           'GeometryReference_t',geo,'end')
		if (ier .eq. ERROR) call cg_error_exit_f

		call cg_descriptor_write_f('Descriptor',
     &           geoname, ier)
		if (ier .eq. ERROR) call cg_error_exit_f
	    enddo

	  ! A family may have several FamilyBC_t node
	    do bc=1,2
		write(fambcname,'(a,i1)')'FamBC#',bc
	 	call cg_fambc_write_f(cg, base, fam, fambcname,
     &            BCGeneral, index, ier)
		if (ier .eq. ERROR) call cg_error_exit_f
	    enddo

	 !  Family Descriptor and Ordinal
	    call cg_goto_f(cg, base, ier, 'Family_t', fam, 'end')
	    if (ier .eq. ERROR) call cg_error_exit_f

	    call cg_descriptor_write_f('Fam_Descr_Name',
     &            'Fam_Descr_Text', ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

	    call cg_ordinal_write_f(fam, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
	enddo

! Auxiliary nodes for FAMILY and GEOMETRY

! *********************************************************************

	call cg_close_f(cg, ier)
	if (ier.eq. ERROR) call cg_error_exit_f()
 100	format(a)
 200	format(a,i1,a,i1)

	end

      program write_timevert_str
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Opens an existing CGNS file that contains a simple 3-D
!   structured grid, and adds 3 different flow solutions
!   (at VERTICES) to it, along with time-accurate info.
!   In this example, r1 & p1, r2 & p2, r3 & p3 correspond
!   with solutions at 3 different time steps.
!
!   The CGNS grid file 'grid.cgns' must already exist
!   (created using write_grid_str.f)
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c write_timevert_str.F90
!   ifort -o write_timevert_str write_timevert_str.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
!   dimension statements (note that tri-dimensional arrays
!   r1, r2, r3 and p1, p2, p3
!   must be dimensioned exactly as (21,17,N) (N>=9)
!   for this particular case or else they will be written to
!   the CGNS file incorrectly!  Other options are to use 1-D
!   arrays, use dynamic memory, or pass index values to a
!   subroutine and dimension exactly there):
      real*8 r1(21,17,9),p1(21,17,9)
      real*8 r2(21,17,9),p2(21,17,9)
      real*8 r3(21,17,9),p3(21,17,9)
      real*8 time(3)
      integer nsteps,index_field,n,index_zone,ier,index_file
      integer i,j,k,ni,nj,nk,index_base,index_flow
      integer(cgsize_t) idata(2),nuse
      character solname(3)*32
!
      write(6,'('' Program write_timevert_str'')')
      if (CG_BUILD_64BIT) then
        write(6,'('' ...using 64-bit mode for particular integers'')')
      end if
!
!   set up the times corresponding to the 3 solutions to be
!   stored:
      time(1)=10.d0
      time(2)=20.d0
      time(3)=50.d0
!   create fake flow solution AT VERTICES for simple example:
      ni=21
      nj=17
      nk=9
      do k=1,nk
        do j=1,nj
          do i=1,ni
!           soln at time 1:
            r1(i,j,k)=float(i-1)
            p1(i,j,k)=float(j-1)
!           soln at time 2:
            r2(i,j,k)=r1(i,j,k)+1.d0
            p2(i,j,k)=p1(i,j,k)+1.d0
!           soln at time 3:
            r3(i,j,k)=r2(i,j,k)+1.d0
            p3(i,j,k)=p2(i,j,k)+1.d0
          enddo
        enddo
      enddo
      write(6,'('' created simple 3-D rho and p flow solution'')')
!
!   WRITE FLOW SOLUTION TO EXISTING CGNS FILE
!   open CGNS file for modify
      call cg_open_f('grid.cgns',CG_MODE_MODIFY,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!   we know there is only one base (real working code would check!)
      index_base=1
!   we know there is only one zone (real working code would check!)
      index_zone=1
!   define 3 different solution names (user can give any names)
      solname(1) = 'FlowSolution1'
      solname(2) = 'FlowSolution2'
      solname(3) = 'FlowSolution3'
!   do loop for the 3 solutions:
      do n=1,3
!   create flow solution node
      call cg_sol_write_f(index_file,index_base,index_zone,solname(n),         &
           CGNS_ENUMV(Vertex),index_flow,ier)
      write(6,'('' ... writing solution number '',i5)') index_flow
!   write flow solution (user must use SIDS-standard names here)
      if (n .eq. 1) then
      call cg_field_write_f(index_file,index_base,index_zone,index_flow,       &
           CGNS_ENUMV(RealDouble),'Density',r1,index_field,ier)
      call cg_field_write_f(index_file,index_base,index_zone,index_flow,       &
           CGNS_ENUMV(RealDouble),'Pressure',p1,index_field,ier)
      else if (n .eq. 2) then
      call cg_field_write_f(index_file,index_base,index_zone,index_flow,       &
           CGNS_ENUMV(RealDouble),'Density',r2,index_field,ier)
      call cg_field_write_f(index_file,index_base,index_zone,index_flow,       &
           CGNS_ENUMV(RealDouble),'Pressure',p2,index_field,ier)
      else
      call cg_field_write_f(index_file,index_base,index_zone,index_flow,       &
           CGNS_ENUMV(RealDouble),'Density',r3,index_field,ier)
      call cg_field_write_f(index_file,index_base,index_zone,index_flow,       &
           CGNS_ENUMV(RealDouble),'Pressure',p3,index_field,ier)
      end if
      enddo
!   create BaseIterativeData
      nsteps=3
      call cg_biter_write_f(index_file,index_base,'TimeIterValues',nsteps,ier)
!   go to BaseIterativeData level and write time values
      call cg_goto_f(index_file,index_base,ier,'BaseIterativeData_t',1,'end')
      nuse=3
      call cg_array_write_f('TimeValues',CGNS_ENUMV(RealDouble),1,[nuse],time,ier)
!   create ZoneIterativeData
      call cg_ziter_write_f(index_file,index_base,index_zone,                  &
           'ZoneIterativeData',ier)
!   go to ZoneIterativeData level and give info telling which
!   flow solution corresponds with which time (solname(1) corresponds
!   with time(1), solname(2) with time(2), and solname(3) with time(3))
      call cg_goto_f(index_file,index_base,ier,'Zone_t',                       &
           index_zone,'ZoneIterativeData_t',1,'end')
      idata(1)=32
      idata(2)=3
      call cg_array_write_f('FlowSolutionPointers',CGNS_ENUMV(Character),2,idata,          &
           solname,ier)
!   add SimulationType
      call cg_simulation_type_write_f(index_file,index_base,CGNS_ENUMV(TimeAccurate),ier)
!   close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully added 3 times of flow solution data'',         &
       '' and time info to file grid.cgns'')')
      write(6,'(''   Note:  if the original CGNS file already had'',           &
       '' a FlowSolution_t node,'')')
      write(6,'(''          it has been overwritten'')')
      stop
      end

PROGRAM test_mixed_par_ser

  USE cgns
  use mpi
  IMPLICIT NONE

#include "cgnstypes_f03.h"
#ifdef WINNT
  INCLUDE 'cgnswin_f.h'
#endif

  INTEGER :: ierr, base, i, cg, iCoor
  INTEGER(cgsize_t) :: sizes(9)
  INTEGER :: commsize, commrank
  CHARACTER(LEN=11) :: FNAME1 = "fname1.cgns"
  CHARACTER(LEN=11) :: FNAME2 = "fname2.cgns"
  CHARACTER(LEN=11) :: FNAME3 = "fname3.cgns"
  DOUBLE PRECISION, ALLOCATABLE, DIMENSION(:) :: Dxyz

  CALL MPI_INIT(ierr)
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,commsize,ierr)
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,commrank,ierr)

  ! *******************************
  ! TEST S-P-S, all different files
  ! *******************************
  IF(commrank.EQ.0) WRITE(*,"(A)") "TEST S-P-S, all different files"
  IF(commrank.EQ.0) CALL test_serial(FNAME1)
  CALL MPI_Barrier(MPI_COMM_WORLD, ierr)
  CALL test_parallel(FNAME2)
  IF(commrank.EQ.0) CALL test_serial(FNAME3)
  CALL MPI_Barrier(MPI_COMM_WORLD, ierr)

  ! *******************************
  ! TEST S-P-S, all same files
  ! *******************************
  IF(commrank.EQ.0) WRITE(*,"(A)") "TEST S-P-S, all same files"
  IF(commrank.EQ.0) CALL test_serial(FNAME1)
  CALL MPI_Barrier(MPI_COMM_WORLD, ierr)
  CALL test_parallel(FNAME1)
  IF(commrank.EQ.0) CALL test_serial(FNAME1)
  CALL MPI_Barrier(MPI_COMM_WORLD, ierr)

  ! *******************************
  ! TEST P-S-P, all different files
  ! *******************************
  IF(commrank.EQ.0) WRITE(*,"(A)") "TEST P-S-P, all different files"
  CALL test_parallel(FNAME1)
  IF(commrank.EQ.0) CALL test_serial(FNAME2)
  CALL MPI_Barrier(MPI_COMM_WORLD, ierr)
  CALL test_parallel(FNAME3)
  
  ! *******************************
  ! TEST P-S-P, all same files
  ! *******************************
  IF(commrank.EQ.0) WRITE(*,"(A)") "TEST P-S-P, all same files"
  CALL test_parallel(FNAME1)
  IF(commrank.EQ.0) CALL test_serial(FNAME1)
  CALL MPI_Barrier(MPI_COMM_WORLD, ierr)
  CALL test_parallel(FNAME1)
  CALL mpi_finalize(ierr)

CONTAINS

  SUBROUTINE test_serial(fname)

    IMPLICIT NONE
    CHARACTER*(*) :: fname
    INTEGER(cgsize_t) ii,kk,jj, pos

    WRITE(*,"(3X,A)", ADVANCE="NO") "SERIAL CREATE....."

    ! Make a serial file:
    CALL cg_open_f(fname, CG_MODE_WRITE, cg, ierr)
    IF (ierr == CG_ERROR) CALL cgp_error_exit_f()

    CALL cg_base_write_f(cg, "Base#1", 3, 3, base, ierr)
    IF (ierr == CG_ERROR) CALL cgp_error_exit_f

    sizes = 0
    sizes(1) = 10
    sizes(2) = 10
    sizes(3) = 10
    sizes(4) = sizes(1) - 1
    sizes(5) = sizes(2) - 1
    sizes(6) = sizes(3) - 1

    ALLOCATE(Dxyz(1:sizes(1)*sizes(2)*sizes(3)) )
    DO kk=1, sizes(3)
       DO jj=1, sizes(2)
          DO ii=1, sizes(1)
             pos = ii + (jj-1)*sizes(1) + (kk-1)*sizes(1)*sizes(2)
             ! * make up some dummy coordinates just for the test:
             Dxyz(pos) = i
          ENDDO
       ENDDO
    ENDDO

    CALL cg_zone_write_f(cg, base, "zone1", sizes, CGNS_ENUMV(Structured), i, ierr)
    IF (ierr == CG_ERROR) CALL cgp_error_exit_f

    CALL cg_coord_write_f(cg, base, i, CGNS_ENUMV(RealDouble), "CoordinateX", Dxyz, iCoor, ierr)
    IF (ierr == CG_ERROR) CALL cgp_error_exit_f

    CALL cg_coord_write_f(cg, base, i, CGNS_ENUMV(RealDouble), "CoordinateY", Dxyz, iCoor, ierr)
    IF (ierr == CG_ERROR) CALL cgp_error_exit_f
    
    CALL cg_coord_write_f(cg, base, i, CGNS_ENUMV(RealDouble), "CoordinateZ", Dxyz, iCoor, ierr)
    IF (ierr == CG_ERROR) CALL cgp_error_exit_f

    CALL cg_close_f(cg, ierr)
    IF (ierr == CG_ERROR) CALL cgp_error_exit_f

    DEALLOCATE(Dxyz)

    WRITE(*,"(A)") "PASS"

  END SUBROUTINE test_serial

  SUBROUTINE test_parallel(fName)

    IMPLICIT NONE
    CHARACTER*(*) :: fname

    IF( commrank.EQ.0) WRITE(*,"(3X,A)", ADVANCE="NO") "PARALLEL CREATE..."

    CALL cgp_mpi_comm_f(MPI_COMM_WORLD, ierr)
    IF (ierr == CG_ERROR) CALL cg_error_exit_f

    CALL cgp_pio_mode_f(CGP_COLLECTIVE, ierr)
    IF (ierr == CG_ERROR) CALL cg_error_exit_f

    CALL cgp_open_f(fName, CG_MODE_WRITE, cg, ierr)
    IF (ierr == CG_ERROR) CALL cg_error_exit_f

    CALL cg_base_write_f(cg, "Base#1", 3, 3, base, ierr)
    IF (ierr == CG_ERROR) CALL cg_error_exit_f
    
    sizes = 0
    sizes(1) = 10
    sizes(2) = 10
    sizes(3) = 10
    sizes(4) = sizes(1) - 1
    sizes(5) = sizes(2) - 1
    sizes(6) = sizes(3) - 1
    CALL cg_zone_write_f(cg, base, "zone1", sizes, CGNS_ENUMV(Structured), i, ierr)
    IF (ierr == CG_ERROR) CALL cg_error_exit_f

    CALL cgp_coord_write_f(cg, base, i, CGNS_ENUMV(RealDouble), "CoordinateX", iCoor, ierr)
    IF (ierr == CG_ERROR) CALL cg_error_exit_f

    CALL cgp_coord_write_f(cg, base, i, CGNS_ENUMV(RealDouble), "CoordinateY", iCoor, ierr)
    IF (ierr == CG_ERROR) CALL cg_error_exit_f
    
    CALL cgp_coord_write_f(cg, base, i, CGNS_ENUMV(RealDouble), "CoordinateZ", iCoor, ierr)
    IF (ierr == CG_ERROR) CALL cg_error_exit_f
    
    CALL cgp_close_f(cg, ierr)
    IF (ierr == CG_ERROR) CALL cg_error_exit_f
    
    IF( commrank.EQ.0) WRITE(*,"(A)") "PASS"
    
  END SUBROUTINE test_parallel
  
END PROGRAM test_mixed_par_ser

        PROGRAM write_axisym
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on June 7 2002

!       This example tests the Axisymmetry_t data structure and its children
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 2)
	integer index_dim, cell_dim, phys_dim, i
	integer cg, base_no, ier
        integer(cgsize_t) dimval(2)
	real*4 ref_point(Ndim), axis(Ndim), angle
	character*100 linkpath, DescriptorText
	character*32 CoordinateNames(2), DescriptorName


! *** initialize
	ier = 0
	index_dim=Ndim
	cell_dim=Ndim
	phys_dim=Ndim

! *** open CGNS file for writing
 	call cg_open_f('Test_V2', MODE_WRITE, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f

! *** base
 	call cg_base_write_f(cg, 'Basename', cell_dim, phys_dim, &
                             base_no, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f

! *** write a descriptor under the base
        call cg_goto_f(cg, base_no, ier, 'end')
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_descriptor_write_f('BaseDescriptorName', &
            'BaseDescriptorText', ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** write Axisymmetry_t node
	do i=1,Ndim
	    ref_point(i)=0
	    axis(i) = i-1
	enddo

	call cg_axisym_write_f(cg, base_no, ref_point, axis, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** write children of Axisymmetry_t
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	call cg_goto_f(cg, base_no, ier, 'Axisymmetry_t', 1, 'end')
	if (ier .eq. ERROR) call cg_error_exit_f

! * DataArray_t AxisymmetryAngle
	angle = 360
	dimval(1)=1
	call cg_array_write_f('AxisymmetryAngle', CGNS_ENUMV(RealSingle), 1, &
             [1_cgsize_t], [angle], ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! * DataArray_t CoordinateNames
        dimval(1)=32
        dimval(2)=2
	write(CoordinateNames(1),'(a)')'CoordinateX'
	write(CoordinateNames(2),'(a)')'CoordinateZ'
	call cg_array_write_f('CoordinateNames', CGNS_ENUMV(Character), 2, &
             dimval, CoordinateNames, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! * Descriptor
	call cg_descriptor_write_f('AxisymDescriptorName', &
             'AxisymDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * DataClass
        call cg_dataclass_write_f(CGNS_ENUMV(Dimensional), ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! * DimensionalUnits
	call cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), CGNS_ENUMV(Kelvin), &
                              CGNS_ENUMV(Radian), ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! * UserDefinedData
        call cg_user_data_write_f('UserData1', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * Link to BaseDescriptorName
        write(linkpath,'(a)') 'Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * DataArray_t/Descriptor
	do i=1, 4
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	    call cg_goto_f(cg, base_no, ier, 'Axisymmetry_t', 1, &
                           'DataArray_t', i, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f
	    write(DescriptorName,'(a,i1)') 'DescriptorName4Array',i
	    write(DescriptorText,'(a,i1)') 'DescriptorText4Array',i
	    call cg_descriptor_write_f(DescriptorName, &
                 DescriptorText, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

! * DataArray_t/DimensionalUnits
	    call cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), CGNS_ENUMV(Kelvin), &
                                  CGNS_ENUMV(Degree), ier)
            if (ier .eq. ERROR) call cg_error_exit_f
	enddo

! *** close CGNS file
	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
        END PROGRAM write_axisym

      program write_flowvert_unst
      use cgns
      implicit none
!
!   Opens an existing CGNS file that contains a simple 3-D
!   unstructured grid, and adds a flow solution (at VERTICES)
!   to it.
!
!   The CGNS grid file 'grid.cgns' must already exist
!   (created using write_grid_unst.f)
!   Note that, other than the dimensions of the variables
!   r and p, this program is essentially identical to that for
!   writing flow solutions to a structured zone:
!   write_flowvert_str.f
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c write_flowvert_unst.F90
!   ifort -o write_flowvert_unst write_flowvert_unst.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superceded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
      real*8 r(21*17*9),p(21*17*9)
      integer index_field,index_flow,index_zone,index_base,ier
      integer index_file,i,j,k,ni,nj,nk,iset
      character solname*32
!
      write(6,'('' Program write_flowvert_unst'')')
      if (CG_BUILD_64BIT) then
        write(6,'('' ...compiled in 64-bit mode, but not needed'')')
      end if
!
!   create fake flow solution AT VERTICES for simple example:
      ni=21
      nj=17
      nk=9
      iset=0
      do k=1,nk
        do j=1,nj
          do i=1,ni
            iset=iset+1
            r(iset)=float(i-1)
            p(iset)=float(j-1)
          enddo
        enddo
      enddo
      write(6,'('' created simple 3-D rho and p flow solution'')')
!
!   WRITE FLOW SOLUTION TO EXISTING CGNS FILE
!   open CGNS file for modify
      call cg_open_f('grid.cgns',CG_MODE_MODIFY,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!   we know there is only one base (real working code would check!)
      index_base=1
!   we know there is only one zone (real working code would check!)
      index_zone=1
!   define flow solution node name (user can give any name)
      solname = 'FlowSolution'
!   create flow solution node
      call cg_sol_write_f(index_file,index_base,index_zone,solname,            &
           Vertex,index_flow,ier)
!   write flow solution (user must use SIDS-standard names here)
      call cg_field_write_f(index_file,index_base,index_zone,index_flow,       &
           RealDouble,'Density',r,index_field,ier)
      call cg_field_write_f(index_file,index_base,index_zone,index_flow,       &
           RealDouble,'Pressure',p,index_field,ier)
!   close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully added flow solution data to file'',            &
       '' grid.cgns (unstructured)'')')
      write(6,'(''   Note:  if the original CGNS file already had'',           &
       '' a FlowSolution_t node,'')')
      write(6,'(''          it has been overwritten'')')
      stop
      end

	program modify_gravity
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on May 31 2002

!       This example test the Gravity_t data structure and its children

#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 3)
	integer index_dim, cell_dim, phys_dim
	integer cg, base_no, ier, nbases
	real*4 gravity_vector(Ndim)
	character*100 linkpath
	character*32 basename
	real*4 version

! *** initialize
	ier = 0
	index_dim=Ndim
	cell_dim=Ndim
	phys_dim=Ndim

! *** open CGNS file for modifying
 	call cg_open_f('Test_V2', MODE_MODIFY, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,600)'MODIFYING FILE Test_V2'

! *** CGNS Library Version used for file creation:
        call cg_version_f(cg, version, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,102)
     &     'Library Version used for file creation:',version

        call cg_nbases_f(cg, nbases, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,200)'nbases=',nbases

! *** base
	base_no=1
        call cg_base_read_f(cg,base_no,basename,cell_dim,phys_dim,ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,300)'BaseName = "',basename,'"',
     &                'cell_dimension=',cell_dim

! *** Delete the Gravity_t node
        call cg_goto_f(cg, base_no, ier, 'end')
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_delete_node_f('Gravity', ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** Re-write Gravity_t node
!	gravity_vector(1)=0
!		gravity_vector(2)=0
!		gravity_vector(3)=9.8
!		call cg_gravity_write_f(cg, base_no, gravity_vector, ier)
!		if (ier .eq. ERROR) call cg_error_exit_f

! *** write children of Gravity_t
!		call cg_goto_f(cg, base_no, ier, 'Gravity_t', 1, 'end')
!		if (ier .eq. ERROR) call cg_error_exit_f

! * Descriptor
!		call cg_descriptor_write_f('GravityDescriptorName',
!	  &       'GravityDescriptorText', ier)
!	 if (ier .eq. ERROR) call cg_error_exit_f

! * DataClass
!       call cg_dataclass_write_f(Dimensional, ier)
!	if (ier .eq. ERROR) call cg_error_exit_f

! * DimensionalUnits
!		call cg_units_write_f(Kilogram, Meter, Second, Kelvin,
!	     &                        Radian, ier)
!		if (ier .eq. ERROR) call cg_error_exit_f

! * UserDefinedData
!        call cg_user_data_write_f('UserData1', ier)
!        if (ier .eq. ERROR) call cg_error_exit_f

! * Link to BaseDescriptorName
!        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
!        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
!        if (ier .eq. ERROR) call cg_error_exit_f

! * GravityVector/Descriptor
!	call cg_goto_f(cg, base_no, ier, 'Gravity_t', 1, 'DataArray_t',
!     &                 1, 'end')
!        if (ier .eq. ERROR) call cg_error_exit_f
!	call cg_descriptor_write_f('GravityVectorDescriptorName',
!     &       'GravityVectorDescriptorText', ier)
!	if (ier .eq. ERROR) call cg_error_exit_f
	
! * GravityVector/DimensionalUnits
!	call cg_units_write_f(Kilogram, Meter, Second, Kelvin,
!     &                        Radian, ier)
!        if (ier .eq. ERROR) call cg_error_exit_f

! *** close CGNS file
	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

 102    format(a,f5.3)
 200    format(a,i5)
 300    format(3a/a,i2)
 600    format(3a)
	end

      program write_bc_str
      use cgns
      implicit none
!
!   Opens an existing CGNS file that contains a simple 3-D
!   structured grid, and adds BC definitions (defined
!   over a range of points = PointRange)
!
!   The CGNS grid file 'grid.cgns' must already exist
!   (created using write_grid_str.f).  Note: whether the
!   existing CGNS file has a flow solution in it already or
!   not is irrelevant.
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c write_bc_str.F90
!   ifort -o write_bc_str write_bc_str.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superceded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
      integer ilo,ihi,jlo,jhi,klo,khi
      integer index_zone,index_base,index_file,index_bc,ier
      integer(cgsize_t) isize(3,3),ipnts(3,2)
      character zonename*32
!
      write(6,'('' Program write_bc_str'')')
      if (CG_BUILD_64BIT) then
        write(6,'('' ...using 64-bit mode for particular integers'')')
      end if
!
!  WRITE BOUNDARY CONDITIONS TO EXISTING CGNS FILE
!  open CGNS file for modify
      call cg_open_f('grid.cgns',CG_MODE_MODIFY,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!  we know there is only one base (real working code would check!)
      index_base=1
!  we know there is only one zone (real working code would check!)
      index_zone=1
!   get zone size (and name - although not needed here)
      call cg_zone_read_f(index_file,index_base,index_zone,zonename,           &
           isize,ier)
      write(6,'('' zonename='',a32)') zonename
      ilo=1
      ihi=isize(1,1)
      jlo=1
      jhi=isize(2,1)
      klo=1
      khi=isize(3,1)
!  write boundary conditions for ilo face, defining range first
!  (user can give any name)
!  lower point of range
      ipnts(1,1)=ilo
      ipnts(2,1)=jlo
      ipnts(3,1)=klo
!  upper point of range
      ipnts(1,2)=ilo
      ipnts(2,2)=jhi
      ipnts(3,2)=khi
      call cg_boco_write_f(index_file,index_base,index_zone,'Ilo',             &
           BCTunnelInflow,PointRange,2_cgsize_t,ipnts,index_bc,ier)
!  write boundary conditions for ihi face, defining range first
!  (user can give any name)
!  lower point of range
      ipnts(1,1)=ihi
      ipnts(2,1)=jlo
      ipnts(3,1)=klo
!  upper point of range
      ipnts(1,2)=ihi
      ipnts(2,2)=jhi
      ipnts(3,2)=khi
      call cg_boco_write_f(index_file,index_base,index_zone,'Ihi',             &
           BCExtrapolate,PointRange,2_cgsize_t,ipnts,index_bc,ier)
!  write boundary conditions for jlo face, defining range first
!  (user can give any name)
!  lower point of range
      ipnts(1,1)=ilo
      ipnts(2,1)=jlo
      ipnts(3,1)=klo
!  upper point of range
      ipnts(1,2)=ihi
      ipnts(2,2)=jlo
      ipnts(3,2)=khi
      call cg_boco_write_f(index_file,index_base,index_zone,'Jlo',             &
           BCWallInviscid,PointRange,2_cgsize_t,ipnts,index_bc,ier)
!  write boundary conditions for jhi face, defining range first
!  (user can give any name)
!  lower point of range
      ipnts(1,1)=ilo
      ipnts(2,1)=jhi
      ipnts(3,1)=klo
!  upper point of range
      ipnts(1,2)=ihi
      ipnts(2,2)=jhi
      ipnts(3,2)=khi
      call cg_boco_write_f(index_file,index_base,index_zone,'Jhi',             &
           BCWallInviscid,PointRange,2_cgsize_t,ipnts,index_bc,ier)
!  write boundary conditions for klo face, defining range first
!  (user can give any name)
!  lower point of range
      ipnts(1,1)=ilo
      ipnts(2,1)=jlo
      ipnts(3,1)=klo
!  upper point of range
      ipnts(1,2)=ihi
      ipnts(2,2)=jhi
      ipnts(3,2)=klo
      call cg_boco_write_f(index_file,index_base,index_zone,'Klo',             &
           BCWallInviscid,PointRange,2_cgsize_t,ipnts,index_bc,ier)
!  write boundary conditions for khi face, defining range first
!  (user can give any name)
!  lower point of range
      ipnts(1,1)=ilo
      ipnts(2,1)=jlo
      ipnts(3,1)=khi
!  upper point of range
      ipnts(1,2)=ihi
      ipnts(2,2)=jhi
      ipnts(3,2)=khi
      call cg_boco_write_f(index_file,index_base,index_zone,'Khi',             &
           BCWallInviscid,PointRange,2_cgsize_t,ipnts,index_bc,ier)
!  close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully added BCs (PointRange) to file'',              &
        '' grid.cgns'')')
      stop
      end

      program read_con2zn_genrl_str
      use cgns
      implicit none
!
!   Opens an existing CGNS file that contains a simple 3-D
!   structured grid (2 zones) plus 1-to-1 connectivity
!   information (written in GENERAL form), and reads the
!   connectivity info.
!
!   The CGNS grid file 'grid.cgns' must already exist
!   (created using write_grid2zn_str.f plus write_con2zn_genrl_str.f)
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c read_con2zn_genrl_str.F90
!   ifort -o read_con2zn_genrl_str read_con2zn_genrl_str.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
      integer, parameter :: maxpnts=400
      integer(cgsize_t) npts,ndata_donor
      integer(cgsize_t) ipnts(3,maxpnts),ipntsdonor(3,maxpnts)
      integer i,idonor_datatype,idonor_ptset_type,idonor_zonetype,iptset_type
      integer iconnect_type,location,nconns,nzone
      integer index_conn,index_zone,index_base,index_file,ier
      character donorname*32,connectname*32
!
!  READ GENERAL CONNECTIVITY INFORMATION FROM EXISTING CGNS FILE
!  open CGNS file for read-only
      call cg_open_f('grid.cgns',CG_MODE_READ,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!  we know there is only one base (real working code would check!)
      index_base=1
!   get number of zones (should be 2 for our case)
      call cg_nzones_f(index_file,index_base,nzone,ier)
      if (nzone .ne. 2) then
         write(6,'('' Error.  This program expects 2 zones. '',i5,             &
          '' read'')') nzone
         stop
      end if
!   loop over zones
      do index_zone=1,nzone
!   find out how many general interfaces there are in this zone
!   (for this program, there should only be one)
        call cg_nconns_f(index_file,index_base,index_zone,nconns,ier)
        if (nconns .ne. 1) then
          write(6,'('' Error.  Expecting one general interface.'',             &
            i6,'' read'')') nconns
          stop
        end if
        index_conn=nconns
!   read general connectivity info
        call cg_conn_info_f(index_file,index_base,index_zone,index_conn,       &
             connectname,location,iconnect_type,iptset_type,npts,              &
             donorname,idonor_zonetype,idonor_ptset_type,idonor_datatype,      &
             ndata_donor,ier)
        if (npts .gt. maxpnts) then
          write(6,'('' Error.  Must increase maxpnts to at least '',i5)') npts
          stop
        end if
        call cg_conn_read_f(index_file,index_base,index_zone,index_conn,       &
             ipnts,idonor_datatype,ipntsdonor,ier)
        write(6,'('' In zone '',i5,'':'')') index_zone
        write(6,'(''    donor name='',a32)') donorname
        write(6,'(''    number of connectivity pts='',i6)') npts
        write(6,'(''    grid location='',a32)')                                &
         GridLocationName(location)
        write(6,'(''    connectivity type='',a32)')                            &
         GridConnectivityTypeName(iconnect_type)
        write(6,'(''    pointset type='',a32)')                                &
         PointSetTypeName(iptset_type)
        write(6,'(''    donor zonetype='',a32)')                               &
         ZoneTypeName(idonor_zonetype)
        write(6,'(''    donor pointset type='',a32)')                          &
         PointSetTypeName(idonor_ptset_type)
!       write(6,'(''    data type='',a32)') DataTypeName(idonor_datatype)
        write(6,'(''    ipnts and ipntsdonor arrays read, only some'',         &
         '' written out here:'')')
        do i=1,10
          write(6,'('' ipnts(1,'',i2,''), (2,'',i2,''), (3,'',i2,'')='',       &
            3i4,''   ipntsdonor(1,'',i2,''), (2,'',i2,''), (3,'',i2,           &
            '')='',3i4)') i,i,i,ipnts(1,i),ipnts(2,i),ipnts(3,i),              &
            i,i,i,ipntsdonor(1,i),ipntsdonor(2,i),ipntsdonor(3,i)
        enddo
      enddo
!  close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully read general 1-to-1 connectivity'',            &
       '' info from file grid.cgns'')')
      stop
      end

      subroutine openf (iread,fname)
      integer iread
      character *(*) fname
      if (iread .eq. 0) then
        open (2,file=fname,form='unformatted',status='new')
      else
        open (2,file=fname,form='unformatted',status='old')
      endif
      end
c
      subroutine closef
      close (2)
      end
c
      subroutine readif (icnt,idata,ierr)
      integer icnt,idata(*)
      read (2,end=10) (idata(i),i=1,icnt)
      ierr = 0
      return
   10 ierr = 1
      end
c
      subroutine readff (icnt,rdata,ierr)
      integer icnt
      real*4 rdata(*)
      read (2,end=10) (rdata(i),i=1,icnt)
      ierr = 0
      return
   10 ierr = 1
      end
c
      subroutine readdf (icnt,rdata,ierr)
      integer icnt
      real*8 rdata(*)
      read (2,end=10) (rdata(i),i=1,icnt)
      ierr = 0
      return
   10 ierr = 1
      end
c
      subroutine readgff (icnt,rdata,idata,ierr)
      integer icnt,idata(*),ierr
      real*4 rdata(*)
      read (2,end=10) (rdata(i),i=1,3*icnt),(idata(i),i=1,icnt)
      ierr = 0
      return
   10 ierr = 1
      end
c
      subroutine readgdf (icnt,rdata,idata,ierr)
      integer icnt,idata(*),ierr
      real*8 rdata(*)
      read (2,end=10) (rdata(i),i=1,3*icnt),(idata(i),i=1,icnt)
      ierr = 0
      return
   10 ierr = 1
      end
c
      subroutine writeif (icnt,idata,ierr)
      integer icnt,idata(*)
      write (2) (idata(i),i=1,icnt)
      ierr = 0
      end
c
      subroutine writeff (icnt,rdata,ierr)
      integer icnt
      real*4 rdata(*)
      write (2) (rdata(i),i=1,icnt)
      ierr = 0
      end
c
      subroutine writedf (icnt,rdata,ierr)
      integer icnt
      real*8 rdata(*)
      write (2) (rdata(i),i=1,icnt)
      ierr = 0
      end
c
      subroutine writegff (icnt,rdata,idata,ierr)
      integer icnt,idata(*),ierr
      real*4 rdata(*)
      write (2) (rdata(i),i=1,3*icnt),(idata(i),i=1,icnt)
      ierr = 0
      end
c
      subroutine writegdf (icnt,rdata,idata,ierr)
      integer icnt,idata(*),ierr
      real*8 rdata(*)
      write (2) (rdata(i),i=1,3*icnt),(idata(i),i=1,icnt)
      ierr = 0
      end

      program write_grid2zn_str
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Creates simple 3-D structured grid WITH 2 ZONES and writes
!   it to a CGNS file.
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c write_grid2zn_str.F90
!   ifort -o write_grid2zn_str write_grid2zn_str.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
!   dimension statements (note that tri-dimensional arrays
!   x,y,z must be dimensioned exactly as (21,17,N) (N>=9)
!   for this particular case or else they will be written to
!   the CGNS file incorrectly!  Other options are to use 1-D
!   arrays, use dynamic memory, or pass index values to a
!   subroutine and dimension exactly there):
      real*8 x1(21,17,9),y1(21,17,9),z1(21,17,9)
      real*8 x2(21,17,9),y2(21,17,9),z2(21,17,9)
      integer index_coord,index_zone,index_base,ier
      integer iphysdim,icelldim,index_file
      integer i,j,k,ni,nj,nk
      integer(cgsize_t) isize(3,3)
      character basename*32,zonename*32
!
      write(6,'('' Program write_grid2zn_str'')')
      if (CG_BUILD_64BIT) then
        write(6,'('' ...using 64-bit mode for particular integers'')')
      end if
!
!   create gridpoints for simple example:
      ni=21
      nj=17
      nk=9
      do k=1,nk
        do j=1,nj
          do i=1,ni
            x1(i,j,k)=float(i-1)
            y1(i,j,k)=float(j-1)
            z1(i,j,k)=float(k-1)
            x2(i,j,k)=x1(i,j,k)+20.d0
            y2(i,j,k)=y1(i,j,k)
            z2(i,j,k)=z1(i,j,k)
          enddo
        enddo
      enddo
      write(6,'('' created simple 3-D grid points (2 zones)'')')
!
!   WRITE X, Y, Z GRID POINTS TO CGNS FILE
!   open CGNS file for write
      call cg_open_f('grid.cgns',CG_MODE_WRITE,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!   create base (user can give any name)
      basename='Base'
      icelldim=3
      iphysdim=3
      call cg_base_write_f(index_file,basename,icelldim,iphysdim,index_base,ier)
!   vertex size
      isize(1,1)=21
      isize(2,1)=17
      isize(3,1)=9
!   cell size
      isize(1,2)=isize(1,1)-1
      isize(2,2)=isize(2,1)-1
      isize(3,2)=isize(3,1)-1
!   boundary vertex size (always zero for structured grids)
      isize(1,3)=0
      isize(2,3)=0
      isize(3,3)=0
!   define zone 1 name (user can give any name)
      zonename = 'Zone  1'
!   create zone
      call cg_zone_write_f(index_file,index_base,zonename,isize,               &
           CGNS_ENUMV(Structured),index_zone,ier)
!   write grid coordinates (user must use SIDS-standard names here)
      call cg_coord_write_f(index_file,index_base,index_zone,CGNS_ENUMV(RealDouble),       &
           'CoordinateX',x1,index_coord,ier)
      call cg_coord_write_f(index_file,index_base,index_zone,CGNS_ENUMV(RealDouble),       &
           'CoordinateY',y1,index_coord,ier)
      call cg_coord_write_f(index_file,index_base,index_zone,CGNS_ENUMV(RealDouble),       &
           'CoordinateZ',z1,index_coord,ier)
!   define zone 2 name (user can give any name)
      zonename = 'Zone  2'
!   create zone
      call cg_zone_write_f(index_file,index_base,zonename,isize,               &
           CGNS_ENUMV(Structured),index_zone,ier)
!   write grid coordinates (user must use SIDS-standard names here)
      call cg_coord_write_f(index_file,index_base,index_zone,CGNS_ENUMV(RealDouble),       &
           'CoordinateX',x2,index_coord,ier)
      call cg_coord_write_f(index_file,index_base,index_zone,CGNS_ENUMV(RealDouble),       &
           'CoordinateY',y2,index_coord,ier)
      call cg_coord_write_f(index_file,index_base,index_zone,CGNS_ENUMV(RealDouble),       &
           'CoordinateZ',z2,index_coord,ier)
!   close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully wrote grid to file grid.cgns'')')
      stop
      end

      program test64f
      implicit none
#ifdef WINNT
      include 'cgnswin_f.h'
#endif
      include 'cgnslib_f.h'

      integer*8 nnodes,nelems
      integer dotest

      parameter (nnodes = 40000000)
      parameter (nelems = 40000000)
      parameter (dotest = 1)

      integer*8 cgfile,cgbase,cgzone,cgcoord,cgsect
      integer*8 cdim,pdim,i,ier,type,nb,pflag
      integer*8 n,ns,ne,nerrs
      integer*8 size(3),elems(4,nelems)
      real*4 nodes(nnodes)

      if (CG_BUILD_64BIT .eq. 0) then
        print *, 'must be built in 64 bit mode'
        stop
      endif

      call cg_open_f('test64.cgns',CG_MODE_WRITE,cgfile,ier)
      if (ier.ne.CG_OK) call cg_error_exit_f

      cdim = 3
      pdim = 3
      call cg_base_write_f(cgfile,'Base',cdim,pdim,cgbase,ier)
      if (ier.ne.CG_OK) call cg_error_exit_f

      size(1) = nnodes
      size(2) = nelems
      size(3) = 0
      call cg_zone_write_f(cgfile,cgbase,'Zone',size,
     &                     Unstructured, cgzone, ier)
      if (ier.ne.CG_OK) call cg_error_exit_f

      print *,'writing',nnodes,' coordinates'
      do n=1,nnodes
        nodes(n) = n
      enddo
      call cg_coord_write_f(cgfile,cgbase,cgzone,RealSingle,
     &                      'Coordinates',nodes,cgcoord,ier)
      if (ier.ne.CG_OK) call cg_error_exit_f

      print *,'writing',nelems,' tetrahedra'
      do n=1,nelems
        do i=1,4
          elems(i,n) = n
        enddo
      enddo
      ns = 1
      ne = nelems
      nb = 0
      call cg_section_write_f(cgfile,cgbase,cgzone,'Elements',
     &                        TETRA_4,ns,ne,nb,elems,cgsect,ier)
      if (ier.ne.CG_OK) call cg_error_exit_f

      call cg_close_f(cgfile,ier)
      if (ier.ne.CG_OK) call cg_error_exit_f

      if (dotest.eq.0) goto 100

      call cg_open_f('test64.cgns',CG_MODE_READ,cgfile,ier)
      if (ier.ne.CG_OK) call cg_error_exit_f

      cgbase = 1
      cgzone = 1

      print *,'reading/checking',nnodes,' coordinates'
      ns = 1
      ne = nnodes
      call cg_coord_read_f(cgfile,cgbase,cgzone,'Coordinates',
     &                     RealSingle,ns,ne,nodes,ier)
      if (ier.ne.CG_OK) call cg_error_exit_f
      nerrs = 0
      do n=1,nnodes
        if (nodes(n).ne.n) nerrs = nerrs + 1
      enddo
      print *,nerrs,' errors'

      print *,'reading/checking',nelems,' tetrahedra'
      call cg_elements_read_f(cgfile,cgbase,cgzone,cgsect,
     &                        elems,0,ier)
      if (ier.ne.CG_OK) call cg_error_exit_f
      nerrs = 0
      do n=1,nelems
        do i=1,4
          if (elems(i,n).ne.n) nerrs = nerrs + 1
        enddo
      enddo
      print *,nerrs,' errors'

      call cg_close_f(cgfile,ier)
      if (ier.ne.CG_OK) call cg_error_exit_f

  100 continue
      end

	program delete_axisym
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on June 7 2002

!       This example tests the Axisymmetry_t data structure and its children
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 2)
	integer index_dim, cell_dim, phys_dim, i
	integer cg, base_no, ier, dimval(2), nbases
	real*4 ref_point(Ndim), axis(Ndim), angle
	character*100 linkpath, DescriptorText
	character*32 CoordinateNames(2), DescriptorName, basename
        real*4 version


! *** initialize
	ier = 0
	index_dim=Ndim
	cell_dim=Ndim
	phys_dim=Ndim

! *** open CGNS file for writing
 	call cg_open_f('Test_V2', MODE_MODIFY, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,600)'MODIFYING FILE Test_V2'

! *** CGNS Library Version used for file creation:
        call cg_version_f(cg, version, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,102) &
           'Library Version used for file creation:',version

        call cg_nbases_f(cg, nbases, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,200)'nbases=',nbases

! *** base
        base_no=1
        call cg_base_read_f(cg,base_no,basename,cell_dim,phys_dim,ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,300)'BaseName = "',basename,'"', &
                      'cell_dimension=',cell_dim

! *** Delete the Axisymmetry_t node
        call cg_goto_f(cg, base_no, ier, 'end')
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_delete_node_f('Axisymmetry',ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** Re-write Axisymmetry_t node
!	do i=1,Ndim
!	    ref_point(i)=0
!	    axis(i) = i-1
!	enddo

!	call cg_axisym_write_f(cg, base_no, ref_point, axis, ier)
!	if (ier .eq. ERROR) call cg_error_exit_f

! *** write children of Axisymmetry_t
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
!	call cg_goto_f(cg, base_no, ier, 'Axisymmetry_t', 1, 'end')
!	if (ier .eq. ERROR) call cg_error_exit_f

! * DataArray_t AxisymmetryAngle
!	angle = 360
!	dimval(1)=1
!       call cg_array_write_f('AxisymmetryAngle', CGNS_ENUMV(RealSingle), 1,
!    &       1, angle, ier)
!	if (ier .eq. ERROR) call cg_error_exit_f

! * DataArray_t CoordinateNames
!       dimval(1)=32
!       dimval(2)=2
!	write(CoordinateNames(1),'(a)')'CoordinateX'
!	write(CoordinateNames(2),'(a)')'CoordinateZ'
!	call cg_array_write_f('CoordinateNames', CGNS_ENUMV(Character), 2,
!    &       dimval, CoordinateNames, ier)
!	if (ier .eq. ERROR) call cg_error_exit_f

! * Descriptor
!	call cg_descriptor_write_f('AxisymDescriptorName',
!    &       'AxisymDescriptorText', ier)
!       if (ier .eq. ERROR) call cg_error_exit_f

! * DataClass
!       call cg_dataclass_write_f(CGNS_ENUMV(Dimensional), ier)
!	if (ier .eq. ERROR) call cg_error_exit_f

! * DimensionalUnits
!	call cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), CGNS_ENUMV(Kelvin),
!    &                        CGNS_ENUMV(Radian), ier)
!	if (ier .eq. ERROR) call cg_error_exit_f

! * UserDefinedData
!       call cg_user_data_write_f('UserData1', ier)
!       if (ier .eq. ERROR) call cg_error_exit_f

! * Link to BaseDescriptorName
!       write(linkpath,'(a)') 'Basename/BaseDescriptorName'
!       call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
!       if (ier .eq. ERROR) call cg_error_exit_f

! * DataArray_t/Descriptor
!	do i=1, 4
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
!	    call cg_goto_f(cg, base_no, ier, 'Axisymmetry_t', 1,
!    &                     'DataArray_t', i, 'end')
!           if (ier .eq. ERROR) call cg_error_exit_f
!    	    write(DescriptorName,'(a,i1)') 'DescriptorName4Array',i
!	    write(DescriptorText,'(a,i1)') 'DescriptorText4Array',i
!	    call cg_descriptor_write_f(DescriptorName,
!    &           DescriptorText, ier)
!	    if (ier .eq. ERROR) call cg_error_exit_f

! * DataArray_t/DimensionalUnits
!	    call cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), CGNS_ENUMV(Kelvin),
!    &                            CGNS_ENUMV(Degree), ier)
!           if (ier .eq. ERROR) call cg_error_exit_f
!	enddo

! *** close CGNS file
	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

 102    format(a,f5.3)
 200    format(a,i5)
 300    format(3a/a,i2)
 600    format(3a)

	end

      program cgsubreg

#include "cgnstypes_f.h"
#ifdef WINNT
      include 'cgnswin_f.h'
#endif
      include 'cgnslib_f.h'

      cgsize_t ierr, cgfile, cgbase, cgzone, cgcoord
      cgsize_t csub, nsub, dim
      cgsize_t i, j, k, n, size(9)
      cgsize_t ptrange(6), ptlist(125)
      cgsize_t loc, ptype, npts, bclen, gclen
      real*4 x(125), y(125), z(125)
      character*32 sname, cname

c open and write base
      dim = 3
      call cg_open_f('cgsubreg.cgns', CG_MODE_WRITE, cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_base_write_f(cgfile, 'Base', dim, dim, cgbase, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

c create some bogus data
      do n=1,3
        size(n)   = 5
        size(n+3) = 4
        size(n+6) = 0
      enddo
      n = 0
      do k=1,5
        do j=1,5
          do i=1,5
            n = n + 1
            x(n) = i
            y(n) = j
            z(n) = k
          enddo
        enddo
      enddo
      do n=1,3
        ptrange(n) = 1
        ptrange(n+3) = 5
      enddo
      ptrange(4) = 1
      n = 0
      do j=1,5
        do i=1,5
          n = n + 1
          ptlist(n) = i
          n = n + 1
          ptlist(n) = j
          n = n + 1
          ptlist(n) = 1
        enddo
      enddo

c write zone
      call cg_zone_write_f(cgfile, cgbase, 'Zone', size,
     &                     Structured, cgzone, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
c write coordinates
      call cg_coord_write_f(cgfile, cgbase, cgzone, RealSingle,
     &                      'CoordinateX', x, cgcoord, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_coord_write_f(cgfile, cgbase, cgzone, RealSingle,
     &                      'CoordinateY', y, cgcoord, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_coord_write_f(cgfile, cgbase, cgzone, RealSingle,
     &                      'CoordinateZ', z, cgcoord, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

c write first ZoneSubRegion as BCRegionName
      dim = 2
      call cg_subreg_bcname_write_f(cgfile, cgbase, cgzone, 'reg1',
     &                              dim, 'bcname', csub, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

c write second ZoneSubRegion as GridConnectivityRegionName
      call cg_subreg_gcname_write_f(cgfile, cgbase, cgzone, 'reg2',
     &                              dim, 'gcname', csub, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

c write third ZoneSubRegion as PointRange
      npts = 2
      call cg_subreg_ptset_write_f(cgfile, cgbase, cgzone, 'reg3',
     &                             dim, Vertex, PointRange, npts,
     &                             ptrange, csub, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

c write fourth ZoneSubRegion as PointList
      npts = 25
      call cg_subreg_ptset_write_f(cgfile, cgbase, cgzone, 'reg4',
     &                             dim, EdgeCenter, PointList, npts,
     &                             ptlist, csub, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

c close the file and reopen in read mode
      call cg_close_f(cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_open_f('cgsubreg.cgns', CG_MODE_READ, cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      cgbase = 1
      cgzone = 1
      call cg_nsubregs_f(cgfile, cgbase, cgzone, nsub, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      if (nsub .ne. 4) then
        print *,'expecting nsub=4 - got',nsub
        stop
      endif

      do csub=1,4
        call cg_subreg_info_f(cgfile, cgbase, cgzone, csub, sname, dim,
     &                        loc, ptype, npts, bclen, gclen, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f

        if (sname .eq. 'reg1') then
          if (bclen .ne. 6 .or. gclen .ne. 0 .or.
     &        ptype .ne. CG_NULL .or. npts .ne. 0) then
            print *,'bad info for',sname
            stop
          endif
          call cg_subreg_bcname_read_f(cgfile, cgbase, cgzone, csub,
     &                                 cname, ierr)
          if (ierr .ne. CG_OK) call cg_error_exit_f
          if (cname .ne. 'bcname') then
            print *,'expecting bcname - got ',cname
            stop
          endif

        elseif (sname .eq. 'reg2') then
          if (bclen .ne. 0 .or. gclen .ne. 6 .or.
     &        ptype .ne. CG_NULL .or. npts .ne. 0) then
            print *,'bad info for',sname
            stop
          endif
          call cg_subreg_gcname_read_f(cgfile, cgbase, cgzone, csub,
     &                                 cname, ierr)
          if (ierr .ne. CG_OK) call cg_error_exit_f
          if (cname .ne. 'gcname') then
            print *,'expecting gcname - got ',cname
            stop
          endif

        elseif (sname .eq. 'reg3') then
          if (bclen .ne. 0 .or. gclen .ne. 0 .or.
     &        ptype .ne. PointRange .or. npts .ne. 2 .or.
     &        loc .ne. Vertex) then
            print *,'bad info for',sname
            stop
          endif
          call cg_subreg_ptset_read_f(cgfile, cgbase, cgzone, csub,
     &                                ptrange, ierr)
          if (ierr .ne. CG_OK) call cg_error_exit_f

        elseif (sname .eq. 'reg4') then
          if (bclen .ne. 0 .or. gclen .ne. 0 .or.
     &        ptype .ne. PointList .or. npts .ne. 25 .or.
     &        loc .ne. EdgeCenter) then
            print *,'bad info for',sname
            stop
          endif
          call cg_subreg_ptset_read_f(cgfile, cgbase, cgzone, csub,
     &                                ptlist, ierr)
          if (ierr .ne. CG_OK) call cg_error_exit_f

        else
          print *,'unknown subregion ',sname
          stop
        endif
      enddo

      call cg_close_f(cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      end

      program read_grid2zn_str
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Reads simple 3-D structured 2-zone grid from CGNS file
!   (companion program to write_grid2zn_str.f)
!
!   The CGNS grid file 'grid.cgns' must already exist.
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c read_grid2zn_str.F90
!   ifort -o read_grid2zn_str read_grid2zn_str.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
!   dimension statements (note that tri-dimensional arrays
!   x,y,z must be dimensioned exactly as (21,17,N) (N>=9)
!   for this particular case or else they will be read from
!   the CGNS file incorrectly!  Other options are to use 1-D
!   arrays, use dynamic memory, or pass index values to a
!   subroutine and dimension exactly there):
      real*4 x(21,17,9),y(21,17,9),z(21,17,9)
      real*4 xsav(21,17,9,2),ysav(21,17,9,2),zsav(21,17,9,2)
      integer(cgsize_t) isize(3,3),irmin(3),irmax(3)
      integer nzone,i,j,k,index_zone,index_base,index_file,ier
      character zonename*32
!
!   READ X, Y, Z GRID POINTS FROM CGNS FILE
!   open CGNS file for read-only
      call cg_open_f('grid.cgns',CG_MODE_READ,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!   we know there is only one base (real working code would check!)
      index_base=1
!   get number of zones (should be 2 for our case)
      call cg_nzones_f(index_file,index_base,nzone,ier)
      if (nzone .ne. 2) then
         write(6,'('' Error.  This program expects 2 zones. '',i5,             &
          '' read'')') nzone
         stop
      end if
!   do loop over the zones
      do index_zone=1,nzone
!   get zone size (and name - although not needed here)
        call cg_zone_read_f(index_file,index_base,index_zone,                  &
             zonename,isize,ier)
!   lower range index
        irmin(1)=1
        irmin(2)=1
        irmin(3)=1
!   upper range index of vertices
        irmax(1)=isize(1,1)
        irmax(2)=isize(2,1)
        irmax(3)=isize(3,1)
!   read grid coordinates
        call cg_coord_read_f(index_file,index_base,index_zone,                 &
             'CoordinateX',CGNS_ENUMV(RealSingle),irmin,irmax,x,ier)
        call cg_coord_read_f(index_file,index_base,index_zone,                 &
             'CoordinateY',CGNS_ENUMV(RealSingle),irmin,irmax,y,ier)
        call cg_coord_read_f(index_file,index_base,index_zone,                 &
             'CoordinateZ',CGNS_ENUMV(RealSingle),irmin,irmax,z,ier)
!   store grid coordinates in xsav,ysav,zsav array:
        do i=1,isize(1,1)
          do j=1,isize(2,1)
            do k=1,isize(3,1)
              xsav(i,j,k,index_zone)=x(i,j,k)
              ysav(i,j,k,index_zone)=y(i,j,k)
              zsav(i,j,k,index_zone)=z(i,j,k)
            enddo
          enddo
        enddo
      enddo
!   close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully read grid from file grid.cgns'')')
      write(6,'(''   For example, zone 1 x,y,z(21,17,9)='',3f12.5)')           &
       xsav(21,17,9,1),ysav(21,17,9,1),zsav(21,17,9,1)
      write(6,'(''                zone 2 x,y,z(21,17,9)='',3f12.5)')           &
       xsav(21,17,9,2),ysav(21,17,9,2),zsav(21,17,9,2)
      write(6,'('' Program successful... ending now'')')
      stop
      end

      program write_bcpnts_str
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Opens an existing CGNS file that contains a simple 3-D
!   structured grid, and adds BC definitions (defined
!   as individual points = PointList)
!
!   The CGNS grid file 'grid.cgns' must already exist
!   (created using write_grid_str.f).  Note: whether the
!   existing CGNS file has a flow solution in it already or
!   not is irrelevant.
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c write_bcpnts_str.F90
!   ifort -o write_bcpnts_str write_bcpnts_str.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
      integer, parameter :: maxcount=400
      integer(cgsize_t) isize(3,3),ipnts(3,maxcount),icounts
      integer i,j,k,ilo,ihi,jlo,jhi,klo,khi,icount
      integer index_bc,index_zone,index_base,index_file,ier
      character zonename*32
!
      write(6,'('' Program write_bcpnts_str'')')
      if (CG_BUILD_64BIT) then
        write(6,'('' ...using 64-bit mode for particular integers'')')
      end if
!
!  WRITE BOUNDARY CONDITIONS TO EXISTING CGNS FILE
!  open CGNS file for modify
      call cg_open_f('grid.cgns',CG_MODE_MODIFY,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!  we know there is only one base (real working code would check!)
      index_base=1
!  we know there is only one zone (real working code would check!)
      index_zone=1
!   get zone size (and name - although not needed here)
      call cg_zone_read_f(index_file,index_base,index_zone,zonename,isize,ier)
      write(6,'('' zonename='',a32)') zonename
      ilo=1
      ihi=isize(1,1)
      jlo=1
      jhi=isize(2,1)
      klo=1
      khi=isize(3,1)
!  write boundary conditions for ilo face, defining pointlist first
!  (user can give any name)
      icount=0
      do j=jlo,jhi
        do k=klo,khi
          icount=icount+1
          ipnts(1,icount)=ilo
          ipnts(2,icount)=j
          ipnts(3,icount)=k
        enddo
      enddo
      if (icount .gt. maxcount) then
        write(6,'('' Error.  Need to increase maxcount to at least'',          &
          i5)') icount
        stop
      end if
      icounts=icount
      call cg_boco_write_f(index_file,index_base,index_zone,'Ilo',             &
           CGNS_ENUMV(BCTunnelInflow),CGNS_ENUMV(PointList),icounts,ipnts,index_bc,ier)
!  write boundary conditions for ihi face, defining pointlist first
!  (user can give any name)
      icount=0
      do j=jlo,jhi
        do k=klo,khi
          icount=icount+1
          ipnts(1,icount)=ihi
          ipnts(2,icount)=j
          ipnts(3,icount)=k
        enddo
      enddo
      if (icount .gt. maxcount) then
        write(6,'('' Error.  Need to increase maxcount to at least'',          &
          i5)') icount
        stop
      end if
      icounts=icount
      call cg_boco_write_f(index_file,index_base,index_zone,'Ihi',             &
           CGNS_ENUMV(BCExtrapolate),CGNS_ENUMV(PointList),icounts,ipnts,index_bc,ier)
!  write boundary conditions for jlo face, defining pointlist first
!  (user can give any name)
      icount=0
      do i=ilo,ihi
        do k=klo,khi
          icount=icount+1
          ipnts(1,icount)=i
          ipnts(2,icount)=jlo
          ipnts(3,icount)=k
        enddo
      enddo
      if (icount .gt. maxcount) then
        write(6,'('' Error.  Need to increase maxcount to at least'',          &
          i5)') icount
        stop
      end if
      icounts=icount
      call cg_boco_write_f(index_file,index_base,index_zone,'Jlo',             &
           CGNS_ENUMV(BCWallInviscid),CGNS_ENUMV(PointList),icounts,ipnts,index_bc,ier)
!  write boundary conditions for jhi face, defining pointlist first
!  (user can give any name)
      icount=0
      do i=ilo,ihi
        do k=klo,khi
          icount=icount+1
          ipnts(1,icount)=i
          ipnts(2,icount)=jhi
          ipnts(3,icount)=k
        enddo
      enddo
      if (icount .gt. maxcount) then
        write(6,'('' Error.  Need to increase maxcount to at least'',          &
          i5)') icount
        stop
      end if
      icounts=icount
      call cg_boco_write_f(index_file,index_base,index_zone,'Jhi',             &
           CGNS_ENUMV(BCWallInviscid),CGNS_ENUMV(PointList),icounts,ipnts,index_bc,ier)
!  write boundary conditions for klo face, defining pointlist first
!  (user can give any name)
      icount=0
      do i=ilo,ihi
        do j=jlo,jhi
          icount=icount+1
          ipnts(1,icount)=i
          ipnts(2,icount)=j
          ipnts(3,icount)=klo
        enddo
      enddo
      if (icount .gt. maxcount) then
        write(6,'('' Error.  Need to increase maxcount to at least'',          &
          i5)') icount
        stop
      end if
      icounts=icount
      call cg_boco_write_f(index_file,index_base,index_zone,'Klo',             &
           CGNS_ENUMV(BCWallInviscid),CGNS_ENUMV(PointList),icounts,ipnts,index_bc,ier)
!  write boundary conditions for khi face, defining pointlist first
!  (user can give any name)
      icount=0
      do i=ilo,ihi
        do j=jlo,jhi
          icount=icount+1
          ipnts(1,icount)=i
          ipnts(2,icount)=j
          ipnts(3,icount)=khi
        enddo
      enddo
      if (icount .gt. maxcount) then
        write(6,'('' Error.  Need to increase maxcount to at least'',          &
          i5)') icount
        stop
      end if
      icounts=icount
      call cg_boco_write_f(index_file,index_base,index_zone,'Khi',             &
           CGNS_ENUMV(BCWallInviscid),CGNS_ENUMV(PointList),icounts,ipnts,index_bc,ier)
!  close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully added BCs (PointList) to file'',               &
        '' grid.cgns'')')
      stop
      end

! @file benchmark_hdf5_f90.F90
! @author M. Scot Breitenfeld <brtnfld@hdfgroup.org>
! @version 0.1
!
! @section LICENSE
! BSD style license
!
! @section DESCRIPTION
! F90 benchmarking program for pcgns library

MODULE testing_functions

  USE mpi
  USE ISO_C_BINDING
  USE cgns
  IMPLICIT NONE

  INTEGER :: piomode = CGP_COLLECTIVE
  LOGICAL :: enable_md = .FALSE.
  LOGICAL :: checkRead = .FALSE.
  INTEGER(cgsize_t) :: nelem = 65536

  !
  ! Contains functions to verify values
  !
  INTERFACE check_eq
     MODULE PROCEDURE c_float_eq, c_double_eq, c_long_eq, c_long_long_eq
  END INTERFACE

CONTAINS

  SUBROUTINE read_inputs(comm_rank)

    IMPLICIT NONE
    INTEGER(C_INT) :: comm_rank


    CHARACTER(len=64) :: arg
    INTEGER :: i, icnt
    LOGICAL, DIMENSION(1:3) :: buffer

    INTEGER :: err
    CHARACTER(LEN=5), DIMENSION(0:1), PARAMETER :: state= (/ "FALSE", "TRUE "/)

    IF(comm_rank.EQ.0)THEN

       buffer(1) = .FALSE.
       buffer(2) = enable_md
       buffer(3) = checkRead

       icnt = 1
       DO i = 1, command_argument_count()
          CALL get_command_argument(icnt, arg)

          SELECT CASE (arg)
          CASE ('-ind')
             buffer(1)=.TRUE.;
          CASE ('-md')
             buffer(2)=.TRUE.;
          CASE ('-R')
             buffer(3)=.TRUE.;
          CASE ('-nelem')
             icnt = icnt + 1
             CALL get_command_argument(icnt, arg)
             READ(arg,*) nelem
          END SELECT
          icnt = icnt + 1
       END DO
    ENDIF

    CALL MPI_Bcast(nelem, 1, MPI_INTEGER8, 0, MPI_COMM_WORLD, err)
    CALL MPI_Bcast(buffer, 3, MPI_LOGICAL, 0, MPI_COMM_WORLD, err)

    IF(buffer(1) .EQV. .FALSE.)THEN
       piomode = CGP_COLLECTIVE
    ELSE
       piomode = CGP_INDEPENDENT
    ENDIF
    enable_md = buffer(2)
    checkRead = buffer(3)

    IF(comm_rank.EQ.0)THEN
       WRITE(*,'(A)') REPEAT("-",32)
       WRITE(*,'(A)') "Summary"
       WRITE(*,'(A)') REPEAT("-",32)
       IF(piomode.EQ.CGP_COLLECTIVE)THEN
          WRITE(*,'(A)') "I/O mode: CGP_COLLECTIVE"
       ELSE
          WRITE(*,'(A)') "I/O mode: CGP_INDEPENDENT"
       ENDIF
       WRITE(*,'(A,L1)') "Enable multidataset APIs: ", enable_md
       WRITE(*,'(A,L1)') "Check read after read: ", checkRead
       WRITE(*,'(A,I0)') "Number of elements: ", nelem
       WRITE(*,'(A)') REPEAT("-",32)
    ENDIF

  END SUBROUTINE read_inputs

  LOGICAL FUNCTION c_float_eq(a,b)
    IMPLICIT NONE
    ! Check if two C_FLOAT reals are equivalent
    REAL*4, INTENT(IN):: a,b
    REAL*4, PARAMETER :: eps = 1.e-8
    c_float_eq = ABS(a-b) .LT. eps
  END FUNCTION c_float_eq

  LOGICAL FUNCTION c_double_eq(a,b)
    IMPLICIT NONE
    ! Check if two C_DOUBLE reals are equivalent
    REAL*8, INTENT(IN):: a,b
    REAL*8, PARAMETER :: eps = 1.e-8
    c_double_eq = ABS(a-b) .LT. eps
  END FUNCTION c_double_eq

  LOGICAL FUNCTION c_long_eq(a,b)
    IMPLICIT NONE
    ! Check if two C_LONG integers are equivalent
    INTEGER*4, INTENT(IN):: a,b
    c_long_eq = a-b .EQ. 0
  END FUNCTION c_long_eq

  LOGICAL FUNCTION c_long_long_eq(a,b)
    IMPLICIT NONE
    ! Check if two C_LONG_LONG integers are equivalent
    INTEGER*8, INTENT(IN):: a,b
    c_long_long_eq = a-b .EQ. 0
  END FUNCTION c_long_long_eq

END MODULE testing_functions

PROGRAM benchmark_hdf5_f90

  USE testing_functions
  IMPLICIT NONE

#include "cgnstypes_f03.h"
#ifdef WINNT
  INCLUDE 'cgnswin_f.h'
#endif

  INTEGER, PARAMETER :: dp = KIND(1.d0)
  ! Use powers of 2
  INTEGER(CGSIZE_T), PARAMETER :: NodePerElem = 6

  INTEGER(CGSIZE_T) :: Nnodes
  INTEGER(C_INT) :: comm_size, comm_rank, comm_info, mpi_err
  INTEGER :: err
  INTEGER :: fn
  INTEGER :: B
  INTEGER :: Z
  INTEGER :: S
  INTEGER :: Cx,Cy,Cz, Fx, Fy, Fz, Ar, Ai
  INTEGER :: cell_dim = 3
  INTEGER :: phys_dim = 3
  INTEGER :: r_cell_dim = 0
  INTEGER :: r_phys_dim = 0
  INTEGER(CGSIZE_T), DIMENSION(1:3) :: nijk, sizes
  INTEGER(CGSIZE_T) :: min, max
  INTEGER(CGSIZE_T), DIMENSION(1) :: vmin, vmax
  INTEGER(CGSIZE_T) :: k, count
  ! For writing and reading data
  REAL(KIND=dp), DIMENSION(:), ALLOCATABLE, TARGET :: Coor_x
  REAL(KIND=dp), DIMENSION(:), ALLOCATABLE, TARGET :: Coor_y
  REAL(KIND=dp), DIMENSION(:), ALLOCATABLE, TARGET :: Coor_z
  REAL(KIND=dp), DIMENSION(:), ALLOCATABLE, TARGET :: Data_Fx
  REAL(KIND=dp), DIMENSION(:), ALLOCATABLE, TARGET :: Data_Fy
  REAL(KIND=dp), DIMENSION(:), ALLOCATABLE, TARGET :: Data_Fz
  REAL(KIND=dp), DIMENSION(:), ALLOCATABLE, TARGET :: Array_r
  INTEGER(CGSIZE_T), DIMENSION(:), ALLOCATABLE, TARGET :: Array_i
  INTEGER(CGSIZE_T) :: start, iend, emin, emax
  INTEGER(CGSIZE_T), DIMENSION(:), ALLOCATABLE :: elements
  CHARACTER(LEN=32) :: fname, name
  CHARACTER(LEN=180) :: bname, zname
  INTEGER :: indx_null
  REAL(KIND=dp) t0, t1, t2
  TYPE(C_PTR), DIMENSION(1:2) :: buf2
  TYPE(C_PTR), DIMENSION(1:3) :: buf3

  ! Timing storage convention:
  ! timing(0) = Total program time
  ! timing(1) = Time to write nodal coordinates
  ! timing(2) = Time to write connectivity table
  ! timing(3) = Time to write solution data (field data)
  ! timing(4) = Time to write array data
  ! timing(5) = Time to read nodal coordinates
  ! timing(6) = Time to read connectivity table
  ! timing(7) = Time to read solution data (field data)
  ! timing(8) = Time to read array data
  ! timing(9) = Time for cgp_open, CG_MODE_WRITE
  ! timing(10) = Time for cg_base_write
  ! timing(11) = Time for cg_zone_write
  ! timing(12) = Time for cgp_open, CG_MODE_READ
  ! timing(13) = Time for cg_base_read
  ! timing(14) = Time for cg_zone_read

  REAL(KIND=dp), DIMENSION(1:15) :: xtiming, timing, timingMin, timingMax

  INTEGER :: ierr
  INTEGER :: istat
  CHARACTER(LEN=6) :: ichr6
  INTEGER, DIMENSION(1:3) :: Cvec, Fvec
  INTEGER, DIMENSION(1:2) :: Avec

  CALL MPI_Init(mpi_err)
  CALL MPI_Comm_size(MPI_COMM_WORLD,comm_size,mpi_err)
  CALL MPI_Comm_rank(MPI_COMM_WORLD,comm_rank,mpi_err)

  CALL MPI_Info_Create(comm_info,mpi_err)
  ! set this to what your GPFS block size actually is
  CALL MPI_Info_set(comm_info, "striping_unit", "8388608",mpi_err)

  WRITE(ichr6,'(I6.6)') comm_size

  CALL read_inputs(comm_rank)

  t0 = MPI_Wtime()

  CALL cgp_mpi_info_f(comm_info, ierr)
  CALL cgp_pio_mode_f(piomode, ierr)

  Nnodes = Nelem*NodePerElem

  nijk(1) = Nnodes ! Number of vertices
  nijk(2) = Nelem  ! Number of cells
  nijk(3) = 0      ! Number of boundary vertices

  ! ======================================
  ! ==    **WRITE THE CGNS FILE **      ==
  ! ======================================

  t1 = MPI_Wtime()
  CALL cgp_open_f("benchmark_"//ichr6//".cgns", CG_MODE_WRITE, fn, err)
  IF(err.NE.CG_OK)THEN
     PRINT*,'*FAILED* cgp_open_f'
     CALL cgp_error_exit_f()
  ENDIF
  t2 = MPI_Wtime()
  xtiming(10) = t2-t1

  t1 = MPI_Wtime()
  CALL cg_base_write_f(fn, "Base 1", cell_dim, phys_dim, B, err)
  IF(err.NE.CG_OK)THEN
     PRINT*,'*FAILED* cg_base_write_f'
     CALL cgp_error_exit_f()
  ENDIF
  t2 = MPI_Wtime()
  xtiming(11) = t2-t1

  t1 = MPI_Wtime()
  CALL cg_zone_write_f(fn, B, "Zone 1", nijk, CGNS_ENUMV(Unstructured), Z, err)
  IF(err.NE.CG_OK)THEN
     PRINT*,'*FAILED* cg_zone_write_f'
     CALL cgp_error_exit_f()
  ENDIF
  t2 = MPI_Wtime()
  xtiming(12) = t2-t1

  ! ======================================
  ! == (A) WRITE THE NODAL COORDINATES  ==
  ! ======================================

  count = nijk(1)/comm_size

  ALLOCATE(Coor_x(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, '*FAILED* allocation of Coor_x'
     CALL cgp_error_exit_f()
  ENDIF
  ALLOCATE(Coor_y(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, '*FAILED* allocation of Coor_y'
     CALL cgp_error_exit_f()
  ENDIF
  ALLOCATE(Coor_z(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, '*FAILED* allocation of Coor_z'
     CALL cgp_error_exit_f()
  ENDIF

  vmin(1) = count*comm_rank+1
  vmax(1) = count*(comm_rank+1)

  DO k = 1, count
     Coor_x(k) = REAL(comm_rank*count + k, KIND=dp) + 0.1_dp
     Coor_y(k) = Coor_x(k) + 0.1_dp
     Coor_z(k) = Coor_y(k) + 0.1_dp
  ENDDO

  CALL cgp_coord_write_f(fn,B,Z,CGNS_ENUMV(RealDouble),"CoordinateX",Cx,err)
  IF(err.NE.CG_OK)THEN
     PRINT*,'*FAILED* cgp_coord_write_f (Coor_X)'
     CALL cgp_error_exit_f()
  ENDIF
  CALL cgp_coord_write_f(fn,B,Z,CGNS_ENUMV(RealDouble),"CoordinateY",Cy,err)
  IF(err.NE.CG_OK)THEN
     PRINT*,'*FAILED* cgp_coord_write_f (Coor_Y)'
     CALL cgp_error_exit_f()
  ENDIF
  CALL cgp_coord_write_f(fn,B,Z,CGNS_ENUMV(RealDouble),"CoordinateZ",Cz,err)
  IF(err.NE.CG_OK)THEN
     PRINT*,'*FAILED* cgp_coord_write_f (Coor_Z)'
     CALL cgp_error_exit_f()
  ENDIF

  t1 = MPI_Wtime()
  IF(enable_md)THEN
     Cvec(1:3) = (/Cx,Cy,Cz/)

     buf3(1) = C_LOC(Coor_x)
     buf3(2) = C_LOC(Coor_y)
     buf3(3) = C_LOC(Coor_z)

     CALL cgp_coord_multi_write_data_f(fn,B,Z,Cvec,vmin(1),vmax(1),3,buf3,err)
     IF(err.NE.CG_OK)THEN
        PRINT*,'*FAILED* cgp_coord_multi_write_data_f'
        CALL cgp_error_exit_f()
     ENDIF
  ELSE
     CALL cgp_coord_write_data_f(fn,B,Z,Cx,vmin(1),vmax(1),Coor_x,err)
     IF(err.NE.CG_OK)THEN
        PRINT*,'*FAILED* cgp_coord_write_data_f (Coor_x)'
        CALL cgp_error_exit_f()
     ENDIF
     CALL cgp_coord_write_data_f(fn,B,Z,Cy,vmin(1),vmax(1),Coor_y,err)
     IF(err.NE.CG_OK)THEN
        PRINT*,'*FAILED* cgp_coord_write_data_f (Coor_y)'
        CALL cgp_error_exit_f()
     ENDIF
     CALL cgp_coord_write_data_f(fn,B,Z,Cz,vmin(1),vmax(1),Coor_z,err)
     IF(err.NE.CG_OK)THEN
        PRINT*,'*FAILED* cgp_coord_write_data_f (Coor_z)'
        CALL cgp_error_exit_f()
     ENDIF
  ENDIF
  t2 = MPI_Wtime()
  xtiming(2) = t2-t1

  DEALLOCATE(Coor_x, Coor_y, Coor_z)

  ! ======================================
  ! == (B) WRITE THE CONNECTIVITY TABLE ==
  ! ======================================

  start = 1
  iend = nijk(2)
  CALL cgp_section_write_f(fn,B,Z,"Elements",CGNS_ENUMV(PENTA_6),start,iend,0,S,err)
  IF(err.NE.CG_OK)THEN
     PRINT*,'*FAILED* cgp_section_write_f'
     CALL cgp_error_exit_f()
  ENDIF

  count = nijk(2)/comm_size
  ALLOCATE(elements(1:count*NodePerElem), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, '*FAILED* allocation of elements'
     CALL cgp_error_exit_f()
  ENDIF

  ! Create ridiculous connectivity table ...
  DO k = 1, count*NodePerElem
     elements(k) = comm_rank*count*NodePerElem + k
  ENDDO

  emin = count*comm_rank+1
  emax = count*(comm_rank+1)

  t1 = MPI_Wtime()
  CALL cgp_elements_write_data_f(fn, B, Z, S, emin, emax, elements,err)
  IF(err.NE.CG_OK)THEN
     PRINT*,'*FAILED* cgp_elements_write_data_f (elements)'
     CALL cgp_error_exit_f()
  ENDIF

  t2 = MPI_Wtime()
  xtiming(3) = t2-t1

  DEALLOCATE(elements)

  ! ======================================
  ! == (C) WRITE THE FIELD DATA         ==
  ! ======================================

  count = nijk(1)/comm_size

  ALLOCATE(Data_Fx(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, '*FAILED* allocation of Data_Fx'
     CALL cgp_error_exit_f()
  ENDIF
  ALLOCATE(Data_Fy(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, '*FAILED* allocation of Data_Fy'
     CALL cgp_error_exit_f()
  ENDIF
  ALLOCATE(Data_Fz(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, '*FAILED* allocation of Data_Fz'
     CALL cgp_error_exit_f()
  ENDIF

  DO k = 1, count
     Data_Fx(k) = REAL(comm_rank*count+k, KIND=dp) + .01_dp
     Data_Fy(k) = REAL(comm_rank*count+k, KIND=dp) + .02_dp
     Data_Fz(k) = REAL(comm_rank*count+k, KIND=dp) + .03_dp
  ENDDO

  CALL cg_sol_write_f(fn, B, Z, "Solution", CGNS_ENUMV(Vertex), S, err)
  IF(err.NE.CG_OK)THEN
     PRINT*,'*FAILED* cg_sol_write_f'
     CALL cgp_error_exit_f()
  ENDIF

  CALL cgp_field_write_f(fn,B,Z,S,CGNS_ENUMV(RealDouble),"MomentumX",Fx, err)
  IF(err.NE.CG_OK)THEN
     PRINT*,'*FAILED* cgp_field_write  (MomentumX)'
     CALL cgp_error_exit_f()
  ENDIF
  CALL cgp_field_write_f(fn,B,Z,S,CGNS_ENUMV(RealDouble),"MomentumY",Fy, err)
  IF(err.NE.CG_OK)THEN
     PRINT*,'*FAILED* cgp_field_write (MomentumY)'
     CALL cgp_error_exit_f()
  ENDIF
  CALL cgp_field_write_f(fn,B,Z,S,CGNS_ENUMV(RealDouble),"MomentumZ",Fz, err)
  IF(err.NE.CG_OK)THEN
     PRINT*,'*FAILED* cgp_field_write (MomentumZ)'
     CALL cgp_error_exit_f()
  ENDIF

  t1 = MPI_Wtime()

  IF(enable_md)THEN
     Fvec(1:3) = (/Fx,Fy,Fz/)

     buf3(1) = C_LOC(Data_Fx)
     buf3(2) = C_LOC(Data_Fy)
     buf3(3) = C_LOC(Data_Fz)

     CALL cgp_field_multi_write_data_f(fn,B,Z,S,Fvec,vmin,vmax,3,buf3,err)
     IF(err.NE.CG_OK)THEN
        PRINT*,'*FAILED* cgp_field_multi_write_data_f'
        CALL cgp_error_exit_f()
     ENDIF
  ELSE
     CALL cgp_field_write_data_f(fn,B,Z,S,Fx,vmin(1),vmax(1),Data_Fx, err)
     IF(err.NE.CG_OK)THEN
        PRINT*,'*FAILED* cgp_field_write_data (Data_Fx)'
        CALL cgp_error_exit_f()
     ENDIF
     CALL cgp_field_write_data_f(fn,B,Z,S,Fy,vmin(1),vmax(1),Data_Fy, err)
     IF(err.NE.CG_OK)THEN
        PRINT*,'*FAILED* cgp_field_write_data (Data_Fy)'
        CALL cgp_error_exit_f()
     ENDIF
     CALL cgp_field_write_data_f(fn,B,Z,S,Fz,vmin(1),vmax(1),Data_Fz, err)
     IF(err.NE.CG_OK)THEN
        PRINT*,'*FAILED* cgp_field_write_data (Data_Fz)'
        CALL cgp_error_exit_f()
     ENDIF
  ENDIF
  t2 = MPI_Wtime()
  xtiming(4) = t2-t1

  DEALLOCATE(Data_Fx,Data_Fy,Data_Fz)

  ! ======================================
  ! == (D) WRITE THE ARRAY DATA         ==
  ! ======================================

  count = nijk(1)/comm_size

  ALLOCATE(Array_r(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, '*FAILED* allocation of Array_r'
     CALL cgp_error_exit_f()
  ENDIF
  ALLOCATE(Array_i(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, '*FAILED* allocation of Array_i'
     CALL cgp_error_exit_f()
  ENDIF

  vmin(1) = count*comm_rank+1
  vmax(1) = count*(comm_rank+1)

  DO k = 1, count
     Array_r(k) = REAL(comm_rank*count + k, KIND=dp) + .001_dp
     Array_i(k) = comm_rank*count*NodePerElem + k
  ENDDO

  CALL cg_goto_f(fn, B, err, 'Zone 1', 0, 'end')
  IF(err.NE.CG_OK)THEN
     PRINT*,'*FAILED* cg_goto_f'
     CALL cgp_error_exit_f()
  ENDIF
  CALL cg_user_data_write_f("User Data", err)
  IF(err.NE.CG_OK)THEN
     PRINT*,'*FAILED* cg_user_data_write_f'
     CALL cgp_error_exit_f()
  ENDIF

  CALL cg_gorel_f(fn,err,'User Data',0,'end')
  IF(err.NE.CG_OK)THEN
     PRINT*,'*FAILED* cg_gorel_f'
     CALL cgp_error_exit_f()
  ENDIF

  CALL cgp_array_write_f("ArrayR",cg_get_type(Array_r(1)),1,INT(nijk(1),cgsize_t),Ar, err)
  IF(err.NE.CG_OK)THEN
     PRINT*,'*FAILED* cgp_array_write_f (Array_Ar)'
     CALL cgp_error_exit_f()
  ENDIF

  CALL cgp_array_write_f("ArrayI",cg_get_type(Array_i(1)),1,INT(nijk(1),cgsize_t),Ai, err)
  IF(err.NE.CG_OK)THEN
     PRINT*,'*FAILED* cgp_array_write_f   (Array_Ai)'
     CALL cgp_error_exit_f()
  ENDIF

  t1 = MPI_Wtime()

  IF(enable_md)THEN
     Avec = (/Ai,Ar/)
     buf2(1) = C_LOC(Array_i)
     buf2(2) = C_LOC(Array_r)
     CALL cgp_array_multi_write_data_f(fn,Avec,vmin,vmax,2,buf2,err)
     IF(err.NE.CG_OK)THEN
        PRINT*,'*FAILED* cgp_array_multi_write_data_f'
        CALL cgp_error_exit_f()
     ENDIF
  ELSE
     CALL cgp_array_write_data_f(Ai,vmin(1),vmax(1),Array_i, err)
     IF(err.NE.CG_OK)THEN
        PRINT*,'*FAILED* cgp_array_write_data_f  (Array_Ai)'
        CALL cgp_error_exit_f()
     ENDIF
     CALL cgp_array_write_data_f(Ar,vmin(1),vmax(1),Array_r, err)
     IF(err.NE.CG_OK)THEN
        PRINT*,'*FAILED* cgp_array_write_data_f (Array_Ar)'
        CALL cgp_error_exit_f()
     ENDIF
  ENDIF
  t2 = MPI_Wtime()
  xtiming(5) = t2-t1

  DEALLOCATE(Array_r,Array_i)

  CALL cgp_close_f(fn, err)
  IF(err.NE.CG_OK)THEN
     PRINT*,'*FAILED* cgp_close_f'
     CALL cgp_error_exit_f()
  ENDIF

  ! ======================================
  ! ==    **  READ THE CGNS FILE **     ==
  ! ======================================

  CALL MPI_Barrier(MPI_COMM_WORLD, mpi_err)

  t1 = MPI_Wtime()
  ! Open the cgns file for reading
  CALL cgp_open_f("benchmark_"//ichr6//".cgns", CG_MODE_MODIFY, fn, err)
  IF(err.NE.CG_OK)THEN
     PRINT*,'*FAILED* cgp_open_f'
     CALL cgp_error_exit_f()
  ENDIF
  t2 = MPI_Wtime()
  xtiming(13) = t2-t1

  ! Read the base information
  t1 = MPI_Wtime()
  CALL cg_base_read_f(fn, B, bname, r_cell_dim, r_phys_dim, err)
  IF(err.NE.CG_OK)THEN
     PRINT*,'*FAILED* cg_base_read_f'
     CALL cgp_error_exit_f()
  ENDIF
  t2 = MPI_Wtime()
  xtiming(14) = t2-t1
  IF(r_cell_dim.NE.cell_dim.OR.r_phys_dim.NE.phys_dim)THEN
     WRITE(*,'(2(A,I0))') '*FAILED* bad cell dim = ',r_cell_dim,'or phy dim =',r_phys_dim
     CALL cgp_error_exit_f()
  ENDIF

  IF(TRIM(bname).NE.'Base 1')THEN
     WRITE(*,'(A,A)') '*FAILED* bad base name = ',TRIM(bname)
     CALL cgp_error_exit_f()
  ENDIF

  ! Read the zone information
  t1 = MPI_Wtime()
  CALL cg_zone_read_f(fn, B, Z, zname, sizes, err)
  IF(err.NE.CG_OK) PRINT*,'*FAILED* cgp_zone_read_f'
  t2 = MPI_Wtime()
  xtiming(15) = t2-t1

  ! Check the read zone information is correct
  IF(sizes(1).NE.Nnodes)THEN
     WRITE(*,'(A,I0)') '*FAILED* bad num points = ',sizes(1)
     CALL cgp_error_exit_f()
  ENDIF

  IF(sizes(2).NE.Nelem)THEN
     WRITE(*,'(A,I0)') '*FAILED* bad num elements = ',sizes(2)
     CALL cgp_error_exit_f()
  ENDIF
  IF(sizes(3).NE.0)THEN
     WRITE(*,'(A,I0)') '*FAILED* bad num elements = ',sizes(3)
     CALL cgp_error_exit_f()
  ENDIF

  IF(TRIM(zname).NE.'Zone 1')THEN
     WRITE(*,'(A,A)') '*FAILED* bad zone name = ',TRIM(zname)
     CALL cgp_error_exit_f()
  ENDIF


  ! ======================================
  ! ==  (A) READ THE NODAL COORDINATES  ==
  ! ======================================

  count = nijk(1)/comm_size
  ALLOCATE(Coor_x(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, '*FAILED* allocation of Coor_x'
     CALL cgp_error_exit_f()
  ENDIF
  ALLOCATE(Coor_y(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, '*FAILED* allocation of Coor_y'
     CALL cgp_error_exit_f()
  ENDIF
  ALLOCATE(Coor_z(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, '*FAILED* allocation of Coor_z'
     CALL cgp_error_exit_f()
  ENDIF

  vmin = count*comm_rank+1
  vmax = count*(comm_rank+1)

  t1 = MPI_Wtime()
  IF(enable_md)THEN
     Cvec(1:3) = (/Cx,Cy,Cz/)

     ! Point to the read buffer
     buf3(1) = C_LOC(Coor_x)
     buf3(2) = C_LOC(Coor_y)
     buf3(3) = C_LOC(Coor_z)

     CALL cgp_coord_multi_read_data_f(fn,B,Z,Cvec,vmin,vmax,3,buf3,err)
     IF(err.NE.CG_OK)THEN
        PRINT*,'*FAILED* cgp_coord_multi_read_data_f'
        CALL cgp_error_exit_f()
     ENDIF
  ELSE
     CALL cgp_coord_read_data_f(fn,B,Z,Cx,vmin(1),vmax(1),Coor_x,err)
     IF(err.NE.CG_OK)THEN
        PRINT*,'*FAILED* cgp_coord_read_data_f (Reading Coor_x)'
        CALL cgp_error_exit_f()
     ENDIF
     CALL cgp_coord_read_data_f(fn,B,Z,Cy,vmin(1),vmax(1),Coor_y,err)
     IF(err.NE.CG_OK)THEN
        PRINT*,'*FAILED* cgp_coord_read_data_f (Reading Coor_y)'
        CALL cgp_error_exit_f()
     ENDIF
     CALL cgp_coord_read_data_f(fn,B,Z,Cz,vmin(1),vmax(1),Coor_z,err)
     IF(err.NE.CG_OK)THEN
        PRINT*,'*FAILED* cgp_coord_read_data_f (Reading Coor_z)'
        CALL cgp_error_exit_f()
     ENDIF
  ENDIF
  t2 = MPI_Wtime()
  xtiming(6) = t2-t1

  ! Check if read the data back correctly
  IF(checkRead)THEN
     DO k = 1, count
        IF(.NOT.check_eq(Coor_x(k), REAL(comm_rank*count + k, KIND=DP) + 0.1_DP).OR. &
             .NOT.check_eq(Coor_y(k), REAL(comm_rank*count + k, KIND=DP) + 0.2_DP).OR. &
             .NOT.check_eq(Coor_z(k), REAL(comm_rank*count + k, KIND=DP) + 0.3_DP)) THEN
           PRINT*,'*FAILED* cgp_coord_read_data values are incorrect'
           CALL cgp_error_exit_f()
        ENDIF
     ENDDO
  ENDIF

  DEALLOCATE(Coor_x, Coor_y, Coor_z)

  ! ======================================
  ! == (B) READ THE CONNECTIVITY TABLE  ==
  ! ======================================

  count = nijk(2)/comm_size
  ALLOCATE(elements(1:count*NodePerElem), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, '*FAILED* allocation of elements'
     CALL cgp_error_exit_f()
  ENDIF

  emin = count*comm_rank+1
  emax = count*(comm_rank+1)

  t1 = MPI_Wtime()
  CALL cgp_elements_read_data_f(fn, B, Z, S, emin, emax, elements, err)
  IF(err.NE.CG_OK)THEN
     PRINT*,'*FAILED* cgp_elements_read_data_f ( Reading elements)'
     CALL cgp_error_exit_f()
  ENDIF
  t2 = MPI_Wtime()
  xtiming(7) = t2-t1
  IF(checkRead)THEN
     DO k = 1, count
        IF(.NOT.check_eq(elements(k), comm_rank*count*NodePerElem + k)) THEN
           PRINT*,'*FAILED* cgp_elements_read_data values are incorrect'
           CALL cgp_error_exit_f()
        ENDIF
     ENDDO
  ENDIF

  DEALLOCATE(elements)

  ! ======================================
  ! == (C) READ THE FIELD DATA          ==
  ! ======================================
  count = nijk(1)/comm_size

  ALLOCATE(Data_Fx(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, '*FAILED* allocation of Data_Fx'
     CALL cgp_error_exit_f()
  ENDIF
  ALLOCATE(Data_Fy(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, '*FAILED* allocation of Data_Fy'
     CALL cgp_error_exit_f()
  ENDIF
  ALLOCATE(Data_Fz(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, '*FAILED* allocation of Data_Fz'
     CALL cgp_error_exit_f()
  ENDIF

  vmin = count*comm_rank+1
  vmax = count*(comm_rank+1)

  t1 = MPI_Wtime()
  IF(enable_md)THEN
     Fvec(1:3) = (/Fx,Fy,Fz/)

     buf3(1) = C_LOC(Data_Fx)
     buf3(2) = C_LOC(Data_Fy)
     buf3(3) = C_LOC(Data_Fz)

     CALL cgp_field_multi_read_data_f(fn,B,Z,S,Fvec,vmin,vmax,3,buf3,err)
     IF(err.NE.CG_OK)THEN
        PRINT*,'*FAILED* cgp_field_multi_read_data_f'
        CALL cgp_error_exit_f()
     ENDIF
  ELSE
     CALL cgp_field_read_data_f(fn,B,Z,S,Fx,vmin(1),vmax(1),Data_Fx,err)
     IF(err.NE.CG_OK)THEN
        PRINT*,'*FAILED* cgp_field_read_data (Data_Fx)'
        CALL cgp_error_exit_f()
     ENDIF
     CALL cgp_field_read_data_f(fn,B,Z,S,Fy,vmin(1),vmax(1),Data_Fy,err)
     IF(err.NE.CG_OK)THEN
        PRINT*,'*FAILED* cgp_field_read_data (Data_Fy)'
        CALL cgp_error_exit_f()
     ENDIF
     CALL cgp_field_read_data_f(fn,B,Z,S,Fz,vmin(1),vmax(1),Data_Fz,err)
     IF(err.NE.CG_OK)THEN
        PRINT*,'*FAILED* cgp_field_read_data (Data_Fz)'
        CALL cgp_error_exit_f()
     ENDIF
  ENDIF
  t2 = MPI_Wtime()
  xtiming(8) = t2-t1

  ! Check if read the data back correctly
  IF(checkRead)THEN
     DO k = 1, count
        IF(.NOT.check_eq(Data_Fx(k), REAL(comm_rank*count + k, KIND=dp) + 0.01_dp).OR. &
             .NOT.check_eq(Data_Fy(k), REAL(comm_rank*count + k, KIND=dp) + 0.02_dp).OR. &
             .NOT.check_eq(Data_Fz(k), REAL(comm_rank*count + k, KIND=dp) + 0.03_dp)) THEN
           PRINT*,'*FAILED* cgp_field_read_data_f values are incorrect'
           CALL cgp_error_exit_f()
        ENDIF
     ENDDO
  ENDIF

  DEALLOCATE(Data_Fx,Data_Fy,Data_Fz)

  ! ======================================
  ! == (D) READ THE ARRAY DATA          ==
  ! ======================================

  count = nijk(1)/comm_size

  ALLOCATE(Array_r(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, '*FAILED* allocation of Array_r'
     CALL cgp_error_exit_f()
  ENDIF
  ALLOCATE(Array_i(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, '*FAILED* allocation of Array_i'
     CALL cgp_error_exit_f()
  ENDIF

  vmin = count*comm_rank+1
  vmax = count*(comm_rank+1)

  CALL cg_goto_f(fn, B, err, "Zone_t",Z,"UserDefinedData_t",1,'end')
  IF(err.NE.CG_OK)THEN
     PRINT*,'*FAILED* cg_goto (User Defined Data)'
     CALL cgp_error_exit_f()
  ENDIF

  t1 = MPI_Wtime()

  IF(enable_md)THEN
     Avec = (/Ai,Ar/)

     buf2(1) = C_LOC(Array_i)
     buf2(2) = C_LOC(Array_r)

     CALL cgp_array_multi_read_data_f(fn,Avec,vmin,vmax,2,buf2,err)
     IF(err.NE.CG_OK)THEN
        PRINT*,'*FAILED* cgp_array_multi_read_data_f'
        CALL cgp_error_exit_f()
     ENDIF
  ELSE
     CALL cgp_array_read_data_f(Ar, vmin(1), vmax(1), Array_r, err)
     IF(err.NE.CG_OK)THEN
        PRINT*,'*FAILED* cgp_field_read_data (Array_r)'
        CALL cgp_error_exit_f()
     ENDIF
     CALL cgp_array_read_data_f(Ai, vmin(1), vmax(1), Array_i, err)
     IF(err.NE.CG_OK)THEN
        PRINT*,'*FAILED* cgp_field_read_data (Array_i)'
        CALL cgp_error_exit_f()
     ENDIF
  ENDIF
  t2 = MPI_Wtime()
  xtiming(9) = t2-t1

  ! Check if read the data back correctly
  IF(checkRead)THEN
     DO k = 1, count
        IF(.NOT.check_eq(Array_r(k), REAL(comm_rank*count + k, KIND=dp) + 0.001_dp).OR. &
             .NOT.check_eq(Array_i(k), comm_rank*count*NodePerElem + k)) THEN
           PRINT*,'*FAILED* cgp_array_read_data values are incorrect'
           CALL cgp_error_exit_f()
        ENDIF
     ENDDO
  ENDIF

  DEALLOCATE(Array_r, Array_i)

  CALL cgp_close_f(fn, err)
  IF(err.NE.CG_OK)THEN
     PRINT*,'*FAILED* cgp_close'
     CALL cgp_error_exit_f()
  ENDIF
  t2 = MPI_Wtime()

  xtiming(1) = t2-t0

  CALL MPI_Reduce(xtiming, timing, 15, MPI_DOUBLE, &
       MPI_SUM, 0, MPI_COMM_WORLD, mpi_err)
  CALL MPI_Reduce(xtiming, timingMin, 15, MPI_DOUBLE, &
       MPI_MIN, 0, MPI_COMM_WORLD, mpi_err)
  CALL MPI_Reduce(xtiming, timingMax, 15, MPI_DOUBLE, &
       MPI_MAX, 0, MPI_COMM_WORLD, mpi_err)

  IF(comm_rank.EQ.0)THEN
     OPEN(10,FILE="timing_"//ichr6//".dat", FORM='formatted')
     WRITE(10,'(A)')"#nprocs, wcoord, welem, wfield, warray, rcoord, relem, rfield, rarray"
     WRITE(10,'(i0,100(x,3(f14.7)))') comm_size, &
          timing(1)/DBLE(comm_size), timingMin(1), timingMax(1), &
          timing(2)/DBLE(comm_size), timingMin(2), timingMax(2), &
          timing(3)/DBLE(comm_size), timingMin(3), timingMax(3), &
          timing(4)/DBLE(comm_size), timingMin(4), timingMax(4), &
          timing(5)/DBLE(comm_size), timingMin(5), timingMax(5), &
          timing(6)/DBLE(comm_size), timingMin(6), timingMax(6), &
          timing(7)/DBLE(comm_size), timingMin(7), timingMax(7), &
          timing(8)/DBLE(comm_size), timingMin(8), timingMax(8), &
          timing(9)/DBLE(comm_size), timingMin(9), timingMax(9), &
          timing(10)/DBLE(comm_size), timingMin(10), timingMax(10), &
          timing(11)/DBLE(comm_size), timingMin(11), timingMax(11), &
          timing(12)/DBLE(comm_size), timingMin(12), timingMax(12), &
          timing(13)/DBLE(comm_size), timingMin(13), timingMax(13), &
          timing(14)/DBLE(comm_size), timingMin(14), timingMax(14), &
          timing(15)/DBLE(comm_size), timingMin(15), timingMax(15)
  ENDIF

  CALL MPI_FINALIZE(mpi_err)

END PROGRAM benchmark_hdf5_f90

        PROGRAM write_bprop
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on August 2002

!       This example test the BCProperty_t data structure and its children
!       It tests the functions:
!	- cg_bc_wallfunction_write_f(cg, B, Z, BC, WallFunctionType, ier)
!	- cg_bc_area_write_f(cg, B, Z, BC, AreaType, SurfaceArea, RegionName, ier)
!       And the following:
!       - multiple calls for the same BC => must return error in mode write
!       - Test RegionName in 32 char string, justification, call with a name (not declared)
!       - cg_descriptor_write under BCProperty_t, WallFunction_t, Area_t
!       - cg_user_data_write, under BCProperty_t, WallFunction_t, Area_t
!       - cg_array_write under Area_t => should return an error
!       - links under BCProperty_t, WallFunction_t, Area_t
!       - cg_goto to BCProperty_t, WallFunction_t, Area_t
!       - Memory check with Insure
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 3)
	integer index_dim, cell_dim, phys_dim
	character*100 linkpath

	integer cg, base, zone, boco, ier, i, num
	integer(cgsize_t) size(Ndim*3)
	integer WallFunctionType, AreaType
	integer(cgsize_t) pnts(Ndim,2)
	character*32 RegionName32
	character*10 RegionName10
	character*100 RegionName100
	real *4 SurfaceArea
	integer(cgsize_t) dim_vals(2)
	

! *** initialize
	ier = 0
	index_dim=Ndim
	cell_dim=Ndim
	phys_dim=Ndim

! *** open CGNS file for writing
 	call cg_open_f('Test_V2', MODE_WRITE, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f

! *** base
 	call cg_base_write_f(cg, 'Basename', cell_dim, phys_dim, &
                             base, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f

! *** write a descriptor under the base
        call cg_goto_f(cg, base, ier, 'end')
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_descriptor_write_f('BaseDescriptorName', &
            'BaseDescriptorText', ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** write a zone
	do i=1,index_dim                    	! zone#1: 3*4*5
	    size(i) = i+2			! nr of nodes in i,j,k
	    size(i+index_dim) = size(i)-1	! nr of elements in i,j,k
	    size(i+2*index_dim) = 0		! nr of bnd nodes if ordered
	    num = num * size(i)             	! nr of nodes
	enddo

	call cg_zone_write_f(cg, base, 'Zone#1', size, CGNS_ENUMV(Structured), &
       	    zone, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** write bocos
	! imin face
	do i=1, index_dim
	    pnts(i,1) = 1
	    pnts(i,2) = size(i)
	enddo
	pnts(1,2) = 1
        call cg_boco_write_f(cg, base, zone, 'boco#1', &
             CGNS_ENUMV(BCInflow), CGNS_ENUMV(PointRange), 2_cgsize_t, pnts, boco, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        ! imax face
	do i=1, index_dim
            pnts(i,1) = 1
            pnts(i,2) = size(i)
        enddo
        pnts(1,1) = size(1)
	call cg_boco_write_f(cg, base, zone, 'boco#2', &
             CGNS_ENUMV(BCOutflow), CGNS_ENUMV(PointRange), 2_cgsize_t, pnts, boco, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	
! *** write BCProperty_t/WallFunction_t node under boco#2
	WallFunctionType = CGNS_ENUMV(Generic)
	call cg_bc_wallfunction_write_f(cg, base, zone, &
              boco, WallFunctionType, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** test calling it again
!	call cg_bc_wallfunction_write_f(cg, base, zone,
!    &        boco, WallFunctionType, ier)
!       if (ier .eq. ERROR) call cg_error_exit_f

! *** write BCProperty_t/Area_t node under boco#2
	AreaType = CGNS_ENUMV(BleedArea)
	SurfaceArea = 123.456
!	RegionName10 = 'myRegion'
 	RegionName100 = 'myRegion'
!	write(RegionName32,'(a10)')'myRegion32'
	call cg_bc_area_write_f(cg, base, zone, boco, AreaType, &
       	     SurfaceArea, RegionName100, ier)

! *** write Descriptor_t, UserDefinedData_t & Link under...
! ...   BCProperty_t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1, &
      	    'BC_t', boco, 'BCProperty_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_descriptor_write_f('BCpropDescriptorName', &
            'BCpropDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_user_data_write_f('BCPropUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! ...   WallFunction_t
	call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1, &
            'BC_t', boco, 'BCProperty_t', 1, 'WallFunction_t', 1, 'end')

	call cg_descriptor_write_f('WFDescriptorName', &
      	    'WFDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_user_data_write_f('WFUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! ...   Area_t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1, &
            'BC_t', boco, 'BCProperty_t', 1, 'Area_t', 1, 'end')
	call cg_descriptor_write_f('AreaDescriptorName', &
      	    'AreaDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_user_data_write_f('AreaUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

 	dim_vals(1)=3
 	dim_vals(2)=2
 	call cg_array_write_f('arraysize', CGNS_ENUMV(Integer), 2, dim_vals, &
              size, ier)
 	if (ier .ne. ERROR) write(6,'(a)') 'Error in API'

! * DataClass & DimensionalUnits under SurfaceArea
	call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1, &
            'BC_t', boco, 'BCProperty_t', 1, 'Area_t', 1, 'DataArray_t', &
      	    1, 'end')

	call cg_dataclass_write_f(CGNS_ENUMV(Dimensional), ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	call cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), CGNS_ENUMV(Kelvin), &
      	    		      CGNS_ENUMV(Radian), ier)
	if (ier .eq. ERROR) call cg_error_exit_f

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

! *** close CGNS file
	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

        END PROGRAM write_bprop

      program write_nondimensional
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Opens an existing CGNS file and adds the DataClass and
!   ReferenceState appropriate for a completely
!   NONDIMENSIONAL data set.
!
!   The CGNS grid file 'grid.cgns' must already exist
!   (for example, created using write_grid_str.f or
!   write_grid_unst.f).  In this case, the flow solution does
!   not need to be present.
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c write_nondimensional.F90
!   ifort -o write_nondimensional write_nondimensional.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
      real*8 xmach,reue,xmv,xmc,rev,rel,renu,rho0,gamma,p0,c0,vm0
      real*8 xlength0,vx,vy,vz
      integer index_file,ier,index_base,idata
      integer(cgsize_t) nuse
!
      write(6,'('' Program write_nondimensional'')')
      if (CG_BUILD_64BIT) then
        write(6,'('' ...using 64-bit mode for particular integers'')')
      end if
!   define nondimensional parameters
      xmach=4.6d0
      reue=6000000.d0
      xmv=xmach
      xmc=1.d0
      rev=xmach
      rel=1.d0
      renu=xmach/reue
      rho0=1.d0
      gamma=1.4d0
      p0=1.d0/gamma
      c0=1.d0
      vm0=xmach/reue
      xlength0=1.d0
      vx=xmach
      vy=0.d0
      vz=0.d0
      nuse=1
!   WRITE NONDIMENSIONAL INFO
!   open CGNS file for modify
      call cg_open_f('grid.cgns',CG_MODE_MODIFY,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!   we know there is only one base (real working code would check!)
      index_base=1
!   put DataClass under Base
      call cg_goto_f(index_file,index_base,ier,'end')
!   check first if a dataclass has already been written
      call cg_dataclass_read_f(idata,ier)
      if (ier .eq. 0) then
        write(6,'('' Error! DataClass already exists!'')')
        write(6,'(''   Re-make CGNS file without it and related info,'',       &
          '' then try again'')')
        stop
      else
        ier=0
      end if
      call cg_dataclass_write_f(CGNS_ENUMV(NormalizedByUnknownDimensional),ier)
!   put ReferenceState under Base
      call cg_state_write_f('ReferenceQuantities',ier)
!   Go to ReferenceState node, write Mach array and its dataclass
      call cg_goto_f(index_file,index_base,ier,'ReferenceState_t',1,'end')
      call cg_array_write_f('Mach',CGNS_ENUMV(RealDouble),1,[nuse],xmach,ier)
      call cg_goto_f(index_file,index_base,ier,'ReferenceState_t',1,           &
           'DataArray_t',1,'end')
      call cg_dataclass_write_f(CGNS_ENUMV(NondimensionalParameter),ier)
!   Go to ReferenceState node, write Reynolds array and its dataclass
      call cg_goto_f(index_file,index_base,ier,'ReferenceState_t',1,'end')
      call cg_array_write_f('Reynolds',CGNS_ENUMV(RealDouble),1,[nuse],reue,ier)
      call cg_goto_f(index_file,index_base,ier,'ReferenceState_t',1,           &
           'DataArray_t',2,'end')
      call cg_dataclass_write_f(CGNS_ENUMV(NondimensionalParameter),ier)
!   Go to ReferenceState node to write reference quantities:
      call cg_goto_f(index_file,index_base,ier,'ReferenceState_t',1,'end')
!   First, write reference quantities that make up Mach and Reynolds:
!   Mach_Velocity
      call cg_array_write_f('Mach_Velocity',CGNS_ENUMV(RealDouble),1,[nuse],xmv,ier)
!   Mach_VelocitySound
      call cg_array_write_f('Mach_VelocitySound',CGNS_ENUMV(RealDouble),1,[nuse],xmc,ier)
!   Reynolds_Velocity
      call cg_array_write_f('Reynolds_Velocity',CGNS_ENUMV(RealDouble),1,[nuse],rev,ier)
!   Reynolds_Length
      call cg_array_write_f('Reynolds_Length',CGNS_ENUMV(RealDouble),1,[nuse],rel,ier)
!   Reynolds_ViscosityKinematic
      call cg_array_write_f('Reynolds_ViscosityKinematic',CGNS_ENUMV(RealDouble),          &
           1,[nuse],renu,ier)
!
!   Next, write flow field reference quantities:
!   Density
      call cg_array_write_f('Density',CGNS_ENUMV(RealDouble),1,[nuse],rho0,ier)
!   Pressure
      call cg_array_write_f('Pressure',CGNS_ENUMV(RealDouble),1,[nuse],p0,ier)
!   VelocitySound
      call cg_array_write_f('VelocitySound',CGNS_ENUMV(RealDouble),1,[nuse],c0,ier)
!   ViscosityMolecular
      call cg_array_write_f('ViscosityMolecular',CGNS_ENUMV(RealDouble),1,[nuse],vm0,ier)
!   LengthReference
      call cg_array_write_f('LengthReference',CGNS_ENUMV(RealDouble),1,[nuse],xlength0,ier)
!   VelocityX
      call cg_array_write_f('VelocityX',CGNS_ENUMV(RealDouble),1,[nuse],vx,ier)
!   VelocityY
      call cg_array_write_f('VelocityY',CGNS_ENUMV(RealDouble),1,[nuse],vy,ier)
!   VelocityZ
      call cg_array_write_f('VelocityZ',CGNS_ENUMV(RealDouble),1,[nuse],vz,ier)
!   close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully wrote nondimensional info to file'',           &
       '' grid.cgns'')')
      stop
      end

        program read_partial_data
        USE CGNS

!	original author (of write_mixed_elements): Diane Poirier
!       author: Ken Wall
!	May 13 2004

! 	This example reads an unstructured zone mixed element section

#ifdef WINNT
	include 'cgnswin_f.h'
#endif

        parameter (NNODES=27, NELEMENTS=3)

	integer Cdim, Pdim, Idim, ier
	integer cg, base, zone, ZoneType
        integer(cgsize_t) size(3)
	integer nbases, nzones, ncoords, nsections
	integer i, n, sect
        integer(cgsize_t) range_min(3), range_max(3)
	integer nbndry, type, count
        integer(cgsize_t) elements(1000)
        integer(cgsize_t) ElementDataSize
	character*32 coordname(3), filename, nodename
        double precision data_double(NNODES)
        integer(cgsize_t) el_st, el_end
        integer(cgsize_t) parent(1000)
        integer parent_flag

!       initialize
        ier = 0

!       write(6,100) 'Input filename'
!       read(5,100) filename
!       open CGNS file for reading
        write(filename,100)'Test_V2'

 	call cg_open_f(filename, MODE_READ, cg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
	write(6,100)'File Opened and Read '

!*******read CGNSBase
	call cg_nbases_f(cg, nbases, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	if (nbases .gt. 1) then
	    write(6,100)'This program reads only the first base'
	else if (nbases .le. 0) then
	    write(6,100)'No base found'
	    goto 9999
	endif
	base = 1
	call cg_base_read_f(cg, base, nodename, Cdim, Pdim, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(6,100)'*** CGNSBase_t node ***'
        write(6,103)'Name= ',nodename
        write(6,104)'CellDimension=',Cdim
        write(6,105)'PhysDimension=',Pdim

! ******read CGNSBase substructure: Zone
	call cg_nzones_f(cg, base, nzones, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	if (nzones .gt. 1) then
	    write(6,100)'This program reads only the first zone'
	else if (nzones .le. 0) then
	    write(6,100)'No zone found'
	    goto 9999
	endif
	zone = 1

        call cg_zone_read_f(cg,base,zone, nodename,size,ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_zone_type_f(cg, base, zone, ZoneType, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	Idim=Cdim
	if (ZoneType .eq. Unstructured) Idim=1

        write(6,100)'*** Zone_t node ***'
        write(6,103)'Name= ',nodename
        write(6,103)'ZoneType= ',ZoneTypeName(ZoneType)
        write(6,106)'Size= ', (size(i),i=1,Idim*3)

! COORDINATES
	call cg_ncoords_f(cg, base, zone, ncoords, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,104)'ncoords=',ncoords

	write(6,104)'Idim=',Idim
	do i=1, Idim
	    range_min(i)= 5
	    range_max(i)=size(i)
        enddo
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	write(6,107) 'range:',(range_min(i),i=1,Idim),
     &                                 (range_max(i),i=1,Idim)
! Name convention
        coordname(1) = 'CoordinateX'
        coordname(2) = 'CoordinateY'
        coordname(3) = 'CoordinateZ'
	do i=1, Pdim
	    call cg_coord_read_f(cg, base, zone, coordname(i),
     &            RealDouble, range_min, range_max, data_double, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
	    write(6,103)coordname(i)
	    write(6,109)'first point:',data_double(1)
	    write(6,109)'last point :',data_double(size(1)-range_min(1)+1)
	enddo

! ELEMENTS
	write(6,102)'*** Elements_t Nodes ***'
	call cg_nsections_f(cg, base, zone, nsections, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	do sect=1, nsections

! Read all element info:
	    call cg_section_read_f(cg, base, zone, sect,
     &              nodename, type, el_st, el_end, nbndry,
     &              parent_flag, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

	    call cg_ElementDataSize_f(cg, base, zone, sect,
     &                                ElementDataSize, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

! Print out element info:
	    write(6,113)'  *** Section ',sect,' ***'
	    write(6,103)'Name= ',nodename
            write(6,108)'Connectivity data range = ', el_st, el_end
            if (nbndry .ne. 0) write(6,103)'Sorted elements'

	    write(6,107) 'ElementDataSize =',ElementDataSize
            write(6,103) 'Section Element Type= ',
     &                         ElementTypeName(type)

            el_st = el_st + 1
            call cg_elements_partial_read_f(cg, base, zone, sect,
     &                 el_st, el_end, elements, parent, ier);
	    if (ier .eq. ERROR) call cg_error_exit_f

            write(6,108)'Connect and Parent data for element range  = ',
     &                 el_st, el_end

            call cg_npe_f(type, npe, ier)
            if (ier .eq. ERROR) call cg_error_exit_f

	    nelem = el_end - el_st +1
	    write(6,103)'Element Connectivity:'
	    if (type .lt. MIXED) then
	        do i=1, nelem
	            write(6,110)(elements((i-1)*npe+n),n=1,npe)
	    	enddo
	    elseif (type .eq. MIXED) then
		count = 0
	        do i=1, nelem
		    count = count + 1
		    type = elements(count)
		    if (type .gt. NGON_n) then
			npe = type - NGON_n
			write(6,111)
     &                    'Element Type= NGON_n, npe =',npe
		    else
			call cg_npe_f(type, npe, ier)
			write(6,112)'Element Type= ',
     &                             ElementTypeName(type)
		    endif
		    write(6,110)(elements(count+n),n=1,npe)
		    count = count+npe
		enddo
	    else
		count = 0
	        do i=1, nelem
		    count = count + 1
		    npe = elements(count)
		    write(6,111)
     &                    'Element Number Points = ',npe
		    write(6,110)(elements(count+n),n=1,npe)
		    count = count+npe
		enddo
	    endif

            write(6,103)'Parent Data:'
            do i=1, nelem
	        write(6,110)(parent((i-1)*4+n),n=1,4)
    	    enddo
	enddo

! Write & close CGNS file

	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f()
	write(6,102)'CGNS File written & closed'

 100	format(a)
 101	format(/a/)
 102	format(/a)
 103	format(6x,2a)
 104 	format(6x,a,i2)
 105	format(6x,a,i2/)
 106	format(6x,a,3i2)
 107	format(6x,a,6i3)
 108	format(6x,a,2i5)
 109	format(8x,a,f8.3)
 110	format(8x,8i3)
 111	format(8x,a,i3)
 112	format(8x,2a)
 113	format(/a,i2,a)
 9999   end

      program write_grid_unst
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Creates simple 3-D unstructured grid and writes it to a
!   CGNS file.
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c write_grid_unst.F90
!   ifort -o write_grid_unst write_grid_unst.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
      integer, parameter :: maxelemi=20*16*8
      integer, parameter :: maxelemj=1216
      real*8 x(21*17*9),y(21*17*9),z(21*17*9)
      integer i,j,k,ifirstnode,nbdyelem,ni,nj,nk
      integer index_file,index_section,ielem_no
      integer index_base,index_zone,index_coord
      integer ier,iset,iphysdim,icelldim
      integer(cgsize_t) isize(1,3),ielem(8,maxelemi),jelem(4,maxelemj)
      integer(cgsize_t) nelem_start,nelem_end
      character basename*32,zonename*32
!
      write(6,'('' Program write_grid_unst'')')
      if (CG_BUILD_64BIT) then
        write(6,'('' ...using 64-bit mode for particular integers'')')
      end if
!
!   create gridpoints for simple example:
      ni=21
      nj=17
      nk=9
      iset=0
      do k=1,nk
        do j=1,nj
          do i=1,ni
            iset=iset+1
            x(iset)=float(i-1)
            y(iset)=float(j-1)
            z(iset)=float(k-1)
          enddo
        enddo
      enddo
      write(6,'('' created simple 3-D grid points'')')
!
!   WRITE X, Y, Z GRID POINTS TO CGNS FILE
!   open CGNS file for write
      call cg_open_f('grid.cgns',CG_MODE_WRITE,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!   create base (user can give any name)
      basename='Base'
      icelldim=3
      iphysdim=3
      call cg_base_write_f(index_file,basename,icelldim,iphysdim,index_base,ier)
!   define zone name (user can give any name)
      zonename = 'Zone  1'
!   vertex size
      isize(1,1)=ni*nj*nk
!   cell size
      isize(1,2)=(ni-1)*(nj-1)*(nk-1)
!   boundary vertex size (zero if elements not sorted)
      isize(1,3)=0
!   create zone
      call cg_zone_write_f(index_file,index_base,zonename,isize,               &
           CGNS_ENUMV(Unstructured),index_zone,ier)
!   write grid coordinates (user must use SIDS-standard names here)
      call cg_coord_write_f(index_file,index_base,index_zone,CGNS_ENUMV(RealDouble),       &
           'CoordinateX',x,index_coord,ier)
      call cg_coord_write_f(index_file,index_base,index_zone,CGNS_ENUMV(RealDouble),       &
           'CoordinateY',y,index_coord,ier)
      call cg_coord_write_f(index_file,index_base,index_zone,CGNS_ENUMV(RealDouble),       &
           'CoordinateZ',z,index_coord,ier)
!  set element connectivity:
!  ----------------------------------------------------------
!  do all the HEXA_8 elements (this part is mandatory):
!  maintain SIDS-standard ordering
      ielem_no=0
!  index no of first element
      nelem_start=1
      do k=1,nk-1
        do j=1,nj-1
          do i=1,ni-1
            ielem_no=ielem_no+1
!  in this example, due to the order in the node numbering, the
!  hexahedral elements can be reconstructed using the following
!  relationships:
            ifirstnode=i+(j-1)*ni+(k-1)*ni*nj
            ielem(1,ielem_no)=ifirstnode
            ielem(2,ielem_no)=ifirstnode+1
            ielem(3,ielem_no)=ifirstnode+1+ni
            ielem(4,ielem_no)=ifirstnode+ni
            ielem(5,ielem_no)=ifirstnode+ni*nj
            ielem(6,ielem_no)=ifirstnode+ni*nj+1
            ielem(7,ielem_no)=ifirstnode+ni*nj+1+ni
            ielem(8,ielem_no)=ifirstnode+ni*nj+ni
          enddo
        enddo
      enddo
!  index no of last element (=2560)
      nelem_end=ielem_no
      if (nelem_end .gt. maxelemi) then
        write(6,'('' Error, must increase maxelemi to at least '',             &
         i7)') nelem_end
        stop
      end if
!  unsorted boundary elements
      nbdyelem=0
!  write HEXA_8 element connectivity (user can give any name)
      call cg_section_write_f(index_file,index_base,index_zone,                &
           'Elem',CGNS_ENUMV(HEXA_8),nelem_start,nelem_end,nbdyelem,ielem,                 &
           index_section,ier)
!  ----------------------------------------------------------
!  do boundary (QUAD) elements (this part is optional,
!  but you must do it if you eventually want to define BCs
!  at element faces rather than at nodes):
!  maintain SIDS-standard ordering
!  INFLOW:
      ielem_no=0
!  index no of first element
      nelem_start=nelem_end+1
      i=1
      do k=1,nk-1
        do j=1,nj-1
          ielem_no=ielem_no+1
          ifirstnode=i+(j-1)*ni+(k-1)*ni*nj
          jelem(1,ielem_no)=ifirstnode
          jelem(2,ielem_no)=ifirstnode+ni*nj
          jelem(3,ielem_no)=ifirstnode+ni*nj+ni
          jelem(4,ielem_no)=ifirstnode+ni
        enddo
      enddo
!  index no of last element
      nelem_end=nelem_start+ielem_no-1
      if (ielem_no .gt. maxelemj) then
        write(6,'('' Error, must increase maxelemj to at least '',             &
         i7)') ielem_no
        stop
      end if
!  write QUAD element connectivity for inflow face (user can give any name)
      call cg_section_write_f(index_file,index_base,index_zone,                &
           'InflowElem',CGNS_ENUMV(QUAD_4),nelem_start,nelem_end,nbdyelem,                 &
           jelem,index_section,ier)
!  OUTFLOW:
      ielem_no=0
!  index no of first element
      nelem_start=nelem_end+1
      i=ni-1
      do k=1,nk-1
        do j=1,nj-1
          ielem_no=ielem_no+1
          ifirstnode=i+(j-1)*ni+(k-1)*ni*nj
          jelem(1,ielem_no)=ifirstnode+1
          jelem(2,ielem_no)=ifirstnode+1+ni
          jelem(3,ielem_no)=ifirstnode+ni*nj+1+ni
          jelem(4,ielem_no)=ifirstnode+ni*nj+1
        enddo
      enddo
!  index no of last element
      nelem_end=nelem_start+ielem_no-1
      if (ielem_no .gt. maxelemj) then
        write(6,'('' Error, must increase maxelemj to at least '',             &
         i7)') ielem_no
        stop
      end if
!  write QUAD element connectivity for outflow face (user can give any name)
      call cg_section_write_f(index_file,index_base,index_zone,                &
           'OutflowElem',CGNS_ENUMV(QUAD_4),nelem_start,nelem_end,nbdyelem,                &
           jelem,index_section,ier)
!  SIDEWALLS:
      ielem_no=0
!  index no of first element
      nelem_start=nelem_end+1
      j=1
      do k=1,nk-1
        do i=1,ni-1
          ielem_no=ielem_no+1
          ifirstnode=i+(j-1)*ni+(k-1)*ni*nj
          jelem(1,ielem_no)=ifirstnode
          jelem(2,ielem_no)=ifirstnode+ni*nj
          jelem(3,ielem_no)=ifirstnode+ni*nj+1
          jelem(4,ielem_no)=ifirstnode+1
        enddo
      enddo
      j=nj-1
      do k=1,nk-1
        do i=1,ni-1
          ielem_no=ielem_no+1
          ifirstnode=i+(j-1)*ni+(k-1)*ni*nj
          jelem(1,ielem_no)=ifirstnode+1+ni
          jelem(2,ielem_no)=ifirstnode+ni
          jelem(3,ielem_no)=ifirstnode+ni*nj+ni
          jelem(4,ielem_no)=ifirstnode+ni*nj+1+ni
        enddo
      enddo
      k=1
      do j=1,nj-1
        do i=1,ni-1
          ielem_no=ielem_no+1
          ifirstnode=i+(j-1)*ni+(k-1)*ni*nj
          jelem(1,ielem_no)=ifirstnode
          jelem(2,ielem_no)=ifirstnode+1
          jelem(3,ielem_no)=ifirstnode+1+ni
          jelem(4,ielem_no)=ifirstnode+ni
        enddo
      enddo
      k=nk-1
      do j=1,nj-1
        do i=1,ni-1
          ielem_no=ielem_no+1
          ifirstnode=i+(j-1)*ni+(k-1)*ni*nj
          jelem(1,ielem_no)=ifirstnode+ni*nj
          jelem(2,ielem_no)=ifirstnode+ni*nj+ni
          jelem(3,ielem_no)=ifirstnode+ni*nj+1+ni
          jelem(4,ielem_no)=ifirstnode+ni*nj+1
        enddo
      enddo
!  index no of last element
      nelem_end=nelem_start+ielem_no-1
      if (ielem_no .gt. maxelemj) then
        write(6,'('' Error, must increase maxelemj to at least '',             &
         i7)') ielem_no
        stop
      end if
!  write QUAD element connectivity for sidewall face (user can give any name)
      call cg_section_write_f(index_file,index_base,index_zone,                &
           'SidewallElem',CGNS_ENUMV(QUAD_4),nelem_start,nelem_end,nbdyelem,               &
           jelem,index_section,ier)
!  ----------------------------------------------------------
!   close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully wrote unstructured grid to file'',             &
        '' grid.cgns'')')
      stop
      end

      program write_con2zn_genrl_str
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Opens an existing CGNS file that contains a simple 3-D
!   structured grid (2 zones), and adds 1-to-1
!   connectivity information to it (using GENERAL
!   method, as opposed to specific 1-to-1 method).
!
!   The CGNS grid file 'grid.cgns' must already exist
!   (created using write_grid2zn_str.f)
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c write_con2zn_genrl_str.F90
!   ifort -o write_con2zn_genrl_str write_con2zn_genrl_str.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
      integer, parameter :: maxcount=400
      integer ilo(2),ihi(2),jlo(2),jhi(2),klo(2),khi(2)
      integer(cgsize_t) isize(3,3),ipnts(3,maxcount)
      integer(cgsize_t) ipntsdonor(3,maxcount),icounts
      integer index_conn,index_zone,index_base,index_file,ier
      integer nconns,n1to1,icount,nzone,j,k
      character donorname*32,zonename(2)*32
!
      write(6,'('' Program write_con2zn_genrl_str'')')
      if (CG_BUILD_64BIT) then
        write(6,'('' ...using 64-bit mode for particular integers'')')
      end if
!
!  WRITE GENERAL CONNECTIVITY INFORMATION TO EXISTING CGNS FILE
!  open CGNS file for modify
      call cg_open_f('grid.cgns',CG_MODE_MODIFY,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!  we know there is only one base (real working code would check!)
      index_base=1
!   get number of zones (should be 2 for our case)
      call cg_nzones_f(index_file,index_base,nzone,ier)
      if (nzone .ne. 2) then
         write(6,'('' Error.  This program expects 2 zones. '',i5,             &
          '' read'')') nzone
         stop
      end if
!   loop over zones to get zone sizes and names
      do index_zone=1,nzone
        call cg_zone_read_f(index_file,index_base,index_zone,                  &
             zonename(index_zone),isize,ier)
        ilo(index_zone)=1
        ihi(index_zone)=isize(1,1)
        jlo(index_zone)=1
        jhi(index_zone)=isize(2,1)
        klo(index_zone)=1
        khi(index_zone)=isize(3,1)
      enddo
!   loop over zones again
      do index_zone=1,nzone
!   for this program, there should be no existing connectivity info:
        call cg_nconns_f(index_file,index_base,index_zone,nconns,ier)
        if (nconns .ne. 0) then
          write(6,'('' Error.  This program expects no interfaces'',           &
            '' yet.'',i5,'' read'')') nconns
          stop
        end if
        call cg_n1to1_f(index_file,index_base,index_zone,n1to1,ier)
        if (n1to1 .ne. 0) then
          write(6,'('' Error.  This program expects no interfaces'',           &
            '' yet.'',i5,'' read'')') n1to1
          stop
        end if
!   set up point lists
        if (index_zone .eq. 1) then
          icount=0
          do j=jlo(index_zone),jhi(index_zone)
            do k=klo(index_zone),khi(index_zone)
              icount=icount+1
              ipnts(1,icount)=ihi(1)
              ipnts(2,icount)=j
              ipnts(3,icount)=k
              ipntsdonor(1,icount)=ilo(2)
              ipntsdonor(2,icount)=j
              ipntsdonor(3,icount)=k
            enddo
          enddo
          if (icount .gt. maxcount) then
            write(6,'('' Error.  Need to increase maxcount to at least'',      &
              i5)') icount
            stop
          end if
          donorname=zonename(2)
        else
          icount=0
          do j=jlo(index_zone),jhi(index_zone)
            do k=klo(index_zone),khi(index_zone)
              icount=icount+1
              ipnts(1,icount)=ilo(2)
              ipnts(2,icount)=j
              ipnts(3,icount)=k
              ipntsdonor(1,icount)=ihi(1)
              ipntsdonor(2,icount)=j
              ipntsdonor(3,icount)=k
            enddo
          enddo
          if (icount .gt. maxcount) then
            write(6,'('' Error.  Need to increase maxcount to at least'',      &
              i5)') icount
            stop
          end if
          donorname=zonename(1)
        end if
!   write integer connectivity info (user can give any name)
        icounts=icount
        call cg_conn_write_f(index_file,index_base,index_zone,                 &
             'GenInterface',CGNS_ENUMV(Vertex),CGNS_ENUMV(Abutting1to1),CGNS_ENUMV(PointList),icounts,ipnts,       &
             donorname,CGNS_ENUMV(Structured),CGNS_ENUMV(PointListDonor),CGNS_ENUMV(Integer),icounts,              &
             ipntsdonor,index_conn,ier)
      enddo
!  close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully added 1-to-1 connectivity info to'',           &
       '' file grid.cgns (using GENERAL method)'')')
      stop
      end

	program read_chemistry
	USE CGNS
	implicit none

! Demonstrate Version 2.1 chemistry extensions.
! D. Leich, Intelligent Light 11-Jan-02
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim, Nglobal
	parameter (Ndim = 3)
	parameter (Nglobal = 500)
	integer CellDim, PhysDim
	integer ier, n
	integer nbases
	integer type
        integer datatype
	character*32 basename
	integer cg, base
	character*32 name, filename
	character*40 text
	integer equation_dimension, GoverningEquationsFlag
	integer GasModelFlag, ViscosityModelFlag
	integer ThermalConductivityModelFlag
	integer TurbulenceClosureFlag, TurbulenceModelFlag
	integer ThermalRelaxationFlag, ChemicalKineticsFlag
	integer ElecFieldModelFlag, MagnFieldModelFlag
	integer ConductivityModelFlag
	integer diffusion_model(6)
	integer nndim
	integer(cgsize_t) dim_vals(12)
	integer mass, length, time, temp, deg, iarray, i,narrays
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	real*4 data_single(100000)
	double precision data_double(100000)
	real*4 version
        real*4 exponents(8)

! *** open file
!	write(6,*) 'Input filename'
!	read(5,600) filename
	write(filename,'(a)')'Test_V2'
	call cg_open_f(filename, MODE_READ, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,600)'READING FILE ',filename

! *** CGNS Library Version used for file creation (version must be real*4):
	call cg_version_f(cg, version, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,102) &
          'Library Version used for file creation:',version

! *** base
	call cg_nbases_f(cg, nbases, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,200)'nbases=',nbases

	do base=1, nbases
	  call cg_base_read_f(cg, base, basename, CellDim, PhysDim, ier)
	  if (ier .eq. ERROR) call cg_error_exit_f
	  write(6,300)'BaseName = "',basename,'"', &
                      'cell_dimension=',CellDim

! *** base attribute:  GOTO base node
	  call cg_goto_f(cg, base, ier, 'end')
          if (ier .eq. ERROR) call cg_error_exit_f

! ***     base attribute:  Descriptor
          call cg_descriptor_read_f(1, name, text, ier)
          if (ier .eq. ERROR) call cg_error_exit_f
          if (ier.eq.ALL_OK) then
            write(6,400)'Base Descriptor_t Information:'
            write(6,500)' DescriptorName="',name,'"', &
                        ' DescriptorText="',text,'"'
          endif

! ***     base attribute: flow equation set:
	  call cg_equationset_read_f(equation_dimension, &
            GoverningEquationsFlag,  GasModelFlag, &
            ViscosityModelFlag, ThermalConductivityModelFlag, &
            TurbulenceClosureFlag,  TurbulenceModelFlag, ier)
	  if (ier .eq. ERROR) then
	    call cg_error_exit_f
	  elseif (ier .eq. NODE_NOT_FOUND) then
	    write(6,200) &
            'FlowEquationSet_t not defined under CGNSBase_t #',base
	  elseif (ier .eq. INCORRECT_PATH) then
  	    write(6,400)'Incorrect path input to cg_goto_f'
	  else
	    write(6,400) 'FlowEquationSet_t Information:'
	    write(6,200)' equation_dimension=',equation_dimension

! *** chemistry attributes: flow equation set:
	    call cg_equationset_chemistry_read_f(ThermalRelaxationFlag, &
              ChemicalKineticsFlag, ier)
	    if (ier .eq. ERROR) then
	      call cg_error_exit_f
	    elseif (ier .eq. NODE_NOT_FOUND) then
	      write(6,200) &
              'FlowEquationSet_t not defined under CGNSBase_t #',base
	    elseif (ier .eq. INCORRECT_PATH) then
  	      write(6,400)'Incorrect path input to cg_goto_f'
	    endif

! begin KMW Electromagnetics extension
	    call cg_equationset_elecmagn_read_f(ElecFieldModelFlag, &
              MagnFieldModelFlag, ConductivityModelFlag, ier)
	    if (ier .eq. ERROR) then
	      call cg_error_exit_f
	    elseif (ier .eq. NODE_NOT_FOUND) then
	      write(6,200) &
              'FlowEquationSet_t not defined under CGNSBase_t #',base
	    elseif (ier .eq. INCORRECT_PATH) then
  	      write(6,400)'Incorrect path input to cg_goto_f'
	    endif
! end KMW Electromagnetics extension

! ***       flow equation set attributes:  GOTO FlowEquationSet_t node
            call cg_goto_f(cg, base, ier, 'FlowEquationSet_t', 1, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f

! ***       flow equation set attribute: Descriptor
            call cg_descriptor_read_f(1, name,text,ier)
            if (ier .eq. ERROR) call cg_error_exit_f
            if (ier .eq. ALL_OK) write(6,500) &
              ' DescriptorName="',name,'"',' DescriptorText="',text,'"'

! ***       flow equation set attribute: Gas Model Type
	    if (GasModelFlag.eq.1) then
                call cg_model_read_f('GasModel_t', type, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                if (ier .eq. ALL_OK) write(6,600) &
                  ' GasModelType="',ModelTypeName(type),'"'
            endif

! ***       flow equation set attribute: ViscosityModel Type
            if (ViscosityModelFlag.eq.1) then
              call cg_model_read_f('ViscosityModel_t', type, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              if (ier .eq. ALL_OK) write(6,600) &
                ' ViscosityModelType="',ModelTypeName(type),'"'
            endif

! ***       flow equation set attribute:  TypmlConductivityModel Type
            if (ThermalConductivityModelFlag.eq.1) then
              call cg_model_read_f('ThermalConductivityModel_t', &
                        type, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              if (ier .eq. ALL_OK) write(6,600) &
                ' ThermalConductivityModelType=', &
                  ModelTypeName(type),'"'
            endif

! ***   flow equation set attribute: TurbulenceClosureType
            if (TurbulenceClosureFlag.eq.1) then
              call cg_model_read_f('TurbulenceClosure_t', type, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              if (ier .eq. ALL_OK) write(6,600) &
                ' TurbulenceClosureType="', ModelTypeName(type),'"'
            endif

! ***   flow equation set attribute: TurbulenceModelType
            if (TurbulenceModelFlag.eq.1) then
              call cg_model_read_f('TurbulenceModel_t', type, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              if (ier .eq. ALL_OK) write(6,600) &
                ' TurbulenceModelType="',ModelTypeName(type),'"'
            endif

! ***   flow equation set attribute: Governing Equations Type
            if (GoverningEquationsFlag .eq. 1) then
              call cg_governing_read_f(type, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              if (ier.eq.ALL_OK) &
                write(6,600)' GoverningEquationsType="', &
                                GoverningEquationsTypeName(type),'"'

    	! ! *** Governing Equations attribute:  GOTO GoverningEquations_t node
	      call cg_goto_f(cg,base,ier, 'FlowEquationSet_t', 1, &
                  'GoverningEquations_t',1,'end')
	      if (ier .eq. ERROR) call cg_error_exit_f

        ! ! *** Governing Equations attribute:  Diffusion model
	      call cg_diffusion_read_f(diffusion_model, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      if (ier.eq.ALL_OK)write(6,103)'   Diffusion model=', &
                                 (diffusion_model(i), i=1,6)

! ***         flow equation set attributes:  GOTO FlowEquationSet_t node
              call cg_goto_f(cg, base, ier, 'FlowEquationSet_t', 1,  &
      	        'end')
              if (ier .eq. ERROR) call cg_error_exit_f

            endif       ! If Governing Equations are defined
	  endif         ! If FlowEquationSet_t exists under CGNSBase_t

! ***   flow equation set attribute: ThermalRelaxationModel
            if (ThermalRelaxationFlag.eq.1) then
              call cg_model_read_f('ThermalRelaxationModel_t',  &
      	        type, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              if (ier .eq. ALL_OK) write(6,600) &
                ' ThermalRelaxationModel="',ModelTypeName(type),'"'
            endif

! ***   flow equation set attribute: ChemicalKineticsModel
            if (ChemicalKineticsFlag.eq.1) then
              call cg_model_read_f('ChemicalKineticsModel_t',  &
      	        type, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              if (ier .eq. ALL_OK) write(6,600) &
                ' ChemicalKineticsModel="',ModelTypeName(type),'"'

    	! *** GOTO ChemicalKineticsModel_t node
	      call cg_goto_f(cg,base,ier, 'FlowEquationSet_t', 1, &
                  'ChemicalKineticsModel_t',1,'end')
	      if (ier .eq. ERROR) call cg_error_exit_f

           ! ** ChemicalKineticsModel_t attributes: Descriptor
              call cg_descriptor_read_f(1, name, text, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              if (ier.eq.ALL_OK) then
                write(6,400)'Descriptor_t Information:'
                write(6,500)' DescriptorName="',name,'"', &
                            ' DescriptorText="',text,'"'
              endif

              write(6,400)'                             *     *     *'

         ! ** ChemicalKineticsModel_t attributes: DataArray_t
	      call cg_narrays_f(narrays, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      write(6,105) 'ChemicalKineticsModel_t contains ', &
                            narrays,' array(s)'
	      do iarray=1, narrays

                call cg_array_info_f(iarray, name, datatype, &
                                   nndim, dim_vals, ier)
                if (ier .eq. ERROR) call cg_error_exit_f

	        write(6,600) ' DataArrayName="',name,'"'
	        write(6,600) ' DataType="',DataTypeName(datatype),'"'
	        write(6,200) ' DataNdim=',nndim
	        write(6,200) ' DataDim=',dim_vals(1)

	        write(6,105) ' Data:'
	        if (datatype .eq. CGNS_ENUMV(RealSingle)) then
	          call cg_array_read_f(iarray, data_single, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
	          write(6,106) (data_single(n),n=1,dim_vals(1))
	        elseif (datatype .eq. CGNS_ENUMV(RealDouble)) then
		  call cg_array_read_f(iarray, data_double, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
	 	  write(6,106) (data_double(n),n=1,dim_vals(1))
	        endif

    	  ! *** GOTO DataArray_t node
	        call cg_goto_f(cg,base,ier, 'FlowEquationSet_t', 1, &
                    'ChemicalKineticsModel_t',1, &
                    'DataArray_t',iarray,'end')
	        if (ier .eq. ERROR) call cg_error_exit_f

           ! ** DataArray_t attributes: DataClass_t
	        call cg_dataclass_read_f(type,ier)
	        if (ier .eq. ERROR) call cg_error_exit_f
	        write(6,600)'DataClassName=',DataClassName(type)

           ! ** DataArray_t attributes: DimensionalUnits_t
	        call cg_units_read_f(mass, length, time, temp, deg, ier)
	        if (ier .eq. ERROR) call cg_error_exit_f
	        if (ier .eq. ALL_OK) then
	          write(6,100) &
      	 	    'Dimensional Units:', &
                    MassUnitsName(mass), LengthUnitsName(length), &
                    TimeUnitsName(time), TemperatureUnitsName(temp),  &
                    AngleUnitsName(deg)
	        endif

           ! ** DataArray_t attributes: DimensionalExponents_t
                call cg_exponents_read_f(exponents, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                if (ier .eq. ALL_OK) then
                  write(6,99) &
                    'Dimensional Exponents:', &
                    exponents(1), exponents(2), exponents(3), &
                    exponents(4), exponents(5)
                endif

           ! ** DataArray_t attributes: Descriptor
                call cg_descriptor_read_f(1, name, text, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                if (ier.eq.ALL_OK) then
                  write(6,400)'Descriptor_t Information:'
                  write(6,500)' DescriptorName="',name,'"', &
                              ' DescriptorText="',text,'"'
                endif

    	  ! *** GOTO ChemicalKineticsModel_t node
	        call cg_goto_f(cg,base,ier, 'FlowEquationSet_t', 1, &
                    'ChemicalKineticsModel_t',1,'end')
	        if (ier .eq. ERROR) call cg_error_exit_f

              write(6,400)'                             *     *     *'
	      enddo
            endif

! begin KMW Electromagnetics extension
! ***   flow equationset attribute: EMElectricFieldModel
            if (ElecFieldModelFlag.eq.1) then
	      call cg_goto_f(cg,base,ier, 'FlowEquationSet_t', 1,'end')
	        if (ier .eq. ERROR) call cg_error_exit_f

              call cg_model_read_f('EMElectricFieldModel_t',  &
      	        type, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              if (ier .eq. ALL_OK) write(6,600) &
                ' EMElectricFieldModel="',ModelTypeName(type),'"'

    	! *** GOTO EMElectricFieldModel_t node
	      call cg_goto_f(cg,base,ier, 'FlowEquationSet_t', 1, &
                  'EMElectricFieldModel_t',1,'end')
	      if (ier .eq. ERROR) call cg_error_exit_f

           ! ** EMElectricFieldModel_t attributes: Descriptor
              call cg_descriptor_read_f(1, name, text, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              if (ier.eq.ALL_OK) then
                write(6,400)'Descriptor_t Information:'
                write(6,500)' DescriptorName="',name,'"', &
                            ' DescriptorText="',text,'"'
              endif

              write(6,400)'                             *     *     *'

         ! ** EMElectricFieldModel_t attributes: DataArray_t
	      call cg_narrays_f(narrays, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      write(6,105) 'EMElectricFieldModel_t contains ', &
                            narrays,' array(s)'
	      do iarray=1, narrays

                call cg_array_info_f(iarray, name, datatype, &
                                   nndim, dim_vals, ier)
                if (ier .eq. ERROR) call cg_error_exit_f

	        write(6,600) ' DataArrayName="',name,'"'
	        write(6,600) ' DataType="',DataTypeName(datatype),'"'
	        write(6,200) ' DataNdim=',nndim
	        write(6,200) ' DataDim=',dim_vals(1)

	        write(6,105) ' Data:'
	        if (datatype .eq. CGNS_ENUMV(RealSingle)) then
	          call cg_array_read_f(iarray, data_single, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
	          write(6,106) (data_single(n),n=1,dim_vals(1))
	        elseif (datatype .eq. CGNS_ENUMV(RealDouble)) then
		  call cg_array_read_f(iarray, data_double, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
	 	  write(6,106) (data_double(n),n=1,dim_vals(1))
	        endif

    	  ! *** GOTO DataArray_t node
	        call cg_goto_f(cg,base,ier, 'FlowEquationSet_t', 1, &
                    'EMElectricFieldModel_t',1, &
                    'DataArray_t',iarray,'end')
	        if (ier .eq. ERROR) call cg_error_exit_f

           ! ** DataArray_t attributes: DataClass_t
	        call cg_dataclass_read_f(type,ier)
	        if (ier .eq. ERROR) call cg_error_exit_f
	        write(6,600)'DataClassName=',DataClassName(type)

           ! ** DataArray_t attributes: DimensionalUnits_t
	        call cg_units_read_f(mass, length, time, temp, deg, ier)
	        if (ier .eq. ERROR) call cg_error_exit_f
	        if (ier .eq. ALL_OK) then
	          write(6,100) &
      	 	    'Dimensional Units:', &
                    MassUnitsName(mass), LengthUnitsName(length), &
                    TimeUnitsName(time), TemperatureUnitsName(temp),  &
                    AngleUnitsName(deg)
	        endif

           ! ** DataArray_t attributes: DimensionalExponents_t
                call cg_expfull_read_f(exponents, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                if (ier .eq. ALL_OK) then
                  write(6,199) &
                    'Dimensional Exponents:', &
                    exponents(1), exponents(2), exponents(3), &
                    exponents(4), exponents(5), exponents(6), &
                    exponents(7), exponents(8)
                endif

           ! ** DataArray_t attributes: Descriptor
                call cg_descriptor_read_f(1, name, text, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                if (ier.eq.ALL_OK) then
                  write(6,400)'Descriptor_t Information:'
                  write(6,500)' DescriptorName="',name,'"', &
                              ' DescriptorText="',text,'"'
                endif

    	  ! *** GOTO EMElectricFieldModel_t node
	        call cg_goto_f(cg,base,ier, 'FlowEquationSet_t', 1, &
                    'EMElectricFieldModel_t',1,'end')
	        if (ier .eq. ERROR) call cg_error_exit_f

              write(6,400)'                             *     *     *'
	      enddo
! end KMW Electromagnetics extension
	    endif
 	enddo    				! loop through bases

        write(6,400)'                             *     *     *'

        call cg_close_f(cg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

  99    format(a/,'    Mass exponent: ',f5.1/,'    Length exponent: ', &
          f5.1/,'    Time exponent: ',f5.1/, &
          '    Temperature exponent: ',f5.1/,'    Angle exponent:',f5.1)
 100 	format(a/,'    Mass units: ',a/,'    Length units: ',a/, &
          '    Time units: ',a/,'    Temperature units: ',a/, &
          '    Angle units:',a)
 199    format(a/,'    Mass exponent: ',f5.1/,'    Length exponent: ', &
          f5.1/,'    Time exponent: ',f5.1/, &
          '    Temperature exponent: ',f5.1/,'    Angle exponent:',f5.1 &
          /,'    Electric Current exponent: ',f5.1/, &
          '    Substance Amount exponent: ',f5.1/, &
          '    Luminous Intensity exponent: ',f5.1)
 101	format(a,i1,a,/2a,/2a,/2a,/3a,/a,i4,3a,/2a,/2a,/2a,/a,i4)
 102 	format(a,f5.3)
 103	format(a,6i2)
 104	format(a,i5,3a)
 105	format(a,i2,a)
 106    format(6f10.3)
 107	format(i2,2a)
 108    format(a,i2,a,i2,a)
 109	format(a,f5.1)
 110	format(a,5f5.1)
 111	format(a,i1,a,i8)
 112	format(a,i1/2a/3a)
 113	format(i1,3a)
 114	format(/a, i1)
 115	format(a,i1,a/3a/2a)
 116	format(a,i1,a,i1,a)
 117	format(/i4,2a)
 118	format(a,i1,a/3a/2a/a,i1,a,i5)
 119	format(a/a,3i2/a,3i2)
 120	format(a10, 3(a1,i1),a6,3(i1,a1))
 121 	format(a16,3(a1,i1),a6,3(i1,a1))
 122	format(a12,3(a1,i2),a1)
 124	format(4x, f7.2)
 126	format(a/a,3f5.2/a,3f5.2)
 127	format(2a,i1,a)
 130	format(a15, i2, a4)
 131	format(a10, 3(a1,i1),a6,3(i1,a1))
 132	format(a16,3(a1,i1),a6,3(i1,a1))
 133	format(a12,3(a1,i2),a1)
 200    format(a,i5)
 300	format(3a/a,i2)
 400	format(/a/)
 401	format(/2a/)
 500	format(3a/3a)
 600	format(3a)

 9999	end

	program read_cprop
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on August 2002

!       This example test the GridConnectivityProperty_t data structure and its children
!	It tests the functions:
!	- cg_conn_average_read_f(fn, B, Z, I, AverageInterfaceType, ier)
!	- cg_conn_periodic_read_f(fn, B, Z, I, RotationCenter, RotationAngle, Translation, ier)
!	And the following:
!	- return value when GridConnectivityProperty_t doesn't exist, or when AverageInterface/Periodic doesn't exist
!	- printing AverageInterfaceTypeName, & type<=>name association.
!	- cg_ndescriptors, cg_descriptor_read under GridConnectivityProperty_t, AverageInterface_t, Periodic_t
!	- cg_nuser_data, cg_user_data_read, under GridConnectivityProperty_t, AverageInterface_t, Periodic_t
!	- cg_narray, cg_array_read under Periodic_t
!	- links under GridConnectivityProperty_t, AverageInterface_t, Periodic_t
!	- cg_goto to GridConnectivityProperty_t, AverageInterface_t, Periodic_t
! 	- Memory check with Insure

#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 3)
	integer ier, cg, nbases, base, nzones, zone, nconns, conn
	integer CellDim, PhysDim, IndexDim
	integer(cgsize_t) size(3*Ndim)
	integer ndescriptors, idescr, zonetype
	integer ptset_type, ndonor_ptset_type
	integer(cgsize_t) npnts, npnts_donor
	integer location, nzonetype, donor_datatype
	integer AverageInterfaceType, nuser_data, n
	integer type, mass, length, time, temp, deg
	character*32 filename, basename, zonename
	character*32 name, user_data_name, connectname, donorname
	character*100 text
	real*4 version, Translation(Ndim)
	real *4 RotationCenter(Ndim), RotationAngle(Ndim)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

! *** open file
!	write(6,*) 'Input filename'
!	read(5,600) filename
 	write(filename,'(a)')'Test_V2'
	call cg_open_f(filename, MODE_READ, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,600)'READING FILE ',filename

! *** CGNS Library Version used for file creation:
	call cg_version_f(cg, version, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,102)
     &     'Library Version used for file creation:',version

! *** base
	call cg_nbases_f(cg, nbases, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,200)'nbases=',nbases
	
	base=1

	call cg_base_read_f(cg, base, basename, CellDim, PhysDim, ier)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,300)'BaseName = "',basename,'"',
     &                'cell_dimension=',CellDim

! *** base attribute:  GOTO base node
	call cg_goto_f(cg, base, ier, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

! ***   base attribute:  Descriptor
	call cg_ndescriptors_f(ndescriptors, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,400)'Base Descriptor_t Information:'
        write(6,105) 'No. of descriptors=',ndescriptors

	do idescr=1, ndescriptors
          call cg_descriptor_read_f(idescr, name, text, ier)
          if (ier .eq. ERROR) call cg_error_exit_f
          if (ier.eq.ALL_OK) then
            write(6,500)' DescriptorName="',name,'"',
     &                  ' DescriptorText="',text,'"'
          endif
	enddo

! *** read Zone
        call cg_nzones_f(cg, base, nzones, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,200)'nzones=',nzones

	zone = 1

	call cg_zone_read_f(cg, base, zone, zonename, size, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,104)'Name of Zone',zone,' is "',zonename,'"'

        call cg_zone_type_f(cg, base, zone, zonetype, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,600)'  Zone type is ', ZoneTypeName(zonetype)
	
        if (zonetype.eq.Structured) then
            IndexDim=CellDim
        else
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
            IndexDim=1
        endif

	write(6,104)'  IndexDimension=',IndexDim

! *** read GridConnectivity_t's
        call cg_nconns_f(cg, base, zone, nconns, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,113)nconns,' GridConnectivity_t found for ',
     &             zonename

        do conn=1, nconns
            call cg_conn_info_f(cg, base, zone, conn, connectname,
     &         location, type, ptset_type, npnts, donorname,
     &         nzonetype, ndonor_ptset_type, donor_datatype,
     &         npnts_donor, ier)
            if (ier .eq. ERROR) call cg_error_exit_f
            write(6, 101)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
     &        '  GridConnectivity #',conn,':',
     &        '   connect name=',connectname,
     &        '   Grid location=',GridLocationName(location),
     &        '   Connect-type=',GridConnectivityTypeName(type),
     &        '   ptset type="',PointSetTypeName(ptset_type),'"',
     &        '   npnts=',npnts,'   donorname="',donorname,'"',
     &        '   donor zonetype=',ZoneTypeName(nzonetype),
     &        '   donor ptset type=',
     &            PointSetTypeName(ndonor_ptset_type),
     &        '   DonorDatatype=',DataTypeName(donor_datatype),
     &        '   npnts_donor=',npnts_donor


!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
! *** read GridConnectivityProperty_t node

	    call cg_conn_average_read_f(cg, base, zone, conn,
     &		AverageInterfaceType, ier)
!	    if (ier .ne. ALL_OK) call cg_error_print_f
	    if (ier .eq. ERROR) call cg_error_exit_f

	    if (ier .eq. ALL_OK) then
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	        write(6,600) '   AverageInterfaceTypeName= "',
     & 		    AverageInterfaceTypeName(AverageInterfaceType),'"'
	    endif

	    call cg_conn_periodic_read_f(cg, base, zone, conn,
     &		RotationCenter, RotationAngle, Translation, ier)
!           if (ier .ne. ALL_OK) call cg_error_print_f
	    if (ier .eq. ERROR) call cg_error_exit_f

            if (ier .eq. ALL_OK) then
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	 	write(6,110)'   RotationCenter=',RotationCenter(1),
     &				RotationCenter(2), RotationCenter(3)
                write(6,110)'   RotationAngle=',RotationAngle(1),
     &                          RotationAngle(2), RotationAngle(3)
                write(6,110)'   Translation=',Translation(1),
     &                          Translation(2), Translation(3)
	    endif

! *** read Descriptor_t & UserDefinedData_t under...
! ...   GridConnectivityProperty_t
            call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &		'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn,
     &		'GridConnectivityProperty_t', 1, 'end')
!	    if (ier .ne. ALL_OK) call cg_error_print_f
	    if (ier .eq. ERROR) call cg_error_exit_f
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

            if (ier .eq. ALL_OK) then

                call cg_ndescriptors_f(ndescriptors, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'GridConnProperty Descriptor_t Information:'
                write(6,105) 'No. of descriptors=',ndescriptors
                do idescr=1, ndescriptors
                    call cg_descriptor_read_f(idescr, name, text, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' DescriptorName="',name,'"',
     &                           ' DescriptorText="',text,'"'
                enddo

                call cg_nuser_data_f(nuser_data, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'GridConnProperty User Data Information:'
                write(6,105) 'No. of UserData=',nuser_data
                do n=1, nuser_data
                    call cg_user_data_read_f(n, user_data_name, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' user_data_name="',user_data_name,'"'
                enddo

	    endif

! ...   AverageInterface_t
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
            call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     & 		'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn,
     &		'GridConnectivityProperty_t', 1, 'AverageInterface_t',
     &		1, 'end')
!	    if (ier .ne. ALL_OK) call cg_error_print_f
	    if (ier .eq. ERROR) call cg_error_exit_f

            if (ier .eq. ALL_OK) then

                call cg_ndescriptors_f(ndescriptors, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'AverageInterface Descriptor_t Information:'
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
                write(6,105) 'No. of descriptors=',ndescriptors
                do idescr=1, ndescriptors
                    call cg_descriptor_read_f(idescr, name, text, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' DescriptorName="',name,'"',
     &                           ' DescriptorText="',text,'"'
                enddo

                call cg_nuser_data_f(nuser_data, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'AverageInterface User Data Information:'
                write(6,105) 'No. of UserData=',nuser_data
                do n=1, nuser_data
                    call cg_user_data_read_f(n, user_data_name, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' user_data_name="',user_data_name,'"'
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
                enddo

            endif

! ...   Periodic_t
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
            call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &		'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn,
     &		'GridConnectivityProperty_t', 1, 'Periodic_t', 1, 'end')
!           if (ier .ne. ALL_OK) call cg_error_print_f
	    if (ier .eq. ERROR) call cg_error_exit_f

            if (ier .eq. ALL_OK) then

                call cg_ndescriptors_f(ndescriptors, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'Periodic Descriptor_t Information:'
                write(6,105) 'No. of descriptors=',ndescriptors
                do idescr=1, ndescriptors
                    call cg_descriptor_read_f(idescr, name, text, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' DescriptorName="',name,'"',
     &                           ' DescriptorText="',text,'"'
                enddo

                call cg_nuser_data_f(nuser_data, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'Periodic User Data Information:'
                write(6,105) 'No. of UserData=',nuser_data
                do n=1, nuser_data
                    call cg_user_data_read_f(n, user_data_name, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' user_data_name="',user_data_name,'"'
                enddo

! * Read DataClass & DimensionalUnits under RotationCenter
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
		call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &		    'ZoneGridConnectivity_t', 1, 'GridConnectivity_t',
     & 		    conn, 'GridConnectivityProperty_t', 1,
     &		    'Periodic_t', 1, 'DataArray_t', 1, 'end')

		call cg_dataclass_read_f(type,ier)
		if (ier .eq. ERROR) call cg_error_exit_f
		write(6,600)'DataClassName=',DataClassName(type)

        	call cg_units_read_f(mass, length, time, temp, deg, ier)
        	if (ier .eq. ERROR) call cg_error_exit_f
        	if (ier .eq. ALL_OK) then
          	    write(6,100)
     &      	    'SurfacePeriodic Dimensional Units:',
     &      	    MassUnitsName(mass), LengthUnitsName(length),
     &      	    TemperatureUnitsName(temp), TimeUnitsName(time),
     &      	    AngleUnitsName(deg)
        	endif

            endif

	enddo ! conn loop

! Close file
        call cg_close_f(cg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

 100 	format(a/,'    Mass units: ',a/,'    Length units: ',a/,
     &    '    Temperature units: ',a/,'    Time units: ',a/,
     &    '    Angle units:',a)
 101    format(a,i1,a,/2a,/2a,/2a,/3a,/a,i4,3a,/2a,/2a,/2a,/a,i4)
 102 	format(a,f8.3)
 103    format(a,6i2)
 104    format(a,i5,3a)
 105	format(a,i2,a)
 110    format(a,5f5.1)
 113    format(i1,3a)
 119    format(a/a,3i2/a,3i2)
 200    format(a,i5)
 300	format(3a/a,i2)
 400	format(/a/)
 500	format(3a/3a)
 600	format(3a)

 9999	end

	program write_cgns_motion
	USE CGNS

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on November 2000
!       This example test the API functions for grid motion and time accurate data.
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	parameter (Ndim = 3, NumberOfSteps=2)
	parameter (Nnodes = 120)
	integer index_dim, cell_dim, phys_dim, pos
	integer base_no, zone_no, coord_no, sol_no, field_no
	integer num
	integer(cgsize_t) data_size(2)
	integer(cgsize_t) size(Ndim*3)
	integer cg, ier, coord, i, sol, field
	double precision Dxyz(Nnodes), values(Nnodes)
	character*32 zonename, solname, fieldname, coordname(Ndim)

! *** Variables for RigidGridMotion_t test
!	real*4 origin(Ndim,2), angle(Ndim), velocity(Ndim)
	double precision origin(Ndim,2), angle(Ndim), velocity(Ndim)
	integer rmotion_no, rmotion
	character*32 rmotionname

! *** Variables for ArbitraryGridMotion_t test
!	real*4 GridVelocity(Nnodes)
	double precision GridVelocity(Nnodes)
	integer amotion_no, amotion
	character*32 amotionname

! *** Multiple GridCoordinates_t node
	integer grid_no, grid
	character*32 gridname

! *** Base/Zone IterativeData_t nodes
!	real*4 time(2)
	double precision time(2)
	integer nsteps, step, iteration(NumberOfSteps)
	integer nzones(NumberOfSteps)
	integer(cgsize_t) dimval(3)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	character*32 bitername, zitername, zone_ptrs(2,NumberOfSteps)
	character*32 grid_ptrs(NumberOfSteps), sol_ptrs(NumberOfSteps)
	character*32 rmotion_ptrs(NumberOfSteps)
        character*32 amotion_ptrs(NumberOfSteps)

	coordname(1) = 'CoordinateX'
	coordname(2) = 'CoordinateY'
	coordname(3) = 'CoordinateZ'

! *** initialize
	ier = 0
	index_dim=Ndim
	cell_dim=Ndim
	phys_dim=Ndim

! *** open CGNS file for writing
 	call cg_open_f('Test_V2M', MODE_MODIFY, cg, ier)
 	if (ier .ne. ALL_OK) call cg_error_exit_f
	
! *** base
 	call cg_base_write_f(cg, 'Basename', cell_dim, phys_dim, &
                             base_no, ier)
 	if (ier .ne. ALL_OK) call cg_error_exit_f

! *** simulation type
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	call cg_simulation_type_write_f(cg, base_no, CGNS_ENUMV(TimeAccurate), ier)
	if (ier .ne. ALL_OK) call cg_error_exit_f

! *** Base iterative data
	write(bitername,100) 'BaseIterativeData'
	nsteps=2
	call cg_biter_write_f(cg, base_no, bitername, nsteps, ier)
	if (ier .ne. ALL_OK) call cg_error_exit_f

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	call cg_goto_f(cg, base_no, ier, 'BaseIterativeData_t',1,'end')
	if (ier .ne. ALL_OK) call cg_error_exit_f

  ! *** TimeValues & IterationValues
	do step=1,nsteps
	    time(step) = 15.5*step
	    iteration(step) = 1000*step
	    nzones(step) = step
	    write(zone_ptrs(1,step),100) 'Zone#',1
	    write(zone_ptrs(2,step),100) 'Null'
	    if (step.eq.2) write(zone_ptrs(2,step),100) 'Zone#',2
	enddo
	!call cg_array_write_f('TimeValues', CGNS_ENUMV(RealSingle), 1, nsteps,
	call cg_array_write_f('TimeValues', CGNS_ENUMV(RealDouble), 1, &
                [INT(nsteps, cgsize_t)], time, ier)
        if (ier .ne. ALL_OK) call cg_error_exit_f
	call cg_array_write_f('IterationValues', CGNS_ENUMV(Integer), 1, &
                [INT(nsteps, cgsize_t)], iteration, ier)
	if (ier .ne. ALL_OK) call cg_error_exit_f
	call cg_array_write_f('NumberOfZones', CGNS_ENUMV(Integer), 1, &
                [INT(nsteps, cgsize_t)], nzones, ier)
	if (ier .ne. ALL_OK) call cg_error_exit_f
	dimval(1)=32
	dimval(2)=2 		! *** MaxNumberOfZones in a step1
	dimval(3)=nsteps
        call cg_array_write_f('ZonePointers', CGNS_ENUMV(Character), 3, dimval, &
                               zone_ptrs(1,:), ier)
	if (ier .ne. ALL_OK) call cg_error_exit_f
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

! *** zone
        write(zonename,100) 'Zone#',1
        num = 1
	do i=1,index_dim      		! zone#1: 3*4*5
            size(i) = i+2		! nr of nodes in i,j,k
	    size(i+Ndim) = size(i)-1	! nr of elements in i,j,k
	    size(i+2*Ndim) = 0		! nr of bnd nodes if ordered
       	    num = num * size(i)		! nr of nodes &
         enddo
         call cg_zone_write_f(cg, base_no, zonename, size, &
                             CGNS_ENUMV(Structured), zone_no, ier)
        if (ier .ne. ALL_OK) call cg_error_exit_f

! *** Zone iterative data
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	write(zitername,100) 'ZoneIterativeData'
        call cg_ziter_write_f(cg, base_no, zone_no, zitername, ier)
        if (ier .ne. ALL_OK) call cg_error_exit_f

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
        call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no, &
                       'ZoneIterativeData_t',1,'end')
        if (ier .ne. ALL_OK) call cg_error_exit_f

	do step=1, nsteps
	    write(grid_ptrs(step),100)   'GridCoordinates#',    step
	    write(sol_ptrs(step),100)    'FlowSolution#',       step
	    write(rmotion_ptrs(step),100)'RigidGridMotion#',    step
	    write(amotion_ptrs(step),100)'ArbitraryGridMotion#',step
	enddo
	dimval(1)=32
	dimval(2)=nsteps

	call cg_array_write_f('GridCoordinatesPointers', CGNS_ENUMV(Character), 2, &
                               dimval, grid_ptrs, ier)
        if (ier .ne. ALL_OK) call cg_error_exit_f
	call cg_array_write_f('FlowSolutionPointers', CGNS_ENUMV(Character), 2, &
                               dimval, sol_ptrs, ier)
        if (ier .ne. ALL_OK) call cg_error_exit_f
	call cg_array_write_f('RigidGridMotionPointers', CGNS_ENUMV(Character), 2, &
                               dimval, rmotion_ptrs, ier)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	if (ier .ne. ALL_OK) call cg_error_exit_f
        call cg_array_write_f('ArbitraryGridMotionPointers', CGNS_ENUMV(Character), &
                               2, dimval, amotion_ptrs, ier)
	if (ier .ne. ALL_OK) call cg_error_exit_f

! *** coordinate
      do coord=1, phys_dim
 	    do k=1, size(3)
 	    do j=1, size(2)
 	    do i=1, size(1)
	        pos = i + (j-1)*size(1) + (k-1)*size(1)*size(2)
		! * make up some dummy coordinates just for the test:
 	        if (coord.eq.1) Dxyz(pos) = i
 	        if (coord.eq.2) Dxyz(pos) = j
 	        if (coord.eq.3) Dxyz(pos) = k
 	    enddo
 	    enddo
 	    enddo

            call cg_coord_write_f(cg, base_no, zone_no, CGNS_ENUMV(RealDouble), &
                                  coordname(coord), Dxyz, coord_no, ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f

      enddo

! *** additional GridCoordinates_t Descriptions
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	do grid = 1,2
	    write(gridname,100)'GridCoordinates#',grid
	    call cg_grid_write_f(cg, base_no, zone_no, gridname, &
                                 grid_no, ier)
	    if (ier .ne. ALL_OK) call cg_error_exit_f

	    call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no, &
                           'GridCoordinates_t', grid_no, 'end')
            if (ier .ne. ALL_OK) call cg_error_exit_f
	
	    call cg_array_write_f('CoordinateX', CGNS_ENUMV(RealDouble), 3, &
                                   size, Dxyz, ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f
            call cg_array_write_f('CoordinateY', CGNS_ENUMV(RealDouble), 3, &
                                   size, Dxyz, ier)
            call cg_array_write_f('CoordinateZ', CGNS_ENUMV(RealDouble), 3, &
                                   size, Dxyz, ier)

      ! *** Write DataClass_t under CoordinateX
	    call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no, &
              'GridCoordinates_t', grid_no, 'DataArray_t', 1, 'end')
            if (ier .ne. ALL_OK) call cg_error_exit_f

	    call cg_dataclass_write_f(CGNS_ENUMV(Dimensional), ier)
	    if (ier .ne. ALL_OK) call cg_error_exit_f
	enddo

! *** solution
      do sol=1, 2
 	    write(solname,100) 'Solution#',sol
 	    call cg_sol_write_f(cg, base_no, zone_no, solname, &
                                CGNS_ENUMV(Vertex), sol_no, ier)
 	    if (ier .ne. ALL_OK) call cg_error_exit_f

! *** solution field
 	    do field=1, 2
	    ! make up some dummy solution values
 	  	do i=1, num
 		    values(i) = i*field*sol
 	    	enddo
 	    	write(fieldname,100) 'Field#',field
 	    	call cg_field_write_f(cg, base_no, zone_no, sol_no, &
                    CGNS_ENUMV(RealDouble), fieldname, values, field_no, ier)
 	    	if (ier .ne. ALL_OK) call cg_error_exit_f

 	    enddo				! field loop
        enddo				! solution loop

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
! *** Rigid Grid Motion
	do rmotion=1, 2
	    write(rmotionname,100) 'RigidGridMotion#',rmotion
	    do coord=1, phys_dim
	        origin(coord,1) = (rmotion-1)*10.0
	        origin(coord,2) = origin(coord,1) + 10.0
	        angle(coord) = 5.0 * rmotion
		velocity(coord) = 7.0
	    enddo
	    call cg_rigid_motion_write_f(cg, base_no, zone_no, &
            rmotionname, CGNS_ENUMV(ConstantRate), rmotion_no, ier)
	    if (ier .ne. ALL_OK) call cg_error_exit_f

! ** Goto RigidGridMotion_t node
	    call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no, &
                           'RigidGridMotion_t', rmotion_no, 'end')
	    if (ier .ne. ALL_OK) call cg_error_exit_f

! *** Add an attribute under RigidGridMotion_t
	    call cg_descriptor_write_f('DescriptorName', &
                                       'DescriptotText', ier)
	    if (ier .ne. ALL_OK) call cg_error_exit_f

! *** Add a DataArray_t under RigidGridMotion_t
	    data_size(1)=phys_dim
	    data_size(2)=2
            !call cg_array_write_f('OriginLocation', CGNS_ENUMV(RealSingle), 2,
            call cg_array_write_f('OriginLocation', CGNS_ENUMV(RealDouble), 2, &
                                   data_size, origin(1,1), ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f

            !call cg_array_write_f('RigidRotationAngle', CGNS_ENUMV(RealSingle), 1,
            call cg_array_write_f('RigidRotationAngle', CGNS_ENUMV(RealDouble), 1, &
                                   [INT(phys_dim,cgsize_t)], angle, ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f

	    !call cg_array_write_f('RigidVelocity', CGNS_ENUMV(RealSingle), 1,
	    call cg_array_write_f('RigidVelocity', CGNS_ENUMV(RealDouble), 1, &
                                   [INT(phys_dim, cgsize_t)], velocity, ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f

! *** Add an attribute for this data array: GOTO DataArray node
	    call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no, &
                           'RigidGridMotion_t', rmotion_no, &
                           'DataArray_t', 3, 'end')
	    if (ier .ne. ALL_OK) call cg_error_exit_f

            call cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), CGNS_ENUMV(Kelvin), &
                                  CGNS_ENUMV(Radian), ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f

	enddo

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
! *** Arbitrary Grid Motion

        do amotion=1, 2

! *** Create the ArbitraryGridMotion_t node
            write(amotionname,100)'ArbitraryGridMotion#',amotion
	    call cg_arbitrary_motion_write_f(cg, base_no, zone_no, &
                 amotionname, CGNS_ENUMV(DeformingGrid), amotion_no, ier)
	    if (ier .ne. ALL_OK) call cg_error_exit_f

! *** Goto the ArbitraryGridMotion_t node
            call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no, &
                          'ArbitraryGridMotion_t', amotion_no, 'end')
            if (ier .ne. ALL_OK) call cg_error_exit_f

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
! *** Add an attribute under ArbitraryGridMotion_t
            call cg_descriptor_write_f('DescriptorName', &
                                       'DescriptotText', ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f

! *** make up some dummy GridVelocityX values just for the test:
            DO k=1, SIZE(3)
               DO j=1, SIZE(2)
                  DO i=1, SIZE(1)
                     pos = i + (j-1)*SIZE(1) + (k-1)*SIZE(1)*SIZE(2)
                     GridVelocity(pos) = pos
                  ENDDO
               ENDDO
            ENDDO

! *** Add a DataArray_t 'GridVelocityX' under ArbitraryGridMotion_t
            !call cg_array_write_f('GridVelocityX', CGNS_ENUMV(RealSingle),
            call cg_array_write_f('GridVelocityX', CGNS_ENUMV(RealDouble), &
      		                  index_dim, size, GridVelocity, ier)
	    if (ier .ne. ALL_OK) call cg_error_exit_f

! *** Add an attribute for this data array: GOTO DataArray node
            call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no, &
                          'ArbitraryGridMotion_t', amotion_no, &
                          'DataArray_t', 1, 'end')
            if (ier .ne. ALL_OK) call cg_error_exit_f

            call cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), CGNS_ENUMV(Kelvin), &
                                  CGNS_ENUMV(Radian), ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f
	enddo

! *** close CGNS file
	call cg_close_f(cg, ier)
	if (ier .ne. ALL_OK) call cg_error_exit_f

 100	format(a,i1)
	end

      program write_dimensional
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Opens an existing CGNS file that contains a simple 3-D
!   grid plus a flow solution and adds its dimensionality
!   (dimensional data).
!
!   The CGNS grid file 'grid.cgns' must already exist
!   (for example, created using
!       write_grid_str.f followed by write_flowcent_str.f or
!       write_grid_str.f followed by write_flowvert_str.f or
!       write_grid_str.f followed by write_flowcentrind_str.f or
!       write_grid_unst.f followed by write_flowvert_unst.f)
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c write_dimensional.F90
!   ifort -o write_dimensional write_dimensional.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
      real*4 exponents(5)
      integer icc,iff,nfields,index_grid,index_flow,index_zone
      integer index_base,index_file,ier,ncoords,idatatype
      character fieldname*32
!
      write(6,'('' Program write_dimensional'')')
      if (CG_BUILD_64BIT) then
        write(6,'('' ...compiled in 64-bit mode, but not needed'')')
      end if
!
!   WRITE DIMENSIONAL INFO FOR GRID AND FLOW SOLN
!   open CGNS file for modify
      call cg_open_f('grid.cgns',CG_MODE_MODIFY,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!   we know there is only one base (real working code would check!)
      index_base=1
!   we know there is only one zone (real working code would check!)
      index_zone=1
!   we know there is only one FlowSolution_t (real working code would check!)
      index_flow=1
!   we know there is only one GridCoordinates_t (real working code would check!)
      index_grid=1
!   put DataClass and DimensionalUnits under Base
      call cg_goto_f(index_file,index_base,ier,'end')
      call cg_dataclass_write_f(CGNS_ENUMV(Dimensional),ier)
      call cg_units_write_f(CGNS_ENUMV(Kilogram),CGNS_ENUMV(Meter),CGNS_ENUMV(Second),CGNS_ENUMV(Kelvin),CGNS_ENUMV(Degree),ier)
!   read fields
      call cg_nfields_f(index_file,index_base,index_zone,index_flow,           &
           nfields,ier)
      if (nfields .ne. 2) then
        write(6,'('' Error! expecting 2 fields, read '',i5)') nfields
        stop
      end if
      do iff=1,nfields
        call cg_field_info_f(index_file,index_base,index_zone,                 &
             index_flow,iff,idatatype,fieldname,ier)
        write(6,'('' fieldname='',a32)') fieldname
        if (fieldname .eq. 'Density') then
          exponents(1)=1.
          exponents(2)=-3.
          exponents(3)=0.
          exponents(4)=0.
          exponents(5)=0.
        else if (fieldname .eq. 'Pressure') then
          exponents(1)=1.
          exponents(2)=-1.
          exponents(3)=-2.
          exponents(4)=0.
          exponents(5)=0.
        else
          write(6,'('' Error! this fieldname not expected: '',a32)') fieldname
          stop
        end if
!   write DimensionalExponents
        call cg_goto_f(index_file,index_base,ier,'Zone_t',1,                   &
             'FlowSolution_t',1,'DataArray_t',iff,'end')
        call cg_exponents_write_f(CGNS_ENUMV(RealSingle),exponents,ier)
      enddo
!   read grid
      call cg_ncoords_f(index_file,index_base,index_zone,ncoords,ier)
      exponents(1)=0.
      exponents(2)=1.
      exponents(3)=0.
      exponents(4)=0.
      exponents(5)=0.
      do icc=1,ncoords
!   write DimensionalExponents
        call cg_goto_f(index_file,index_base,ier,'Zone_t',1,                   &
             'GridCoordinates_t',1,'DataArray_t',icc,'end')
        call cg_exponents_write_f(CGNS_ENUMV(RealSingle),exponents,ier)
      enddo
!   close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully wrote dimensional data to file'',              &
       '' grid.cgns'')')
      stop
      end

	program write_rotating
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on May 31 2002

!       This example test the RotatingCoordinates_t data structure and its children

#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 3)
	integer index_dim, cell_dim, phys_dim, i
	integer cg, base_no, zone_no, ier
	integer(cgsize_t) size(Ndim*3)
	real*4 rot_rate(Ndim), rot_center(Ndim)
	character*100 linkpath

! *** initialize
	ier = 0
	index_dim=Ndim
	cell_dim=Ndim
	phys_dim=Ndim

! *** open CGNS file for writing
 	call cg_open_f('Test_V2', MODE_WRITE, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f

! *** base
 	call cg_base_write_f(cg, 'Basename', cell_dim, phys_dim,
     &                       base_no, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f

! *** write a descriptor under the base
        call cg_goto_f(cg, base_no, ier, 'end')
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_descriptor_write_f('BaseDescriptorName',
     &      'BaseDescriptorText', ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** write RotatingCoordinates_t node
	rot_rate(1)=10.1
	rot_rate(2)=0
	rot_rate(3)=0
	rot_center(1) = 1.1
	rot_center(2) = 1.2
	rot_center(3) = 1.3
	call cg_rotating_write_f(rot_rate, rot_center, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** write children of RotatingCoordinates_t node
	call cg_goto_f(cg, base_no, ier, 'RotatingCoordinates_t',
     &                 1, 'end')
	if (ier .eq. ERROR) call cg_error_exit_f

! * Descriptor
	call cg_descriptor_write_f('RotatingCoordinatesDescriptorName',
     &       'RotatingCoordinatesDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * DataClass
        call cg_dataclass_write_f(Dimensional, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! * DimensionalUnits
	call cg_units_write_f(Kilogram, Meter, Second, Kelvin,
     &                        Radian, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! * UserDefinedData
        call cg_user_data_write_f('UserData1', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * Link to BaseDescriptorName
        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * RotationCenter/Descriptor
	call cg_goto_f(cg, base_no, ier, 'RotatingCoordinates_t', 1,
     &                 'DataArray_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f
	call cg_descriptor_write_f('RotationCenterDescriptorName',
     &       'RotationCenterDescriptorText', ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	
! * RotationCenter/DimensionalUnits
	call cg_units_write_f(Kilogram, Meter, Second, Kelvin,
     &                        Radian, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * Write a zone
	do i=1,index_dim
	    size(i) = i+1		! nr of nodes in i,j,k = 3,4,5
	    size(i+Ndim) = size(i)-1	! nr of elements in i,j,k
	    size(i+2*Ndim) = 0		! nr of bnd nodes if ordered
	enddo
	call cg_zone_write_f(cg, base_no, 'MyZone', size,
     &                           Structured, zone_no, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! *** write a descriptor under the zone
        call cg_goto_f(cg, base_no, ier, 'Zone_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_descriptor_write_f('ZoneDescriptorName',
     &      'ZoneDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! *** write RotatingCoordinates_t node
        rot_rate(1)=10.1
        rot_rate(2)=0
        rot_rate(3)=0
        rot_center(1) = 1.1
        rot_center(2) = 1.2
        rot_center(3) = 1.3
        call cg_rotating_write_f(rot_rate, rot_center, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! *** write children of RotatingCoordinates_t node
        call cg_goto_f(cg, base_no, ier, 'Zone_t', 1,
     &                 'RotatingCoordinates_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

! * Descriptor
        call cg_descriptor_write_f('RotatingCoordinatesDescriptorName',
     &       'RotatingCoordinatesDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * DataClass
        call cg_dataclass_write_f(Dimensional, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * DimensionalUnits
        call cg_units_write_f(Kilogram, Meter, Second, Kelvin,
     &                        Radian, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * UserDefinedData
        call cg_user_data_write_f('UserData2', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * Link to ZoneDescriptorName
        write(linkpath,'(a)') '/Basename/MyZone/ZoneDescriptorName'
        call cg_link_write_f('LinkToZoneDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * RotationCenter/Descriptor
        call cg_goto_f(cg, base_no, ier, 'Zone_t', 1,
     &       'RotatingCoordinates_t', 1, 'DataArray_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f
        call cg_descriptor_write_f('RotationCenterDescriptorName',
     &       'RotationCenterDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * RotationCenter/DimensionalUnits
        call cg_units_write_f(Kilogram, Meter, Second, Kelvin,
     &                        Radian, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! *** close CGNS file
	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	end

      program fmain
      integer*4 i,j
      character*32 string
      i = 1
      j = 3
      string = 'string'
      call cg_sub(i,string,j)
      call adfsub(i,string,j)
      call varsub(i,string,j)
      stop
      end

      PROGRAM TEST
!
!     SAMPLE ADF TEST PROGRAM TO BUILD ADF FILES ILLUSTRATED
!     IN THE EXAMPLE DATABASE FIGURE
!
      PARAMETER (MAXCHR=32)
!
      CHARACTER*(MAXCHR) TSTLBL,DTYPE
      CHARACTER*(MAXCHR) FNAM,PATH
!
      REAL*8 RID,PID,CID,TMPID,RIDF2
      REAL A(4,3),B(4,3)
      INTEGER IC(6),ID(6)
      INTEGER IERR
      INTEGER IDIM(2),IDIMA(2),IDIMC,IDIMD
!
      DATA A /1.1,2.1,3.1,4.1, &
              1.2,2.2,3.2,4.2, &
              1.3,2.3,3.3,4.3/
      DATA IDIMA /4,3/
!
      DATA IC /1,2,3,4,5,6/
      DATA IDIMC /6/
!
!     SET ERROR FLAG TO ABORT ON ERROR
!
      CALL ADFSES(1,IERR)
!
! *** 1.) OPEN 1ST DATABASE (ADF_FILE_TWO.ADF)
!     2.) CREATE THREE NODES AT FIRST LEVEL
!     3.) PUT LABEL ON NODE F3
!     4.) PUT DATA IN F3
!     5.) CREATE TWO NODES BELOW F3
!     6.) CLOSE DATABASE
!
      CALL ADFDOPN('adf_file_two.adf','NEW',' ',RID,IERR)
      RIDF2 = RID
      CALL ADFCRE(RID,'F1',TMPID,IERR)
      CALL ADFCRE(RID,'F2',TMPID,IERR)
      CALL ADFCRE(RID,'F3',PID,IERR)
      CALL ADFSLB(PID,'LABEL ON NODE F3',IERR)
      CALL ADFPDIM(PID,'R4',2,IDIMA,IERR)
      CALL ADFWALL(PID,A,IERR)
!
      CALL ADFCRE(PID,'F4',CID,IERR)
!
      CALL ADFCRE(PID,'F5',CID,IERR)
!
      CALL ADFDCLO(RID,IERR)
!
! *** 1.) OPEN 2ND DATABASE
!     2.) CREATE NODES
!     3.) PUT DATA IN N13
!
      CALL ADFDOPN('adf_file_one.adf','NEW',' ',RID,IERR)
!
!     THREE NODES UNDER ROOT
!
      CALL ADFCRE(RID,'N1',TMPID,IERR)
      CALL ADFCRE(RID,'N2',TMPID,IERR)
      CALL ADFCRE(RID,'N3',TMPID,IERR)
!
!     THREE NODES UNDER N1 (TWO REGULAR AND ONE LINK)
!
      CALL ADFGNID(RID,'N1',PID,IERR)
      CALL ADFCRE(PID,'N4',TMPID,IERR)
      CALL ADFLINK(PID,'L3','adf_file_two.adf','/F3',TMPID,IERR)
      CALL ADFCRE(PID,'N5',TMPID,IERR)
!
!     TWO NODES UNDER N4
!
      CALL ADFGNID(PID,'N4',CID,IERR)
      CALL ADFCRE(CID,'N6',TMPID,IERR)
      CALL ADFCRE(CID,'N7',TMPID,IERR)
!
!     ONE NODE UNDER N6
!
      CALL ADFGNID(RID,'/N1/N4/N6',PID,IERR)
      CALL ADFCRE(PID,'N8',TMPID,IERR)
!
!     THREE NODES UNDER N3
!
      CALL ADFGNID(RID,'N3',PID,IERR)
      CALL ADFCRE(PID,'N9',TMPID,IERR)
      CALL ADFCRE(PID,'N10',TMPID,IERR)
      CALL ADFCRE(PID,'N11',TMPID,IERR)
!
!     TWO NODES UNDER N9
!
      CALL ADFGNID(PID,'N9',CID,IERR)
      CALL ADFCRE(CID,'N12',TMPID,IERR)
      CALL ADFCRE(CID,'N13',TMPID,IERR)
!
!     PUT LABEL AND DATA IN N13
!
      CALL ADFSLB(TMPID,'LABEL ON NODE N13',IERR)
      CALL ADFPDIM(TMPID,'I4',1,IDIMC,IERR)
      CALL ADFWALL(TMPID,IC,IERR)
!
!     TWO NODES UNDER N10
!
      CALL ADFGNID(RID,'/N3/N10',PID,IERR)
      CALL ADFLINK(PID,'L1',' ','/N3/N9/N13',TMPID,IERR)
      CALL ADFCRE(PID,'N14',TMPID,IERR)
!
!     TWO NODES UNDER N11
!
      CALL ADFGNID(RID,'/N3/N11',PID,IERR)
      CALL ADFLINK(PID,'L2',' ','/N3/N9/N13',TMPID,IERR)
      CALL ADFCRE(PID,'N15',TMPID,IERR)
!
! *** READ AND PRINT DATA FROM NODES
!     1.) NODE F5 THROUGH LINK L3
!
      CALL ADFGNID(RID,'/N1/L3',PID,IERR)
      CALL ADFGLB(PID,TSTLBL,IERR)
      CALL ADFGDT(PID,DTYPE,IERR)
      CALL ADFGND(PID,NUMDIM,IERR)
      CALL ADFGDV(PID,IDIM,IERR)
      CALL ADFRALL(PID,B,IERR)
      PRINT *,' NODE F3 THROUGH LINK L3:'
      PRINT *,'   LABEL       = ',TSTLBL
      PRINT *,'   DATA TYPE   = ',DTYPE
      PRINT *,'   NUM OF DIMS = ',NUMDIM
      PRINT *,'   DIM VALS    = ',IDIM
      PRINT *,'   DATA:'
      WRITE(*,100)((B(J,I),I=1,3),J=1,4)
  100 FORMAT(5X,3F10.2)
!
!     2.) N13
!
      CALL ADFGNID(RID,'N3/N9/N13',PID,IERR)
      CALL ADFGLB(PID,TSTLBL,IERR)
      CALL ADFGDT(PID,DTYPE,IERR)
      CALL ADFGND(PID,NUMDIM,IERR)
      CALL ADFGDV(PID,IDIMD,IERR)
      CALL ADFRALL(PID,ID,IERR)
      PRINT *,' '
      PRINT *,' NODE N13:'
      PRINT *,'   LABEL       = ',TSTLBL
      PRINT *,'   DATA TYPE   = ',DTYPE
      PRINT *,'   NUM OF DIMS = ',NUMDIM
      PRINT *,'   DIM VALS    = ',IDIMD
      PRINT *,'   DATA:'
      WRITE(*,200)(ID(I),I=1,6)
  200 FORMAT(5X,6I6)
!
!     3.) N13 THROUGH L1
!
      CALL ADFGNID(RID,'N3/N10/L1',TMPID,IERR)
      CALL ADFGLB(TMPID,TSTLBL,IERR)
      CALL ADFRALL(TMPID,ID,IERR)
      PRINT *,' '
      PRINT *,' NODE N13 THROUGH LINK L1:'
      PRINT *,'   LABEL       = ',TSTLBL
      PRINT *,'   DATA:'
      WRITE(*,200)(ID(I),I=1,6)
!
!     4.) N13 THROUGH L2
!
      CALL ADFGNID(RID,'N3/N11/L2',CID,IERR)
      CALL ADFGLB(CID,TSTLBL,IERR)
      CALL ADFRALL(CID,ID,IERR)
      PRINT *,' '
      PRINT *,' NODE N13 THROUGH LINK L2:'
      PRINT *,'   LABEL       = ',TSTLBL
      PRINT *,'   DATA:'
      WRITE(*,200)(ID(I),I=1,6)
!
!     PRINT LIST OF CHILDREN UNDER ROOT NODE
!
      CALL PRTCLD(RID)
!
!     PRINT LIST OF CHILDREN UNDER N3
!
      CALL ADFGNID(RID,'N3',PID,IERR)
      CALL PRTCLD(PID)
!
!     REOPEN ADF_FILE_TWO AND GET NEW ROOT ID
!
      CALL ADFDOPN('adf_file_two.adf','OLD',' ',RID,IERR)
      PRINT *,' '
      PRINT *,' COMPARISON OF ROOT ID: '
      PRINT *,' ADF_FILE_TWO.ADF ORIGINAL ROOT ID = ',RIDF2
      PRINT *,' ADF_FILE_TWO.ADF NEW ROOT ID      = ',RID
!
      END PROGRAM TEST
!
! ************* SUBROUTINES ****************
!
      SUBROUTINE PRTCLD(PID)
!
! *** PRINT TABLE OF CHILDREN GIVEN A PARENT NODE-ID
!
      PARAMETER (MAXCLD=10)
      PARAMETER (MAXCHR=32)
      REAL*8 PID
      CHARACTER*(MAXCHR) NODNAM,NDNMS(MAXCLD)
      CALL ADFGNAM(PID,NODNAM,IERR)
      CALL ADFNCLD(PID,NUMC,IERR)
      WRITE(*,120)NODNAM,NUMC
  120 FORMAT(/,' PARENT NODE NAME = ',A,/, &
             '     NUMBER OF CHILDREN = ',I2,/, &
             '     CHILDREN NAMES:')
      NLEFT = NUMC
      ISTART = 1
!     --- TOP OF DO-WHILE LOOP
  130 CONTINUE
!        CALL ADFCNAM(PID,ISTART,MAXCLD,LEN(NDNMS),
!---------------- g77 doesn't like this ^
         CALL ADFCNAM(PID,ISTART,MAXCLD,MAXCHR, &
                      NUMRET,NDNMS,IERR)
         WRITE(*,140)(NDNMS(K),K=1,NUMRET)
  140    FORMAT(8X,A)
         NLEFT = NLEFT - MAXCLD
         ISTART = ISTART + MAXCLD
      IF (NLEFT .GT. 0) GO TO 130
      RETURN
      END SUBROUTINE PRTCLD

      program read_grid_unst
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Reads simple 3-D unstructured grid from a CGNS file
!   (created using write_grid_unst.f).
!
!   The CGNS grid file 'grid.cgns' must already exist.
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c read_grid_unst.F90
!   ifort -o read_grid_unst read_grid_unst.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
      real*4 x(21*17*9),y(21*17*9),z(21*17*9)
      integer(cgsize_t) isize(1,3),ielem(8,20*16*8)
      integer(cgsize_t) irmin,irmax,istart,iend,iparentdata
      integer iparent_flag,nbndry,itype,index_sect,nsections
      integer index_zone,index_base,index_file,ier
      character zonename*32,sectionname*32
!
!   READ X, Y, Z GRID POINTS FROM CGNS FILE
!   open CGNS file for read-only
      call cg_open_f('grid.cgns',CG_MODE_READ,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!   we know there is only one base (real working code would check!)
      index_base=1
!   we know there is only one zone (real working code would check!)
      index_zone=1
!   get zone size (and name - although not needed here)
      call cg_zone_read_f(index_file,index_base,index_zone,zonename,           &
           isize,ier)
!   lower range index
      irmin=1
!   upper range index of vertices
      irmax=isize(1,1)
!   read grid coordinates
      call cg_coord_read_f(index_file,index_base,index_zone,                   &
           'CoordinateX',CGNS_ENUMV(RealSingle),irmin,irmax,x,ier)
      call cg_coord_read_f(index_file,index_base,index_zone,                   &
           'CoordinateY',CGNS_ENUMV(RealSingle),irmin,irmax,y,ier)
      call cg_coord_read_f(index_file,index_base,index_zone,                   &
           'CoordinateZ',CGNS_ENUMV(RealSingle),irmin,irmax,z,ier)
!  find out how many sections
      call cg_nsections_f(index_file,index_base,index_zone,nsections,ier)
      write(6,'('' number of sections='',i7)') nsections
!  read element connectivity
      do index_sect=1,nsections
        call cg_section_read_f(index_file,index_base,index_zone,               &
             index_sect,sectionname,itype,istart,iend,nbndry,                  &
             iparent_flag,ier)
        write(6,'('' Reading section data...'')')
        write(6,'(''    section name='',a32)') sectionname
        write(6,'(''    section type='',a32)') ElementTypeName(itype)
        write(6,'(''    istart,iend='',2i6)') istart,iend
        if (ElementTypeName(itype) .eq. 'HEXA_8') then
          write(6,'(''    reading element data for this element'')')
          call cg_elements_read_f(index_file,index_base,index_zone,            &
               index_sect,ielem,iparentdata,ier)
        else
          write(6,'(''    not reading element data for this element'')')
        end if
      enddo
!   close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully read unstructured grid from file'',            &
        '' grid.cgns'')')
      write(6,'(''   for example, element 1 is made up of nodes:'',            &
        8i5)') ielem(1,1),ielem(2,1),ielem(3,1),ielem(4,1),                    &
        ielem(5,1),ielem(6,1),ielem(7,1),ielem(8,1)
      write(6,'(''   x,y,z of node 358 are:'',3f12.5)')                        &
        x(358),y(358),z(358)
      write(6,'(''   x,y,z of node 1358 are:'',3f12.5)')                       &
        x(1358),y(1358),z(1358)
      stop
      end

        program modify_mixed_elements
	USE CGNS

!	author: Diane Poirier
!	last revised on March 15 2000

! 	This example test the writing of and element section of
!	type CGNS_ENUMV(MIXED), which includes some NGON_x elements of different size
!	The model is not realistic, as all the data is dummy.
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer index_dim, cell_dim, phys_dim
	integer cg, base, zone, ier, index, ZoneType
        integer(cgsize_t) size(3)
	integer i, j, k, n, pos, coord, element(22), section_no
	integer connect_offsets(12)
	character*32 ZoneName, coordname(3)
        double precision data_double(27)
	integer grid_no, count

!       initialize
        ier = 0
	index_dim = 1
	cell_dim=3
	phys_dim=3

!       open CGNS file for writing

        call cg_open_f('Test_V2M', MODE_MODIFY, cg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

!*******write CGNSBase
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	call cg_base_write_f(cg, 'MixedElementBase', cell_dim, phys_dim, &
      			     base, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

!*******write only 1 unstructured zone
	zone = 1
	ZoneType=CGNS_ENUMV(Unstructured)
	write(ZoneName,100) 'UnstructuredZone#1'
 100	format(a)
	size(1) = 27		! no of nodes
	size(2) = 3		! no of elements
	size(3) = 0		! unsorted nodes

	call cg_zone_write_f(cg, base, 'UnstructuredZone#1', size, &
                             ZoneType, index, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! Name convention
        coordname(1) = 'CoordinateX'
        coordname(2) = 'CoordinateY'
        coordname(3) = 'CoordinateZ'


! Create GridCoordinates_t node
            call cg_grid_write_f(cg,base,index,'GridCoordinates', &
                               grid_no, ier)
            if (ier.ne. ALL_OK) call cg_error_exit_f

! create coordinate data(10x10x10 box with 3x3x3 equidistant nodes)
        do coord=1,phys_dim
           DO k=1, 3
              DO j=1, 3
                 DO i=1, 3
                    pos = i + (j-1)*3 + (k-1)*9
                    IF (coord.EQ.1) data_double(pos) = (i-1)*5
                    IF (coord.EQ.2) data_double(pos) = (j-1)*5
                    IF (coord.EQ.3) data_double(pos) = (k-1)*5
                 ENDDO
              ENDDO
           ENDDO

! GOTO GridCoordinatesNode & write DataArray
            call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                           'GridCoordinates_t', 1, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_array_write_f(coordname(coord), CGNS_ENUMV(RealDouble), &
                                  index_dim, size, data_double, ier)
            if (ier .eq. ERROR) call cg_error_exit_f
	enddo	! coord. loop

! Generate dummy elements

	count = 0
! first element HEXA_8
	connect_offsets(1) = 0
	count = count + 1
	element(count)=CGNS_ENUMV(HEXA_8)
	do i=1,8
	    count = count + 1
	    element(count)=i
	enddo
! second element TETRA_4
	connect_offsets(2) = count
	count = count + 1
	element(count)=CGNS_ENUMV(TETRA_4)
	do i=1,4
	    count = count + 1
            element(count)=i
        enddo
! 3rd element NGON_7, so set ElementType to  NGON_n+7
	connect_offsets(3) = count
	count = count + 1
	element(count)= NGON_n+7
	do i=1,7
            count = count + 1
            element(count)=i
        enddo
	connect_offsets(4) = count

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
! Write MIXED element section
	call cg_poly_section_write_f(cg, base, zone, 'MixedElements', CGNS_ENUMV(MIXED), &
                                1, 3, 0, element, connect_offsets, &
                                section_no, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! Write section of 4  NGON_n of 3 nodes
        count = 0
	do n=1,4
	    !count = count + 1
	    !element(count)= NGON_n+3
            connect_offsets(n) = count
	    do i=1,3
		count = count + 1
		element(count)=10*n+i
	    enddo
	enddo
	connect_offsets(5) = count
	call cg_poly_section_write_f(cg, base, zone, ' NGON_n(3)', &
                        NGON_n+3, 1, 4, 0, element, &
                       connect_offsets, section_no, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! Write & close CGNS file

	call cg_close_f(cg, ier)
	if (ier.eq. ERROR) call cg_error_exit_f()

	end

        PROGRAM read_cprop
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on August 2002

!       This example test the GridConnectivityProperty_t data structure and its children
!	It tests the functions:
!	- cg_conn_average_read_f(fn, B, Z, I, AverageInterfaceType, ier)
!	- cg_conn_periodic_read_f(fn, B, Z, I, RotationCenter, RotationAngle, Translation, ier)
!	And the following:
!	- return value when GridConnectivityProperty_t doesn't exist, or when AverageInterface/Periodic doesn't exist
!	- printing AverageInterfaceTypeName, & type<=>name association.
!	- cg_ndescriptors, cg_descriptor_read under GridConnectivityProperty_t, AverageInterface_t, Periodic_t
!	- cg_nuser_data, cg_user_data_read, under GridConnectivityProperty_t, AverageInterface_t, Periodic_t
!	- cg_narray, cg_array_read under Periodic_t
!	- links under GridConnectivityProperty_t, AverageInterface_t, Periodic_t
!	- cg_goto to GridConnectivityProperty_t, AverageInterface_t, Periodic_t
! 	- Memory check with Insure
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 3)
	integer ier, cg, nbases, base, nzones, zone, nconns, conn
	integer CellDim, PhysDim, IndexDim
	integer ndescriptors, idescr, zonetype
	integer(cgsize_t) size(3*Ndim)
	integer ptset_type, ndonor_ptset_type, npnts, npnts_donor
	integer location, nzonetype, donor_datatype
	integer AverageInterfaceType, nuser_data, n
	integer type, mass, length, time, temp, deg
	character*32 filename, basename, zonename
	character*32 name, user_data_name, connectname, donorname
	character*100 text
	real*4 version, Translation(Ndim)
	real *4 RotationCenter(Ndim), RotationAngle(Ndim)
	integer(cgsize_t) range(Ndim, 2), donor_range(Ndim, 2)
 	integer transform(Ndim)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

! *** open file
!	write(6,*) 'Input filename'
!	read(5,600) filename
 	write(filename,'(a)')'Test_V2'
	call cg_open_f(filename, MODE_READ, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,600)'READING FILE ',filename

! *** CGNS Library Version used for file creation:
	call cg_version_f(cg, version, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,102) &
           'Library Version used for file creation:',version

! *** base
	call cg_nbases_f(cg, nbases, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,200)'nbases=',nbases
	
	base=1

	call cg_base_read_f(cg, base, basename, CellDim, PhysDim, ier)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,300)'BaseName = "',basename,'"', &
                      'cell_dimension=',CellDim

! *** base attribute:  GOTO base node
	call cg_goto_f(cg, base, ier, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

! ***   base attribute:  Descriptor
	call cg_ndescriptors_f(ndescriptors, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,400)'Base Descriptor_t Information:'
        write(6,105) 'No. of descriptors=',ndescriptors

	do idescr=1, ndescriptors
          call cg_descriptor_read_f(idescr, name, text, ier)
          if (ier .eq. ERROR) call cg_error_exit_f
          if (ier.eq.ALL_OK) then
            write(6,500)' DescriptorName="',name,'"', &
                        ' DescriptorText="',text,'"'
          endif
	enddo

! *** read Zone
        call cg_nzones_f(cg, base, nzones, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,200)'nzones=',nzones

	zone = 1

	call cg_zone_read_f(cg, base, zone, zonename, size, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,104)'Name of Zone',zone,' is "',zonename,'"'

        call cg_zone_type_f(cg, base, zone, zonetype, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,600)'  Zone type is ', ZoneTypeName(zonetype)
	
        if (zonetype.eq.CGNS_ENUMV(Structured)) then
            IndexDim=CellDim
        else
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
            IndexDim=1
        endif

	write(6,104)'  IndexDimension=',IndexDim

! *** read GridConnectivity1to1_t's
        call cg_n1to1_f(cg, base, zone, nconns, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,113)nconns,' GridConnectivity1to1_t found for ', &
                   zonename

        do conn=1, nconns
            call cg_1to1_read_f(cg, base, zone, conn, connectname, &
               donorname, range, donor_range, transform, ier)
            if (ier .eq. ERROR) call cg_error_exit_f
            write(6, 101) &
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
              '  GridConnectivity1to1 #',conn,':', &
              '   connect name=',connectname, &
              '   donorname="',donorname,'"'

	    write(6,120) ' range: ', &
                 '(',range(1,1),',',range(2,1),',',range(3,1), &
                 ') to (',range(1,2),',',range(2,2),',',range(3,2),')'

                write(6,121)' donor_range: ', &
                '(', donor_range(1,1), ',', donor_range(2,1), ',', &
                  donor_range(3,1), ') to (', &
                  donor_range(1,2), ',', donor_range(2,2), ',', &
                  donor_range(3,2), ')'

                write(6,122) ' Transform: ', '(', &
                  transform(1), ',', &
                  transform(2), ',', transform(3), ')'

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
! *** read GridConnectivityProperty_t node

	    call cg_1to1_average_read_f(cg, base, zone, conn, &
      		AverageInterfaceType, ier)
!	    if (ier .ne. ALL_OK) call cg_error_print_f
	    if (ier .eq. ERROR) call cg_error_exit_f

	    if (ier .eq. ALL_OK) then
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	        write(6,600) '   AverageInterfaceTypeName= "', &
       		    AverageInterfaceTypeName(AverageInterfaceType),'"'
	    endif

	    call cg_1to1_periodic_read_f(cg, base, zone, conn, &
      		RotationCenter, RotationAngle, Translation, ier)
!           if (ier .ne. ALL_OK) call cg_error_print_f
	    if (ier .eq. ERROR) call cg_error_exit_f

            if (ier .eq. ALL_OK) then
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	 	write(6,110)'   RotationCenter=',RotationCenter(1), &
      				RotationCenter(2), RotationCenter(3)
                write(6,110)'   RotationAngle=',RotationAngle(1), &
                                RotationAngle(2), RotationAngle(3)
                write(6,110)'   Translation=',Translation(1), &
                                Translation(2), Translation(3)
	    endif

! *** read Descriptor_t & UserDefinedData_t under...
! ...   GridConnectivityProperty_t
            call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
      		'ZoneGridConnectivity_t', 1, 'GridConnectivity1to1_t',conn, &
      		'GridConnectivityProperty_t', 1, 'end')
!	    if (ier .ne. ALL_OK) call cg_error_print_f
	    if (ier .eq. ERROR) call cg_error_exit_f
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

            if (ier .eq. ALL_OK) then

                call cg_ndescriptors_f(ndescriptors, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'GridConnProperty Descriptor_t Information:'
                write(6,105) 'No. of descriptors=',ndescriptors
                do idescr=1, ndescriptors
                    call cg_descriptor_read_f(idescr, name, text, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' DescriptorName="',name,'"', &
                                 ' DescriptorText="',text,'"'
                enddo

                call cg_nuser_data_f(nuser_data, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'GridConnProperty User Data Information:'
                write(6,105) 'No. of UserData=',nuser_data
                do n=1, nuser_data
                    call cg_user_data_read_f(n, user_data_name, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' user_data_name="',user_data_name,'"'
                enddo

	    endif

! ...   AverageInterface_t
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
            call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
       		'ZoneGridConnectivity_t', 1, &
                'GridConnectivity1to1_t', conn, &
      		'GridConnectivityProperty_t', 1, 'AverageInterface_t', &
      		1, 'end')
!	    if (ier .ne. ALL_OK) call cg_error_print_f
	    if (ier .eq. ERROR) call cg_error_exit_f

            if (ier .eq. ALL_OK) then

                call cg_ndescriptors_f(ndescriptors, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'AverageInterface Descriptor_t Information:'
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
                write(6,105) 'No. of descriptors=',ndescriptors
                do idescr=1, ndescriptors
                    call cg_descriptor_read_f(idescr, name, text, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' DescriptorName="',name,'"', &
                                 ' DescriptorText="',text,'"'
                enddo

                call cg_nuser_data_f(nuser_data, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'AverageInterface User Data Information:'
                write(6,105) 'No. of UserData=',nuser_data
                do n=1, nuser_data
                    call cg_user_data_read_f(n, user_data_name, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' user_data_name="',user_data_name,'"'
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
                enddo

            endif

! ...   Periodic_t
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
            call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
      		'ZoneGridConnectivity_t', 1, &
      	        'GridConnectivity1to1_t', conn, &
      		'GridConnectivityProperty_t', 1, 'Periodic_t', 1, 'end')
!           if (ier .ne. ALL_OK) call cg_error_print_f
	    if (ier .eq. ERROR) call cg_error_exit_f

            if (ier .eq. ALL_OK) then

                call cg_ndescriptors_f(ndescriptors, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'Periodic Descriptor_t Information:'
                write(6,105) 'No. of descriptors=',ndescriptors
                do idescr=1, ndescriptors
                    call cg_descriptor_read_f(idescr, name, text, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' DescriptorName="',name,'"', &
                                 ' DescriptorText="',text,'"'
                enddo

                call cg_nuser_data_f(nuser_data, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'Periodic User Data Information:'
                write(6,105) 'No. of UserData=',nuser_data
                do n=1, nuser_data
                    call cg_user_data_read_f(n, user_data_name, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' user_data_name="',user_data_name,'"'
                enddo

! * Read DataClass & DimensionalUnits under RotationCenter
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
		call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
      		    'ZoneGridConnectivity_t', 1, &
                    'GridConnectivity1to1_t', conn, &
                    'GridConnectivityProperty_t', 1, &
      		    'Periodic_t', 1, 'DataArray_t', 1, 'end')

		call cg_dataclass_read_f(type,ier)
		if (ier .eq. ERROR) call cg_error_exit_f
		write(6,600)'DataClassName=',DataClassName(type)

        	call cg_units_read_f(mass, length, time, temp, deg, ier)
        	if (ier .eq. ERROR) call cg_error_exit_f
        	if (ier .eq. ALL_OK) then
          	    write(6,100) &
            	    'SurfacePeriodic Dimensional Units:', &
            	    MassUnitsName(mass), LengthUnitsName(length), &
            	    TemperatureUnitsName(temp), TimeUnitsName(time), &
            	    AngleUnitsName(deg)
        	endif

            endif

	enddo ! conn loop

! Close file
        call cg_close_f(cg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

 100 	format(a/,'    Mass units: ',a/,'    Length units: ',a/, &
          '    Temperature units: ',a/,'    Time units: ',a/, &
          '    Angle units:',a)
 101    format(a,i1,a,/2a,/2a,/2a,/3a,/a,i4,3a,/2a,/2a,/2a,/a,i4)
 102 	format(a,f8.3)
 103    format(a,6i2)
 104    format(a,i5,3a)
 105	format(a,i2,a)
 110    format(a,5f5.1)
 113    format(i1,3a)
 119    format(a/a,3i2/a,3i2)
 120	format(a10, 3(a1,i1),a6,3(i1,a1))
 121 	format(a16,3(a1,i1),a6,3(i1,a1))
 122	format(a12,3(a1,i2),a1)
 200    format(a,i5)
 300	format(3a/a,i2)
 400	format(/a/)
 500	format(3a/3a)
 600	format(3a)

        END PROGRAM read_cprop

      program write_con2zn_str
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Opens an existing CGNS file that contains a simple 3-D
!   structured grid (2 zones), and adds 1-to-1
!   connectivity information to it.
!
!   The CGNS grid file 'grid.cgns' must already exist
!   (created using write_grid2zn_str.f)
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c write_con2zn_str.F90
!   ifort -o write_con2zn_str write_con2zn_str.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
      integer ilo(2),ihi(2),jlo(2),jhi(2),klo(2),khi(2)
      integer itranfrm(3)
      integer index_conn,n1to1,nconns,nzone
      integer index_zone,index_base,index_file,ier
      integer(cgsize_t) isize(3,3),ipnts(3,2),ipntsdonor(3,2)
      character donorname*32,zonename(2)*32
!
      write(6,'('' Program write_con2zn_str'')')
      if (CG_BUILD_64BIT) then
        write(6,'('' ...using 64-bit mode for particular integers'')')
      end if
!
!  WRITE 1-TO-1 CONNECTIVITY INFORMATION TO EXISTING CGNS FILE
!  open CGNS file for modify
      call cg_open_f('grid.cgns',CG_MODE_MODIFY,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!  we know there is only one base (real working code would check!)
      index_base=1
!   get number of zones (should be 2 for our case)
      call cg_nzones_f(index_file,index_base,nzone,ier)
      if (nzone .ne. 2) then
         write(6,'('' Error.  This program expects 2 zones. '',i5,             &
          '' read'')') nzone
         stop
      end if
!   loop over zones to get zone sizes and names
      do index_zone=1,nzone
        call cg_zone_read_f(index_file,index_base,index_zone,                  &
             zonename(index_zone),isize,ier)
        ilo(index_zone)=1
        ihi(index_zone)=isize(1,1)
        jlo(index_zone)=1
        jhi(index_zone)=isize(2,1)
        klo(index_zone)=1
        khi(index_zone)=isize(3,1)
      enddo
!   loop over zones again
      do index_zone=1,nzone
!   for this program, there should be no existing connectivity info:
        call cg_nconns_f(index_file,index_base,index_zone,nconns,ier)
        if (nconns .ne. 0) then
          write(6,'('' Error.  This program expects no interfaces'',           &
            '' yet.'',i5,'' read'')') nconns
          stop
        end if
        call cg_n1to1_f(index_file,index_base,index_zone,n1to1,ier)
        if (n1to1 .ne. 0) then
          write(6,'('' Error.  This program expects no interfaces'',           &
            '' yet.'',i5,'' read'')') n1to1
          stop
        end if
!   set up index ranges
        if (index_zone .eq. 1) then
          donorname=zonename(2)
!   lower point of receiver range
          ipnts(1,1)=ihi(1)
          ipnts(2,1)=jlo(1)
          ipnts(3,1)=klo(1)
!   upper point of receiver range
          ipnts(1,2)=ihi(1)
          ipnts(2,2)=jhi(1)
          ipnts(3,2)=khi(1)
!   lower point of donor range
          ipntsdonor(1,1)=ilo(2)
          ipntsdonor(2,1)=jlo(2)
          ipntsdonor(3,1)=klo(2)
!   upper point of donor range
          ipntsdonor(1,2)=ilo(2)
          ipntsdonor(2,2)=jhi(2)
          ipntsdonor(3,2)=khi(2)
        else
          donorname=zonename(1)
!   lower point of receiver range
          ipnts(1,1)=ilo(2)
          ipnts(2,1)=jlo(2)
          ipnts(3,1)=klo(2)
!   upper point of receiver range
          ipnts(1,2)=ilo(2)
          ipnts(2,2)=jhi(2)
          ipnts(3,2)=khi(2)
!   lower point of donor range
          ipntsdonor(1,1)=ihi(1)
          ipntsdonor(2,1)=jlo(1)
          ipntsdonor(3,1)=klo(1)
!   upper point of donor range
          ipntsdonor(1,2)=ihi(1)
          ipntsdonor(2,2)=jhi(1)
          ipntsdonor(3,2)=khi(1)
        end if
!   set up Transform
        itranfrm(1)=1
        itranfrm(2)=2
        itranfrm(3)=3
!   write 1-to-1 info (user can give any name)
        call cg_1to1_write_f(index_file,index_base,index_zone,                 &
             'Interface',donorname,ipnts,ipntsdonor,itranfrm,                  &
             index_conn,ier)
      enddo
!  close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully added 1-to-1 connectivity info to'',           &
       '' file grid.cgns'')')
      stop
      end

	program write_gravity
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on May 31 2002

!       This example test the Gravity_t data structure and its children

#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 3)
	integer index_dim, cell_dim, phys_dim
	integer cg, base_no, ier
	real*4 gravity_vector(Ndim)
	character*100 linkpath

! *** initialize
	ier = 0
	index_dim=Ndim
	cell_dim=Ndim
	phys_dim=Ndim

! *** open CGNS file for writing
 	call cg_open_f('Test_V2', MODE_WRITE, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f

! *** base
 	call cg_base_write_f(cg, 'Basename', cell_dim, phys_dim,
     &                       base_no, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f

! *** write a descriptor under the base
        call cg_goto_f(cg, base_no, ier, 'end')
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_descriptor_write_f('BaseDescriptorName',
     &      'BaseDescriptorText', ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** write Gravity_t node
	gravity_vector(1)=0
	gravity_vector(2)=0
	gravity_vector(3)=9.8
	call cg_gravity_write_f(cg, base_no, gravity_vector, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** write children of Gravity_t
	call cg_goto_f(cg, base_no, ier, 'Gravity_t', 1, 'end')
	if (ier .eq. ERROR) call cg_error_exit_f

! * Descriptor
	call cg_descriptor_write_f('GravityDescriptorName',
     &       'GravityDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * DataClass
        call cg_dataclass_write_f(Dimensional, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! * DimensionalUnits
	call cg_units_write_f(Kilogram, Meter, Second, Kelvin,
     &                        Radian, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! * UserDefinedData
        call cg_user_data_write_f('UserData1', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * Link to BaseDescriptorName
        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! *** close CGNS file
	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	end

	program read_udata
	USE CGNS
	implicit none

! This program reads a 3D mesh, structured or unstructured.
!
!
! Test1 example modified for Version 2.1 UserDefinedData_t extensions.
! Don Leich, Intelligent Light  30-Nov-01

#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim, Nglobal
	integer i, narrays, iarray, nintegrals, integral
	integer ndescriptors, idescr, nzonetype
	integer(cgsize_t) nptsets
	integer ndonor_ptset_type, idataset, dirichletflag, neumannflag
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	parameter (Ndim = 3)
	parameter (Nglobal = 500)
	integer IndexDim, CellDim, PhysDim
	integer ier, n, zonetype
	integer nbases, nzones
	integer(cgsize_t) size(Ndim*3), DataSize(Ndim)
	integer ncoords, type, nsols, nfields, location
	integer nholes, nconns, n1to1, n1to1_global, nbocos
	integer ptset_type
        integer(cgsize_t) npnts, pnts(100000), donor_pnts(100000)
        integer donor_datatype, bocotype, datatype
	integer(cgsize_t) npnts_donor
	character*32 basename, zonename, solname, fieldname
	character*32 coordname, holename, connectname
	character*32 boconame, donorname
	integer cg, base, zone, coord, sol, field, discr
	integer hole, conn, one21, boco
	integer(cgsize_t) rmin(3)
	integer(cgsize_t) range(Ndim, 2), donor_range(Ndim, 2)
 	integer transform(Ndim)
  	integer(cgsize_t) G_range(Ndim*2, Nglobal)
	integer(cgsize_t) G_donor_range(Ndim*2, Nglobal)
	integer G_transform(Ndim, Nglobal)
	character*32 G_connectname(Nglobal), G_zonename(Nglobal)
	character*32 G_donorname(Nglobal)
	character*32 name, filename
	character*40 text, NormDefinitions, StateDescription
	integer equation_dimension, GoverningEquationsFlag
	integer GasModelFlag, ViscosityModelFlag
	integer ThermalConductivityModelFlag
	integer TurbulenceClosureFlag, TurbulenceModelFlag
	integer diffusion_model(6), niterations
	integer nndim, rind(6), ndiscrete, num
	integer(cgsize_t) dim_vals(12)
	integer mass, length, time, temp, deg
	integer NormalIndex(3), ndataset
	integer(cgsize_t) NormalListFlag
	real*4 data_single(100000)
	double precision data_double(100000)
	real*4 version
	integer nuser_data
	character*32 user_data_name


! *** open file
!	write(6,*) 'Input filename'
!	read(5,600) filename
	write(filename,'(a)')'Test_V2'
	call cg_open_f(filename, MODE_READ, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,600)'READING FILE ',filename

! *** CGNS Library Version used for file creation (version must be real*4):
	call cg_version_f(cg, version, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,102)
     &     'Library Version used for file creation:',version

! *** base
	call cg_nbases_f(cg, nbases, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,200)'nbases=',nbases

	do base=1, nbases

	  call cg_base_read_f(cg, base, basename, CellDim, PhysDim, ier)
	  if (ier .eq. ERROR) call cg_error_exit_f
	  write(6,300)'BaseName = "',basename,'"',
     &                'cell_dimension=',CellDim

! *** base attribute:  GOTO base node
	  call cg_goto_f(cg, base, ier, 'end')
          if (ier .eq. ERROR) call cg_error_exit_f

! ***     base attribute:  Descriptor
          call cg_descriptor_read_f(1, name, text, ier)
          if (ier .eq. ERROR) call cg_error_exit_f
          if (ier.eq.ALL_OK) then
            write(6,400)'Base Descriptor_t Information:'
            write(6,500)' DescriptorName="',name,'"',
     &                  ' DescriptorText="',text,'"'
          endif

! ***     base attribute: flow equation set:
	  call cg_equationset_read_f(equation_dimension,
     &      GoverningEquationsFlag,  GasModelFlag,
     &      ViscosityModelFlag, ThermalConductivityModelFlag,
     &      TurbulenceClosureFlag,  TurbulenceModelFlag, ier)
	  if (ier .eq. ERROR) then
	    call cg_error_exit_f
	  elseif (ier .eq. NODE_NOT_FOUND) then
	    write(6,200)
     &      'FlowEquationSet_t not defined under CGNSBase_t #',base
	  elseif (ier .eq. INCORRECT_PATH) then
  	    write(6,400)'Incorrect path input to cg_goto_f'
	  else
	    write(6,400) 'FlowEquationSet_t Information:'
	    write(6,100)' equation_dimension=',equation_dimension

! ***       flow equation set attributes:  GOTO FlowEquationSet_t node
            call cg_goto_f(cg, base, ier, 'FlowEquationSet_t', 1, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f

! ***       flow equation set attribute: Descriptor
            call cg_descriptor_read_f(1, name,text,ier)
            if (ier .eq. ERROR) call cg_error_exit_f
            if (ier .eq. ALL_OK) write(6,500)
     &        ' DescriptorName="',name,'"',' DescriptorText="',text,'"'

! ***       flow equation set attribute: Gas Model Type
	    if (GasModelFlag.eq.1) then
                call cg_model_read_f('GasModel_t', type, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                if (ier .eq. ALL_OK) write(6,600)
     &            ' GasModelType="',ModelTypeName(type),'"'
            endif

! ***       flow equation set attribute: ViscosityModel Type
            if (ViscosityModelFlag.eq.1) then
              call cg_model_read_f('ViscosityModel_t', type, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              if (ier .eq. ALL_OK) write(6,600)
     &          ' ViscosityModelType="',ModelTypeName(type),'"'
            endif

! ***       flow equation set attribute:  TypmlConductivityModel Type
            if (ThermalConductivityModelFlag.eq.1) then
              call cg_model_read_f('ThermalConductivityModel_t',
     &                  type, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              if (ier .eq. ALL_OK) write(6,600)
     &          ' ThermalConductivityModelType=',
     &            ModelTypeName(type),'"'
            endif

! ***   flow equation set attribute: TurbulenceClosureType
            if (TurbulenceClosureFlag.eq.1) then
              call cg_model_read_f('TurbulenceClosure_t', type, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              if (ier .eq. ALL_OK) write(6,600)
     &          ' TurbulenceClosureType="', ModelTypeName(type),'"'
            endif

! ***   flow equation set attribute: TurbulenceModelType
            if (TurbulenceModelFlag.eq.1) then
              call cg_model_read_f('TurbulenceModel_t', type, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              if (ier .eq. ALL_OK) write(6,600)
     &          ' TurbulenceModelType="',ModelTypeName(type),'"'
            endif

! ***   flow equation set attribute: Governing Equations Type
            if (GoverningEquationsFlag .eq. 1) then
              call cg_governing_read_f(type, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              if (ier.eq.ALL_OK)
     &          write(6,600)' GoverningEquationsType="',
     &                          GoverningEquationsTypeName(type),'"'

    	! *** Governing Equations attribute:  GOTO GoverningEquations_t node
	      call cg_goto_f(cg,base,ier, 'FlowEquationSet_t', 1,
     &            'GoverningEquations_t',1,'end')
	      if (ier .eq. ERROR) call cg_error_exit_f


        ! *** Governing Equations attribute:  Diffusion model
	      call cg_diffusion_read_f(diffusion_model, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      if (ier.eq.ALL_OK)write(6,103)'   Diffusion model=',
     &                           (diffusion_model(i), i=1,6)
            endif       ! If Governing Equations are defined
	  endif		! If FlowEquationSet_t exists under CGNSBase_t


	  write(6,400)'                              *     *     *'

	  call cg_nzones_f(cg, base, nzones, ier)
	  if (ier .eq. ERROR) call cg_error_exit_f
	  write(6,200)'nzones=',nzones

! *** zone
	  do zone=1, nzones
	    call cg_zone_read_f(cg, base, zone, zonename, size, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
	    write(6,104)'Name of Zone',zone,' is "',zonename,'"'

	    call cg_zone_type_f(cg, base, zone, zonetype, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
	    write(6,600)'  Zone type is ', ZoneTypeName(zonetype)


	    if (zonetype.eq.Structured) then
		IndexDim=CellDim
	    else
		IndexDim=1
	    endif


	    write(6,104)'  IndexDimension=',IndexDim

      ! *** zone attribute:  GOTO zone node
	    call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'end')
	    if (ier .eq. ERROR) call cg_error_exit_f

      ! *** zone attribute:  ordinal
	    call cg_ordinal_read_f(num, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
	    if (ier .eq. ALL_OK)
     &          write(6,200)' Zone ordinal=',num


      ! *** zone attribute:  convergence history
	    call cg_convergence_read_f(niterations,
     &            NormDefinitions, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

	    if (ier .eq. ALL_OK) then
	      write(6,600)'Convergence History of ',zonename
	      write(6,104) ' niterations=',niterations,
     &                     ' NormDefinitions="',NormDefinitions,'"'

         ! ** ConvergenceHistory_t attributes:
	      call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &                      'ConvergenceHistory_t', 1, 'end')
	      if (ier .eq. ERROR) call cg_error_exit_f

         ! ** ConvergenceHistory_t attributes: DataArray_t
	      call cg_narrays_f(narrays, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      write(6,105) 'ConvergenceHistory_t contains ',
     &                      narrays,' array(s)'
	      do iarray=1, narrays
                call cg_array_info_f(iarray, name, datatype,
     &                             nndim, dim_vals, ier)
                if (ier .eq. ERROR) call cg_error_exit_f

	        write(6,600) ' DataArrayName="',name,'"'
	        write(6,600) ' DataType="',DataTypeName(datatype),'"'
	        write(6,200) ' DataNdim=',nndim
	        write(6,200) ' DataDim=',dim_vals(1)

	        write(6,105) ' Data:'
	        if (datatype .eq. RealSingle) then
	          call cg_array_read_f(iarray, data_single, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
	          write(6,106) (data_single(n),n=1,dim_vals(1))
	        elseif (datatype .eq. RealDouble) then
		  call cg_array_read_f(iarray, data_double, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
	 	  write(6,106) (data_double(n),n=1,dim_vals(1))
	        endif
	      enddo

         ! ** ConvergenceHistory_t attributes: DataClass_t
	      call cg_dataclass_read_f(type,ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      write(6,600)'DataClassName=',DataClassName(type)

         ! ** ConvergenceHistory_t attributes: DimensionalUnits_t
	      call cg_units_read_f(mass, length, time, temp, deg, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      if (ier .eq. ALL_OK) then
	        write(6,100)
     &	 	  'Dimensional Units:',
     &            MassUnitsName(mass), LengthUnitsName(length),
     &            TemperatureUnitsName(temp), TimeUnitsName(time),
     &            AngleUnitsName(deg)
	      endif
	    endif
            write(6,400)'                             *     *     *'

! *** zone attribute:  return to Zone_t node
	    call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'end')
	    if (ier .eq. ERROR) call cg_error_exit_f
	    write(6,401)'Integral Data Information of ',zonename

	    call cg_nintegrals_f(nintegrals, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
	    write(6,107) nintegrals, ' IntegralData_t node in ',
     &                    zonename

! *** zone attribute:  IntegralData_t
	    do integral=1, nintegrals
	      call cg_integral_read_f(integral, name, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      write(6,104) 'IntegralData_t #',integral,
     &                             ' is named "', name,'"'

        ! *** IntegralData_t attribute:  GOTO IntegralData_t node
	      call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &                       'IntegralData_t', integral, 'end')
              if (ier .eq. ERROR) call cg_error_exit_f

	      call cg_narrays_f(narrays, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
              write(6,108) 'IntegralData_t #',integral,
     &                     ' contains ', narrays,' data'

	      do iarray=1, narrays

          ! *** IntegralData_t attribute: DataArray_t
                call cg_array_info_f(iarray, name, datatype,
     &                               nndim, dim_vals, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,600) ' DataArrayName="',name,'"'
                write(6,600) ' DataType=',DataTypeName(datatype)
                write(6,108) ' DataNdim=',nndim,
     &                       ', DataDim=',dim_vals(1)

                if (datatype .eq. RealSingle) then
                  call cg_array_read_f(iarray, data_single, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
                  write(6,109) ' integraldata=',data_single(1)
                elseif (datatype .eq. RealDouble) then
                  call cg_array_read_f(iarray, data_double, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
                  write(6,109) 'integraldata=',data_double(1)
                endif

	  ! *** DattaArray_t attribute: GOTO DataArray_t
		call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &                         'IntegralData_t', integral,
     &                         'DataArray_t', iarray, 'end')
                if (ier .eq. ERROR) call cg_error_exit_f


          ! *** DattaArray_t attribute: DimensionalExponents_t
	        call cg_exponents_info_f(datatype, ier)
                if (ier .eq. ERROR) then
	          call cg_error_exit_f
	        elseif (ier .eq. ALL_OK) then
		  write(6,600)' Datatype for exponents is ',
     &               DataTypeName(datatype)
                  if (datatype .eq. RealSingle) then
	            call cg_exponents_read_f(data_single, ier)
		    if (ier .eq. ERROR) call cg_error_exit_f
		    write(6,110)' Exponents:',(data_single(n),n=1,5)
                  elseif (datatype .eq. RealDouble) then
                    call cg_exponents_read_f(data_double, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,110)' Exponents:',(data_double(n),n=1,5)
                  endif
	        endif

          ! *** DattaArray_t attribute: DataConversion_t
	        call cg_conversion_info_f(datatype, ier)
                if (ier .eq. ERROR) then
		  call cg_error_exit_f
                elseif (ier .eq. ALL_OK) then
		  write(6,600)' Datatype for conversion is ',
     &               DataTypeName(datatype)
                  if (datatype .eq. RealSingle) then
                    call cg_conversion_read_f(data_single, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,110)' Conversion:',(data_single(n),n=1,2)
                  elseif (datatype .eq. RealDouble) then
                    call cg_conversion_read_f(data_double, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,110)' Conversion:',(data_double(n),n=1,2)
                  endif
		endif

	      enddo	! loop through DataArray_t
	    enddo	! loop through IntegralData_t

            write(6,400)'                             *     *     *'

      ! *** zone coordinate attribute:  GOTO GridCoordinates_t node
            call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &            'GridCoordinates_t', 1, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f
	    if (ier .eq. ALL_OK) then

        ! *** GridCoordinates_t attribute: dimensional units
              call cg_units_read_f(mass, length, time, temp, deg, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
	      if (ier .eq. ALL_OK) write(6,400)
     &            'Dimensional Units for GridCoordinates_t: ',
     &            LengthUnitsName(length)

	! *** GridCoordinates_t attribute:  Rind
              call cg_rind_read_f(rind, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              write(6,103)'GC Rind Data is ',(rind(i),i=1,6)

        ! *** coordinate array
	      call cg_narrays_f(narrays, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
              write(6,105) 'GridCoordinates_t contains ',
     &                            narrays,' arrays'
	      do iarray=1,narrays

		call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &            'GridCoordinates_t', 1, 'end')
                if (ier .eq. ERROR) call cg_error_exit_f

	  ! *** GridCoordinates_t attribute: DataArray_t
                call cg_array_info_f(iarray, name, datatype,
     &                               nndim, dim_vals, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,600)' DataArrayName="',name,'"'
                write(6,600)' DataType=',DataTypeName(datatype)
                write(6,104)' DataNdim=',nndim
		do i=1,nndim
                  write(6,111)' DataDim(',i,')=',dim_vals(i)
		enddo

	  ! *** Compute nr of data in data array:
	   	num = 1
		do i=1,nndim
		  num = num*dim_vals(i)
		enddo

                if (datatype .eq. RealSingle) then
                  call cg_array_read_f(iarray, data_single, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
                  write(6,106) (data_single(i),i=1,2)
                  write(6,106) (data_single(i),i=num-1,num)
                elseif (datatype .eq. RealDouble) then
                  call cg_array_read_f(iarray, data_double, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
                  write(6,106) (data_double(i),i=1,2)
                  write(6,106) (data_double(i),i=num-1,num)
                endif

          ! *** coordinate attribute:  GOTO coordinate array node
                call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &          'GridCoordinates_t', 1, 'DataArray_t', iarray, 'end')
                if (ier .eq. ERROR) call cg_error_exit_f

                call cg_ndescriptors_f(ndescriptors, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,105) 'No. of descriptors=',ndescriptors
                do idescr=1, ndescriptors
                  call cg_descriptor_read_f(idescr, name, text, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
                  write(6,500) ' DescriptorName="',name,'"',
     &                               ' DescriptorText="',text,'"'
                enddo

	      enddo	! loop through data arrays

        ! *** read coordinates using coordinate arrays' specific functions:

	      write(6,400)'Specific functions to read coordinates arrays'
	      call cg_ncoords_f(cg, base, zone, ncoords, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      write(6,103)'no. of coordinates=',ncoords

	 ! ** Compute the nr of data to be read
              do i=1,IndexDim
                rmin(i)=1
                DataSize(i)=size(i) + rind(2*i-1) + rind(2*i)
              enddo

	      do coord=1, ncoords
	  	call cg_coord_info_f(cg, base, zone, coord, datatype,
     &                               coordname, ier)
		if (ier .eq. ERROR) call cg_error_exit_f
 		write(6,112)'coord #',coord,
     &            '   datatype=',DataTypeName(datatype),
     &            '   name="',coordname,'"'

                if (datatype .eq. RealSingle) then
        	    call cg_coord_read_f(cg, base, zone, coordname,
     &                  RealSingle, rmin, DataSize, data_single, ier)
        	    if (ier .eq. ERROR) call cg_error_exit_f

                elseif (datatype .eq. RealDouble) then
                    call cg_coord_read_f(cg, base, zone, coordname,
     &                  RealDouble, rmin, DataSize, data_double, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                endif
	      enddo
	    endif 	! if GridCoordinates_t exists

            write(6,400)'                             *     *     *'

! *** solution

	    call cg_nsols_f(cg, base, zone, nsols, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
	    write(6,113) nsols,' FlowSolution_t node(s)',
     &              'found for ',zonename

      ! *** Read solution with general cg_array_read function
	    do sol=1, nsols
	      call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &            'FlowSolution_t', sol, 'end')
	      if (ier .eq. ERROR) call cg_error_exit_f

	! *** FlowSolution_t attribute:  DataArray_t
	      call cg_narrays_f(narrays, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
              write(6,108) ' FlowSolution_t #',sol,
     &              ' contains ',narrays,' solution arrays'

	! *** FlowSolution_t attribute:  GridLocation
	      call cg_gridlocation_read_f(location, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      write(6,600)'  The solution data are recorded at the ',
     &                 GridLocationName(location)

	! *** FlowSolution_t attribute:  Rind
	      call cg_rind_read_f(rind, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
	      write(6,103)'  The Rind Data is ',(rind(i),i=1,6)

              do iarray=1,narrays
	        call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &            'FlowSolution_t', sol, 'end')
                if (ier .eq. ERROR) call cg_error_exit_f

                call cg_array_info_f(iarray, name, datatype,
     &                               nndim, dim_vals, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
	        write(6,114) '  DataArray #',iarray
                write(6,600) '   Name="',name,'"'
                write(6,600) '   DataType=',DataTypeName(datatype)
                write(6,103) '   DataNdim=',nndim
                do i=1,nndim
                  write(6,111)'   DataDim(',i,')=',dim_vals(i)
                enddo

	 ! *** For dynamic memory allocation, compute the number of data to be read:
                num = 1
                do i=1,nndim
                    num = num*dim_vals(i)
                enddo
                write(6,200) 'Nr of data in solution vector=',num

                if (datatype .eq. RealSingle) then
                  call cg_array_read_f(iarray, data_single, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
                  !write(6,106) (data_single(i),i=1,num)
                elseif (datatype .eq. RealDouble) then
                  call cg_array_read_f(iarray, data_double, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
                  !write(6,106) (data_double(i),i=1,num)
                endif

          ! *** solution field attribute:  GOTO solution array node
                call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &          'FlowSolution_t',sol,'DataArray_t',iarray,'end')
                    if (ier .eq. ERROR) call cg_error_exit_f

          ! *** solution field attribute:  DimensionalUnits
                call cg_units_read_f(mass, length, time, temp,
     &                   deg, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                if (ier .eq. ALL_OK) then
                write(6,100)
     &		  '   Dimensional Units:',
     &            MassUnitsName(mass), LengthUnitsName(length),
     &            TemperatureUnitsName(temp), TimeUnitsName(time),
     &            AngleUnitsName(deg)
                endif

	      enddo	! loop through DataArray_t
	      write(6,103)' '

      ! *** Reading solution data with solution specific functions:
              call cg_sol_info_f(cg, base, zone, sol, solname,
     &                           location, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              write(6,115)'sol #',sol,':',
     &           '   solname="',solname,'"',
     &           '   location=',GridLocationName(location)

        ! *** Compute the nr of data to be read
! ici

              if (zonetype.eq.Structured) then
                do i=1,3
                  DataSize(i)=size(i) + rind(2*i-1) + rind(2*i)
                  if (location.eq.CellCenter) DataSize(i)=DataSize(i)-1
                enddo
              else
                DataSize(1)=size(2)
              endif

        ! *** solution field
              call cg_nfields_f(cg, base, zone, sol, nfields, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              write(6,105)'  nfields=',nfields

              do field=1, nfields
                call cg_field_info_f(cg, base, zone, sol, field,
     &                               type, fieldname, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,115)'  field #',field,':',
     &                    '   fieldname="',fieldname,'"',
     &                    '   datatype=',DataTypeName(type)

          ! *** read entire range of solution data and record in double precision
                call cg_field_read_f(cg, base, zone, sol, fieldname,
     &              RealDouble, rmin, DataSize, data_double, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
              enddo                             ! field loop

            enddo	! loop through FlowSolution_t

            write(6,400)'                             *     *     *'

! *** discrete data under zone
	    call cg_ndiscrete_f(cg, base, zone, ndiscrete, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
	    if (ier .eq. ALL_OK) write(6,113)ndiscrete,
     &        ' DiscreteData_t node(s) found under ',zonename

	    do discr=1, ndiscrete
	      call cg_discrete_read_f(cg, base,zone, discr, name, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      write(6,600)' name=',name

        ! *** discrete data attribute:  GOTO DiscreteData_t node
	      call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &                'DiscreteData_t',  discr, 'end')
	      if (ier .eq. ERROR) call cg_error_exit_f

        ! *** discrete data attribute:  GridLocation_t
	      call cg_gridlocation_read_f(location, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      if (ier .eq. ALL_OK) write(6,600)
     &           ' The location of the DiscreteData vector is ',
     &                 GridLocationName(location)

        ! *** get user defined data info:
              call cg_nuser_data_f(nuser_data, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f

	      call cg_user_data_read_f(1, user_data_name, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f

        ! *** discrete data attribute:  GOTO DiscreteData_t/UserDefinedData_t node
	      call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &                'DiscreteData_t',  discr,
     &                'UserDefinedData_t', 1, 'end')
	      if (ier .eq. ERROR) call cg_error_exit_f

  	! *** discrete data arrays:
              call cg_narrays_f(narrays, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              write(6,134) user_data_name,' DiscreteData #', discr,
     &                         ' contains ', narrays,' arrays'
	      do iarray=1, narrays
	        call cg_array_info_f(iarray, name, datatype,
     &                              nndim, dim_vals, ier)
                if (ier .eq. ERROR) call cg_error_exit_f

		write(6,116) 'DataArray #',iarray,':'
	        write(6,600)'  Name =',name
		write(6,600)'  Datatype=',
     &            DataTypeName(datatype)

	  ! *** compute nr of data to be read
		num=1
		do n=1, nndim
		  num=num*dim_vals(n)
		enddo

                if (datatype .eq. RealSingle) then
                  call cg_array_read_f(iarray, data_single, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
                  !write(6,*) (data_single(n),n=1,num)
                elseif (datatype .eq. RealDouble) then
                  call cg_array_read_f(1, data_double, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
                  !write(6,*) (data_double(n),n=1,num)
                endif

          ! *** discrete data arrays attribute: GOTO UserDefinedData/DataArray node
                call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &            'DiscreteData_t', discr,
     &            'UserDefinedData_t', 1,
     &            'DataArray_t', iarray, 'end')
	        if (ier .eq. ERROR) call cg_error_exit_f

	        call cg_units_read_f(mass, length, time, temp, deg, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
		if (ier .eq. ALL_OK) then
                  write(6,100)
     &		    '  Dimensional Units for UserDefinedData_t/DiscreteData_t:',
     &              MassUnitsName(mass), LengthUnitsName(length),
     &              TemperatureUnitsName(temp), TimeUnitsName(time),
     &              AngleUnitsName(deg)
                endif
	      enddo		! loop through DataArray_t
	    enddo

            write(6,400)'                             *     *     *'

! *** Interblock Connectivity:
	    write(6,401)'Interblock Connectivity for ',zonename

! *** ZoneGridConnectivity attributes:  GOTO ZoneGridConnectivity_t node
            call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &         'ZoneGridConnectivity_t', 1, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f

	    if (ier.eq. ALL_OK) then
! *** ZoneGridConnectivity attributes: Descriptor_t
              call cg_ndescriptors_f(ndescriptors, ier)
              if (ier .ne. 0) call cg_error_exit_f
              write(6,117)
     &        ndescriptors, ' descriptors for ZoneGridConnectivity_t'
              do idescr=1, ndescriptors
                call cg_descriptor_read_f(idescr, name, text, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,500) '     DescriptorName="',name,'"',
     &                             '     DescriptorText="',text,'"'
              enddo


        ! *** overset holes
	      call cg_nholes_f(cg, base, zone, nholes, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      write(6,107) nholes, ' holes found'

	      do hole=1, nholes
	        call cg_hole_info_f(cg, base, zone, hole, holename,
     &             location, ptset_type, nptsets, npnts, ier)
	        if (ier .eq. ERROR) call cg_error_exit_f
	        write(6,118)
     &	      	  '  hole #',hole,':', '   holename="',holename,'"',
     &            '   data location=',GridLocationName(location),
     &            '   nptsets = ',nptsets,
     &            ', total no. of points =',npnts

	        if (npnts .lt. 30000) then
	 	  call cg_hole_read_f(cg, base, zone, hole, pnts, ier)
	  	  if (ier .eq. ERROR) call cg_error_exit_f
	        endif

          ! *** overset holes attributes:  GOTO OversetHoles_t node
	        call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &             'ZoneGridConnectivity_t', 1,
     &             'OversetHoles_t', hole, 'end')
                if (ier .ne. 0) call cg_error_exit_f

	        call cg_ndescriptors_f(ndescriptors, ier)
	        if (ier .ne. 0) call cg_error_exit_f
	        write(6,117)
     &            ndescriptors, ' descriptors for ',holename
                do idescr=1, ndescriptors
                  call cg_descriptor_read_f(idescr, name, text, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f
                  write(6,500) '     DescriptorName="',name,'"',
     &                               '     DescriptorText="',text,'"'
                enddo
	      enddo	!hole loop



! *** general connectivity
	      call cg_nconns_f(cg, base, zone, nconns, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              write(6,107) nconns,' GridConnectivity_t found'

	      do conn=1, nconns
                call cg_conn_info_f(cg, base, zone, conn, connectname,
     &             location, type, ptset_type, npnts, donorname,
     &             nzonetype, ndonor_ptset_type, donor_datatype,
     &             npnts_donor, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
	        write(6, 101)
     &            '  GridConnectivity #',conn,':',
     &            '   connect name=',connectname,
     &            '   Grid location=',GridLocationName(location),
     &            '   Connect-type=',GridConnectivityTypeName(type),
     &            '   ptset type="',PointSetTypeName(ptset_type),'"',
     &            '   npnts=',npnts,'   donorname="',donorname,'"',
     &            '   donor zonetype=',ZoneTypeName(nzonetype),
     &            '   donor ptset type=',
     &                PointSetTypeName(ndonor_ptset_type),
     &            '   DonorDatatype=',DataTypeName(donor_datatype),
     &            '   npnts_donor=',npnts_donor


                call cg_conn_read_f(cg, base, zone, conn, pnts, Integer,
     &                            donor_pnts, ier)
                if (ier .eq. ERROR) call cg_error_exit_f

	        write(6,119) '   Current zone:',
     &           '    first point:', pnts(1),pnts(2),pnts(3),
     &           '    last point :', pnts(3*npnts-2), pnts(3*npnts-1),
     &                               pnts(3*npnts)
	        write(6,119) '   Donor zone:',
     &           '    first point:', donor_pnts(1),donor_pnts(2),
     &                               donor_pnts(3),
     &           '    last point :', donor_pnts(3*npnts-2),
     &                               donor_pnts(3*npnts-1),
     &                               donor_pnts(3*npnts)

! *** general connectivity attributes:  GOTO GridConnectivity_t node
	        call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &              'ZoneGridConnectivity_t', 1,
     &              'GridConnectivity_t', conn, 'end')
	        if (ier .eq. ERROR) call cg_error_exit_f

	        call cg_ordinal_read_f(num, ier)
	        if (ier .eq. ERROR) call cg_error_exit_f
	        if (ier .eq. ALL_OK) write(6,200)'  Ordinal=',num
              enddo

! *** connectivity 1to1
	      call cg_n1to1_f(cg, base, zone, n1to1, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
              write(6,107) n1to1,' GridConnectivity1to1_t found'

              do one21=1, n1to1
                call cg_1to1_read_f(cg, base, zone, one21, connectname,
     &             donorname, range, donor_range, transform, ier)
                if (ier .eq. ERROR) call cg_error_exit_f

                write(6,105) 'GridConnectivity1to1 #',one21
                write(6,600) 'connectname="',connectname,'"'
                write(6,600) 'donorname  ="',donorname,'"'

                write(6,120) ' range: ',
     &           '(',range(1,1),',',range(2,1),',',range(3,1),
     &           ') to (',range(1,2),',',range(2,2),',',range(3,2),')'

                write(6,121)' donor_range: ',
     &          '(', donor_range(1,1), ',', donor_range(2,1), ',',
     &            donor_range(3,1), ') to (',
     &            donor_range(1,2), ',', donor_range(2,2), ',',
     &            donor_range(3,2), ')'

                write(6,122) ' Transform: ', '(',
     &            transform(1), ',',
     &            transform(2), ',', transform(3), ')'


! *** connectivity 1to1 attributes:  GOTO GridConnectivity1to1_t node
	        call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &              'ZoneGridConnectivity_t', 1,
     &           'GridConnectivity1to1_t', one21, 'end')
		  if (ier .eq. ERROR) call cg_error_exit_f
		  if (ier .eq. ALL_OK) then

! *** connectivity 1to1 attributes:  Descriptor_t
	            call cg_ndescriptors_f(ndescriptors, ier)
                    if (ier .ne. 0) call cg_error_exit_f
                    write(6,117)
     &              ndescriptors, ' descriptors for ',connectname
                    do idescr=1, ndescriptors
                      call cg_descriptor_read_f(idescr, name, text, ier)
                      if (ier .eq. ERROR) call cg_error_exit_f
                      write(6,500) '   DescriptorName="',name,'"',
     &                               '   DescriptorText="',text,'"'
                    enddo
		endif
              enddo
	    endif	! if ZoneGridConnectivity exists

            write(6,400)'                             *     *     *'

! *** bocos
	    write(6,600)'Boundary Conditions for ',zonename


! *** Zone bound. condition attributes: GOTO ZoneBC_t node
            call cg_goto_f(cg, base,ier, 'Zone_t', zone,
     &                     'ZoneBC_t', 1, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f
	    if (ier .eq. ALL_OK) then

  	! *** Zone bound. condition attributes: ReferenceState_t
              call cg_state_read_f(StateDescription, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
	      if (ier.eq.ALL_OK) then
		write(6,600)' ReferenceState defined under ZoneBC_t'
                write(6,600)'  StateDescription=',StateDescription

         ! ** ReferenceState_t attributes:  GOTO ReferenceState_t
                call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &            'ZoneBC_t', 1, 'ReferenceState_t', 1, 'end')
                if (ier .eq. ERROR) call cg_error_exit_f

                call cg_narrays_f(narrays, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,105) '  ReferenceState_t contains ',
     &                          narrays,' array(s)'

                do iarray=1, narrays

                  call cg_array_info_f(iarray, name, datatype,
     &              nndim, dim_vals, ier)
                  if (ier .eq. ERROR) call cg_error_exit_f

		  write(6,105) '   DataArray #',iarray,':'
                  write(6,600)'    Name =',name
                  write(6,600)'    Datatype=',DataTypeName(datatype)

		  write(6,600)'    Data:'
                  if (datatype .eq. RealSingle) then
                    call cg_array_read_f(iarray, data_single, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,124) data_single(1)
                  elseif (datatype .eq. RealDouble) then
                    call cg_array_read_f(iarray, data_double, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,124) data_double(1)
                  endif
                enddo


           ! ** ReferenceState_t attributes: DimensionalUnits_t
                call cg_units_read_f(mass, length, time, temp,
     &                   deg, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                if (ier .eq. ALL_OK) then
                  write(6,100)
     &		    '  Dimensional Units:',
     &              MassUnitsName(mass), LengthUnitsName(length),
     &              TemperatureUnitsName(temp), TimeUnitsName(time),
     &              AngleUnitsName(deg)
                endif
	      endif	!if ReferenceState exists under ZoneBC_t

	      call cg_nbocos_f(cg, base, zone, nbocos, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
              write(6,113)nbocos,' bound. conditions found for ',
     &                   zonename

	      do boco=1, nbocos
	        call cg_boco_info_f(cg, base, zone, boco, boconame,
     &             bocotype, ptset_type, npnts,
     &             NormalIndex, NormalListFlag, datatype,
     &             ndataset, ier)
	   	if (ier .eq. ERROR) call cg_error_exit_f
           	write(6,105) ' boundary condition #',boco
		write(6,600) '  boconame=',boconame
	  	write(6,600) '  bocotype=',BCTypeName(bocotype)
		write(6,600) '  ptset_type=',
     &            PointSetTypeName(ptset_type)
		write(6,103) '  NormalIndex=',
     &            NormalIndex(1),NormalIndex(2), NormalIndex(3)
		write(6,104) '  NormalListFlag=',NormalListFlag
		write(6,600) '  datatype for normals=',
     &            DataTypeName(datatype)

	       ! read patch points and InwardNormalList
	        if (datatype.eq.RealSingle) then
		   call cg_boco_read_f(cg, base, zone, boco, pnts,
     &              data_single, ier)
		   if (ier .eq. ERROR) call cg_error_exit_f
	        elseif (datatype.eq.RealDouble) then
		   call cg_boco_read_f(cg, base, zone, boco, pnts,
     &              data_double, ier)
		   if (ier .eq. ERROR) call cg_error_exit_f
		endif

                write(6,119) '   Bound. Condition Patch:',
     &           '    first point:', pnts(1),pnts(2),pnts(3),
     &           '    last point :', pnts(3*npnts-2), pnts(3*npnts-1),
     &                               pnts(3*npnts)

	 	if (NormalListFlag .ne. 0) then
		  if (datatype.eq.RealSingle)
     &              write(6,126) '   Normals:',
     &           '    first point:', data_single(1),data_single(2),
     &                               data_single(3),
     &           '    last point :', data_single(3*npnts-2),
     &                               data_single(3*npnts-1),
     &                               data_single(3*npnts)
		  if (datatype.eq.RealDouble)
     &              write(6,126) '   Normals:',
     &           '    first point:', data_double(1),data_double(2),
     &                               data_double(3),
     &           '    last point :', data_double(3*npnts-2),
     &                               data_double(3*npnts-1),
     &                               data_double(3*npnts)
		endif
         ! ***  bound. condition attributes: GOTO BC_t node
		call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &              'ZoneBC_t', 1, 'BC_t', boco, 'end')
		if (ier .eq. ERROR) call cg_error_exit_f

         ! ***  bound. condition attribute: DataClass_t
	        call cg_dataclass_read_f(type,ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                if (ier.eq.ALL_OK)
     &            write(6,600)'  B.C. DataClass=',
     &                           DataClassName(type)

         ! ***  boundary condition attribute:  GridLocation_t
                call cg_gridlocation_read_f(location, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                if (ier .ne. ALL_OK) call cg_error_print_f
                if (ier.eq.ALL_OK)
     &            write(6,600)'    data location=',
     &               GridLocationName(location)

           ! ** boundary condition dataset
	        write(6,103) '  ndataset=',ndataset
		do idataset=1, ndataset
                  call cg_dataset_read_f(cg, base, zone, boco,idataset,
     &            name, type, DirichletFlag, NeumannFlag, ier)
		  if (ier .eq. ERROR) call cg_error_exit_f

		  write(6,103)'   Dataset #',idataset
		  write(6,600)'    Name=',name
		  write(6,600)'    BCType=',BCTypeName(type)

             ! ** boundary condition data:  GOTO BCData_t node
		  if (DirichletFlag.eq.1) then
		    call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &                'ZoneBC_t', 1, 'BC_t', boco, 'BCDataSet_t',
     &                idataset,'BCData_t',Dirichlet,'end')
		      if (ier .eq. ERROR) call cg_error_exit_f

               ! ** boundary condition data attributes: DataClass_t
		    write(6,401)'   Dirichlet DataSet:'
		    call cg_dataclass_read_f(type,ier)
		    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,600)'    DataClass=',
     &                              DataClassName(type)

	       ! ** boundary condition data attributes: DataArray_t
		    call cg_narrays_f(narrays, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,127) '    DirichletData',
     &                         ' contains ', narrays,' data arrays'
                    do iarray=1, narrays
                      call cg_array_info_f(iarray, name, datatype,
     &                              nndim, dim_vals, ier)
                      if (ier .eq. ERROR) call cg_error_exit_f

                      write(6,105) '    DataArray #',iarray,':'
                      write(6,600)'     Name =',name
                      write(6,600)'     Datatype=',
     &                  DataTypeName(datatype)

		      write(6,105)'    Dirichlet Data:'
                      if (datatype .eq. RealSingle) then
                        call cg_array_read_f(iarray, data_single, ier)
                        if (ier .eq. ERROR) call cg_error_exit_f
                        write(6,106)
     &                      (data_single(n),n=1,dim_vals(1))

                      elseif (datatype .eq. RealDouble) then
                        call cg_array_read_f(iarray, data_double, ier)
                        if (ier .eq. ERROR) call cg_error_exit_f
                        write(6,106)
     &                      (data_double(n),n=1,dim_vals(1))
                      endif
		    enddo
		  endif

		  if (NeumannFlag.eq.1) then
		    call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &                  'ZoneBC_t', 1, 'BC_t', boco, 'BCDataSet_t',
     &                  idataset, 'BCData_t', Neumann,'end')
                      if (ier .eq. ERROR) call cg_error_exit_f

               ! ** boundary condition data attributes: DataClass_t
                    call cg_dataclass_read_f(type,ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,600)'    DataClass=',
     &                              DataClassName(type)

               ! ** boundary condition data attributes: DataArray_t
                    call cg_narrays_f(narrays, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,105)
     &              '    Neumann Data contains ', narrays,' data arrays'
                    do iarray=1, narrays
                      call cg_array_info_f(iarray, name, datatype,
     &                              nndim, dim_vals, ier)
                      if (ier .eq. ERROR) call cg_error_exit_f

                      write(6,105) '    DataArray #',iarray,':'
                      write(6,600)'     Name =',name
                      write(6,600)'     Datatype=',
     &                  DataTypeName(datatype)

                      write(6,400)'    Neumann Data:'
                      if (datatype .eq. RealSingle) then
                        call cg_array_read_f(iarray, data_single, ier)
                        if (ier .eq. ERROR) call cg_error_exit_f
                        write(6,106)
     &                      (data_single(n),n=1,dim_vals(1))

                      elseif (datatype .eq. RealDouble) then
                        call cg_array_read_f(iarray, data_double, ier)
                        if (ier .eq. ERROR) call cg_error_exit_f
                        write(6,106)
     &                      (data_double(n),n=1,num)
                      endif

                    enddo	! loop through DataArray
		  endif		! if Neumann
		enddo		! loop through dataset
              enddo		! loop through boco
	    endif		! if ZoneBC_t exists
 	  enddo			! zone loop

          write(6,400)'                             *     *     *'

! *** connectivity 1to1 - Global
          write(6,600)' Reading 1to1 connectivity for entire Base'
          call cg_n1to1_global_f(cg, base, n1to1_global, ier)
          if (ier .eq. ERROR) call cg_error_exit_f
          write(6,200)'n1to1_global=',n1to1_global

	  if (n1to1_global .gt. 0) then
	  call cg_1to1_read_global_f(cg, base,
     &       G_connectname, G_zonename, G_donorname,
     &       G_range, G_donor_range, G_transform, ier)
	  if (ier .eq. ERROR) call cg_error_exit_f

	  do i=1, n1to1_global
	    write(6,600) ' '
	    write(6,130) '*** interface #',i,' ***'
	    write(6,600) 'G_connectname="',G_connectname(i),'"'
	    write(6,600) 'G_zonename   ="',G_zonename(i),'"'
	    write(6,600) 'G_donorname  ="',G_donorname(i),'"'

	    write(6,131) 'G_range: ',
     &           '(',G_range(1,i),',',G_range(2,i),',',G_range(3,i),
     &      ') to (',G_range(4,i),',',G_range(5,i),',',G_range(6,i),')'

            write(6,132) 'G_donor_range: ',
     &     '(', G_donor_range(1,i), ',', G_donor_range(2,i), ',',
     &          G_donor_range(3,i), ') to (',
     &          G_donor_range(4,i), ',', G_donor_range(5,i), ',',
     &          G_donor_range(6,i), ')'

	   write(6,133) 'Transform: ', '(',
     &          G_transform(1,i), ',',
     &          G_transform(2,i), ',', G_transform(3,i), ')'
	  enddo
	  endif


 	enddo    				! loop through bases

        write(6,400)'                             *     *     *'

        call cg_close_f(cg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

 100 	format(a/,'    Mass units: ',a/,'    Length units: ',a/,
     &    '    Temperature units: ',a/,'    Time units: ',a/,
     &    '    Angle units:',a)
 101	format(a,i1,a,/2a,/2a,/2a,/3a,/a,i4,3a,/2a,/2a,/2a,/a,i4)
 102 	format(a,f5.3)
 103	format(a,6i2)
 104	format(a,i5,3a)
 105	format(a,i2,a)
 106    format(6f10.3)
 107	format(i2,2a)
 108    format(a,i2,a,i2,a)
 109	format(a,f5.1)
 110	format(a,5f5.1)
 111	format(a,i1,a,i8)
 112	format(a,i1/2a/3a)
 113	format(i1,3a)
 114	format(/a, i1)
 115	format(a,i1,a/3a/2a)
 116	format(a,i1,a,i1,a,i1)
 117	format(/i4,2a)
 118	format(a,i1,a/3a/2a/a,i1,a,i5)
 119	format(a/a,3i2/a,3i2)
 120	format(a10, 3(a1,i1),a6,3(i1,a1))
 121 	format(a16,3(a1,i1),a6,3(i1,a1))
 122	format(a12,3(a1,i2),a1)
 124	format(4x, f7.2)
 126	format(a/a,3f5.2/a,3f5.2)
 127	format(2a,i1,a)
 130	format(a15, i2, a4)
 131	format(a10, 3(a1,i1),a6,3(i1,a1))
 132	format(a16,3(a1,i1),a6,3(i1,a1))
 133	format(a12,3(a1,i2),a1)
 134    format(2a,i1,a,i1,a,i1)
 200    format(a,i5)
 300	format(3a/a,i2)
 400	format(/a/)
 401	format(/2a/)
 500	format(3a/3a)
 600	format(3a)

 9999	end

      program write_bcpnts_unst
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Opens an existing CGNS file that contains a simple 3-D
!   unstructured grid, and adds BC definitions (defined
!   as individual FaceCenter "points" = PointList+GridLocation=FaceCenter)
!   The BCs are added as FaceCenter points, associated with
!   face elements (QUAD_4), rather than associated to nodes
!
!   For the following, be sure you are using Version 2.0 or
!   later release of the API
!
!   The CGNS grid file 'grid.cgns' must already exist
!   (created using write_grid_unst.f).  Note: whether the
!   existing CGNS file has a flow solution in it already or
!   not is irrelevant.
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c write_bcpnts_unst.F90
!   ifort -o write_bcpnts_unst write_bcpnts_unst.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
      integer, parameter :: maxcount=960
      integer n,ibc,icount,nelem_start,nelem_end
      integer index_zone,index_base,index_file,index_bc,ier
      integer(cgsize_t) ipnts(maxcount),icounts
!
      write(6,'('' Program write_bcpnts_unst'')')
      if (CG_BUILD_64BIT) then
        write(6,'('' ...using 64-bit mode for particular integers'')')
      end if
!
!  WRITE BOUNDARY CONDITIONS TO EXISTING CGNS FILE
!  open CGNS file for modify
      call cg_open_f('grid.cgns',CG_MODE_MODIFY,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!  we know there is only one base (real working code would check!)
      index_base=1
!  we know there is only one zone (real working code would check!)
      index_zone=1
!  we know that for the unstructured zone, the following face elements
!  have been defined as inflow (real working code would check!):
      nelem_start=2561
      nelem_end=2688
      icount=0
      do n=nelem_start,nelem_end
        icount=icount+1
        ipnts(icount)=n
      enddo
      if (icount .gt. maxcount) then
        write(6,'('' Error.  Need to increase maxcount to at least'',          &
         i5)') icount
        stop
      end if
!  write boundary conditions for ilo face
      icounts=icount
      call cg_boco_write_f(index_file,index_base,index_zone,'Ilo',             &
           CGNS_ENUMV(BCTunnelInflow),CGNS_ENUMV(PointList),icounts,ipnts,index_bc,ier)
!  we know that for the unstructured zone, the following face elements
!  have been defined as outflow (real working code would check!):
      nelem_start=2689
      nelem_end=2816
      icount=0
      do n=nelem_start,nelem_end
        icount=icount+1
        ipnts(icount)=n
      enddo
      if (icount .gt. maxcount) then
        write(6,'('' Error.  Need to increase maxcount to at least'',          &
         i5)') icount
        stop
      end if
!  write boundary conditions for ihi face
      icounts=icount
      call cg_boco_write_f(index_file,index_base,index_zone,'Ihi',             &
           CGNS_ENUMV(BCExtrapolate),CGNS_ENUMV(PointList),icounts,ipnts,index_bc,ier)
!  we know that for the unstructured zone, the following face elements
!  have been defined as walls (real working code would check!):
      nelem_start=2817
      nelem_end=3776
      icount=0
      do n=nelem_start,nelem_end
        icount=icount+1
        ipnts(icount)=n
      enddo
      if (icount .gt. maxcount) then
        write(6,'('' Error.  Need to increase maxcount to at least'',          &
         i5)') icount
        stop
      end if
!  write boundary conditions for wall faces
      icounts=icount
      call cg_boco_write_f(index_file,index_base,index_zone,'Walls',           &
           CGNS_ENUMV(BCWallInviscid),CGNS_ENUMV(PointList),icounts,ipnts,index_bc,ier)
!
!  the above are all face-center locations for the BCs - must indicate this,
!  otherwise Vertices will be assumed!
      do ibc=1,index_bc
!  (the following call positions you in BC_t - it assumes there
!  is only one Zone_t and one ZoneBC_t - real working code would check!)
        call cg_goto_f(index_file,index_base,ier,'Zone_t',1,                   &
             'ZoneBC_t',1,'BC_t',ibc,'end')
        call cg_gridlocation_write_f(CGNS_ENUMV(FaceCenter),ier)
      enddo
!  close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully added FaceCenter BCs (PointList) to'',         &
        '' unstructured grid file grid.cgns'')')
      stop
      end

	program read_cgns_motion
	USE CGNS
        IMPLICIT NONE

! This program reads the CGNS file created with write_cgns_motion
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif
        INTEGER Ndim, Nglobal
	parameter (Ndim = 3)
	parameter (Nglobal = 500)
	integer IndexDim, CellDim, PhysDim
	INTEGER ier, i, zonetype
	integer nbases, nzones
	integer(cgsize_t) size(Ndim*3)
	integer nsols, location
        integer datatype
	character*32 basename, zonename
	integer cg, base, zone, sol
	character*32 name, filename
	integer nndim, rind(6), num
	integer(cgsize_t) dim_vals(12)
	real*4 data_single(100000), version
	double precision data_double(100000)
	integer*4 data_int(100000)
	character data_char(100000)

! Variable for GridMotion_t:
	integer nrmotion, rmotion, rmotiontype
	character*32 rmotionname, arrayname
	INTEGER narrays, iarray
	integer mass, length, time, temp, deg
	integer ndescr, descr
	character*32 descrname, descrtext
	integer namotion, amotion, amotiontype
	character*32 amotionname

! Multiple GridCoordinates_t
	integer grid, ngrids
	character*32 gridname

! *** Base/Zone IterativeData_t nodes
        integer nsteps, step, mzone, start, end
        character*32 bitername, zitername

! Iterative/Time accurate Data
	integer simulation

! *** open file
!	write(6,*) 'Input filename'
!	read(5,600) filename
	write(filename,'(a)')'Test_V2'
	call cg_open_f(filename, MODE_READ, cg, ier)
 	if (ier .ne. ALL_OK) call cg_error_exit_f
	write(6,600)'READING FILE ',filename

! *** CGNS Library Version used for file creation:
	call cg_version_f(cg, version, ier)
	if (ier .ne. ALL_OK) call cg_error_exit_f
	write(6,102) &
          'Library Version used for file creation:',version

! *** base
	call cg_nbases_f(cg, nbases, ier)
	if (ier .ne. ALL_OK) call cg_error_exit_f
	write(6,200)'nbases=',nbases
	
	do base=1, nbases

	  call cg_base_read_f(cg, base, basename, CellDim, PhysDim, ier)
	  if (ier .ne. ALL_OK) call cg_error_exit_f
	  write(6,300)'BaseName = "',basename,'"',  &
                      'cell_dimension=',Celldim, &
                      'physical_dimension=',PhysDim

! *** simulation type
	  call cg_simulation_type_read_f(cg, base, simulation, ier)
	  if (ier .ne. ALL_OK) call cg_error_exit_f
	  write(6,600)' Simulation Type is ', &
                        SimulationTypeName(simulation)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	
! *** base iterative data
	  call cg_biter_read_f(cg, base, bitername, nsteps, ier)
	  if (ier .eq. ERROR) call cg_error_exit_f
	  if (ier .eq. ALL_OK) then
	      write(6,300)' BaseIterativeData_t name ="',bitername,'"'
	      write(6,200)'   nsteps=',nsteps

        ! *** Data arrays under BaseIterativeData_t node
	      call cg_goto_f(cg, base, ier, 'BaseIterativeData_t', &
                             1, 'end')
	      if (ier .ne. ALL_OK) call cg_error_exit_f

              call cg_narrays_f(narrays, ier)
              if (ier .ne. ALL_OK) call cg_error_exit_f
              write(6,105) '   ',narrays,' DataArray_t nodes(s)'

              do iarray=1,narrays
		
              	call cg_array_info_f(iarray, arrayname, datatype, &
                      nndim, dim_vals, ier)
                if (ier .ne. ALL_OK) call cg_error_exit_f

                write(6,108)'     DataArray_t #',iarray,':'
                write(6,600)'       Name = ',arrayname
                write(6,600)'       Type = ',DataTypeName(datatype)
                write(6,104)'       Ndim=',nndim
                num = 1
                do i=1,nndim
                    write(6,111)'       DataDim(',i,')=',dim_vals(i)
                    num = num*dim_vals(i)
                enddo
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

                if (datatype .eq. CGNS_ENUMV(Character)) then
                    call cg_array_read_f(iarray, data_char, ier)
                    if (ier .ne. ALL_OK) call cg_error_exit_f
		    if (arrayname(1:12).eq.'ZonePointers') then
		      do step=1, nsteps
		        do mzone=1,dim_vals(2)
			  start = ((step-1)*dim_vals(2)+(mzone-1))*32+1
			  end=start+32-1
			  write(6,601)'step ',step,' zone ',mzone, &
                                      ' is ',(data_char(i),i=start,end)
			enddo
		      enddo
		    endif

		else if (datatype .eq. CGNS_ENUMV(RealSingle)) then
		    call cg_array_read_f(iarray, data_single, ier)
		    if (ier .ne. ALL_OK) call cg_error_exit_f
		    write(6,106)'       data=',(data_single(i),i=1,num)

	        else if (datatype .eq. CGNS_ENUMV(RealDouble)) then
                    call cg_array_read_f(iarray, data_double, ier)
                    if (ier .ne. ALL_OK) call cg_error_exit_f
                    write(6,106)'       data=',(data_double(i),i=1,num)

		else if (datatype .eq. CGNS_ENUMV(Integer)) then
		    call cg_array_read_f(iarray, data_int, ier)
		    if (ier .ne. ALL_OK) call cg_error_exit_f
		    write(6,128)'       data=',(data_int(i),i=1,num)
                endif
	      enddo	! loop through arrays
	  endif		! if BaseIterativeData_t is defined

! *** zone
	  call cg_nzones_f(cg, base, nzones, ier)
	  if (ier .ne. ALL_OK) call cg_error_exit_f
	  write(6,200)'nzones=',nzones

	  do zone=1, nzones

	    call cg_zone_read_f(cg, base, zone, zonename, size, ier)
	    if (ier .ne. ALL_OK) call cg_error_exit_f
	    write(6,104)'Name of Zone',zone,' is "',zonename,'"'

	    call cg_zone_type_f(cg, base, zone, zonetype, ier)
	    if (ier .ne. ALL_OK) call cg_error_exit_f
	    write(6,600)'  Zone type is ', ZoneTypeName(zonetype)

	    if (zonetype.eq.CGNS_ENUMV(Structured)) then
                 IndexDim=CellDim
	    else
                 IndexDim=1
            endif
	    write(6,104)'  IndexDimension=',IndexDim

! *** zone iterative data
            call cg_ziter_read_f(cg, base, zone, zitername, ier)
            if (ier .eq. ERROR) call cg_error_exit_f
            if (ier .eq. ALL_OK) then
              write(6,300)' ZoneIterativeData_t name ="',zitername,'"'

        ! *** Data arrays under BaseIterativeData_t node
              call cg_goto_f(cg, base, ier, 'Zone_t', zone,  &
                             'ZoneIterativeData_t', 1, 'end')
              if (ier .ne. ALL_OK) call cg_error_exit_f

              call cg_narrays_f(narrays, ier)
              if (ier .ne. ALL_OK) call cg_error_exit_f
              write(6,105) '   ',narrays,' DataArray_t nodes(s)'

              do iarray=1,narrays

                call cg_array_info_f(iarray, arrayname, datatype, &
                      nndim, dim_vals, ier)
                if (ier .ne. ALL_OK) call cg_error_exit_f

                write(6,108)'     DataArray_t #',iarray,':'
                write(6,600)'       Name = ',arrayname
                write(6,600)'       Type = ',DataTypeName(datatype)
                write(6,104)'       Ndim=',nndim
                num = 1
                do i=1,nndim
                    write(6,111)'       DataDim(',i,')=',dim_vals(i)
                    num = num*dim_vals(i)
                enddo
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

                if (datatype .eq. CGNS_ENUMV(Character) ) then
                    call cg_array_read_f(iarray, data_char, ier)
                    if (ier .ne. ALL_OK) call cg_error_exit_f
                    if (arrayname(1:23).eq.'GridCoordinatesPointers'.or. &
                      arrayname(1:20).eq.'FlowSolutionPointers'.or. &
                      arrayname(1:23).eq.'RigidGridMotionPointers'.or. &
                      arrayname(1:27).eq.'ArbitraryGridMotionPointers') &
                      then
                      do step=1, nsteps
                          start = (step-1)*32+1
                          end=start+32-1
                          write(6,602)'step ',step, &
                                      ' is ',(data_char(i),i=start,end)
                      enddo
                    endif
		endif
              enddo     ! loop through arrays
	    endif	! if ZoneIterativeData_t exist
! ***

! *** Multiple GridCoordinates_t Nodes
	    call cg_ngrids_f(cg, base, zone, ngrids, ier)
	    if (ier .ne. ALL_OK) call cg_error_exit_f

            write(6,113) ngrids,' GridCoordinates_t node(s)', &
                    'found for ',zonename
	
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	    do grid=1, ngrids
	! *** GridCoordinates_t info
	      call cg_grid_read_f(cg, base, zone, grid, gridname, ier)
	      if (ier .ne. ALL_OK) call cg_error_exit_f

              write(6,108)' GridCoordinates_t #',grid,':'
              write(6,600)'   Name = ',gridname

        ! *** GOTO GridCoordinates_t node
              call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                             'GridCoordinates_t', grid, 'end')
       	      if (ier .ne. ALL_OK) call cg_error_exit_f

        ! *** Read coordinate arrays
	      call cg_narrays_f(narrays, ier)
	      if (ier .ne. ALL_OK) call cg_error_exit_f
	      write(6,105) '   ',narrays,' DataArray_t nodes(s)'

	      do iarray=1,narrays

	  ! *** GridCoordinates_t attribute: DataArray_t
                call cg_array_info_f(iarray, name, datatype, &
                                     nndim, dim_vals, ier)
                if (ier .ne. ALL_OK) call cg_error_exit_f
                write(6,600)' DataArrayName="',name,'"'
                write(6,600)' DataType=',DataTypeName(datatype)
                write(6,104)' DataNdim=',nndim
		do i=1,nndim
                  write(6,111)' DataDim(',i,')=',dim_vals(i)
		enddo

	  ! *** Compute nr of data in data array:
	   	num = 1
		do i=1,nndim
		  num = num*dim_vals(i)
		enddo

                if (datatype .eq. CGNS_ENUMV(RealSingle)) then
                  call cg_array_read_f(iarray, data_single, ier)
                  if (ier .ne. ALL_OK) call cg_error_exit_f
                  write(6,106) 'first pts:',(data_single(i),i=1,2)
                  write(6,106) 'last pts:',(data_single(i),i=num-1,num)
                elseif (datatype .eq. CGNS_ENUMV(RealDouble)) then
                  call cg_array_read_f(iarray, data_double, ier)
                  if (ier .ne. ALL_OK) call cg_error_exit_f
                  write(6,106) 'first pts:',(data_double(i),i=1,2)
                  write(6,106) 'last pts:',(data_double(i),i=num-1,num)
                endif

	      enddo	! loop through data arrays

	    enddo 	! loop through GridCoordinates_t nodes

            write(6,400)'                             *     *     *'
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

! *** solution
	
	    call cg_nsols_f(cg, base, zone, nsols, ier)
	    if (ier .ne. ALL_OK) call cg_error_exit_f
	    write(6,113) nsols,' FlowSolution_t node(s)', &
                    'found for ',zonename

      ! *** Read solution with general cg_array_read function
	    do sol=1, nsols
	      call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                  'FlowSolution_t', sol, 'end')
	      if (ier .ne. ALL_OK) call cg_error_exit_f

	! *** FlowSolution_t attribute:  DataArray_t
	      call cg_narrays_f(narrays, ier)
	      if (ier .ne. ALL_OK) call cg_error_exit_f
              write(6,108) ' FlowSolution_t #',sol, &
                    ' contains ',narrays,' solution arrays'

	! *** FlowSolution_t attribute:  GridLocation
	      call cg_gridlocation_read_f(location, ier)
	      if (ier .eq. ERROR) call cg_error_exit_f
	      write(6,600)'  The solution data are recorded at the ', &
                       GridLocationName(location)

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	! *** FlowSolution_t attribute:  Rind
	      call cg_rind_read_f(rind, ier)
              if (ier .eq. ERROR) call cg_error_exit_f
	      write(6,103)'  The Rind Data is ',(rind(i),i=1,6)

              do iarray=1,narrays
	        call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                  'FlowSolution_t', sol, 'end')
                if (ier .ne. ALL_OK) call cg_error_exit_f

                call cg_array_info_f(iarray, name, datatype, &
                                     nndim, dim_vals, ier)
                if (ier .ne. ALL_OK) call cg_error_exit_f
	        write(6,114) '  DataArray #',iarray
                write(6,600) '   Name="',name,'"'
                write(6,600) '   DataType=',DataTypeName(datatype)
                write(6,103) '   DataNdim=',nndim
                do i=1,nndim
                  write(6,111)'   DataDim(',i,')=',dim_vals(i)
                enddo

                if (datatype .eq. CGNS_ENUMV(RealSingle)) then
                  call cg_array_read_f(iarray, data_single, ier)
                  if (ier .ne. ALL_OK) call cg_error_exit_f
                  write(6,106) '   first pts:',(data_single(i),i=1,2)
                elseif (datatype .eq. CGNS_ENUMV(RealDouble)) then
                  call cg_array_read_f(iarray, data_double, ier)
                  if (ier .ne. ALL_OK) call cg_error_exit_f
                  write(6,106) '   first pts:',(data_double(i),i=1,2)
                endif

	      enddo	! loop through DataArray_t
	      write(6,103)' '

            enddo	! loop through FlowSolution_t

            write(6,400)'                             *     *     *'


! *** Rigid Grid Motion
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	    call cg_n_rigid_motions_f(cg, base, zone, nrmotion, ier)
	    if (ier .ne. ALL_OK) call cg_error_exit_f
            write(6,113) nrmotion,' RigidGridMotion_t node(s)', &
                    'found for ',zonename

	    do rmotion=1, nrmotion
	        call cg_rigid_motion_read_f(cg, base, zone, rmotion, &
      		    rmotionname, rmotiontype, ier)
	        if (ier .ne. ALL_OK) call cg_error_exit_f

                write(6,108)' RigidGridMotion_t #',rmotion,':'
	        write(6,600)'   Name = ',rmotionname
	        write(6,600)'   Type = ', &
                             RigidGridMotionTypeName(rmotiontype)

                call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                               'RigidGridMotion_t', rmotion, 'end')
                if (ier .ne. ALL_OK) call cg_error_exit_f

		call cg_ndescriptors_f(ndescr, ier)
		if (ier .ne. ALL_OK) call cg_error_exit_f
		write(6,105) '   ',ndescr, ' Descriptor_t node(s)'

		do descr=1, ndescr
		    call cg_descriptor_read_f(descr, descrname,  &
                         descrtext, ier)
		    if (ier .ne. ALL_OK) call cg_error_exit_f
		    write(6,108)'     Descriptor_t #',descr,':'
		    write(6,600)'       Name = ',descrname
		    write(6,600)'       Text = ',descrtext
		enddo

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
! *** Data arrays under RigidGridMotion_t node
	        call cg_narrays_f(narrays, ier)
	        if (ier .ne. ALL_OK) call cg_error_exit_f
		write(6,105) '   ',narrays,' DataArray_t nodes(s)'

		do iarray=1,narrays
		    call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                               'RigidGridMotion_t', rmotion, 'end')

		    call cg_array_info_f(iarray, arrayname, datatype, &
                      nndim, dim_vals, ier)
		    if (ier .ne. ALL_OK) call cg_error_exit_f

		    write(6,108)'     DataArray_t #',iarray,':'
		    write(6,600)'       Name = ',arrayname
		    write(6,600)'       Type = ',DataTypeName(datatype)
                    write(6,104)'       Ndim=',nndim
                    num = 1
                    do i=1,nndim
                        write(6,111)'       DataDim(',i,')=',dim_vals(i)
			num = num*dim_vals(i)
                    enddo
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

                    if (datatype .eq. CGNS_ENUMV(RealSingle)) then
                        call cg_array_read_f(iarray, data_single, ier)
                        if (ier .ne. ALL_OK) call cg_error_exit_f
                  	write(6,106)'       first pts:', &
                                     (data_single(i),i=1,dim_vals(1))
		    else if (datatype .eq. CGNS_ENUMV(RealDouble)) then
			call cg_array_read_f(iarray, data_double, ier)
		  	if (ier .ne. ALL_OK) call cg_error_exit_f
			write(6,106)'       first pts:', &
                                     (data_double(i),i=1,dim_vals(1))
		    endif

		    call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                               'RigidGridMotion_t', rmotion, &
                               'DataArray_t', iarray, 'end')
		    if (ier .ne. ALL_OK) call cg_error_exit_f

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
		    call cg_units_read_f(mass,length,time,temp,deg,ier)
              	    if (ier .eq. ERROR) call cg_error_exit_f
              	    if (ier .eq. ALL_OK) then
                	write(6,100) &
                  	'       Dimensional Units:', &
                  	MassUnitsName(mass), LengthUnitsName(length), &
                  	TemperatureUnitsName(temp), TimeUnitsName(time), &
                  	AngleUnitsName(deg)
		    endif
		enddo	! loop through data arrays
	    enddo	! loop through rmotion
            write(6,400)'                             *     *     *'

	
! *** Read arbitrary grid motion
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
            call cg_n_arbitrary_motions_f(cg, base, zone, namotion, ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f
            write(6,113) namotion,' ArbitraryGridMotion_t node(s)', &
                    'found for ',zonename

            do amotion=1, namotion
                call cg_arbitrary_motion_read_f(cg, base, zone, amotion, &
                    amotionname, amotiontype, ier)
                if (ier .ne. ALL_OK) call cg_error_exit_f

                write(6,108)' ArbitraryGridMotion_t #',amotion,':'
                write(6,600)'   Name = ',amotionname
                write(6,600)'   Type = ', &
                             ArbitraryGridMotionTypeName(amotiontype)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

                call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                           'ArbitraryGridMotion_t', amotion, 'end')
                if (ier .ne. ALL_OK) call cg_error_exit_f

                call cg_ndescriptors_f(ndescr, ier)
                if (ier .ne. ALL_OK) call cg_error_exit_f
                write(6,105) '   ',ndescr, ' Descriptor_t node(s)'

                do descr=1, ndescr
                    call cg_descriptor_read_f(descr, descrname, &
                         descrtext, ier)
                    if (ier .ne. ALL_OK) call cg_error_exit_f
                    write(6,108)'     Descriptor_t #',descr,':'
                    write(6,600)'       Name = ',descrname
                    write(6,600)'       Text = ',descrtext
                enddo
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
! *** Data arrays under ArbitraryGridMotion_t node
                call cg_narrays_f(narrays, ier)
                if (ier .ne. ALL_OK) call cg_error_exit_f
                write(6,105) '   ',narrays,' DataArray_t nodes(s)'

                do iarray=1,narrays
                    call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                           'ArbitraryGridMotion_t', amotion, 'end')

                    call cg_array_info_f(iarray, arrayname, datatype, &
                      nndim, dim_vals, ier)
                    if (ier .ne. ALL_OK) call cg_error_exit_f

                    write(6,108)'     DataArray_t #',iarray,':'
                    write(6,600)'       Name = ',arrayname
                    write(6,600)'       Type = ',DataTypeName(datatype)
                    write(6,104)'       Ndim=',nndim
                    num = 1
                    do i=1,nndim
                        write(6,111)'       DataDim(',i,')=',dim_vals(i)
                        num = num*dim_vals(i)
                    enddo
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

                    if (datatype .eq. CGNS_ENUMV(RealSingle)) then
                        call cg_array_read_f(iarray, data_single, ier)
                        if (ier .ne. ALL_OK) call cg_error_exit_f
                        write(6,106)'       first pts:', &
                                     (data_single(i),i=1,dim_vals(1))
		    else if (datatype .eq. CGNS_ENUMV(RealDouble)) then
                        call cg_array_read_f(iarray, data_double, ier)
                        if (ier .ne. ALL_OK) call cg_error_exit_f
                        write(6,106)'       first pts:', &
                                     (data_double(i),i=1,dim_vals(1))
                    endif

                    call cg_goto_f(cg, base, ier, 'Zone_t', zone, &
                           'ArbitraryGridMotion_t', amotion, &
                               'DataArray_t', iarray, 'end')
                    if (ier .ne. ALL_OK) call cg_error_exit_f

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
                    call cg_units_read_f(mass,length,time,temp,deg,ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    if (ier .eq. ALL_OK) then
                        write(6,100) &
                        '       Dimensional Units:', &
                        MassUnitsName(mass), LengthUnitsName(length), &
                        TemperatureUnitsName(temp), TimeUnitsName(time), &
                        AngleUnitsName(deg)
                    endif
                enddo   ! loop through data arrays
            enddo       ! loop through amotion
            write(6,400)'                             *     *     *'
	  enddo					! loop through zones
 	enddo    				! loop through bases

        call cg_close_f(cg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

 100 	format(a/,'        Mass units: ',a/, &
                  '        Length units: ',a/, &
                  '        Temperature units: ',a/, &
                  '        Time units: ',a/, &
                  '        Angle units:',a)
 101	format(a,i1,a,/2a,/2a,/2a,/3a,/a,i4,3a,/2a,/2a,/2a,/a,i4)
 102 	format(a,f5.3)
 103	format(a,6i2)
 104	format(a,i2,3a)
 105	format(a,i2,a)
 106    format(a,6f10.3)
 107	format(i2,2a)
 108    format(a,i2,a,i2,a)
 109	format(a,f5.1)
 110	format(a,5f5.1)
 111	format(a,i1,a,i8)
 112	format(a,i1/2a/3a)
 113	format(i1,3a)
 114	format(/a, i1)
 115	format(a,i1,a/3a/2a)
 116	format(a,i1,a,i1,a)
 117	format(/i4,2a)
 118	format(a,i1,a/3a/2a/a,i1,a,i5)
 119	format(a/a,3i2/a,3i2)
 120	format(a10, 3(a1,i1),a6,3(i1,a1))
 121 	format(a16,3(a1,i1),a6,3(i1,a1))
 122	format(a12,3(a1,i2),a1)
 124	format(4x, f7.2)
 126	format(a/a,3f5.2/a,3f5.2)
 127	format(2a,i1,a)
 128	format(a,6i5)
 130	format(a15, i2, a4)
 131	format(a10, 3(a1,i1),a6,3(i1,a1))
 132	format(a16,3(a1,i1),a6,3(i1,a1))
 133	format(a12,3(a1,i2),a1)
 134	format(a,6f6.2)
 200    format(a,i3)
 300	format(3a/a,i2,/a,i2)
 400	format(/a/)
 401	format(/2a/)
 500	format(3a/3a)
 600	format(3a)
 601	format(7x,a,i2,a,i2,33a)
 602	format(7x,a,i2,33a)

 	end

      program cgzconn

#include "cgnstypes_f.h"
#ifdef WINNT
      include 'cgnswin_f.h'
#endif
      include 'cgnslib_f.h'

      cgsize_t ierr, cgfile, cgbase, cgzone, cgcoord
      cgsize_t cgz1, cgz2, cgconn, nzconn, nconn, n1to1
      cgsize_t i, j, k, n, size(9), dim
      cgsize_t ptrange(6), ptlist(125), transform(3)
      cgsize_t loc, type, ptype, npts, dztype, dptype, ddtype, dnpts
      real*4 x(125), y(125), z(125), exp(5)
      character*32 zname, dname, cname

c open and write base
      dim = 3
      call cg_open_f('cgzconn.cgns', CG_MODE_WRITE, cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_base_write_f(cgfile, 'Base', dim, dim, cgbase, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

c create some bogus data
      do n=1,3
        size(n)   = 5
        size(n+3) = 4
        size(n+6) = 0
      enddo
      n = 0
      do k=1,5
        do j=1,5
          do i=1,5
            n = n + 1
            x(n) = i
            y(n) = j
            z(n) = k
          enddo
        enddo
      enddo
      do n=1,3
        ptrange(n) = 1
        ptrange(n+3) = 5
        transform(n) = n
      enddo
      ptrange(4) = 1
      n = 0
      do j=1,5
        do i=1,5
          n = n + 1
          ptlist(n) = i
          n = n + 1
          ptlist(n) = j
          n = n + 1
          ptlist(n) = 1
        enddo
      enddo
      do n=1,5
        exp(n) = 0
      enddo
      exp(2) = 1

c loop over zones
      do n=1,2
        if (n .eq. 1) then
          zname = 'Zone1'
          dname = 'Zone2'
        else
          zname = 'Zone2'
          dname = 'Zone1'
        endif
c write zone
        call cg_zone_write_f(cgfile, cgbase, zname, size,
     &                       Structured, cgzone, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        call cg_goto_f(cgfile, cgbase, ierr, 'Zone_t', cgzone, 'end')
        if (ierr .ne. CG_OK) call cg_error_exit_f
        call cg_dataclass_write_f(NormalizedByDimensional, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
c write coordinates
        call cg_coord_write_f(cgfile, cgbase, cgzone, RealSingle,
     &                        'CoordinateX', x, cgcoord, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        call cg_gopath_f(cgfile, 'GridCoordinates/CoordinateX', ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        call cg_exponents_write_f(RealSingle, exp, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f

        call cg_coord_write_f(cgfile, cgbase, cgzone, RealSingle,
     &                        'CoordinateY', y, cgcoord, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        call cg_gopath_f(cgfile, '../CoordinateY', ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        call cg_exponents_write_f(RealSingle, exp, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f

        call cg_coord_write_f(cgfile, cgbase, cgzone, RealSingle,
     &                        'CoordinateZ', z, cgcoord, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        call cg_gopath_f(cgfile, '../CoordinateZ', ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        call cg_exponents_write_f(RealSingle, exp, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f

c write first ZoneGridConnectivity - will be active
        call cg_zconn_write_f(cgfile, cgbase, cgzone,
     &                        'ZoneConnectivity1', cgz1, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f

c write second ZoneGridConnectivity - will be active
        call cg_zconn_write_f(cgfile, cgbase, cgzone,
     &                        'ZoneConnectivity2', cgz2, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
c write general connectivity
        npts = 2
        dnpts = 25
        call cg_conn_write_f(cgfile, cgbase, cgzone, 'conn', Vertex,
     &                       Abutting1to1, PointRange, npts, ptrange,
     &                       dname, Structured, PointListDonor,
     &                       Integer, dnpts, ptlist, cgconn, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
c set it back to previous ZoneGridConnectivity and write 1to1
        call cg_zconn_set_f(cgfile, cgbase, cgzone, cgz1, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        call cg_1to1_write_f(cgfile, cgbase, cgzone, '1to1', dname,
     &                       ptrange, ptrange, transform, cgconn, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
      enddo

c close the file and reopen in read mode
      call cg_close_f(cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_open_f('cgzconn.cgns', CG_MODE_READ, cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      cgbase = 1
      cgz1 = 1
      cgz2 = 2
      cgconn = 1
      do cgzone=1,2
        call cg_nzconns_f(cgfile, cgbase, cgzone, nzconn, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        if (nzconn .ne. 2) then
          print *,'nzconn != 2'
          stop
        endif
c read should make ZoneGridConnectivity active
        call cg_zconn_read_f(cgfile, cgbase, cgzone, cgz2, zname, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        if (zname .ne. 'ZoneConnectivity2') then
          print *,'expecting Zoneconnectivity2 - got',zname
          stop
        endif
        call cg_nconns_f(cgfile, cgbase, cgzone, nconn, ierr);
        if (ierr .ne. CG_OK) call cg_error_exit_f
        call cg_n1to1_f(cgfile, cgbase, cgzone, n1to1, ierr);
        if (ierr .ne. CG_OK) call cg_error_exit_f
        if (nconn .ne. 1 .or. n1to1 .ne. 0) then
          print *,'expecting nconn=1,n1to1=0 - got',nconn,n1to1
          stop
        endif
        call cg_conn_info_f(cgfile, cgbase, cgzone, cgconn, cname,
     &                      loc, type, ptype, npts, dname, dztype,
     &                      dptype, ddtype, dnpts, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        if (cname .ne. 'conn' .or. loc .ne. Vertex .or.
     &      type .ne. Abutting1to1 .or. ptype .ne. PointRange .or.
     &      npts .ne. 2 .or. dztype .ne. Structured .or.
     &      dptype .ne. PointListDonor .or. dnpts .ne. 25) then
          print *,'invalid conn data'
          stop
        endif

c read should make ZoneGridConnectivity active
        call cg_zconn_read_f(cgfile, cgbase, cgzone, cgz1, zname, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        if (zname .ne. 'ZoneConnectivity1') then
          print *,'expecting Zoneconnectivity1 - got',zname
          stop
        endif
        call cg_nconns_f(cgfile, cgbase, cgzone, nconn, ierr);
        if (ierr .ne. CG_OK) call cg_error_exit_f
        call cg_n1to1_f(cgfile, cgbase, cgzone, n1to1, ierr);
        if (ierr .ne. CG_OK) call cg_error_exit_f
        if (nconn .ne. 0 .or. n1to1 .ne. 1) then
          print *,'expecting nconn=0,n1to1=1 - got',nconn,n1to1
          stop
        endif
        call cg_1to1_read_f(cgfile, cgbase, cgzone, cgconn, cname,
     &                      dname, ptrange, ptrange, transform, ierr)
        if (ierr .ne. CG_OK) call cg_error_exit_f
        if (cname .ne. '1to1') then
          print *,'invalid 1to1 data'
          stop
        endif
      enddo

      call cg_close_f(cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      end

      program read_bcpnts_unst
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Opens an existing CGNS file that contains a simple 3-D
!   unstructured grid + BCs (in PointList+GridLocation=FaceCenter
!   format), and reads the BCs
!
!   The CGNS grid file 'grid.cgns' must already exist
!   (created using write_grid_unst.f), and the BCs must also
!   already have been written (using write_bcpnts_unst.f).  Note: whether the
!   existing CGNS file has a flow solution in it already or
!   not is irrelevant.
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c read_bcpnts_unst.F90
!   ifort -o read_bcpnts_unst read_bcpnts_unst.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
      integer, parameter :: maxpnts=960
      integer(cgsize_t) ipnts(maxpnts),npts,normallistflag
      integer normalindex(3)
      integer i,normallist,ndataset,normaldatatype,iptset,ibocotype
      integer igr,ib,nbocos
      integer index_zone,index_base,index_file,ier
      character boconame*32
!
!  READ BOUNDARY CONDITIONS FROM EXISTING CGNS FILE
!  open CGNS file for read-only
      call cg_open_f('grid.cgns',CG_MODE_READ,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!  we know there is only one base (real working code would check!)
      index_base=1
!  we know there is only one zone (real working code would check!)
      index_zone=1
!  find out number of BCs that exist under this zone
      call cg_nbocos_f(index_file,index_base,index_zone,nbocos,ier)
!  do loop over the total number of BCs
      do ib=1,nbocos
!  find out what BC grid location is (expecting FaceCenter)
        call cg_goto_f(index_file,index_base,ier,'Zone_t',1,                   &
             'ZoneBC_t',1,'BC_t',ib,'end')
        call cg_gridlocation_read_f(igr,ier)
        if (igr .eq. CGNS_ENUMV(FaceCenter)) then
          write(6,'('' GridLocation=FaceCenter means BC data refers'',         &
            '' to elements, not nodes'')')
        end if
!  get BC info
        call cg_boco_info_f(index_file,index_base,index_zone,ib,               &
             boconame,ibocotype,iptset,npts,normalindex,normallistflag,        &
             normaldatatype,ndataset,ier)
        if (iptset .ne. CGNS_ENUMV(PointList)) then
          write(6,'('' Error.  For this program, BCs must be set'',            &
           ''  up as PointList type'',a32)') PointSetTypeName(iptset)
          stop
        end if
        write(6,'('' BC number: '',i5)') ib
        write(6,'(''    name='',a32)') boconame
        write(6,'(''    type='',a32)') BCTypeName(ibocotype)
        write(6,'(''    no of elements='',i5)') npts
        if (npts .gt. maxpnts) then
          write(6,'('' Error.  Must increase maxpnts to at least '',           &
           i5)') npts
          stop
        end if
!  read point list in here (nothing done with them in this program)
        call cg_boco_read_f(index_file,index_base,index_zone,ib,               &
             ipnts,normallist,ier)
        write(6,'(''      (these elements read here, but only some'',          &
          '' printed out:)'')')
        do i=1,10
          write(6,'('' ipnts('',i2,'')='',i4)') i,ipnts(i)
        enddo
      enddo
!  close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully read BCs (PointList format)'',                 &
       '' from file grid.cgns'')')
      stop
      end

	program read_gravity
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on May 31 2002

!       This example test the Gravity_t data structure and its children
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 3)
	integer CellDim, PhysDim
	integer ier, n, cg, nbases, base, type
	integer ndescriptors, idescr, nuser_data
	integer mass, length, time, temp, deg
	real*4 version, gravity_vector(Ndim)
	character*32 name, filename, basename, user_data_name
	character*100 text

! *** open file
!	write(6,*) 'Input filename'
!	read(5,600) filename
 	write(filename,'(a)')'Test_V2'
	call cg_open_f(filename, MODE_READ, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,600)'READING FILE ',filename

! *** CGNS Library Version used for file creation:
	call cg_version_f(cg, version, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,102) &
          'Library Version used for file creation:',version

! *** base
	call cg_nbases_f(cg, nbases, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,200)'nbases=',nbases
	
	base=1

	call cg_base_read_f(cg, base, basename, CellDim, PhysDim, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,300)'BaseName = "',basename,'"',  &
                      'cell_dimension=',CellDim

! *** base attribute:  GOTO base node
	call cg_goto_f(cg, base, ier, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

! ***   base attribute:  Descriptor
	call cg_ndescriptors_f(ndescriptors, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,400)'Base Descriptor_t Information:'
        write(6,105) 'No. of descriptors=',ndescriptors

	do idescr=1, ndescriptors
          call cg_descriptor_read_f(idescr, name, text, ier)
          if (ier .eq. ERROR) call cg_error_exit_f
          if (ier.eq.ALL_OK) then
            write(6,500)' DescriptorName="',name,'"', &
                        ' DescriptorText="',text,'"'
          endif
	enddo

! *** read Gravity_t node
	call cg_gravity_read_f(cg, base, gravity_vector, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

	write(6,110)'gravity_vector=',gravity_vector(1), &
                     gravity_vector(2), gravity_vector(3)

! *** read children of Gravity_t
	call cg_goto_f(cg, base, ier, 'Gravity_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

! * Descriptor
 	call cg_ndescriptors_f(ndescriptors, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
 	write(6,400)'Gravity Descriptor_t Information:'
        write(6,105) 'No. of descriptors=',ndescriptors

        do idescr=1, ndescriptors
          call cg_descriptor_read_f(idescr, name, text, ier)
          if (ier .eq. ERROR) call cg_error_exit_f
          write(6,500) ' DescriptorName="',name,'"', &
                             ' DescriptorText="',text,'"'
        enddo

! * DataClass
        call cg_dataclass_read_f(type,ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,600)'DataClassName=',DataClassName(type)

! * DimensionalUnits
        call cg_units_read_f(mass, length, time, temp, deg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        if (ier .eq. ALL_OK) then
          write(6,100) &
            'Gravity Dimensional Units:', &
            MassUnitsName(mass), LengthUnitsName(length), &
            TemperatureUnitsName(temp), TimeUnitsName(time), &
            AngleUnitsName(deg)
        endif

! * UserDefinedData
	call cg_nuser_data_f(nuser_data, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,400)'Gravity User Data Information:'
	write(6,105) 'No. of UserData=',nuser_data

	do n=1, nuser_data
          call cg_user_data_read_f(n, user_data_name, ier)
          if (ier .eq. ERROR) call cg_error_exit_f
	  write(6,500) ' user_data_name="',user_data_name,'"'
	enddo

! * GravityVector/Descriptor
        call cg_goto_f(cg, base, ier, 'Gravity_t', 1, 'DataArray_t', &
                       1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_ndescriptors_f(ndescriptors, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,400)'Gravity Vector Descriptor_t Information:'
        write(6,105) 'No. of descriptors=',ndescriptors

        do idescr=1, ndescriptors
          call cg_descriptor_read_f(idescr, name, text, ier)
          if (ier .eq. ERROR) call cg_error_exit_f
          write(6,500) ' DescriptorName="',name,'"', &
                             ' DescriptorText="',text,'"'
        enddo

! * GravityVector/DimensionalUnits
        call cg_units_read_f(mass, length, time, temp, deg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        if (ier .eq. ALL_OK) then
          write(6,100) &
            'Gravity Vector Dimensional Units:', &
            MassUnitsName(mass), LengthUnitsName(length), &
            TemperatureUnitsName(temp), TimeUnitsName(time), &
            AngleUnitsName(deg)
        endif
        call cg_close_f(cg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

 100 	format(a/,'    Mass units: ',a/,'    Length units: ',a/, &
          '    Temperature units: ',a/,'    Time units: ',a/, &
          '    Angle units:',a)
 102 	format(a,f5.3)
 105	format(a,i2,a)
 110	format(a,5f5.1)
 200    format(a,i5)
 300	format(3a/a,i2)
 400	format(/a/)
 500	format(3a/3a)
 600	format(3a)

 9999	end

	program modify_axisym
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on June 7 2002

!       This example tests the Axisymmetry_t data structure and its children

#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 2)
	integer index_dim, cell_dim, phys_dim, i
	integer cg, base_no, ier, dimval(2), nbases
	real*4 ref_point(Ndim), axis(Ndim), angle
	character*100 linkpath, DescriptorText
	character*32 CoordinateNames(2), DescriptorName, basename
        real*4 version


! *** initialize
	ier = 0
	index_dim=Ndim
	cell_dim=Ndim
	phys_dim=Ndim

! *** open CGNS file for writing
 	call cg_open_f('Test_V2', MODE_MODIFY, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,600)'MODIFYING FILE Test_V2'

! *** CGNS Library Version used for file creation:
        call cg_version_f(cg, version, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,102)
     &     'Library Version used for file creation:',version

        call cg_nbases_f(cg, nbases, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,200)'nbases=',nbases

! *** base
        base_no=1
        call cg_base_read_f(cg,base_no,basename,cell_dim,phys_dim,ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,300)'BaseName = "',basename,'"',
     &                'cell_dimension=',cell_dim

! *** write a descriptor under the base
        call cg_goto_f(cg, base_no, ier, 'end')
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_descriptor_write_f('BaseDescriptorName',
     &      'BaseDescriptorText', ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** write Axisymmetry_t node
	do i=1,Ndim
	    ref_point(i)=0
	    axis(i) = i-1
	enddo
	
	call cg_axisym_write_f(cg, base_no, ref_point, axis, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** write children of Axisymmetry_t
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	call cg_goto_f(cg, base_no, ier, 'Axisymmetry_t', 1, 'end')
	if (ier .eq. ERROR) call cg_error_exit_f

! * DataArray_t AxisymmetryAngle
	angle = 360
	dimval(1)=1
	call cg_array_write_f('AxisymmetryAngle', RealSingle, 1,
     &       1, angle, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! * DataArray_t CoordinateNames
        dimval(1)=32
        dimval(2)=2
	write(CoordinateNames(1),'(a)')'CoordinateX'
	write(CoordinateNames(2),'(a)')'CoordinateZ'
	call cg_array_write_f('CoordinateNames', Character, 2,
     &       dimval, CoordinateNames, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! * Descriptor
	call cg_descriptor_write_f('AxisymDescriptorName',
     &       'AxisymDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * DataClass
        call cg_dataclass_write_f(Dimensional, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! * DimensionalUnits
	call cg_units_write_f(Kilogram, Meter, Second, Kelvin,
     &                        Radian, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! * UserDefinedData
        call cg_user_data_write_f('UserData1', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * Link to BaseDescriptorName
        write(linkpath,'(a)') 'Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * DataArray_t/Descriptor
	do i=1, 4
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	    call cg_goto_f(cg, base_no, ier, 'Axisymmetry_t', 1,
     &                     'DataArray_t', i, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f
	    write(DescriptorName,'(a,i1)') 'DescriptorName4Array',i
	    write(DescriptorText,'(a,i1)') 'DescriptorText4Array',i
	    call cg_descriptor_write_f(DescriptorName,
     &           DescriptorText, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
	
! * DataArray_t/DimensionalUnits
	    call cg_units_write_f(Kilogram, Meter, Second, Kelvin,
     &                            Degree, ier)
            if (ier .eq. ERROR) call cg_error_exit_f
	enddo	

! *** close CGNS file
	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

 102    format(a,f5.3)
 200    format(a,i5)
 300    format(3a/a,i2)
 600    format(3a)

	end

        program write_mixed_elements
        USE CGNS

!	author: Diane Poirier
!	last revised on March 15 2000

! 	This example test the writing of and element section of
!	type MIXED, which includes some NGON_x elements of different size
!	The model is not realistic, as all the data is dummy.

#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer index_dim, cell_dim, phys_dim
	integer cg, base, zone, ier, index, ZoneType
        integer(cgsize_t) size(3)
	integer i, j, k, n, pos, coord, section_no
        integer(cgsize_t) element(20)
	character*32 ZoneName, coordname(3)
        double precision data_double(27)
	integer grid_no, count

!       initialize
        ier = 0
	index_dim = 1
	cell_dim=3
	phys_dim=3

!       open CGNS file for writing

        call cg_open_f('Test_V2', MODE_WRITE, cg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

!*******write CGNSBase
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	call cg_base_write_f(cg, 'MixedElementBase', cell_dim, phys_dim,
     &			     base, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

!*******write only 1 unstructured zone
	zone = 1
	ZoneType=Unstructured
	write(ZoneName,100) 'UnstructuredZone#1'
 100	format(a)
	size(1) = 27		! no of nodes
	size(2) = 3		! no of elements
	size(3) = 0		! unsorted nodes

	call cg_zone_write_f(cg, base, 'UnstructuredZone#1', size,
     &                       ZoneType, index, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! Name convention
        coordname(1) = 'CoordinateX'
        coordname(2) = 'CoordinateY'
        coordname(3) = 'CoordinateZ'


! Create GridCoordinates_t node
            call cg_grid_write_f(cg,base,index,'GridCoordinates',
     &                         grid_no, ier)
            if (ier.ne. ALL_OK) call cg_error_exit_f

! create coordinate data(10x10x10 box with 3x3x3 equidistant nodes)
        do coord=1,phys_dim
            do 20 k=1, 3
            do 20 j=1, 3
            do 20 i=1, 3
                pos = i + (j-1)*3 + (k-1)*9
                if (coord.eq.1) data_double(pos) = (i-1)*5
                if (coord.eq.2) data_double(pos) = (j-1)*5
                if (coord.eq.3) data_double(pos) = (k-1)*5
 20         continue
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

! GOTO GridCoordinatesNode & write DataArray
            call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &                     'GridCoordinates_t', 1, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f

            call cg_array_write_f(coordname(coord), RealDouble,
     &                            index_dim, size, data_double, ier)
            if (ier .eq. ERROR) call cg_error_exit_f
	enddo	! coord. loop

! Generate dummy elements

	count = 0
! first element HEXA_8
	count = count + 1
	element(count)=HEXA_8
	do i=1,8
	    count = count + 1
	    element(count)=i
	enddo
! second element TETRA_4
	count = count + 1
	element(count)=TETRA_4
	do i=1,4
	    count = count + 1
            element(count)=i
        enddo
! third element PYRA_5
        count = count + 1
        element(count)=PYRA_5
        do i=1,5
            count = count + 1
            element(count)=i
        enddo

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
! Write MIXED element section
	call cg_section_write_f(cg, base, zone, 'MixedElements', MIXED,
     &                          1_cgsize_t, 3_cgsize_t, 0, element,
     &                          section_no, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! Write section of 4 NGON_n of 3 nodes
        count = 0
	do n=1,4
	    count = count + 1
	    element(count)=3
	    do i=1,3
		count = count + 1
		element(count)=10*n+i
	    enddo
	enddo
	call cg_section_write_f(cg, base, zone, 'NGON_n(3)',
     &                 NGON_n, 1_cgsize_t, 4_cgsize_t, 0, element,
     &                 section_no, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! Write & close CGNS file

	call cg_close_f(cg, ier)
	if (ier.eq. ERROR) call cg_error_exit_f()

	end

      program testbboxf

#include "cgnstypes_f03.h"
#ifdef WINNT
      include 'cgnswin_f.h'
#endif
      USE CGNS
      implicit none
      INTEGER, PARAMETER :: sp = KIND(1.0)
      INTEGER, PARAMETER :: dp = KIND(1.d0)
      
      integer, parameter :: celldim = 3, physdim = 3
      integer, parameter :: NUM_SIDE = 5
 
      real(kind=sp), dimension(NUM_SIDE*NUM_SIDE*NUM_SIDE) :: coord
      real(kind=dp), dimension(3, 2) :: bbox

      integer :: n
      integer :: ierr
      integer :: cgfile, cgbase, cgzone, cgcoord
      integer(cgsize_t) :: size(9)
      
      character(len=32) fname
      fname = 'boundingbox_f90.cgns'

      do n=1,NUM_SIDE*NUM_SIDE*NUM_SIDE
        coord(n) = n
      enddo

      call cg_open_f (fname, CG_MODE_WRITE, cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_base_write_f (cgfile,"Base", celldim, physdim, cgbase, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

!     write zone

      do n =1,3
        size(n)   = NUM_SIDE
        size(n+3) = NUM_SIDE - 1
        size(n+6) = 0
      enddo
      call cg_zone_write_f (cgfile, cgbase, "Zone", size, CGNS_ENUMV(Structured), &
     &                    cgzone, ierr)
      call cg_coord_write_f(cgfile, cgbase, cgzone, CGNS_ENUMV(RealSingle), &
     &            "CoordinateX", coord, cgcoord, ierr)
      call cg_coord_write_f(cgfile, cgbase, cgzone, CGNS_ENUMV(RealSingle), &
     &            "CoordinateY", coord, cgcoord, ierr)
      call cg_coord_write_f(cgfile, cgbase, cgzone, CGNS_ENUMV(RealSingle), &
     &            "CoordinateZ", coord, cgcoord, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_close_f (cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

!     read file
      call cg_open_f (fname, CG_MODE_READ, cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      cgbase = 1
      cgzone = 1

      bbox(1,1) = 1.0
      bbox(1,2) = -1.0
      bbox(2,1) = 1.0
      bbox(2,2) = -1.0
      bbox(3,1) = 1.0
      bbox(3,2) = -1.0
!     check bounding box is not modified
      call cg_grid_bounding_box_read_f(cgfile, cgbase, cgzone, 1, &
     &                               CGNS_ENUMV(RealDouble), bbox, ierr)
      if (ierr .eq. CG_ERROR) call cg_error_exit_f
      if (bbox(1,2) .ne. -1.0) stop
      if (bbox(1,1) .ne. 1.0) stop
      call cg_close_f (cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_open_f (fname, CG_MODE_MODIFY, cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      cgbase = 1
      cgzone = 1

      bbox(1, 1) = 1.0
      bbox(1 ,2) = (NUM_SIDE*NUM_SIDE*NUM_SIDE)
      bbox(2, 1) = 1.0;
      bbox(2, 2) = (NUM_SIDE*NUM_SIDE*NUM_SIDE)
      bbox(3, 1) = 1.0
      bbox(3, 2) = (NUM_SIDE*NUM_SIDE*NUM_SIDE)

      call cg_grid_bounding_box_write_f(cgfile, cgbase, cgzone, 1, &
     &                                CGNS_ENUMV(RealDouble), bbox, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      call cg_close_f(cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      call cg_open_f(fname, CG_MODE_READ, cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f
      cgbase = 1
      cgzone = 1
      bbox(1,1) = 1.0
      bbox(1,2) = -1.0
      bbox(2,1) = 1.0
      bbox(2,2) = -1.0
      bbox(3,1) = 1.0
      bbox(3,2) = -1.0
!     check bounding box
      call cg_grid_bounding_box_read_f(cgfile, cgbase, cgzone, 1, &
     &                               CGNS_ENUMV(RealDouble), bbox, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      if (bbox(1, 1) .ne. 1.0) stop
      if (bbox(1, 2) .ne. (NUM_SIDE*NUM_SIDE*NUM_SIDE)) stop
    
      call cg_close_f (cgfile, ierr)
      if (ierr .ne. CG_OK) call cg_error_exit_f

      end program

	program read_bprop
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on August 2002

!       This example test the BCProperty_t data structure and its children
!	It tests the functions:
!	- cg_bc_wallfunction_read_f(fn, B, Z, BC, WallFunctionType, ier)
!	- cg_bc_area_read_f(fn, B, Z, BC, AreaType, SurfaceArea, RegionName, ier)
!	And the following:
!	- return value when BCProperty_t doesn't exist, or when WallFunction/Area doesn't exist
!	- printing WallFunctionTypeName, & type<=>name association.
!	- cg_ndescriptors, cg_descriptor_read under BCProperty_t, WallFunction_t, Area_t
!	- cg_nuser_data, cg_user_data_read, under BCProperty_t, WallFunction_t, Area_t
!	- cg_narray, cg_array_read under Area_t
!	- links under BCProperty_t, WallFunction_t, Area_t
!	- cg_goto to BCProperty_t, WallFunction_t, Area_t
! 	- Memory check with Insure

#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 3)
	integer ier, cg, nbases, base, nzones, zone, nbocos, boco
	integer CellDim, PhysDim, IndexDim, datatype
	integer(cgsize_t) NormalListFlag
	integer ndescriptors, idescr, zonetype, ndataset
	integer(cgsize_t) size(3*Ndim)
	integer bocotype, ptset_type, NormalIndex(3), AreaType
	integer(cgsize_t) npnts
	integer WallFunctionType, nuser_data, n
	integer(cgsize_t) pnts(100000)
	integer type, mass, length, time, temp, deg
	character*32 filename, basename, zonename, boconame, bpropname
	character*32 name, RegionName, user_data_name
	character*100 text
	real*4 version, data_single(100), SurfaceArea
        double precision data_double(100)

! *** open file
!	write(6,*) 'Input filename'
!	read(5,600) filename
 	write(filename,'(a)')'Test_V2'
	call cg_open_f(filename, MODE_READ, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,600)'READING FILE ',filename

! *** CGNS Library Version used for file creation:
	call cg_version_f(cg, version, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,102)
     &     'Library Version used for file creation:',version

! *** base
	call cg_nbases_f(cg, nbases, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,200)'nbases=',nbases
	
	base=1

	call cg_base_read_f(cg, base, basename, CellDim, PhysDim, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,300)'BaseName = "',basename,'"',
     &                'cell_dimension=',CellDim

! *** base attribute:  GOTO base node
	call cg_goto_f(cg, base, ier, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

! ***   base attribute:  Descriptor
	call cg_ndescriptors_f(ndescriptors, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,400)'Base Descriptor_t Information:'
        write(6,105) 'No. of descriptors=',ndescriptors

	do idescr=1, ndescriptors
          call cg_descriptor_read_f(idescr, name, text, ier)
          if (ier .eq. ERROR) call cg_error_exit_f
          if (ier.eq.ALL_OK) then
            write(6,500)' DescriptorName="',name,'"',
     &                  ' DescriptorText="',text,'"'
          endif
	enddo

! *** read Zone
        call cg_nzones_f(cg, base, nzones, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,200)'nzones=',nzones

	zone = 1

	call cg_zone_read_f(cg, base, zone, zonename, size, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,104)'Name of Zone',zone,' is "',zonename,'"'

        call cg_zone_type_f(cg, base, zone, zonetype, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,600)'  Zone type is ', ZoneTypeName(zonetype)

        if (zonetype.eq.Structured) then
            IndexDim=CellDim
        else
            IndexDim=1
        endif

	write(6,104)'  IndexDimension=',IndexDim

! *** read BC_t's
        call cg_nbocos_f(cg, base, zone, nbocos, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,113)nbocos,' bound. conditions found for ',
     &             zonename

        do boco=1, nbocos
            call cg_boco_info_f(cg, base, zone, boco, boconame,
     &             bocotype, ptset_type, npnts, NormalIndex,
     &             NormalListFlag, datatype, ndataset, ier)
            if (ier .eq. ERROR) call cg_error_exit_f
            write(6,105) ' boundary condition #',boco
            write(6,600) '  boconame=',boconame
            write(6,600) '  bocotype=',BCTypeName(bocotype)
            write(6,600) '  ptset_type=', PointSetTypeName(ptset_type)
	    if (NormalIndex(1).eq.0 .and. NormalIndex(2).eq.0 .and.
     &          NormalIndex(3).eq.0) then
	        write(6,103) '  NormalIndex undefined'
	    else
                write(6,103) '  NormalIndex=', NormalIndex(1),
     &                          NormalIndex(2), NormalIndex(3)
	    endif
            write(6,104) '  NormalListFlag=',NormalListFlag
	    if (NormalListFlag .eq. 1) then
                write(6,600) '  datatype for normals=',
     &		    	        DataTypeName(datatype)
	    endif

           ! read patch points and InwardNormalList
            if (datatype.eq.RealSingle .or. datatype.eq.Null) then
               call cg_boco_read_f(cg, base, zone, boco, pnts,
     &          data_single, ier)
               if (ier .eq. ERROR) call cg_error_exit_f
            elseif (datatype.eq.RealDouble) then
               call cg_boco_read_f(cg, base, zone, boco, pnts,
     &          data_double, ier)
               if (ier .eq. ERROR) call cg_error_exit_f
            endif

            write(6,119) '   Bound. Condition Patch:',
     &       '    first point:', pnts(1),pnts(2),pnts(3),
     &       '    last point :', pnts(3*npnts-2), pnts(3*npnts-1),
     &                           pnts(3*npnts)

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
! *** read BCProperty_t node

	    call cg_bc_wallfunction_read_f(cg, base, zone, boco,
     &		WallFunctionType, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

	    if (ier .eq. ALL_OK) then
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	        write(6,600) '   WallFunctionTypeName= "',
     & 		    WallFunctionTypeName(WallFunctionType),'"'
	    endif

	    call cg_bc_area_read_f(cg, base, zone, boco, AreaType,
     &		SurfaceArea, RegionName, ier)
            if (ier .eq. ERROR) call cg_error_exit_f

            if (ier .eq. ALL_OK) then
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
                write(6,600)'   AreaTypeName= "',AreaTypeName(AreaType),
     &			    '"'
                write(6,600)'   RegionName= "',RegionName,'"'
	 	write(6,102)'   SurfaceArea=',SurfaceArea
	    endif

! *** read Descriptor_t & UserDefinedData_t under...
! ...   BCProperty_t
            call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1,
     &      		   'BC_t', boco, 'BCProperty_t', 1, 'end')
	    if (ier .eq. ERROR) call cg_error_exit_f
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

            if (ier .eq. ALL_OK) then

                call cg_ndescriptors_f(ndescriptors, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'BCProperty Descriptor_t Information:'
                write(6,105) 'No. of descriptors=',ndescriptors
                do idescr=1, ndescriptors
                    call cg_descriptor_read_f(idescr, name, text, ier)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' DescriptorName="',name,'"',
     &                           ' DescriptorText="',text,'"'
                enddo

                call cg_nuser_data_f(nuser_data, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'BCProperty User Data Information:'
                write(6,105) 'No. of UserData=',nuser_data
                do n=1, nuser_data
                    call cg_user_data_read_f(n, user_data_name, ier)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' user_data_name="',user_data_name,'"'
                enddo

	    endif

! ...   WallFunction_t
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
            call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1,
     &      'BC_t', boco, 'BCProperty_t', 1, 'WallFunction_t', 1, 'end')
	    if (ier .eq. ERROR) call cg_error_exit_f

            if (ier .eq. ALL_OK) then

                call cg_ndescriptors_f(ndescriptors, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'WallFunction Descriptor_t Information:'
                write(6,105) 'No. of descriptors=',ndescriptors
                do idescr=1, ndescriptors
                    call cg_descriptor_read_f(idescr, name, text, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' DescriptorName="',name,'"',
     &                           ' DescriptorText="',text,'"'
                enddo

                call cg_nuser_data_f(nuser_data, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'WallFunction User Data Information:'
                write(6,105) 'No. of UserData=',nuser_data
                do n=1, nuser_data
                    call cg_user_data_read_f(n, user_data_name, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' user_data_name="',user_data_name,'"'
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
                enddo

            endif

! ...   Area_t
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
            call cg_goto_f(cg, base, ier, 'Zone_t', zone, 'ZoneBC_t', 1,
     &          'BC_t', boco, 'BCProperty_t', 1, 'Area_t', 1, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f

            if (ier .eq. ALL_OK) then

                call cg_ndescriptors_f(ndescriptors, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'Area Descriptor_t Information:'
                write(6,105) 'No. of descriptors=',ndescriptors
                do idescr=1, ndescriptors
                    call cg_descriptor_read_f(idescr, name, text, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' DescriptorName="',name,'"',
     &                           ' DescriptorText="',text,'"'
                enddo

                call cg_nuser_data_f(nuser_data, ier)
                if (ier .eq. ERROR) call cg_error_exit_f
                write(6,400)'Area User Data Information:'
                write(6,105) 'No. of UserData=',nuser_data
                do n=1, nuser_data
                    call cg_user_data_read_f(n, user_data_name, ier)
                    if (ier .eq. ERROR) call cg_error_exit_f
                    write(6,500) ' user_data_name="',user_data_name,'"'
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
                enddo

! * Read DataClass & DimensionalUnits under SurfaceArea
		call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &		    'ZoneBC_t', 1, 'BC_t', boco, 'BCProperty_t', 1,
     &		    'Area_t', 1, 'DataArray_t', 1, 'end')

		call cg_dataclass_read_f(type,ier)
		if (ier .eq. ERROR) call cg_error_exit_f
		write(6,600)'DataClassName=',DataClassName(type)

        	call cg_units_read_f(mass, length, time, temp, deg, ier)
        	if (ier .eq. ERROR) call cg_error_exit_f
        	if (ier .eq. ALL_OK) then
          	    write(6,100)
     &      	    'SurfaceArea Dimensional Units:',
     &      	    MassUnitsName(mass), LengthUnitsName(length),
     &      	    TemperatureUnitsName(temp), TimeUnitsName(time),
     &      	    AngleUnitsName(deg)
        	endif

            endif

	enddo ! boco loop

! Close file
        call cg_close_f(cg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

 100 	format(a/,'    Mass units: ',a/,'    Length units: ',a/,
     &    '    Temperature units: ',a/,'    Time units: ',a/,
     &    '    Angle units:',a)
 102 	format(a,f8.3)
 103    format(a,6i2)
 104    format(a,i5,3a)
 105	format(a,i2,a)
 113    format(i1,3a)
 119    format(a/a,3i2/a,3i2)
 200    format(a,i5)
 300	format(3a/a,i2)
 400	format(/a/)
 500	format(3a/3a)
 600	format(3a)

 9999	end

	program write_cgns_motion
	USE CGNS

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on November 2000
!       This example test the API functions for grid motion and time accurate data.

#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	parameter (Ndim = 3, NumberOfSteps=2)
	parameter (Nnodes = 120)
	integer index_dim, cell_dim, phys_dim, pos
	integer base_no, zone_no, coord_no, sol_no, field_no
	integer num, data_size(2)
	integer(cgsize_t) size(Ndim*3)
	integer cg, ier, coord, i, sol, field
	double precision Dxyz(Nnodes), values(Nnodes)
	character*32 zonename, solname, fieldname, coordname(Ndim)

! *** Variables for RigidGridMotion_t test
!	real*4 origin(Ndim,2), angle(Ndim), velocity(Ndim)
	double precision origin(Ndim,2), angle(Ndim), velocity(Ndim)
	integer rmotion_no, rmotion
	character*32 rmotionname

! *** Variables for ArbitraryGridMotion_t test
!	real*4 GridVelocity(Nnodes)
	double precision GridVelocity(Nnodes)
	integer amotion_no, amotion
	character*32 amotionname

! *** Multiple GridCoordinates_t node
	integer grid_no, grid
	character*32 gridname

! *** Base/Zone IterativeData_t nodes
!	real*4 time(2)
	double precision time(2)
	integer nsteps, step, iteration(NumberOfSteps)
	integer nzones(NumberOfSteps), dimval(3)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	character*32 bitername, zitername, zone_ptrs(2,NumberOfSteps)
	character*32 grid_ptrs(NumberOfSteps), sol_ptrs(NumberOfSteps)
	character*32 rmotion_ptrs(NumberOfSteps)
        character*32 amotion_ptrs(NumberOfSteps)

	coordname(1) = 'CoordinateX'
	coordname(2) = 'CoordinateY'
	coordname(3) = 'CoordinateZ'

! *** initialize
	ier = 0
	index_dim=Ndim
	cell_dim=Ndim
	phys_dim=Ndim

! *** open CGNS file for writing
 	call cg_open_f('Test_V2M', MODE_MODIFY, cg, ier)
 	if (ier .ne. ALL_OK) call cg_error_exit_f
	
! *** base
 	call cg_base_write_f(cg, 'Basename', cell_dim, phys_dim,
     &                       base_no, ier)
 	if (ier .ne. ALL_OK) call cg_error_exit_f

! *** simulation type
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	call cg_simulation_type_write_f(cg, base_no, TimeAccurate, ier)
	if (ier .ne. ALL_OK) call cg_error_exit_f

! *** Base iterative data
	write(bitername,100) 'BaseIterativeData'
	nsteps=2
	call cg_biter_write_f(cg, base_no, bitername, nsteps, ier)
	if (ier .ne. ALL_OK) call cg_error_exit_f

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	call cg_goto_f(cg, base_no, ier, 'BaseIterativeData_t',1,'end')
	if (ier .ne. ALL_OK) call cg_error_exit_f

  ! *** TimeValues & IterationValues
	do step=1,nsteps
	    time(step) = 15.5*step
	    iteration(step) = 1000*step
	    nzones(step) = step
	    write(zone_ptrs(1,step),100) 'Zone#',1
	    write(zone_ptrs(2,step),100) 'Null'
	    if (step.eq.2) write(zone_ptrs(2,step),100) 'Zone#',2
	enddo
	!call cg_array_write_f('TimeValues', RealSingle, 1, nsteps,
	call cg_array_write_f('TimeValues', RealDouble, 1, nsteps,
     &                         time, ier)
        if (ier .ne. ALL_OK) call cg_error_exit_f
	call cg_array_write_f('IterationValues', Integer, 1, nsteps,
     &                         iteration, ier)
	if (ier .ne. ALL_OK) call cg_error_exit_f
	call cg_array_write_f('NumberOfZones', Integer, 1, nsteps,
     &                         nzones, ier)
	if (ier .ne. ALL_OK) call cg_error_exit_f
	dimval(1)=32
	dimval(2)=2 		! *** MaxNumberOfZones in a step1
	dimval(3)=nsteps
        call cg_array_write_f('ZonePointers', Character, 3, dimval,
     &                         zone_ptrs, ier)
	if (ier .ne. ALL_OK) call cg_error_exit_f
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

! *** zone
        write(zonename,100) 'Zone#',1
    	num = 1
	do i=1,index_dim      		! zone#1: 3*4*5
            size(i) = i+2		! nr of nodes in i,j,k
	    size(i+Ndim) = size(i)-1	! nr of elements in i,j,k
	    size(i+2*Ndim) = 0		! nr of bnd nodes if ordered
       	    num = num * size(i)		! nr of nodes
    	enddo
    	call cg_zone_write_f(cg, base_no, zonename, size,
     &                       Structured, zone_no, ier)
    	if (ier .ne. ALL_OK) call cg_error_exit_f

! *** Zone iterative data
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	write(zitername,100) 'ZoneIterativeData'
        call cg_ziter_write_f(cg, base_no, zone_no, zitername, ier)
        if (ier .ne. ALL_OK) call cg_error_exit_f

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
        call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no,
     &                 'ZoneIterativeData_t',1,'end')
        if (ier .ne. ALL_OK) call cg_error_exit_f

	do step=1, nsteps
	    write(grid_ptrs(step),100)   'GridCoordinates#',    step
	    write(sol_ptrs(step),100)    'FlowSolution#',       step
	    write(rmotion_ptrs(step),100)'RigidGridMotion#',    step
	    write(amotion_ptrs(step),100)'ArbitraryGridMotion#',step
	enddo
	dimval(1)=32
	dimval(2)=nsteps

	call cg_array_write_f('GridCoordinatesPointers', Character, 2,
     &                         dimval, grid_ptrs, ier)
        if (ier .ne. ALL_OK) call cg_error_exit_f
	call cg_array_write_f('FlowSolutionPointers', Character, 2,
     &                         dimval, sol_ptrs, ier)
        if (ier .ne. ALL_OK) call cg_error_exit_f
	call cg_array_write_f('RigidGridMotionPointers', Character, 2,
     &                         dimval, rmotion_ptrs, ier)
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	if (ier .ne. ALL_OK) call cg_error_exit_f
        call cg_array_write_f('ArbitraryGridMotionPointers', Character,
     &                         2, dimval, amotion_ptrs, ier)
	if (ier .ne. ALL_OK) call cg_error_exit_f

! *** coordinate
     	do coord=1, phys_dim
 	    do k=1, size(3)
 	    do j=1, size(2)
 	    do i=1, size(1)
	        pos = i + (j-1)*size(1) + (k-1)*size(1)*size(2)
		! * make up some dummy coordinates just for the test:
 	        if (coord.eq.1) Dxyz(pos) = i
 	        if (coord.eq.2) Dxyz(pos) = j
 	        if (coord.eq.3) Dxyz(pos) = k
 	    enddo
 	    enddo
 	    enddo

            call cg_coord_write_f(cg, base_no, zone_no, RealDouble,
     &                            coordname(coord), Dxyz, coord_no, ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f

     	enddo

! *** additional GridCoordinates_t Descriptions
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	do grid = 1,2
	    write(gridname,100)'GridCoordinates#',grid
	    call cg_grid_write_f(cg, base_no, zone_no, gridname,
     &                           grid_no, ier)
	    if (ier .ne. ALL_OK) call cg_error_exit_f

	    call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no,
     &                     'GridCoordinates_t', grid_no, 'end')
            if (ier .ne. ALL_OK) call cg_error_exit_f
	
	    call cg_array_write_f('CoordinateX', RealDouble, 3,
     &                             size, Dxyz, ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f
            call cg_array_write_f('CoordinateY', RealDouble, 3,
     &                             size, Dxyz, ier)
            call cg_array_write_f('CoordinateZ', RealDouble, 3,
     &                             size, Dxyz, ier)

      ! *** Write DataClass_t under CoordinateX
	    call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no,
     &        'GridCoordinates_t', grid_no, 'DataArray_t', 1, 'end')
            if (ier .ne. ALL_OK) call cg_error_exit_f

	    call cg_dataclass_write_f(Dimensional, ier)
	    if (ier .ne. ALL_OK) call cg_error_exit_f
	enddo

! *** solution
     	do sol=1, 2
 	    write(solname,100) 'Solution#',sol
 	    call cg_sol_write_f(cg, base_no, zone_no, solname,
     &                          Vertex, sol_no, ier)
 	    if (ier .ne. ALL_OK) call cg_error_exit_f

! *** solution field
 	    do field=1, 2
	    ! make up some dummy solution values
 	  	do i=1, num
 		    values(i) = i*field*sol
 	    	enddo
 	    	write(fieldname,100) 'Field#',field
 	    	call cg_field_write_f(cg, base_no, zone_no, sol_no,
     &              RealDouble, fieldname, values, field_no, ier)
 	    	if (ier .ne. ALL_OK) call cg_error_exit_f

 	    enddo				! field loop
        enddo				! solution loop

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
! *** Rigid Grid Motion
	do rmotion=1, 2
	    write(rmotionname,100) 'RigidGridMotion#',rmotion
	    do coord=1, phys_dim
	        origin(coord,1) = (rmotion-1)*10.0
	        origin(coord,2) = origin(coord,1) + 10.0
	        angle(coord) = 5.0 * rmotion
		velocity(coord) = 7.0
	    enddo
	    call cg_rigid_motion_write_f(cg, base_no, zone_no,
     &      rmotionname, ConstantRate, rmotion_no, ier)
	    if (ier .ne. ALL_OK) call cg_error_exit_f

! ** Goto RigidGridMotion_t node
	    call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no,
     &                     'RigidGridMotion_t', rmotion_no, 'end')
	    if (ier .ne. ALL_OK) call cg_error_exit_f

! *** Add an attribute under RigidGridMotion_t
	    call cg_descriptor_write_f('DescriptorName',
     &                                 'DescriptotText', ier)
	    if (ier .ne. ALL_OK) call cg_error_exit_f

! *** Add a DataArray_t under RigidGridMotion_t
	    data_size(1)=phys_dim
	    data_size(2)=2
            !call cg_array_write_f('OriginLocation', RealSingle, 2,
            call cg_array_write_f('OriginLocation', RealDouble, 2,
     &                             data_size, origin, ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f

            !call cg_array_write_f('RigidRotationAngle', RealSingle, 1,
            call cg_array_write_f('RigidRotationAngle', RealDouble, 1,
     &                             phys_dim, angle, ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f

	    !call cg_array_write_f('RigidVelocity', RealSingle, 1,
	    call cg_array_write_f('RigidVelocity', RealDouble, 1,
     &                             phys_dim, velocity, ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f

! *** Add an attribute for this data array: GOTO DataArray node
	    call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no,
     &                     'RigidGridMotion_t', rmotion_no,
     &                     'DataArray_t', 3, 'end')
	    if (ier .ne. ALL_OK) call cg_error_exit_f

            call cg_units_write_f(Kilogram, Meter, Second, Kelvin,
     &                            Radian, ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f

	enddo

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
! *** Arbitrary Grid Motion

        do amotion=1, 2

! *** Create the ArbitraryGridMotion_t node
            write(amotionname,100)'ArbitraryGridMotion#',amotion
	    call cg_arbitrary_motion_write_f(cg, base_no, zone_no,
     &           amotionname, DeformingGrid, amotion_no, ier)
	    if (ier .ne. ALL_OK) call cg_error_exit_f

! *** Goto the ArbitraryGridMotion_t node
            call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no,
     &                    'ArbitraryGridMotion_t', amotion_no, 'end')
            if (ier .ne. ALL_OK) call cg_error_exit_f

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
! *** Add an attribute under ArbitraryGridMotion_t
            call cg_descriptor_write_f('DescriptorName',
     &                                 'DescriptotText', ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f

! *** make up some dummy GridVelocityX values just for the test:
            do 13 k=1, size(3)
            do 13 j=1, size(2)
            do 13 i=1, size(1)
                pos = i + (j-1)*size(1) + (k-1)*size(1)*size(2)
		GridVelocity(pos) = pos
 13	    continue

! *** Add a DataArray_t 'GridVelocityX' under ArbitraryGridMotion_t
            !call cg_array_write_f('GridVelocityX', RealSingle,
            call cg_array_write_f('GridVelocityX', RealDouble,
     &		                  index_dim, size, GridVelocity, ier)
	    if (ier .ne. ALL_OK) call cg_error_exit_f

! *** Add an attribute for this data array: GOTO DataArray node
            call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no,
     &                    'ArbitraryGridMotion_t', amotion_no,
     &                    'DataArray_t', 1, 'end')
            if (ier .ne. ALL_OK) call cg_error_exit_f

            call cg_units_write_f(Kilogram, Meter, Second, Kelvin,
     &                            Radian, ier)
            if (ier .ne. ALL_OK) call cg_error_exit_f
	enddo

! *** close CGNS file
	call cg_close_f(cg, ier)
	if (ier .ne. ALL_OK) call cg_error_exit_f

 100	format(a,i1)
	end

      program write_convergence
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Adds convergence history to an existing CGNS file.
!
!   The CGNS grid file 'grid.cgns' must already exist.
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c write_convergence.F90
!   ifort -o write_convergence write_convergence.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
      integer, parameter :: ntt=20
      real*8 cl(ntt)
      integer index_base,index_file,ier,n
      integer(cgsize_t) nuse
!
      write(6,'('' Program write_convergence'')')
      if (CG_BUILD_64BIT) then
        write(6,'('' ...using 64-bit mode for particular integers'')')
      end if
!
!   create history array simple example:
      do n=1,ntt
        cl(n)=float(n)
      enddo
      write(6,'('' created simple cl history'')')
!
!  WRITE CONVERGENCE HISTORY INFORMATION TO EXISTING CGNS FILE
!  open CGNS file for modify
      call cg_open_f('grid.cgns',CG_MODE_MODIFY,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!  we know there is only one base (real working code would check!)
      index_base=1
!   go to base node
      call cg_goto_f(index_file,index_base,ier,'end')
!   create history node (SIDS names it GlobalConvergenceHistory at base level)
      call cg_convergence_write_f(ntt,CHAR(0),ier)
!   go to new history node
      call cg_goto_f(index_file,index_base,ier,'ConvergenceHistory_t',1,'end')
!   write lift coefficient array (user must use SIDS-standard name here)
      nuse=ntt
      call cg_array_write_f('CoefLift',CGNS_ENUMV(RealDouble),1,[nuse],cl,ier)
!  close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully wrote cl history to file grid.cgns'')')
      stop
      end

	program modify_cprop
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on August 2002

!       This example test modifying the GridConnectivityProperty_t data structure and its children

#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 3)
	integer index_dim, cell_dim, phys_dim
	integer cg, base, zone, conn, ier, size(Ndim*3), i, num, n
	integer nbases
	integer dim_vals(2)
	integer AverageInterfaceType, pnts(Ndim,20), donor_pnts(Ndim,20)
	real *4 RotationCenter(Ndim), RotationAngle(Ndim)
	real *4 Translation(Ndim), version
	character*100 linkpath
	character*32 basename

! *** initialize
	ier = 0
	index_dim=Ndim
	cell_dim=Ndim
	phys_dim=Ndim

! *** open CGNS file for writing
 	call cg_open_f('Test_V2', MODE_MODIFY, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,600)'MODIFYING FILE Test_V2'

! *** CGNS Library Version used for file creation:
        call cg_version_f(cg, version, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,102)
     &     'Library Version used for file creation:',version

! *** base
        call cg_nbases_f(cg, nbases, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,200)'nbases=',nbases

        base=1

        call cg_base_read_f(cg, base, basename, cell_dim, phys_dim, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,300)'BaseName = "',basename,'"',
     &                'cell_dimension=',cell_dim

        zone = 1
	conn = 2

! *** write GridConnectivityProperty_t/AverageInterface_t node under conn#2
	AverageInterfaceType = AverageCircumferential
	call cg_conn_average_write_f(cg, base, zone,
     &        conn, AverageInterfaceType, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** test calling it again
!	call cg_conn_average_write_f(cg, base, zone,
!    &        conn, AverageInterfaceType, ier)
!       if (ier .eq. ERROR) call cg_error_print_f

! *** write GridConnectivityProperty_t/Periodic_t node under conn#2
	do n=1, Ndim
	    RotationCenter(n) = n*1.1
	    RotationAngle(n) = (n+3)*1.1
	    Translation(n) = (n+6)*1.1
	enddo
	call cg_conn_periodic_write_f(cg, base, zone, conn,
     & 	     RotationCenter, RotationAngle, Translation, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! *** write Descriptor_t, UserDefinedData_t & Link under...
! ...   GridConnectivityProperty_t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &      'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn,
     &	    'GridConnectivityProperty_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_descriptor_write_f('GridConnPropDescriptorName',
     &      'GridConnPropDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_user_data_write_f('GridConnPropUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

!	write(linkpath,'(a)') '/Basename/BaseDescriptorName'
!       call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
!       if (ier .eq. ERROR) call cg_error_exit_f

! ...   AverageInterface_t
	call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &	    'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn,
     &      'GridConnectivityProperty_t', 1, 'AverageInterface_t', 1,
     &      'end')
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_descriptor_write_f('AverageInterfaceDescriptorName',
     &	    'AverageInterfaceDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_user_data_write_f('AverageInterfaceUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! ...   Periodic_t
        call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &      'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn,
     &      'GridConnectivityProperty_t', 1, 'Periodic_t', 1, 'end')
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_descriptor_write_f('PeriodicDescriptorName',
     &	    'PeriodicDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_user_data_write_f('PeriodicUserData', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * DataClass & DimensionalUnits under Periodic
        call cg_dataclass_write_f(Dimensional, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        call cg_units_write_f(Kilogram, Meter, Second, Kelvin,
     &                        Radian, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * DataArray under Periodic
 	dim_vals(1)=3
 	dim_vals(2)=2
 	call cg_array_write_f('arraysize', Integer, 2, dim_vals,
     &        size, ier)
 	if (ier .ne. ERROR) write(6,'(a)') 'Error in API'

! * DataClass & DimensionalUnits under RotationCenter
	call cg_goto_f(cg, base, ier, 'Zone_t', zone,
     &      'ZoneGridConnectivity_t', 1, 'GridConnectivity_t', conn,
     &      'GridConnectivityProperty_t', 1, 'Periodic_t', 1,
     &      'DataArray_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

	call cg_dataclass_write_f(Dimensional, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	call cg_units_write_f(Kilogram, Meter, Second, Kelvin,
     &	    		      Radian, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** close CGNS file
	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

 102    format(a,f8.3)
 200    format(a,i5)
 300    format(3a/a,i2)
 600    format(3a)

	end

      program read_timevert_str
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Opens an existing CGNS file that contains a simple 3-D
!   structured grid plus 3 different flow solutions (at VERTICES),
!   along with time-accurate info, and reads it.
!
!   The CGNS grid file 'grid.cgns' must already exist
!   (created using write_grid_str.f followed by
!   write_timevert_str.f)
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c read_timevert_str.F90
!   ifort -o read_timevert_str read_timevert_str.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
!   dimension statements (note that tri-dimensional arrays
!   r1, r2, r3 and p1, p2, p3
!   must be dimensioned exactly as (21,17,N) (N>=9)
!   for this particular case or else they will be written to
!   the CGNS file incorrectly!  Other options are to use 1-D
!   arrays, use dynamic memory, or pass index values to a
!   subroutine and dimension exactly there):
      real*4 r1(21,17,9),p1(21,17,9)
      real*4 r2(21,17,9),p2(21,17,9)
      real*4 r3(21,17,9),p3(21,17,9)
      real*4 time(3)
      integer(cgsize_t) isize(3,3),irmin(3),irmax(3)
      integer(cgsize_t) idims(2),id2(1)
      integer n,idatatype,id1,nsteps,narrays,isim,loc
      integer index_zone,index_base,index_file,ier
      character zonename*32,bitername*32,zitername*32
      character arrayname*32
      character solname(3)*32,solname2*32
!
!   READ FLOW SOLUTION FROM CGNS FILE
!   open CGNS file for read-only
      call cg_open_f('grid.cgns',CG_MODE_READ,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!   we know there is only one base (real working code would check!)
      index_base=1
!   we know there is only one zone (real working code would check!)
      index_zone=1
!   get zone size (and name - although not needed here)
      call cg_zone_read_f(index_file,index_base,index_zone,zonename,           &
           isize,ier)
!   lower range index
      irmin(1)=1
      irmin(2)=1
      irmin(3)=1
!   upper range index - use vertex dimensions
      irmax(1)=isize(1,1)
      irmax(2)=isize(2,1)
      irmax(3)=isize(3,1)
!   read BaseIterativeData
      call cg_biter_read_f(index_file,index_base,bitername,nsteps,ier)
      write(6,'('' number of time steps stored = '',i5)') nsteps
      if (nsteps .ne. 3) then
        write(6,'('' Error, expecting nsteps=3!'')')
        stop
      end if
      call cg_goto_f(index_file,index_base,ier,'BaseIterativeData_t',1,'end')
      call cg_narrays_f(narrays,ier)
      if (narrays .ne. 1) then
        write(6,'('' Error, expecting 1 array in BaseIterativeData'',          &
         ''... there are '',i5)') narrays
        stop
      end if
      call cg_array_info_f(1,arrayname,idatatype,id1,id2,ier)
      if (id1 .ne. 1 .or. id2(1) .ne. 3) then
        write(6,'('' Error, expecting data dimension and vector to'',          &
         '' be 1 and 3 in BaseIterativeData... read '',2i5)') id1,id2(1)
        stop
      end if
      call cg_array_read_as_f(1,CGNS_ENUMV(RealSingle),time,ier)
      write(6,'('' Times stored are:'')')
      do n=1,nsteps
        write(6,'(f12.3)') time(n)
      enddo
!   read ZoneIterativeData
      call cg_ziter_read_f(index_file,index_base,index_zone,zitername,ier)
      call cg_goto_f(index_file,index_base,ier,'Zone_t',                       &
           index_zone,'ZoneIterativeData_t',1,'end')
      call cg_narrays_f(narrays,ier)
      if (narrays .ne. 1) then
        write(6,'('' Error, expecting 1 array in ZoneIterativeData'',          &
         ''... there are '',i5)') narrays
        stop
      end if
      call cg_array_info_f(1,arrayname,idatatype,id1,idims,ier)
      if (id1 .ne. 2 .or. idims(1) .ne. 32) then
        write(6,'('' Error, expecting data dimension and vector to'',          &
         '' be 2 and 32 in ZoneIterativeData... read '',2i5)') id1,            &
         idims(1)
        stop
      end if
      call cg_array_read_as_f(1,CGNS_ENUMV(Character),solname,ier)
      write(6,'('' Flow solution names corresponding to each are:'')')
      do n=1,nsteps
        write(6,'(a32)') solname(n)
      enddo
!   read SimulationType
      call cg_simulation_type_read_f(index_file,index_base,isim,ier)
      write(6,'('' Simulation type is: '',a32)') SimulationTypeName(isim)
!   do loop to read flow solutions
      do n=1,nsteps
!   check that soln names match, and also check GridLocation (real
!   working code would check to make sure there are no Rind cells
!   also!):
      call cg_sol_info_f(index_file,index_base,index_zone,n,                   &
           solname2,loc,ier)
      if (solname2 .ne. solname(n)) then
        write(6,'('' Error, soln names do not match'')')
        stop
      end if
      if (loc .ne. CGNS_ENUMV(Vertex)) then
        write(6,'('' Error, GridLocation must be Vertex!  Currently:'',        &
         a32)') GridLocationName(loc)
        stop
      end if
      if (n .eq. 1) then
      call cg_field_read_f(index_file,index_base,index_zone,n,                 &
           'Density',CGNS_ENUMV(RealSingle),irmin,irmax,r1,ier)
      call cg_field_read_f(index_file,index_base,index_zone,n,                 &
           'Pressure',CGNS_ENUMV(RealSingle),irmin,irmax,p1,ier)
      else if (n .eq. 2) then
      call cg_field_read_f(index_file,index_base,index_zone,n,                 &
           'Density',CGNS_ENUMV(RealSingle),irmin,irmax,r2,ier)
      call cg_field_read_f(index_file,index_base,index_zone,n,                 &
           'Pressure',CGNS_ENUMV(RealSingle),irmin,irmax,p2,ier)
      else
      call cg_field_read_f(index_file,index_base,index_zone,n,                 &
           'Density',CGNS_ENUMV(RealSingle),irmin,irmax,r3,ier)
      call cg_field_read_f(index_file,index_base,index_zone,n,                 &
           'Pressure',CGNS_ENUMV(RealSingle),irmin,irmax,p3,ier)
      end if
      enddo
!   close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully read 3 flow solutions from file'',             &
       '' grid.cgns'')')
      write(6,'(''   For example, r1,p1(1,1,1)='',2f12.5)')                    &
       r1(1,1,1),p1(1,1,1)
      write(6,'(''                r2,p2(1,1,1)='',2f12.5)')                    &
       r2(1,1,1),p2(1,1,1)
      write(6,'(''                r3,p3(1,1,1)='',2f12.5)')                    &
       r3(1,1,1),p3(1,1,1)
      write(6,'(''   For example, r1,p1(21,17,9)='',2f12.5)')                  &
       r1(21,17,9),p1(21,17,9)
      write(6,'(''                r2,p2(21,17,9)='',2f12.5)')                  &
       r2(21,17,9),p2(21,17,9)
      write(6,'(''                r3,p3(21,17,9)='',2f12.5)')                  &
       r3(21,17,9),p3(21,17,9)
!
      write(6,'('' Program successful... ending now'')')
      stop
      end

	program modify_gravity
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on May 31 2002

!       This example test the Gravity_t data structure and its children
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 3)
	integer index_dim, cell_dim, phys_dim
	integer cg, base_no, ier, nbases
	real*4 gravity_vector(Ndim)
	character*100 linkpath
	character*32 basename
	real*4 version

! *** initialize
	ier = 0
	index_dim=Ndim
	cell_dim=Ndim
	phys_dim=Ndim

! *** open CGNS file for modifying
 	call cg_open_f('Test_V2', MODE_MODIFY, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f
	write(6,600)'MODIFYING FILE Test_V2'

! *** CGNS Library Version used for file creation:
        call cg_version_f(cg, version, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,102) &
           'Library Version used for file creation:',version

        call cg_nbases_f(cg, nbases, ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,200)'nbases=',nbases

! *** base
	base_no=1
        call cg_base_read_f(cg,base_no,basename,cell_dim,phys_dim,ier)
        if (ier .eq. ERROR) call cg_error_exit_f
        write(6,300)'BaseName = "',basename,'"', &
                      'cell_dimension=',cell_dim

! *** Delete the Gravity_t node
        call cg_goto_f(cg, base_no, ier, 'end')
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_delete_node_f('Gravity', ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** Re-write Gravity_t node
!	gravity_vector(1)=0
!		gravity_vector(2)=0
!		gravity_vector(3)=9.8
!		call cg_gravity_write_f(cg, base_no, gravity_vector, ier)
!		if (ier .eq. ERROR) call cg_error_exit_f

! *** write children of Gravity_t
!		call cg_goto_f(cg, base_no, ier, 'Gravity_t', 1, 'end')
!		if (ier .eq. ERROR) call cg_error_exit_f

! * Descriptor
!		call cg_descriptor_write_f('GravityDescriptorName',
!	  &       'GravityDescriptorText', ier)
!	 if (ier .eq. ERROR) call cg_error_exit_f

! * DataClass
!       call cg_dataclass_write_f(CGNS_ENUMV(Dimensional), ier)
!	if (ier .eq. ERROR) call cg_error_exit_f

! * DimensionalUnits
!		call cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), CGNS_ENUMV(Kelvin),
!	     &                        CGNS_ENUMV(Radian), ier)
!		if (ier .eq. ERROR) call cg_error_exit_f

! * UserDefinedData
!        call cg_user_data_write_f('UserData1', ier)
!        if (ier .eq. ERROR) call cg_error_exit_f

! * Link to BaseDescriptorName
!        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
!        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
!        if (ier .eq. ERROR) call cg_error_exit_f

! * GravityVector/Descriptor
!	call cg_goto_f(cg, base_no, ier, 'Gravity_t', 1, 'DataArray_t',
!     &                 1, 'end')
!        if (ier .eq. ERROR) call cg_error_exit_f
!	call cg_descriptor_write_f('GravityVectorDescriptorName',
!     &       'GravityVectorDescriptorText', ier)
!	if (ier .eq. ERROR) call cg_error_exit_f
	
! * GravityVector/DimensionalUnits
!	call cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), CGNS_ENUMV(Kelvin),
!     &                        CGNS_ENUMV(Radian), ier)
!        if (ier .eq. ERROR) call cg_error_exit_f

! *** close CGNS file
	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

 102    format(a,f5.3)
 200    format(a,i5)
 300    format(3a/a,i2)
 600    format(3a)
	end

MODULE ftests

  USE mpi
  USE ISO_C_BINDING
  USE CGNS
  USE testing_utils
  IMPLICIT NONE

#include "cgnstypes_f03.h"
#ifdef WINNT
  INCLUDE 'cgnswin_f.h'
#endif

  INTEGER(C_INT) commsize, commrank, mpi_err

CONTAINS

  SUBROUTINE general_ptests()

  INTEGER(cgsize_t), PARAMETER :: totcnt = 40320 * 10
  INTEGER, PARAMETER :: NLOOPS = 5000
  INTEGER(cgsize_t) npp
  INTEGER i, nb, nz, nerrs
  INTEGER ierr, F, B, Z, E, S
  INTEGER Cx, Cy, Cz, Fx, Fy, Fz, Ax, Ay, Az
  INTEGER(cgsize_t) sizes(3), start, END, n, j
  INTEGER(cgsize_t), PARAMETER :: start_1 = 1
  REAL*8 ts, te, tt, dsize
  REAL*8 dx(totcnt), dy(totcnt), dz(totcnt)
  INTEGER(cgsize_t), ALLOCATABLE, DIMENSION(:) :: ie
  CHARACTER*32 name
  CHARACTER*11 piomode(2)
  INTEGER :: istat
  INTEGER :: precision
  INTEGER, TARGET :: value

  DATA piomode /'independent','collective'/

  IF (commsize .GT. 8) THEN
     IF (commrank .EQ. 0) &
          PRINT *, 'number of processes must be 8 or less'
     CALL cgp_error_exit_f
     STOP
  ENDIF

  ALLOCATE(ie(1:4*totcnt), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, '*FAILED* allocation of ie'
     CALL cgp_error_exit_f()
  ENDIF

  npp = totcnt / commsize
  start = commrank * npp + 1
  end = start + npp - 1

  j = 0
  DO n=1,npp
     dx(n) = start + n - 1
     dy(n) = commrank + 1
     dz(n) = n
     DO i=1,4
        j = j + 1
        ie(j) = start + n - 1
     ENDDO
  ENDDO
  sizes(1) = totcnt
  sizes(2) = totcnt
  sizes(3) = 0

  dsize = (9.0 * totcnt * 8.0 + 4.0 * totcnt * 4.0) / (1024.0 * 1024.0)

  IF (commrank .EQ. 0) THEN
     WRITE(*,'(A,1X,I0)') 'number processes       =', commsize
     WRITE(*,'(A,1X,I0)') 'array size per process =', npp
     WRITE(*,'(A,1X,I0)') 'total array size       =', totcnt
     WRITE(*,'(A,1X,F11.6)') 'total Mb for all data  =', dsize
  ENDIF

  ! default is MPI_COMM_WORLD, but can set another communicator with this
  ! call cgp_mpi_comm_f(MPI_COMM_WORLD,ierr)

  ! Check repeated opening and closing of a file to detect issues with 
  ! missed closed HDF5 objects, CGNS-109.

  ! Note, this is extremely slow when used with Github Actions 
  ! and Linux, so it is disabled in that case.
#ifndef DISABLE_CGNS109
  DO n = 1, NLOOPS
     CALL cgp_open_f('pcgns_ftest.cgns',CG_MODE_WRITE,F,ierr)
     IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
     CALL cgp_close_f(F,ierr)
     IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
  ENDDO
#endif

  CALL cgp_open_f('pcgns_ftest.cgns',CG_MODE_WRITE,F,ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

  DO nb=1,2
     WRITE(name,'(a4,i2)') 'Base',nb
     CALL cg_base_write_f(F,name,3,3,B,ierr)
     IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
     CALL cgp_pio_mode_f(INT(nb-1,C_INT), ierr)
     IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

     DO nz=1,2
        WRITE(name,'(a4,i2)') 'Zone',nz
        CALL cg_zone_write_f(F,B,name,sizes,CGNS_ENUMV(Unstructured),Z,ierr)
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
        CALL cgp_coord_write_f(F,B,Z,CGNS_ENUMV(RealDouble),'CoordinateX',Cx,ierr)
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
        CALL cgp_coord_write_f(F,B,Z,CGNS_ENUMV(RealDouble),'CoordinateY',Cy,ierr)
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
        CALL cgp_coord_write_f(F,B,Z,CGNS_ENUMV(RealDouble),'CoordinateZ',Cz,ierr)
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
        CALL cgp_section_write_f(F,B,Z,'Tets',CGNS_ENUMV(TETRA_4),start_1,totcnt,0,E,ierr)
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
        CALL cg_sol_write_f(F,B,Z,'Solution',CGNS_ENUMV(Vertex),S,ierr)
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
        CALL cgp_field_write_f(F,B,Z,S,CGNS_ENUMV(RealDouble),'MomentumX',Fx,ierr)
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
        CALL cgp_field_write_f(F,B,Z,S,CGNS_ENUMV(RealDouble),'MomentumY',Fy,ierr)
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
        CALL cgp_field_write_f(F,B,Z,S,CGNS_ENUMV(RealDouble),'MomentumZ',Fz,ierr)
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
        CALL cg_goto_f(F,B,ierr,name,0,'end')
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
        CALL cg_user_data_write_f('User Data',ierr)
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
        CALL cg_gorel_f(F,ierr,'User Data',0,'end')
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
        CALL cgp_array_write_f('ArrayX',CGNS_ENUMV(RealDouble),1,totcnt,Ax,ierr)
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
        CALL cgp_array_write_f('ArrayY',CGNS_ENUMV(RealDouble),1,totcnt,Ay,ierr)
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
        CALL cgp_array_write_f('ArrayZ',CGNS_ENUMV(RealDouble),1,totcnt,Az,ierr)
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
        CALL MPI_BARRIER(MPI_COMM_WORLD, mpi_err)
        ts = MPI_WTIME()

        CALL cgp_coord_write_data_f(F,B,Z,Cx,start,END,dx,ierr)
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
        CALL cgp_coord_write_data_f(F,B,Z,Cy,start,END,dy,ierr)
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
        CALL cgp_coord_write_data_f(F,B,Z,Cz,start,END,dz,ierr)
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
        CALL cgp_elements_write_data_f(F,B,Z,E,start,END,ie,ierr)
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
        CALL cgp_field_write_data_f(F,B,Z,S,Fx,start,END,dx,ierr)
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
        CALL cgp_field_write_data_f(F,B,Z,S,Fy,start,END,dy,ierr)
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
        CALL cgp_field_write_data_f(F,B,Z,S,Fz,start,END,dz,ierr)
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
        CALL cg_goto_f(F,B,ierr,'Zone_t',Z,'UserDefinedData_t',1,'end')
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
        CALL cgp_array_write_data_f(Ax,start,END,dx,ierr)
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
        CALL cgp_array_write_data_f(Ay,start,END,dy,ierr)
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
        CALL cgp_array_write_data_f(Az,start,END,dz,ierr)
        IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

        CALL MPI_BARRIER(MPI_COMM_WORLD, mpi_err)
        te = MPI_WTIME()
        tt = te - ts;
        IF (commrank .EQ. 0) &
             WRITE(*,'(A,F11.6,A,F11.6,A)') 'write:',tt,' secs,', dsize/tt, ' Mb/sec ('// piomode(nb)//')'
     ENDDO
  ENDDO
  CALL cgp_close_f(F,ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
  CALL cgp_open_f('pcgns_ftest.cgns',CG_MODE_READ,F,ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

  CALL cg_precision_f(F, PRECISION, ierr)
  IF (commrank .EQ. 0) WRITE(*,'(A,I0)') 'cg_precision_f PRECISION ',PRECISION

  Z = 1
  S = 1
  E = 1
  DO B=1,2
     CALL cgp_pio_mode_f(INT(B-1,C_INT),ierr)
     IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

     CALL MPI_BARRIER(MPI_COMM_WORLD, mpi_err)
     ts = MPI_WTIME()

     CALL cgp_coord_read_data_f(F,B,Z,1,start,END,dx,ierr)
     IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
     CALL cgp_coord_read_data_f(F,B,Z,2,start,END,dy,ierr)
     IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
     CALL cgp_coord_read_data_f(F,B,Z,3,start,END,dz,ierr)
     IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
     CALL cgp_elements_read_data_f(F,B,Z,E,start,END,ie,ierr)
     IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

     CALL MPI_BARRIER(MPI_COMM_WORLD, mpi_err)
     te = MPI_WTIME()
     tt = te - ts

     nerrs = 0
     j = 0
     DO n=1,npp
        IF (dx(n) .NE. (start+n-1)) nerrs = nerrs + 1
        IF (dy(n) .NE. (commrank+1)) nerrs = nerrs + 1
        IF (dz(n) .NE. n) nerrs = nerrs + 1
        DO i=1,4
           j = j + 1
         !  IF (ie(j) .NE. (start+n-1)) nerrs = nerrs + 1
        ENDDO
     ENDDO

     CALL MPI_BARRIER(MPI_COMM_WORLD, mpi_err)
     ts = MPI_WTIME()

     CALL cgp_field_read_data_f(F,B,Z,S,1,start,END,dx,ierr)
     IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
     CALL cgp_field_read_data_f(F,B,Z,S,2,start,END,dy,ierr)
     IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
     CALL cgp_field_read_data_f(F,B,Z,S,3,start,END,dz,ierr)
     IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

     CALL MPI_BARRIER(MPI_COMM_WORLD, mpi_err)
     te = MPI_WTIME()
     tt = tt + te - ts

     DO n=1,npp
        IF (dx(n) .NE. (start+n-1)) nerrs = nerrs + 1
        IF (dy(n) .NE. (commrank+1)) nerrs = nerrs + 1
        IF (dz(n) .NE. n) nerrs = nerrs + 1
     ENDDO

     CALL MPI_BARRIER(MPI_COMM_WORLD, mpi_err)
     ts = MPI_WTIME()
     CALL cg_goto_f(F,B,ierr,'Zone_t',Z,'UserDefinedData_t',1,'end')
     IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
     CALL cgp_array_read_data_f(1,start,END,dx,ierr)
     IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
     CALL cgp_array_read_data_f(2,start,END,dy,ierr)
     IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
     CALL cgp_array_read_data_f(3,start,END,dz,ierr)
     IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

     CALL MPI_BARRIER(MPI_COMM_WORLD, mpi_err)
     te = MPI_WTIME()
     tt = tt + te - ts

     DO n=1,npp
        IF (dx(n) .NE. (start+n-1)) nerrs = nerrs + 1
        IF (dy(n) .NE. (commrank+1)) nerrs = nerrs + 1
        IF (dz(n) .NE. n) nerrs = nerrs + 1
     ENDDO

     IF (commrank .EQ. 0) THEN
        WRITE(*,'(A,F11.6,A,F11.6,3A,I0)') 'read :',tt,' secs,',dsize/tt,' Mb/sec (', &
             piomode(B),') errors = ',nerrs
     ENDIF
  ENDDO

  CALL cgp_close_f(F,ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

! Disable with gfortran, GCC Bugzilla - Bug 99982
#ifndef __GFORTRAN__ 
  ! test cg_configure_f
  value = MPI_COMM_SELF
  CALL cg_configure_f(CG_CONFIG_HDF5_MPI_COMM, C_LOC(value), ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

  IF (commrank .EQ. 0) THEN
     CALL cgp_open_f('pcgns_ftest.cgns',CG_MODE_READ,F,ierr)
     IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
     CALL cgp_close_f(F,ierr)
     IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
  ENDIF
#endif

END SUBROUTINE general_ptests

SUBROUTINE multisets()

  IMPLICIT NONE

  INTEGER, PARAMETER :: dp = KIND(1.d0)
  INTEGER(CGSIZE_T), PARAMETER :: NodePerElem = 6
  INTEGER(cgsize_t) :: nelem = 1024

  INTEGER(CGSIZE_T) :: Nnodes
  INTEGER :: err
  INTEGER :: fn
  INTEGER :: B
  INTEGER :: Z
  INTEGER :: S
  INTEGER :: Cx,Cy,Cz, Fx, Fy, Fz, Ar, Ai
  INTEGER :: cell_dim = 3
  INTEGER :: phys_dim = 3
  INTEGER :: r_cell_dim = 0
  INTEGER :: r_phys_dim = 0
  INTEGER(CGSIZE_T), DIMENSION(1:3) :: nijk, sizes
  INTEGER(CGSIZE_T) :: min, max
  INTEGER(CGSIZE_T), DIMENSION(1) :: vmin, vmax
  INTEGER(CGSIZE_T) :: k, count
  ! For writing and reading data
  REAL(KIND=dp), DIMENSION(:), ALLOCATABLE, TARGET :: Coor_x
  REAL(KIND=dp), DIMENSION(:), ALLOCATABLE, TARGET :: Coor_y
  REAL(KIND=dp), DIMENSION(:), ALLOCATABLE, TARGET :: Coor_z
  REAL(KIND=dp), DIMENSION(:), ALLOCATABLE, TARGET :: Data_Fx
  REAL(KIND=dp), DIMENSION(:), ALLOCATABLE, TARGET :: Data_Fy
  REAL(KIND=dp), DIMENSION(:), ALLOCATABLE, TARGET :: Data_Fz
  REAL(KIND=dp), DIMENSION(:), ALLOCATABLE, TARGET :: Array_r
  INTEGER(CGSIZE_T), DIMENSION(:), ALLOCATABLE, TARGET :: Array_i
  INTEGER(CGSIZE_T) :: start, iend, emin, emax
  INTEGER(CGSIZE_T), DIMENSION(:), ALLOCATABLE :: elements
  CHARACTER(LEN=32) :: fname, name
  CHARACTER(LEN=180) :: bname, zname
  INTEGER :: indx_null
  REAL(KIND=dp) t0, t1, t2
  TYPE(C_PTR), DIMENSION(1:2) :: buf2
  TYPE(C_PTR), DIMENSION(1:3) :: buf3

  INTEGER :: ierr
  INTEGER :: istat
  CHARACTER(LEN=6) :: ichr6
  INTEGER, DIMENSION(1:3) :: Cvec, Fvec
  INTEGER, DIMENSION(1:2) :: Avec

  INTEGER :: piomode = CGP_COLLECTIVE

  WRITE(ichr6,'(I6.6)') commsize

  CALL cgp_pio_mode_f(piomode, ierr)

  Nnodes = Nelem*NodePerElem

  nijk(1) = Nnodes ! Number of vertices
  nijk(2) = Nelem  ! Number of cells
  nijk(3) = 0      ! Number of boundary vertices

  ! ======================================
  ! ==    **WRITE THE CGNS FILE **      ==
  ! ======================================

  CALL cgp_open_f('pcgns_ftest_md.cgns', CG_MODE_WRITE, fn, err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "cgp_open_f")
     CALL cgp_error_exit_f()
  ENDIF

  CALL cg_base_write_f(fn, "Base 1", cell_dim, phys_dim, B, err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "cg_base_write_f")
     CALL cgp_error_exit_f()
  ENDIF

  CALL cg_zone_write_f(fn, B, "Zone 1", nijk, CGNS_ENUMV(Unstructured), Z, err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "cg_zone_write_f")
     CALL cgp_error_exit_f()
  ENDIF

  ! ======================================
  ! == (A) WRITE THE NODAL COORDINATES  ==
  ! ======================================

  count = nijk(1)/commsize

  ALLOCATE(Coor_x(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, '*FAILED* allocation of Coor_x'
     CALL cgp_error_exit_f()
  ENDIF
  ALLOCATE(Coor_y(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, '*FAILED* allocation of Coor_y'
     CALL cgp_error_exit_f()
  ENDIF
  ALLOCATE(Coor_z(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, '*FAILED* allocation of Coor_z'
     CALL cgp_error_exit_f()
  ENDIF

  vmin(1) = count*commrank+1
  vmax(1) = count*(commrank+1)

  DO k = 1, count
     Coor_x(k) = REAL(commrank*count + k, KIND=dp) + 0.1_dp
     Coor_y(k) = Coor_x(k) + 0.1_dp
     Coor_z(k) = Coor_y(k) + 0.1_dp
  ENDDO

  CALL cgp_coord_write_f(fn,B,Z,CGNS_ENUMV(RealDouble),"CoordinateX",Cx,err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed,"cgp_coord_write_f (Coor_X)")
     CALL cgp_error_exit_f()
  ENDIF
  CALL cgp_coord_write_f(fn,B,Z,CGNS_ENUMV(RealDouble),"CoordinateY",Cy,err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "cgp_coord_write_f (Coor_Y)")
     CALL cgp_error_exit_f()
  ENDIF
  CALL cgp_coord_write_f(fn,B,Z,CGNS_ENUMV(RealDouble),"CoordinateZ",Cz,err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "cgp_coord_write_f (Coor_Z)")
     CALL cgp_error_exit_f()
  ENDIF

  Cvec(1:3) = (/Cx,Cy,Cz/)

  buf3(1) = C_LOC(Coor_x)
  buf3(2) = C_LOC(Coor_y)
  buf3(3) = C_LOC(Coor_z)

  CALL cgp_coord_multi_write_data_f(fn,B,Z,Cvec,vmin,vmax,3,buf3,err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "Test cgp_coord_multi_write_data_f")
     CALL cgp_error_exit_f()
  ELSE
     IF (commrank .EQ. 0) CALL write_test_status(passed, "Test cgp_coord_multi_write_data_f")
  ENDIF

  DEALLOCATE(Coor_x, Coor_y, Coor_z)

  ! ======================================
  ! == (B) WRITE THE CONNECTIVITY TABLE ==
  ! ======================================

  start = 1
  iend = nijk(2)
  CALL cgp_section_write_f(fn,B,Z,"Elements",CGNS_ENUMV(PENTA_6),start,iend,0,S,err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "cgp_section_write_f")
     CALL cgp_error_exit_f()
  ENDIF

  count = nijk(2)/commsize
  ALLOCATE(elements(1:count*NodePerElem), STAT = istat)
  IF (istat.NE.0)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "allocation of elements")
     CALL cgp_error_exit_f()
  ENDIF

  ! Create ridiculous connectivity table ...
  DO k = 1, count*NodePerElem
     elements(k) = commrank*count*NodePerElem + k
  ENDDO

  emin = count*commrank+1
  emax = count*(commrank+1)

  CALL cgp_elements_write_data_f(fn, B, Z, S, emin, emax, elements,err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "Test cgp_elements_write_data_f")
     CALL cgp_error_exit_f()
  ELSE
     IF (commrank .EQ. 0) CALL write_test_status(passed, "Test cgp_elements_write_data_f")
  ENDIF

  DEALLOCATE(elements)

  ! ======================================
  ! == (C) WRITE THE FIELD DATA         ==
  ! ======================================

  count = nijk(1)/commsize

  ALLOCATE(Data_Fx(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "allocation of Data_Fx")
     CALL cgp_error_exit_f()
  ENDIF
  ALLOCATE(Data_Fy(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "allocation of Data_Fy")
     CALL cgp_error_exit_f()
  ENDIF
  ALLOCATE(Data_Fz(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "allocation of Data_Fz")
     CALL cgp_error_exit_f()
  ENDIF

  DO k = 1, count
     Data_Fx(k) = REAL(commrank*count+k, KIND=dp) + .01_dp
     Data_Fy(k) = REAL(commrank*count+k, KIND=dp) + .02_dp
     Data_Fz(k) = REAL(commrank*count+k, KIND=dp) + .03_dp
  ENDDO

  CALL cg_sol_write_f(fn, B, Z, "Solution", CGNS_ENUMV(Vertex), S, err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "cg_sol_write_f")
     CALL cgp_error_exit_f()
  ENDIF

  CALL cgp_field_write_f(fn,B,Z,S,CGNS_ENUMV(RealDouble),"MomentumX",Fx, err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "cgp_field_write  (MomentumX)")
     CALL cgp_error_exit_f()
  ENDIF
  CALL cgp_field_write_f(fn,B,Z,S,CGNS_ENUMV(RealDouble),"MomentumY",Fy, err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "cgp_field_write (MomentumY)")
     CALL cgp_error_exit_f()
  ENDIF
  CALL cgp_field_write_f(fn,B,Z,S,CGNS_ENUMV(RealDouble),"MomentumZ",Fz, err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "cgp_field_write (MomentumZ)")
     CALL cgp_error_exit_f()
  ENDIF

  Fvec(1:3) = (/Fx,Fy,Fz/)

  buf3(1) = C_LOC(Data_Fx)
  buf3(2) = C_LOC(Data_Fy)
  buf3(3) = C_LOC(Data_Fz)

  CALL cgp_field_multi_write_data_f(fn,B,Z,S,Fvec,vmin,vmax,3,buf3,err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "Test cgp_field_multi_write_data_f")
     CALL cgp_error_exit_f()
  ELSE
     IF (commrank .EQ. 0) CALL write_test_status(passed, "Test cgp_field_multi_write_data_f")
  ENDIF

  DEALLOCATE(Data_Fx,Data_Fy,Data_Fz)

  ! ======================================
  ! == (D) WRITE THE ARRAY DATA         ==
  ! ======================================

  count = nijk(1)/commsize

  ALLOCATE(Array_r(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, "*FAILED* allocation of Array_r"
     CALL cgp_error_exit_f()
  ENDIF
  ALLOCATE(Array_i(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, "*FAILED* allocation of Array_i"
     CALL cgp_error_exit_f()
  ENDIF

  vmin(1) = count*commrank+1
  vmax(1)= count*(commrank+1)

  DO k = 1, count
     Array_r(k) = REAL(commrank*count + k, KIND=dp) + .001_dp
     Array_i(k) = commrank*count*NodePerElem + k
  ENDDO

  CALL cg_goto_f(fn, B, err, "Zone 1", 0, "end")
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "cg_goto_f")
     CALL cgp_error_exit_f()
  ENDIF
  CALL cg_user_data_write_f("User Data", err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "cg_user_data_write_f")
     CALL cgp_error_exit_f()
  ENDIF

  CALL cg_gorel_f(fn,err,"User Data",0,"end")
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "cg_gorel_f")
     CALL cgp_error_exit_f()
  ENDIF

  CALL cgp_array_write_f("ArrayR",cg_get_type(Array_r(1)),1,INT(nijk(1),cgsize_t),Ar, err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "cgp_array_write_f (Array_Ar)")
     CALL cgp_error_exit_f()
  ENDIF

  CALL cgp_array_write_f("ArrayI",cg_get_type(Array_i(1)),1,INT(nijk(1),cgsize_t),Ai, err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "cgp_array_write_f (Array_Ai)")
     CALL cgp_error_exit_f()
  ENDIF

  Avec = (/Ai,Ar/)
  buf2(1) = C_LOC(Array_i)
  buf2(2) = C_LOC(Array_r)
  CALL cgp_array_multi_write_data_f(fn,Avec,vmin,vmax,2,buf2,err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "Test cgp_array_multi_write_data_f")
     CALL cgp_error_exit_f()
  ELSE
     IF (commrank .EQ. 0) CALL write_test_status(passed, "Test cgp_array_multi_write_data_f")
  ENDIF

  DEALLOCATE(Array_r,Array_i)

  CALL cgp_close_f(fn, err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "cgp_close_f")
     CALL cgp_error_exit_f()
  ENDIF

  ! ======================================
  ! ==    **  READ THE CGNS FILE **     ==
  ! ======================================

  CALL MPI_Barrier(MPI_COMM_WORLD, mpi_err)

  ! Open the cgns file for reading
  CALL cgp_open_f('pcgns_ftest_md.cgns', CG_MODE_MODIFY, fn, err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "cgp_open_f")
     CALL cgp_error_exit_f()
  ENDIF

  ! Read the base information
  CALL cg_base_read_f(fn, B, bname, r_cell_dim, r_phys_dim, err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "cg_base_read_f")
     CALL cgp_error_exit_f()
  ENDIF
  IF(r_cell_dim.NE.cell_dim.OR.r_phys_dim.NE.phys_dim)THEN
     WRITE(*,'(2(A,I0))') '*FAILED* bad cell dim = ',r_cell_dim,'or phy dim =',r_phys_dim
     CALL cgp_error_exit_f()
  ENDIF

  IF(TRIM(bname).NE."Base 1")THEN
     WRITE(*,'(A,A)') "*FAILED* bad base name = ",TRIM(bname)
     CALL cgp_error_exit_f()
  ENDIF

  ! Read the zone information
  CALL cg_zone_read_f(fn, B, Z, zname, sizes, err)
  IF(err.NE.CG_OK.AND. commrank .EQ. 0) CALL write_test_status(failed, "cgp_zone_read_f")

  ! Check the read zone information is correct
  IF(sizes(1).NE.Nnodes)THEN
     WRITE(*,'(A,I0)') "*FAILED* bad num points = ",sizes(1)
     CALL cgp_error_exit_f()
  ENDIF

  IF(sizes(2).NE.Nelem)THEN
     WRITE(*,'(A,I0)') "*FAILED* bad num elements = ",sizes(2)
     CALL cgp_error_exit_f()
  ENDIF
  IF(sizes(3).NE.0)THEN
     WRITE(*,'(A,I0)') "*FAILED* bad num elements = ",sizes(3)
     CALL cgp_error_exit_f()
  ENDIF

  IF(TRIM(zname).NE.'Zone 1')THEN
     WRITE(*,'(A,A)') "*FAILED* bad zone name = ",TRIM(zname)
     CALL cgp_error_exit_f()
  ENDIF


  ! ======================================
  ! ==  (A) READ THE NODAL COORDINATES  ==
  ! ======================================

  count = nijk(1)/commsize
  ALLOCATE(Coor_x(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, "*FAILED* allocation of Coor_x"
     CALL cgp_error_exit_f()
  ENDIF
  ALLOCATE(Coor_y(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, "*FAILED* allocation of Coor_y"
     CALL cgp_error_exit_f()
  ENDIF
  ALLOCATE(Coor_z(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, "*FAILED* allocation of Coor_z"
     CALL cgp_error_exit_f()
  ENDIF

  vmin = count*commrank+1
  vmax = count*(commrank+1)

  Cvec(1:3) = (/Cx,Cy,Cz/)

  ! Point to the read buffers
  buf3(1) = C_LOC(Coor_x)
  buf3(2) = C_LOC(Coor_y)
  buf3(3) = C_LOC(Coor_z)

  CALL cgp_coord_multi_read_data_f(fn,B,Z,Cvec,vmin,vmax,3,buf3,err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "Test cgp_coord_multi_read_data_f")
     CALL cgp_error_exit_f()
  ELSE
     IF (commrank .EQ. 0) CALL write_test_status(passed, "Test cgp_coord_multi_read_data_f")
  ENDIF

  ! Check if read the data back correctly
  DO k = 1, count
     IF(.NOT.check_eq(Coor_x(k), REAL(commrank*count + k, KIND=DP) + 0.1_DP, 2).OR. &
          .NOT.check_eq(Coor_y(k), REAL(commrank*count + k, KIND=DP) + 0.2_DP, 2).OR. &
          .NOT.check_eq(Coor_z(k), REAL(commrank*count + k, KIND=DP) + 0.3_DP, 2)) THEN
        IF (commrank .EQ. 0) CALL write_test_status(failed, "Check cgp_coord_multi_read_data_f values", &
             "ERR: values are incorrect")
        CALL cgp_error_exit_f()
     ENDIF
  ENDDO
  IF (commrank .EQ. 0) CALL write_test_status(passed, "Check cgp_coord_multi_read_data_f values")

  DEALLOCATE(Coor_x, Coor_y, Coor_z)

  ! ======================================
  ! == (B) READ THE CONNECTIVITY TABLE  ==
  ! ======================================

  count = nijk(2)/commsize
  ALLOCATE(elements(1:count*NodePerElem), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, "*FAILED* allocation of elements"
     CALL cgp_error_exit_f()
  ENDIF

  emin = count*commrank+1
  emax = count*(commrank+1)

  CALL cgp_elements_read_data_f(fn, B, Z, S, emin, emax, elements, err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "Test cgp_elements_read_data_f", "( Reading elements)")
     CALL cgp_error_exit_f()
  ELSE
     IF (commrank .EQ. 0) CALL write_test_status(passed, "Test cgp_elements_read_data_f")
  ENDIF

  DO k = 1, count
     IF(.NOT.check_eq(elements(k), commrank*count*NodePerElem + k)) THEN
        IF (commrank .EQ. 0) CALL write_test_status(failed, "cgp_elements_read_data_f", &
             "ERR: values are incorrect")
        CALL cgp_error_exit_f()
     ENDIF
  ENDDO

  DEALLOCATE(elements)

  ! ======================================
  ! == (C) READ THE FIELD DATA          ==
  ! ======================================
  count = nijk(1)/commsize

  ALLOCATE(Data_Fx(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, "*FAILED* allocation of Data_Fx"
     CALL cgp_error_exit_f()
  ENDIF
  ALLOCATE(Data_Fy(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, "*FAILED* allocation of Data_Fy"
     CALL cgp_error_exit_f()
  ENDIF
  ALLOCATE(Data_Fz(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, "*FAILED* allocation of Data_Fz"
     CALL cgp_error_exit_f()
  ENDIF

  Fvec(1:3) = (/Fx,Fy,Fz/)

  buf3(1) = C_LOC(Data_Fx)
  buf3(2) = C_LOC(Data_Fy)
  buf3(3) = C_LOC(Data_Fz)

  CALL cgp_field_multi_read_data_f(fn,B,Z,S,Fvec,vmin,vmax,3,buf3,err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "Test cgp_field_multi_read_data_f")
     CALL cgp_error_exit_f()
  ELSE
     IF (commrank .EQ. 0) CALL write_test_status(passed, "Test cgp_field_multi_read_data_f")
  ENDIF

  ! Check if read the data back correctly
  DO k = 1, count
     IF(.NOT.check_eq(Data_Fx(k), REAL(commrank*count + k, KIND=dp) + 0.01_dp).OR. &
          .NOT.check_eq(Data_Fy(k), REAL(commrank*count + k, KIND=dp) + 0.02_dp).OR. &
          .NOT.check_eq(Data_Fz(k), REAL(commrank*count + k, KIND=dp) + 0.03_dp)) THEN
        IF (commrank .EQ. 0) CALL write_test_status(failed, "cgp_field_multi_read_data_f", &
                "ERR: values are incorrect")
        CALL cgp_error_exit_f()
     ENDIF
  ENDDO
  IF (commrank .EQ. 0) CALL write_test_status(passed, "Check cgp_field_multi_read_data_f values")
  DEALLOCATE(Data_Fx,Data_Fy,Data_Fz)

  ! ======================================
  ! == (D) READ THE ARRAY DATA          ==
  ! ======================================

  count = nijk(1)/commsize

  ALLOCATE(Array_r(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, "*FAILED* allocation of Array_r"
     CALL cgp_error_exit_f()
  ENDIF
  ALLOCATE(Array_i(1:count), STAT = istat)
  IF (istat.NE.0)THEN
     PRINT*, "*FAILED* allocation of Array_i"
     CALL cgp_error_exit_f()
  ENDIF

  vmin = count*commrank+1
  vmax = count*(commrank+1)

  CALL cg_goto_f(fn, B, err, "Zone_t",Z,"UserDefinedData_t",1,"end")
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "cg_goto_f","cg_goto (User Defined Data)")
     CALL cgp_error_exit_f()
  ENDIF

  Avec = (/Ai,Ar/)

  buf2(1) = C_LOC(Array_i)
  buf2(2) = C_LOC(Array_r)

  CALL cgp_array_multi_read_data_f(fn,Avec,vmin,vmax,2,buf2,err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "Test cgp_array_multi_read_data_f","cgp_array_multi_read_data_f")
     CALL cgp_error_exit_f()
  ELSE
     IF (commrank .EQ. 0) CALL write_test_status(passed, "Test cgp_array_multi_read_data_f")
  ENDIF

  ! Check if read the data back correctly
  DO k = 1, count
     IF(.NOT.check_eq(Array_r(k), REAL(commrank*count + k, KIND=dp) + 0.001_dp).OR. &
          .NOT.check_eq(Array_i(k), commrank*count*NodePerElem + k)) THEN
        IF (commrank .EQ. 0) CALL write_test_status(failed, "Check cgp_array_multi_read_data_f",&
                "ERR: values are incorrect")
        CALL cgp_error_exit_f()
     ENDIF
  ENDDO
  IF (commrank .EQ. 0) CALL write_test_status(passed, "Check cgp_array_multi_read_data_f values")

  DEALLOCATE(Array_r, Array_i)

  CALL cgp_close_f(fn, err)
  IF(err.NE.CG_OK)THEN
     IF (commrank .EQ. 0) CALL write_test_status(failed, "cgp_close")
     CALL cgp_error_exit_f()
  ENDIF

END SUBROUTINE multisets


SUBROUTINE particle()

  IMPLICIT NONE

  CHARACTER(LEN=32) :: fname
  INTEGER :: fn, B, P, S
  INTEGER :: Cx, Cy, Cz, Fx, Fy, Fz
  INTEGER :: cell_dim = 3, phys_dim = 3
  INTEGER :: r_cell_dim = 0, r_phys_dim = 0
  INTEGER(cgsize_t) :: num_particles = 1024, size
  INTEGER(cgsize_t), DIMENSION(1) :: min_v, max_v
  INTEGER(cgsize_t) :: min_s, max_s
  INTEGER(cgsize_t) :: count, k
  REAL(KIND=8), DIMENSION(:), ALLOCATABLE, TARGET :: Coor_x, Coor_y, Coor_z
  REAL(KIND=8), DIMENSION(:), ALLOCATABLE, TARGET :: Data_Fx, Data_Fy, Data_Fz
  CHARACTER(LEN=32) :: name
  INTEGER :: piomode = CGP_COLLECTIVE
  INTEGER :: ier
  INTEGER(cgsize_t) :: m_numdim = 1
  INTEGER(cgsize_t), DIMENSION(1) :: s_rmin, s_rmax, m_rmin, m_rmax
  INTEGER(cgsize_t) :: s_rmin_s, s_rmax_s, m_rmin_s, m_rmax_s
  INTEGER(cgsize_t), DIMENSION(1) :: m_arg_dimvals
  REAL, DIMENSION(:), ALLOCATABLE, TARGET :: Coor_z_float, Data_Fz_float

  TYPE(C_PTR) :: f_ptr

  ! Set PIO mode
  call cgp_pio_mode_f(piomode, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_pio_mode"
     CALL cgp_error_exit_f()
  END IF

  ! ======================================
  ! ==    **WRITE THE CGNS FILE **      ==
  ! ======================================

  ! Create filename
  WRITE(fname,'(A,I6.6,A)') "particle_test_", commsize, ".cgns"

  ! Open file and write base
  CALL cgp_open_f(fname, CG_MODE_WRITE, fn, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_open_f"
     CALL cgp_error_exit_f()
  END IF
  CALL cg_base_write_f(fn, "Base 1", cell_dim, phys_dim, B, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cg_base_write"
     CALL cgp_error_exit_f()
  END IF

  CALL cg_particle_write_f(fn, B, "Particle 1", num_particles, P, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cg_particle_write"
     CALL cgp_error_exit_f()
  END IF

  ! ========================================
  ! == (A) WRITE THE PARTICLE COORDINATES ==
  ! ========================================

  count = num_particles/commsize
  ALLOCATE(Coor_x(count), STAT=ier)
  IF(ier .NE. 0) THEN
     WRITE(*,*) "*FAILED* allocation of particle Coor_x"
     CALL cgp_error_exit_f()
  END IF

  ALLOCATE(Coor_y(count), STAT=ier)
  IF(ier .NE. 0) THEN
     WRITE(*,*) "*FAILED* allocation of particle Coor_y"
     CALL cgp_error_exit_f()
  END IF

  ALLOCATE(Coor_z(count), STAT=ier)
  IF(ier .NE. 0) THEN
     WRITE(*,*) "*FAILED* allocation of particle Coor_z"
     CALL cgp_error_exit_f()
  END IF

  min_v(1) = count*commrank + 1
  max_v(1) = count*(commrank + 1)

  min_s = min_v(1)
  max_s = max_v(1)

  DO k = 1, count
     Coor_x(k) = commrank*count + k + 1.1d0
     Coor_y(k) = Coor_x(k) + 0.1d0
     Coor_z(k) = Coor_y(k) + 0.1d0
  END DO

  ! Write coordinate data


  CALL cgp_particle_coord_write_f(fn, B, P, CGNS_ENUMV(RealDouble), "CoordinateX", Cx, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_particle_coord_write (Coor_x)"
     CALL cgp_error_exit_f()
  END IF

  CALL cgp_particle_coord_write_f(fn, B, P, CGNS_ENUMV(RealDouble), "CoordinateY", Cy, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_particle_coord_write (Coor_y)"
     CALL cgp_error_exit_f()
  END IF

  CALL cgp_particle_coord_write_f(fn, B, P, CGNS_ENUMV(RealDouble), "CoordinateZ", Cz, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_particle_coord_write (Coor_z)"
     CALL cgp_error_exit_f()
  END IF

  f_ptr = C_LOC(Coor_x(1))
  CALL cgp_particle_coord_write_data_f(fn, B, P, Cx, min_v, max_v, f_ptr, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_particle_coord_write_data (Coor_x)"
     CALL cgp_error_exit_f()
  END IF

  f_ptr = C_LOC(Coor_y)
  CALL cgp_particle_coord_write_data_f(fn, B, P, Cy, min_s, max_s, f_ptr, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_particle_coord_write_data (Coor_y)"
     CALL cgp_error_exit_f()
  END IF

  ! Set up general write parameters
  s_rmin(1) = min_s
  s_rmax(1) = max_s
  m_rmin(1) = 1
  m_rmax(1) = count
  m_arg_dimvals(1) = count

  f_ptr = C_LOC(Coor_z(1))
  CALL cgp_particle_coord_general_write_data_f(fn, B, P, Cz, s_rmin, s_rmax, &
       CGNS_ENUMV(RealDouble), m_numdim, m_arg_dimvals, m_rmin, m_rmax, f_ptr, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_particle_coord_general_write_data (Coor_z)"
     CALL cgp_error_exit_f()
  END IF

  DEALLOCATE(Coor_x, Coor_y, Coor_z)

  ! Write particle field data
  count = num_particles/commsize

  ALLOCATE(Data_Fx(count), STAT=ier)
  IF(ier .NE. 0) THEN
     WRITE(*,*) "*FAILED* allocation of Data_Fx"
     CALL cgp_error_exit_f()
  END IF

  ALLOCATE(Data_Fy(count), STAT=ier)
  IF(ier .NE. 0) THEN
     WRITE(*,*) "*FAILED* allocation of Data_Fy"
     CALL cgp_error_exit_f()
  END IF

  ALLOCATE(Data_Fz(count), STAT=ier)
  IF(ier .NE. 0) THEN
     WRITE(*,*) "*FAILED* allocation of Data_Fz"
     CALL cgp_error_exit_f()
  END IF

  DO k = 1, count
     Data_Fx(k) = commrank*count + k + 1.01d0
     Data_Fy(k) = commrank*count + k + 1.02d0
     Data_Fz(k) = commrank*count + k + 1.03d0
  END DO

  CALL cg_particle_sol_write_f(fn, B, P, "Solution", S, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cg_particle_sol_write"
     CALL cgp_error_exit_f()
  END IF

  CALL cgp_particle_field_write_f(fn, B, P, S, CGNS_ENUMV(RealDouble), "VelocityX", Fx, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_particle_field_write (VelocityX)"
     CALL cgp_error_exit_f()
  END IF

  CALL cgp_particle_field_write_f(fn, B, P, S, CGNS_ENUMV(RealDouble), "VelocityY", Fy, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_particle_field_write (VelocityY)"
     CALL cgp_error_exit_f()
  END IF

  CALL cgp_particle_field_write_f(fn, B, P, S, CGNS_ENUMV(RealDouble), "VelocityZ", Fz, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_particle_field_write (VelocityZ)"
     CALL cgp_error_exit_f()
  END IF

  CALL cgp_particle_field_write_data_f(fn, B, P, S, Fx, min_v, max_v, C_LOC(Data_Fx), ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_particle_field_write_data (VelocityX)"
     CALL cgp_error_exit_f()
  END IF

  min_s = min_v(1)
  max_s = max_v(1)

  CALL cgp_particle_field_write_data_f(fn, B, P, S, Fy, min_s, max_s, C_LOC(Data_Fy), ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_particle_field_write_data (VelocityY)"
     CALL cgp_error_exit_f()
  END IF

  CALL cgp_particle_field_general_write_data_f(fn, B, P, S, Fz, s_rmin, s_rmax, &
       CGNS_ENUMV(RealDouble), m_numdim, m_arg_dimvals, m_rmin, m_rmax,  C_LOC(Data_Fz), ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_particle_field_general_write_data (VelocityZ)"
     CALL cgp_error_exit_f()
  END IF

  DEALLOCATE(Data_Fx, Data_Fy, Data_Fz)

  CALL cgp_close_f(fn, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_close"
     CALL cgp_error_exit_f()
  END IF

  ! Read verification section
  CALL MPI_Barrier(MPI_COMM_WORLD, ier)

  ! Open file for reading
  CALL cgp_open_f(fname, CG_MODE_MODIFY, fn, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_open"
     CALL cgp_error_exit_f()
  END IF

  ! Read base information
  CALL cg_base_read_f(fn, B, name, r_cell_dim, r_phys_dim, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cg_base_read"
     CALL cgp_error_exit_f()
  END IF

  IF(r_cell_dim .NE. cell_dim .OR. r_phys_dim .NE. phys_dim) THEN
     WRITE(*,*) "*FAILED* bad cell dim=", r_cell_dim, " or phy dim=", r_phys_dim
     CALL cgp_error_exit_f()
  END IF

  IF(name .NE. "Base 1") THEN
     WRITE(*,*) "*FAILED* bad base name=", TRIM(name)
     CALL cgp_error_exit_f()
  END IF

  ! Read particle zone information
  CALL cg_particle_read_f(fn, B, P, name, size, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cg_particle_read"
     CALL cgp_error_exit_f()
  END IF

  IF(size .NE. num_particles) THEN
     WRITE(*,*) "bad num points=", size
     CALL cgp_error_exit_f()
  END IF

  IF(name .NE. "Particle 1") THEN
     WRITE(*,*) "bad zone name=", TRIM(name)
     CALL cgp_error_exit_f()
  END IF

  ! Read particle coordinates
  count = num_particles/commsize

  ALLOCATE(Coor_x(count), Coor_y(count), STAT=ier)
  IF(ier .NE. 0) THEN
     WRITE(*,*) "*FAILED* allocation of particle coordinates"
     CALL cgp_error_exit_f()
  END IF

  ALLOCATE(Coor_z_float(count), STAT=ier)
  IF(ier .NE. 0) THEN
     WRITE(*,*) "*FAILED* allocation of particle Coor_z_float"
     CALL cgp_error_exit_f()
  END IF

  min_v(1) = count*commrank + 1
  max_v(1) = count*(commrank + 1)

  ! Read and verify coordinates
  CALL cgp_particle_coord_read_data_f(fn, B, P, Cx, min_v, max_v, C_LOC(Coor_x), ier)
  IF(ier .NE. CG_OK) THEN
     IF(commrank == 0) CALL write_test_status(FAILED, "Test cgp_particle_coord_read_data (Coor_x)")
     CALL cgp_error_exit_f()
  ELSE
     IF(commrank == 0) CALL write_test_status(PASSED, "Test cgp_particle_coord_read_data (Coor_x)")
  END IF

  min_s = min_v(1)
  max_s = max_v(1)

  CALL cgp_particle_coord_read_data_f(fn, B, P, Cy, min_s, max_s, C_LOC(Coor_y), ier)
  IF(ier .NE. CG_OK) THEN
     IF(commrank == 0) CALL write_test_status(FAILED, "Test cgp_particle_coord_read_data (Coor_y)")
     CALL cgp_error_exit_f()
  ELSE
     IF(commrank == 0) CALL write_test_status(PASSED, "Test cgp_particle_coord_read_data (Coor_y)")
  END IF

  s_rmin_s = s_rmin(1)
  s_rmax_s = s_rmax(1)
  m_rmin_s = m_rmin(1)
  m_rmax_s = m_rmax(1)

  CALL cgp_particle_coord_general_read_data_f(fn, B, P, Cz, s_rmin_s, s_rmax_s, &
       CGNS_ENUMV(RealSingle), m_numdim, m_arg_dimvals(1), m_rmin_s, m_rmax_s, C_LOC(Coor_z_float), ier)
  IF(ier .NE. CG_OK) THEN
     IF(commrank == 0) CALL write_test_status(FAILED, "Test cgp_particle_coord_general_read_data (Coor_z_float)")
     CALL cgp_error_exit_f()
  ELSE
     IF(commrank == 0) CALL write_test_status(PASSED, "Test cgp_particle_coord_general_read_data (Coor_z_float)")
  END IF

  ! Verify coordinate values
  DO k = 1, count
     IF(.NOT. check_eq(Coor_x(k), commrank*count + k + 1.1d0) .OR. &
          .NOT. check_eq(Coor_y(k), Coor_x(k) + 0.1d0) .OR. &
          .NOT. check_eq(Coor_z_float(k), REAL(Coor_y(k) + 0.1))) THEN
        IF(commrank == 0) CALL write_test_status(FAILED, "Check cgp_particle_coord_read_data values")
        CALL cgp_error_exit_f()
     END IF
  END DO
  IF(commrank == 0) CALL write_test_status(PASSED, "Check cgp_particle_coord_read_data values")

  DEALLOCATE(Coor_x, Coor_y, Coor_z_float)

  ! Read particle field data
  count = num_particles/commsize

  ALLOCATE(Data_Fx(count), STAT=ier)
  IF(ier .NE. 0) THEN
     WRITE(*,*) "*FAILED* allocation of Reading Data_Fx"
     CALL cgp_error_exit_f()
  END IF

  ALLOCATE(Data_Fy(count), STAT=ier)
  IF(ier .NE. 0) THEN
     WRITE(*,*) "*FAILED* allocation of Reading Data_Fy"
     CALL cgp_error_exit_f()
  END IF

  ALLOCATE(Data_Fz_float(count), STAT=ier)
  IF(ier .NE. 0) THEN
     WRITE(*,*) "*FAILED* allocation of Reading Data_Fz_float"
     CALL cgp_error_exit_f()
  END IF

  CALL cgp_particle_field_read_data_f(fn, B, P, S, Fx, min_v, max_v, C_LOC(Data_Fx), ier)
  IF(ier .NE. CG_OK) THEN
     IF(commrank == 0) CALL write_test_status(FAILED, "Test cgp_particle_field_read_data (Data_Fx)")
     CALL cgp_error_exit_f()
  ELSE
     IF(commrank == 0) CALL write_test_status(PASSED, "Test cgp_particle_field_read_data (Data_Fx)")
  END IF

  min_s = min_v(1)
  max_s = max_v(1)

  CALL cgp_particle_field_read_data_f(fn, B, P, S, Fy, min_s, max_s, C_LOC(Data_Fy), ier)
  IF(ier .NE. CG_OK) THEN
     IF(commrank == 0) CALL write_test_status(FAILED, "Test cgp_particle_field_read_data (Data_Fy)")
     CALL cgp_error_exit_f()
  ELSE
     IF(commrank == 0) CALL write_test_status(PASSED, "Test cgp_particle_field_read_data (Data_Fy)")
  END IF

  CALL cgp_particle_field_general_read_data_f(fn, B, P, S, Fz, s_rmin, s_rmax, &
       CGNS_ENUMV(RealSingle), m_numdim, m_arg_dimvals, m_rmin, m_rmax, C_LOC(Data_Fz_float), ier)
  IF(ier .NE. CG_OK) THEN
     IF(commrank == 0) CALL write_test_status(FAILED, "Test cgp_particle_field_general_read_data (Data_Fz_float)")
     CALL cgp_error_exit_f()
  ELSE
     IF(commrank == 0) CALL write_test_status(PASSED, "Test cgp_particle_field_general_read_data (Data_Fz_float)")
  END IF

  ! Verify field values
  DO k = 1, count
     IF(.NOT. check_eq(Data_Fx(k), commrank*count + k + 1.01d0) .OR. &
          .NOT. check_eq(Data_Fy(k), commrank*count + k + 1.02d0) .OR. &
          .NOT. check_eq(Data_Fz_float(k), REAL(commrank*count + k + 1.03), 2) ) THEN
        IF(commrank == 0) CALL write_test_status(FAILED, "Check cgp_particle_field_read_data values")
        CALL cgp_error_exit_f()
     END IF
  END DO

  IF(commrank == 0) CALL write_test_status(PASSED, "Check cgp_particle_field_read_data values")

  DEALLOCATE(Data_Fx, Data_Fy, Data_Fz_float)

  CALL cgp_close_f(fn, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_close"
     CALL cgp_error_exit_f()
  END IF

END SUBROUTINE particle

SUBROUTINE particle_multisets()

  CHARACTER(LEN=32) :: fname
  INTEGER :: fn, B, P, S
  INTEGER :: Cvec(3), Fvec(3)
  INTEGER :: Cx, Cy, Cz, Fx, Fy, Fz
  INTEGER :: cell_dim = 3, phys_dim = 3
  INTEGER :: r_cell_dim = 0, r_phys_dim = 0
  INTEGER(cgsize_t) :: num_particles = 1024, size
  INTEGER(cgsize_t), DIMENSION(1) :: min_v, max_v
  INTEGER(cgsize_t) :: min_s, max_s
  INTEGER(cgsize_t) :: count, k
  REAL(KIND=8), DIMENSION(:), ALLOCATABLE, TARGET :: Coor_x, Coor_y, Coor_z
  REAL(KIND=8), DIMENSION(:), ALLOCATABLE, TARGET :: Data_Fx, Data_Fy, Data_Fz
  CHARACTER(LEN=32) :: name
  INTEGER :: piomode = CGP_COLLECTIVE
  INTEGER :: ier
  INTEGER :: m_numdim = 1
  INTEGER(cgsize_t), DIMENSION(1) :: s_rmin, s_rmax, m_rmin, m_rmax
  INTEGER(cgsize_t) :: m_arg_dimvals
  TYPE(C_PTR), DIMENSION(:), ALLOCATABLE :: buf

  ! Set PIO mode
  CALL cgp_pio_mode_f(piomode, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_pio_mode"
     CALL cgp_error_exit_f()
  END IF

  ! Create filename
  WRITE(fname,'(A,I6.6,A)') "particle_multiset_", commsize, ".cgns"
  ! Open file and write base
  CALL cgp_open_f(fname, CG_MODE_WRITE, fn, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_open"
     CALL cgp_error_exit_f()
  END IF

  CALL cg_base_write_f(fn, "Base 1", cell_dim, phys_dim, B, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cg_base_write"
     CALL cgp_error_exit_f()
  END IF

  CALL cg_particle_write_f(fn, B, "Particle 1", num_particles, P, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cg_particle_write"
     CALL cgp_error_exit_f()
  END IF

  ! Write particle coordinates
  count = num_particles/commsize

  ALLOCATE(Coor_x(count), STAT=ier)
  IF(ier .NE. 0) THEN
     WRITE(*,*) "*FAILED* allocation of particle Coor_x"
     CALL cgp_error_exit_f()
  END IF

  ALLOCATE(Coor_y(count), STAT=ier)
  IF(ier .NE. 0) THEN
     WRITE(*,*) "*FAILED* allocation of particle Coor_y"
     CALL cgp_error_exit_f()
  END IF

  ALLOCATE(Coor_z(count), STAT=ier)
  IF(ier .NE. 0) THEN
     WRITE(*,*) "*FAILED* allocation of particle Coor_z"
     CALL cgp_error_exit_f()
  END IF

  min_v(1) = count*commrank + 1
  max_v(1) = count*(commrank + 1)

  DO k = 1, count
     Coor_x(k) = commrank*count + k + 1.1d0
     Coor_y(k) = Coor_x(k) + 0.1d0
     Coor_z(k) = Coor_y(k) + 0.1d0
  END DO

  CALL cgp_particle_coord_write_f(fn, B, P, CGNS_ENUMV(RealDouble), "CoordinateX", Cx, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_particle_coord_write (Coor_x)"
     CALL cgp_error_exit_f()
  END IF

  CALL cgp_particle_coord_write_f(fn, B, P, CGNS_ENUMV(RealDouble), "CoordinateY", Cy, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_particle_coord_write (Coor_y)"
     CALL cgp_error_exit_f()
  END IF

  CALL cgp_particle_coord_write_f(fn, B, P, CGNS_ENUMV(RealDouble), "CoordinateZ", Cz, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_particle_coord_write (Coor_z)"
     CALL cgp_error_exit_f()
  END IF

  Cvec(1) = Cx
  Cvec(2) = Cy
  Cvec(3) = Cz

  ALLOCATE(buf(3))
  buf(1) = C_LOC(Coor_x)
  buf(2) = C_LOC(Coor_y)
  buf(3) = C_LOC(Coor_z)

  CALL cgp_particle_coord_multi_write_data_f(fn, B, P, Cvec, min_v, max_v, 3, buf, ier)

  IF(ier .NE. CG_OK) THEN
     IF(commrank == 0) CALL write_test_status(FAILED, "Test cgp_particle_coord_multi_write_data")
     CALL cgp_error_exit_f()
  ELSE
     IF(commrank == 0) CALL write_test_status(PASSED, "Test cgp_particle_coord_multi_write_data")
  END IF

  DEALLOCATE(buf)
  DEALLOCATE(Coor_x, Coor_y, Coor_z)

  ! Write particle field data
  count = num_particles/commsize

  ALLOCATE(Data_Fx(count), STAT=ier)
  IF(ier .NE. 0) THEN
     WRITE(*,*) "*FAILED* allocation of Data_Fx"
     CALL cgp_error_exit_f()
  END IF

  ALLOCATE(Data_Fy(count), STAT=ier)
  IF(ier .NE. 0) THEN
     WRITE(*,*) "*FAILED* allocation of Data_Fy"
     CALL cgp_error_exit_f()
  END IF

  ALLOCATE(Data_Fz(count), STAT=ier)
  IF(ier .NE. 0) THEN
     WRITE(*,*) "*FAILED* allocation of Data_Fz"
     CALL cgp_error_exit_f()
  END IF

  DO k = 1, count
     Data_Fx(k) = commrank*count + k + 1.01d0
     Data_Fy(k) = commrank*count + k + 1.02d0
     Data_Fz(k) = commrank*count + k + 1.03d0
  END DO

  CALL cg_particle_sol_write_f(fn, B, P, "Solution", S, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cg_particle_sol_write"
     CALL cgp_error_exit_f()
  END IF

  CALL cgp_particle_field_write_f(fn, B, P, S, CGNS_ENUMV(RealDouble), "VelocityX", Fx, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_particle_field_write (VelocityX)"
     CALL cgp_error_exit_f()
  END IF

  CALL cgp_particle_field_write_f(fn, B, P, S, CGNS_ENUMV(RealDouble), "VelocityY", Fy, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_particle_field_write (VelocityY)"
     CALL cgp_error_exit_f()
  END IF

  CALL cgp_particle_field_write_f(fn, B, P, S, CGNS_ENUMV(RealDouble), "VelocityZ", Fz, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_particle_field_write (VelocityZ)"
     CALL cgp_error_exit_f()
  END IF

  Fvec(1) = Fx
  Fvec(2) = Fy
  Fvec(3) = Fz

  ALLOCATE(buf(3))
  buf(1) = C_LOC(Data_Fx)
  buf(2) = C_LOC(Data_Fy)
  buf(3) = C_LOC(Data_Fz)

  min_s = min_v(1)
  max_s = max_v(1)

  CALL cgp_particle_field_multi_write_data_f(fn, B, P, S, Fvec, min_s, max_s, 3, buf, ier)
  IF(ier .NE. CG_OK) THEN
     IF(commrank == 0) CALL write_test_status(FAILED, "Test cgp_particle_field_multi_write_data")
     CALL cgp_error_exit_f()
  ELSE
     IF(commrank == 0) CALL write_test_status(PASSED, "Test cgp_particle_field_multi_write_data")
  END IF

  DEALLOCATE(buf)
  DEALLOCATE(Data_Fx, Data_Fy, Data_Fz)

  CALL cgp_close_f(fn, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_close"
     CALL cgp_error_exit_f()
  END IF

  ! Read verification section
  CALL MPI_Barrier(MPI_COMM_WORLD, ier)

  CALL cgp_open_f(fname, CG_MODE_MODIFY, fn, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_open"
     CALL cgp_error_exit_f()
  END IF
  ! Read base information
  CALL cg_base_read_f(fn, B, name, r_cell_dim, r_phys_dim, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cg_base_read"
     CALL cgp_error_exit_f()
  END IF

  IF(r_cell_dim .NE. cell_dim .OR. r_phys_dim .NE. phys_dim) THEN
     WRITE(*,*) "*FAILED* bad cell dim=", r_cell_dim, " or phy dim=", r_phys_dim
     CALL cgp_error_exit_f()
  END IF

  IF(name .NE. "Base 1") THEN
     WRITE(*,*) "*FAILED* bad base name=", TRIM(name)
     CALL cgp_error_exit_f()
  END IF

  CALL cg_particle_read_f(fn, B, P, name, size, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cg_particle_read"
     CALL cgp_error_exit_f()
  END IF

  IF(size .NE. num_particles) THEN
     WRITE(*,*) "bad num points=", size
     CALL cgp_error_exit_f()
  END IF

  IF(name .NE. "Particle 1") THEN
     WRITE(*,*) "bad zone name=", TRIM(name)
     CALL cgp_error_exit_f()
  END IF

  ! Read particle coordinates
  count = num_particles/commsize

  ALLOCATE(Coor_x(count), STAT=ier)
  IF(ier .NE. 0) THEN
     WRITE(*,*) "*FAILED* allocation of particle Coor_x"
     CALL cgp_error_exit_f()
  END IF

  ALLOCATE(Coor_y(count), STAT=ier)
  IF(ier .NE. 0) THEN
     WRITE(*,*) "*FAILED* allocation of particle Coor_y"
     CALL cgp_error_exit_f()
  END IF

  ALLOCATE(Coor_z(count), STAT=ier)
  IF(ier .NE. 0) THEN
     WRITE(*,*) "*FAILED* allocation of particle Coor_z"
     CALL cgp_error_exit_f()
  END IF

  min_v(1) = count*commrank + 1
  max_v(1) = count*(commrank + 1)

  ALLOCATE(buf(3))
  buf(1) = C_LOC(Coor_x)
  buf(2) = C_LOC(Coor_y)
  buf(3) = C_LOC(Coor_z)

  min_s = min_v(1)
  max_s = max_v(1)

  CALL cgp_particle_coord_multi_read_data_f(fn, B, P, Cvec, min_s, max_s, 3, buf, ier)
  IF(ier .NE. CG_OK) THEN
     IF(commrank == 0) CALL write_test_status(FAILED, "Test cgp_particle_coord_multi_read_data")
     CALL cgp_error_exit_f()
  ELSE
     IF(commrank == 0) CALL write_test_status(PASSED, "Test cgp_particle_coord_multi_read_data")
  END IF

  DO k = 1, count
     IF(.NOT. check_eq(Coor_x(k), commrank*count + k + 1.1d0) .OR. &
          .NOT. check_eq(Coor_y(k), Coor_x(k) + 0.1d0) .OR. &
          .NOT. check_eq(Coor_z(k), Coor_y(k) + 0.1d0)) THEN
        IF(commrank == 0) CALL write_test_status(FAILED, "Check cgp_particle_coord_multi_read_data values")
        CALL cgp_error_exit_f()
     END IF
  END DO
  IF(commrank == 0) CALL write_test_status(PASSED, "Check cgp_particle_coord_multi_read_data values")

  DEALLOCATE(buf)
  DEALLOCATE(Coor_x, Coor_y, Coor_z)

  ! Read particle field data
  count = num_particles/commsize

  ALLOCATE(Data_Fx(count), STAT=ier)
  IF(ier .NE. 0) THEN
     WRITE(*,*) "*FAILED* allocation of Reading Data_Fx"
     CALL cgp_error_exit_f()
  END IF

  ALLOCATE(Data_Fy(count), STAT=ier)
  IF(ier .NE. 0) THEN
     WRITE(*,*) "*FAILED* allocation of Reading Data_Fy"
     CALL cgp_error_exit_f()
  END IF

  ALLOCATE(Data_Fz(count), STAT=ier)
  IF(ier .NE. 0) THEN
     WRITE(*,*) "*FAILED* allocation of Reading Data_Fz"
     CALL cgp_error_exit_f()
  END IF

  ALLOCATE(buf(3))
  buf(1) = C_LOC(Data_Fx)
  buf(2) = C_LOC(Data_Fy)
  buf(3) = C_LOC(Data_Fz)

  CALL cgp_particle_field_multi_read_data_f(fn, B, P, S, Fvec, min_v, max_v, 3, buf, ier)
  IF(ier .NE. CG_OK) THEN
     IF(commrank == 0) CALL write_test_status(FAILED, "Test cgp_particle_field_multi_read_data")
     CALL cgp_error_exit_f()
  ELSE
     IF(commrank == 0) CALL write_test_status(PASSED, "Test cgp_particle_field_multi_read_data")
  END IF

  DO k = 1, count
     IF(.NOT. check_eq(Data_Fx(k), commrank*count + k + 1.01d0) .OR. &
          .NOT. check_eq(Data_Fy(k), commrank*count + k + 1.02d0) .OR. &
          .NOT. check_eq(Data_Fz(k), commrank*count + k + 1.03d0)) THEN
        IF(commrank == 0) CALL write_test_status(FAILED, "Check cgp_particle_field_multi_read_data values")
        CALL cgp_error_exit_f()
     END IF
  END DO
  IF(commrank == 0) CALL write_test_status(PASSED, "Check cgp_particle_field_multi_read_data values")

  DEALLOCATE(buf)
  DEALLOCATE(Data_Fx, Data_Fy, Data_Fz)

  CALL cgp_close_f(fn, ier)
  IF(ier .NE. CG_OK) THEN
     WRITE(*,*) "*FAILED* cgp_close"
     CALL cgp_error_exit_f()
  END IF

END SUBROUTINE particle_multisets

END MODULE ftests

PROGRAM pcgns_ftest

  USE ftests
  IMPLICIT NONE

  CALL MPI_INIT(mpi_err)
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,commsize,mpi_err)
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,commrank,mpi_err)

  IF(commrank.eq.0) CALL write_test_header("General Parallel CGNS Testing")
  CALL general_ptests()

  CALL MPI_Barrier(MPI_COMM_WORLD, mpi_err)
  IF(commrank.EQ.0) CALL write_test_header("Multi-sets API Testing")
  CALL multisets()

  CALL MPI_Barrier(MPI_COMM_WORLD, mpi_err)
  IF(commrank.EQ.0) CALL write_test_header("Particle API Testing")
  CALL particle()

  CALL MPI_Barrier(MPI_COMM_WORLD, mpi_err)
  IF(commrank.EQ.0) CALL write_test_header("Particle Multi-sets API Testing")
  CALL particle_multisets()

  IF(commrank.EQ.0) CALL write_test_footer()

  CALL MPI_FINALIZE(mpi_err)

END PROGRAM pcgns_ftest

      program write_flowvert_str
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Opens an existing CGNS file that contains a simple 3-D
!   structured grid, and adds a flow solution (at VERTICES)
!   to it.  (Compare this program with write_flowcent_str)
!
!   The CGNS grid file 'grid.cgns' must already exist
!   (created using write_grid_str.f)
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c write_flowvert_str.F90
!   ifort -o write_flowvert_str write_flowvert_str.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
!   dimension statements (note that tri-dimensional arrays
!   r and p must be dimensioned exactly as (21,17,N) (N>=9)
!   for this particular case or else they will be written to
!   the CGNS file incorrectly!  Other options are to use 1-D
!   arrays, use dynamic memory, or pass index values to a
!   subroutine and dimension exactly there):
      real*8 r(21,17,9),p(21,17,9)
      integer index_field,index_flow,index_zone,index_base,ier
      integer index_file,i,j,k,ni,nj,nk
      character solname*32
!
      write(6,'('' Program write_flowvert_str'')')
      if (CG_BUILD_64BIT) then
        write(6,'('' ...compiled in 64-bit mode, but not needed'')')
      end if
!
!   create fake flow solution AT VERTICES for simple example:
      ni=21
      nj=17
      nk=9
      do k=1,nk
        do j=1,nj
          do i=1,ni
            r(i,j,k)=float(i-1)
            p(i,j,k)=float(j-1)
          enddo
        enddo
      enddo
      write(6,'('' created simple 3-D rho and p flow solution'')')
!
!   WRITE FLOW SOLUTION TO EXISTING CGNS FILE
!   open CGNS file for modify
      call cg_open_f('grid.cgns',CG_MODE_MODIFY,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!   we know there is only one base (real working code would check!)
      index_base=1
!   we know there is only one zone (real working code would check!)
      index_zone=1
!   define flow solution node name (user can give any name)
      solname = 'FlowSolution'
!   create flow solution node
      call cg_sol_write_f(index_file,index_base,index_zone,solname,            &
           CGNS_ENUMV(Vertex),index_flow,ier)
!   write flow solution (user must use SIDS-standard names here)
      call cg_field_write_f(index_file,index_base,index_zone,index_flow,       &
           CGNS_ENUMV(RealDouble),'Density',r,index_field,ier)
      call cg_field_write_f(index_file,index_base,index_zone,index_flow,       &
           CGNS_ENUMV(RealDouble),'Pressure',p,index_field,ier)
!   close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully added Vertex flow solution data'',             &
       '' to file grid.cgns'')')
      write(6,'(''   Note:  if the original CGNS file already had'',           &
       '' a FlowSolution_t node,'')')
      write(6,'(''          it has been overwritten'')')
      stop
      end

!
! @file test_unstruc_quad_f90.F90
! @author Greg Sjaardema <gsjaardema@gmail.com>
!
! @section LICENSE
! BSD style license
!
! @section DESCRIPTION
! Test program for pcgns library
! -- Created to test cgp_parent_data_write function
! -- Based on test_unstructured_quad.c
!

!
!
! 2....4....6....8 8...10...12...14 14...16...18...20 L+1.L+3...L+5...L+7
! |    |    |    | |    |    |    | |     |    |    | |     |     |     |
! 1....3....5....7 7....9...11...13 13...15...17...19 L...L+2...L+4...L+6
!   1    2   3      4    5    6       7    8    9      M     M+1   M+2
!       P0               P1                P2             PN
!
!L = P*6+1   M = P*3+1
!The BC "Bottom" is on the bottom (y=0) edge of the mesh.
!The BC "Left"   is on the left (x=0) edge of the mesh.
! -- included to test whether works with 0 entries on some procs.
!


PROGRAM test_unstruc_quad_f

  USE mpi
  USE ISO_C_BINDING
  USE CGNS
  IMPLICIT NONE

#include "cgnstypes_f03.h"
#ifdef WINNT
  INCLUDE 'cgnswin_f.h'
#endif
  integer, parameter :: dp = kind(0.0d0)

  INTEGER vert_proc
  PARAMETER(vert_proc = 8)
  INTEGER depth
  PARAMETER(depth = 4)

  INTEGER(C_INT) comm_size, comm_rank, mpi_err
  INTEGER info
  INTEGER ierr
  INTEGER(cgsize_t) :: sizes(3)
  INTEGER(cgsize_t) :: n_boco_elems
  INTEGER(cgsize_t) :: start_local(1), end_local(1)
  INTEGER(cgsize_t) :: start, end
  INTEGER(cgsize_t) :: emin(1), emax(1)
  INTEGER(cgsize_t) :: rmin(1), rmax(1)
  INTEGER(cgsize_t) :: nelem, nvert
  INTEGER(cgsize_t), PARAMETER :: start_1 = 1
  INTEGER Cx, Cy, Cz, F, B, Z, S, BC
  INTEGER i, k
  INTEGER global_num_quads
  INTEGER(C_INT), DIMENSION(4) :: indices

  REAL(dp), allocatable ::  fx(:), fy(:), fz(:) 
  INTEGER(cgsize_t), allocatable, target :: elements(:)
  INTEGER(cgsize_t), allocatable :: point_list(:)
  INTEGER(cgsize_t), dimension(:), pointer :: el_ptr => null()
  INTEGER(cgsize_t), dimension(:), pointer :: null_ptr => null()
  LOGICAL found_point


  CHARACTER(len=10, kind=C_CHAR), allocatable, target :: labels(:)
  TYPE(C_PTR), dimension(:), allocatable :: pt_labels
!
!---- initialize MPI
  CALL MPI_INIT(mpi_err)
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD, comm_size, mpi_err)
  CALL MPI_COMM_RANK(MPI_COMM_WORLD, comm_rank, mpi_err)
  CALL MPI_INFO_CREATE(info, mpi_err)

! First define the label array on fortran side 
  allocate(labels(4))
  labels(1) = "Zone_t"//C_NULL_CHAR
  labels(2) = "ZoneBC_t"//C_NULL_CHAR
  labels(3) = "BC_t"//C_NULL_CHAR
  labels(4) = "PointList"//C_NULL_CHAR
! do mapping for C side
  allocate(pt_labels(4))
  pt_labels(1) = C_LOC(labels(1))
  pt_labels(2) = C_LOC(labels(2))
  pt_labels(3) = C_LOC(labels(3))
  pt_labels(4) = C_LOC(labels(4))

!---- open file and create base and zone
  nelem = 3*comm_size
  nvert = 2*nelem + 2
  sizes(1) = nvert
  sizes(2) = nelem
  sizes(3) = 0

  CALL cgp_open_f('test_uns_quad_f90.cgns', CG_MODE_WRITE, F, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
  CALL cg_base_write_f(F, 'Base#1', 3, 3, B, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
  CALL cg_zone_write_f(F, B, 'Zone_1', sizes, CGNS_ENUMV(Unstructured), Z, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

!---- create the coordinate data 
  allocate(fx(vert_proc))
  allocate(fy(vert_proc))
  allocate(fz(vert_proc))
  
  rmin(1) = 6*comm_rank+1
  rmax(1) = rmin(1)+7

  DO k=1,vert_proc,2
    fx(k+0) = real(rmin(1)+k, dp)
    fx(k+1) = real(rmin(1)+k, dp)
    fy(k+0) = 0.0
    fy(k+1) = 1.0
    fz(k+0) = 0.0
    fz(k+1) = 0.0
  ENDDO

!---- create data nodes for coordinates
  CALL cgp_coord_write_f(F, B, Z, CGNS_ENUMV(RealSingle), 'CoordinateX', Cx, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
  CALL cgp_coord_write_f(F, B, Z, CGNS_ENUMV(RealSingle), 'CoordinateY', Cy, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
  CALL cgp_coord_write_f(F, B, Z, CGNS_ENUMV(RealSingle), 'CoordinateZ', Cz, ierr)


!---- write the coordinate data in parallel
  CALL cgp_coord_write_data_f(F, B, Z, Cx, rmin, rmax, fx, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
  CALL cgp_coord_write_data_f(F, B, Z, Cy, rmin, rmax, fy, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
  CALL cgp_coord_write_data_f(F, B, Z, Cz, rmin, rmax, fz, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

  end = comm_size*3
!---- create data node for elements
  CALL cgp_section_write_f(F, B, Z, 'Elements', CGNS_ENUMV(QUAD_4), start_1, end, 0, S, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

  nelem = 3;
  emin(1) = comm_rank*3+1;
  emax(1) = emin(1)+2;

  PRINT *, 'rank ', comm_rank, ': ', nelem, ' elements'

  allocate(elements(nelem*4))
  DO k=1,nelem
    elements(4*(k-1)+1) = 2*(emin(1)+k-1)-1
    elements(4*(k-1)+2) = 2*(emin(1)+k-1)+1
    elements(4*(k-1)+3) = 2*(emin(1)+k-1)+2
    elements(4*(k-1)+4) = 2*(emin(1)+k-1)+0
  ENDDO

  PRINT *, comm_rank, ":", nelem, ":", emin(1), ":", emax(1)

!---- write the element connectivity in parallel
  CALL cgp_elements_write_data_f(F, B, Z, S, emin(1), emax(1), elements, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f


!---- create data node for elements
  start = 3*comm_size + 1
  end = start + 3*comm_size - 1
  CALL cgp_section_write_f(F, B, Z, 'Bottom', CGNS_ENUMV(BAR_2), start, end, 0, S, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

! Parent elements/side data 
  DO k=1,3
    elements(3*0+k) = comm_rank*3+k  ! Element
    elements(3*1+k) = 0
    elements(3*2+k) = 1 ! Side
    elements(3*3+k) = 0
  ENDDO

  emin(1) = comm_rank*3+start
  emax(1) = emin(1)+2
  PRINT *, comm_rank, ':', emin(1), ' ', emax(1) 
  
  CALL cgp_parent_data_write_f(F, B, Z, S, emin(1), emax(1), elements, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

! side connectivity
  DO k=1,3
    elements(2*(k-1)+1) = 2*(comm_rank*3+(k-1))+1
    elements(2*(k-1)+2) = 2*(comm_rank*3+(k-1))+3
  ENDDO
  CALL cgp_elements_write_data_f(F, B, Z, S, emin(1), emax(1), elements, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

  n_boco_elems = end-start+1

  CALL cg_boco_write_f(F, B, Z, "BottomBC", CGNS_ENUMV(FamilySpecified), CGNS_ENUMV(PointList), n_boco_elems, null_ptr, BC, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

  i = 1
  DO k=emin(1),emax(1)
    elements(i) = k
    i = i + 1
  ENDDO

  start_local(1) = comm_rank * 3 + 1
  end_local(1) = start_local(1) + 2
  PRINT *, comm_rank, ':', start_local(1), ' ', end_local(1) 

  indices(1) = Z
  indices(2) = 1
  indices(3) = BC
  indices(4) = 0

  ierr = cg_golist(F, B, depth, pt_labels, indices)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
  PRINT *, elements(1), elements(2), start_local(1), end_local(1)
  CALL cgp_ptlist_write_data_f(F, start_local(1), end_local(1), elements, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

  CALL cg_boco_gridlocation_write_f(F, B, Z, BC, CGNS_ENUMV(EdgeCenter), ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

! Add family tag
  ierr =  cg_golist(F, B, 3, pt_labels, indices)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

  CALL cg_famname_write_f("Bottom", ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f
  

! left BC
  start = end + 1
  end = start

  CALL cgp_section_write_f(F, B, Z, 'Left', CGNS_ENUMV(BAR_2), start, end, 0, S, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

  IF (comm_rank .EQ. 0) THEN
    emin(1) = start
    emax(1) = end
! Parent Element/Side data
    elements(1) = 1 ! Element
    elements(2) = 0
    elements(3) = 4 ! Side
    elements(4) = 0
    el_ptr => elements
  ELSE
    emin(1) = 0
    emax(1) = 0
    el_ptr => NULL()
  ENDIF
  PRINT *, comm_rank, ":", emin(1), " ", emax(1)

  CALL cgp_parent_data_write_f(F, B, Z, S, emin(1), emax(1), el_ptr, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

  IF (comm_rank .EQ. 0) THEN
    elements(1) = 1
    elements(2) = 2
  ENDIF
  
  CALL cgp_elements_write_data_f(F, B, Z, S, emin(1), emax(1), el_ptr, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

  n_boco_elems = 1
  CALL cg_boco_write_f(F, B, Z, "LeftBC", CGNS_ENUMV(FamilySpecified), CGNS_ENUMV(PointList), n_boco_elems, null_ptr, BC, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

  IF (comm_rank .EQ. 0) THEN
    start_local(1) = 1
    end_local(1) = 1
    elements(1) = start
    el_ptr => elements
  ELSE
    start_local(1) = 0
    end_local(1) = 0
    el_ptr => NULL()
  ENDIF

  PRINT *, comm_rank, ":", start_local(1), " ", end_local(1)
  indices(3) = BC
  ierr = cg_golist(F, B, depth, pt_labels, indices)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

  CALL cgp_ptlist_write_data_f(F, start_local(1), end_local(1), el_ptr, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

  CALL cg_boco_gridlocation_write_f(F, B, Z, BC, CGNS_ENUMV(EdgeCenter), ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

! Add family tag
  ierr = cg_golist(F, B, 3, pt_labels, indices)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

  CALL cg_famname_write_f("Left", ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

  CALL cgp_close_f(F, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

!
! ---  Test file reading
!

  CALL cgp_open_f('test_uns_quad_f90.cgns', CG_MODE_READ, F, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

  ! Left BC
  start = 6*comm_size + 1
  end   = start

  IF (comm_rank .EQ. 0) THEN
     emin(1) = start
     emax(1) = END
  ELSE
     emin(1) = 0
     emax(1) = 0
  END IF

  CALL cgp_parentelements_read_data_f(F, 1, 1, 3, emin(1), emax(1), el_ptr, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

  IF (comm_rank .EQ. 0) THEN
     IF (el_ptr(1) .NE. 1 .OR. el_ptr(2) .NE. 0)THEN
        WRITE(*,'(A)') "Could not read parent_element"
        CALL MPI_Abort(MPI_COMM_WORLD, 1, mpi_err)
     ENDIF
  ENDIF
!  if (cg_goto(fn,1,"Zone_t",1,"Elements_t",3,"end"))
!    cgp_error_exit();

! reset array
  DO i=1, nelem*4
    elements(i) = 0
  ENDDO

  start_local(1) = comm_rank * 3 + 1
  end_local(1)  = start_local(1) + 2

  indices(1) = Z
  indices(2) = 1
  indices(3) = 1
  indices(4) = 0

  ierr = cg_golist(F, B, depth, pt_labels, indices)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

  CALL cgp_ptlist_read_data_f(F, start_local(1), end_local(1), elements, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

  PRINT *, comm_rank, ": ", elements(1), " ", elements(2), " ", elements(3)
! Test read values
  global_num_quads = nelem * comm_size
  allocate(point_list(global_num_quads))
  do i=1,global_num_quads
    point_list(i) =  global_num_quads + i
  enddo

  do i=1,3
    found_point = .FALSE.
    do k=1,global_num_quads
      if (elements(i) .EQ. point_list(k)) then
        found_point = .TRUE.
        EXIT
      endif
    enddo
    if (found_point .NEQV. .TRUE.) then
        PRINT *, "Error:: Could not find point ", elements(i), &
                " in boundary list [", point_list(1), ",..., ", &
                point_list(global_num_quads), "]"
        CALL MPI_Abort(MPI_COMM_WORLD, 1, mpi_err)
    endif
  enddo
  

!---- close the file and terminate MPI
  CALL cgp_close_f(F, ierr)
  IF (ierr .NE. CG_OK) CALL cgp_error_exit_f

  CALL MPI_FINALIZE(mpi_err)
END PROGRAM test_unstruc_quad_f

      program read_floweqn_str
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Opens an existing CGNS file and reads flow equation info
!
!   The CGNS grid file 'grid.cgns' must already exist
!   (created using write_grid_str.f followed by write_floweqn_str.f)
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c read_floweqn_str.F90
!   ifort -o read_floweqn_str read_floweqn_str.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
      real*4 prandtl,gamma
      integer idata(6)
      integer itype,itm,itc,itcm,ivm,igm,ige,id
      integer index_zone,index_base,index_file,ier
!
!   READ FLOW EQUATION SET INFO
!   open CGNS file for read-only
      call cg_open_f('grid.cgns',CG_MODE_READ,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!   we know there is only one base (real working code would check!)
      index_base=1
!   we know there is only one zone (real working code would check!)
      index_zone=1
!   existing file must be 3D structured (real working code would check!)
!   Read info from 'FlowEquationSet' node under 'Zone_t'
      call cg_goto_f(index_file,index_base,ier,'Zone_t',index_zone,'end')
      call cg_equationset_read_f(id,ige,igm,ivm,itcm,itc,itm,ier)
      if (ier .gt. 0) then
        write(6,'('' Error!  FlowEquationSet node does not exist.'')')
        stop
      end if
      write(6,'('' Eqn dimension = '',i5)') id
!   Read 'GoverningEquations' node
      if (ige .eq. 1) then
        call cg_goto_f(index_file,index_base,ier,'Zone_t',index_zone,          &
             'FlowEquationSet_t',1,'end')
        call cg_governing_read_f(itype,ier)
        write(6,'('' Gov eqn = '',a32)') GoverningEquationsTypeName(itype)
!   Read 'DiffusionModel' node
        call cg_goto_f(index_file,index_base,ier,'Zone_t',index_zone,          &
             'FlowEquationSet_t',1,'GoverningEquations_t',1,'end')
        call cg_diffusion_read_f(idata,ier)
        write(6,'(''    diffusion='',6i5)') idata(1),idata(2),                 &
         idata(3),idata(4),idata(5),idata(6)
      end if
!   Read gas model
      if (igm .eq. 1) then
        call cg_goto_f(index_file,index_base,ier,'Zone_t',index_zone,          &
             'FlowEquationSet_t',1,'end')
        call cg_model_read_f('GasModel_t',itype,ier)
        write(6,'('' Gas model type = '',a32)') ModelTypeName(itype)
        call cg_goto_f(index_file,index_base,ier,'Zone_t',index_zone,          &
             'FlowEquationSet_t',1,'GasModel_t',1,'end')
        call cg_array_read_as_f(1,CGNS_ENUMV(RealSingle),gamma,ier)
        write(6,'(''    gamma='',f12.5)') gamma
      end if
!   Read turbulence closure
      if (itc .eq. 1) then
        call cg_goto_f(index_file,index_base,ier,'Zone_t',index_zone,          &
          'FlowEquationSet_t',1,'end')
        call cg_model_read_f('TurbulenceClosure_t',itype,ier)
        write(6,'('' Turbulence closure type = '',a32)')                       &
          ModelTypeName(itype)
        call cg_goto_f(index_file,index_base,ier,'Zone_t',index_zone,          &
         'FlowEquationSet_t',1,'TurbulenceClosure_t',1,'end')
        call cg_array_read_as_f(1,CGNS_ENUMV(RealSingle),prandtl,ier)
        write(6,'(''    turb prandtl number = '',f12.5)') prandtl
      end if
      if (itm .eq. 1) then
        call cg_goto_f(index_file,index_base,ier,'Zone_t',index_zone,          &
          'FlowEquationSet_t',1,'end')
        call cg_model_read_f('TurbulenceModel_t',itype,ier)
        write(6,'('' Turbulence model type = '',a32)')                         &
          ModelTypeName(itype)
      end if
!   close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully read equation set info from file'',            &
       '' grid.cgns'')')
      stop
      end

        program write_partial_data
        USE CGNS
        IMPLICIT NONE

!	original author (of write_mixed_elements): Diane Poirier
!       author: Ken Wall
!	May 13 2004

!       Original code came from the example write_mixed_elements.

! 	This example test the writing of and element section of
!	type CGNS_ENUMV(MIXED), which includes some NGON_x elements of different size
!	The model is not realistic, as all the data is dummy.
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer index_dim, cell_dim, phys_dim
	integer cg, base, zone, ier, index, ZoneType
        integer(cgsize_t) size(3)
	integer i, j, k, n, pos, coord, section_no
	integer(cgsize_t) element(20)
	integer(cgsize_t) connect_offsets(20)
	character*32 ZoneName, coordname(3)
        real*8 data_double(27)
	integer grid_no, C, count
        integer(cgsize_t) rmin, rmax, parent(12)

!       initialize
        ier = 0
	index_dim = 1
	cell_dim=3
	phys_dim=3

!       open CGNS file for writing

        call cg_open_f('Test_V2', MODE_WRITE, cg, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

!*******write CGNSBase
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	call cg_base_write_f(cg, 'PartialReadWriteBase', cell_dim, &
                             phys_dim, base, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

!*******write only 1 unstructured zone
	zone = 1
	ZoneType=CGNS_ENUMV(Unstructured)
	write(ZoneName,100) 'UnstructuredZone#1'
 100	format(a)
	size(1) = 27		! no of nodes
	size(2) = 3		! no of elements
	size(3) = 0		! unsorted nodes

	call cg_zone_write_f(cg, base, 'UnstructuredZone#1', size, &
                             ZoneType, index, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! Name convention
        coordname(1) = 'CoordinateX'
        coordname(2) = 'CoordinateY'
        coordname(3) = 'CoordinateZ'

! write coordinate data in 2 separate calls

! Set the ranges for the first partial write of the Coordinate data
            rmin = 15
            rmax = 27

! create coordinate data(10x10x10 box with 3x3x3 equidistant nodes)
        do coord=1,phys_dim
            pos = 0
            DO i= rmin, rmax
               pos = pos + 1
               IF (coord.EQ.1) data_double(pos) = i
               IF (coord.EQ.2) data_double(pos) = -i
               IF (coord.EQ.3) data_double(pos) = i
            ENDDO

            call cg_coord_partial_write_f(cg, base, zone, CGNS_ENUMV(RealDouble), &
                        coordname(coord), rmin, rmax, data_double, C, &
                        ier)
            if (ier .eq. ERROR) call cg_error_exit_f

	enddo	! coord. loop

! Set the ranges for the second partial write of the Coordinate data
            rmin = 1
            rmax = 14

! create coordinate data(10x10x10 box with 3x3x3 equidistant nodes)

        do coord=1,phys_dim
            pos = 0
            DO i=rmin, rmax
               pos = pos + 1
               IF (coord.EQ.1) data_double(pos) = -i
               IF (coord.EQ.2) data_double(pos) = i
               IF (coord.EQ.3) data_double(pos) = -i
            ENDDO

            call cg_coord_partial_write_f(cg, base, zone, CGNS_ENUMV(RealDouble), &
                        coordname(coord), rmin, rmax, data_double, C, &
                        ier)
            if (ier .eq. ERROR) call cg_error_exit_f

	enddo	! coord. loop

! create section with 3 elements

	call cg_section_partial_write_f(cg, base, zone, 'MixedElements', &
             CGNS_ENUMV(MIXED), 1_cgsize_t, 3_cgsize_t, 0, section_no, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! Generate dummy elements

	count = 0
	connect_offsets(1) = 0
! first element HEXA_8
	count = count + 1
	element(count)=CGNS_ENUMV(HEXA_8)
	do i=1,8
	    count = count + 1
	    element(count)=i
	enddo
! second element TETRA_4
	connect_offsets(2) = count
	count = count + 1
	element(count)=CGNS_ENUMV(TETRA_4)
	do i=1,4
	    count = count + 1
            element(count)=i
        enddo
        connect_offsets(3) = count

! Write first 2 elements of the MIXED element section
        rmin = 1
        rmax = 2
	call cg_poly_elements_partial_write_f(cg, base, zone, &
             section_no, rmin, rmax, element, connect_offsets, ier)
	if (ier .eq. ERROR) call cg_error_exit_f
! second element TETRA_4
	connect_offsets(1) = 0
	count = 1
	element(count)=CGNS_ENUMV(TETRA_4)
	do i=1,4
	    count = count + 1
            element(count)= -i
        enddo
	connect_offsets(2) = count

! third element PYRA_5
        count = count + 1
        element(count)=CGNS_ENUMV(PYRA_5)
        do i=1,5
            count = count + 1
            element(count)=i
        enddo
        connect_offsets(3) = count

! Write second and third elements of the MIXED element section
        rmin = 2
        rmax = 3
	call cg_poly_elements_partial_write_f(cg, base, zone, &
             section_no, rmin, rmax, element, connect_offsets, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

!234567890!234567890!234567890!234567890!234567890!234567890!23456789012

! Write parent data in 2 separate calls

        count = 0
	do i=5,12
            count = count + 1
            parent(count)=i
        enddo

        ! write parent data for the second and third elements
        call cg_parent_data_partial_write_f(cg, base, zone, section_no, &
             2_cgsize_t, 3_cgsize_t, parent, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

        count = 0
	do i=1,4
            count = count + 1
            parent(count)= -i
        enddo

        ! write parent data for the first element
        call cg_parent_data_partial_write_f(cg, base, zone, section_no, &
             1_cgsize_t, 1_cgsize_t, parent, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! Write & close CGNS file

	call cg_close_f(cg, ier)
	if (ier.eq. ERROR) call cg_error_exit_f()

	end

      program read_flowcentrind_str
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Opens an existing CGNS file that contains a simple 3-D
!   structured grid plus a flow solution (at CELL CENTERS PLUS
!   RIND CELLS IN THE I AND J DIRECTIONS), and reads it.
!   (Compare this program with read_flowcent_str)
!
!   The CGNS grid file 'grid.cgns' must already exist
!   (created using write_grid_str.f followed by
!   write_flowcentrind_str.f)
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c read_flowcentrind_str.F90
!   ifort -o read_flowcentrind_str read_flowcentrind_str.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
!   dimension statements (note that tri-dimensional arrays
!   r and p must be dimensioned exactly as (21-1+2,17-1+2,N-1) (N>=9)
!   for this particular case or else they will be read from
!   the CGNS file incorrectly!  Other options are to use 1-D
!   arrays, use dynamic memory, or pass index values to a
!   subroutine and dimension exactly there):
!   Rind cells are stored in array locations (i,1,k), (i,18,k), (1,j,k), (22,j,k)
      real*4 r(22,18,8),p(22,18,8)
      integer(cgsize_t) isize(3,3),irmin(3),irmax(3)
      integer irinddata(6)
      integer loc,index_flow,index_zone,index_base,index_file,ier
      character*32 zonename,solname
!
!   READ FLOW SOLUTION FROM CGNS FILE
!   open CGNS file for read-only
      call cg_open_f('grid.cgns',CG_MODE_READ,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!   we know there is only one base (real working code would check!)
      index_base=1
!   we know there is only one zone (real working code would check!)
      index_zone=1
!   we know there is only one FlowSolution_t (real working code would check!)
      index_flow=1
!   get zone size (and name - although not needed here)
      call cg_zone_read_f(index_file,index_base,index_zone,zonename,isize,ier)
!  go to position within tree at FlowSolution\_t node
      call cg_goto_f(index_file,index_base,ier,'Zone_t',index_zone,            &
           'FlowSolution_t',index_flow,'end')
!  read rind data
      call cg_rind_read_f(irinddata,ier)
!   lower range index
      irmin(1)=1-irinddata(1)
      irmin(2)=1-irinddata(3)
      irmin(3)=1-irinddata(5)
!   upper range index - use cell dimensions and rind info
!   checking GridLocation first:
      call cg_sol_info_f(index_file,index_base,index_zone,index_flow,          &
           solname,loc,ier)
      if (loc .ne.  CGNS_ENUMV(CellCenter)) then
        write(6,'('' Error, GridLocation must be CellCenter!'',                &
         ''  Currently:'',a32)') GridLocationName(loc)
        stop
      end if
      irmax(1)=isize(1,2)+irinddata(2)
      irmax(2)=isize(2,2)+irinddata(4)
      irmax(3)=isize(3,2)+irinddata(6)
!   read flow solution
      call cg_field_read_f(index_file,index_base,index_zone,index_flow,        &
           'Density',CGNS_ENUMV(RealSingle),irmin,irmax,r,ier)
      call cg_field_read_f(index_file,index_base,index_zone,index_flow,        &
           'Pressure',CGNS_ENUMV(RealSingle),irmin,irmax,p,ier)
!   close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully read flow solution from file'',                &
       '' grid.cgns'')')
      write(6,'(''   For example, r,p(21,17,8)='',2f12.5)')                    &
       r(21,17,8),p(21,17,8)
      write(6,'(''          rind: r,p(1,17,8)='',2f12.5)')                     &
       r(1,17,8),p(1,17,8)
      write(6,'(''          rind: r,p(22,17,8)='',2f12.5)')                    &
       r(22,17,8),p(22,17,8)
      write(6,'('' Program successful... ending now'')')
      stop
      end

      program write_flowcentrind_str
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Opens an existing CGNS file that contains a simple 3-D
!   structured grid, and adds a flow solution (at CELL CENTERS
!   PLUS RIND CELLS IN I AND J DIRECTIONS) to it.
!   (Compare this program with write_flowcent_str)
!
!   The CGNS grid file 'grid.cgns' must already exist
!   (created using write_grid_str.f)
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c write_flowcentrind_str.F90
!   ifort -o write_flowcentrind_str write_flowcentrind_str.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
!   dimension statements (note that tri-dimensional arrays
!   r and p must be dimensioned exactly as (21-1+2,17-1+2,N-1) (N>=9)
!   for this particular case or else they will be written to
!   the CGNS file incorrectly!  Other options are to use 1-D
!   arrays, use dynamic memory, or pass index values to a
!   subroutine and dimension exactly there):
!   Rind cells are stored in array locations (i,1,k), (i,18,k), (1,j,k), (22,j,k)
      real*8 r(22,18,8),p(22,18,8)
      integer index_file,index_base,index_zone,index_flow,index_field,ier
      integer i,j,k,ni,nj,nk
      integer irinddata(6)
      character solname*32
!
      write(6,'('' Program write_flowcentrind_str'')')
      if (CG_BUILD_64BIT) then
        write(6,'('' ...compiled in 64-bit mode, but not needed'')')
      end if
!
!   create fake flow solution AT CELL CENTERS for simple example:
      ni=20
      nj=16
      nk=8
      do k=1,nk
        do j=1,nj
          do i=1,ni
            r(i+1,j+1,k)=float(i-1)
            p(i+1,j+1,k)=float(j-1)
          enddo
        enddo
      enddo
!   create rind cell data:
      do k=1,nk
        do j=0,nj+1
          r(1,j+1,k)=999.d0+float(j)+5.d0*float(k)
          p(1,j+1,k)=999.d0+float(j)+5.d0*float(k)+1.d0
          r(ni+2,j+1,k)=-999.d0-float(j)-5.d0*float(k)
          p(ni+2,j+1,k)=-999.d0-float(j)-5.d0*float(k)-1.d0
        enddo
      enddo
      do k=1,nk
        do i=0,ni+1
          r(i+1,1,k)=888.d0+float(i)+5.d0*float(k)
          p(i+1,1,k)=888.d0+float(i)+5.d0*float(k)+1.d0
          r(i+1,nj+2,k)=-888.d0-float(i)-5.d0*float(k)
          p(i+1,nj+2,k)=-888.d0-float(i)-5.d0*float(k)-1.d0
        enddo
      enddo
      write(6,'('' created simple 3-D rho and p flow solution'',               &
       '' with rind data'')')
!
!   WRITE FLOW SOLUTION TO EXISTING CGNS FILE
!   open CGNS file for modify
      call cg_open_f('grid.cgns',CG_MODE_MODIFY,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!   we know there is only one base (real working code would check!)
      index_base=1
!   we know there is only one zone (real working code would check!)
      index_zone=1
!   define flow solution node name (user can give any name)
      solname = 'FlowSolution'
!   create flow solution node (NOTE USE OF CellCenter HERE)
      call cg_sol_write_f(index_file,index_base,index_zone,solname,            &
           CGNS_ENUMV(CellCenter),index_flow,ier)
!  go to position within tree at FlowSolution_t node
      call cg_goto_f(index_file,index_base,ier,'Zone_t',index_zone,            &
           'FlowSolution_t',index_flow,'end')
!   write rind information under FlowSolution_t node (ilo,ihi,jlo,jhi,klo,khi)
      irinddata(1)=1
      irinddata(2)=1
      irinddata(3)=1
      irinddata(4)=1
      irinddata(5)=0
      irinddata(6)=0
      call cg_rind_write_f(irinddata,ier)
!   write flow solution (user must use SIDS-standard names here)
      call cg_field_write_f(index_file,index_base,index_zone,index_flow,       &
           CGNS_ENUMV(RealDouble),'Density',r,index_field,ier)
      call cg_field_write_f(index_file,index_base,index_zone,index_flow,       &
           CGNS_ENUMV(RealDouble),'Pressure',p,index_field,ier)
!   close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully added flow solution data to file'',            &
       '' grid.cgns'')')
      write(6,'(''   Note:  if the original CGNS file already had'',           &
       '' a FlowSolution_t node,'')')
      write(6,'(''          it has been overwritten'')')
      stop
      end

      PROGRAM TEST

!
!     SAMPLE ADF TEST PROGRAM TO BUILD FILES ILLUSTRATED
!     IN THE EXAMPLE DATABASE FIGURE
!
      USE CGNS
      IMPLICIT NONE
!
      INTEGER MAXCHR
      PARAMETER (MAXCHR=32)

      INTEGER, PARAMETER :: dp = KIND(1.d0)
      INTEGER, PARAMETER :: i4 = SELECTED_INT_KIND(9) ! should map to INTEGER*4 on most modern processors
      CHARACTER(len=MAXCHR) TSTLBL,DTYPE
      CHARACTER(len=MAXCHR) FNAM,PATH
!
      REAL(KIND=dp) RID,PID,CID,TMPID,RIDF2
      REAL A(4,3),B(4,3)
      INTEGER(KIND=i4) IC(6),ID(6)
      INTEGER IERR,ICGIO,ICGIO2
      INTEGER(KIND=CGSIZE_T) :: IDIM(2),IDIMA(2),IDIMC,IDIMD
!
      DATA A /1.1,2.1,3.1,4.1,                                          &
     &      1.2,2.2,3.2,4.2,                                            &
     &      1.3,2.3,3.3,4.3/
      DATA IDIMA /4,3/
!
      DATA IC /1,2,3,4,5,6/
      DATA IDIMC /6/
      INTEGER NUMDIM, I, J
!
      IF (CG_BUILD_64BIT) THEN
        PRINT *,'PROGRAM NOT SET UP FOR 64-BIT'
        STOP
      ENDIF
!
!     SET ERROR FLAG TO ABORT ON ERROR
!
      CALL CGIO_ERROR_ABORT_F(1)
!
! *** 1.) OPEN 1ST DATABASE (ADF_FILE_TWO.ADF)
!     2.) CREATE THREE NODES AT FIRST LEVEL
!     3.) PUT LABEL ON NODE F3
!     4.) PUT DATA IN F3
!     5.) CREATE TWO NODES BELOW F3
!     6.) CLOSE DATABASE
!
      CALL CGIO_OPEN_FILE_F('file_two.cgio',CGIO_MODE_WRITE,            &
     &                      CGIO_FILE_ADF,ICGIO,IERR)
      CALL CGIO_GET_ROOT_ID_F(ICGIO,RID,IERR)
      RIDF2 = RID
      CALL CGIO_CREATE_NODE_F(ICGIO,RID,'F1',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,RID,'F2',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,RID,'F3',PID,IERR)
      CALL CGIO_SET_LABEL_F(ICGIO,PID,'LABEL ON NODE F3',IERR)
      CALL CGIO_SET_DIMENSIONS_F(ICGIO,PID,'R4',2,IDIMA,IERR)
      CALL CGIO_WRITE_ALL_DATA_F(ICGIO,PID,A,IERR)
!
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'F4',CID,IERR)
!
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'F5',CID,IERR)
!
      CALL CGIO_CLOSE_FILE_F(ICGIO,IERR)
!
! *** 1.) OPEN 2ND DATABASE
!     2.) CREATE NODES
!     3.) PUT DATA IN N13
!
      CALL CGIO_OPEN_FILE_F('file_one.cgio',CGIO_MODE_WRITE,            &
     &                      CGIO_FILE_ADF,ICGIO,IERR)
      CALL CGIO_GET_ROOT_ID_F(ICGIO,RID,IERR)
!
!     THREE NODES UNDER ROOT
!
      CALL CGIO_CREATE_NODE_F(ICGIO,RID,'N1',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,RID,'N2',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,RID,'N3',TMPID,IERR)
!
!     THREE NODES UNDER N1 (TWO REGULAR AND ONE LINK)
!
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'N1',PID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'N4',TMPID,IERR)
      CALL CGIO_CREATE_LINK_F(ICGIO,PID,'L3','file_two.cgio','/F3',     &
     &                        TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'N5',TMPID,IERR)
!
!     TWO NODES UNDER N4
!
      CALL CGIO_GET_NODE_ID_F(ICGIO,PID,'N4',CID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,CID,'N6',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,CID,'N7',TMPID,IERR)
!
!     ONE NODE UNDER N6
!
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'/N1/N4/N6',PID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'N8',TMPID,IERR)
!
!     THREE NODES UNDER N3
!
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'N3',PID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'N9',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'N10',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'N11',TMPID,IERR)
!
!     TWO NODES UNDER N9
!
      CALL CGIO_GET_NODE_ID_F(ICGIO,PID,'N9',CID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,CID,'N12',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,CID,'N13',TMPID,IERR)
!
!     PUT LABEL AND DATA IN N13
!
      CALL CGIO_SET_LABEL_F(ICGIO,TMPID,'LABEL ON NODE N13',IERR)
      CALL CGIO_SET_DIMENSIONS_F(ICGIO,TMPID,'I4',1,IDIMC,IERR)
      CALL CGIO_WRITE_ALL_DATA_F(ICGIO,TMPID,IC,IERR)
!
!     TWO NODES UNDER N10
!
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'/N3/N10',PID,IERR)
      CALL CGIO_CREATE_LINK_F(ICGIO,PID,'L1',CHAR(0),'/N3/N9/N13',     &
     & TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'N14',TMPID,IERR)
!
!     TWO NODES UNDER N11
!
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'/N3/N11',PID,IERR)
      CALL CGIO_CREATE_LINK_F(ICGIO,PID,'L2',CHAR(0),'/N3/N9/N13',     &
     & TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'N15',TMPID,IERR)
!
! *** READ AND PRINT DATA FROM NODES
!     1.) NODE F5 THROUGH LINK L3
!
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'/N1/L3',PID,IERR)
      CALL CGIO_GET_LABEL_F(ICGIO,PID,TSTLBL,IERR)
      CALL CGIO_GET_DATA_TYPE_F(ICGIO,PID,DTYPE,IERR)
      CALL CGIO_GET_DIMENSIONS_F(ICGIO,PID,NUMDIM,IDIM,IERR)
      CALL CGIO_READ_ALL_DATA_TYPE_F(ICGIO,PID,DTYPE,B,IERR)
      PRINT *,' NODE F3 THROUGH LINK L3:'
      PRINT *,'   LABEL       = ',TSTLBL
      PRINT *,'   DATA TYPE   = ',DTYPE
      PRINT *,'   NUM OF DIMS = ',NUMDIM
      PRINT *,'   DIM VALS    = ',IDIM
      PRINT *,'   DATA:'
      WRITE(*,100)((B(J,I),I=1,3),J=1,4)
  100 FORMAT(5X,3F10.2)
!
!     2.) N13
!
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'N3/N9/N13',PID,IERR)
      CALL CGIO_GET_LABEL_F(ICGIO,PID,TSTLBL,IERR)
      CALL CGIO_GET_DATA_TYPE_F(ICGIO,PID,DTYPE,IERR)
      CALL CGIO_GET_DIMENSIONS_F(ICGIO,PID,NUMDIM,IDIMD,IERR)
      CALL CGIO_READ_ALL_DATA_TYPE_F(ICGIO,PID,DTYPE,ID,IERR)
      PRINT *,' '
      PRINT *,' NODE N13:'
      PRINT *,'   LABEL       = ',TSTLBL
      PRINT *,'   DATA TYPE   = ',DTYPE
      PRINT *,'   NUM OF DIMS = ',NUMDIM
      PRINT *,'   DIM VALS    = ',IDIMD
      PRINT *,'   DATA:'
      WRITE(*,200)(ID(I),I=1,6)
  200 FORMAT(5X,6I6)
!
!     3.) N13 THROUGH L1
!
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'N3/N10/L1',TMPID,IERR)
      CALL CGIO_GET_LABEL_F(ICGIO,TMPID,TSTLBL,IERR)
      CALL CGIO_READ_ALL_DATA_TYPE_F(ICGIO,TMPID,DTYPE,ID,IERR)
      PRINT *,' '
      PRINT *,' NODE N13 THROUGH LINK L1:'
      PRINT *,'   LABEL       = ',TSTLBL
      PRINT *,'   DATA:'
      WRITE(*,200)(ID(I),I=1,6)
!
!     4.) N13 THROUGH L2
!
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'N3/N11/L2',CID,IERR)
      CALL CGIO_GET_LABEL_F(ICGIO,CID,TSTLBL,IERR)
      CALL CGIO_READ_ALL_DATA_TYPE_F(ICGIO,CID,DTYPE,ID,IERR)
      PRINT *,' '
      PRINT *,' NODE N13 THROUGH LINK L2:'
      PRINT *,'   LABEL       = ',TSTLBL
      PRINT *,'   DATA:'
      WRITE(*,200)(ID(I),I=1,6)
!
!     PRINT LIST OF CHILDREN UNDER ROOT NODE
!
      CALL PRTCLD(ICGIO,RID)
!
!     PRINT LIST OF CHILDREN UNDER N3
!
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'N3',PID,IERR)
      CALL PRTCLD(ICGIO,PID)
!
!     REOPEN ADF_FILE_TWO AND GET NEW ROOT ID
!
      CALL CGIO_OPEN_FILE_F('file_two.cgio',CGIO_MODE_READ,             &
     &                      CGIO_FILE_ADF,ICGIO2,IERR)
      CALL CGIO_GET_ROOT_ID_F(ICGIO2,RID,IERR)
      PRINT *,' '
      PRINT *,' COMPARISON OF ROOT ID: '
      PRINT *,' file_two.cgio ORIGINAL ROOT ID = ',INT(RIDF2)
      PRINT *,' file_two.cgio NEW ROOT ID      = ',INT(RID)
!
      CALL CGIO_CLOSE_FILE_F(ICGIO,IERR)
      CALL CGIO_CLOSE_FILE_F(ICGIO2,IERR)
!
      STOP
      END
!
! ************* SUBROUTINES ****************
!
      SUBROUTINE PRTCLD(ICGIO,PID)
      USE CGNS
!
! *** PRINT TABLE OF CHILDREN GIVEN A PARENT NODE-ID
!
      PARAMETER (MAXCLD=10)
      PARAMETER (MAXCHR=32)
      INTEGER, PARAMETER :: dp = KIND(1.d0)
      REAL(KIND=dp) PID
      CHARACTER(len=MAXCHR) NODNAM,NDNMS(MAXCLD)
      CALL CGIO_GET_NAME_F(ICGIO,PID,NODNAM,IERR)
      CALL CGIO_NUMBER_CHILDREN_F(ICGIO,PID,NUMC,IERR)
      WRITE(*,120)NODNAM,NUMC
  120 FORMAT(/,' PARENT NODE NAME = ',A,/,                              &
     &       '     NUMBER OF CHILDREN = ',I2,/,                         &
     &       '     CHILDREN NAMES:')
      NLEFT = NUMC
      ISTART = 1
!     --- TOP OF DO-WHILE LOOP
  130 CONTINUE
         CALL CGIO_CHILDREN_NAMES_F(ICGIO,PID,ISTART,MAXCLD,MAXCHR,     &
     &                              NUMRET,NDNMS,IERR)
         WRITE(*,140)(NDNMS(K),K=1,NUMRET)
  140    FORMAT(8X,A)
         NLEFT = NLEFT - MAXCLD
         ISTART = ISTART + MAXCLD
      IF (NLEFT .GT. 0) GO TO 130
      RETURN
      END

      PROGRAM TEST
C
C     SAMPLE ADF TEST PROGRAM TO BUILD FILES ILLUSTRATED
C     IN THE EXAMPLE DATABASE FIGURE
C
      INCLUDE 'cgns_io_f.h'
#include "cgnstypes_f.h"
C
      PARAMETER (MAXCHR=32)
C
      CHARACTER*(MAXCHR) TSTLBL,DTYPE
      CHARACTER*(MAXCHR) FNAM,PATH
C
      REAL*8 RID,PID,CID,TMPID,RIDF2
      REAL A(4,3),B(4,3)
      INTEGER*4 IC(6),ID(6)
      INTEGER IERR,ICGIO,ICGIO2
      INTEGER IDIM(2),IDIMA(2),IDIMC,IDIMD
C
      DATA A /1.1,2.1,3.1,4.1,
     X        1.2,2.2,3.2,4.2,
     X        1.3,2.3,3.3,4.3/
      DATA IDIMA /4,3/
C
      DATA IC /1,2,3,4,5,6/
      DATA IDIMC /6/
C
#if CG_BUILD_64BIT
      PRINT *,'PROGRAM NOT SET UP FOR 64-BIT'
      STOP
#endif
C
C     SET ERROR FLAG TO ABORT ON ERROR
C
      CALL CGIO_ERROR_ABORT_F(1)
C
C *** 1.) OPEN 1ST DATABASE (ADF_FILE_TWO.ADF)
C     2.) CREATE THREE NODES AT FIRST LEVEL
C     3.) PUT LABEL ON NODE F3
C     4.) PUT DATA IN F3
C     5.) CREATE TWO NODES BELOW F3
C     6.) CLOSE DATABASE
C
      CALL CGIO_OPEN_FILE_F('file_two.cgio',CGIO_MODE_WRITE,
     &                      CGIO_FILE_ADF,ICGIO,IERR)
      CALL CGIO_GET_ROOT_ID_F(ICGIO,RID,IERR)
      RIDF2 = RID
      CALL CGIO_CREATE_NODE_F(ICGIO,RID,'F1',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,RID,'F2',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,RID,'F3',PID,IERR)
      CALL CGIO_SET_LABEL_F(ICGIO,PID,'LABEL ON NODE F3',IERR)
      CALL CGIO_SET_DIMENSIONS_F(ICGIO,PID,'R4',2,IDIMA,IERR)
      CALL CGIO_WRITE_ALL_DATA_F(ICGIO,PID,A,IERR)
C
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'F4',CID,IERR)
C
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'F5',CID,IERR)
C
      CALL CGIO_CLOSE_FILE_F(ICGIO,IERR)
C
C *** 1.) OPEN 2ND DATABASE
C     2.) CREATE NODES
C     3.) PUT DATA IN N13
C
      CALL CGIO_OPEN_FILE_F('file_one.cgio',CGIO_MODE_WRITE,
     &                      CGIO_FILE_ADF,ICGIO,IERR)
      CALL CGIO_GET_ROOT_ID_F(ICGIO,RID,IERR)
C
C     THREE NODES UNDER ROOT
C
      CALL CGIO_CREATE_NODE_F(ICGIO,RID,'N1',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,RID,'N2',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,RID,'N3',TMPID,IERR)
C
C     THREE NODES UNDER N1 (TWO REGULAR AND ONE LINK)
C
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'N1',PID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'N4',TMPID,IERR)
      CALL CGIO_CREATE_LINK_F(ICGIO,PID,'L3','file_two.cgio','/F3',
     &                        TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'N5',TMPID,IERR)
C
C     TWO NODES UNDER N4
C
      CALL CGIO_GET_NODE_ID_F(ICGIO,PID,'N4',CID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,CID,'N6',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,CID,'N7',TMPID,IERR)
C
C     ONE NODE UNDER N6
C
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'/N1/N4/N6',PID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'N8',TMPID,IERR)
C
C     THREE NODES UNDER N3
C
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'N3',PID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'N9',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'N10',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'N11',TMPID,IERR)
C
C     TWO NODES UNDER N9
C
      CALL CGIO_GET_NODE_ID_F(ICGIO,PID,'N9',CID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,CID,'N12',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,CID,'N13',TMPID,IERR)
C
C     PUT LABEL AND DATA IN N13
C
      CALL CGIO_SET_LABEL_F(ICGIO,TMPID,'LABEL ON NODE N13',IERR)
      CALL CGIO_SET_DIMENSIONS_F(ICGIO,TMPID,'I4',1,IDIMC,IERR)
      CALL CGIO_WRITE_ALL_DATA_F(ICGIO,TMPID,IC,IERR)
C
C     TWO NODES UNDER N10
C
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'/N3/N10',PID,IERR)
      CALL CGIO_CREATE_LINK_F(ICGIO,PID,'L1','','/N3/N9/N13',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'N14',TMPID,IERR)
C
C     TWO NODES UNDER N11
C
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'/N3/N11',PID,IERR)
      CALL CGIO_CREATE_LINK_F(ICGIO,PID,'L2','','/N3/N9/N13',TMPID,IERR)
      CALL CGIO_CREATE_NODE_F(ICGIO,PID,'N15',TMPID,IERR)
C
C *** READ AND PRINT DATA FROM NODES
C     1.) NODE F5 THROUGH LINK L3
C
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'/N1/L3',PID,IERR)
      CALL CGIO_GET_LABEL_F(ICGIO,PID,TSTLBL,IERR)
      CALL CGIO_GET_DATA_TYPE_F(ICGIO,PID,DTYPE,IERR)
      CALL CGIO_GET_DIMENSIONS_F(ICGIO,PID,NUMDIM,IDIM,IERR)
      CALL CGIO_READ_ALL_DATA_TYPE_F(ICGIO,PID,DTYPE,B,IERR)
      PRINT *,' NODE F3 THROUGH LINK L3:'
      PRINT *,'   LABEL       = ',TSTLBL
      PRINT *,'   DATA TYPE   = ',DTYPE
      PRINT *,'   NUM OF DIMS = ',NUMDIM
      PRINT *,'   DIM VALS    = ',IDIM
      PRINT *,'   DATA:'
      WRITE(*,100)((B(J,I),I=1,3),J=1,4)
  100 FORMAT(5X,3F10.2)
C
C     2.) N13
C
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'N3/N9/N13',PID,IERR)
      CALL CGIO_GET_LABEL_F(ICGIO,PID,TSTLBL,IERR)
      CALL CGIO_GET_DATA_TYPE_F(ICGIO,PID,DTYPE,IERR)
      CALL CGIO_GET_DIMENSIONS_F(ICGIO,PID,NUMDIM,IDIMD,IERR)
      CALL CGIO_READ_ALL_DATA_TYPE_F(ICGIO,PID,DTYPE,ID,IERR)
      PRINT *,' '
      PRINT *,' NODE N13:'
      PRINT *,'   LABEL       = ',TSTLBL
      PRINT *,'   DATA TYPE   = ',DTYPE
      PRINT *,'   NUM OF DIMS = ',NUMDIM
      PRINT *,'   DIM VALS    = ',IDIMD
      PRINT *,'   DATA:'
      WRITE(*,200)(ID(I),I=1,6)
  200 FORMAT(5X,6I6)
C
C     3.) N13 THROUGH L1
C
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'N3/N10/L1',TMPID,IERR)
      CALL CGIO_GET_LABEL_F(ICGIO,TMPID,TSTLBL,IERR)
      CALL CGIO_READ_ALL_DATA_TYPE_F(ICGIO,TMPID,DTYPE,ID,IERR)
      PRINT *,' '
      PRINT *,' NODE N13 THROUGH LINK L1:'
      PRINT *,'   LABEL       = ',TSTLBL
      PRINT *,'   DATA:'
      WRITE(*,200)(ID(I),I=1,6)
C
C     4.) N13 THROUGH L2
C
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'N3/N11/L2',CID,IERR)
      CALL CGIO_GET_LABEL_F(ICGIO,CID,TSTLBL,IERR)
      CALL CGIO_READ_ALL_DATA_TYPE_F(ICGIO,CID,DTYPE,ID,IERR)
      PRINT *,' '
      PRINT *,' NODE N13 THROUGH LINK L2:'
      PRINT *,'   LABEL       = ',TSTLBL
      PRINT *,'   DATA:'
      WRITE(*,200)(ID(I),I=1,6)
C
C     PRINT LIST OF CHILDREN UNDER ROOT NODE
C
      CALL PRTCLD(ICGIO,RID)
C
C     PRINT LIST OF CHILDREN UNDER N3
C
      CALL CGIO_GET_NODE_ID_F(ICGIO,RID,'N3',PID,IERR)
      CALL PRTCLD(ICGIO,PID)
C
C     REOPEN ADF_FILE_TWO AND GET NEW ROOT ID
C
      CALL CGIO_OPEN_FILE_F('file_two.cgio',CGIO_MODE_READ,
     &                      CGIO_FILE_ADF,ICGIO2,IERR)
      CALL CGIO_GET_ROOT_ID_F(ICGIO2,RID,IERR)
      PRINT *,' '
      PRINT *,' COMPARISON OF ROOT ID: '
      PRINT *,' file_two.cgio ORIGINAL ROOT ID = ',RIDF2
      PRINT *,' file_two.cgio NEW ROOT ID      = ',RID
C
      CALL CGIO_CLOSE_FILE_F(ICGIO,IERR)
      CALL CGIO_CLOSE_FILE_F(ICGIO2,IERR)
C
      STOP
      END
C
C ************* SUBROUTINES ****************
C
      SUBROUTINE PRTCLD(ICGIO,PID)
C
C *** PRINT TABLE OF CHILDREN GIVEN A PARENT NODE-ID
C
      PARAMETER (MAXCLD=10)
      PARAMETER (MAXCHR=32)
      REAL*8 PID
      CHARACTER*(MAXCHR) NODNAM,NDNMS(MAXCLD)
      CALL CGIO_GET_NAME_F(ICGIO,PID,NODNAM,IERR)
      CALL CGIO_NUMBER_CHILDREN_F(ICGIO,PID,NUMC,IERR)
      WRITE(*,120)NODNAM,NUMC
  120 FORMAT(/,' PARENT NODE NAME = ',A,/,
     X       '     NUMBER OF CHILDREN = ',I2,/,
     X       '     CHILDREN NAMES:')
      NLEFT = NUMC
      ISTART = 1
C     --- TOP OF DO-WHILE LOOP
  130 CONTINUE
         CALL CGIO_CHILDREN_NAMES_F(ICGIO,PID,ISTART,MAXCLD,MAXCHR,
     X                              NUMRET,NDNMS,IERR)
         WRITE(*,140)(NDNMS(K),K=1,NUMRET)
  140    FORMAT(8X,A)
         NLEFT = NLEFT - MAXCLD
         ISTART = ISTART + MAXCLD
      IF (NLEFT .GT. 0) GO TO 130
      RETURN
      END

        PROGRAM write_rotating
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on May 31 2002

!       This example test the RotatingCoordinates_t data structure and its children
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 3)
	integer index_dim, cell_dim, phys_dim, i
	integer cg, base_no, zone_no, ier
	integer(cgsize_t) size(Ndim*3)
	real*4 rot_rate(Ndim), rot_center(Ndim)
	character*100 linkpath

! *** initialize
	ier = 0
	index_dim=Ndim
	cell_dim=Ndim
	phys_dim=Ndim

! *** open CGNS file for writing
 	call cg_open_f('Test_V2', MODE_WRITE, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f

! *** base
 	call cg_base_write_f(cg, 'Basename', cell_dim, phys_dim, &
                             base_no, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f

! *** write a descriptor under the base
        call cg_goto_f(cg, base_no, ier, 'end')
	if (ier .eq. ERROR) call cg_error_exit_f

	call cg_descriptor_write_f('BaseDescriptorName', &
            'BaseDescriptorText', ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** write RotatingCoordinates_t node
	rot_rate(1)=10.1
	rot_rate(2)=0
	rot_rate(3)=0
	rot_center(1) = 1.1
	rot_center(2) = 1.2
	rot_center(3) = 1.3
	call cg_rotating_write_f(rot_rate, rot_center, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! *** write children of RotatingCoordinates_t node
	call cg_goto_f(cg, base_no, ier, 'RotatingCoordinates_t', &
                       1, 'end')
	if (ier .eq. ERROR) call cg_error_exit_f

! * Descriptor
	call cg_descriptor_write_f('RotatingCoordinatesDescriptorName', &
             'RotatingCoordinatesDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * DataClass
        call cg_dataclass_write_f(CGNS_ENUMV(Dimensional), ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! * DimensionalUnits
	call cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), CGNS_ENUMV(Kelvin), &
                              CGNS_ENUMV(Radian), ier)
	if (ier .eq. ERROR) call cg_error_exit_f

! * UserDefinedData
        call cg_user_data_write_f('UserData1', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * Link to BaseDescriptorName
        write(linkpath,'(a)') '/Basename/BaseDescriptorName'
        call cg_link_write_f('LinkToBaseDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * RotationCenter/Descriptor
	call cg_goto_f(cg, base_no, ier, 'RotatingCoordinates_t', 1, &
                       'DataArray_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f
	call cg_descriptor_write_f('RotationCenterDescriptorName', &
             'RotationCenterDescriptorText', ier)
	if (ier .eq. ERROR) call cg_error_exit_f
	
! * RotationCenter/DimensionalUnits
	call cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), CGNS_ENUMV(Kelvin), &
                              CGNS_ENUMV(Radian), ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * Write a zone
	do i=1,index_dim
	    size(i) = i+1		! nr of nodes in i,j,k = 3,4,5
	    size(i+Ndim) = size(i)-1	! nr of elements in i,j,k
	    size(i+2*Ndim) = 0		! nr of bnd nodes if ordered
	enddo
	call cg_zone_write_f(cg, base_no, 'MyZone', size, &
                                 CGNS_ENUMV(Structured), zone_no, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! *** write a descriptor under the zone
        call cg_goto_f(cg, base_no, ier, 'Zone_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

        call cg_descriptor_write_f('ZoneDescriptorName', &
            'ZoneDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! *** write RotatingCoordinates_t node
        rot_rate(1)=10.1
        rot_rate(2)=0
        rot_rate(3)=0
        rot_center(1) = 1.1
        rot_center(2) = 1.2
        rot_center(3) = 1.3
        call cg_rotating_write_f(rot_rate, rot_center, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! *** write children of RotatingCoordinates_t node
        call cg_goto_f(cg, base_no, ier, 'Zone_t', 1, &
                       'RotatingCoordinates_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f

! * Descriptor
        call cg_descriptor_write_f('RotatingCoordinatesDescriptorName', &
             'RotatingCoordinatesDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * DataClass
        call cg_dataclass_write_f(CGNS_ENUMV(Dimensional), ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * DimensionalUnits
        call cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), CGNS_ENUMV(Kelvin), &
                              CGNS_ENUMV(Radian), ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * UserDefinedData
        call cg_user_data_write_f('UserData2', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * Link to ZoneDescriptorName
        write(linkpath,'(a)') '/Basename/MyZone/ZoneDescriptorName'
        call cg_link_write_f('LinkToZoneDescr', ' ',linkpath, ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * RotationCenter/Descriptor
        call cg_goto_f(cg, base_no, ier, 'Zone_t', 1, &
             'RotatingCoordinates_t', 1, 'DataArray_t', 1, 'end')
        if (ier .eq. ERROR) call cg_error_exit_f
        call cg_descriptor_write_f('RotationCenterDescriptorName', &
             'RotationCenterDescriptorText', ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! * RotationCenter/DimensionalUnits
        call cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), CGNS_ENUMV(Kelvin), &
                              CGNS_ENUMV(Radian), ier)
        if (ier .eq. ERROR) call cg_error_exit_f

! *** close CGNS file
	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

        END PROGRAM write_rotating

        PROGRAM write_cgns_1
	USE CGNS
	implicit none

!       author: Diane Poirier (diane@icemcfd.com)
!       last revised on March 8 2000

!       This example test the complete SIDS for multi-block data.
!	It creates a dummy mesh composed of 2 structured blocks in 3D.
#include "cgnstypes_f03.h"
#ifdef WINNT
	include 'cgnswin_f.h'
#endif

	integer Ndim
	parameter (Ndim = 3)
	integer index_dim, cell_dim, phys_dim
	integer base_no, zone_no, coord_no, sol_no, discr_no, conn_no
	integer hole_no, boco_no, field_no, dset_no
	integer num
	integer(cgsize_t) NormalIndex(Ndim)
	integer(cgsize_t) npnts
	integer(cgsize_t) size(Ndim*3)
	integer cg, ier, zone, coord, i, j, k, n, pos, sol, field
	integer(cgsize_t) pnts(Ndim,120), donor_pnts(Ndim,120)
	integer transform(Ndim)
	real*4 data(120), normals(360)
	double precision Dxyz(120), values(120)
	character*32 zonename, solname, fieldname
	character*32 coordname(Ndim)
	character*32 donorname

	coordname(1) = 'CoordinateX'
	coordname(2) = 'CoordinateY'
	coordname(3) = 'CoordinateZ'

! *** initialize
	ier = 0
	index_dim=Ndim
	cell_dim=Ndim
	phys_dim=Ndim

! *** open CGNS file for writing
 	call cg_open_f('Test_V2', MODE_WRITE, cg, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f

! *** base
 	call cg_base_write_f(cg, 'Basename', cell_dim, phys_dim, &
                             base_no, ier)
 	if (ier .eq. ERROR) call cg_error_exit_f

! *** zone
	do zone=1, 2
    	    write(zonename,'(a5,i1)') 'zone#',zone
    	    num = 1
	    do i=1,index_dim          		! zone#1: 3*4*5, zone#2: 4*5*6
                size(i) = i+zone+1		! nr of nodes in i,j,k
		size(i+Ndim) = size(i)-1	! nr of elements in i,j,k
	 	size(i+2*Ndim) = 0		! nr of bnd nodes if ordered
       		num = num * size(i)		! nr of nodes
    	    enddo
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
    	    call cg_zone_write_f(cg, base_no, zonename, size, &
                                 CGNS_ENUMV(Structured), zone_no, ier)
    	    if (ier .eq. ERROR) call cg_error_exit_f
! *** coordinate
          do coord=1, phys_dim
 		do k=1, size(3)
 		do j=1, size(2)
 		do i=1, size(1)
		    pos = i + (j-1)*size(1) + (k-1)*size(1)*size(2)
		! * make up some dummy coordinates just for the test:
 	    	    if (coord.eq.1) Dxyz(pos) = i
 	    	    if (coord.eq.2) Dxyz(pos) = j
 	    	    if (coord.eq.3) Dxyz(pos) = k
 		enddo
 		enddo
 		enddo

         	call cg_coord_write_f(cg, base_no, zone_no, CGNS_ENUMV(RealDouble), &
                                  coordname(coord), Dxyz, coord_no, ier)
         	if (ier .eq. ERROR) call cg_error_exit_f

          enddo

! *** solution
          do sol=1, 2
 		write(solname,'(a5,i1,a5,i1)') 'Zone#',zone,' sol#',sol
 		call cg_sol_write_f(cg, base_no, zone_no, solname, &
                                    CGNS_ENUMV(Vertex), sol_no, ier)
 		if (ier .eq. ERROR) call cg_error_exit_f

! *** solution field
 		do field=1, 2
		    ! make up some dummy solution values
 	    	    do i=1, num
 		  	values(i) = i*field*sol
 	    	    enddo
 	    	    write(fieldname,'(a6,i1)') 'Field#',field
 	    	    call cg_field_write_f(cg, base_no, zone_no, sol_no, &
                        CGNS_ENUMV(RealDouble), fieldname, values, field_no, ier)
 	    	    if (ier .eq. ERROR) call cg_error_exit_f

 		enddo				! field loop
            enddo				! solution loop

! *** discrete data
	    call cg_discrete_write_f(cg, base_no, zone_no, 'discrete#1', &
                                     discr_no, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

  	! *** discrete data arrays, defined on vertices:
	    call cg_goto_f(cg, base_no, ier, 'Zone_t', zone, &
                           'DiscreteData_t', discr_no, 'end')
            if (ier .eq. ERROR) call cg_error_exit_f

	    DO k=1, SIZE(3)
               DO j=1, SIZE(2)
                  DO i=1, SIZE(1)
                     pos = i + (j-1)*SIZE(1) + (k-1)*SIZE(1)*SIZE(2)
                     DATA(pos) = pos	! * make up some dummy data
                  ENDDO
               ENDDO
            ENDDO
	    call cg_array_write_f('arrayname', CGNS_ENUMV(RealSingle), index_dim, &
                                   size, data, ier)
            if (ier .eq. ERROR) call cg_error_exit_f

  	! *** discrete data arrays attribute: GOTO DataArray node
	    call cg_goto_f(cg, base_no, ier, 'Zone_t', zone, &
      	            'DiscreteData_t', discr_no, 'DataArray_t', 1, 'end')
	    if (ier .eq. ERROR) call cg_error_exit_f

	    call cg_units_write_f(CGNS_ENUMV(Kilogram), CGNS_ENUMV(Meter), CGNS_ENUMV(Second), CGNS_ENUMV(Kelvin), &
                                  CGNS_ENUMV(Radian), ier)
            if (ier .eq. ERROR) call cg_error_exit_f
		
! *** overset holes
	 !  create dummy data
	    do i=1,3
	      ! Define 2 separate CGNS_ENUMV(PointRange), for 2 patches in the hole
		pnts(i,1)=1
		pnts(i,2)=size(i)
	      ! second PointRange of hole
		pnts(i,3)=2
		pnts(i,4)=size(i)
	    enddo
	  ! Hole defined with 2 point set type CGNS_ENUMV(PointRange), so 4 points:
	    call cg_hole_write_f(cg, base_no, zone_no, 'hole#1', CGNS_ENUMV(Vertex), &
                                 CGNS_ENUMV(PointRange), 2, 4_cgsize_t, pnts, &
                                 hole_no, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

! *** general connectivity
            DO n=1, 5
               DO i=1,3
                  pnts(i,n)=i		! * dummy data
                  donor_pnts(i,n)=i*2
               ENDDO
            ENDDO
	  ! create a point matching connectivity
	    call cg_conn_write_f(cg, base_no, zone_no, 'Connect#1', &
                CGNS_ENUMV(Vertex), CGNS_ENUMV(Abutting1to1), CGNS_ENUMV(PointList), 5_cgsize_t, pnts, &
                'zone#2', &
                CGNS_ENUMV(Structured), CGNS_ENUMV(PointListDonor), CGNS_ENUMV(Integer), 5_cgsize_t, &
                donor_pnts, conn_no, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

! *** connectivity 1to1
	 !  generate data
	    do i=1,3
	     !**make up some dummy data:
                pnts(i,1)=1
                pnts(i,2)=size(i)
		donor_pnts(i,1)=1
		donor_pnts(i,2)=size(i)
		transform(i)=i*(-1)
            enddo
	    if (zone .eq. 1) then
		donorname='zone#2'
	    else if (zone .eq. 2) then
		donorname='zone#1'
	    endif

	    call cg_1to1_write_f(cg, base_no, zone_no, '1to1_#1', &
      		donorname, pnts, donor_pnts, transform, conn_no, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

! *** ZoneGridConnectivity attributes:  GOTO ZoneGridConnectivity_t node
	    call cg_goto_f(cg, base_no, ier, 'Zone_t', zone, &
                           'ZoneGridConnectivity_t', 1, 'end')
	    if (ier .eq. ERROR) call cg_error_exit_f

! *** ZoneGridConnectivity attributes: Descriptor_t
!234567890!234567890!234567890!234567890!234567890!234567890!23456789012
	    call cg_descriptor_write_f('DescriptorName', &
                                       'Zone Connectivity', ier)

! *** bocos
	    call cg_boco_write_f(cg, base_no, zone_no, 'boco#1', &
                 CGNS_ENUMV(BCInflow), CGNS_ENUMV(PointRange), 2_cgsize_t, pnts, boco_no, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

! *** boco normal
	    npnts = 1
	    do i=1,Ndim
	        NormalIndex(i)=0
		! compute nr of points on bc patch:
		npnts = npnts * (pnts(i,2)-pnts(i,1)+1)
	    enddo
	    NormalIndex(1)=1
	    do i=1,phys_dim*npnts
		normals(i)=i
	    enddo

	    call cg_boco_normal_write_f(cg, base_no, zone_no, boco_no, &
               NormalIndex, 1, CGNS_ENUMV(RealSingle), normals, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

! ** boundary condition attributes: GOTO BC_t node
	    call cg_goto_f(cg, base_no, ier, 'Zone_t', zone, 'ZoneBC_t', &
                1, 'BC_t', boco_no, 'end')
	    if (ier .eq. ERROR) call cg_error_exit_f

! ** boundary condition attributes:  GridLocation_t
	    call cg_gridlocation_write_f(CGNS_ENUMV(Vertex), ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

! ** boundary condition dataset
            call cg_dataset_write_f(cg, base_no, zone, &
               boco_no, 'DataSetName', CGNS_ENUMV(BCInflow), dset_no, ier)
            if (ier .eq. ERROR) call cg_error_exit_f

! ** boundary condition data:
	    call cg_bcdata_write_f(cg, base_no, zone, &
               boco_no, dset_no, CGNS_ENUMV(Neumann), ier)
	    if (ier .eq. ERROR) call cg_error_exit_f
	
! ** boundary condition data arrays: GOTO BCData_t node
	    call cg_goto_f(cg, base_no, ier, 'Zone_t', zone_no, &
                'ZoneBC_t', 1, 'BC_t', boco_no, 'BCDataSet_t', dset_no, &
                'BCData_t', CGNS_ENUMV(Neumann), 'end')
	    if (ier .eq. ERROR) call cg_error_exit_f

	    do i=1, npnts
		data(i) = i
	    enddo
	    call cg_array_write_f('dataset_arrayname', CGNS_ENUMV(RealSingle), &
                 1, [npnts], data, ier)
	    if (ier .eq. ERROR) call cg_error_exit_f

! ** boundary condition data attributes:
	    call cg_dataclass_write_f(CGNS_ENUMV(NormalizedByDimensional), ier)
            if (ier .eq. ERROR) call cg_error_exit_f

 	enddo					! zone loop

! *** close CGNS file
	call cg_close_f(cg, ier)
	if (ier .eq. ERROR) call cg_error_exit_f

        END PROGRAM write_cgns_1

      program read_nondimensional
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Opens an existing CGNS file and reads the DataClass and
!   ReferenceState appropriate for a completely
!   NONDIMENSIONAL data set.
!
!   The CGNS grid file 'grid.cgns' must already exist,
!   processed further using write_nondimensional.f.
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c read_nondimensional.F90
!   ifort -o read_nondimensional read_nondimensional.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
      real*8 data
      integer(cgsize_t) idimvec(1)
      integer n,idim,idata,narrays,id,index_base,index_file,ier
      character state*32,arrayname*32
!
!   READ NONDIMENSIONAL INFO
!   open CGNS file for read-only
      call cg_open_f('grid.cgns',CG_MODE_READ,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!   we know there is only one base (real working code would check!)
      index_base=1
!   read DataClass under Base
      call cg_goto_f(index_file,index_base,ier,'end')
      call cg_dataclass_read_f(id,ier)
      write(6,'('' DataClass = '',a32)') DataClassName(id)
      if (DataClassName(id) .ne. 'NormalizedByUnknownDimensional') then
        write(6,'('' Error!  Expecting NormalizedByUnknownDimensional'')')
        stop
      end if
!   read ReferenceState under Base
      call cg_state_read_f(state,ier)
      write(6,'('' ReferenceState = '',a32)') state
!   Go to ReferenceState node, read Mach array and its dataclass
      call cg_goto_f(index_file,index_base,ier,'ReferenceState_t',1,'end')
!   find out how many data arrays
      call cg_narrays_f(narrays,ier)
      do n=1,narrays
        call cg_array_info_f(n,arrayname,idata,idim,idimvec,ier)
        if (idim .ne. 1 .or. idimvec(1) .ne. 1) then
          write(6,'('' Error! expecting idim,idimvec=1,1'')')
          write(6,'(''    they are idim,idimvec='',2i5)')idim,idimvec(1)
          stop
        end if
        call cg_array_read_as_f(n,CGNS_ENUMV(RealDouble),data,ier)
        write(6,'('' Variable='',a32)') arrayname
        write(6,'(''     data='',f18.8)') data
      enddo
!   close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully read nondimensional info from file'',          &
       '' grid.cgns'')')
      stop
      end

      program write_floweqn_str
      use cgns
      implicit none
#include "cgnstypes_f03.h"
!
!   Opens an existing CGNS file and writes flow eqn info
!
!   The CGNS grid file 'grid.cgns' must already exist
!   (created using write_grid_str.f)
!
!   Example compilation for this program is (change paths if needed!):
!   Note: when using the cgns module file, you must use the SAME fortran compiler
!   used to compile CGNS (see make.defs file)
!   ...or change, for example, via environment "setenv FC ifort"
!
!   ifort -I ../.. -c write_floweqn_str.F90
!   ifort -o write_floweqn_str write_floweqn_str.o -L ../../lib -lcgns
!
!   (../../lib is the location where the compiled
!   library libcgns.a is located)
!
!   The following is no longer supported; now superseded by "use cgns":
!     include 'cgnslib_f.h'
!   Note Windows machines need to include cgnswin_f.h
!
      real*4 gamma,prandtl
      integer idata(6)
      integer ieq_dim,index_zone,index_base,index_file,ier
      integer(cgsize_t) nuse
!
      write(6,'('' Program write_floweqn_str'')')
      if (CG_BUILD_64BIT) then
        write(6,'('' ...using 64-bit mode for particular integers'')')
      end if
!
!   data for writing
      gamma=1.4
      prandtl=0.90
!   WRITE FLOW EQUATION SET INFO
!   open CGNS file for modify
      call cg_open_f('grid.cgns',CG_MODE_MODIFY,index_file,ier)
      if (ier .ne. CG_OK) call cg_error_exit_f
!   we know there is only one base (real working code would check!)
      index_base=1
!   we know there is only one zone (real working code would check!)
      index_zone=1
!   existing file must be 3D structured (real working code would check!)
!   Create 'FlowEquationSet' node under 'Zone_t'
      call cg_goto_f(index_file,index_base,ier,'Zone_t',index_zone,'end')
!   equation dimension = 3
      ieq_dim=3
      call cg_equationset_write_f(ieq_dim,ier)
!
!   Create 'GoverningEquations' node under 'FlowEquationSet'
      call cg_goto_f(index_file,index_base,ier,'Zone_t',index_zone,            &
           'FlowEquationSet_t',1,'end')
      call cg_governing_write_f(CGNS_ENUMV(NSTurbulent),ier)
!   Create 'DiffusionModel' node under 'GoverningEquations'
      call cg_goto_f(index_file,index_base,ier,'Zone_t',index_zone,            &
           'FlowEquationSet_t',1,'GoverningEquations_t',1,'end')
      idata(1)=0
      idata(2)=1
      idata(3)=0
      idata(4)=0
      idata(5)=0
      idata(6)=0
      call cg_diffusion_write_f(idata,ier)
!
      nuse=1
!   Create 'GasModel' under 'FlowEquationSet'
      call cg_goto_f(index_file,index_base,ier,'Zone_t',index_zone,            &
           'FlowEquationSet_t',1,'end')
      call cg_model_write_f('GasModel_t',CGNS_ENUMV(Ideal),ier)
!   Create 'SpecificHeatRatio' under GasModel
      call cg_goto_f(index_file,index_base,ier,'Zone_t',index_zone,            &
           'FlowEquationSet_t',1,'GasModel_t',1,'end')
      call cg_array_write_f('SpecificHeatRatio',CGNS_ENUMV(RealSingle),1,[nuse],gamma,ier)
!   Create 'DataClass' under 'SpecificHeatRatio'
      call cg_goto_f(index_file,index_base,ier,'Zone_t',index_zone,            &
           'FlowEquationSet_t',1,'GasModel_t',1,'DataArray_t',1,'end')
      call cg_dataclass_write_f(CGNS_ENUMV(NondimensionalParameter),ier)
!
!   Create 'TurbulenceClosure' under 'FlowEquationSet'
      call cg_goto_f(index_file,index_base,ier,'Zone_t',index_zone,            &
           'FlowEquationSet_t',1,'end')
      call cg_model_write_f('TurbulenceClosure_t',CGNS_ENUMV(EddyViscosity),ier)
!   Create 'PrandtlTurbulent' under 'TurbulenceClosure'
      call cg_goto_f(index_file,index_base,ier,'Zone_t',index_zone,            &
           'FlowEquationSet_t',1,'TurbulenceClosure_t',1,'end')
      call cg_array_write_f('PrandtlTurbulent',CGNS_ENUMV(RealSingle),1,[nuse],prandtl,ier)
!   Create 'DataClass' under 'PrandtlTurbulent'
      call cg_goto_f(index_file,index_base,ier,'Zone_t',index_zone,            &
           'FlowEquationSet_t',1,'TurbulenceClosure_t',1,                      &
           'DataArray_t',1,'end')
      call cg_dataclass_write_f(CGNS_ENUMV(NondimensionalParameter),ier)
!
!   Create 'TurbulenceModel' under 'FlowEquationSet'
      call cg_goto_f(index_file,index_base,ier,'Zone_t',index_zone,            &
           'FlowEquationSet_t',1,'end')
      call cg_model_write_f('TurbulenceModel_t',                               &
           CGNS_ENUMV(OneEquation_SpalartAllmaras),ier)
!   close CGNS file
      call cg_close_f(index_file,ier)
      write(6,'('' Successfully wrote equation set info to file'',             &
       '' grid.cgns'')')
      stop
      end

@echo off
setlocal

set dir=%~dps0
if not exist %dir%cgnscheck.exe goto notfound

rem -- for path setting to dlls
if exist %dir%..\cgconfig.bat call %dir%..\cgconfig.bat
if exist %dir%cgconfig.bat call %dir%cgconfig.bat

%dir%cgnscheck -U %1 %2
goto done

:notfound
echo cgnscheck.exe not found in %dir%
:done
endlocal

#!/bin/sh
set -e
#git clone -b develop --single-branch https://github.com/CGNS/CGNS.git
#cd CGNS/src
cd src
if [ $TRAVIS_OS_NAME = "osx" ]; then
  export FC=gfortran-4.9
  export F77=gfortran-4.9
  export CC=gcc-4.9
else
  export FC=gfortran
  export F77=gfortran
  export CC=gcc
  export FLIBS="-Wl,--no-as-needed -ldl -lz"
  export LIBS="-Wl,--no-as-needed -ldl -lz"
fi

./configure \
--prefix=$PWD/cgns_build \
--with-hdf5=$HOME/hdf5 \
--with-fortran \
--enable-lfs \
--enable-64bit \
--disable-shared \
--enable-debug \
--with-zlib \
--disable-cgnstools \
--disable-x \
--enable-64bit

@echo off
setlocal
if "%2" == "" (
  echo usage: runptest mpiexecname exename [numprocs]
  goto done
)
if "%3" == "" (
  set np=2
) else (
  set np=%3
)
set PATH=..\lib;%PATH%
%1 -np %np% %2 > nul 2>&1
if %ERRORLEVEL% == 0 (
  echo %2 ... passed
) else (
  echo %2 ... *** FAILED ***
)
:done
endlocal

@echo off
setlocal

set args=-MD -MT -debug -lfs -legacy -64 -scope -dll -install -f2c -ifort
set args=%args% -absoft -hdf5 -zlib -szip -mpi -parallel -basescope
set args=%args% -cgnstools -tcl -tk -nocut -nomesh -winhtml
set copts=
set debug=
set cfgflags=
set dllopts=
set build=
set dolegacy=0
set do64bit=0
set doscope=0
set dobasescope=0
set target=cgns
set make=nmake /nologo
set f2c=
set f77=f77
set hdf5inc=
set hdf5lib=
set zliblib=
set sziplib=
set mpiinc=
set mpilibs=
set mpiexec=
set hdf5dll=#HDF5DLL
set parallel=
set cgnstools=
set tcldir=
set tkdir=
set tclinc=
set tcllib=
set tklib=
set plotopts=
set instdir=c:\cgnslib
set builddir=lib
set winhtml=

set drive=%~d0
set cgnsdir=%~dps0

:next
if "%1" == "" goto doit
if %1 == -help goto usage
for %%a in ( %args% ) do (
  if %1 == %%a goto copts
)
goto badarg

rem ----- compiler options

:copts
if %1 == -MD (
  echo using MD : multi-threaded library with RTL
  set copts=/MD
  shift
  goto next
)
if %1 == -MT (
  echo using MT : multi-threaded library
  set copts=/MT
  shift
  goto next
)
if %1 == -debug (
  echo debug is enabled
  set debug=/Zi
  shift
  goto next
)

rem ----- enable large file support

if %1 == -lfs (
  echo large file support is enabled
  set cfgflags=/DHAVE_LSEEK64
  shift
  goto next
)

rem ----- build legacy code

if %1 == -legacy (
  echo building legacy code version
  set dolegacy=1
  shift
  goto next
)

rem ----- build for 64 bit

if %1 == -64 (
  echo building 64-bit version
  set do64bit=1
  shift
  goto next
)

rem ----- enable enum scoping

if %1 == -scope (
  echo enabling enumeration scoping
  set doscope=1
  shift
  goto next
)

rem ----- enable base scope for family/zone ref-to

if %1 == -basescope (
  echo enabling base scope for family/zone ref-to
  set dobasescope=1
  shift
  goto next
)

rem ----- build DLL

if %1 == -dll (
  echo building DLL instead of static library
  set target=dll
  set dllopts=/DBUILD_DLL
  shift
  goto next
)

rem ----- ifort Fortran compiler

if %1 == -ifort (
  echo using ifort Fortran compiler with UPPERCASE
  set f77=ifort
  set f2c=/DUPPERCASE
  shift
  goto next
)

rem ----- absoft Fortran compiler

if %1 == -absoft (
  echo using absoft Fortran compiler with LOWERCASE
  set f2c=/DLOWERCASE
  shift
  goto next
)

rem ----- parallel IO code

if %1 == -parallel (
  echo building parallel IO interface
  set parallel=runptests
  shift
  goto next
)

rem ----- cgnstools options

if %1 == -cgnstools (
  echo building cgsntools
  set cgnstools=cgnstools
  shift
  goto next
)

if %1 == -nocut (
  echo building cgnsplot without cutting plane
  set plotopts=/DNO_CUTTING_PLANE %plotopts%
  shift
  goto next
)

if %1 == -nomesh (
  echo building cgnsplot without structured mesh boundaries
  set plotopts=/DNO_MESH_BOUNDARIES %plotopts%
  shift
  goto next
)

if %1 == -winhtml (
  set winhtml=c:\PROGRA~1\HTMLHE~1
  shift
  goto next
)

rem ----- Fortran to C interface

if not %1 == -f2c goto hdf5
set f2c=/DLOWERCASE_
shift
if "%1" == "" (
  echo using LOWERCASE_ as Fortran to C interface
  goto doit
)
for %%a in ( %args% ) do (
  if %1 == %%a (
    echo using LOWERCASE_ as Fortran to C interface
    goto next
  )
)
if %1 == none (
  echo Fortran interface is disabled
  set f2c=none
  shift
  goto next
)
if %1 == LOWERCASE goto setf2c
if %1 == LOWERCASE_ goto setf2c
if %1 == LOWERCASE__ goto setf2c
if %1 == UPPERCASE goto setf2c
if %1 == UPPERCASE_ goto setf2c
if %1 == UPPERCASE__ goto setf2c
echo ERROR:-f2c argument %1 is invalid
goto usage

:setf2c
echo using %1 as Fortran to C interface
set f2c=/D%1
shift
goto next

rem ----- HDF5 setup

:hdf5
if not %1 == -hdf5 goto zlib
shift

if '%1' == '' goto findhdf5
for %%a in ( %args% ) do if %1 == %%a goto findhdf5

set hdf5dir=%~s1
if not exist %hdf5dir%\nul (
  echo ERROR:HDF5 directory %1 does not exist or is not a directory
  goto done
)
shift
goto gethdf5

:findhdf5
echo checking for HDF5 ...
for /D %%d in ( %drive%\*.* ) do (
  if exist %%d\include\hdf5.h (
    echo %%d
    set hdf5dir=%%d
    goto gethdf5
  )
  if exist %%d\src\hdf5.h (
    echo %%d
    set hdf5dir=%%d
    goto gethdf5
  )
  for /D %%e in ( %%d\*.* ) do (
    if exist %%e\include\hdf5.h (
      echo %%e
      set hdf5dir=%%e
      goto gethdf5
    )
    if exist %%e\src\hdf5.h (
      echo %%e
      set hdf5dir=%%e
      goto gethdf5
    )
    for /D %%f in ( %%e\*.* ) do (
      if exist %%f\include\hdf5.h (
        echo %%f
        set hdf5dir=%%f
        goto gethdf5
      )
      if exist %%f\src\hdf5.h (
        echo %%f
        set hdf5dir=%%f
        goto gethdf5
      )
      for /D %%g in ( %%f\*.* ) do (
        if exist %%g\include\hdf5.h (
          echo %%g
          set hdf5dir=%%g
          goto gethdf5
        )
        if exist %%g\src\hdf5.h (
          echo %%g
          set hdf5dir=%%g
          goto gethdf5
        )
      )
    )
  )
)
echo ERROR:couldn't find hdf5 directory
goto done

:gethdf5
echo checking for hdf5 headers in %hdf5dir% ...
if exist %hdf5dir%\include\hdf5.h (
  echo %hdf5dir%\include
  set hdf5inc=%hdf5dir%\include
  echo checking for hdf5 library in %hdf5dir%\lib ...
  for %%l in ( hdf5dll hdf5 hdf5dlld hdf5d ) do (
    for %%d in ( dll lib ) do (
      if exist %hdf5dir%\%%d\%%l.lib (
        echo %hdf5dir%\%%d\%%l.lib
        set hdf5lib=%hdf5dir%\%%d\%%l.lib
        if %%l == hdf5dll set hdf5dll=HDF5DLL
        if %%l == hdf5dlld set hdf5dll=HDF5DLL
        goto next
      )
    )
  )
  echo ERROR:hdf5 library not found in %hdf5dir%
  goto done
)
if exist %hdf5dir%\src\hdf5.h (
  echo %hdf5dir%\src
  set hdf5inc=%hdf5dir%\src
  echo checking for hdf5 library in %hdf5dir%\proj\ ...
  for %%j in ( Release Debug ) do (
    for %%i in ( hdf5dll hdf5 ) do (
      if exist %hdf5dir%\proj\%%i\%%j\%%i.lib (
        echo %hdf5dir%\proj\%%i\%%j\%%i.lib
        set hdf5lib=%hdf5dir%\proj\%%i\%%j\%%i.lib
        if %%i == hdf5dll set hdf5dll=HDF5DLL
        goto next
      )
      if exist %hdf5dir%\proj\%%i\%%j\%%id.lib (
        echo %hdf5dir%\proj\%%i\%%j\%%id.lib
        set hdf5lib=%hdf5dir%\proj\%%i\%%j\%%id.lib
        if %%i == hdf5dll set hdf5dll=HDF5DLL
        goto next
      )
    )
  )
  echo ERROR:hdf5 library not found in %hdf5dir%\proj
  goto done
)
echo ERROR:hdf5.h not found in %hdf5dir%\include or %hdf5dir%\src
goto done

rem ----- zlib setup

:zlib
if not %1 == -zlib goto szip
echo checking for zlib ...
shift
if '%1' == '' goto findzlib
for %%a in ( %args% ) do if %1 == %%a goto findzlib

if not exist %1 (
  echo ERROR:zlib library %1 doesn't exist
  goto done
)
set zliblib=%~s1
echo %zliblib%
shift
goto next

:findzlib
for %%i in ( zlib zdll ) do (
  if exist %hdf5dir%\lib\%%i.lib (
    echo %hdf5dir%\lib\%%i.lib
    set zliblib=%hdf5dir%\lib\%%i.lib
    goto next
  )
)
for /D %%d in ( %drive%\*.* ) do (
  for %%i in ( zlib zdll ) do (
    if exist %%d\%%i.lib (
      echo %%d\%%i.lib
      set zliblib=%%d\%%i.lib
      goto next
    )
  )
  for /D %%e in ( %%d\*.* ) do (
    for %%i in ( zlib zdll ) do (
      if exist %%e\%%i.lib (
        echo %%e\%%i.lib
        set zliblib=%%e\%%i.lib
        goto next
      )
    )
    for /D %%f in ( %%e\*.* ) do (
      for %%i in ( zlib zdll ) do (
        if exist %%f\%%i.lib (
          echo %%f\%%i.lib
          set zliblib=%%f\%%i.lib
          goto next
        )
      )
      for /D %%g in ( %%f\*.* ) do (
        for %%i in ( zlib zdll ) do (
          if exist %%g\%%i.lib (
            echo %%g\%%i.lib
            set zliblib=%%g\%%i.lib
            goto next
          )
        )
      )
    )
  )
)
echo ERROR:couldn't find zlib or zdll library
goto done

rem ----- szip setup

:szip
if not %1 == -szip goto mpi
echo checking for szip ...
shift
if '%1' == '' goto findszip
for %%a in ( %args% ) do if %1 == %%a goto findszip

if not exist %1 (
  echo ERROR:szip library %1 doesn't exist
  goto done
)
set sziplib=%~s1
echo %sziplib%
shift
goto next

:findszip
for %%i in ( szip szlib szlibdll ) do (
  if exist %hdf5dir%\lib\%%i.lib (
    echo %hdf5dir%\lib\%%i.lib
    set sziplib=%hdf5dir%\lib\%%i.lib
    goto next
)
for /D %%d in ( %drive%\*.* ) do (
  for %%i in ( szip szlib szlibdll ) do (
    if exist %%d\%%i.lib (
      echo %%d\%%i.lib
      set sziplib=%%d\%%i.lib
      goto next
    )
  )
  for /D %%e in ( %%d\*.* ) do (
    for %%i in ( szip szlib szlibdll ) do (
      if exist %%e\%%i.lib (
        echo %%e\%%i.lib
        set sziplib=%%e\%%i.lib
        goto next
      )
    )
    for /D %%f in ( %%e\*.* ) do (
      for %%i in ( szip szlib szlibdll ) do (
        if exist %%f\%%i.lib (
          echo %%f\%%i.lib
          set sziplib=%%f\%%i.lib
          goto next
        )
      )
      for /D %%g in ( %%f\*.* ) do (
        for %%i in ( szip szlib szlibdll ) do (
          if exist %%g\%%i.lib (
            echo %%g\%%i.lib
            set sziplib=%%g\%%i.lib
            goto next
          )
        )
      )
    )
  )
)
echo ERROR:couldn't find szip, szlib or szlibdll library
goto done

rem ----- MPI setup

:mpi
if not %1 == -mpi goto tcl
shift

if '%1' == '' goto findmpi
for %%a in ( %args% ) do if %1 == %%a goto findmpi

set mpidir=%~s1
if not exist %mpidir%\nul (
  echo ERROR:MPI directory %1 does not exist or is not a directory
  goto done
)
shift
goto getmpi

:findmpi
echo checking for MPI ...
for /D %%d in ( c:\PROGRA~1\*.* ) do (
  if exist %%d\include\mpi.h (
    echo %%d
    set mpidir=%%d
    goto getmpi
  )
)
for /D %%d in ( %drive%\*.* ) do (
  if exist %%d\include\mpi.h (
    echo %%d
    set mpidir=%%d
    goto getmpi
  )
  if exist %%d\src\include\mpi.h (
    echo %%d
    set mpidir=%%d
    goto getmpi
  )
  for /D %%e in ( %%d\*.* ) do (
    if exist %%e\include\mpi.h (
      echo %%e
      set mpidir=%%e
      goto getmpi
    )
    if exist %%e\src\include\mpi.h (
      echo %%e
      set mpidir=%%e
      goto getmpi
    )
    for /D %%f in ( %%e\*.* ) do (
      if exist %%f\include\mpi.h (
        echo %%f
        set mpidir=%%f
        goto getmpi
      )
      if exist %%f\src\include\mpi.h (
        echo %%f
        set mpidir=%%f
        goto getmpi
      )
      for /D %%g in ( %%f\*.* ) do (
        if exist %%g\include\mpi.h (
          echo %%g
          set mpidir=%%g
          goto getmpi
        )
        if exist %%g\src\include\mpi.h (
          echo %%g
          set mpidir=%%g
          goto getmpi
        )
      )
    )
  )
)
echo ERROR:couldn't find MPI directory
goto done

:getmpi
echo checking for mpi headers ...
if exist %mpidir%\include\mpi.h (
  echo %mpidir%\include
  set mpiinc=%mpidir%\include
)
if exist %mpidir%\src\include\mpi.h (
  echo %mpidir%\src\include
  set mpiinc=%mpidir%\src\include
)
if "%mpiinc%" == "" (
  echo ERROR:mpi.h not found in %mpidir%\include or %mpidir%\src\include
  goto done
)
rem ----- if using OpenMPI
if exist %mpidir%\share\openmpi\nul set mpiinc=%mpiinc% /DOMPI_IMPORTS
echo checking for mpiexec ...
if exist %mpidir%\bin\mpiexec.exe (
  echo %mpidir%\bin\mpiexec.exe
  set mpiexec=%mpidir%\bin\mpiexec.exe
)
echo checking for MPI library ...
for %%l in ( mpi mpich libmpi mpid mpichd libmpid impi) do (
  if exist %mpidir%\lib\%%l.lib (
    echo %mpidir%\lib\%%l.lib
    set mpilibs=%mpidir%\lib\%%l.lib
    goto next
  )
)
echo ERROR:MPI library not found in %mpidir%\lib
goto done

rem ----- tcl directory

:tcl
if not %1 == -tcl goto tk
shift
if '%1' == '' (
  echo ERROR:tcl directory arg to -tcl not given
  goto usage
)
for %%a in ( %args% ) do (
  if %1 == %%a (
    echo ERROR:tcl directory arg to -tcl not given
    goto usage
  )
)
set tcldir=%~s1
if exist %tcldir%\generic\tcl.h goto got_tcldir
if exist %tcldir%\include\tcl.h goto got_tcldir
echo ERROR:can't find tcl.h in %1\include or %1\generic
goto done
:got_tcldir
shift
goto next

rem ----- tk directory

:tk
if not %1 == -tk goto install
shift
if '%1' == '' (
  echo ERROR:tk directory arg to -tk not given
  goto usage
)
for %%a in ( %args% ) do (
  if %1 == %%a (
    echo ERROR:tk directory arg to -tk not given
    goto usage
  )
)
set tkdir=%~s1
if exist %tkdir%\generic\tk.h goto got_tkdir
if exist %tkdir%\include\tk.h goto got_tkdir
echo ERROR:can't find tk.h in %1\include or %1\generic
goto done
:got_tkdir
shift
goto next

rem ----- installation directory

:install
if not %1 == -install goto badarg
shift
if '%1' == '' (
  echo ERROR:installation directory not given
  goto usage
)
for %%a in ( %args% ) do (
  if %1 == %%a (
    echo ERROR:installation directory not given
    goto usage
  )
)
set instdir=%~s1
shift
goto next

rem ----- print usage

:badarg
echo ERROR:unknown argument %1
:usage
echo usage: configure [options]
echo options:
echo   -MT : multi-threaded using libcmt.lib (default)
echo   -MD : multi-threaded using mscvrt.lib and mscvrt.dll
echo   -debug : add debugging to library
echo   -lfs : enable large file support (more than 2Gb)
echo   -legacy : build as legacy code
echo   -64 : build 64-bit version
echo   -scope : enable enumeration scoping by prefixing CG_
echo   -parallel : enable parallel IO
echo   -cgnstools : build CGNStools
echo   -basescope : enable base scope for family/zone ref-to
echo   -dll : build DLL istead of static library
echo   -ifort : use ifort Fortran compiler (implies -f2c UPPERCASE)
echo   -absoft : use the absoft Fortran compiler (implies -f2c LOWERCASE)
echo   -f2c [type] : set Fortran to C interface. "type" is one of LOWERCASE,
echo        LOWERCASE_,LOWERCASE__,UPPERCASE,UPPERCASE_, or UPPERCASE__ If not
echo        given, LOWERCASE_ is used. This option will also use Unix-like
echo        argument passing, instead of Visual Fortran.
echo        If you specify "type" as none, the Fortran interface is disbled.
echo   -hdf5 [hdf5dir] : build HDF5 interface. "hdf5dir" is the HDF5 toplevel
echo        directory. If "hdf5dir" is not given, the current drive is searched.
echo   -zlib [zliblib] : use zlib. "zliblib" is the pathname to the library.
echo        If "zliblib" is not given, the current drive is searched.
echo   -szip [sziplib] : use szip. "sziplib" is the pathname to the library.
echo        If "sziplib" is not given, the current drive is searched.
echo   -mpi [mpidir] : build MPI interface. "mpidir" is the MPI toplevel
echo        directory. If "mpidir" is not given, the current drive is searched.
echo   -tcl tcldir : specify the Tcl source directory
echo   -tk tkdir : specify the Tk source directory
echo   -nocut : build cgnsplot without cutting plane
echo   -nomesh : build cgnsplot without structured mesh boundaries
echo   -install instdir : install to directory "instdir" (default %instdir%)
echo        headers are installed to instdir\include
echo        library is installed to instdir\lib
echo        executables are installed to instdir\bin
goto done

:doit

if "%copts%" == "" set copts=/MT
if %copts% == /MT (
  set mslib=libcmt.lib
) else (
  set mslib=msvcrt.lib
)
if not "%debug%" == "" (
  set copts=%copts%d %debug%
  set lopts=/debug
) else (
  set lopts=/release
)
if %do64bit% == 1 (
  set copts=%copts% /Wp64
  set windir=WIN64
) else (
  set windir=WIN32
)

set libs="ADF"

if "%hdf5inc%" == "" (
  set hdf5def=
  set hdf5lib=
  set zliblib=
  set sziplib=
) else (
  set hdf5def=/I%hdf5inc%
  set libs=%libs HDF5
  set build=%build% /DBUILD_HDF5
)

set mpidef=
if not "%mpiinc%" == "" set mpidef=/I%mpiinc%
if not "%parallel%" == "" set build=%build% /DBUILD_PARALLEL

if "%f2c%" == "none" (
  set f2cobjs=
  set f2cflags=
) else (
  set f2cobjs=$^(F2COBJS^)
  set f2cflags=%f2c%
)

rem ----- Tcl setup

if not "%tcldir%" == "" goto tclincludes
if not "%tkdir%" == "" (
  if exist %tkdir%\include\tcl.h (
    set tcldir=%tkdir%
    goto tclincludes
  )
)
echo checking for Tcl
if exist c:\Tcl\include\tcl.h (
  set tcldir=c:\Tcl
  goto tclincludes
)
if exist c:\progra~1\Tcl\include\tcl.h (
  set tcldir=c:c:\progra~1\Tcl
  goto tclincludes
)
if exist %drive%\Tcl\include\tcl.h (
  set tcldir=%drive%\Tcl
  goto tclincludes
)
for /D %%d in ( %drive%\*.* ) do (
  if exist %%d\generic\tcl.h (
    set tcldir=%%d
    goto tclincludes
  )
  if exist %%d\include\tcl.h (
    set tcldir=%%d
    goto tclincludes
  )
  for /D %%e in ( %%d\*.* ) do (
    if exist %%e\generic\tcl.h (
      set tcldir=%%e
      goto tclincludes
    )
    if exist %%e\include\tcl.h (
      set tcldir=%%e
      goto tclincludes
    )
    for /D %%f in ( %%e\*.* ) do (
      if exist %%f\generic\tcl.h (
        set tcldir=%%f
        goto tclincludes
      )
      if exist %%f\include\tcl.h (
        set tcldir=%%f
        goto tclincludes
      )
      for /D %%g in ( %%f\*.* ) do (
        if exist %%g\generic\tcl.h (
          set tcldir=%%g
          goto tclincludes
        )
        if exist %%g\include\tcl.h (
          set tcldir=%%g
          goto tclincludes
        )
      )
    )
  )
)
echo couldn't find Tcl directory
echo WARNING:You will not be able to build cgnstools
goto configure

:tclincludes
echo using Tcl directory %tcldir%
if exist %tcldir%\generic\tcl.h (
  set tclinc=/I%tcldir%\generic
) else (
  set tclinc=/I%tcldir%\include
)
for %%i in ( 81 82 83 84 85 86 ) do (
  if exist %tcldir%\lib\tcl%%i.lib (
    set tcllib=%tcldir%\lib\tcl%%i.lib
    goto gettk
  )
  if exist %tcldir%\win\Release\tcl%%i.lib (
    set tcllib=%tcldir%\win\Release\tcl%%i.lib
    goto gettk
  )
  if exist %tcldir%\win\Debug\tcl%%i.lib (
    set tcllib=%tcldir%\win\Debug\tcl%%i.lib
    goto gettk
  )
)
set tcllib=%tcldir%\lib\tcl.lib
echo couldn't find Tcl library - using %tcllib%

:gettk
if "%tkdir%" == "" (
  if exist %tcldir%\include\tk.h set tkdir=%tcldir%
)
if not "%tkdir%" == "" goto tkincludes
echo checking for Tk
for /D %%d in ( %drive%\*.* ) do (
  if exist %%d\generic\tk.h (
    set tkdir=%%d
    goto tkincludes
  )
  if exist %%d\include\tk.h (
    set tkdir=%%d
    goto tkincludes
  )
  for /D %%e in ( %%d\*.* ) do (
    if exist %%e\generic\tk.h (
      set tkdir=%%e
      goto tkincludes
    )
    if exist %%e\include\tk.h (
      set tkdir=%%e
      goto tkincludes
    )
    for /D %%f in ( %%e\*.* ) do (
      if exist %%f\generic\tk.h (
        set tkdir=%%f
        goto tkincludes
      )
      if exist %%f\include\tk.h (
        set tkdir=%%f
        goto tkincludes
      )
      for /D %%g in ( %%f\*.* ) do (
        if exist %%g\generic\tk.h (
          set tkdir=%%g
          goto tkincludes
        )
        if exist %%g\include\tk.h (
          set tkdir=%%g
          goto tkincludes
        )
      )
    )
  )
)
echo couldn't find Tk directory
echo WARNING:You will not be able to build cgnstools
goto configure

:tkincludes
echo using Tk directory %tkdir%
if not %tkdir% == %tcldir% (
  if exist %tkdir%\generic\tk.h (
    set tclinc=%tclinc% /I%tkdir%\generic
  ) else (
    set tclinc=%tclinc% /I%tkdir%\include
  )
)
if exist %tkdir%\include\tkWinInt.h (
  goto gotwinint
)
if exist %tkdir%\win\tkWinInt.h (
  set tclinc=%tclinc% /I%tkdir%\win
  goto gotwinint
)
if exist %tkdir%\include\win\tkWinInt.h (
  set tclinc=%tclinc% /I%tkdir%\include\win
  goto gotwinint
)
echo couldn't find tkWinInt.h in %tkdir%\include or %tkdir%\win or %tkdir%\include\win
echo WARNING:You will not be able to build cgnstools
goto configure

:gotwinint
if exist %tkdir%\xlib\nul set tclinc=%tclinc% /I%tkdir%\xlib

for %%i in ( 81 82 83 84 85 86 ) do (
  if exist %tkdir%\lib\tk%%i.lib (
    set tklib=%tkdir%\lib\tk%%i.lib
    goto configure
  )
  if exist %tkdir%\win\Release\tk%%i.lib (
    set tklib=%tkdir%\win\Release\tk%%i.lib
    goto setopts
  )
  if exist %tkdir%\win\Debug\tk%%i.lib (
    set tklib=%tkdir%\win\Debug\tk%%i.lib
    goto setopts
  )
)
set tklib=%tkdir%\lib\tk.lib
echo couldn't find Tk library - using %tklib%

:configure
echo install library in %instdir%\lib
echo install headers in %instdir%\include
echo install executables in %instdir%\bin

if %dolegacy% == 1 (
  set do64bit=0
  set fbytes=
  if not "%hdf5inc%" == "" (
    set adfinc=install-adf install-adfh
  ) else (
    set adfinc=install-adf
  )
) else (
  set fbytes=*4
  if %do64bit% == 1 set fbytes=*8
  set adfinc=
)

rem ----- create cgnstypes.h

echo creating cgnstypes.h
echo /* ------------------------------------------------------------------------- *> cgnstypes.h
echo  * CGNS - CFD General Notation System (http://www.cgns.org)                  *>> cgnstypes.h
echo  * CGNS/MLL - Mid-Level Library header file                                  *>> cgnstypes.h
echo  * Please see cgnsconfig.h file for this local installation configuration    *>> cgnstypes.h
echo  * ------------------------------------------------------------------------- */>> cgnstypes.h
echo.>> cgnstypes.h
echo /* ------------------------------------------------------------------------- *>> cgnstypes.h
echo.>> cgnstypes.h
echo   This software is provided 'as-is', without any express or implied warranty.>> cgnstypes.h
echo   In no event will the authors be held liable for any damages arising from>> cgnstypes.h
echo   the use of this software.>> cgnstypes.h
echo.>> cgnstypes.h
echo   Permission is granted to anyone to use this software for any purpose,>> cgnstypes.h
echo   including commercial applications, and to alter it and redistribute it>> cgnstypes.h
echo   freely, subject to the following restrictions:>> cgnstypes.h
echo.>> cgnstypes.h
echo   1. The origin of this software must not be misrepresented; you must not>> cgnstypes.h
echo      claim that you wrote the original software. If you use this software>> cgnstypes.h
echo      in a product, an acknowledgment in the product documentation would be>> cgnstypes.h
echo      appreciated but is not required.>> cgnstypes.h
echo.>> cgnstypes.h
echo   2. Altered source versions must be plainly marked as such, and must not>> cgnstypes.h
echo      be misrepresented as being the original software.>> cgnstypes.h
echo.>> cgnstypes.h
echo   3. This notice may not be removed or altered from any source distribution.>> cgnstypes.h
echo.>> cgnstypes.h
echo  * ------------------------------------------------------------------------- */>> cgnstypes.h
echo.>> cgnstypes.h
echo #ifndef CGNSTYPES_H>> cgnstypes.h
echo #define CGNSTYPES_H>> cgnstypes.h
echo.>> cgnstypes.h
echo #define CG_BUILD_LEGACY %dolegacy% >> cgnstypes.h
echo #define CG_BUILD_64BIT  %do64bit% >> cgnstypes.h
echo #define CG_BUILD_SCOPE  %doscope% >> cgnstypes.h
echo #define CG_BUILD_BASESCOPE  %dobasescope% >> cgnstypes.h
echo.>> cgnstypes.h
echo #define CG_MAX_INT32 0x7FFFFFFF>> cgnstypes.h
echo #ifdef _WIN32>> cgnstypes.h
echo #define CG_LONG_T    __int64>> cgnstypes.h
echo #ifdef CG_BUILD_64BIT>> cgnstypes.h
echo #define stat _stat32i64>> cgnstypes.h
echo #endif>> cgnstypes.h
echo #else>> cgnstypes.h
echo # define CG_LONG_T long long>> cgnstypes.h
echo #endif>> cgnstypes.h
echo.>> cgnstypes.h
echo #if CG_BUILD_LEGACY>> cgnstypes.h
echo # define CG_SIZEOF_SIZE    32 >> cgnstypes.h
echo # define CG_SIZE_DATATYPE "I4">> cgnstypes.h
echo # define cgerr_t  int>> cgnstypes.h
echo # define cgint_t  int>> cgnstypes.h
echo # define cgsize_t int>> cgnstypes.h
echo # define cgid_t   double>> cgnstypes.h
echo #else>> cgnstypes.h
echo # if CG_BUILD_64BIT>> cgnstypes.h
echo #  define CG_SIZEOF_SIZE    64 >> cgnstypes.h
echo #  define CG_SIZE_DATATYPE "I8">> cgnstypes.h
echo    typedef CG_LONG_T cgsize_t;>> cgnstypes.h
echo # else>> cgnstypes.h
echo #  define CG_SIZEOF_SIZE    32 >> cgnstypes.h
echo #  define CG_SIZE_DATATYPE "I4">> cgnstypes.h
echo    typedef int cgsize_t;>> cgnstypes.h
echo # endif>> cgnstypes.h
echo   typedef int cgerr_t;>> cgnstypes.h
echo   typedef int cgint_t;>> cgnstypes.h
echo   typedef double cgid_t;>> cgnstypes.h
echo #endif>> cgnstypes.h
echo.>> cgnstypes.h
echo typedef CG_LONG_T cglong_t;>> cgnstypes.h
echo typedef unsigned CG_LONG_T cgulong_t;>> cgnstypes.h
echo.>> cgnstypes.h
echo #endif>> cgnstypes.h

rem ----- create cgnstypes_f.h

echo creating cgnstypes_f.h
echo /* ------------------------------------------------------------------------- *> cgnstypes_f.h
echo  * CGNS - CFD General Notation System (http://www.cgns.org)                  *>> cgnstypes_f.h
echo  * CGNS/MLL - Mid-Level Library header file                                  *>> cgnstypes_f.h
echo  * Please see cgnsconfig.h file for this local installation configuration    *>> cgnstypes_f.h
echo  * ------------------------------------------------------------------------- */>> cgnstypes_f.h
echo.>> cgnstypes_f.h
echo /* ------------------------------------------------------------------------- *>> cgnstypes_f.h
echo.>> cgnstypes_f.h
echo   This software is provided 'as-is', without any express or implied warranty.>> cgnstypes_f.h
echo   In no event will the authors be held liable for any damages arising from>> cgnstypes_f.h
echo   the use of this software.>> cgnstypes_f.h
echo.>> cgnstypes_f.h
echo   Permission is granted to anyone to use this software for any purpose,>> cgnstypes_f.h
echo   including commercial applications, and to alter it and redistribute it>> cgnstypes_f.h
echo   freely, subject to the following restrictions:>> cgnstypes_f.h
echo.>> cgnstypes_f.h
echo   1. The origin of this software must not be misrepresented; you must not>> cgnstypes_f.h
echo      claim that you wrote the original software. If you use this software>> cgnstypes_f.h
echo      in a product, an acknowledgment in the product documentation would be>> cgnstypes_f.h
echo      appreciated but is not required.>> cgnstypes_f.h
echo.>> cgnstypes_f.h
echo   2. Altered source versions must be plainly marked as such, and must not>> cgnstypes_f.h
echo      be misrepresented as being the original software.>> cgnstypes_f.h
echo.>> cgnstypes_f.h
echo   3. This notice may not be removed or altered from any source distribution.>> cgnstypes_f.h
echo.>> cgnstypes_f.h
echo  * ------------------------------------------------------------------------- */>> cgnstypes_f.h
echo.>> cgnstypes_f.h
echo #ifndef CGNSTYPES_F_H>> cgnstypes_f.h
echo #define CGNSTYPES_F_H>> cgnstypes_f.h
echo.>> cgnstypes_f.h
echo #define CG_BUILD_64BIT %do64bit% >> cgnstypes_f.h
echo.>> cgnstypes_f.h
echo #if CG_BUILD_64BIT>> cgnstypes_f.h
echo # define cgsize_t integer*8 >> cgnstypes_f.h
echo # define CGSIZE_T integer*8 >> cgnstypes_f.h
echo #else>> cgnstypes_f.h
echo # define cgsize_t integer*4 >> cgnstypes_f.h
echo # define CGSIZE_T integer*4 >> cgnstypes_f.h
echo #endif>> cgnstypes_f.h
echo.>> cgnstypes_f.h
echo #define cglong_t integer*8 >> cgnstypes_f.h
echo #define CGLONG_T integer*8 >> cgnstypes_f.h
echo #define cgid_t   real*8 >> cgnstypes_f.h
echo #define CGID_T   real*8 >> cgnstypes_f.h
echo.>> cgnstypes_f.h
echo #endif>> cgnstypes_f.h

rem ----- create cgnslib_f.h

echo creating cgnslib_f.h
echo c * ------------------------------------------------------------------------- *> cgnslib_f.h
echo c * CGNS - CFD General Notation System (http://www.cgns.org)                  *>> cgnslib_f.h
echo c * CGNS/MLL - Mid-Level Library header file                                  *>> cgnslib_f.h
echo c * Please see cgnsconfig.h file for this local installation configuration    *>> cgnslib_f.h
echo c * ------------------------------------------------------------------------- *>> cgnslib_f.h
echo c>> cgnslib_f.h
echo c * ------------------------------------------------------------------------- *>> cgnslib_f.h
echo c>> cgnslib_f.h
echo c  This software is provided 'as-is', without any express or implied warranty.>> cgnslib_f.h
echo c  In no event will the authors be held liable for any damages arising from>> cgnslib_f.h
echo c  the use of this software.>> cgnslib_f.h
echo c>> cgnslib_f.h
echo c  Permission is granted to anyone to use this software for any purpose,>> cgnslib_f.h
echo c  including commercial applications, and to alter it and redistribute it>> cgnslib_f.h
echo c  freely, subject to the following restrictions:>> cgnslib_f.h
echo c>> cgnslib_f.h
echo c  1. The origin of this software must not be misrepresented; you must not>> cgnslib_f.h
echo c     claim that you wrote the original software. If you use this software>> cgnslib_f.h
echo c     in a product, an acknowledgment in the product documentation would be>> cgnslib_f.h
echo c     appreciated but is not required.>> cgnslib_f.h
echo c>> cgnslib_f.h
echo c  2. Altered source versions must be plainly marked as such, and must not>> cgnslib_f.h
echo c     be misrepresented as being the original software.>> cgnslib_f.h
echo c>> cgnslib_f.h
echo c  3. This notice may not be removed or altered from any source distribution.>> cgnslib_f.h
echo c>> cgnslib_f.h
echo c * ------------------------------------------------------------------------- *>> cgnslib_f.h
echo c>> cgnslib_f.h
echo ! Fortran version of cgnslib.h>> cgnslib_f.h
echo         integer CG_BUILD_64BIT>> cgnslib_f.h
echo         parameter (CG_BUILD_64BIT = %do64bit%)>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      modes for cgns file                                            *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo         integer%fbytes% CG_MODE_READ, CG_MODE_WRITE, CG_MODE_MODIFY>> cgnslib_f.h
echo         parameter (CG_MODE_READ   = 0)>> cgnslib_f.h
echo         parameter (CG_MODE_WRITE  = 1)>> cgnslib_f.h
echo         parameter (CG_MODE_MODIFY = 2)>> cgnslib_f.h
echo !* legacy code support>> cgnslib_f.h
echo         integer%fbytes% MODE_READ, MODE_WRITE, MODE_MODIFY>> cgnslib_f.h
echo         parameter (MODE_READ   = 0)>> cgnslib_f.h
echo         parameter (MODE_WRITE  = 1)>> cgnslib_f.h
echo         parameter (MODE_MODIFY = 2)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      file types                                                     *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo         integer%fbytes% CG_FILE_NONE, CG_FILE_ADF, CG_FILE_HDF5>> cgnslib_f.h
echo         integer%fbytes% CG_FILE_ADF2>> cgnslib_f.h
echo         parameter (CG_FILE_NONE = 0)>> cgnslib_f.h
echo         parameter (CG_FILE_ADF  = 1)>> cgnslib_f.h
echo         parameter (CG_FILE_HDF5 = 2)>> cgnslib_f.h
echo         parameter (CG_FILE_ADF2 = 3)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      some error code                                                *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo         integer%fbytes% CG_OK, CG_ERROR, CG_NODE_NOT_FOUND>> cgnslib_f.h
echo         integer%fbytes% CG_INCORRECT_PATH, CG_NO_INDEX_DIM>> cgnslib_f.h
echo         parameter (CG_OK             = 0)>> cgnslib_f.h
echo         parameter (CG_ERROR          = 1)>> cgnslib_f.h
echo         parameter (CG_NODE_NOT_FOUND = 2)>> cgnslib_f.h
echo         parameter (CG_INCORRECT_PATH = 3)>> cgnslib_f.h
echo         parameter (CG_NO_INDEX_DIM   = 4)>> cgnslib_f.h
echo !* legacy code support>> cgnslib_f.h
echo         integer%fbytes% ALL_OK, ERROR, NODE_NOT_FOUND, INCORRECT_PATH>> cgnslib_f.h
echo         parameter (ALL_OK         = 0)>> cgnslib_f.h
echo         parameter (ERROR          = 1)>> cgnslib_f.h
echo         parameter (NODE_NOT_FOUND = 2)>> cgnslib_f.h
echo         parameter (INCORRECT_PATH = 3)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Parallel CGNS parameters                                       *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo         integer%fbytes% CGP_INDEPENDENT, CGP_COLLECTIVE>> cgnslib_f.h
echo         parameter (CGP_INDEPENDENT = 0)>> cgnslib_f.h
echo         parameter (CGP_COLLECTIVE  = 1)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Dimensional Units                                              *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo         integer%fbytes% CG_UserDefined, CG_Null>> cgnslib_f.h
echo         parameter (CG_Null = 0)>> cgnslib_f.h
echo         parameter (CG_UserDefined = 1)>> cgnslib_f.h
echo !* legacy code support>> cgnslib_f.h
echo         integer%fbytes% Null, UserDefined>> cgnslib_f.h
echo         parameter (Null = 0)>> cgnslib_f.h
echo         parameter (UserDefined = 1)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         integer%fbytes% Kilogram, Gram, Slug, PoundMass>> cgnslib_f.h
echo         character*32 MassUnitsName(0:5)>> cgnslib_f.h
echo         parameter (Kilogram  = 2)>> cgnslib_f.h
echo         parameter (Gram      = 3)>> cgnslib_f.h
echo         parameter (Slug      = 4)>> cgnslib_f.h
echo         parameter (PoundMass = 5)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         integer%fbytes% Meter, Centimeter, Millimeter>> cgnslib_f.h
echo         integer%fbytes% Foot, Inch>> cgnslib_f.h
echo         character*32 LengthUnitsName(0:6)>> cgnslib_f.h
echo         parameter (Meter      = 2)>> cgnslib_f.h
echo         parameter (Centimeter = 3)>> cgnslib_f.h
echo         parameter (Millimeter = 4)>> cgnslib_f.h
echo         parameter (Foot       = 5)>> cgnslib_f.h
echo         parameter (Inch       = 6)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         integer%fbytes% Second>> cgnslib_f.h
echo         character*32 TimeUnitsName(0:2)>> cgnslib_f.h
echo         parameter (Second = 2)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         integer%fbytes% Kelvin, Celsius, Rankine, Fahrenheit>> cgnslib_f.h
echo         character*32 TemperatureUnitsName(0:5)>> cgnslib_f.h
echo         parameter (Kelvin     = 2)>> cgnslib_f.h
echo         parameter (Celsius    = 3)>> cgnslib_f.h
echo         parameter (Rankine    = 4)>> cgnslib_f.h
echo         parameter (Fahrenheit = 5)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         integer%fbytes% Degree, Radian>> cgnslib_f.h
echo         character*32 AngleUnitsName(0:3)>> cgnslib_f.h
echo         parameter (Degree = 2)>> cgnslib_f.h
echo         parameter (Radian = 3)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         integer%fbytes% Ampere, Abampere, Statampere, Edison, auCurrent>> cgnslib_f.h
echo         character*32 ElectricCurrentUnitsName(0:6)>> cgnslib_f.h
echo         parameter (Ampere     = 2)>> cgnslib_f.h
echo         parameter (Abampere   = 3)>> cgnslib_f.h
echo         parameter (Statampere = 4)>> cgnslib_f.h
echo         parameter (Edison     = 5)>> cgnslib_f.h
echo         parameter (auCurrent  = 6)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         integer%fbytes% Mole, Entities, StandardCubicFoot, StandardCubicMeter>> cgnslib_f.h
echo         character*32 SubstanceAmountUnitsName(0:5)>> cgnslib_f.h
echo         parameter (Mole               = 2)>> cgnslib_f.h
echo         parameter (Entities           = 3)>> cgnslib_f.h
echo         parameter (StandardCubicFoot  = 4)>> cgnslib_f.h
echo         parameter (StandardCubicMeter = 5)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         integer%fbytes% Candela, Candle, Carcel, Hefner, Violle>> cgnslib_f.h
echo         character*32 LuminousIntensityUnitsName(0:6)>> cgnslib_f.h
echo         parameter (Candela = 2)>> cgnslib_f.h
echo         parameter (Candle  = 3)>> cgnslib_f.h
echo         parameter (Carcel  = 4)>> cgnslib_f.h
echo         parameter (Hefner  = 5)>> cgnslib_f.h
echo         parameter (Violle  = 6)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Data Class                                                     *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo         integer%fbytes% Dimensional, NormalizedByDimensional>> cgnslib_f.h
echo         integer%fbytes% NormalizedByUnknownDimensional>> cgnslib_f.h
echo         integer%fbytes% NondimensionalParameter, DimensionlessConstant>> cgnslib_f.h
echo         character*32 DataClassName(0:6)>> cgnslib_f.h
echo         parameter (Dimensional                    = 2)>> cgnslib_f.h
echo         parameter (NormalizedByDimensional        = 3)>> cgnslib_f.h
echo         parameter (NormalizedByUnknownDimensional = 4)>> cgnslib_f.h
echo         parameter (NondimensionalParameter        = 5)>> cgnslib_f.h
echo         parameter (DimensionlessConstant          = 6)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Grid Location                                                  *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         integer%fbytes% Vertex, CellCenter, FaceCenter>> cgnslib_f.h
echo         integer%fbytes% IFaceCenter, JFaceCenter, KFaceCenter, EdgeCenter>> cgnslib_f.h
echo         character*32 GridLocationName(0:8)>> cgnslib_f.h
echo         parameter (Vertex      = 2)>> cgnslib_f.h
echo         parameter (CellCenter  = 3)>> cgnslib_f.h
echo         parameter (FaceCenter  = 4)>> cgnslib_f.h
echo         parameter (IFaceCenter = 5)>> cgnslib_f.h
echo         parameter (JFaceCenter = 6)>> cgnslib_f.h
echo         parameter (KFaceCenter = 7)>> cgnslib_f.h
echo         parameter (EdgeCenter  = 8)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Grid Connectivity Types                                        *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         integer%fbytes% Overset, Abutting, Abutting1to1>> cgnslib_f.h
echo         character*32 GridConnectivityTypeName(0:4)>> cgnslib_f.h
echo         parameter (Overset      = 2)>> cgnslib_f.h
echo         parameter (Abutting     = 3)>> cgnslib_f.h
echo         parameter (Abutting1to1 = 4)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Point Set Types                                                *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         integer%fbytes% PointList, PointListDonor>> cgnslib_f.h
echo         integer%fbytes% PointRange, PointRangeDonor>> cgnslib_f.h
echo         integer%fbytes% ElementRange, ElementList, CellListDonor>> cgnslib_f.h
echo         character*32 PointSetTypeName(0:8)>> cgnslib_f.h
echo         parameter (PointList       = 2)>> cgnslib_f.h
echo         parameter (PointListDonor  = 3)>> cgnslib_f.h
echo         parameter (PointRange      = 4)>> cgnslib_f.h
echo         parameter (PointRangeDonor = 5)>> cgnslib_f.h
echo         parameter (ElementRange    = 6)>> cgnslib_f.h
echo         parameter (ElementList     = 7)>> cgnslib_f.h
echo         parameter (CellListDonor   = 8)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Governing Equations and Physical Models Types                  *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         integer%fbytes% FullPotential, Euler>> cgnslib_f.h
echo         integer%fbytes% NSLaminar, NSTurbulent>> cgnslib_f.h
echo         integer%fbytes% NSLaminarIncompressible>> cgnslib_f.h
echo         integer%fbytes% NSTurbulentIncompressible>> cgnslib_f.h
echo         character*32 GoverningEquationsTypeName(0:7)>> cgnslib_f.h
echo         parameter (FullPotential             = 2)>> cgnslib_f.h
echo         parameter (Euler                     = 3)>> cgnslib_f.h
echo         parameter (NSLaminar                 = 4)>> cgnslib_f.h
echo         parameter (NSTurbulent               = 5)>> cgnslib_f.h
echo         parameter (NSLaminarIncompressible   = 6)>> cgnslib_f.h
echo         parameter (NSTurbulentIncompressible = 7)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !** Any model type will accept both ModelTypeNull and ModelTypeUserDefined.>> cgnslib_f.h
echo !** The following models will accept these values as vaild...>> cgnslib_f.h
echo !**>> cgnslib_f.h
echo !** GasModel_t: Ideal, VanderWaals, CaloricallyPerfect, ThermallyPerfect,>> cgnslib_f.h
echo !**    ConstantDensity, RedlichKwong>> cgnslib_f.h
echo !**>> cgnslib_f.h
echo !** ViscosityModel_t: Constant, PowerLaw, SutherlandLaw>> cgnslib_f.h
echo !**>> cgnslib_f.h
echo !** ThermalConductivityModel_t: PowerLaw, SutherlandLaw, ConstantPrandtl>> cgnslib_f.h
echo !**>> cgnslib_f.h
echo !** TurbulenceModel_t: Algebraic_BaldwinLomax, Algebraic_CebeciSmith,>> cgnslib_f.h
echo !**    HalfEquation_JohnsonKing, OneEquation_BaldwinBarth,>> cgnslib_f.h
echo !**    OneEquation_SpalartAllmaras, TwoEquation_JonesLaunder,>> cgnslib_f.h
echo !**    TwoEquation_MenterSST,TwoEquation_Wilcox>> cgnslib_f.h
echo !**>> cgnslib_f.h
echo !** TurbulenceClosure_t: EddyViscosity, ReynoldsStress,>> cgnslib_f.h
echo !**    ReynoldsStressAlgebraic>> cgnslib_f.h
echo !**>> cgnslib_f.h
echo !** ThermalRelaxationModel_t: Frozen, ThermalEquilib, ThermalNonequilib>> cgnslib_f.h
echo !**>> cgnslib_f.h
echo !** ChemicalKineticsModel_t: Frozen, ChemicalEquilibCurveFit,>> cgnslib_f.h
echo !**    ChemicalEquilibMinimization, ChemicalNonequilib>> cgnslib_f.h
echo !**>> cgnslib_f.h
echo !** EMElectricFieldModel_t: Voltage, Interpolated, Constant, Frozen>> cgnslib_f.h
echo !**>> cgnslib_f.h
echo !** EMMagneticFieldModel_t: Interpolated, Constant, Frozen>> cgnslib_f.h
echo !**>> cgnslib_f.h
echo !** EMConductivityModel_t: Constant, Frozen, Equilibrium_LinRessler,>> cgnslib_f.h
echo !**                        Chemistry_LinRessler>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         integer%fbytes% Ideal, VanderWaals>> cgnslib_f.h
echo         integer%fbytes% Constant>> cgnslib_f.h
echo         integer%fbytes% PowerLaw, SutherlandLaw>> cgnslib_f.h
echo         integer%fbytes% ConstantPrandtl>> cgnslib_f.h
echo         integer%fbytes% EddyViscosity, ReynoldsStress>> cgnslib_f.h
echo         integer%fbytes% ReynoldsStressAlgebraic>> cgnslib_f.h
echo         integer%fbytes% Algebraic_BaldwinLomax, Algebraic_CebeciSmith>> cgnslib_f.h
echo         integer%fbytes% HalfEquation_JohnsonKing, OneEquation_BaldwinBarth>> cgnslib_f.h
echo         integer%fbytes% OneEquation_SpalartAllmaras>> cgnslib_f.h
echo         integer%fbytes% TwoEquation_JonesLaunder>> cgnslib_f.h
echo         integer%fbytes% TwoEquation_MenterSST, TwoEquation_Wilcox>> cgnslib_f.h
echo         integer%fbytes% CaloricallyPerfect, ThermallyPerfect>> cgnslib_f.h
echo         integer%fbytes% ConstantDensity, RedlichKwong>> cgnslib_f.h
echo         integer%fbytes% Frozen, ThermalEquilib, ThermalNonequilib>> cgnslib_f.h
echo         integer%fbytes% ChemicalEquilibCurveFit>> cgnslib_f.h
echo         integer%fbytes% ChemicalEquilibMinimization>> cgnslib_f.h
echo         integer%fbytes% ChemicalNonequilib>> cgnslib_f.h
echo         integer%fbytes% EMElectricField, EMMagneticField, Voltage>> cgnslib_f.h
echo         integer%fbytes% Interpolated>> cgnslib_f.h
echo         integer%fbytes% EMConductivity, Equilibrium_LinRessler>> cgnslib_f.h
echo         integer%fbytes% Chemistry_LinRessler>> cgnslib_f.h
echo         character*32 ModelTypeName(0:35)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         parameter (Ideal                       = 2)>> cgnslib_f.h
echo         parameter (VanderWaals                 = 3)>> cgnslib_f.h
echo         parameter (Constant                    = 4)>> cgnslib_f.h
echo         parameter (PowerLaw                    = 5)>> cgnslib_f.h
echo         parameter (SutherlandLaw               = 6)>> cgnslib_f.h
echo         parameter (ConstantPrandtl             = 7)>> cgnslib_f.h
echo         parameter (EddyViscosity               = 8)>> cgnslib_f.h
echo         parameter (ReynoldsStress              = 9)>> cgnslib_f.h
echo         parameter (ReynoldsStressAlgebraic     = 10)>> cgnslib_f.h
echo         parameter (Algebraic_BaldwinLomax      = 11)>> cgnslib_f.h
echo         parameter (Algebraic_CebeciSmith       = 12)>> cgnslib_f.h
echo         parameter (HalfEquation_JohnsonKing    = 13)>> cgnslib_f.h
echo         parameter (OneEquation_BaldwinBarth    = 14)>> cgnslib_f.h
echo         parameter (OneEquation_SpalartAllmaras = 15)>> cgnslib_f.h
echo         parameter (TwoEquation_JonesLaunder    = 16)>> cgnslib_f.h
echo         parameter (TwoEquation_MenterSST       = 17)>> cgnslib_f.h
echo         parameter (TwoEquation_Wilcox          = 18)>> cgnslib_f.h
echo         parameter (CaloricallyPerfect          = 19)>> cgnslib_f.h
echo         parameter (ThermallyPerfect            = 20)>> cgnslib_f.h
echo         parameter (ConstantDensity             = 21)>> cgnslib_f.h
echo         parameter (RedlichKwong                = 22)>> cgnslib_f.h
echo         parameter (Frozen                      = 23)>> cgnslib_f.h
echo         parameter (ThermalEquilib              = 24)>> cgnslib_f.h
echo         parameter (ThermalNonequilib           = 25)>> cgnslib_f.h
echo         parameter (ChemicalEquilibCurveFit     = 26)>> cgnslib_f.h
echo         parameter (ChemicalEquilibMinimization = 27)>> cgnslib_f.h
echo         parameter (ChemicalNonequilib          = 28)>> cgnslib_f.h
echo         parameter (EMElectricField             = 29)>> cgnslib_f.h
echo         parameter (EMMagneticField             = 30)>> cgnslib_f.h
echo         parameter (EMConductivity              = 31)>> cgnslib_f.h
echo         parameter (Voltage                     = 32)>> cgnslib_f.h
echo         parameter (Interpolated                = 33)>> cgnslib_f.h
echo         parameter (Equilibrium_LinRessler      = 34)>> cgnslib_f.h
echo         parameter (Chemistry_LinRessler        = 35)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Boundary Condition Types                                       *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         integer%fbytes% BCAxisymmetricWedge, BCDegenerateLine>> cgnslib_f.h
echo         integer%fbytes% BCDegeneratePoint>> cgnslib_f.h
echo         integer%fbytes% BCDirichlet, BCExtrapolate, BCFarfield, BCGeneral>> cgnslib_f.h
echo         integer%fbytes% BCInflow, BCInflowSubsonic,  BCInflowSupersonic>> cgnslib_f.h
echo         integer%fbytes% BCNeumann>> cgnslib_f.h
echo         integer%fbytes% BCOutflow, BCOutflowSubsonic, BCOutflowSupersonic>> cgnslib_f.h
echo         integer%fbytes% BCSymmetryPlane, BCSymmetryPolar>> cgnslib_f.h
echo         integer%fbytes% BCTunnelInflow, BCTunnelOutflow>> cgnslib_f.h
echo         integer%fbytes% BCWall, BCWallInviscid, BCWallViscous>> cgnslib_f.h
echo         integer%fbytes% BCWallViscousHeatFlux, BCWallViscousIsothermal>> cgnslib_f.h
echo         integer%fbytes% FamilySpecified>> cgnslib_f.h
echo         character*32 BCTypeName(0:25)>> cgnslib_f.h
echo         parameter (BCAxisymmetricWedge     = 2)>> cgnslib_f.h
echo         parameter (BCDegenerateLine        = 3)>> cgnslib_f.h
echo         parameter (BCDegeneratePoint       = 4)>> cgnslib_f.h
echo         parameter (BCDirichlet             = 5)>> cgnslib_f.h
echo         parameter (BCExtrapolate           = 6)>> cgnslib_f.h
echo         parameter (BCFarfield              = 7)>> cgnslib_f.h
echo         parameter (BCGeneral               = 8)>> cgnslib_f.h
echo         parameter (BCInflow                = 9)>> cgnslib_f.h
echo         parameter (BCInflowSubsonic        = 10)>> cgnslib_f.h
echo         parameter (BCInflowSupersonic      = 11)>> cgnslib_f.h
echo         parameter (BCNeumann               = 12)>> cgnslib_f.h
echo         parameter (BCOutflow               = 13)>> cgnslib_f.h
echo         parameter (BCOutflowSubsonic       = 14)>> cgnslib_f.h
echo         parameter (BCOutflowSupersonic     = 15)>> cgnslib_f.h
echo         parameter (BCSymmetryPlane         = 16)>> cgnslib_f.h
echo         parameter (BCSymmetryPolar         = 17)>> cgnslib_f.h
echo         parameter (BCTunnelInflow          = 18)>> cgnslib_f.h
echo         parameter (BCTunnelOutflow         = 19)>> cgnslib_f.h
echo         parameter (BCWall                  = 20)>> cgnslib_f.h
echo         parameter (BCWallInviscid          = 21)>> cgnslib_f.h
echo         parameter (BCWallViscous           = 22)>> cgnslib_f.h
echo         parameter (BCWallViscousHeatFlux   = 23)>> cgnslib_f.h
echo         parameter (BCWallViscousIsothermal = 24)>> cgnslib_f.h
echo         parameter (FamilySpecified         = 25)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Data types                                                     *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         integer%fbytes% Integer, RealSingle, RealDouble, Character>> cgnslib_f.h
echo         integer%fbytes% LongInteger>> cgnslib_f.h
echo         character*32 DataTypeName(0:6)>> cgnslib_f.h
echo         parameter (Integer     = 2)>> cgnslib_f.h
echo         parameter (RealSingle  = 3)>> cgnslib_f.h
echo         parameter (RealDouble  = 4)>> cgnslib_f.h
echo         parameter (Character   = 5)>> cgnslib_f.h
echo         parameter (LongInteger = 6)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      BCData_t types                                                 *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         integer%fbytes% Dirichlet, Neumann>> cgnslib_f.h
echo         character*32 BCDataTypeName(0:3)>> cgnslib_f.h
echo         parameter (Dirichlet = 2)>> cgnslib_f.h
echo         parameter (Neumann   = 3)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Element types                                                  *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         integer%fbytes% NODE, BAR_2, BAR_3, TRI_3, TRI_6>> cgnslib_f.h
echo         integer%fbytes% QUAD_4, QUAD_8, QUAD_9>> cgnslib_f.h
echo         integer%fbytes% TETRA_4, TETRA_10, PYRA_5, PYRA_14>> cgnslib_f.h
echo         integer%fbytes% PENTA_6, PENTA_15, PENTA_18>> cgnslib_f.h
echo         integer%fbytes% HEXA_8, HEXA_20, HEXA_27>> cgnslib_f.h
echo         integer%fbytes% MIXED, PYRA_13, NGON_n, NFACE_n>> cgnslib_f.h
echo         integer%fbytes% BAR_4, TRI_9, TRI_10>> cgnslib_f.h
echo         integer%fbytes% QUAD_12, QUAD_16>> cgnslib_f.h
echo         integer%fbytes% TETRA_16, TETRA_20>> cgnslib_f.h
echo         integer%fbytes% PYRA_21, PYRA_29, PYRA_30>> cgnslib_f.h
echo         integer%fbytes% PENTA_24, PENTA_38, PENTA_40>> cgnslib_f.h
echo         integer%fbytes% HEXA_32, HEXA_56, HEXA_64>> cgnslib_f.h
echo         integer%fbytes% BAR_5, TRI_12, TRI_15>> cgnslib_f.h
echo         integer%fbytes% QUAD_P4_16, QUAD_25>> cgnslib_f.h
echo         integer%fbytes% TETRA_22, TETRA_34, TETRA_35>> cgnslib_f.h
echo         integer%fbytes% PYRA_P4_29, PYRA_50, PYRA_55>> cgnslib_f.h
echo         integer%fbytes% PENTA_33, PENTA_66, PENTA_75>> cgnslib_f.h
echo         integer%fbytes% HEXA_44, HEXA_98, HEXA_125>> cgnslib_f.h
echo         character*32 ElementTypeName(0:56)>> cgnslib_f.h
echo         parameter (NODE       =  2)>> cgnslib_f.h
echo         parameter (BAR_2      =  3)>> cgnslib_f.h
echo         parameter (BAR_3      =  4)>> cgnslib_f.h
echo         parameter (TRI_3      =  5)>> cgnslib_f.h
echo         parameter (TRI_6      =  6)>> cgnslib_f.h
echo         parameter (QUAD_4     =  7)>> cgnslib_f.h
echo         parameter (QUAD_8     =  8)>> cgnslib_f.h
echo         parameter (QUAD_9     =  9)>> cgnslib_f.h
echo         parameter (TETRA_4    = 10)>> cgnslib_f.h
echo         parameter (TETRA_10   = 11)>> cgnslib_f.h
echo         parameter (PYRA_5     = 12)>> cgnslib_f.h
echo         parameter (PYRA_14    = 13)>> cgnslib_f.h
echo         parameter (PENTA_6    = 14)>> cgnslib_f.h
echo         parameter (PENTA_15   = 15)>> cgnslib_f.h
echo         parameter (PENTA_18   = 16)>> cgnslib_f.h
echo         parameter (HEXA_8     = 17)>> cgnslib_f.h
echo         parameter (HEXA_20    = 18)>> cgnslib_f.h
echo         parameter (HEXA_27    = 19)>> cgnslib_f.h
echo         parameter (MIXED      = 20)>> cgnslib_f.h
echo         parameter (PYRA_13    = 21)>> cgnslib_f.h
echo         parameter (NGON_n     = 22)>> cgnslib_f.h
echo         parameter (NFACE_n    = 23)>> cgnslib_f.h
echo         parameter (BAR_4      = 24)>> cgnslib_f.h
echo         parameter (TRI_9      = 25)>> cgnslib_f.h
echo         parameter (TRI_10     = 26)>> cgnslib_f.h
echo         parameter (QUAD_12    = 27)>> cgnslib_f.h
echo         parameter (QUAD_16    = 28)>> cgnslib_f.h
echo         parameter (TETRA_16   = 29)>> cgnslib_f.h
echo         parameter (TETRA_20   = 30)>> cgnslib_f.h
echo         parameter (PYRA_21    = 31)>> cgnslib_f.h
echo         parameter (PYRA_29    = 32)>> cgnslib_f.h
echo         parameter (PYRA_30    = 33)>> cgnslib_f.h
echo         parameter (PENTA_24   = 34)>> cgnslib_f.h
echo         parameter (PENTA_38   = 35)>> cgnslib_f.h
echo         parameter (PENTA_40   = 36)>> cgnslib_f.h
echo         parameter (HEXA_32    = 37)>> cgnslib_f.h
echo         parameter (HEXA_56    = 38)>> cgnslib_f.h
echo         parameter (HEXA_64    = 39)>> cgnslib_f.h
echo         parameter (BAR_5      = 40)>> cgnslib_f.h
echo         parameter (TRI_12     = 41)>> cgnslib_f.h
echo         parameter (TRI_15     = 42)>> cgnslib_f.h
echo         parameter (QUAD_P4_16 = 43)>> cgnslib_f.h
echo         parameter (QUAD_25    = 44)>> cgnslib_f.h
echo         parameter (TETRA_22   = 45)>> cgnslib_f.h
echo         parameter (TETRA_34   = 46)>> cgnslib_f.h
echo         parameter (TETRA_35   = 47)>> cgnslib_f.h
echo         parameter (PYRA_P4_29 = 48)>> cgnslib_f.h
echo         parameter (PYRA_50    = 49)>> cgnslib_f.h
echo         parameter (PYRA_55    = 50)>> cgnslib_f.h
echo         parameter (PENTA_33   = 51)>> cgnslib_f.h
echo         parameter (PENTA_66   = 52)>> cgnslib_f.h
echo         parameter (PENTA_75   = 53)>> cgnslib_f.h
echo         parameter (HEXA_44    = 54)>> cgnslib_f.h
echo         parameter (HEXA_98    = 55)>> cgnslib_f.h
echo         parameter (HEXA_125   = 56)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Zone types                                                     *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         integer%fbytes% Structured, Unstructured>> cgnslib_f.h
echo         character*32 ZoneTypeName(0:3)>> cgnslib_f.h
echo         parameter (Structured   =  2)>> cgnslib_f.h
echo         parameter (Unstructured =  3)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Rigid Grid Motion types                                        *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         integer%fbytes% ConstantRate, VariableRate>> cgnslib_f.h
echo         character*32 RigidGridMotionTypeName(0:3)>> cgnslib_f.h
echo         parameter (ConstantRate = 2)>> cgnslib_f.h
echo         parameter (VariableRate = 3)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Arbitrary Grid Motion types                                    *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         integer%fbytes% NonDeformingGrid, DeformingGrid>> cgnslib_f.h
echo         character*32 ArbitraryGridMotionTypeName(0:3)>> cgnslib_f.h
echo         parameter (NonDeformingGrid = 2)>> cgnslib_f.h
echo         parameter (DeformingGrid = 3)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Simulation type                                                *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         integer%fbytes% TimeAccurate, NonTimeAccurate>> cgnslib_f.h
echo         character*32 SimulationTypeName(0:3)>> cgnslib_f.h
echo         parameter (TimeAccurate = 2)>> cgnslib_f.h
echo         parameter (NonTimeAccurate = 3)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      BC Property types                                              *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         integer%fbytes% Generic>> cgnslib_f.h
echo         character*32 WallFunctionTypeName(0:2)>> cgnslib_f.h
echo         parameter (Generic = 2)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         integer%fbytes% BleedArea, CaptureArea>> cgnslib_f.h
echo         character*32 AreaTypeName(0:3)>> cgnslib_f.h
echo         parameter (BleedArea = 2)>> cgnslib_f.h
echo         parameter (CaptureArea = 3)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Grid Connectivity Property types                               *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         integer%fbytes% AverageAll, AverageCircumferential, AverageRadial>> cgnslib_f.h
echo         integer%fbytes% AverageI, AverageJ, AverageK>> cgnslib_f.h
echo         character*32 AverageInterfaceTypeName(0:7)>> cgnslib_f.h
echo         parameter (AverageAll = 2)>> cgnslib_f.h
echo         parameter (AverageCircumferential = 3)>> cgnslib_f.h
echo         parameter (AverageRadial = 4)>> cgnslib_f.h
echo         parameter (AverageI = 5)>> cgnslib_f.h
echo         parameter (AverageJ = 6)>> cgnslib_f.h
echo         parameter (AverageK = 7)>> cgnslib_f.h
echo.>> cgnslib_f.h
echo ! For portability to Linux Absoft, all data statements were moved after the>> cgnslib_f.h
echo ! variables and parametres declarations>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Dimensional Units                                              *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo         data MassUnitsName /'Null','UserDefined','Kilogram','Gram',     ^&>> cgnslib_f.h
echo      ^&                      'Slug','PoundMass'/>> cgnslib_f.h
echo         data LengthUnitsName / 'Null', 'UserDefined',                   ^&>> cgnslib_f.h
echo      ^&         'Meter','Centimeter','Millimeter','Foot','Inch'/>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         data TimeUnitsName /'Null','UserDefined','Second'/>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         data TemperatureUnitsName /'Null','UserDefined',                ^&>> cgnslib_f.h
echo      ^&         'Kelvin','Celsius','Rankine','Fahrenheit'/>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         data AngleUnitsName /'Null','UserDefined','Degree','Radian'/>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         data ElectricCurrentUnitsName /'Null', 'UserDefined', 'Ampere', ^&>> cgnslib_f.h
echo      ^&         'Abampere', 'Statampere', 'Edison', 'a.u.'/>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         data SubstanceAmountUnitsName /'Null', 'UserDefined', 'Mole',   ^&>> cgnslib_f.h
echo      ^&         'Entities', 'StandardCubicFoot', 'StandardCubicMeter'/>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         data LuminousIntensityUnitsName /'Null', 'UserDefined',         ^&>> cgnslib_f.h
echo      ^&         'Candela', 'Candle', 'Carcel', 'Hefner', 'Violle'/>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Data Class                                                     *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo         data DataClassName / 'Null','UserDefined',                      ^&>> cgnslib_f.h
echo      ^&          'Dimensional','NormalizedByDimensional',                ^&>> cgnslib_f.h
echo      ^&          'NormalizedByUnknownDimensional',                       ^&>> cgnslib_f.h
echo      ^&          'NondimensionalParameter','DimensionlessConstant'/>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Grid Location                                                  *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         data GridLocationName / 'Null','UserDefined',                   ^&>> cgnslib_f.h
echo      ^&          'Vertex','CellCenter','FaceCenter','IFaceCenter',       ^&>> cgnslib_f.h
echo      ^&          'JFaceCenter','KFaceCenter','EdgeCenter' />> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Grid Connectivity Types                                        *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         data GridConnectivityTypeName / 'Null','UserDefined',           ^&>> cgnslib_f.h
echo      ^&          'Overset','Abutting','Abutting1to1'/>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Point Set Types                                                *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         data PointSetTypeName / 'Null','UserDefined',                   ^&>> cgnslib_f.h
echo      ^&          'PointList','PointListDonor',                           ^&>> cgnslib_f.h
echo      ^&          'PointRange','PointRangeDonor',                         ^&>> cgnslib_f.h
echo      ^&          'ElementRange','ElementList','CellListDonor'/>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Governing Equations and Physical Models Types                  *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         data GoverningEquationsTypeName / 'Null','UserDefined',         ^&>> cgnslib_f.h
echo      ^&          'FullPotential','Euler', 'NSLaminar', 'NSTurbulent',    ^&>> cgnslib_f.h
echo      ^&          'NSLaminarIncompressible', 'NSTurbulentIncompressible'/>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         data ModelTypeName / 'Null','UserDefined',                      ^&>> cgnslib_f.h
echo      ^&        'Ideal','VanderWaals', 'Constant','PowerLaw',             ^&>> cgnslib_f.h
echo      ^&        'SutherlandLaw','ConstantPrandtl','EddyViscosity',        ^&>> cgnslib_f.h
echo      ^&        'ReynoldsStress','ReynoldsStressAlgebraic',               ^&>> cgnslib_f.h
echo      ^&        'Algebraic_BaldwinLomax','Algebraic_CebeciSmith',         ^&>> cgnslib_f.h
echo      ^&        'HalfEquation_JohnsonKing','OneEquation_BaldwinBarth',    ^&>> cgnslib_f.h
echo      ^&        'OneEquation_SpalartAllmaras','TwoEquation_JonesLaunder', ^&>> cgnslib_f.h
echo      ^&        'TwoEquation_MenterSST','TwoEquation_Wilcox',             ^&>> cgnslib_f.h
echo      ^&        'CaloricallyPerfect', 'ThermallyPerfect',                 ^&>> cgnslib_f.h
echo      ^&        'ConstantDensity', 'RedlichKwong', 'Frozen',              ^&>> cgnslib_f.h
echo      ^&        'ThermalEquilib', 'ThermalNonequilib',                    ^&>> cgnslib_f.h
echo      ^&        'ChemicalEquilibCurveFit', 'ChemicalEquilibMinimization', ^&>> cgnslib_f.h
echo      ^&        'ChemicalNonequilib', 'EMElectricField',                  ^&>> cgnslib_f.h
echo      ^&        'EMMagneticField', 'EMConductivity', 'Voltage',           ^&>> cgnslib_f.h
echo      ^&        'Interpolated', 'Equilibrium_LinRessler',                 ^&>> cgnslib_f.h
echo      ^&        'Chemistry_LinRessler'/>> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Boundary Condition Types                                       *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         data BCTypeName / 'Null','UserDefined',                         ^&>> cgnslib_f.h
echo      ^&          'BCAxisymmetricWedge','BCDegenerateLine',               ^&>> cgnslib_f.h
echo      ^&          'BCDegeneratePoint','BCDirichlet','BCExtrapolate',      ^&>> cgnslib_f.h
echo      ^&          'BCFarfield','BCGeneral','BCInflow','BCInflowSubsonic', ^&>> cgnslib_f.h
echo      ^&          'BCInflowSupersonic','BCNeumann','BCOutflow',           ^&>> cgnslib_f.h
echo      ^&          'BCOutflowSubsonic','BCOutflowSupersonic',              ^&>> cgnslib_f.h
echo      ^&          'BCSymmetryPlane','BCSymmetryPolar','BCTunnelInflow',   ^&>> cgnslib_f.h
echo      ^&          'BCTunnelOutflow','BCWall','BCWallInviscid',            ^&>> cgnslib_f.h
echo      ^&          'BCWallViscous','BCWallViscousHeatFlux',                ^&>> cgnslib_f.h
echo      ^&          'BCWallViscousIsothermal','FamilySpecified' />> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Data types                                                     *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         data DataTypeName / 'Null','UserDefined',                       ^&>> cgnslib_f.h
echo      ^&          'Integer','RealSingle','RealDouble','Character',        ^&>> cgnslib_f.h
echo      ^&          'LongInteger' />> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      BCData_t types                                                 *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         data BCDataTypeName / 'Null','UserDefined',                     ^&>> cgnslib_f.h
echo      ^&          'Dirichlet', 'Neumann' />> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Element types                                                  *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         data ElementTypeName / 'Null','UserDefined',                    ^&>> cgnslib_f.h
echo      ^&      'NODE', 'BAR_2', 'BAR_3', 'TRI_3', 'TRI_6',                 ^&>> cgnslib_f.h
echo      ^&      'QUAD_4', 'QUAD_8', 'QUAD_9', 'TETRA_4', 'TETRA_10',        ^&>> cgnslib_f.h
echo      ^&      'PYRA_5', 'PYRA_14', 'PENTA_6', 'PENTA_15',                 ^&>> cgnslib_f.h
echo      ^&      'PENTA_18', 'HEXA_8', 'HEXA_20', 'HEXA_27', 'MIXED',        ^&>> cgnslib_f.h
echo      ^&      'PYRA_13', 'NGON_n', 'NFACE_n',                             ^&>> cgnslib_f.h
echo      ^&      'BAR_4', 'TRI_9', 'TRI_10',                                 ^&>> cgnslib_f.h
echo      ^&      'QUAD_12', 'QUAD_16',                                       ^&>> cgnslib_f.h
echo      ^&      'TETRA_16', 'TETRA_20',                                     ^&>> cgnslib_f.h
echo      ^&      'PYRA_21', 'PYRA_29', 'PYRA_30',                            ^&>> cgnslib_f.h
echo      ^&      'PENTA_24', 'PENTA_38', 'PENTA_40',                         ^&>> cgnslib_f.h
echo      ^&      'HEXA_32', 'HEXA_56', 'HEXA_64',                            ^&>> cgnslib_f.h
echo      ^&      'BAR_5', 'TRI_12'. 'TRI_15',                                ^&>> cgnslib_f.h
echo      ^&      'QUAD_P4_16', 'QUAD_25',                                    ^&>> cgnslib_f.h
echo      ^&      'TETRA_22', 'TETRA_34', 'TETRA_35',                         ^&>> cgnslib_f.h
echo      ^&      'PYRA_P4_29', 'PYRA_50', 'PYRA_55',                         ^&>> cgnslib_f.h
echo      ^&      'PENTA_33', 'PENTA_66', 'PENTA_75',                         ^&>> cgnslib_f.h
echo      ^&      'HEXA_44', 'HEXA_98', 'HEXA_125' />> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Zone types                                                     *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         data ZoneTypeName / 'Null','UserDefined',                       ^&>> cgnslib_f.h
echo      ^&      'Structured', 'Unstructured' />> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Rigid Grid Motion types                                        *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         data RigidGridMotionTypeName / 'Null','UserDefined',            ^&>> cgnslib_f.h
echo      ^&       'ConstantRate', 'VariableRate' />> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Arbitrary Grid Motion types                                    *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         data ArbitraryGridMotionTypeName / 'Null','UserDefined',        ^&>> cgnslib_f.h
echo      ^&       'NonDeformingGrid', 'DeformingGrid' />> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Simulation type                                                *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         data SimulationTypeName / 'Null','UserDefined',                 ^&>> cgnslib_f.h
echo      ^&       'TimeAccurate', 'NonTimeAccurate' />> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      BC Property types                                              *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         data WallFunctionTypeName / 'Null','UserDefined',               ^&>> cgnslib_f.h
echo      ^&       'Generic' />> cgnslib_f.h
echo.>> cgnslib_f.h
echo         data AreaTypeName / 'Null','UserDefined',                       ^&>> cgnslib_f.h
echo      ^&       'BleedArea', 'CaptureArea' />> cgnslib_f.h
echo.>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo !*      Grid Connectivity Property types                               *>> cgnslib_f.h
echo !* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *>> cgnslib_f.h
echo.>> cgnslib_f.h
echo         data AverageInterfaceTypeName / 'Null','UserDefined',           ^&>> cgnslib_f.h
echo      ^&       'AverageAll', 'AverageCircumferential', 'AverageRadial',   ^&>> cgnslib_f.h
echo      ^&       'AverageI', 'AverageJ', 'AverageK' />> cgnslib_f.h

rem ----- create cgnsconfig.h

set dodebug=0
if not "%debug%" == "" set dodebug=1
set dofortran=0
if not "%f2c%" == "none" set dofortran=1
set doparallel=0
if not "%parallel%" == "" set doparallel=1
set buildhdf5=0
if not "%hdf5lib%" == "" set buildhdf5=1
set needmpi=0
if not "%hdf5lib%" == "" set needmpi=1
set needszip=0
if not "%sziplib%" == "" set needszip=1
set needzlib=0
if not "%zliblib%" == "" set needzlib=1

echo creating cgnsconfig.h
echo /* ------------------------------------------------------------------------- *> cgnsconfig.h
echo  * CGNS - CFD General Notation System (http://www.cgns.org)                  *>> cgnsconfig.h
echo  * CGNS/MLL - Mid-Level Library header file                                  *>> cgnsconfig.h
echo  * ------------------------------------------------------------------------- */>> cgnsconfig.h
echo.>> cgnsconfig.h
echo /* ------------------------------------------------------------------------- *>> cgnsconfig.h
echo.>> cgnsconfig.h
echo   This software is provided 'as-is', without any express or implied warranty.>> cgnsconfig.h
echo   In no event will the authors be held liable for any damages arising from>> cgnsconfig.h
echo   the use of this software.>> cgnsconfig.h
echo.>> cgnsconfig.h
echo   Permission is granted to anyone to use this software for any purpose,>> cgnsconfig.h
echo   including commercial applications, and to alter it and redistribute it>> cgnsconfig.h
echo   freely, subject to the following restrictions:>> cgnsconfig.h
echo.>> cgnsconfig.h
echo   1. The origin of this software must not be misrepresented; you must not>> cgnsconfig.h
echo      claim that you wrote the original software. If you use this software>> cgnsconfig.h
echo      in a product, an acknowledgment in the product documentation would be>> cgnsconfig.h
echo      appreciated but is not required.>> cgnsconfig.h
echo.>> cgnsconfig.h
echo   2. Altered source versions must be plainly marked as such, and must not>> cgnsconfig.h
echo      be misrepresented as being the original software.>> cgnsconfig.h
echo.>> cgnsconfig.h
echo   3. This notice may not be removed or altered from any source distribution.>> cgnsconfig.h
echo.>> cgnsconfig.h
echo  * ------------------------------------------------------------------------- */>> cgnsconfig.h
echo.>> cgnsconfig.h
echo /* ------------------------------------------------------------------------- *>> cgnsconfig.h
echo    This file has been generated during the CGNS/MLL installation.>> cgnsconfig.h
echo    This is a snapshot of the parameters used for CGNS/MLL production and>> cgnsconfig.h
echo    some PATHS parameters (headers or shared libs) may change or>> cgnsconfig.h
echo    disappear (for example in case of cross-compilation).>> cgnsconfig.h
echo  * ------------------------------------------------------------------------- */>> cgnsconfig.h
echo.>> cgnsconfig.h
echo #ifndef CGNSCONFIG_H>> cgnsconfig.h
echo #define CGNSCONFIG_H>> cgnsconfig.h
echo.>> cgnsconfig.h
echo #include "cgnstypes.h">> cgnsconfig.h
echo.>> cgnsconfig.h
echo #define CG_BUILD_HDF5     %buildhdf5% >> cgnsconfig.h
echo #define CG_BUILD_DEBUG    %dodebug% >> cgnsconfig.h
echo #define CG_BUILD_FORTRAN  %dofortran% >> cgnsconfig.h
echo #define CG_BUILD_PARALLEL %doparallel% >> cgnsconfig.h
echo.>> cgnsconfig.h
echo #define HDF5_INCLUDE_PATH "%hdf5inc%">> cgnsconfig.h
echo #define HDF5_LIBRARY      "%hdf5lib%">> cgnsconfig.h
echo.>> cgnsconfig.h
echo #define HDF5_NEED_MPI     %needmpi% >> cgnsconfig.h
echo #define HDF5_NEED_SZIP    %needszip% >> cgnsconfig.h
echo #define HDF5_NEED_ZLIB    %needzlib% >> cgnsconfig.h
echo.>> cgnsconfig.h
echo #define MPI_INCLUDE_PATH  "%mpiinc%">> cgnsconfig.h
echo #define MPI_LIBRARY       "%mpilibs%">> cgnsconfig.h
echo #define SZIP_LIBRARY      "%sziplib%">> cgnsconfig.h
echo #define ZLIB_LIBRARY      "%zliblib%">> cgnsconfig.h
echo.>> cgnsconfig.h
echo #endif>> cgnsconfig.h

rem ----- create make.defs

echo creating make.defs
echo # makefile include for %windir%> make.defs
echo.>> make.defs
echo #------------------------------------------------------------------------>> make.defs
echo # CC      - C compiler>> make.defs
echo # CFLAGS  - compiler flags>> make.defs
echo # COOUT   - flag to name object output file (typically /Fo)>> make.defs
echo # CEOUT   - flag to name the output executable (typically /Fe)>> make.defs
echo # LDFLAGS - any additional linker options>> make.defs
echo # CLIBS   - any additional libraries needed to link a CGNS application>> make.defs
echo #------------------------------------------------------------------------>> make.defs
echo.>> make.defs
echo CC      = cl>> make.defs
echo CFLAGS  = /nologo %copts% /D_CRT_SECURE_NO_WARNINGS>> make.defs
echo COOUT   = /Fo>> make.defs
echo CEOUT   = /Fe>> make.defs
echo LDFLAGS = /nologo %lopts%>> make.defs
echo CLIBS   =>> make.defs
echo.>> make.defs
echo #------------------------------------------------------------------------>> make.defs
echo # SPACE  - used to force a space in the compiler executable output flag>> make.defs
echo # O       - object file extension>> make.defs
echo # A       - library file extension>> make.defs
echo # EXE     - executable extension>> make.defs
echo # LIBCGNS - CGNS library name>> make.defs
echo #------------------------------------------------------------------------>> make.defs
echo.>> make.defs
echo SPACE   =>> make.defs
echo O       = obj>> make.defs
echo A       = lib>> make.defs
echo EXE     = .exe>> make.defs
echo.>> make.defs
echo LIBCGNS = %builddir%\cgns.lib>> make.defs
echo.>> make.defs
echo #------------------------------------------------------------------------>> make.defs
echo # F2CFLAGS defines the type of Fortran to C interface.>> make.defs
echo #>> make.defs
echo # CFGFLAGS defines any additional compiler options needed to build>> make.defs
echo # the CGNS library. This is typically set by the configure script.>> make.defs
echo #------------------------------------------------------------------------>> make.defs
echo.>> make.defs
echo F2CFLAGS = %f2cflags%>> make.defs
echo CFGFLAGS = %cfgflags%>> make.defs
echo.>> make.defs
echo #------------------------------------------------------------------------>> make.defs
echo # These are not used to build the CGNS library>> make.defs
echo # Fortran compiler (F77) and options (FFLAGS).>> make.defs
echo # FEOUT is the flag to name the output executable (typically /exe:).>> make.defs
echo # FLIBS lists any additional libraries needed to link a CGNS application>> make.defs
echo #------------------------------------------------------------------------>> make.defs
echo.>> make.defs
echo F77    = %f77%>> make.defs
if %f77% == ifort (
echo FFLAGS = /nologo /extfpp:F /fpp %copts%>> make.defs
) else (
echo FFLAGS = /nologo /extfpp:F /fpp:"/DWINNT" %copts%>> make.defs
)
echo FEOUT  = /exe:>> make.defs
echo FLIBS  =>> make.defs
echo.>> make.defs
echo #------------------------------------------------------------------------>> make.defs
echo # strip command for executables - set to true if not used>> make.defs
echo #------------------------------------------------------------------------>> make.defs
echo.>> make.defs
echo STRIP  = :>> make.defs
echo.>> make.defs
echo #------------------------------------------------------------------------>> make.defs
echo # library archiver and ranlib>> make.defs
echo # AROUT may be used to set a library output flag as:>> make.defs
echo #    $(AR) $(AROUT)library_name objects>> make.defs
echo # Set RANLIB to true if not used>> make.defs
echo #------------------------------------------------------------------------>> make.defs
echo.>> make.defs
echo AR     = link>> make.defs
echo AROUT  = /out:>> make.defs
echo RANLIB = :>> make.defs
echo.>> make.defs
echo #------------------------------------------------------------------------>> make.defs
echo # these should only be set if building HDF5 interface>> make.defs
echo # HDF5INC - path to HDF5 header files>> make.defs
echo # HDF5LIB - HDF5 library>> make.defs
echo # SZIPLIB - szip library (if needed)>> make.defs
echo # ZLIBLIB - zlib library (if needed)>> make.defs
echo #------------------------------------------------------------------------>> make.defs
echo.>> make.defs
echo HDF5INC = %hdf5def%>> make.defs
echo HDF5LIB = %hdf5lib%>> make.defs
echo SZIPLIB = %sziplib%>> make.defs
echo ZLIBLIB = %zliblib%>> make.defs
echo.>> make.defs
echo #------------------------------------------------------------------------>> make.defs
echo # these should only be set if building with HDF5 and MPI>> make.defs
echo # MPIINC  - path to MPI header files>> make.defs
echo # MPILIBS - MPI libraries>> make.defs
echo # MPIEXEC - MPI executor>> make.defs
echo #------------------------------------------------------------------------>> make.defs
echo.>> make.defs
echo MPIINC  = %mpidef%>> make.defs
echo MPILIBS = %mpilibs%>> make.defs
echo MPIEXEC = %mpiexec%>> make.defs
echo.>> make.defs
echo #------------------------------------------------------------------------>> make.defs
echo # BUILDLIBS contains the list of additional libraries>> make.defs
echo #           with which a CGNS application needs to link>> make.defs
echo #------------------------------------------------------------------------>> make.defs
echo.>> make.defs
echo BUILDLIBS = $(HDF5LIB) $(SZIPLIB) $(ZLIBLIB) $(MPILIBS)>> make.defs
echo.>> make.defs
echo #------------------------------------------------------------------------>> make.defs
echo # commands for removing files and creating/deleting directory>> make.defs
echo #------------------------------------------------------------------------>> make.defs
echo.>> make.defs
echo RM     = del /q>> make.defs
echo RMDIR  = rd /s/q>> make.defs
echo MKDIR  = md>> make.defs
echo.>> make.defs
echo #------------------------------------------------------------------------>> make.defs
echo # installation library name and directories>> make.defs
echo #>> make.defs
echo # INSTALL      - install command>> make.defs
echo # INSTALL_PROG - install executable>> make.defs
echo # INSTALL_DATA - install data>> make.defs
echo # LIBDIR       - installation directory for CGNS library>> make.defs
echo # INCLUDEDIR   - installation directory for CGNS headers>> make.defs
echo # BINDIR       - installation directory for CGNS executables>> make.defs
echo #------------------------------------------------------------------------>> make.defs
echo.>> make.defs
echo INSTALL      = copy /b>> make.defs
echo INSTALL_PROG = $(INSTALL)>> make.defs
echo INSTALL_DATA = $(INSTALL)>> make.defs
echo INSTALLDIR   = %instdir%>> make.defs
echo LIBDIR       = $(INSTALLDIR)\lib>> make.defs
echo INCLUDEDIR   = $(INSTALLDIR)\include>> make.defs
echo BINDIR       = $(INSTALLDIR)\bin>> make.defs

rem ----- create cgnsBuild.defs

set dodebug=0
if not "%debug%" == "" set dodebug=1
set dofortran=0
if not "%f2c%" == "none" set dofortran=1
set doparallel=0
if not "%parallel%" == "" set doparallel=1

echo creating cgnsBuild.defs
echo # makefile include for building CGNS code under %windir%> cgnsBuild.defs
echo # this file contains the options and libraries used for>> cgnsBuild.defs
echo # building and linking CGNS code, and is intended to be>> cgnsBuild.defs
echo # included in a user's Makefile from the installation>> cgnsBuild.defs
echo.>> cgnsBuild.defs
echo #----------------------------------------------------------------------->> cgnsBuild.defs
echo # CGNS library build options. A 1 indicates that the library>> cgnsBuild.defs
echo # was built with that option, a 0 indicates without>> cgnsBuild.defs
echo # CGNS_DEBUG    = debug>> cgnsBuild.defs
echo # CGNS_LEGACY   = legacy code (prior to 3.0)>> cgnsBuild.defs
echo # CGNS_SCOPING  = scoping of enums>> cgnsBuild.defs
echo # CGNS_64BIT    = 64 bit support>> cgnsBuild.defs
echo # CGNS_FORTRAN  = Fortran interface>> cgnsBuild.defs
echo # CGNS_PARALLEL = parallel I/O>> cgnsBuild.defs
echo #----------------------------------------------------------------------->> cgnsBuild.defs
echo.>> cgnsBuild.defs
echo CGNS_DEBUG    = %dodebug% >> cgnsBuild.defs
echo CGNS_LEGACY   = %dolegacy% >> cgnsBuild.defs
echo CGNS_SCOPING  = %doscope% >> cgnsBuild.defs
echo CGNS_BASESCOPE = %dobasescope% >> cgnsBuild.defs
echo CGNS_64BIT    = %do64bit% >> cgnsBuild.defs
echo CGNS_FORTRAN  = %dofortran% >> cgnsBuild.defs
echo CGNS_PARALLEL = %doparallel% >> cgnsBuild.defs
echo.>> cgnsBuild.defs
echo #------------------------------------------------------------------------>> cgnsBuild.defs
echo # CGNS_LIBDIR     - installation directory for CGNS library>> cgnsBuild.defs
echo # CGNS_INCLUDEDIR - installation directory for CGNS headers>> cgnsBuild.defs
echo #------------------------------------------------------------------------>> cgnsBuild.defs
echo.>> cgnsBuild.defs
echo CGNS_LIBDIR     = %instdir%\lib>> cgnsBuild.defs
echo CGNS_INCLUDEDIR = %instdir%\include>> cgnsBuild.defs
echo.>> cgnsBuild.defs
echo #------------------------------------------------------------------------>> cgnsBuild.defs
echo # CGNS_CC      - C compiler used to build library>> cgnsBuild.defs
echo # CGNS_CFLAGS  - compiler flags used to build library>> cgnsBuild.defs
echo # CGNS_LDFLAGS - any additional linker options>> cgnsBuild.defs
echo #------------------------------------------------------------------------>> cgnsBuild.defs
echo.>> cgnsBuild.defs
echo CGNS_CC      = cl>> cgnsBuild.defs
echo CGNS_CFLAGS  = /nologo %copts% /D_CRT_SECURE_NO_WARNINGS>> cgnsBuild.defs
echo CGNS_LDFLAGS = /nologo %lopts%>> cgnsBuild.defs
echo.>> cgnsBuild.defs
echo #------------------------------------------------------------------------>> cgnsBuild.defs
echo # CGNS_LIB - CGNS library name>> cgnsBuild.defs
echo #------------------------------------------------------------------------>> cgnsBuild.defs
echo.>> cgnsBuild.defs
echo CGNS_LIB = $(CGNS_LIBDIR)\cgns.lib>> cgnsBuild.defs
echo.>> cgnsBuild.defs
echo #------------------------------------------------------------------------>> cgnsBuild.defs
echo # CGNS_HDF5INC - path to HDF5 header files>> cgnsBuild.defs
echo # CGNS_HDF5LIB - HDF5 library>> cgnsBuild.defs
echo # CGNS_SZIPLIB - szip library (if needed)>> cgnsBuild.defs
echo # CGNS_ZLIBLIB - zlib library (if needed)>> cgnsBuild.defs
echo #------------------------------------------------------------------------>> cgnsBuild.defs
echo.>> cgnsBuild.defs
echo CGNS_HDF5INC = %hdf5inc%>> cgnsBuild.defs
echo CGNS_HDF5LIB = %hdf5lib%>> cgnsBuild.defs
echo CGNS_SZIPLIB = %sziplib%>> cgnsBuild.defs
echo CGNS_ZLIBLIB = %zliblib%>> cgnsBuild.defs
echo.>> cgnsBuild.defs
echo #------------------------------------------------------------------------>> cgnsBuild.defs
echo # CGNS_MPIINC  - path to MPI header files>> cgnsBuild.defs
echo # CGNS_MPILIBS - MPI libraries>> cgnsBuild.defs
echo #------------------------------------------------------------------------>> cgnsBuild.defs
echo.>> cgnsBuild.defs
echo CGNS_MPIINC  = %mpiinc%>> cgnsBuild.defs
echo CGNS_MPILIBS = %mpilibs%>> cgnsBuild.defs
echo.>> cgnsBuild.defs
echo #------------------------------------------------------------------------>> cgnsBuild.defs
echo # CGNS_LINKLIBS contains the list of libraries>> cgnsBuild.defs
echo #               with which a CGNS application needs to link>> cgnsBuild.defs
echo #------------------------------------------------------------------------>> cgnsBuild.defs
echo.>> cgnsBuild.defs
echo CGNS_LINKLIBS = $(CGNS_LIB) $(CGNS_HDF5LIB) $(CGNS_SZIPLIB) \>> cgnsBuild.defs
echo 	$(CGNS_ZLIBLIB) $(CGNS_MPILIBS)>> cgnsBuild.defs

rem ----- create Makefile

echo creating Makefile
echo # nmake makefile for the CGNS Library under Windows> Makefile
echo.>> Makefile
echo !include make.defs>> Makefile
echo.>> Makefile
echo .SUFFIXES :>> Makefile
echo .SUFFIXES : .c .$(O) $(EXE)>> Makefile
echo.>> Makefile
echo OBJDIR  = %builddir%>> Makefile
echo CGNSLIB = $(LIBCGNS)>> Makefile
echo INSTLIB = cgns.$(A)>> Makefile
if %target% == dll (
  echo CGNSDLL = $^(OBJDIR^)\cgns.dll>> Makefile
  echo INSTDLL = cgns.dll>> Makefile
)
echo.>> Makefile
echo COPTS   = $(CFLAGS) $(CFGFLAGS) /I. %build% %dllopts%>> Makefile
if not "%hdf5inc%" == "" (
  echo # uncomment the following when using HDF5 DLL>> Makefile
  echo %hdf5dll% = /DWIN32 /D_HDF5USEDLL_>> Makefile
)
echo.>> Makefile
echo #---------->> Makefile
echo.>> Makefile
echo CGNSOBJS=\>> Makefile
echo 	$(OBJDIR)\cgns_error.$(O) \>> Makefile
echo 	$(OBJDIR)\cgns_internals.$(O) \>> Makefile
echo 	$(OBJDIR)\cgns_io.$(O) \>> Makefile
echo 	$(OBJDIR)\cgnslib.$(O)>> Makefile
echo.>> Makefile
echo # ADF/ADFH routines>> Makefile
echo.>> Makefile
echo ADFOBJS=\>>Makefile
if not "%hdf5inc%" == "" echo 	$(OBJDIR)\ADFH.$(O) \>>Makefile
if not "%parallel%" == "" echo 	$(OBJDIR)\pcgnslib.$(O) \>>Makefile
echo 	$(OBJDIR)\ADF_interface.$(O) \>>Makefile
echo 	$(OBJDIR)\ADF_internals.$(O)>> Makefile
echo.>> Makefile
echo F2COBJS= $(OBJDIR)\cg_ftoc.$(O) $(OBJDIR)\cgio_ftoc.$(O)>> Makefile
echo.>> Makefile
echo #---------->> Makefile
echo.>> Makefile
echo all     : %target% tools %cgnstools%>> Makefile
if %target% == dll echo dll     : $^(CGNSDLL^)>> Makefile
echo cgns    : $(CGNSLIB)>> Makefile
echo test    : runtests %parallel%>> Makefile
if "%cgnstools%" == "cgnstools" (
  echo install : install-cgns install-tools install-cgnstools>> Makefile
) else (
  echo install : install-cgns>> Makefile
)
echo.>> Makefile
echo #---------->> Makefile
echo.>> Makefile
echo $(CGNSLIB) : $(OBJDIR) $(CGNSOBJS) $(ADFOBJS) %f2cobjs%>> Makefile
echo 	-@$(RM) $@>> Makefile
echo 	$(AR) /lib /nologo $(AROUT)$@ $(CGNSOBJS) $(ADFOBJS) %f2cobjs%>> Makefile
if not %target% == dll goto make2
echo.>> Makefile
echo #---------->> Makefile
echo.>> Makefile
echo $(CGNSDLL) : $(OBJDIR) $(CGNSOBJS) $(ADFOBJS) %f2cobjs%>> Makefile
echo 	-@$(RM) $@ $(CGNSLIB)>> Makefile
echo 	$(AR) /dll /nologo $(AROUT)$@ $(CGNSOBJS) $(ADFOBJS) %f2cobjs% $(BUILDLIBS)>> Makefile
:make2
echo.>> Makefile
echo #---------->> Makefile
echo.>> Makefile
echo $(OBJDIR) :>> Makefile
echo 	-$(MKDIR) $(OBJDIR)>> Makefile
echo.>> Makefile
echo #---------->> Makefile
echo.>> Makefile
echo tools : %target%>> Makefile
echo 	-cd tools ^&^& %make%>> Makefile
echo.>> Makefile
echo cgnstools : %target%>> Makefile
echo 	-cd cgnstools ^&^& %make%>> Makefile
echo.>> Makefile
echo tests : %target%>> Makefile
echo 	-cd tests ^&^& %make%>> Makefile
echo.>> Makefile
echo ptests : %target%>> Makefile
echo 	-cd ptests ^&^& %make%>> Makefile
echo.>> Makefile
echo runtests : %target%>> Makefile
echo 	-cd tests ^&^& %make% test>> Makefile
echo.>> Makefile
echo runptests : %target%>> Makefile
echo 	-cd ptests ^&^& %make% test>> Makefile
echo.>> Makefile
echo #---------->> Makefile
echo.>> Makefile
echo clean :>> Makefile
echo 	-cd $(OBJDIR) ^&^& $(RM) *.$(O)>> Makefile
echo 	-cd tools ^&^& %make% clean>> Makefile
echo 	-cd tests ^&^& %make% clean>> Makefile
echo 	-cd ptests ^&^& %make% clean>> Makefile
echo 	-cd cgnstools ^&^& %make% clean>> Makefile
echo.>> Makefile
echo allclean : distclean>> Makefile
echo.>> Makefile
echo distclean : clean>> Makefile
echo 	-cd tools ^&^& %make% allclean>> Makefile
echo 	-cd tools ^&^& $(RM) Makefile>> Makefile
echo 	-cd tests ^&^& %make% allclean>> Makefile
echo 	-cd tests ^&^& $(RM) Makefile>> Makefile
echo 	-cd ptests ^&^& %make% allclean>> Makefile
echo 	-cd ptests ^&^& $(RM) Makefile>> Makefile
echo 	-cd cgnstools ^&^& %make% distclean>> Makefile
echo 	-$(RM) $(CGNSLIB)>> Makefile
if %target% == dll echo 	-$(RM) $(CGNSDLL)>> Makefile
echo 	-$(RMDIR) $(OBJDIR)>> Makefile
echo 	-$(RM) cgnsconfig.h cgnstypes.h cgnstypes_f.h cgnslib_f.h>> Makefile
echo 	-$(RM) *.pdb *.bak>> Makefile
echo 	-$(RM) make.defs cgnsBuild.defs Makefile>> Makefile
echo.>> Makefile
echo install-cgns : %target% $(INCLUDEDIR) $(LIBDIR) %adfinc%>> Makefile
echo 	$(INSTALL_DATA) cgnstypes.h $(INCLUDEDIR)\cgnstypes.h>> Makefile
echo 	$(INSTALL_DATA) cgnstypes_f.h $(INCLUDEDIR)\cgnstypes_f.h>> Makefile
echo 	$(INSTALL_DATA) cgnslib.h $(INCLUDEDIR)\cgnslib.h>> Makefile
echo 	$(INSTALL_DATA) cgnslib_f.h $(INCLUDEDIR)\cgnslib_f.h>> Makefile
echo 	$(INSTALL_DATA) cgnswin_f.h $(INCLUDEDIR)\cgnswin_f.h>> Makefile
echo 	$(INSTALL_DATA) cgns_io.h $(INCLUDEDIR)\cgns_io.h>> Makefile
if not "%parallel%" == "" echo 	$(INSTALL_DATA) pcgnslib.h $(INCLUDEDIR)\pcgnslib.h>> Makefile
echo 	$(INSTALL_DATA) cgnsconfig.h $(INCLUDEDIR)\cgnsconfig.h>> Makefile
echo 	$(INSTALL_DATA) cgnsBuild.defs $(INCLUDEDIR)\cgnsBuild.defs>> Makefile
echo 	$(INSTALL_DATA) $(CGNSLIB) $(LIBDIR)\$(INSTLIB)>> Makefile
if %target% == dll echo 	$(INSTALL_DATA) $(CGNSDLL) $(LIBDIR)\$(INSTDLL)>> Makefile
echo.>> Makefile
echo install-all : install>> Makefile
echo.>> Makefile
echo install-tools :>> Makefile
echo 	-cd tools ^&^& %make% install>> Makefile
echo.>> Makefile
echo install-cgnstools :>> Makefile
echo 	-cd cgnstools ^&^& %make% install>> Makefile
echo.>> Makefile
echo $(INCLUDEDIR) : $(INSTALLDIR)>> Makefile
echo 	-$(MKDIR) $(INCLUDEDIR)>> Makefile
echo.>> Makefile
echo $(LIBDIR) : $(INSTALLDIR)>> Makefile
echo 	-$(MKDIR) $(LIBDIR)>> Makefile
echo.>> Makefile
echo $(INSTALLDIR) :>> Makefile
echo 	-$(MKDIR) $(INSTALLDIR)>> Makefile
echo.>> Makefile
echo install-adf : $(INCLUDEDIR)\adf>> Makefile
echo 	$(INSTALL_DATA) adf\ADF.h $(INCLUDEDIR)\adf\ADF.h>> Makefile
echo.>> Makefile
echo $(INCLUDEDIR)\adf : $(INCLUDEDIR)>> Makefile
echo 	-$(MKDIR) $(INCLUDEDIR)\adf>> Makefile
echo.>> Makefile
echo install-adfh : $(INCLUDEDIR)\adfh>> Makefile
echo 	$(INSTALL_DATA) adfh\ADFH.h $(INCLUDEDIR)\adfh\ADFH.h>> Makefile
echo.>> Makefile
echo $(INCLUDEDIR)\adfh : $(INCLUDEDIR)>> Makefile
echo 	-$(MKDIR) $(INCLUDEDIR)\adfh>> Makefile
echo.>> Makefile
echo #---------- mid-level library>> Makefile
echo.>> Makefile
echo $(OBJDIR)\cgns_error.$(O) : cgns_error.c cgnslib.h cgns_header.h cgns_io.h>> Makefile
echo 	$(CC) $(COPTS) $(COOUT)$@ /c cgns_error.c>> Makefile
echo.>> Makefile
echo $(OBJDIR)\cgns_internals.$(O) : cgns_internals.c cgnslib.h cgns_header.h cgns_io.h>> Makefile
echo 	$(CC) $(COPTS) $(COOUT)$@ /c cgns_internals.c>> Makefile
echo.>> Makefile
echo $(OBJDIR)\cgns_io.$(O) : cgns_io.c cgnslib.h cgns_io.h \>> Makefile
set includes=adf\ADF.h
if not "%hdf5inc%" == "" set includes=%includes% adfh\ADFH.h
echo 	%includes%>> Makefile
echo 	$(CC) $(COPTS) $(COOUT)$@ /c cgns_io.c>> Makefile
echo.>> Makefile
echo $(OBJDIR)\cgnslib.$(O) : cgnslib.c cgnslib.h cgns_header.h cgns_io.h>> Makefile
echo 	$(CC) $(COPTS) $(HDF5INC) $(MPIINC) $(COOUT)$@ /c cgnslib.c>> Makefile
echo.>> Makefile
echo $(OBJDIR)\cg_ftoc.$(O) : cg_ftoc.c fortran_macros.h cgnslib.h cgns_header.h cgns_io.h>> Makefile
echo 	$(CC) $(COPTS) $(F2CFLAGS) $(COOUT)$@ /c cg_ftoc.c>> Makefile
echo $(OBJDIR)\cgio_ftoc.$(O) : cgio_ftoc.c fortran_macros.h cgns_io.h>> Makefile
echo 	$(CC) $(COPTS) $(F2CFLAGS) $(COOUT)$@ /c cgio_ftoc.c>> Makefile
echo.>> Makefile
echo cgnslib.h : cgnstypes.h>> Makefile
echo cgns_header.h : cgnstypes.h>> Makefile
echo cgns_io.h : cgnstypes.h>> Makefile
echo.>> Makefile
echo #---------- ADF>> Makefile
echo.>> Makefile
echo $(OBJDIR)\ADF_interface.$(O) : adf\ADF_interface.c \>> Makefile
echo 	adf\ADF.h adf\ADF_internals.h>> Makefile
echo 	$(CC) $(COPTS) /Iadf $(COOUT)$@ /c adf\ADF_interface.c>> Makefile
echo.>> Makefile
echo $(OBJDIR)\ADF_internals.$(O) : adf\ADF_internals.c \>> Makefile
echo 	adf\ADF.h adf\ADF_internals.h>> Makefile
echo 	$(CC) $(COPTS) /Iadf $(COOUT)$@ /c adf\ADF_internals.c>> Makefile
echo.>> Makefile
echo adf\ADF.h : cgnstypes.h>> Makefile
echo adf\ADF_internals.h : cgnstypes.h>> Makefile
echo.>> Makefile
echo #---------- HDF5>> Makefile
echo.>> Makefile
echo $(OBJDIR)\ADFH.$(O) : adfh\ADFH.c adfh\ADFH.h>> Makefile
echo 	$(CC) $(COPTS) /Iadfh $(HDF5INC) $(HDF5DLL) $(MPIINC) $(COOUT)$@ /c adfh\ADFH.c>> Makefile
echo.>> Makefile
echo adfh\ADFH.h : cgnstypes.h>> Makefile
echo.>> Makefile
echo #---------- PCGNS>> Makefile
echo.>> Makefile
echo $(OBJDIR)\pcgnslib.$(O) : pcgnslib.c pcgnslib.h>> Makefile
echo 	$(CC) $(COPTS) $(HDF5INC) $(MPIINC) $(COOUT)$@ /c pcgnslib.c>> Makefile
echo.>> Makefile
echo pcgnslib.h : cgnslib.h>> Makefile

rem ----- create tools/Makefile

if not exist tools\nul goto tests

echo creating tools\Makefile
echo # nmake makefile for Windows> tools\Makefile
echo.>> tools\Makefile
echo CGNSDIR = ..>> tools\Makefile
echo !include $(CGNSDIR)\make.defs>> tools\Makefile
echo.>> tools\Makefile
echo CGNSLIB = $(CGNSDIR)\$(LIBCGNS)>> tools\Makefile
echo.>> tools\Makefile
echo COPTS  = $(CFLAGS) /I$(CGNSDIR)>> tools\Makefile
echo LDLIBS = $(CGNSLIB) $(BUILDLIBS)>> tools\Makefile
echo.>> tools\Makefile
echo #---------->> tools\Makefile
echo.>> tools\Makefile
echo ALL =	cgnslist$(EXE) \>> tools\Makefile
echo 	cgnscheck$(EXE) \>> tools\Makefile
echo 	cgnsconvert$(EXE) \>> tools\Makefile
echo 	cgnscompress$(EXE) \>> tools\Makefile
echo 	cgnsdiff$(EXE) \>> tools\Makefile
echo 	cgnsnames$(EXE)>> tools\Makefile
echo.>> tools\Makefile
echo all : $(ALL)>> tools\Makefile
echo.>> tools\Makefile
echo #---------->> tools\Makefile
echo.>> tools\Makefile
echo cgnslist$(EXE) : cgnslist.$(O) getargs.$(O) $(CGNSLIB)>> tools\Makefile
echo 	$(CC) $(COPTS) $(CEOUT)$@ cgnslist.$(O) getargs.$(O) $(LDLIBS) $(CLIBS)>> tools\Makefile
echo cgnslist.$(O) : cgnslist.c getargs.h>> tools\Makefile
echo 	$(CC) $(COPTS) /c cgnslist.c>> tools\Makefile
echo.>> tools\Makefile
echo #---------->> tools\Makefile
echo.>> tools\Makefile
echo cgnscheck$(EXE) : cgnscheck.$(O) getargs.$(O) hash.$(O) cgnames.$(O) $(CGNSLIB)>> tools\Makefile
echo 	$(CC) $(COPTS) $(CEOUT)$@ cgnscheck.$(O) getargs.$(O) hash.$(O) cgnames.$(O) $(LDLIBS) $(CLIBS)>> tools\Makefile
echo cgnscheck.$(O) : cgnscheck.c getargs.h hash.h cgnames.h>> tools\Makefile
echo 	$(CC) $(COPTS) /c cgnscheck.c>> tools\Makefile
echo.>> tools\Makefile
echo #---------->> tools\Makefile
echo.>> tools\Makefile
echo cgnsconvert$(EXE) : cgnsconvert.$(O) getargs.$(O) $(CGNSLIB)>> tools\Makefile
echo 	$(CC) $(CFLAGS) $(CEOUT)$@ cgnsconvert.$(O) getargs.$(O) $(LDLIBS) $(CLIBS)>> tools\Makefile
echo cgnsconvert.$(O) : cgnsconvert.c getargs.h>> tools\Makefile
echo 	$(CC) $(COPTS) /c cgnsconvert.c>> tools\Makefile
echo.>> tools\Makefile
echo #---------->> tools\Makefile
echo.>> tools\Makefile
echo cgnscompress$(EXE) : cgnscompress.$(O) $(CGNSLIB)>> tools\Makefile
echo 	$(CC) $(CFLAGS) $(CEOUT)$@ cgnscompress.$(O) $(LDLIBS) $(CLIBS)>> tools\Makefile
echo cgnscompress.$(O) : cgnscompress.c>> tools\Makefile
echo 	$(CC) $(COPTS) /c cgnscompress.c>> tools\Makefile
echo.>> tools\Makefile
echo #---------->> tools\Makefile
echo.>> tools\Makefile
echo cgnsdiff$(EXE) : cgnsdiff.$(O) getargs.$(O) $(CGNSLIB)>> tools\Makefile
echo 	$(CC) $(CFLAGS) $(CEOUT)$@ cgnsdiff.$(O) getargs.$(O) $(LDLIBS) $(CLIBS)>> tools\Makefile
echo cgnsdiff.$(O) : cgnsdiff.c getargs.h>> tools\Makefile
echo 	$(CC) $(COPTS) /c cgnsdiff.c>> tools\Makefile
echo.>> tools\Makefile
echo #---------->> tools\Makefile
echo.>> tools\Makefile
echo cgnsnames$(EXE) : cgnsnames.$(O) cgnames.$(O) $(CGNSLIB)>> tools\Makefile
echo 	$(CC) $(CFLAGS) $(CEOUT)$@ cgnsnames.$(O) cgnames.$(O) $(LDLIBS) $(CLIBS)>> tools\Makefile
echo cgnsnames.$(O) : cgnsnames.c cgnames.h>> tools\Makefile
echo 	$(CC) $(COPTS) /c cgnsnames.c>> tools\Makefile
echo.>> tools\Makefile
echo #---------->> tools\Makefile
echo.>> tools\Makefile
echo getargs.$(O) : getargs.c getargs.h>> tools\Makefile
echo 	$(CC) $(COPTS) /c getargs.c>> tools\Makefile
echo.>> tools\Makefile
echo hash.$(O) : hash.c hash.h>> tools\Makefile
echo 	$(CC) $(COPTS) /c hash.c>> tools\Makefile
echo.>> tools\Makefile
echo cgnames.$(O) : cgnames.c cgnames.h>> tools\Makefile
echo 	$(CC) $(COPTS) /c cgnames.c>> tools\Makefile
echo.>> tools\Makefile
echo install : all $(BINDIR)>> tools\Makefile
echo 	$(INSTALL_PROG) cgnslist$(EXE) $(BINDIR)>> tools\Makefile
echo 	$(INSTALL_PROG) cgnscheck$(EXE) $(BINDIR)>> tools\Makefile
echo 	$(INSTALL_PROG) cgnsconvert$(EXE) $(BINDIR)>> tools\Makefile
echo 	$(INSTALL_PROG) cgnscompress$(EXE) $(BINDIR)>> tools\Makefile
echo 	$(INSTALL_PROG) cgnsdiff$(EXE) $(BINDIR)>> tools\Makefile
echo 	$(INSTALL_PROG) cgnsnames$(EXE) $(BINDIR)>> tools\Makefile
echo 	$(INSTALL_PROG) adf2hdf.bat $(BINDIR)>> tools\Makefile
echo 	$(INSTALL_PROG) hdf2adf.bat $(BINDIR)>> tools\Makefile
echo 	$(INSTALL_PROG) cgnsupdate.bat $(BINDIR)>> tools\Makefile
echo.>> tools\Makefile
echo $(BINDIR) : $(INSTALLDIR)>> tools\Makefile
echo 	-$(MKDIR) $(BINDIR)>> tools\Makefile
echo.>> tools\Makefile
echo $(INSTALLDIR) :>> tools\Makefile
echo 	-$(MKDIR) $(INSTALLDIR)>> tools\Makefile
echo.>> tools\Makefile
echo clean :>> tools\Makefile
echo 	-$(RM) *.$(O)>> tools\Makefile
echo.>> tools\Makefile
echo allclean : clean>> tools\Makefile
echo 	-$(RM) *.exe>> tools\Makefile
echo 	-$(RM) *.pdb *.ilk>> tools\Makefile

rem ----- create tests/Makefile

:tests
if not exist tests\nul goto ptests

echo creating tests\Makefile
echo # nmake makefile for Windows> tests\Makefile
echo.>> tests\Makefile
echo CGNSDIR = ..>> tests\Makefile
echo !include $(CGNSDIR)\make.defs>> tests\Makefile
echo.>> tests\Makefile
echo CGNSLIB = $(CGNSDIR)\$(LIBCGNS)>> tests\Makefile
echo.>> tests\Makefile
echo COPTS  = $(CFLAGS) /I$(CGNSDIR)>> tests\Makefile
echo FOPTS  = $(FFLAGS) /I$(CGNSDIR)>> tests\Makefile
echo LDLIBS = $(CGNSLIB) $(BUILDLIBS)>> tests\Makefile
echo.>> tests\Makefile
echo #---------->> tests\Makefile
echo.>> tests\Makefile
echo CALL = \>> tests\Makefile
echo 	elemtest$(EXE) \>> tests\Makefile
echo 	test_exts$(EXE) \>> tests\Makefile
echo 	test_partial$(EXE) \>> tests\Makefile
echo 	test_goto$(EXE) \>> tests\Makefile
echo 	test_multifam$(EXE) \>> tests\Makefile
echo 	test_ver31$(EXE) \>> tests\Makefile
echo 	write_array$(EXE) \>> tests\Makefile
echo 	write_links$(EXE) \>> tests\Makefile
echo 	write_bcdata$(EXE) \>> tests\Makefile
echo 	write_test$(EXE) \>> tests\Makefile
echo 	write_zones$(EXE) \>> tests\Makefile
echo 	write_rind$(EXE)>> tests\Makefile
echo FALL =	cgwrite$^(EXE^) \>> tests\Makefile
echo 	cgread$^(EXE^) \>> tests\Makefile
echo 	cgzconn$(EXE) \>> tests\Makefile
echo 	cgsubreg$(EXE)>> tests\Makefile
echo CALL64 = test64c$^(EXE^)>> tests\Makefile
echo FALL64 = test64f$^(EXE^)>> tests\Makefile
echo.>> tests\Makefile
if not "%f2c%" == "none" (
  echo TESTS = $^(CALL^) $^(FALL^)>> tests\Makefile
  echo ALL64 = $^(CALL64^) $^(FALL64^)>> tests\Makefile
) else (
  echo TESTS = $^(CALL^)>> tests\Makefile
  echo ALL64 = $^(CALL64^)>> tests\Makefile
)
echo ALL   = dbtest$(EXE) open_cgns$(EXE) $(TESTS)>> tests\Makefile
echo.>> tests\Makefile
echo #---------->> tests\Makefile
echo.>> tests\Makefile
echo all : $(ALL)>> tests\Makefile
echo fortran : $(FALL)>> tests\Makefile
echo test64 : $(ALL64)>> tests\Makefile
echo.>> tests\Makefile
echo #---------->> tests\Makefile
echo.>> tests\Makefile
echo test : $(TESTS)>> tests\Makefile
echo 	@echo>> tests\Makefile
echo 	@echo === running tests ===>> tests\Makefile
echo 	-@runtest.bat elemtest$(EXE)>> tests\Makefile
echo 	-@runtest.bat test_exts$(EXE)>> tests\Makefile
echo 	-@runtest.bat test_partial$(EXE)>> tests\Makefile
echo 	-@runtest.bat test_goto$(EXE)>> tests\Makefile
echo 	-@runtest.bat test_multifam$(EXE)>> tests\Makefile
echo 	-@runtest.bat test_ver31$(EXE)>> tests\Makefile
echo 	-@runtest.bat write_array$(EXE)>> tests\Makefile
echo 	-@runtest.bat write_links$(EXE)>> tests\Makefile
echo 	-@runtest.bat write_bcdata$(EXE)>> tests\Makefile
echo 	-@runtest.bat write_test$(EXE)>> tests\Makefile
echo 	-@runtest.bat write_zones$(EXE)>> tests\Makefile
echo 	-@runtest.bat write_rind$(EXE)>> tests\Makefile
if not "%f2c%" == "none" (
  echo 	-@runtest.bat cgwrite$^(EXE^)>> tests\Makefile
  echo 	-@runtest.bat cgread$^(EXE^)>> tests\Makefile
  echo 	-@runtest.bat cgzconn$^(EXE^)>> tests\Makefile
  echo 	-@runtest.bat cgsubreg$^(EXE^)>> tests\Makefile
)
echo 	@echo === finished ===>> tests\Makefile
echo.>> tests\Makefile
echo #---------->> tests\Makefile
echo.>> tests\Makefile
echo dbtest$(EXE) : dbtest.$(O) utils.$(O) $(CGNSLIB)>> tests\Makefile
echo 	$(CC) $(COPTS) $(CEOUT)$@ dbtest.$(O) utils.$(O) $(LDLIBS) $(CLIBS)>> tests\Makefile
echo dbtest.$(O) : dbtest.c utils.h>> tests\Makefile
echo 	$(CC) $(COPTS) /c dbtest.c>> tests\Makefile
echo.>> tests\Makefile
echo #---------->> tests\Makefile
echo.>> tests\Makefile
echo elemtest$(EXE) : elemtest.c $(CGNSLIB)>> tests\Makefile
echo 	$(CC) $(COPTS) $(CEOUT)$@ elemtest.c $(LDLIBS) $(CLIBS)>> tests\Makefile
echo.>> tests\Makefile
echo #---------->> tests\Makefile
echo.>> tests\Makefile
echo open_cgns$(EXE) : open_cgns.$(O) utils.$(O) $(CGNSLIB)>> tests\Makefile
echo 	$(CC) $(CFLAGS) $(CEOUT)$@ open_cgns.$(O) utils.$(O) $(LDLIBS) $(CLIBS)>> tests\Makefile
echo open_cgns.$(O) : open_cgns.c utils.h>> tests\Makefile
echo 	$(CC) $(COPTS) /c open_cgns.c>> tests\Makefile
echo.>> tests\Makefile
echo #---------->> tests\Makefile
echo.>> tests\Makefile
echo test_exts$(EXE) : test_exts.c $(CGNSLIB)>> tests\Makefile
echo 	$(CC) $(COPTS) $(CEOUT)$@ test_exts.c $(LDLIBS) $(CLIBS)>> tests\Makefile
echo.>> tests\Makefile
echo #---------->> tests\Makefile
echo.>> tests\Makefile
echo test_partial$(EXE) : test_partial.c $(CGNSLIB)>> tests\Makefile
echo 	$(CC) $(COPTS) $(CEOUT)$@ test_partial.c $(LDLIBS) $(CLIBS)>> tests\Makefile
echo.>> tests\Makefile
echo #---------->> tests\Makefile
echo.>> tests\Makefile
echo test_goto$(EXE) : test_goto.c $(CGNSLIB)>> tests\Makefile
echo 	$(CC) $(COPTS) $(CEOUT)$@ test_goto.c $(LDLIBS) $(CLIBS)>> tests\Makefile
echo.>> tests\Makefile
echo #---------->> tests\Makefile
echo.>> tests\Makefile
echo test_multifam$(EXE) : test_multifam.c $(CGNSLIB)>> tests\Makefile
echo 	$(CC) $(COPTS) $(CEOUT)$@ test_multifam.c $(LDLIBS) $(CLIBS)>> tests\Makefile
echo.>> tests\Makefile
echo #---------->> tests\Makefile
echo.>> tests\Makefile
echo test_ver31$(EXE) : test_ver31.c $(CGNSLIB)>> tests\Makefile
echo 	$(CC) $(COPTS) $(CEOUT)$@ test_ver31.c $(LDLIBS) $(CLIBS)>> tests\Makefile
echo.>> tests\Makefile
echo #---------->> tests\Makefile
echo.>> tests\Makefile
echo write_array$(EXE) : write_array.$(O) utils.$(O) $(CGNSLIB)>> tests\Makefile
echo 	$(CC) $(CFLAGS) $(CEOUT)$@ write_array.$(O) utils.$(O) $(LDLIBS) $(CLIBS)>> tests\Makefile
echo write_array.$(O) : write_array.c utils.h>> tests\Makefile
echo 	$(CC) $(COPTS) /c write_array.c>> tests\Makefile
echo.>> tests\Makefile
echo #---------->> tests\Makefile
echo.>> tests\Makefile
echo write_links$(EXE) : write_links.$(O) utils.$(O) $(CGNSLIB)>> tests\Makefile
echo 	$(CC) $(CFLAGS) $(CEOUT)$@ write_links.$(O) utils.$(O) $(LDLIBS) $(CLIBS)>> tests\Makefile
echo write_links.$(O) : write_links.c utils.h>> tests\Makefile
echo 	$(CC) $(COPTS) /c write_links.c>> tests\Makefile
echo.>> tests\Makefile
echo #---------->> tests\Makefile
echo.>> tests\Makefile
echo write_bcdata$(EXE) : write_bcdata.$(O) utils.$(O) $(CGNSLIB)>> tests\Makefile
echo 	$(CC) $(CFLAGS) $(CEOUT)$@ write_bcdata.$(O) utils.$(O) $(LDLIBS) $(CLIBS)>> tests\Makefile
echo write_bcdata.$(O) : write_bcdata.c utils.h>> tests\Makefile
echo 	$(CC) $(COPTS) /c write_bcdata.c>> tests\Makefile
echo.>> tests\Makefile
echo #---------->> tests\Makefile
echo.>> tests\Makefile
echo write_test$(EXE) : write_test.c $(CGNSLIB)>> tests\Makefile
echo 	$(CC) $(COPTS) $(CEOUT)$@ write_test.c $(LDLIBS) $(CLIBS)>> tests\Makefile
echo.>> tests\Makefile
echo #---------->> tests\Makefile
echo.>> tests\Makefile
echo write_zones$(EXE) : write_zones.$(O) utils.$(O) $(CGNSLIB)>> tests\Makefile
echo 	$(CC) $(CFLAGS) $(CEOUT)$@ write_zones.$(O) utils.$(O) $(LDLIBS) $(CLIBS)>> tests\Makefile
echo write_zones.$(O) : write_zones.c utils.h>> tests\Makefile
echo 	$(CC) $(COPTS) /c write_zones.c>> tests\Makefile
echo.>> tests\Makefile
echo #---------->> tests\Makefile
echo.>> tests\Makefile
echo write_rind$(EXE) : write_rind.c $(CGNSLIB)>> tests\Makefile
echo 	$(CC) $(COPTS) $(CEOUT)$@ write_rind.c $(LDLIBS) $(CLIBS)>> tests\Makefile
echo.>> tests\Makefile
echo #---------->> tests\Makefile
echo.>> tests\Makefile
echo cgwrite$(EXE) : cgwrite.F $(CGNSLIB)>> tests\Makefile
echo 	$(F77) $(FOPTS) $(FEOUT)$@ cgwrite.F $(LDLIBS) $(FLIBS)>> tests\Makefile
echo.>> tests\Makefile
echo #---------->> tests\Makefile
echo.>> tests\Makefile
echo cgread$(EXE) : cgread.F $(CGNSLIB)>> tests\Makefile
echo 	$(F77) $(FOPTS) $(FEOUT)$@ cgread.F $(LDLIBS) $(FLIBS)>> tests\Makefile
echo.>> tests\Makefile
echo #---------->> tests\Makefile
echo.>> tests\Makefile
echo cgzconn$(EXE) : cgzconn.F $(CGNSLIB)>> tests\Makefile
echo 	$(F77) $(FOPTS) $(FEOUT)$@ cgzconn.F $(LDLIBS) $(FLIBS)>> tests\Makefile
echo.>> tests\Makefile
echo #---------->> tests\Makefile
echo.>> tests\Makefile
echo cgsubreg$(EXE) : cgsubreg.F $(CGNSLIB)>> tests\Makefile
echo 	$(F77) $(FOPTS) $(FEOUT)$@ cgsubreg.F $(LDLIBS) $(FLIBS)>> tests\Makefile
echo.>> tests\Makefile
echo #---------->> tests\Makefile
echo.>> tests\Makefile
echo test64c$(EXE) : test64c.$(O) utils.$(O) $(CGNSLIB)>> tests\Makefile
echo 	$(CC) $(CFLAGS) $(CEOUT)$@ test64c.$(O) utils.$(O) $(LDLIBS) $(CLIBS)>> tests\Makefile
echo 	$(STRIP) $@>> tests\Makefile
echo test64c.$(O) : test64c.c utils.h>> tests\Makefile
echo 	$(CC) $(COPTS) /c test64c.c>> tests\Makefile
echo.>> tests\Makefile
echo #---------->> tests\Makefile
echo.>> tests\Makefile
echo test64f$(EXE) : test64f.F $(CGNSLIB)>> tests\Makefile
echo 	$(F77) $(FOPTS) $(FEOUT)$@ test64f.F $(LDLIBS) $(FLIBS)>> tests\Makefile
echo 	$(STRIP) $@>> tests\Makefile
echo.>> tests\Makefile
echo #---------->> tests\Makefile
echo.>> tests\Makefile
echo utils.$(O) : utils.c utils.h>> tests\Makefile
echo 	$(CC) $(COPTS) /c utils.c>> tests\Makefile
echo.>> tests\Makefile
echo clean :>> tests\Makefile
echo 	-$(RM) *.$(O)>> tests\Makefile
echo.>> tests\Makefile
echo allclean : clean>> tests\Makefile
echo 	-$(RM) *.exe>> tests\Makefile
echo 	-$(RM) *.pdb *.ilk>> tests\Makefile
echo 	-$(RM) *.cgns>> tests\Makefile

rem ----- create ptests/Makefile

:ptests
if not exist ptests\nul goto cgnstools

echo creating ptests\Makefile
echo # nmake makefile for Windows> ptests\Makefile
echo.>> ptests\Makefile
echo CGNSDIR = ..>> ptests\Makefile
echo !include $(CGNSDIR)\make.defs>> ptests\Makefile
echo.>> ptests\Makefile
echo CGNSLIB = $(CGNSDIR)\$(LIBCGNS)>> ptests\Makefile
echo.>> ptests\Makefile
echo COPTS  = $(CFLAGS) /I$(CGNSDIR) $(MPIINC)>> ptests\Makefile
echo FOPTS  = $(FFLAGS) /I$(CGNSDIR) $(MPIINC)>> ptests\Makefile
echo LDLIBS = $(CGNSLIB) $(BUILDLIBS)>> ptests\Makefile
echo.>> ptests\Makefile
echo #---------->> ptests\Makefile
echo.>> ptests\Makefile
echo CALL = \>> ptests\Makefile
echo 	ctest$(EXE) \>> ptests\Makefile
echo 	cexample$(EXE) \>> ptests\Makefile
echo 	benchmark$(EXE) \>> ptests\Makefile
echo 	open_close$(EXE) \>> ptests\Makefile
echo 	test_base$(EXE) \>> ptests\Makefile
echo 	test_unstructured$(EXE) \>> ptests\Makefile
echo 	test_unstruc_quad$(EXE) \>> ptests\Makefile
echo 	test_zone$(EXE) \>> ptests\Makefile
echo 	thesis_benchmark$(EXE)>> ptests\Makefile
echo FALL =	ftest$^(EXE^)>> ptests\Makefile
echo.>> ptests\Makefile
if not "%f2c%" == "none" (
  echo ALL   = $^(CALL^) $^(FALL^)>> ptests\Makefile
) else (
  echo ALL   = $^(CALL^)>> ptests\Makefile
)
echo TESTS = $(ALL)>> ptests\Makefile
echo.>> ptests\Makefile
echo all : $(ALL)>> ptests\Makefile
echo.>> ptests\Makefile
echo #---------->> ptests\Makefile
echo.>> ptests\Makefile
echo test : $(TESTS)>> ptests\Makefile
echo 	@echo>> ptests\Makefile
echo 	@echo === running parallel tests ===>> ptests\Makefile
echo 	-@runptest.bat $(MPIEXEC) ctest$(EXE)>> ptests\Makefile
echo 	-@runptest.bat $(MPIEXEC) cexample$(EXE)>> ptests\Makefile
echo 	-@runptest.bat $(MPIEXEC) benchmark$(EXE)>> ptests\Makefile
echo 	-@runptest.bat $(MPIEXEC) open_close$(EXE)>> ptests\Makefile
echo 	-@runptest.bat $(MPIEXEC) test_base$(EXE)>> ptests\Makefile
echo 	-@runptest.bat $(MPIEXEC) test_unstructured$(EXE)>> ptests\Makefile
echo 	-@runptest.bat $(MPIEXEC) test_unstruc_quad$(EXE)>> ptests\Makefile
echo 	-@runptest.bat $(MPIEXEC) test_zone$(EXE)>> ptests\Makefile
echo 	-@runptest.bat $(MPIEXEC) thesis_benchmark$(EXE)>> ptests\Makefile
if not "%f2c%" == "none" (
  echo 	-@runptest.bat $^(MPIEXEC^) ftest$^(EXE^)>> ptests\Makefile
)
echo 	@echo === finished ===>> ptests\Makefile
echo.>> ptests\Makefile
echo #---------->> ptests\Makefile
echo.>> ptests\Makefile
echo ctest$(EXE) : ctest.c $(CGNSLIB)>> ptests\Makefile
echo 	$(CC) $(COPTS) $(CEOUT)$@ ctest.c $(LDLIBS) $(CLIBS)>> ptests\Makefile
echo.>> ptests\Makefile
echo #---------->> ptests\Makefile
echo.>> ptests\Makefile
echo cexample$(EXE) : cexample.c $(CGNSLIB)>> ptests\Makefile
echo 	$(CC) $(COPTS) $(CEOUT)$@ cexample.c $(LDLIBS) $(CLIBS)>> ptests\Makefile
echo.>> ptests\Makefile
echo #---------->> ptests\Makefile
echo.>> ptests\Makefile
echo benchmark$(EXE) : benchmark.c $(CGNSLIB)>> ptests\Makefile
echo 	$(CC) $(COPTS) $(CEOUT)$@ benchmark.c $(LDLIBS) $(CLIBS)>> ptests\Makefile
echo.>> ptests\Makefile
echo #---------->> ptests\Makefile
echo.>> ptests\Makefile
echo open_close$(EXE) : open_close.c $(CGNSLIB)>> ptests\Makefile
echo 	$(CC) $(COPTS) $(CEOUT)$@ open_close.c $(LDLIBS) $(CLIBS)>> ptests\Makefile
echo.>> ptests\Makefile
echo #---------->> ptests\Makefile
echo.>> ptests\Makefile
echo test_base$(EXE) : test_base.c $(CGNSLIB)>> ptests\Makefile
echo 	$(CC) $(COPTS) $(CEOUT)$@ test_base.c $(LDLIBS) $(CLIBS)>> ptests\Makefile
echo.>> ptests\Makefile
echo #---------->> ptests\Makefile
echo.>> ptests\Makefile
echo test_unstructured$(EXE) : test_unstructured.c $(CGNSLIB)>> ptests\Makefile
echo 	$(CC) $(COPTS) $(CEOUT)$@ test_unstructured.c $(LDLIBS) $(CLIBS)>> ptests\Makefile
echo.>> ptests\Makefile
echo test_unstruc_quad$(EXE) : test_unstruc_quad.c $(CGNSLIB)>> ptests\Makefile
echo 	$(CC) $(COPTS) $(CEOUT)$@ test_unstruc_quad.c $(LDLIBS) $(CLIBS)>> ptests\Makefile
echo.>> ptests\Makefile
echo #---------->> ptests\Makefile
echo.>> ptests\Makefile
echo test_zone$(EXE) : test_zone.c $(CGNSLIB)>> ptests\Makefile
echo 	$(CC) $(COPTS) $(CEOUT)$@ test_zone.c $(LDLIBS) $(CLIBS)>> ptests\Makefile
echo.>> ptests\Makefile
echo #---------->> ptests\Makefile
echo.>> ptests\Makefile
echo thesis_benchmark$(EXE) : thesis_benchmark.c $(CGNSLIB)>> ptests\Makefile
echo 	$(CC) $(COPTS) $(CEOUT)$@ thesis_benchmark.c $(LDLIBS) $(CLIBS)>> ptests\Makefile
echo.>> ptests\Makefile
echo #---------->> ptests\Makefile
echo.>> ptests\Makefile
echo ftest$(EXE) : ftest.F $(CGNSLIB)>> ptests\Makefile
echo 	$(F77) $(FOPTS) $(FEOUT)$@ ftest.F $(LDLIBS) $(FLIBS)>> ptests\Makefile
echo.>> ptests\Makefile
echo #---------->> ptests\Makefile
echo.>> ptests\Makefile
echo clean :>> ptests\Makefile
echo 	-$(RM) *.$(O)>> ptests\Makefile
echo.>> ptests\Makefile
echo allclean : clean>> ptests\Makefile
echo 	-$(RM) *.exe>> ptests\Makefile
echo 	-$(RM) *.pdb *.ilk>> ptests\Makefile
echo 	-$(RM) *.cgns *.cgio>> ptests\Makefile

rem ----- create cgsntools\Makefile

:cgnstools
if not exist cgnstools\nul goto done

echo creating cgsntools\Makefile
echo # nmake makefile for the CGNS tools under Windows> cgnstools\Makefile
echo.>> cgnstools\Makefile
echo DOMAKE = nmake /nologo /f Makefile.win>> cgnstools\Makefile
echo !include ..\make.defs>> cgnstools\Makefile
echo.>> cgnstools\Makefile
echo defaults : cgnsview cgnscalc cgnsplot utilities>> cgnstools\Makefile
echo install : install-config install-cgnsview install-cgnscalc \>> cgnstools\Makefile
echo 	install-cgnsplot install-utilities>> cgnstools\Makefile
echo.>> cgnstools\Makefile
echo all : cgnsview cgnscalc cgnsplot utilities>> cgnstools\Makefile
echo install-all : install-config install-cgnsview install-cgnscalc \>> cgnstools\Makefile
echo 	install-cgnsplot install-utilities>> cgnstools\Makefile
echo.>> cgnstools\Makefile
echo clean :>> cgnstools\Makefile
echo 	cd cgnsview ^&^& $(DOMAKE) clean>> cgnstools\Makefile
echo 	cd cgnscalc ^&^& $(DOMAKE) clean>> cgnstools\Makefile
echo 	cd cgnsplot ^&^& $(DOMAKE) clean>> cgnstools\Makefile
echo 	cd utilities ^&^& $(DOMAKE) clean>> cgnstools\Makefile
echo 	cd calclib ^&^& $(DOMAKE) clean>> cgnstools\Makefile
echo 	cd tkogl ^&^& $(DOMAKE) clean>> cgnstools\Makefile
echo.>> cgnstools\Makefile
echo distclean : clean>> cgnstools\Makefile
echo 	-del make.win Makefile cgconfig.bat>> cgnstools\Makefile
echo.>> cgnstools\Makefile
echo cgnsview  : prog-cgnsview>> cgnstools\Makefile
echo cgnscalc  : prog-cgnscalc>> cgnstools\Makefile
echo cgnsplot  : prog-cgnsplot>> cgnstools\Makefile
echo utilities : prog-utilities>> cgnstools\Makefile
echo.>> cgnstools\Makefile
echo prog-cgnsview :>> cgnstools\Makefile
echo 	cd cgnsview ^&^& $(DOMAKE)>> cgnstools\Makefile
echo.>> cgnstools\Makefile
echo prog-cgnscalc : lib-calclib>> cgnstools\Makefile
echo 	cd cgnscalc ^&^& $(DOMAKE)>> cgnstools\Makefile
echo.>> cgnstools\Makefile
echo prog-cgnsplot : lib-tkogl>> cgnstools\Makefile
echo 	cd cgnsplot ^&^& $(DOMAKE)>> cgnstools\Makefile
echo.>> cgnstools\Makefile
echo prog-utilities : lib-calclib>> cgnstools\Makefile
echo 	cd utilities ^&^& $(DOMAKE)>> cgnstools\Makefile
echo.>> cgnstools\Makefile
echo lib-calclib :>> cgnstools\Makefile
echo 	cd calclib ^&^& $(DOMAKE)>> cgnstools\Makefile
echo.>> cgnstools\Makefile
echo lib-tkogl :>> cgnstools\Makefile
echo 	cd tkogl ^&^& $(DOMAKE)>> cgnstools\Makefile
echo.>> cgnstools\Makefile
echo install-config : $(BINDIR)>> cgnstools\Makefile
echo 	$(INSTALL) cgconfig.bat $(BINDIR)>> cgnstools\Makefile
echo.>> cgnstools\Makefile
echo $(BINDIR) : $(INSTALLDIR)>> cgnstools\Makefile
echo 	-mkdir $(BINDIR)>> cgnstools\Makefile
echo.>> cgnstools\Makefile
echo $(INSTALLDIR) :>> cgnstools\Makefile
echo 	-mkdir $(INSTALLDIR)>> cgnstools\Makefile
echo.>> cgnstools\Makefile
echo install-cgnsview :>> cgnstools\Makefile
echo 	cd cgnsview ^&^& $(DOMAKE) install>> cgnstools\Makefile
echo.>> cgnstools\Makefile
echo install-cgnscalc : lib-calclib>> cgnstools\Makefile
echo 	cd cgnscalc ^&^& $(DOMAKE) install>> cgnstools\Makefile
echo.>> cgnstools\Makefile
echo install-cgnsplot : lib-tkogl>> cgnstools\Makefile
echo 	cd cgnsplot ^&^& $(DOMAKE) install>> cgnstools\Makefile
echo.>> cgnstools\Makefile
echo install-utilities : lib-calclib>> cgnstools\Makefile
echo 	cd utilities ^&^& $(DOMAKE) install>> cgnstools\Makefile

rem ----- create cgnstools\make.win

echo creating cgnstools\make.win
echo # makefile include for %windir%> cgnstools\make.win
echo.>> cgnstools\make.win
echo #------------------------------------------------------->> cgnstools\make.win
echo # CGNS setup>> cgnstools\make.win
echo #------------------------------------------------------->> cgnstools\make.win
echo.>> cgnstools\make.win
echo CGNSDIR  = ..\..>> cgnstools\make.win
echo !include $(CGNSDIR)\make.defs>> cgnstools\make.win
echo CGNSLIB  = $(CGNSDIR)\$(LIBCGNS)>> cgnstools\make.win
echo.>> cgnstools\make.win
echo SHAREDIR = $(INSTALLDIR)\share>> cgnstools\make.win
echo.>> cgnstools\make.win
echo #------------------------------------------------------->> cgnstools\make.win
echo # linker options>> cgnstools\make.win
echo #------------------------------------------------------->> cgnstools\make.win
echo.>> cgnstools\make.win
echo LINK   = link>> cgnstools\make.win
echo LFLAGS = /nologo %lopts%>> cgnstools\make.win
echo.>> cgnstools\make.win
echo #------------------------------------------------------->> cgnstools\make.win
echo # path to the standard Tcl/Tk includes and libraries>> cgnstools\make.win
echo # the include path needs to include tcl.h, tk.h,>> cgnstools\make.win
echo # tkWinInt.h and the X11 include subdirectory>> cgnstools\make.win
echo #------------------------------------------------------->> cgnstools\make.win
echo.>> cgnstools\make.win
echo TCLINC = %tclinc%>> cgnstools\make.win
echo TCLLIB = %tcllib%>> cgnstools\make.win
echo TKLIB  = %tklib%>> cgnstools\make.win
echo.>> cgnstools\make.win
echo #------------------------------------------------------->> cgnstools\make.win
echo # TKOGLINCS give the include directories>> cgnstools\make.win
echo # TKOGLLIB is the library relative to cgnsplot directory>> cgnstools\make.win
echo #------------------------------------------------------->> cgnstools\make.win
echo.>> cgnstools\make.win
echo TKOGLINCS = $(TCLINC)>> cgnstools\make.win
echo TKOGLLIB  = ..\tkogl\tkogl.lib>> cgnstools\make.win
echo.>> cgnstools\make.win
echo #---------------------------------------------------------->> cgnstools\make.win
echo # compile options for cgnsplot>> cgnstools\make.win
echo #    -DNO_MESH_BOUNDARIES - no structured mesh boundaries>> cgnstools\make.win
echo #    -DNO_CUTTING_PLANE   - no cutting plane>> cgnstools\make.win
echo #---------------------------------------------------------->> cgnstools\make.win
echo.>> cgnstools\make.win
echo PLOTOPTS = %plotopts%>> cgnstools\make.win
echo.>> cgnstools\make.win
echo #------------------------------------------------------->> cgnstools\make.win
echo # set to trap math errors in calculator>> cgnstools\make.win
echo #------------------------------------------------------->> cgnstools\make.win
echo.>> cgnstools\make.win
echo MATHERR = /DUSE_MATHERR>> cgnstools\make.win
echo.>> cgnstools\make.win
echo #------------------------------------------------------->> cgnstools\make.win
echo # windows libraries>> cgnstools\make.win
echo #------------------------------------------------------->> cgnstools\make.win
echo.>> cgnstools\make.win
echo dlllibs = gdi32.lib comdlg32.lib>> cgnstools\make.win
echo.>> cgnstools\make.win
echo guilibs	= %mslib% oldnames.lib kernel32.lib advapi32.lib \>> cgnstools\make.win
echo 	user32.lib gdi32.lib comdlg32.lib winspool.lib>> cgnstools\make.win
echo.>> cgnstools\make.win
echo ogllibs = opengl32.lib glu32.lib>> cgnstools\make.win
if not "%winhtml%" == "" (
echo.>> cgnstools\make.win
echo #---------------------------------------------------------->> cgnstools\make.win
echo # build tools with HTMLhelp>> cgnstools\make.win
echo #---------------------------------------------------------->> cgnstools\make.win
echo.>> cgnstools\make.win
echo WINHTML_OPT = /DUSE_HTMLHELP>> cgnstools\make.win
echo WINHTML_OBJ = winhtml.obj>> cgnstools\make.win
echo WINHTML_INC = /I%winhtml%\include>> cgnstools\make.win
echo WINHTML_LIB = %winhtml%\lib\htmlhelp.lib>> cgnstools\make.win
)

rem ----- create cgconfig.bat

echo creating cgnstools\cgconfig.bat
echo rem configuration file for windows> cgnstools\cgconfig.bat
echo.>> cgnstools\cgconfig.bat
echo set CG_BIN_DIR=%instdir%\bin>> cgnstools\cgconfig.bat
echo set CG_LIB_DIR=%instdir%\share>> cgnstools\cgconfig.bat
if %target% == dll echo set PATH=%instdir%\lib;%%PATH%%>> cgnstools\cgconfig.bat
if exist %tcldir%\bin\nul (
echo set PATH=%tcldir%\bin;%%PATH%%>> cgnstools\cgconfig.bat
) else (
echo rem may need to add location of tcl/tk dlls to PATH>> cgnstools\cgconfig.bat
echo rem PATH=%tcldir%\bin;%%PATH%%>> cgnstools\cgconfig.bat
)
echo.>> cgnstools\cgconfig.bat
echo rem may need to set these if system can't find Tcl and TK scripts>> cgnstools\cgconfig.bat
echo rem set TCL_LIBRARY=c:/lib/tcl8.4.13/library>> cgnstools\cgconfig.bat
echo rem set TK_LIBRARY=c:/lib/tk8.4.13/library>> cgnstools\cgconfig.bat

:done
endlocal

#!/bin/sh

# sh script to launch CGNS plot

dir=`dirname $0`

# source the setup script

for d in $dir $dir/cgnstools $dir/.. ; do
  if test -f $d/cgconfig ; then
    . $d/cgconfig
    break
  fi
done

# get the plotwish executable

plotwish=""
for d in $CG_BIN_DIR $dir $dir/cgnstools $dir/cgnsplot \
         /usr/local/bin /usr/local/bin/cgnstools ; do
  if test -x $d/plotwish ; then
    plotwish=$d/plotwish
    break
  fi
  if test -x $d/cgnswish/plotwish ; then
    plotwish=$d/cgnswish/plotwish
    break
  fi
done
if test -z "$plotwish" ; then
  echo "Error: plotwish executable not found"
  exit 1
fi

# find the cgnsplot tcl script

cgnsplot=""
for d in $CG_LIB_DIR $dir $dir/cgnstools $dir/cgnsplot \
         $dir/../share/cgnstools \
         /usr/local/share /usr/local/share/cgnstools ; do
  if test -f $d/cgnsplot.tcl ; then
    cgnsplot=$d/cgnsplot.tcl
    break
  fi
done
if test -z "$cgnsplot" ; then
  echo "Error: cgnsplot.tcl script not found"
  exit 1
fi

# check that display is set

#if test -z "$DISPLAY" ; then
#  echo "Error: DISPLAY environment variable not set"
#  exit 1
#fi

# execute

if test "$#" = 0 ; then
  exec $plotwish $cgnsplot
else
  exec $plotwish $cgnsplot "$@"
fi

#! /bin/bash
NO_COLOR="\033[0m"
OK_COLOR="\033[32;01m"
ERROR_COLOR="\033[31;01m"

echoresults() {
    padlimit=40
    pad=$(printf '%*s' "$padlimit")
    pad=${pad// /.}
    padlength=40
    printf ' %*.*s' 0 $((padlength - ${#x} )) "$pad"
    if test $status -ne 0
    then
        printf " [${ERROR_COLOR}FAILED${NO_COLOR}]\n"
        status=1
    else
	printf " [${OK_COLOR}PASSED${NO_COLOR}]"
        printf "%+12s\n" "$itime"
    fi
}
TIMING_AVAIL=$(/usr/bin/time -a -o CGNS_timing.txt -f "%e" pwd > /dev/null; echo $?)

run_tests() {
    printf "%-40s \n" "Testing $dir..."
    cd "$dir"
    # loop through tests
    size_arr=${#w_arr[@]} #Number of elements in the array
    itime=""
    for i in $(seq 1 $size_arr);do
        x="   Program: ${w_arr[$i-1]}"
        printf "$x"
        if [ "$TIMING_AVAIL" = "0" ]; then
            /usr/bin/time -a -o ../CGNS_timing.txt -f "$dir.${w_arr[$i-1]} %e" "./${w_arr[$i-1]}" >/dev/null 2>&1
            itime=$(tail -n1 ../CGNS_timing.txt |  awk  '{print $2}' | sed -e 's/$/ sec/')
        else
            "./${w_arr[$i-1]}" >/dev/null 2>&1
        fi
        status=$?
        echoresults
        return_val=$((status + return_val))

        x="   Program: ${r_arr[$i-1]}"
        printf "$x"
        if [ "$TIMING_AVAIL" = "0" ]; then
            /usr/bin/time -a -o ../CGNS_timing.txt -f "$dir.${r_arr[$i-1]} %e" "./${r_arr[$i-1]}" > "build/output$i"
            itime=$(tail -n1 ../CGNS_timing.txt |  awk  '{print $2}' | sed -e 's/$/ sec/')
        else
            "./${r_arr[$i-1]}" > "build/output$i"
        fi
        diff <( sed '/Library/ d' "build/output$i") <( sed '/Library/ d' "./OUTPUT$i") > "build/results$i.txt"
        status=$?
        echoresults
        return_val=$((status + return_val))
    done
    cd ..
}

return_val=0
rm -f CGNS_timing.txt

###############################
# Special cases
###############################

## declare an array of tests
declare -a w_arr=("write_grid_str" "write_flowvert_str" "write_nondimensional" "write_descriptor" \
	"write_convergence" "write_floweqn_str" "write_bcpnts_str")
declare -a r_arr=("read_grid_str" "read_flowvert_str" "read_nondimensional" "read_descriptor" \
	"read_convergence" "read_floweqn_str" "read_bcpnts_str")

dir=Test_Grid_Str

run_tests

###############################

## declare an array of tests
declare -a w_arr=("write_grid_unst" "write_flowvert_unst" "write_dimensional" "write_descriptor" "write_convergence" "write_bcpnts_unst")
declare -a r_arr=("read_grid_unst" "read_flowvert_unst" "read_dimensional" "read_descriptor" "read_convergence" "read_bcpnts_unst")

dir=Test_Grid_Unstr

run_tests

###############################

## declare an array of tests
declare -a w_arr=("write_grid_str" "write_timevert_str")
declare -a r_arr=("read_grid_str" "read_timevert_str")

dir=Test_Grid_Str_Timeacc

run_tests

###############################

## declare an array of tests
declare -a w_arr=("write_grid_str" "write_flowcent_str" "write_bc_str")
declare -a r_arr=("read_grid_str" "read_flowcent_str" "read_bc_str")

dir=Test_Grid_Str_FlowCent

run_tests

###############################

## declare an array of tests
declare -a w_arr=("write_grid_str" "write_flowcentrind_str")
declare -a r_arr=("read_grid_str" "read_flowcentrind_str")

dir=Test_Grid_Str_FlowCentRind
 
run_tests

###############################

## declare an array of tests
declare -a w_arr=("write_grid2zn_str" "write_con2zn_str")
declare -a r_arr=("read_grid2zn_str" "read_con2zn_str")

dir=Test_Grid_Str_2zn

run_tests

###############################

## declare an array of tests
declare -a w_arr=("write_grid2zn_str" "write_con2zn_genrl_str")
declare -a r_arr=("read_grid2zn_str" "read_con2zn_genrl_str")

dir=Test_Grid_Str_2zngenrl

run_tests

###############################

echo "=== finished ==="
if test $return_val != 0; then
  printf "$ERROR_COLOR"
else
  printf "$OK_COLOR"
fi
printf "$return_val tests failed $NO_COLOR \n"
exit $return_val

#!/bin/sh
#
# Builds and tests CGNS for travis CI.
#
cd src
make
make install
cd tests
make
make test
cd ../examples/fortran
make
make test
cd ../../Test_UserGuideCode/Fortran_code
make
make test
cd ../C_code
make
make test

#!/bin/bash

# SPDX-FileCopyrightText: 2020 Intel Corporation
#
# SPDX-License-Identifier: MIT

#shellcheck disable=SC2010
LATEST_VERSION=$(ls -1 /opt/intel/oneapi/compiler/ | grep -v latest | sort | tail -1)

sudo rm -rf /opt/intel/oneapi/compiler/"$LATEST_VERSION"/linux/compiler/lib/ia32_lin
sudo rm -rf /opt/intel/oneapi/compiler/"$LATEST_VERSION"/linux/bin/ia32
sudo rm -rf /opt/intel/oneapi/compiler/"$LATEST_VERSION"/linux/lib/emu
sudo rm -rf /opt/intel/oneapi/compiler/"$LATEST_VERSION"/linux/lib/oclfpga

@echo off
setlocal

rem the standard wish command will work for this
rem set wish=c:\progra~1\tcl\bin\wish83.exe

set dir=%~dps0
if exist %dir%cgconfig.bat (
  call %dir%cgconfig.bat
  goto getwish
)
if exist %dir%..\cgconfig.bat call %dir%..\cgconfig.bat

:getwish
if "%CG_BIN_DIR%" == "" set CG_BIN_DIR=%dir%

if not "%wish%" == "" goto getscript
if exist %dir%cgiowish.exe (
  set wish=%dir%cgiowish.exe
  goto getscript
)
if exist %dir%cgnstools\cgiowish.exe (
  set wish=%dir%cgnstools\cgiowish.exe
  goto getscript
)
echo cgiowish.exe not found
pause
goto done

:getscript
if exist %dir%cgnsnodes.tcl (
  set script=%dir%cgnsnodes.tcl
  goto run
)
if not "%CG_LIB_DIR%" == "" (
  if exist %CG_LIB_DIR%\cgnsnodes.tcl (
    set script=%CG_LIB_DIR%\cgnsnodes.tcl
    goto run
  )
)
if exist %dir%..\share\cgnsnodes.tcl (
  if "%CG_LIB_DIR%" == "" set CG_LIB_DIR=%dir%..\share
  set script=%dir%..\share\cgnsnodes.tcl
  goto run
)
echo cgnsnodes.tcl not found
pause
goto done

:run
start /b %wish% %script% %1

:done
endlocal

#! /bin/bash
NO_COLOR="\033[0m"
OK_COLOR="\033[32;01m"
ERROR_COLOR="\033[31;01m"

echoresults() {
    padlimit=40
    pad=$(printf '%*s' "$padlimit")
    pad=${pad// /.}
    padlength=40
    printf ' %*.*s' 0 $((padlength - ${#x} )) "$pad"
    if test $status -ne 0
    then
        printf " [${ERROR_COLOR}FAILED${NO_COLOR}]\n"
        status=1
    else
	printf " [${OK_COLOR}PASSED${NO_COLOR}]"
        printf "%+12s\n" "$itime"
    fi
}

TIMING_AVAIL=$(/usr/bin/time -a -o CGNS_timing.txt -f "%e" pwd > /dev/null; echo $?)

DIRS="Test1 \
	Test_1to1ConnProp \
	Test_Axisym \
	Test_BCProperty \
	Test_chemistry \
	Test_ConnProperty \
	Test_EM \
	Test_Family \
	Test_Gravity \
	Test_Links \
	Test_mixed_elements \
	Test_mixed_grid \
	Test_motion \
	Test_PartRdWr \
	Test_RotatingCoordinates \
	Test_UD_BCData \
	Test_UserDefinedData"

return_val=0
rm -f CGNS_timing.txt

echo ""
echo "=== running tests ==="; \
for dir in $DIRS;do
    printf "%-40s \n" "Testing $dir..."
    cd $dir
    x="   Program: cgwrite"
    printf "$x"
    itime=""
    if [ "$TIMING_AVAIL" = "0" ]; then
        /usr/bin/time -a -o ../CGNS_timing.txt -f "$dir.cgwrite %e" ./cgwrite >/dev/null 2>&1
        itime=$(tail -n1 ../CGNS_timing.txt |  awk  '{print $2}' | sed -e 's/$/ sec/')
    else
        ./cgwrite >/dev/null 2>&1
    fi
    status=$?
    echoresults
    return_val=$((status + return_val))

    x="   Program: cgread"
    printf "$x"
    if [ "$TIMING_AVAIL" = "0" ]; then
        /usr/bin/time -a -o ../CGNS_timing.txt -f "$dir.cgread %e" ./cgread > build/output
        itime=$(tail -n1 ../CGNS_timing.txt |  awk  '{print $2}' | sed -e 's/$/ sec/')
    else
        ./cgread > build/output
    fi
    diff <( sed '/Library/ d' build/output | sed '/DonorDatatype/ d' | sed '/datatype=/ d') <( sed '/Library/ d' ./OUTPUT | sed '/DonorDatatype/ d' | sed '/datatype=/ d') > build/results.txt
#   diff -I 'Library Version used for file creation*' -I 'DonorDatatype' -I 'datatype=' output ./OUTPUT > results.txt
    status=$?
    echoresults $status
    return_val=$((status + return_val))
    cd ..
done

###############################
# Special cases
###############################

dir=Test_cgio
printf "%-40s \n" "Testing $dir..."
cd $dir
x="   Program: cgiotest"
printf "$x"
if [ "$TIMING_AVAIL" = "0" ]; then
    /usr/bin/time -a -o ../CGNS_timing.txt -f "$dir.cgiotest %e" ./cgiotest > build/output
else
    ./cgiotest > build/output
fi
diff <( sed '/Library/ d' build/output) <( sed '/Library/ d' ./OUTPUT) > build/results.txt
#diff -I 'Library Version used for file creation*' output ./OUTPUT > results.txt
status=$?
echoresults $status
return_val=$((status + return_val))
cd ..

###############################

echo "=== finished ==="
if test $return_val != 0; then
  printf "$ERROR_COLOR"
else
  printf "$OK_COLOR"
fi
printf "$return_val tests failed $NO_COLOR \n"
exit $return_val

#PBS -S /bin/csh
#PBS -l select=1024:ncpus=16:mpiprocs=16:model=san
#PBS -l walltime=00:15:00
#PBS -j oe
#PBS -q low
#PBS -W group_list=a1519

module load mpi-sgi/mpt.2.12r26 
module load comp-intel/2016.2.181

# By default, PBS executes your job from your home directory.
# However, you can use the environment variable
# PBS_O_WORKDIR to change to the directory where
# you submitted your job.

cd $PBS_O_WORKDIR

mpiexec_mpt ./benchmark_hdf5

# -end of script-

#!/bin/sh

# sh script to launch CGNS calculator

dir=`dirname $0`

# source the setup script

for d in $dir $dir/cgnstools $dir/.. ; do
  if test -f $d/cgconfig ; then
    . $d/cgconfig
    break
  fi
done

# get the calcwish executable

calcwish=""
for d in $CG_BIN_DIR $dir $dir/cgnstools $dir/cgnscalc \
         /usr/local/bin /usr/local/bin/cgnstools ; do
  if test -x $d/calcwish ; then
    calcwish=$d/calcwish
    break
  fi
  if test -x $d/cgnswish/calcwish ; then
    calcwish=$d/cgnswish/calcwish
    break
  fi
done
if test -z "$calcwish" ; then
  echo "Error: calcwish executable not found"
  exit 1
fi

# find the cgnscalc tcl script

cgnscalc=""
for d in $CG_LIB_DIR $dir $dir/cgnstools $dir/cgnscalc \
         /usr/local/share /usr/local/share/cgnstools ; do
  if test -f $d/cgnscalc.tcl ; then
    cgnscalc=$d/cgnscalc.tcl
    break
  fi
done
if test -z "$cgnscalc" ; then
  echo "Error: cgnscalc.tcl script not found"
  exit 1
fi

# check that display is set

#if test -z "$DISPLAY" ; then
#  echo "Error: DISPLAY environment variable not set"
#  exit 1
#fi

# execute

if test "$#" = 0 ; then
  exec $calcwish $cgnscalc
else
  exec $calcwish $cgnscalc "$@"
fi

@echo off
setlocal

set dir=%~dps0
if exist %dir%cgconfig.bat (
  call %dir%cgconfig.bat
  goto getwish
)
if exist %dir%..\cgconfig.bat call %dir%..\cgconfig.bat

:getwish
if "%CG_BIN_DIR%" == "" set CG_BIN_DIR=%dir%

if exist %dir%calcwish.exe (
  set wish=%dir%calcwish.exe
  goto getscript
)
if exist %dir%cgnstools\calcwish.exe (
  set wish=%dir%cgnstools\calcwish.exe
  goto getscript
)
echo calcwish.exe not found
pause
goto done

:getscript
if exist %dir%cgnscalc.tcl (
  set script=%dir%cgnscalc.tcl
  goto run
)
if not "%CG_LIB_DIR%" == "" (
  if exist %CG_LIB_DIR%\cgnscalc.tcl (
    set script=%CG_LIB_DIR%\cgnscalc.tcl
    goto run
  )
)
if exist %dir%..\share\cgnscalc.tcl (
  if "%CG_LIB_DIR%" == "" set CG_LIB_DIR=%dir%..\share
  set script=%dir%..\share\cgnscalc.tcl
  goto run
)
echo cgnscalc.tcl not found
pause
goto done

:run
start /b %wish% %script% %1

:done
endlocal

#!/bin/sh

# sh script to launch CGNS File viewer/editor

dir=`dirname $0`

# To let other tools access the file while cgnsview is running
export HDF5_USE_FILE_LOCKING="FALSE"

# source the setup script

for d in $dir $dir/cgnstools $dir/.. ; do
  if test -f $d/cgconfig ; then
    . $d/cgconfig
    break
  fi
done

# get the cgiowish executable

cgiowish=""
for d in $CG_BIN_DIR $dir $dir/cgnstools $dir/cgnsview \
         /usr/local/bin /usr/local/bin/cgnstools ; do
  if test -x $d/cgiowish ; then
    cgiowish=$d/cgiowish
    break
  fi
  if test -x $d/cgnswish/cgiowish ; then
    cgiowish=$d/cgnswish/cgiowish
    break
  fi
done
if test -z "$cgiowish" ; then
  echo "Error: cgiowish executable not found"
  exit 1
fi

# find the cgnsview tcl script

cgnsview=""
for d in $CG_LIB_DIR $dir $dir/cgnstools $dir/cgnsview \
         $dir/../share/cgnstools \
         /usr/local/share /usr/local/share/cgnstools ; do
  if test -f $d/cgnsview.tcl ; then
    cgnsview=$d/cgnsview.tcl
    break
  fi
done
if test -z "$cgnsview" ; then
  echo "Error: cgnsview.tcl script not found"
  exit 1
fi

# check that display is set

#if test -z "$DISPLAY" ; then
#  echo "Error: DISPLAY environment variable not set"
#  exit 1
#fi

# execute

if test "$#" = 0 ; then
  exec $cgiowish $cgnsview
else
  exec $cgiowish $cgnsview "$@"
fi

#! /bin/bash
NO_COLOR="\033[0m"
OK_COLOR="\033[32;01m"
ERROR_COLOR="\033[31;01m"

echoresults() {
    padlimit=40
    pad=$(printf '%*s' "$padlimit")
    pad=${pad// /.}
    padlength=40
    printf ' %*.*s' 0 $((padlength - ${#x} )) "$pad"
    if test $status -ne 0
    then
        printf " [${ERROR_COLOR}FAILED${NO_COLOR}]\n"
        status=1
    else
	printf " [${OK_COLOR}PASSED${NO_COLOR}]"
        printf "%+12s\n" "$itime"
    fi
}

TIMING_AVAIL=$(/usr/bin/time -a -o CGNS_timing.txt -f "%e" pwd > /dev/null; echo $?)

run_tests() {
    printf "%-40s \n" "Testing $dir..."
    cd "$dir"
    # loop through tests
    size_arr=${#w_arr[@]} #Number of elements in the array
    itime=""
    for i in $(seq 1 $size_arr);do
        x="   Program: ${w_arr[$i-1]}"
        printf "$x"
        if [ "$TIMING_AVAIL" = "0" ]; then
            /usr/bin/time -a -o ../CGNS_timing.txt -f "$dir.${w_arr[$i-1]} %e" "./${w_arr[$i-1]}" >/dev/null 2>&1
            itime=$(tail -n1 ../CGNS_timing.txt |  awk  '{print $2}' | sed -e 's/$/ sec/')
        else
            "./${w_arr[$i-1]}" >/dev/null 2>&1
        fi
        status=$?
        echoresults
        return_val=$((status + return_val))

        x="   Program: ${r_arr[$i-1]}"
        printf "$x"
        if [ "$TIMING_AVAIL" = "0" ]; then
            /usr/bin/time -a -o ../CGNS_timing.txt -f "$dir.${r_arr[$i-1]} %e" "./${r_arr[$i-1]}" > "build/output$i"
            itime=$(tail -n1 ../CGNS_timing.txt |  awk  '{print $2}' | sed -e 's/$/ sec/')
        else
            "./${r_arr[$i-1]}" > build/output$i
        fi
        diff <( sed '/Library/ d' "build/output$i") <( sed '/Library/ d' "./OUTPUT$i") > "build/results$i.txt"
        status=$?
        echoresults
        return_val=$((status + return_val))
    done
    cd ..
}

return_val=0
rm -f CGNS_timing.txt

###############################
# Special cases
###############################

## declare an array of tests
declare -a w_arr=("write_grid_str" "write_flowvert_str" "write_nondimensional" "write_descriptor" \
	"write_convergence" "write_floweqn_str" "write_bcpnts_str")
declare -a r_arr=("read_grid_str" "read_flowvert_str" "read_nondimensional" "read_descriptor" \
	"read_convergence" "read_floweqn_str" "read_bcpnts_str")

dir=Test_Grid_Str

run_tests

###############################

## declare an array of tests
declare -a w_arr=("write_grid_unst" "write_flowvert_unst" "write_dimensional" "write_descriptor" "write_convergence" "write_bcpnts_unst")
declare -a r_arr=("read_grid_unst" "read_flowvert_unst" "read_dimensional" "read_descriptor" "read_convergence" "read_bcpnts_unst")

dir=Test_Grid_Unstr

run_tests

###############################

## declare an array of tests
declare -a w_arr=("write_grid_str" "write_timevert_str")
declare -a r_arr=("read_grid_str" "read_timevert_str")

dir=Test_Grid_Str_Timeacc

run_tests

###############################

## declare an array of tests
declare -a w_arr=("write_grid_str" "write_flowcent_str" "write_bc_str")
declare -a r_arr=("read_grid_str" "read_flowcent_str" "read_bc_str")

dir=Test_Grid_Str_FlowCent

run_tests

###############################

## declare an array of tests
declare -a w_arr=("write_grid_str" "write_flowcentrind_str")
declare -a r_arr=("read_grid_str" "read_flowcentrind_str")

dir=Test_Grid_Str_FlowCentRind

run_tests

###############################

## declare an array of tests
declare -a w_arr=("write_grid2zn_str" "write_con2zn_str")
declare -a r_arr=("read_grid2zn_str" "read_con2zn_str")

dir=Test_Grid_Str_2zn

run_tests

###############################

## declare an array of tests
declare -a w_arr=("write_grid2zn_str" "write_con2zn_genrl_str")
declare -a r_arr=("read_grid2zn_str" "read_con2zn_genrl_str")

dir=Test_Grid_Str_2zngenrl

run_tests

###############################

echo "=== finished ==="
if test $return_val != 0; then
  printf "$ERROR_COLOR"
else
  printf "$OK_COLOR"
fi
printf "$return_val tests failed $NO_COLOR \n"
exit $return_val

@echo off
setlocal

set config=0
set help=0
set system=WIN32

:next
if "%1" == "" goto doit
if "%1" == "conf" set config=1
if "%1" == "-conf" set config=1
if "%1" == "configure" set config=1
if "%1" == "-configure" set config=1
if "%1" == "64" set system=WIN64
if "%1" == "-64" set system=WIN64
if "%1" == "64bit" set system=WIN64
if "%1" == "-64bit" set system=WIN64
if "%1" == "help" set help=1
if "%1" == "-help" set help=1
shift
goto next
:doit

if %help% == 0 goto getsys
echo usage: cgsystem [[-]conf[igure]] [[-]64[bit]]
goto done

:getsys
if %config% == 1 goto config
echo %system%
goto done

:config
echo modifying make.system to set SYSTEM=%systen%
echo SYSTEM = %system%> make.system

:done
endlocal

#!/bin/sh

# sh script to launch unit convertor

dir=`dirname $0`

# source the setup script

for d in $dir $dir/cgnstools $dir/.. ; do
  if test -f $d/cgconfig ; then
    . $d/cgconfig
    break
  fi
done

# The normal wish will work here, but calcwish should
# be available, and may also be used

calcwish=""
for d in $CG_BIN_DIR $dir $dir/cgnstools $dir/cgnscalc \
         /usr/local/bin /usr/local/bin/cgnstools ; do
   if test -x $d/calcwish ; then
    calcwish=$d/calcwish
    break
  fi
  if test -x $d/cgnswish/calcwish ; then
    calcwish=$d/cgnswish/calcwish
    break
  fi
done
if test -z "$calcwish" ; then
  echo "Error: calcwish executable not found"
  exit 1
fi

# find the unitconv tcl script

unitconv=""
for d in $CG_LIB_DIR $dir $dir/cgnstools $dir/cgnscalc \
         /usr/local/share /usr/local/share/cgnstools ; do
  if test -f $d/unitconv.tcl ; then
    unitconv=$d/unitconv.tcl
    break
  fi
done

if test -z "$unitconv" ; then
  echo "Error: unitconv.tcl script not found"
  exit 1
fi

# check that display is set

if test -z "$DISPLAY" ; then
  echo "Error: DISPLAY environment variable not set"
  exit 1
fi

# execute

exec $calcwish $unitconv

#!/bin/bash

NO_COLOR="\033[0m"
OK_COLOR="\033[32;01m"
WARN_COLOR="\033[33;01m"
ERROR_COLOR="\033[31;01m"
NOTE_COLOR="\033[36;01m"

#
# Configure CGNS. 
#
set -e
SRC_DIR=$PWD

BUILD=$1
OPTS=$2
HDF5_DIR=$HOME/hdf5
OPTS_CMAKE=""
if [[ "$OPTS" == *"with-fortran"* ]]; then
   OPTS_CMAKE="$OPTS_CMAKE -D CGNS_ENABLE_FORTRAN:BOOL=ON"
else
   OPTS_CMAKE="$OPTS_CMAKE -D CGNS_ENABLE_FORTRAN:BOOL=OFF"
fi
if [[ "$OPTS" == *"with-hdf5"* ]]; then
   OPTS_CMAKE="$OPTS_CMAKE -D CMAKE_PREFIX_PATH=$HDF5_DIR -D CGNS_ENABLE_HDF5:BOOL=ON -D HDF5_NEED_ZLIB:BOOL=OFF -D HDF5_NEED_SZIP:BOOL=OFF"
else
   OPTS_CMAKE="$OPTS_CMAKE -D CGNS_ENABLE_HDF5:BOOL=OFF"
fi
if [[ "$OPTS" == *"enable-cgnstools"* ]]; then
   OPTS="$OPTS --with-tcl=/usr/lib/x86_64-linux-gnu --with-tk=/usr/lib/x86_64-linux-gnu"
   OPTS_CMAKE="$OPTS_CMAKE -D CGNS_BUILD_CGNSTOOLS:BOOL=ON"
else
   OPTS_CMAKE="$OPTS_CMAKE -D CGNS_BUILD_CGNSTOOLS:BOOL=OFF"
fi

if [[ "$OS_NAME" = "linux" ]]; then
  export FLIBS="-Wl,--no-as-needed -ldl"
  export LIBS="-Wl,--no-as-needed -ldl"
# See note in src/ptests/pcgns_ftest.F90 concerning CGNS-109 and Github Actions
  export FCFLAGS="-D DISABLE_CGNS109"

# Do a different test set-up than the autotools build
  OPTS_CMAKE="$OPTS_CMAKE -D CGNS_ENABLE_LEGACY:BOOL=ON -D CGNS_ENABLE_64BIT:BOOL=OFF"
else
  OPTS_CMAKE="$OPTS_CMAKE -D CMAKE_OSX_ARCHITECTURES:STRING=arm64"
fi

if [[ "$BUILD" == "cmake" ]]; then

##########################
# CMAKE CONFIG
##########################

printf "%b\n" "$NOTE_COLOR"
printf "%b" "$NOTE_COLOR" "       ________  ______    __ __ ______\n"
printf "%b" "$NOTE_COLOR" "      / ____/  |/  /   |  / //_// ____/\n"
printf "%b" "$NOTE_COLOR" "     / /   / /|_/ / /| | / ,<  / __/   \n"
printf "%b" "$NOTE_COLOR" "    / /___/ /  / / ___ |/ /| |/ /___   \n"
printf "%b" "$NOTE_COLOR" "    \____/_/  /_/_/  |_/_/ |_/_____/   \n\n"
printf "%b\n" "$NO_COLOR"

cd $SRC_DIR
mkdir cbuild
cd cbuild

cmake \
    ${OPTS_CMAKE} \
    -D CMAKE_C_COMPILER:PATH=$CC \
    -D CMAKE_C_FLAGS:STRING="$CFLAGS" \
    -D CMAKE_BUILD_TYPE:STRING="Debug" \
    -D CMAKE_STATIC_LINKER_FLAGS:STRING="" \
    -D CGNS_ENABLE_TESTS:BOOL=ON \
    -D CGNS_ENABLE_LFS:BOOL=ON \
    -D CMAKE_INSTALL_PREFIX:PATH="./" \
    -D CMAKE_EXE_LINKER_FLAGS:STRING="$CMAKE_EXE_LINKER_FLAGS" \
    ..

else

##########################
# AUTOTOOLS CONFIG
##########################

printf "%b" "$NOTE_COLOR" "       ___   __  ____________  __________  ____  __   _____\n"
printf "%b" "$NOTE_COLOR" "      /   | / / / /_  __/ __ \/_  __/ __ \/ __ \/ /  / ___/\n"
printf "%b" "$NOTE_COLOR" "     / /| |/ / / / / / / / / / / / / / / / / / / /   \__ \ \n"
printf "%b" "$NOTE_COLOR" "    / ___ / /_/ / / / / /_/ / / / / /_/ / /_/ / /______/ / \n"
printf "%b" "$NOTE_COLOR" "   /_/  |_\____/ /_/  \____/ /_/  \____/\____/_____/____/  \n\n"
printf "%b\n" "$NO_COLOR"

cd src
echo "AUTOTOOLS DIR $PWD"

./configure $OPTS \
--prefix=$PWD/cgns_build \
--with-hdf5=$HOME/hdf5 \
--enable-lfs \
--enable-64bit \
--disable-shared \
--enable-debug

fi

#!/bin/sh

# Set odd/even days of the week
day=$(( $(date +%d) % 2 ))

if [ $day -eq 0 ]; then #even day tests, HDF5 1.8 branch

HDF5_VER="hdf5_1_8"

else #odd day tests, HDF5 develop branch

HDF5_VER="develop"

fi

git clone https://bitbucket.hdfgroup.org/scm/hdffv/hdf5.git --branch $HDF5_VER --single-branch $HDF5_VER

cd $HDF5_VER

if [ ! -f configure ]; then
  ./autogen.sh
fi

./configure --disable-fortran --disable-hl --prefix=$HOME/hdf5 && make > result.txt 2>&1 && make install

@echo off
setlocal

set dir=%~dps0
if exist %dir%cgconfig.bat (
  call %dir%cgconfig.bat
  goto getwish
)
if exist %dir%..\cgconfig.bat call %dir%..\cgconfig.bat

:getwish
if "%CG_BIN_DIR%" == "" set CG_BIN_DIR=%dir%

if exist %dir%plotwish.exe (
  set wish=%dir%plotwish.exe
  goto getscript
)
if exist %dir%cgnstools\plotwish.exe (
  set wish=%dir%cgnstools\plotwish.exe
  goto getscript
)
echo plotwish.exe not found
pause
goto done

:getscript
if exist %dir%cgnsplot.tcl (
  set script=%dir%cgnsplot.tcl
  goto run
)
if not "%CG_LIB_DIR%" == "" (
  if exist %CG_LIB_DIR%\cgnsplot.tcl (
    set script=%CG_LIB_DIR%\cgnsplot.tcl
    goto run
  )
)
if exist %dir%..\share\cgnsplot.tcl (
  set CG_LIB_DIR=%dir%..\share
  set script=%dir%..\share\cgnsplot.tcl
  goto run
)
echo cgnsplot.tcl not found
pause
goto done

:run
start /b %wish% %script% %1

:done
endlocal

#PBS -S /bin/csh
#PBS -l select=4:ncpus=16:mpiprocs=16:model=san
#PBS -l walltime=01:00:00
#PBS -j oe
#PBS -q debug
#PBS -W group_list=a1519

module purge
module load comp-intel/2015.0.090
module load mpi-intel/5.0.1.035

# By default, PBS executes your job from your home directory.
# However, you can use the environment variable
# PBS_O_WORKDIR to change to the directory where
# you submitted your job.

cd $PBS_O_WORKDIR

#mpiexec_mpt ./benchmark_hdf5

/nasa/intel/impi/5.0.1.035/bin64/mpiexec.hydra -env I_MPI_EXTRA_FILESYSTEM on -env I_MPI_EXTRA_FILESYSTEM_LIST lustre ./benchmark_hdf5

# -end of script-

@echo off
setlocal

set dir=%~dps0
if not exist %dir%cgnsconvert.exe goto notfound

rem -- for path setting to dlls
if exist %dir%..\cgconfig.bat call %dir%..\cgconfig.bat
if exist %dir%cgconfig.bat call %dir%cgconfig.bat

set links=
if "%1" == "-links" (
  set links=-l
  shift
)

%dir%cgnsconvert -a %links% %1 %2
goto done

:notfound
echo cgnsconvert.exe not found in %dir%
:done
endlocal

#!/bin/sh
#trunk
#svn co https://svn.hdfgroup.uiuc.edu/hdf5/trunk
#cd trunk && ./autogen.sh ./configure --disable-fortran --disable-hl CC=gcc && make && make install
if [ $TRAVIS_OS_NAME = "osx" ]; then
  export CC=gcc-4.9
else
  export CC=gcc
fi
# 1.8 branch
svn co -q https://svn.hdfgroup.uiuc.edu/hdf5/branches/hdf5_1_8
cd hdf5_1_8 && ./configure --disable-fortran --disable-hl --prefix=$HOME/hdf5 && make > result.txt 2>&1 && make install

@echo off
setlocal

set HDF5_USE_FILE_LOCKING="FALSE"
set dir=%~dps0
if exist "%dir%cgconfig.bat" (
  call %dir%cgconfig.bat
  goto getwish
)
if exist "%dir%..\cgconfig.bat" call "%dir%..\cgconfig.bat"

:getwish
if "%CG_BIN_DIR%" == "" set CG_BIN_DIR=%dir%

if exist "%dir%cgiowish.exe" (
  set wish=%dir%cgiowish.exe
  goto getscript
)
if exist "%dir%cgnstools\cgiowish.exe" (
  set wish=%dir%cgnstools\cgiowish.exe
  goto getscript
)
echo cgiowish.exe not found
pause
goto done

:getscript
if exist "%dir%cgnsview.tcl" (
  set script=%dir%cgnsview.tcl
  goto run
)
if not "%CG_LIB_DIR%" == "" (
  if exist "%CG_LIB_DIR%\cgnsview.tcl" (
    set script=%CG_LIB_DIR%\cgnsview.tcl
    goto run
  )
)
if exist "%dir%..\share\cgnsview.tcl" (
  if "%CG_LIB_DIR%" == "" set CG_LIB_DIR=%dir%..\share
  set script=%dir%..\share\cgnsview.tcl
  goto run
)
echo cgnsview.tcl not found
pause
goto done

:run
start "" /b "%wish%"  "%script%" %1

:done
endlocal

@echo off
setlocal
if "%1" == "" (
  echo usage: runtest exename
  goto done
)
set PATH=..\lib;%PATH%
%1 > nul 2>&1
if %ERRORLEVEL% == 0 (
  echo %1 ... passed
) else (
  echo %1 ... *** FAILED ***
)
:done
endlocal

@echo off
setlocal

set dir=%~dps0
if not exist %dir%cgnsconvert.exe goto notfound

rem -- for path setting to dlls
if exist %dir%..\cgconfig.bat call %dir%..\cgconfig.bat
if exist %dir%cgconfig.bat call %dir%cgconfig.bat

set links=
if "%1" == "-links" (
  set links=-l
  shift
)

%dir%cgnsconvert -h %links% %1 %2
goto done

:notfound
echo cgnsconvert.exe not found in %dir%
:done
endlocal

@echo off
setlocal

rem the standard wish command will work for this
rem set wish=c:\progra~1\tcl\bin\wish83.exe

set dir=%~dps0
if exist %dir%cgconfig.bat (
  call %dir%cgconfig.bat
  goto getwish
)
if exist %dir%..\cgconfig.bat call %dir%..\cgconfig.bat

:getwish
if not "%wish%" == "" goto getscript
if exist %dir%calcwish.exe (
  set wish=%dir%calcwish.exe
  goto getscript
)
if exist %dir%cgnstools\calcwish.exe (
  set wish=%dir%cgnstools\calcwish.exe
  goto getscript
)
if exist %dir%cgiowish.exe (
  set wish=%dir%cgiowish.exe
  goto getscript
)
if exist %dir%cgnstools\cgiowish.exe (
  set wish=%dir%cgnstools\cgiowish.exe
  goto getscript
)
echo calcwish.exe or cgiowish.exe not found
pause
goto done

:getscript
if exist %dir%unitconv.tcl (
  set script=%dir%unitconv.tcl
  goto run
)
if not "%CG_LIB_DIR%" == "" (
  if exist %CG_LIB_DIR%\unitconv.tcl (
    set script=%CG_LIB_DIR%\unitconv.tcl
    goto run
  )
)
if exist %dir%..\share\unitconv.tcl (
  set CG_LIB_DIR=%dir%..\share
  set script=%dir%..\share\unitconv.tcl
  goto run
)
echo unitconv.tcl not found
pause
goto done

:run
start /b %wish% %script% %1

:done
endlocal

#!/bin/bash

# SPDX-FileCopyrightText: 2020 Intel Corporation
#
# SPDX-License-Identifier: MIT

LANGUAGE=$1
SAMPLES_TAG=$2

git clone --depth 1 --branch "$SAMPLES_TAG" https://github.com/oneapi-src/oneAPI-samples.git

#shellcheck disable=SC2010
LATEST_VERSION=$(ls -1 /opt/intel/oneapi/compiler/ | grep -v latest | sort | tail -1)
# shellcheck source=/dev/null
source /opt/intel/oneapi/compiler/"$LATEST_VERSION"/env/vars.sh
sycl-ls

case $LANGUAGE in
c++)
  cd oneAPI-samples/DirectProgramming/C++/CompilerInfrastructure/Intrinsics
  make && make run && make clean && make CC='icx -msse3' && make run
  ;;
fortran)
  cd oneAPI-samples/DirectProgramming/Fortran/CombinationalLogic/openmp-primes
  make && make run && make clean && make FC=ifx && make run
  ;;
dpc++)
  cd oneAPI-samples/DirectProgramming/C++SYCL/DenseLinearAlgebra/simple-add
  mkdir build && cd build && cmake .. && make cpu-gpu
  # Sample has additional HW prerequisites. Please check sample Readme for details. Uncomment the following if the prerequisites are met.
  # mkdir build && cd build && cmake .. && make cpu-gpu &&  ./simple-add-buffers

esac

#!/bin/tcsh
#
# This script uses cmake to build cgns, parallel build,
# it should be executed some place other then in the
# source directory.

#  Note:
#  Does szip support

# set to where hdf5 is installed.
set HDF5=/mnt/scr1/trunk/hdf5
# set to where the mpi compilers are
set MPI=/mnt/hdf/packages/mpich/3.1.3_xl15.1.0/ppc64/bin
# set to where the source is located
set CGNS=/mnt/scr1/HDF5_Parallel

cmake \
  -D CMAKE_C_COMPILER:PATH=$MPI/mpicc \
  -D CMAKE_Fortran_COMPILER:PATH=$MPI/mpif90 \
 $CGNS

ccmake  \
  -D CGNS_BUILD_SHARED:BOOL=OFF \
  -D CGNS_USE_SHARED:BOOL=OFF \
  -D HDF5_NEED_ZLIB:BOOL=ON \
  -D CMAKE_EXE_LINKER_FLAGS:STRING="" \
  -D CMAKE_STATIC_LINKER_FLAGS:STRING="" \
  -D MPIEXEC:STRING=$MPI/mpiexec \
  -D MPI_C_COMPILER:STRING=$MPI/mpicc \
  -D MPI_Fortran_COMPILER:STRING=$MPI/mpif90 \
  -D CGNS_ENABLE_HDF5:BOOL=ON \
  -D CGNS_ENABLE_TESTS:BOOL=ON \
  -D CGNS_BUILD_CGNSTOOLS:BOOL=OFF \
  -D HDF5_LIBRARY_DIR:PATH=$HDF5/lib \
  -D HDF5_LIBRARY:STRING=$HDF5/lib/libhdf5.a \
  -D HDF5_INCLUDE_DIR:PATH=$HDF5/include \
  -D HDF5_INCLUDE_PATH:PATH=$HDF5/include \
  -D HDF5_NEED_MPI:BOOL=ON \
  -D CGNS_ENABLE_FORTRAN:BOOL=ON \
  -D CGNS_ENABLE_64BIT:BOOL=ON \
  -D CMAKE_C_COMPILER:PATH=$MPI/mpicc \
  -D CMAKE_Fortran_COMPILER:PATH=$MPI/mpif90 \
  -D CGNS_ENABLE_PARALLEL:BOOL=ON \
  -D CMAKE_INSTALL_PREFIX:PATH="./" \
  .

# then do:
# make
# make install

#!/bin/sh
#
# Configure CGNS for travis CI. 
#
set -e
cd src
if [ $TRAVIS_OS_NAME = "linux" ]; then
  export FLIBS="-Wl,--no-as-needed -ldl -lz"
  export LIBS="-Wl,--no-as-needed -ldl -lz"
fi

./configure \
--prefix=$PWD/cgns_build \
--with-hdf5=$HOME/hdf5 \
--with-fortran \
--enable-lfs \
--enable-64bit \
--disable-shared \
--enable-debug \
--with-zlib \
--disable-cgnstools \
--enable-64bit

# INTRODUCTION

This document describes the difference between CGNS 4.4.0 and 
CGNS 4.5.0, and contains information on known problems in
CGNS 4.5.0.

Links to the CGNS current released source code can be found at:
<a href="https://cgns.github.io/current/download.html#supportdownload" rel="nofollow">Download</a>
User MLL documentation for the current release can be found at:
<a href="https://cgns.github.io/standard/MLL/CGNS_MLL.html#standardmll" rel="nofollow">MLL Documentation</a>
For more general information, see the CGNS home page:
<a href="http://cgns.org" rel="nofollow">CGNS.org</a>

## CONTENTS
- New Features
- Bug Fixes since CGNS 4.4.0
- Known Problems

# New Features

> [!NOTE]
> This release includes new Doxygen descriptions of the MLL APIs, which are now utilized in the updated documentation at cgns.org.

> [!IMPORTANT]
> All new Fortran APIs introduced in this release that expect a character string are required to pass a scalar 
> character string (i.e.,` CHARACTER(LEN=*) `) and not an array of character strings (i.e., `CHARACTER(LEN=*), DIMENSION(*)`).

Configuration:
--------------------
N/A

Library:
---------------
* New CPEX0046 Particle extension, the inclusion of particle data in CGNS.
  - For Details, see: https://cgns.org/_downloads/74b6fa06432163b5730964340e3084bc/CPEX0046-v2-rev1.pdf
  - Numerous new MLL APIs, both parallel and serial, were added. See the MLL documentation 
    at cgns.org for more details.

> [!NOTE]
> We appreciate Convergent Science's contributions to CPEX 0046 and its implementation.

* Added Fortran support for `cg_configure_f` to allow a callback function, such as in the case of CG_CONFIG_ERROR.

Parallel Library:
------------------------

* Added new PointList Functions:  `cgp_parent_data_write(_f)`, `cgp_ptlist_write_data(_f)` and
  `cgp_ptlist_read_data(_f)`, PR #730, Issue #728.
   - Parallel writing/reading of any PointSet is possible via a `cg_goto` statement rather than
     just pointsets associated with `BC_t` nodes.

* Added poly elements read/parent elements read-write APIs: 
   - `cgp_poly_section_write(_f)`, `cgp_poly_elements_write_data(_f)`
   -  `cgp_poly_elements_read_data_elements`, `cgp_poly_elements_read_data_offsets(_f)`,`cgp_parentelements_read_data(_f)`


Fortran Library:
-----------------------
See section _Parallel Library_.

Tools:
-------------
N/A

# Bug Fixes since CGNS 4.4.0 release

Configuration:
--------------------
* Fixed compilation issues due to missing _POSIX_SOURCE define, Issue #810.

* Add cgns-config.cmake file.
  - Also change hdf5 target names to match those from find_package(HDF5)

* Fix for HDF5 1.14.3 and onward with the NAG compiler.
  - IEEE standard arithmetic enables software to raise exceptions such as overflow,
  division by zero, and other illegal operations without interrupting or halting
  the program flow. The HDF5 C library intentionally performs these exceptions.
  Therefore, the "-ieee=full" nagfor switch is necessary when compiling a program
  to avoid stopping on an exception.

* Improve cmake packaging
   - Set an installed rpath that handles install location differently from "lib"
     for multiple arch support, for instance.

* Update cmake requirement
   - Update cmake requirement to 3.20
   - Fix conversion issue with vs2022 compiler
   - Handle F2C string on ARM64
   - Hidden parameters should be handled through a size_t according to  https://gcc.gnu.org/onlinedocs/gcc-8.2.0/gfortran/Argument-passing-conventions.html

* Remove the deprecated build system on Windows (i.e., .bat); CMake is the current focus of development.

* Bumped the Autotools prerequisite to 2.71, and fixed the check to allow for HDF5 version 2.0.0

Library:
--------------
* [CGNS-284] Fixed  cgi_warning
  -  modify return status when the bounding box is not found.
  -  No more cgi_warning shown see [CGNS-284]
  -  removed outdated documentation

* Do not force Elements_t node to be contiguous
  - Only data arrays are forced to be contiguous in the Elements_t node

* fixed uninitialized warnings

* Fix issue https://github.com/CGNS/CGNS/issues/754 (https://github.com/CGNS/CGNS/pull/756)
  - use C99 types int64_t
  - define cgsize_t as a intxx_t type
  - provide PRIdCGSIZE
  - follow hdf5 changes

* Corrected int types for MPI_Allgather  in ptests
   - Fixed cgsize_t type for MPI _Allgather, in tests, depending on how CGNS was built.

* Misc windows fixes 
   - Make cmakelist more robust to Multi-configuration generators
   - Improve Win32 ctest support
   - Remove the redefinition of MACRO; the MACRO is already defined in glib.h

* use size_t casting to prevent allocation failure
  - the cast to size_t is done before multiplying with size_of
  - size_of now returns a size_t
  - This prevents capacity reduction in 32-bit mode when cgsize_t is an int.

* Remove access() calls in the CGNS library
   - Remove ACCESS calls due to possible race condition

* Address miscellaneous CodeQL issues and warnings.

Fortran:
---------------
* made Fortran Test_Family  example output valid for cgnscheck

Tools:
-------------
* backport gcc14 fedora patch for tkogl
* [cgnscheck] check multiple grid coordinates nodes & null pointer

</code></pre></div>
# Known Problems

************ FORTRAN ************

* A gfortran bug in version 10.2 broke Fortran mapping and caused cg_goto_f 
 to segfault. All other versions of gfortran are suitable.
 (ref. CGNS-246, GNU BUG 100149)

* A bug in gfortran (all versions) causes cg_configure_f to fail,
  GNU BUG 99982. Other Fortran compilers are OK.

* Building CGNS with parallel enabled, with Fortran enabled, and as a shared library on Windows
   is not working. Some C parallel tests fail on Windows with the Intel Compiler.

************ FORTRAN END ********

************ CGNSVIEW ************

* cgnsview for OSX is not viewing properly, and cgnsview under Windows 
  may fail to compile due to tcl/tk incompatibility. 

************ CGNSVIEW END ********

* For details on these and other issues, see https://github.com/CGNS/CGNS/issues
</code></pre></div>

# Supported Platforms

The following platforms are supported and have been tested for this release.
They are built with autotools unless specified otherwise.

> [!NOTE] 
> CGNS is not testing on any 32-bit Linux systems

|Platform | Configuration |
|-- | -- |
| Centos7 <br> #1 SMP x86_64 GNU/Linux<br>      | GNU C (gcc), Fortran (gfortran), C++ (g++) <br>compilers: <br> Version 4.8.5 20150623 (Red Hat 4.8.5-4) <br> Version 4.9.3, Version 7.2.0, Version 8.3.0, <br> Version 9.1.0, Version 10.2.0 <br> |
|                                               |  Intel(R) C (icc), C++ (icpc), Fortran (icc) <br> compilers: <br>   Version 17.0.0.098 Build 20160721 |
|                                               |  GNU C (gcc) and C++ (g++) 4.8.5 compilers<br>&nbsp;&nbsp;&nbsp;with NAG Fortran Compiler Release 7.1(Hanzomon)|
|                                               | Intel(R) C (icc) and C++ (icpc) 17.0.0.098|
|                                               | GNU C (gcc) and C++ (g++) 4.8.5 compilers with NAG Fortran Compiler Release 7.1(Hanzomon) |
|                                               | Intel(R) C (icc) and C++ (icpc) 17.0.0.098 compilers with NAG Fortran Compiler Release 7.1(Hanzomon)|
|                                               | MPICH 3.1.4 compiled with GCC 4.9.3 |
|                                               | MPICH 3.3 compiled with GCC 7.2.0 |
|                                               | OpenMPI 3.1.3 compiled with GCC 7.2.0, and 4.1.2 compiled with GCC 9.1.0 |
|                                               | NVIDIA nvc, nvfortran and nvc++ version 22.5-0 (autotools and cmake) |
| Ubuntu 24.04 <br> #1 SMP x86_64 GNU/Linux<br> | GNU C (gcc), Fortran (gfortran), C++ (g++) <br>compilers: 13.2 |
|                                               | OpenMPI 4.1.6 |

> [!NOTE]
> CGNS is not testing on any 32-bit Windows systems

|Platform         | Configuration                                   |
|---------------- | ----------------------------------------------- |
|  Windows 11 x64 | Visual Studio 2019 w/ Intel OneAPI 2025 (CMake) |
|                 | Visual Studio 2019 w/ MSMPI 10.1 (CMake)        |

> [!NOTE]
> CGNS is tested with the two latest macOS versions that are available
> on GitHub runners. As new major macOS versions become available, CGNS
> will discontinue support for the older version and add the latest
> version to its list of compatible systems and the previous version.


|Platform                   | Configuration                             |
|-------------------------- | ----------------------------------------- |
|macOS Sonoma 14.7.2 64-bit | Apple LLVM<br> gfortran GNU Fortran (GCC) |
|macOS Sequoia 15.2 64-bit  | Apple LLVM<br> gfortran GNU Fortran (GCC) |

</code></pre></div>
# Tested Configuration Features Summary
<div class="snippet-clipboard-content position-relative overflow-auto"><pre><code>In the table below
      y   = tested
      n   = not tested in this release
      x   = not working in this release
</code></pre></div>

Platform | C | C[1] | Fortran | Fortran [1]
-- | -- | -- | -- | --
Windows 11 | n | n | n | n
Windows 11 x64 | y | n | n | n
Windows 11 Cygwin | n | n | x | n
Mac OS X  Sonoma 64-bit | y | n | y | n
Mac OS X Sequoia 64-bit | y | n | y | n
CentOS 7.2 Linux 3.10.0 x86_64 PGI | y | n | y | n
CentOS 7.2 Linux 3.10.0 x86_64 GNU | y | y | y | y
CentOS 7.2 Linux 3.10.0 x86_64 Intel | y | y | y | y
Linux 2.6.32-573.18.1.el6.ppc64 | y | n | y | n

<p>[1] Parallel

# Acknowledgements
 * Thank you, Mickael Philit, for contributing to updating the documentation and resolving various issues 
   in the CGNS library for this release. 
 * We appreciate all the CGNS users who reported issues and submitted pull requests.
